/*
	Copyright (c) Microsoft Corporation.  All rights reserved.
*/

/*
	Your use of this file is governed by the license terms for the Microsoft Office JavaScript (Office.js) API library: https://github.com/OfficeDev/office-js/blob/release/LICENSE.md
*/

/*
* @overview es6-promise - a tiny implementation of Promises/A+.
* @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
* @license   Licensed under MIT license
*            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
* @version   2.3.0
*/


// Sources:
// osfweb: 16.0\16.0.17106.15020
// runtime: 16.0\16.0.17106.15020
// core: 16.0\16.0.17106.15020
// host: 16.0\16.0.17106.15020



"undefined"!==typeof OSFPerformance&&(OSFPerformance.hostInitializationStart=OSFPerformance.now());var OfficeExt,__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t=function(){function e(){}return e.prototype.isMsAjaxLoaded=function(){return!!("undefined"!==typeof Sys&&"undefined"!==typeof Type&&Sys.StringBuilder&&"function"===typeof Sys.StringBuilder&&Type.registerNamespace&&"function"===typeof Type.registerNamespace&&Type.registerClass&&"function"===typeof Type.registerClass&&"function"===typeof Function._validateParams&&Sys.Serialization&&Sys.Serialization.JavaScriptSerializer&&"function"===typeof Sys.Serialization.JavaScriptSerializer.serialize)},e.prototype.loadMsAjaxFull=function(e){var t=("https:"===window.location.protocol.toLowerCase()?"https:":"http:")+"//ajax.aspnetcdn.com/ajax/3.5/MicrosoftAjax.js";OSF.OUtil.loadScript(t,e)},Object.defineProperty(e.prototype,"msAjaxError",{get:function(){return null==this._msAjaxError&&this.isMsAjaxLoaded()&&(this._msAjaxError=Error),this._msAjaxError},set:function(e){this._msAjaxError=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxString",{get:function(){return null==this._msAjaxString&&this.isMsAjaxLoaded()&&(this._msAjaxString=String),this._msAjaxString},set:function(e){this._msAjaxString=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxDebug",{get:function(){return null==this._msAjaxDebug&&this.isMsAjaxLoaded()&&(this._msAjaxDebug=Sys.Debug),this._msAjaxDebug},set:function(e){this._msAjaxDebug=e},enumerable:!0,configurable:!0}),e}();e.MicrosoftAjaxFactory=t}(OfficeExt||(OfficeExt={}));var OSFLog,Logger,OSFAriaLogger,OSFAppTelemetry,OSFPerfUtil,OsfMsAjaxFactory=new OfficeExt.MicrosoftAjaxFactory,OSF=OSF||{};!function(e){var t=function(){function e(e){this._internalStorage=e}return e.prototype.getItem=function(e){try{return this._internalStorage&&this._internalStorage.getItem(e)}catch(e){return null}},e.prototype.setItem=function(e,t){try{this._internalStorage&&this._internalStorage.setItem(e,t)}catch(e){}},e.prototype.clear=function(){try{this._internalStorage&&this._internalStorage.clear()}catch(e){}},e.prototype.removeItem=function(e){try{this._internalStorage&&this._internalStorage.removeItem(e)}catch(e){}},e.prototype.getKeysWithPrefix=function(e){var t=[];try{for(var n=this._internalStorage&&this._internalStorage.length||0,r=0;r<n;r++){var o=this._internalStorage.key(r);0===o.indexOf(e)&&t.push(o)}}catch(e){}return t},e.prototype.isLocalStorageAvailable=function(){return null!=this._internalStorage},e}();e.SafeStorage=t}(OfficeExt||(OfficeExt={})),OSF.XdmFieldName={ConversationUrl:"ConversationUrl",AppId:"AppId"},OSF.TestFlightStart=1e3,OSF.TestFlightEnd=1009,OSF.FlightNames={UseOriginNotUrl:0,AddinEnforceHttps:2,FirstPartyAnonymousProxyReadyCheckTimeout:6,AddinRibbonIdAllowUnknown:9,ManifestParserDevConsoleLog:15,AddinActionDefinitionHybridMode:18,UseActionIdForUILessCommand:20,RequirementSetRibbonApiOnePointTwo:21,SetFocusToTaskpaneIsEnabled:22,ShortcutInfoArrayInUserPreferenceData:23,OSFTestFlight1000:OSF.TestFlightStart,OSFTestFlight1001:OSF.TestFlightStart+1,OSFTestFlight1002:OSF.TestFlightStart+2,OSFTestFlight1003:OSF.TestFlightStart+3,OSFTestFlight1004:OSF.TestFlightStart+4,OSFTestFlight1005:OSF.TestFlightStart+5,OSFTestFlight1006:OSF.TestFlightStart+6,OSFTestFlight1007:OSF.TestFlightStart+7,OSFTestFlight1008:OSF.TestFlightStart+8,OSFTestFlight1009:OSF.TestFlightEnd},OSF.TrustUXFlightValues={TrustUXControlA:0,TrustUXExperimentB:1,TrustUXExperimentC:2},OSF.FlightTreatmentNames={AddinTrustUXImprovement:"Microsoft.Office.SharedOnline.AddinTrustUXImprovement",BlockAutoOpenAddInIfStoreDisabled:"Microsoft.Office.SharedOnline.BlockAutoOpenAddInIfStoreDisabled",Bug7083046KillSwitch:"Microsoft.Office.SharedOnline.Bug7083046KillSwitch",CheckProxyIsReadyRetry:"Microsoft.Office.SharedOnline.OEP.CheckProxyIsReadyRetry",InsertionDialogFixesEnabled:"Microsoft.Office.SharedOnline.InsertionDialogFixesEnabled",WopiPreinstalledAddInsEnabled:"Microsoft.Office.SharedOnline.WopiPreinstalledAddInsEnabled",WopiUseNewActivate:"Microsoft.Office.SharedOnline.WopiUseNewActivate",MosManifestEnabled:"Microsoft.Office.SharedOnline.OEP.MosManifest",RemoveGetTrustNoPrompt:"Microsoft.Office.SharedOnline.removeGetTrustNoPrompt",HostTrustDialog:"Microsoft.Office.SharedOnline.HostTrustDialog",GetAddinFlyoutEnabled:"Microsoft.Office.SharedOnline.GetAddinFlyoutEnabled",BackstageEnabled:"Microsoft.Office.SharedOnline.NewBackstageEnabled",EnablingWindowOpenUsageLogging:"Microsoft.Office.SharedOnline.EnablingWindowOpenUsageLogging"},OSF.Flights=[],OSF.IntFlights={},OSF.Settings={},OSF.WindowNameItemKeys={BaseFrameName:"baseFrameName",HostInfo:"hostInfo",XdmInfo:"xdmInfo",SerializerVersion:"serializerVersion",AppContext:"appContext",Flights:"flights"},OSF.OUtil=function(){var e=-1,t="#",n={},r=null,o=null,i=(new Date).getTime();function a(){var e=2147483647*Math.random();return(e^=i^(new Date).getMilliseconds()<<Math.floor(21*Math.random())).toString(16)}function s(){if(!r){try{var e=window.sessionStorage}catch(t){e=null}r=new OfficeExt.SafeStorage(e)}return r}function c(e){var t,n,r=[],o=[],i=e.length;for(t=0;t<i;t++)(n=e[t]).tabIndex?n.tabIndex>0?o.push(n):0===n.tabIndex&&r.push(n):r.push(n);return o=o.sort((function(e,t){var n=e.tabIndex-t.tabIndex;return 0===n&&(n=o.indexOf(e)-o.indexOf(t)),n})),[].concat(o,r)}return{set_entropy:function(e){if("string"==typeof e)for(var t=0;t<e.length;t+=4){for(var n=0,r=0;r<4&&t+r<e.length;r++)n=(n<<8)+e.charCodeAt(t+r);i^=n}else i^="number"==typeof e?e:2147483647*Math.random();i&=2147483647},extend:function(e,t){var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e,e.uber=t.prototype,t.prototype.constructor===Object.prototype.constructor&&(t.prototype.constructor=t)},setNamespace:function(e,t){t&&e&&!t[e]&&(t[e]={})},unsetNamespace:function(e,t){t&&e&&t[e]&&delete t[e]},serializeSettings:function(e){var t={};for(var n in e){var r=e[n];try{r=JSON?JSON.stringify(r,(function(e,t){return OSF.OUtil.isDate(this[e])?OSF.DDA.SettingsManager.DateJSONPrefix+this[e].getTime()+OSF.DDA.SettingsManager.DataJSONSuffix:t})):Sys.Serialization.JavaScriptSerializer.serialize(r),t[n]=r}catch(e){}}return t},deserializeSettings:function(e){var t={};for(var n in e=e||{}){var r=e[n];try{r=JSON?JSON.parse(r,(function(e,t){var n;return"string"===typeof t&&t&&t.length>6&&t.slice(0,5)===OSF.DDA.SettingsManager.DateJSONPrefix&&t.slice(-1)===OSF.DDA.SettingsManager.DataJSONSuffix&&(n=new Date(parseInt(t.slice(5,-1))))?n:t})):Sys.Serialization.JavaScriptSerializer.deserialize(r,!0),t[n]=r}catch(e){}}return t},loadScript:function(e,t,r){if(e&&t){var o=window.document,i=n[e];if(i)i.loaded?t():i.pendingCallbacks.push(t);else{var a=o.createElement("script");a.type="text/javascript",i={loaded:!1,pendingCallbacks:[t],timer:null},n[e]=i;var s=function(){null!=i.timer&&(clearTimeout(i.timer),delete i.timer),i.loaded=!0;for(var e=i.pendingCallbacks.length,t=0;t<e;t++){i.pendingCallbacks.shift()()}},c=function(t){delete n[e],null!=i.timer&&(clearTimeout(i.timer),delete i.timer);for(var r=i.pendingCallbacks.length,o=0;o<r;o++){i.pendingCallbacks.shift()(t)}};a.readyState?a.onreadystatechange=function(){"loaded"!=a.readyState&&"complete"!=a.readyState||(a.onreadystatechange=null,s())}:a.onload=s,a.onerror=c,r=r||3e4,i.timer=setTimeout((function(){window.navigator.userAgent.indexOf("Trident")>0?c(null):c(new Event("Script load timed out"))}),r),a.setAttribute("crossOrigin","anonymous"),a.src=e,o.getElementsByTagName("head")[0].appendChild(a)}}},loadCSS:function(e){if(e){var t=window.document,n=t.createElement("link");n.type="text/css",n.rel="stylesheet",n.href=e,t.getElementsByTagName("head")[0].appendChild(n)}},parseEnum:function(e,t){var n=t[e.trim()];if("undefined"==typeof n)throw OsfMsAjaxFactory.msAjaxDebug.trace("invalid enumeration string:"+e),OsfMsAjaxFactory.msAjaxError.argument("str");return n},delayExecutionAndCache:function(){var e={calc:arguments[0]};return function(){return e.calc&&(e.val=e.calc.apply(this,arguments),delete e.calc),e.val}},getUniqueId:function(){return(e+=1).toString()},formatString:function(){var e=arguments,t=e[0];return t.replace(/{(\d+)}/gm,(function(t,n){var r=parseInt(n,10)+1;return void 0===e[r]?"{"+n+"}":e[r]}))},generateConversationId:function(){return[a(),a(),(new Date).getTime().toString()].join("_")},getFrameName:function(e){return"_xdm_"+e+this.generateConversationId()},addXdmInfoAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_xdm_Info=",t,!1)},addSerializerVersionAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_serializer_version=",t,!0)},addFlightsAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_flights=",t,!0)},addInfoAsHash:function(e,n,r,o){var i,a=(e=e.trim()||"").split(t),s=a.shift(),c=a.join(t);return i=o?[n,encodeURIComponent(r),c].join(""):[c,n,r].join(""),[s,t,i].join("")},parseHostInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.HostInfo)},parseXdmInfo:function(e){var t=OSF.OUtil.parseXdmInfoWithGivenFragment(e,window.location.hash);return t||(t=OSF.OUtil.parseXdmInfoFromWindowName(e,window.name)),t},parseXdmInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.XdmInfo)},parseXdmInfoWithGivenFragment:function(e,t){return OSF.OUtil.parseInfoWithGivenFragment("&_xdm_Info=","_xdm_",!1,e,t)},parseSerializerVersion:function(e){var t=OSF.OUtil.parseSerializerVersionWithGivenFragment(e,window.location.hash);return isNaN(t)&&(t=OSF.OUtil.parseSerializerVersionFromWindowName(e,window.name)),t},parseSerializerVersionFromWindowName:function(e,t){return parseInt(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.SerializerVersion))},parseSerializerVersionWithGivenFragment:function(e,t){return parseInt(OSF.OUtil.parseInfoWithGivenFragment("&_serializer_version=","_serializer_version=",!0,e,t))},parseFlights:function(e){var t=OSF.OUtil.parseFlightsWithGivenFragment(e,window.location.hash);return 0==t.length&&(t=OSF.OUtil.parseFlightsFromWindowName(e,window.name)),t},checkFlight:function(e){return OSF.Flights&&OSF.Flights.indexOf(e)>=0},pushFlight:function(e){return OSF.Flights.indexOf(e)<0&&(OSF.Flights.push(e),!0)},getBooleanSetting:function(e){return OSF.OUtil.getBooleanFromDictionary(OSF.Settings,e)},getBooleanFromDictionary:function(e,t){var n=e&&t&&void 0!==e[t]&&e[t]&&("string"===typeof e[t]&&"TRUE"===e[t].toUpperCase()||"boolean"===typeof e[t]&&e[t]);return void 0!==n&&n},getIntFromDictionary:function(e,t){return e&&t&&void 0!==e[t]&&"string"===typeof e[t]?parseInt(e[t]):NaN},pushIntFlight:function(e,t){return!(e in OSF.IntFlights)&&(OSF.IntFlights[e]=t,!0)},getIntFlight:function(e){return OSF.IntFlights&&e in OSF.IntFlights?OSF.IntFlights[e]:NaN},parseFlightsFromWindowName:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.Flights))},parseFlightsWithGivenFragment:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoWithGivenFragment("&_flights=","_flights=",!0,e,t))},parseArrayWithDefault:function(e){var t=[];try{t=JSON.parse(e)}catch(e){}return Array.isArray(t)||(t=[]),t},parseInfoFromWindowName:function(e,t,n){try{var r=JSON.parse(t),o=null!=r?r[n]:null,i=s();if(!e&&i&&null!=r){var a=r[OSF.WindowNameItemKeys.BaseFrameName]+n;o?i.setItem(a,o):o=i.getItem(a)}return o}catch(e){return null}},parseInfoWithGivenFragment:function(e,t,n,r,o){var i=o.split(e),a=i.length>1?i[i.length-1]:null;n&&null!=a&&(a.indexOf("&")>=0&&(a=a.split("&")[0]),a=decodeURIComponent(a));var c=s();if(!r&&c){var l=window.name.indexOf(t);if(l>-1){var u=window.name.indexOf(";",l);-1==u&&(u=window.name.length);var d=window.name.substring(l,u);a?c.setItem(d,a):a=c.getItem(d)}}return a},getConversationId:function(){var e=window.location.search,t=null;if(e){var n=e.indexOf("&");(t=n>0?e.substring(1,n):e.substr(1))&&"="===t.charAt(t.length-1)&&(t=t.substring(0,t.length-1))&&(t=decodeURIComponent(t))}return t},getInfoItems:function(e){var t=e.split("$");return"undefined"==typeof t[1]&&(t=e.split("|")),"undefined"==typeof t[1]&&(t=e.split("%7C")),t},getXdmFieldValue:function(e,t){var n="",r=OSF.OUtil.parseXdmInfo(t);if(r){var o=OSF.OUtil.getInfoItems(r);if(void 0!=o&&o.length>=3)switch(e){case OSF.XdmFieldName.ConversationUrl:n=o[2];break;case OSF.XdmFieldName.AppId:n=o[1]}}return n},validateParamObject:function(e,t,n){var r=Function._validateParams(arguments,[{name:"params",type:Object,mayBeNull:!1},{name:"expectedProperties",type:Object,mayBeNull:!1},{name:"callback",type:Function,mayBeNull:!0}]);if(r)throw r;for(var o in t)if(r=Function._validateParameter(e[o],t[o],o))throw r},writeProfilerMark:function(e){window.msWriteProfilerMark&&(window.msWriteProfilerMark(e),OsfMsAjaxFactory.msAjaxDebug.trace(e))},outputDebug:function(e){"undefined"!==typeof OsfMsAjaxFactory&&OsfMsAjaxFactory.msAjaxDebug&&OsfMsAjaxFactory.msAjaxDebug.trace&&OsfMsAjaxFactory.msAjaxDebug.trace(e)},defineNondefaultProperty:function(e,t,n,r){for(var o in n=n||{},r){var i=r[o];void 0==n[i]&&(n[i]=!0)}return Object.defineProperty(e,t,n),e},defineNondefaultProperties:function(e,t,n){for(var r in t=t||{})OSF.OUtil.defineNondefaultProperty(e,r,t[r],n);return e},defineEnumerableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["enumerable"])},defineEnumerableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["enumerable"])},defineMutableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["writable","enumerable","configurable"])},defineMutableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["writable","enumerable","configurable"])},finalizeProperties:function(e,t){t=t||{};for(var n=Object.getOwnPropertyNames(e),r=n.length,o=0;o<r;o++){var i=n[o],a=Object.getOwnPropertyDescriptor(e,i);a.get||a.set||(a.writable=t.writable||!1),a.configurable=t.configurable||!1,a.enumerable=t.enumerable||!0,Object.defineProperty(e,i,a)}return e},mapList:function(e,t){var n=[];if(e)for(var r in e)n.push(t(e[r]));return n},listContainsKey:function(e,t){for(var n in e)if(t==n)return!0;return!1},listContainsValue:function(e,t){for(var n in e)if(t==e[n])return!0;return!1},augmentList:function(e,t){var n=e.push?function(t,n){e.push(n)}:function(t,n){e[t]=n};for(var r in t)n(r,t[r])},redefineList:function(e,t){for(var n in e)delete e[n];for(var r in t)e[r]=t[r]},isArray:function(e){return"[object Array]"===Object.prototype.toString.apply(e)},isFunction:function(e){return"[object Function]"===Object.prototype.toString.apply(e)},isDate:function(e){return"[object Date]"===Object.prototype.toString.apply(e)},addEventListener:function(e,t,n){e.addEventListener?e.addEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.attachEvent?e.attachEvent("on"+t,n):e["on"+t]=n},removeEventListener:function(e,t,n){e.removeEventListener?e.removeEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.detachEvent?e.detachEvent("on"+t,n):e["on"+t]=null},xhrGet:function(e,t,n){var r;try{(r=new XMLHttpRequest).onreadystatechange=function(){4==r.readyState&&(200==r.status?t(r.responseText):n(r.status))},r.open("GET",e,!0),r.send()}catch(e){n(e)}},encodeBase64:function(e){if(!e)return e;var t,n,r,o,i,a,s,c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",l=[],u=[],d=0,f=e.length;do{t=e.charCodeAt(d++),n=e.charCodeAt(d++),r=e.charCodeAt(d++),s=0,o=255&t,i=t>>8,a=255&n,u[s++]=o>>2,u[s++]=(3&o)<<4|i>>4,u[s++]=(15&i)<<2|a>>6,u[s++]=63&a,isNaN(n)||(o=n>>8,i=255&r,a=r>>8,u[s++]=o>>2,u[s++]=(3&o)<<4|i>>4,u[s++]=(15&i)<<2|a>>6,u[s++]=63&a),isNaN(n)?u[s-1]=64:isNaN(r)&&(u[s-2]=64,u[s-1]=64);for(var p=0;p<s;p++)l.push(c.charAt(u[p]))}while(d<f);return l.join("")},getSessionStorage:function(){return s()},getLocalStorage:function(){if(!o){try{var e=window.localStorage}catch(t){e=null}o=new OfficeExt.SafeStorage(e)}return o},convertIntToCssHexColor:function(e){return"#"+(Number(e)+16777216).toString(16).slice(-6)},attachClickHandler:function(e,t){e.onclick=function(e){t()},e.ontouchend=function(e){t(),e.preventDefault()}},getQueryStringParamValue:function(e,t){var n=Function._validateParams(arguments,[{name:"queryString",type:String,mayBeNull:!1},{name:"paramName",type:String,mayBeNull:!1}]);if(n)return OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: Parameters cannot be null."),"";var r=new RegExp("[\\?&]"+t+"=([^&#]*)","i");return r.test(e)?r.exec(e)[1]:(OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: The parameter is not found."),"")},getHostnamePortionForLogging:function(e){var t=Function._validateParams(arguments,[{name:"hostname",type:String,mayBeNull:!1}]);if(t)return"";var n=e.split("."),r=n.length;return r>=2?n[r-2]+"."+n[r-1]:1==r?n[0]:void 0},isiOS:function(){return!!window.navigator.userAgent.match(/(iPad|iPhone|iPod)/g)},isChrome:function(){return window.navigator.userAgent.indexOf("Chrome")>0&&!OSF.OUtil.isEdge()},isEdge:function(){return window.navigator.userAgent.indexOf("Edge")>0},isIE:function(){return window.navigator.userAgent.indexOf("Trident")>0},isFirefox:function(){return window.navigator.userAgent.indexOf("Firefox")>0},startsWith:function(e,t,n){return n?e.substr(0,t.length)===t:e.startsWith(t)},containsPort:function(e,t,n,r){return this.startsWith(e,t+"//"+n+":"+r,!0)||this.startsWith(e,n+":"+r,!0)},getRedundandPortString:function(e,t){return e&&t?"https:"==t.protocol&&this.containsPort(e,"https:",t.hostname,"443")?":443":"http:"==t.protocol&&this.containsPort(e,"http:",t.hostname,"80")?":80":"":""},removeChar:function(e,t){return t<e.length-1?e.substring(0,t)+e.substring(t+1):t==e.length-1?e.substring(0,e.length-1):e},cleanUrlOfChar:function(e,t){var n;for(n=0;n<e.length;n++)if(e.charAt(n)===t){if(n+1>=e.length)return this.removeChar(e,n);if("/"===t){if("?"===e.charAt(n+1)||"#"===e.charAt(n+1))return this.removeChar(e,n)}else if("?"===t&&"#"===e.charAt(n+1))return this.removeChar(e,n)}return e},cleanUrl:function(e){if(e=this.cleanUrlOfChar(e,"/"),e=this.cleanUrlOfChar(e,"?"),"https://"==(e=this.cleanUrlOfChar(e,"#")).substr(0,8))-1!=(t=e.indexOf(":443"))&&(t!=e.length-4&&"/"!=e.charAt(t+4)&&"?"!=e.charAt(t+4)&&"#"!=e.charAt(t+4)||(e=e.substring(0,t)+e.substring(t+4)));else if("http://"==e.substr(0,7)){var t;-1!=(t=e.indexOf(":80"))&&(t!=e.length-3&&"/"!=e.charAt(t+3)&&"?"!=e.charAt(t+3)&&"#"!=e.charAt(t+3)||(e=e.substring(0,t)+e.substring(t+3)))}return e},parseUrl:function(e,t){if(void 0===t&&(t=!1),"undefined"!==typeof e&&e){var n=this.isIE(),r={protocol:void 0,hostname:void 0,host:void 0,port:void 0,pathname:void 0,search:void 0,hash:void 0,isPortPartOfUrl:void 0};try{if(n){var o=document.createElement("a");if(o.href=e,!o||!o.protocol||!o.host||!o.hostname||!o.href||this.cleanUrl(o.href).toLowerCase()!==this.cleanUrl(e).toLowerCase())throw"InvalidUrl";if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=o.protocol)throw new Error("NotHttps");var i=this.getRedundandPortString(e,o);r.protocol=o.protocol,r.hostname=o.hostname,r.port=""==i?o.port:"",r.host=""!=i?o.hostname:o.host,r.pathname=(n?"/":"")+o.pathname,r.search=o.search,r.hash=o.hash,r.isPortPartOfUrl=this.containsPort(e,o.protocol,o.hostname,o.port)}else{var a=new URL(e);if(a&&a.protocol&&a.host&&a.hostname){if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=a.protocol)throw new Error("NotHttps");r.protocol=a.protocol,r.hostname=a.hostname,r.port=a.port,r.host=a.host,r.pathname=a.pathname,r.search=a.search,r.hash=a.hash,r.isPortPartOfUrl=a.host.lastIndexOf(":"+a.port)==a.host.length-a.port.length-1}}}catch(e){if("NotHttps"===e.message)throw e}return r}},shallowCopy:function(e){if(null==e)return null;if(e instanceof Object){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(e[n]);return t}var r=e.constructor();for(var o in e)e.hasOwnProperty(o)&&(r[o]=e[o]);return r}return e},createObject:function(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t},addClass:function(e,t){if(!OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class");n?e.setAttribute("class",n+" "+t):e.setAttribute("class",t)}},removeClass:function(e,t){if(OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class"),r=new RegExp("(\\s|^)"+t+"(\\s|$)");n=n.replace(r,""),e.setAttribute("class",n)}},hasClass:function(e,t){var n=e.getAttribute("class");return n&&n.match(new RegExp("(\\s|^)"+t+"(\\s|$)"))},focusToFirstTabbable:function(e,t){var n,r,o=!1,i=function(e){o=!0},a=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(e=c(e),n=t?e.length-1:0,0===e.length)return null;for(;!o&&n>=0&&n<e.length;)r=e[n],window.focus(),r.addEventListener("focus",i),r.focus(),r.removeEventListener("focus",i),n=a(e.length,n,t),o||r!==document.activeElement||(o=!0);return o?r:null},focusToNextTabbable:function(e,t,n){var r,o,i,a=!1,s=function(e){a=!0},l=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(r=function(e,t){for(var n=0;n<e.length;n++)if(e[n]===t)return n;return-1}(e=c(e),t),(o=l(e.length,r,n))<0)return null;for(;!a&&o>=0&&o<e.length;)(i=e[o]).addEventListener("focus",s),i.focus(),i.removeEventListener("focus",s),o=l(e.length,o,n),a||i!==document.activeElement||(a=!0);return a?i:null},isNullOrUndefined:function(e){return"undefined"===typeof e||null===e},stringEndsWith:function(e,t){if(!OSF.OUtil.isNullOrUndefined(e)&&!OSF.OUtil.isNullOrUndefined(t)){if(t.length>e.length)return!1;if(e.substr(e.length-t.length)===t)return!0}return!1},hashCode:function(e){var t=0;if(!OSF.OUtil.isNullOrUndefined(e))for(var n=0,r=e.length;n<r;)t=(t<<5)-t+e.charCodeAt(n++)|0;return t},getValue:function(e,t){return OSF.OUtil.isNullOrUndefined(e)?t:e},externalNativeFunctionExists:function(e){return"unknown"===e||"undefined"!==e}}}(),OSF.OUtil.Guid=function(){var e=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return{generateNewGuid:function(){for(var t="",n=(new Date).getTime(),r=0;r<32&&n>0;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[n%16],n=Math.floor(n/16);for(;r<32;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[Math.floor(16*Math.random())];return t}}}();try{!function(){OSF.Flights=OSF.OUtil.parseFlights(!0)}()}catch(e){}window.OSF=OSF,OSF.OUtil.setNamespace("OSF",window),OSF.MessageIDs={FetchBundleUrl:0,LoadReactBundle:1,LoadBundleSuccess:2,LoadBundleError:3},OSF.AppName={Unsupported:0,Excel:1,Word:2,PowerPoint:4,Outlook:8,ExcelWebApp:16,WordWebApp:32,OutlookWebApp:64,Project:128,AccessWebApp:256,PowerpointWebApp:512,ExcelIOS:1024,Sway:2048,WordIOS:4096,PowerPointIOS:8192,Access:16384,Lync:32768,OutlookIOS:65536,OneNoteWebApp:131072,OneNote:262144,ExcelWinRT:524288,WordWinRT:1048576,PowerpointWinRT:2097152,OutlookAndroid:4194304,OneNoteWinRT:8388608,ExcelAndroid:8388609,VisioWebApp:8388610,OneNoteIOS:8388611,WordAndroid:8388613,PowerpointAndroid:8388614,Visio:8388615,OneNoteAndroid:4194305},OSF.InternalPerfMarker={DataCoercionBegin:"Agave.HostCall.CoerceDataStart",DataCoercionEnd:"Agave.HostCall.CoerceDataEnd"},OSF.HostCallPerfMarker={IssueCall:"Agave.HostCall.IssueCall",ReceiveResponse:"Agave.HostCall.ReceiveResponse",RuntimeExceptionRaised:"Agave.HostCall.RuntimeExecptionRaised"},OSF.AgaveHostAction={Select:0,UnSelect:1,CancelDialog:2,InsertAgave:3,CtrlF6In:4,CtrlF6Exit:5,CtrlF6ExitShift:6,SelectWithError:7,NotifyHostError:8,RefreshAddinCommands:9,PageIsReady:10,TabIn:11,TabInShift:12,TabExit:13,TabExitShift:14,EscExit:15,F2Exit:16,ExitNoFocusable:17,ExitNoFocusableShift:18,MouseEnter:19,MouseLeave:20,UpdateTargetUrl:21,InstallCustomFunctions:22,SendTelemetryEvent:23,UninstallCustomFunctions:24,SendMessage:25,LaunchExtensionComponent:26,StopExtensionComponent:27,RestartExtensionComponent:28,EnableTaskPaneHeaderButton:29,DisableTaskPaneHeaderButton:30,TaskPaneHeaderButtonClicked:31,RemoveAppCommandsAddin:32,RefreshRibbonGallery:33,GetOriginalControlId:34,OfficeJsReady:35,InsertDevManifest:36,InsertDevManifestError:37,SendCustomerContent:38,KeyboardShortcuts:39},OSF.SharedConstants={NotificationConversationIdSuffix:"_ntf"},OSF.DialogMessageType={DialogMessageReceived:0,DialogParentMessageReceived:1,DialogClosed:12006},OSF.OfficeAppContext=function(e,t,n,r,o,i,a,s,c,l,u,d,f,p,h,m,g,y,v,O,b,S,C,_,A,D,E){this._id=e,this._appName=t,this._appVersion=n,this._appUILocale=r,this._dataLocale=o,this._docUrl=i,this._clientMode=a,this._settings=s,this._reason=c,this._osfControlType=l,this._eToken=u,this._correlationId=d,this._appInstanceId=f,this._touchEnabled=p,this._commerceAllowed=h,this._appMinorVersion=m,this._requirementMatrix=g,this._hostCustomMessage=y,this._hostFullVersion=v,this._isDialog=!1,this._clientWindowHeight=O,this._clientWindowWidth=b,this._addinName=S,this._appDomains=C,this._dialogRequirementMatrix=_,this._featureGates=A,this._officeTheme=D,this._initialDisplayMode=E,this.get_id=function(){return this._id},this.get_appName=function(){return this._appName},this.get_appVersion=function(){return this._appVersion},this.get_appUILocale=function(){return this._appUILocale},this.get_dataLocale=function(){return this._dataLocale},this.get_docUrl=function(){return this._docUrl},this.get_clientMode=function(){return this._clientMode},this.get_bindings=function(){return this._bindings},this.get_settings=function(){return this._settings},this.get_reason=function(){return this._reason},this.get_osfControlType=function(){return this._osfControlType},this.get_eToken=function(){return this._eToken},this.get_correlationId=function(){return this._correlationId},this.get_appInstanceId=function(){return this._appInstanceId},this.get_touchEnabled=function(){return this._touchEnabled},this.get_commerceAllowed=function(){return this._commerceAllowed},this.get_appMinorVersion=function(){return this._appMinorVersion},this.get_requirementMatrix=function(){return this._requirementMatrix},this.get_dialogRequirementMatrix=function(){return this._dialogRequirementMatrix},this.get_hostCustomMessage=function(){return this._hostCustomMessage},this.get_hostFullVersion=function(){return this._hostFullVersion},this.get_isDialog=function(){return this._isDialog},this.get_clientWindowHeight=function(){return this._clientWindowHeight},this.get_clientWindowWidth=function(){return this._clientWindowWidth},this.get_addinName=function(){return this._addinName},this.get_appDomains=function(){return this._appDomains},this.get_featureGates=function(){return this._featureGates},this.get_officeTheme=function(){return this._officeTheme},this.get_initialDisplayMode=function(){return this._initialDisplayMode?this._initialDisplayMode:0}},OSF.OsfControlType={DocumentLevel:0,ContainerLevel:1},OSF.ClientMode={ReadOnly:0,ReadWrite:1},OSF.OUtil.setNamespace("Microsoft",window),OSF.OUtil.setNamespace("Office",Microsoft),OSF.OUtil.setNamespace("Client",Microsoft.Office),OSF.OUtil.setNamespace("WebExtension",Microsoft.Office),Microsoft.Office.WebExtension.InitializationReason={Inserted:"inserted",DocumentOpened:"documentOpened",ControlActivation:"controlActivation"},Microsoft.Office.WebExtension.ValueFormat={Unformatted:"unformatted",Formatted:"formatted"},Microsoft.Office.WebExtension.FilterType={All:"all"},Microsoft.Office.WebExtension.Parameters={BindingType:"bindingType",CoercionType:"coercionType",ValueFormat:"valueFormat",FilterType:"filterType",Columns:"columns",SampleData:"sampleData",GoToType:"goToType",SelectionMode:"selectionMode",Id:"id",PromptText:"promptText",ItemName:"itemName",FailOnCollision:"failOnCollision",StartRow:"startRow",StartColumn:"startColumn",RowCount:"rowCount",ColumnCount:"columnCount",Callback:"callback",AsyncContext:"asyncContext",Data:"data",JsonData:"jsonData",Rows:"rows",OverwriteIfStale:"overwriteIfStale",FileType:"fileType",EventType:"eventType",Handler:"handler",SliceSize:"sliceSize",SliceIndex:"sliceIndex",ActiveView:"activeView",Status:"status",PlatformType:"platformType",HostType:"hostType",ForceConsent:"forceConsent",ForceAddAccount:"forceAddAccount",AuthChallenge:"authChallenge",AllowConsentPrompt:"allowConsentPrompt",ForMSGraphAccess:"forMSGraphAccess",AllowSignInPrompt:"allowSignInPrompt",JsonPayload:"jsonPayload",EnableNewHosts:"enableNewHosts",AccountTypeFilter:"accountTypeFilter",AddinTrustId:"addinTrustId",Reserved:"reserved",Tcid:"tcid",Xml:"xml",Namespace:"namespace",Prefix:"prefix",XPath:"xPath",Text:"text",ImageLeft:"imageLeft",ImageTop:"imageTop",ImageWidth:"imageWidth",ImageHeight:"imageHeight",TaskId:"taskId",FieldId:"fieldId",FieldValue:"fieldValue",ServerUrl:"serverUrl",ListName:"listName",ResourceId:"resourceId",ViewType:"viewType",ViewName:"viewName",GetRawValue:"getRawValue",CellFormat:"cellFormat",TableOptions:"tableOptions",TaskIndex:"taskIndex",ResourceIndex:"resourceIndex",CustomFieldId:"customFieldId",Url:"url",MessageHandler:"messageHandler",Width:"width",Height:"height",RequireHTTPs:"requireHTTPS",MessageToParent:"messageToParent",DisplayInIframe:"displayInIframe",MessageContent:"messageContent",HideTitle:"hideTitle",UseDeviceIndependentPixels:"useDeviceIndependentPixels",PromptBeforeOpen:"promptBeforeOpen",EnforceAppDomain:"enforceAppDomain",UrlNoHostInfo:"urlNoHostInfo",TargetOrigin:"targetOrigin",AppCommandInvocationCompletedData:"appCommandInvocationCompletedData",Base64:"base64",FormId:"formId"},OSF.OUtil.setNamespace("DDA",OSF),OSF.DDA.DocumentMode={ReadOnly:1,ReadWrite:0},OSF.DDA.PropertyDescriptors={AsyncResultStatus:"AsyncResultStatus"},OSF.DDA.EventDescriptors={},OSF.DDA.ListDescriptors={},OSF.DDA.UI={},OSF.DDA.getXdmEventName=function(e,t){return t==Microsoft.Office.WebExtension.EventType.BindingSelectionChanged||t==Microsoft.Office.WebExtension.EventType.BindingDataChanged||t==Microsoft.Office.WebExtension.EventType.DataNodeDeleted||t==Microsoft.Office.WebExtension.EventType.DataNodeInserted||t==Microsoft.Office.WebExtension.EventType.DataNodeReplaced?e+"_"+t:t},OSF.DDA.MethodDispId={dispidMethodMin:64,dispidGetSelectedDataMethod:64,dispidSetSelectedDataMethod:65,dispidAddBindingFromSelectionMethod:66,dispidAddBindingFromPromptMethod:67,dispidGetBindingMethod:68,dispidReleaseBindingMethod:69,dispidGetBindingDataMethod:70,dispidSetBindingDataMethod:71,dispidAddRowsMethod:72,dispidClearAllRowsMethod:73,dispidGetAllBindingsMethod:74,dispidLoadSettingsMethod:75,dispidSaveSettingsMethod:76,dispidGetDocumentCopyMethod:77,dispidAddBindingFromNamedItemMethod:78,dispidAddColumnsMethod:79,dispidGetDocumentCopyChunkMethod:80,dispidReleaseDocumentCopyMethod:81,dispidNavigateToMethod:82,dispidGetActiveViewMethod:83,dispidGetDocumentThemeMethod:84,dispidGetOfficeThemeMethod:85,dispidGetFilePropertiesMethod:86,dispidClearFormatsMethod:87,dispidSetTableOptionsMethod:88,dispidSetFormatsMethod:89,dispidExecuteRichApiRequestMethod:93,dispidAppCommandInvocationCompletedMethod:94,dispidCloseContainerMethod:97,dispidGetAccessTokenMethod:98,dispidGetAuthContextMethod:99,dispidOpenBrowserWindow:102,dispidCreateDocumentMethod:105,dispidInsertFormMethod:106,dispidDisplayRibbonCalloutAsyncMethod:109,dispidGetSelectedTaskMethod:110,dispidGetSelectedResourceMethod:111,dispidGetTaskMethod:112,dispidGetResourceFieldMethod:113,dispidGetWSSUrlMethod:114,dispidGetTaskFieldMethod:115,dispidGetProjectFieldMethod:116,dispidGetSelectedViewMethod:117,dispidGetTaskByIndexMethod:118,dispidGetResourceByIndexMethod:119,dispidSetTaskFieldMethod:120,dispidSetResourceFieldMethod:121,dispidGetMaxTaskIndexMethod:122,dispidGetMaxResourceIndexMethod:123,dispidCreateTaskMethod:124,dispidAddDataPartMethod:128,dispidGetDataPartByIdMethod:129,dispidGetDataPartsByNamespaceMethod:130,dispidGetDataPartXmlMethod:131,dispidGetDataPartNodesMethod:132,dispidDeleteDataPartMethod:133,dispidGetDataNodeValueMethod:134,dispidGetDataNodeXmlMethod:135,dispidGetDataNodesMethod:136,dispidSetDataNodeValueMethod:137,dispidSetDataNodeXmlMethod:138,dispidAddDataNamespaceMethod:139,dispidGetDataUriByPrefixMethod:140,dispidGetDataPrefixByUriMethod:141,dispidGetDataNodeTextMethod:142,dispidSetDataNodeTextMethod:143,dispidMessageParentMethod:144,dispidSendMessageMethod:145,dispidExecuteFeature:146,dispidQueryFeature:147,dispidGetNestedAppAuthContextMethod:205,dispidSdxSendMessage:208},OSF.DDA.EventDispId={dispidEventMin:0,dispidInitializeEvent:0,dispidSettingsChangedEvent:1,dispidDocumentSelectionChangedEvent:2,dispidBindingSelectionChangedEvent:3,dispidBindingDataChangedEvent:4,dispidDocumentOpenEvent:5,dispidDocumentCloseEvent:6,dispidActiveViewChangedEvent:7,dispidDocumentThemeChangedEvent:8,dispidOfficeThemeChangedEvent:9,dispidDialogMessageReceivedEvent:10,dispidDialogNotificationShownInAddinEvent:11,dispidDialogParentMessageReceivedEvent:12,dispidObjectDeletedEvent:13,dispidObjectSelectionChangedEvent:14,dispidObjectDataChangedEvent:15,dispidContentControlAddedEvent:16,dispidSuspend:19,dispidResume:20,dispidActivationStatusChangedEvent:32,dispidRichApiMessageEvent:33,dispidAppCommandInvokedEvent:39,dispidOnSdxSendMessageEvent:40,dispidOlkItemSelectedChangedEvent:46,dispidOlkRecipientsChangedEvent:47,dispidOlkAppointmentTimeChangedEvent:48,dispidOlkRecurrenceChangedEvent:49,dispidOlkAttachmentsChangedEvent:50,dispidOlkEnhancedLocationsChangedEvent:51,dispidOlkInfobarClickedEvent:52,dispidOlkSelectedItemsChangedEvent:53,dispidOlkSensitivityLabelChangedEvent:54,dispidTaskSelectionChangedEvent:56,dispidResourceSelectionChangedEvent:57,dispidViewSelectionChangedEvent:58,dispidDataNodeAddedEvent:60,dispidDataNodeReplacedEvent:61,dispidDataNodeDeletedEvent:62,dispidEventMax:63},OSF.DDA.ErrorCodeManager=function(){var e={};return{getErrorArgs:function(t){var n=e[t];return n?(n.name||(n.name=e[this.errorCodes.ooeInternalError].name),n.message||(n.message=e[this.errorCodes.ooeInternalError].message)):n=e[this.errorCodes.ooeInternalError],n},addErrorMessage:function(t,n){e[t]=n},errorCodes:{ooeSuccess:0,ooeChunkResult:1,ooeCoercionTypeNotSupported:1e3,ooeGetSelectionNotMatchDataType:1001,ooeCoercionTypeNotMatchBinding:1002,ooeInvalidGetRowColumnCounts:1003,ooeSelectionNotSupportCoercionType:1004,ooeInvalidGetStartRowColumn:1005,ooeNonUniformPartialGetNotSupported:1006,ooeGetDataIsTooLarge:1008,ooeFileTypeNotSupported:1009,ooeGetDataParametersConflict:1010,ooeInvalidGetColumns:1011,ooeInvalidGetRows:1012,ooeInvalidReadForBlankRow:1013,ooeUnsupportedDataObject:2e3,ooeCannotWriteToSelection:2001,ooeDataNotMatchSelection:2002,ooeOverwriteWorksheetData:2003,ooeDataNotMatchBindingSize:2004,ooeInvalidSetStartRowColumn:2005,ooeInvalidDataFormat:2006,ooeDataNotMatchCoercionType:2007,ooeDataNotMatchBindingType:2008,ooeSetDataIsTooLarge:2009,ooeNonUniformPartialSetNotSupported:2010,ooeInvalidSetColumns:2011,ooeInvalidSetRows:2012,ooeSetDataParametersConflict:2013,ooeCellDataAmountBeyondLimits:2014,ooeSelectionCannotBound:3e3,ooeBindingNotExist:3002,ooeBindingToMultipleSelection:3003,ooeInvalidSelectionForBindingType:3004,ooeOperationNotSupportedOnThisBindingType:3005,ooeNamedItemNotFound:3006,ooeMultipleNamedItemFound:3007,ooeInvalidNamedItemForBindingType:3008,ooeUnknownBindingType:3009,ooeOperationNotSupportedOnMatrixData:3010,ooeInvalidColumnsForBinding:3011,ooeSettingNameNotExist:4e3,ooeSettingsCannotSave:4001,ooeSettingsAreStale:4002,ooeOperationNotSupported:5e3,ooeInternalError:5001,ooeDocumentReadOnly:5002,ooeEventHandlerNotExist:5003,ooeInvalidApiCallInContext:5004,ooeShuttingDown:5005,ooeUnsupportedEnumeration:5007,ooeIndexOutOfRange:5008,ooeBrowserAPINotSupported:5009,ooeInvalidParam:5010,ooeRequestTimeout:5011,ooeInvalidOrTimedOutSession:5012,ooeInvalidApiArguments:5013,ooeOperationCancelled:5014,ooeWorkbookHidden:5015,ooeWriteNotSupportedWhenModalDialogOpen:5016,ooeTooManyIncompleteRequests:5100,ooeRequestTokenUnavailable:5101,ooeActivityLimitReached:5102,ooeRequestPayloadSizeLimitExceeded:5103,ooeResponsePayloadSizeLimitExceeded:5104,ooeCustomXmlNodeNotFound:6e3,ooeCustomXmlError:6100,ooeCustomXmlExceedQuota:6101,ooeCustomXmlOutOfDate:6102,ooeNoCapability:7e3,ooeCannotNavTo:7001,ooeSpecifiedIdNotExist:7002,ooeNavOutOfBound:7004,ooeElementMissing:8e3,ooeProtectedError:8001,ooeInvalidCellsValue:8010,ooeInvalidTableOptionValue:8011,ooeInvalidFormatValue:8012,ooeRowIndexOutOfRange:8020,ooeColIndexOutOfRange:8021,ooeFormatValueOutOfRange:8022,ooeCellFormatAmountBeyondLimits:8023,ooeMemoryFileLimit:11e3,ooeNetworkProblemRetrieveFile:11001,ooeInvalidSliceSize:11002,ooeInvalidCallback:11101,ooeInvalidWidth:12e3,ooeInvalidHeight:12001,ooeNavigationError:12002,ooeInvalidScheme:12003,ooeAppDomains:12004,ooeRequireHTTPS:12005,ooeWebDialogClosed:12006,ooeDialogAlreadyOpened:12007,ooeEndUserAllow:12008,ooeEndUserIgnore:12009,ooeNotUILessDialog:12010,ooeCrossZone:12011,ooeModalDialogOpen:12012,ooeDocumentIsInactive:12013,ooeDialogParentIsMinimized:12014,ooeNotSSOAgave:13e3,ooeSSOUserNotSignedIn:13001,ooeSSOUserAborted:13002,ooeSSOUnsupportedUserIdentity:13003,ooeSSOInvalidResourceUrl:13004,ooeSSOInvalidGrant:13005,ooeSSOClientError:13006,ooeSSOServerError:13007,ooeAddinIsAlreadyRequestingToken:13008,ooeSSOUserConsentNotSupportedByCurrentAddinCategory:13009,ooeSSOConnectionLost:13010,ooeResourceNotAllowed:13011,ooeSSOUnsupportedPlatform:13012,ooeSSOCallThrottled:13013,ooeAccessDenied:13990,ooeGeneralException:13991},initializeErrorMessages:function(t){e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotSupported]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetSelectionNotMatchDataType]={name:t.L_DataReadError,message:t.L_GetSelectionNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotMatchBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRowColumnCounts]={name:t.L_DataReadError,message:t.L_InvalidGetRowColumnCounts},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionNotSupportCoercionType]={name:t.L_DataReadError,message:t.L_SelectionNotSupportCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetStartRowColumn]={name:t.L_DataReadError,message:t.L_InvalidGetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialGetNotSupported]={name:t.L_DataReadError,message:t.L_NonUniformPartialGetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataIsTooLarge]={name:t.L_DataReadError,message:t.L_GetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFileTypeNotSupported]={name:t.L_DataReadError,message:t.L_FileTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataParametersConflict]={name:t.L_DataReadError,message:t.L_GetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetColumns]={name:t.L_DataReadError,message:t.L_InvalidGetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRows]={name:t.L_DataReadError,message:t.L_InvalidGetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidReadForBlankRow]={name:t.L_DataReadError,message:t.L_InvalidReadForBlankRow},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject]={name:t.L_DataWriteError,message:t.L_UnsupportedDataObject},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotWriteToSelection]={name:t.L_DataWriteError,message:t.L_CannotWriteToSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchSelection]={name:t.L_DataWriteError,message:t.L_DataNotMatchSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOverwriteWorksheetData]={name:t.L_DataWriteError,message:t.L_OverwriteWorksheetData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingSize]={name:t.L_DataWriteError,message:t.L_DataNotMatchBindingSize},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetStartRowColumn]={name:t.L_DataWriteError,message:t.L_InvalidSetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidDataFormat]={name:t.L_InvalidFormat,message:t.L_InvalidDataFormat},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchCoercionType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataIsTooLarge]={name:t.L_DataWriteError,message:t.L_SetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialSetNotSupported]={name:t.L_DataWriteError,message:t.L_NonUniformPartialSetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetColumns]={name:t.L_DataWriteError,message:t.L_InvalidSetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetRows]={name:t.L_DataWriteError,message:t.L_InvalidSetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataParametersConflict]={name:t.L_DataWriteError,message:t.L_SetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionCannotBound]={name:t.L_BindingCreationError,message:t.L_SelectionCannotBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingNotExist]={name:t.L_InvalidBindingError,message:t.L_BindingNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingToMultipleSelection]={name:t.L_BindingCreationError,message:t.L_BindingToMultipleSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSelectionForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidSelectionForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnThisBindingType]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnThisBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNamedItemNotFound]={name:t.L_BindingCreationError,message:t.L_NamedItemNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMultipleNamedItemFound]={name:t.L_BindingCreationError,message:t.L_MultipleNamedItemFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidNamedItemForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidNamedItemForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnknownBindingType]={name:t.L_InvalidBinding,message:t.L_UnknownBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnMatrixData]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnMatrixData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidColumnsForBinding]={name:t.L_InvalidBinding,message:t.L_InvalidColumnsForBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingNameNotExist]={name:t.L_ReadSettingsError,message:t.L_SettingNameNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsCannotSave]={name:t.L_SaveSettingsError,message:t.L_SettingsCannotSave},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsAreStale]={name:t.L_SettingsStaleError,message:t.L_SettingsAreStale},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupported]={name:t.L_HostError,message:t.L_OperationNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError]={name:t.L_InternalError,message:t.L_InternalErrorDescription},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentReadOnly]={name:t.L_PermissionDenied,message:t.L_DocumentReadOnly},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist]={name:t.L_EventRegistrationError,message:t.L_EventHandlerNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext]={name:t.L_InvalidAPICall,message:t.L_InvalidApiCallInContext},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeShuttingDown]={name:t.L_ShuttingDown,message:t.L_ShuttingDown},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration]={name:t.L_UnsupportedEnumeration,message:t.L_UnsupportedEnumerationMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBrowserAPINotSupported]={name:t.L_APINotSupported,message:t.L_BrowserAPINotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTimeout]={name:t.L_APICallFailed,message:t.L_RequestTimeout},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidOrTimedOutSession]={name:t.L_InvalidOrTimedOutSession,message:t.L_InvalidOrTimedOutSessionMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiArguments]={name:t.L_APICallFailed,message:t.L_InvalidApiArgumentsMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWorkbookHidden]={name:t.L_APICallFailed,message:t.L_WorkbookHiddenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWriteNotSupportedWhenModalDialogOpen]={name:t.L_APICallFailed,message:t.L_WriteNotSupportedWhenModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests]={name:t.L_APICallFailed,message:t.L_TooManyIncompleteRequests},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTokenUnavailable]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeActivityLimitReached]={name:t.L_APICallFailed,message:t.L_ActivityLimitReached},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestPayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_RequestPayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeResponsePayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_ResponsePayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlNodeNotFound]={name:t.L_InvalidNode,message:t.L_CustomXmlNodeNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlError]={name:t.L_CustomXmlError,message:t.L_CustomXmlError},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlExceedQuota]={name:t.L_CustomXmlExceedQuotaName,message:t.L_CustomXmlExceedQuotaMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlOutOfDate]={name:t.L_CustomXmlOutOfDateName,message:t.L_CustomXmlOutOfDateMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotNavTo]={name:t.L_CannotNavigateTo,message:t.L_CannotNavigateTo},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSpecifiedIdNotExist]={name:t.L_SpecifiedIdNotExist,message:t.L_SpecifiedIdNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavOutOfBound]={name:t.L_NavOutOfBound,message:t.L_NavOutOfBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellDataAmountBeyondLimits]={name:t.L_DataWriteReminder,message:t.L_CellDataAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeElementMissing]={name:t.L_MissingParameter,message:t.L_ElementMissing},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeProtectedError]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCellsValue]={name:t.L_InvalidValue,message:t.L_InvalidCellsValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidTableOptionValue]={name:t.L_InvalidValue,message:t.L_InvalidTableOptionValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidFormatValue]={name:t.L_InvalidValue,message:t.L_InvalidFormatValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRowIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_RowIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeColIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_ColIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFormatValueOutOfRange]={name:t.L_OutOfRange,message:t.L_FormatValueOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellFormatAmountBeyondLimits]={name:t.L_FormattingReminder,message:t.L_CellFormatAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMemoryFileLimit]={name:t.L_MemoryLimit,message:t.L_CloseFileBeforeRetrieve},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNetworkProblemRetrieveFile]={name:t.L_NetworkProblem,message:t.L_NetworkProblemRetrieveFile},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize]={name:t.L_InvalidValue,message:t.L_SliceSizeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened]={name:t.L_DisplayDialogError,message:t.L_DialogAlreadyOpened},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidWidth]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidHeight]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavigationError]={name:t.L_DisplayDialogError,message:t.L_NetworkProblem},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme]={name:t.L_DialogNavigateError,message:t.L_DialogInvalidScheme},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAppDomains]={name:t.L_DisplayDialogError,message:t.L_DialogAddressNotTrusted},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequireHTTPS]={name:t.L_DisplayDialogError,message:t.L_DialogRequireHTTPS},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore]={name:t.L_DisplayDialogError,message:t.L_UserClickIgnore},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCrossZone]={name:t.L_DisplayDialogError,message:t.L_NewWindowCrossZoneErrorString},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeModalDialogOpen]={name:t.L_DisplayDialogError,message:t.L_ModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentIsInactive]={name:t.L_DisplayDialogError,message:t.L_DocumentIsInactive},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogParentIsMinimized]={name:t.L_DisplayDialogError,message:t.L_DialogParentIsMinimized},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNotSSOAgave]={name:t.L_APINotSupported,message:t.L_InvalidSSOAddinMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserNotSignedIn]={name:t.L_UserNotSignedIn,message:t.L_UserNotSignedIn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserAborted]={name:t.L_UserAborted,message:t.L_UserAbortedMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedUserIdentity]={name:t.L_UnsupportedUserIdentity,message:t.L_UnsupportedUserIdentityMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidResourceUrl]={name:t.L_InvalidResourceUrl,message:t.L_InvalidResourceUrlMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidGrant]={name:t.L_InvalidGrant,message:t.L_InvalidGrantMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOClientError]={name:t.L_SSOClientError,message:t.L_SSOClientErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOServerError]={name:t.L_SSOServerError,message:t.L_SSOServerErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAddinIsAlreadyRequestingToken]={name:t.L_AddinIsAlreadyRequestingToken,message:t.L_AddinIsAlreadyRequestingTokenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserConsentNotSupportedByCurrentAddinCategory]={name:t.L_SSOUserConsentNotSupportedByCurrentAddinCategory,message:t.L_SSOUserConsentNotSupportedByCurrentAddinCategoryMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOConnectionLost]={name:t.L_SSOConnectionLostError,message:t.L_SSOConnectionLostErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedPlatform]={name:t.L_APINotSupported,message:t.L_SSOUnsupportedPlatform},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOCallThrottled]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationCancelled]={name:t.L_OperationCancelledError,message:t.L_OperationCancelledErrorMessage}}}}(),function(e){!function(e){var t=function(){return function(){}}();e.RequirementVersion=t;var n=function(){return function(e){this.isSetSupported=function(e,t){if(void 0==e)return!1;void 0==t&&(t=0);var n=this._setMap._sets;if(n.hasOwnProperty(e.toLowerCase())){var r=n[e.toLowerCase()];try{var o=this._getVersion(r);t+="";var i=this._getVersion(t);if(o.major>0&&o.major>i.major)return!0;if(o.major>0&&o.minor>=0&&o.major==i.major&&o.minor>=i.minor)return!0}catch(e){return!1}}return!1},this._getVersion=function(e){var t=(e+="").split("."),n=0,r=0;if(t.length<2&&isNaN(Number(e)))throw"version format incorrect";if(n=Number(t[0]),t.length>=2&&(r=Number(t[1])),isNaN(n)||isNaN(r))throw"version format incorrect";return{minor:r,major:n}},this._setMap=e,this.isSetSupported=this.isSetSupported.bind(this)}}();e.RequirementMatrix=n;var r=function(){return function(e){this._addSetMap=function(e){for(var t in e)this._sets[t]=e[t]},this._sets=e}}();e.DefaultSetRequirement=r;var o=function(e){function t(){return e.call(this,{dialogapi:1.1})||this}return __extends(t,e),t}(r);e.DefaultRequiredDialogSetRequirement=o;var i=function(e){function t(){return e.call(this,{dialogorigin:1.1})||this}return __extends(t,e),t}(r);e.DefaultOptionalDialogSetRequirement=i;var a=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,excelapi:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelClientDefaultSetRequirement=a;var s=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(a);e.ExcelClientV1DefaultSetRequirement=s;var c=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookClientDefaultSetRequirement=c;var l=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1,wordapi:1.1})||this}return __extends(t,e),t}(r);e.WordClientDefaultSetRequirement=l;var u=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2,imagecoercion:1.1}),t}return __extends(t,e),t}(l);e.WordClientV1DefaultSetRequirement=u;var d=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointClientDefaultSetRequirement=d;var f=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(d);e.PowerpointClientV1DefaultSetRequirement=f;var p=function(e){function t(){return e.call(this,{selection:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ProjectClientDefaultSetRequirement=p;var h=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,file:1.1})||this}return __extends(t,e),t}(r);e.ExcelWebDefaultSetRequirement=h;var m=function(e){function t(){return e.call(this,{compressedfile:1.1,documentevents:1.1,file:1.1,imagecoercion:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablecoercion:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordWebDefaultSetRequirement=m;var g=function(e){function t(){return e.call(this,{activeview:1.1,settings:1.1})||this}return __extends(t,e),t}(r);e.PowerpointWebDefaultSetRequirement=g;var y=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookWebDefaultSetRequirement=y;var v=function(e){function t(){return e.call(this,{activeview:1.1,documentevents:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.SwayWebDefaultSetRequirement=v;var O=function(e){function t(){return e.call(this,{bindingevents:1.1,partialtablebindings:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1})||this}return __extends(t,e),t}(r);e.AccessWebDefaultSetRequirement=O;var b=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelIOSDefaultSetRequirement=b;var S=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordIOSDefaultSetRequirement=S;var C=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2}),t}return __extends(t,e),t}(S);e.WordIOSV1DefaultSetRequirement=C;var _=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointIOSDefaultSetRequirement=_;var A=function(e){function t(){return e.call(this,{mailbox:1.1})||this}return __extends(t,e),t}(r);e.OutlookIOSDefaultSetRequirement=A;var D=function(){function e(){}return e.initializeOsfDda=function(){OSF.OUtil.setNamespace("Requirement",OSF.DDA)},e.getDefaultRequirementMatrix=function(t){this.initializeDefaultSetMatrix();var o=void 0,i=t.get_requirementMatrix();if(void 0!=i&&i.length>0&&"undefined"!==typeof JSON){var a=JSON.parse(t.get_requirementMatrix().toLowerCase());o=new n(new r(a))}else{var s=e.getClientFullVersionString(t);o=void 0!=e.DefaultSetArrayMatrix&&void 0!=e.DefaultSetArrayMatrix[s]?new n(e.DefaultSetArrayMatrix[s]):new n(new r({}))}return o},e.getDefaultDialogRequirementMatrix=function(e){var t=void 0,a=e.get_dialogRequirementMatrix();if(void 0!=a&&a.length>0&&"undefined"!==typeof JSON){var s=JSON.parse(e.get_requirementMatrix().toLowerCase());t=new r(s)}else{t=new o;var c=e.get_requirementMatrix();if(void 0!=c&&c.length>0&&"undefined"!==typeof JSON){s=JSON.parse(c.toLowerCase());for(var l in t._sets)s.hasOwnProperty(l)&&(t._sets[l]=s[l]);var u=new i;for(var l in u._sets)s.hasOwnProperty(l)&&(t._sets[l]=s[l])}}return new n(t)},e.getClientFullVersionString=function(e){var t=e.get_appMinorVersion(),n="",r="",o=e.get_appName();return(1024==o||4096==o||8192==o||65536==o)&&1==e.get_appVersion()?r=4096==o&&t>=15?"16.00.01":"16.00":64==e.get_appName()?r=e.get_appVersion():(n=t<10?"0"+t:""+t,r=e.get_appVersion()+"."+n),e.get_appName()+"-"+r},e.initializeDefaultSetMatrix=function(){e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1600]=new a,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1600]=new l,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1600]=new d,e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1601]=new s,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1601]=new u,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1601]=new f,e.DefaultSetArrayMatrix[e.Outlook_RCLIENT_1600]=new c,e.DefaultSetArrayMatrix[e.Excel_WAC_1600]=new h,e.DefaultSetArrayMatrix[e.Word_WAC_1600]=new m,e.DefaultSetArrayMatrix[e.Outlook_WAC_1600]=new y,e.DefaultSetArrayMatrix[e.Outlook_WAC_1601]=new y,e.DefaultSetArrayMatrix[e.Project_RCLIENT_1600]=new p,e.DefaultSetArrayMatrix[e.Access_WAC_1600]=new O,e.DefaultSetArrayMatrix[e.PowerPoint_WAC_1600]=new g,e.DefaultSetArrayMatrix[e.Excel_IOS_1600]=new b,e.DefaultSetArrayMatrix[e.SWAY_WAC_1600]=new v,e.DefaultSetArrayMatrix[e.Word_IOS_1600]=new S,e.DefaultSetArrayMatrix[e.Word_IOS_16001]=new C,e.DefaultSetArrayMatrix[e.PowerPoint_IOS_1600]=new _,e.DefaultSetArrayMatrix[e.Outlook_IOS_1600]=new A},e.Excel_RCLIENT_1600="1-16.00",e.Excel_RCLIENT_1601="1-16.01",e.Word_RCLIENT_1600="2-16.00",e.Word_RCLIENT_1601="2-16.01",e.PowerPoint_RCLIENT_1600="4-16.00",e.PowerPoint_RCLIENT_1601="4-16.01",e.Outlook_RCLIENT_1600="8-16.00",e.Excel_WAC_1600="16-16.00",e.Word_WAC_1600="32-16.00",e.Outlook_WAC_1600="64-16.00",e.Outlook_WAC_1601="64-16.01",e.Project_RCLIENT_1600="128-16.00",e.Access_WAC_1600="256-16.00",e.PowerPoint_WAC_1600="512-16.00",e.Excel_IOS_1600="1024-16.00",e.SWAY_WAC_1600="2048-16.00",e.Word_IOS_1600="4096-16.00",e.Word_IOS_16001="4096-16.00.01",e.PowerPoint_IOS_1600="8192-16.00",e.Outlook_IOS_1600="65536-16.00",e.DefaultSetArrayMatrix={},e}();e.RequirementsMatrixFactory=D}(e.Requirement||(e.Requirement={}))}(OfficeExt||(OfficeExt={})),OfficeExt.Requirement.RequirementsMatrixFactory.initializeOsfDda(),Microsoft.Office.WebExtension.ApplicationMode={WebEditor:"webEditor",WebViewer:"webViewer",Client:"client"},Microsoft.Office.WebExtension.DocumentMode={ReadOnly:"readOnly",ReadWrite:"readWrite"},OSF.NamespaceManager=function(){var e,t=!1;return{enableShortcut:function(){t||(window.Office?e=window.Office:OSF.OUtil.setNamespace("Office",window),window.Office=Microsoft.Office.WebExtension,t=!0)},disableShortcut:function(){t&&(e?window.Office=e:OSF.OUtil.unsetNamespace("Office",window),t=!1)}}}(),OSF.NamespaceManager.enableShortcut(),Microsoft.Office.WebExtension.useShortNamespace=function(e){e?OSF.NamespaceManager.enableShortcut():OSF.NamespaceManager.disableShortcut()},Microsoft.Office.WebExtension.select=function(e,t){var n;if(e&&"string"==typeof e){var r=e.indexOf("#");if(-1!=r){var o=e.substring(0,r),i=e.substring(r+1);switch(o){case"binding":case"bindings":i&&(n=new OSF.DDA.BindingPromise(i))}}}if(n)return n.onFail=t,n;if(t){var a=typeof t;if("function"!=a)throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,a);var s={};s[Microsoft.Office.WebExtension.Parameters.Callback]=t,OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext,OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext))}},OSF.DDA.Context=function(e,t,n,r,o){if(OSF.OUtil.defineEnumerableProperties(this,{contentLanguage:{value:e.get_dataLocale()},displayLanguage:{value:e.get_appUILocale()},touchEnabled:{value:e.get_touchEnabled()},commerceAllowed:{value:e.get_commerceAllowed()},host:{value:OfficeExt.HostName.Host.getInstance().getHost()},platform:{value:OfficeExt.HostName.Host.getInstance().getPlatform()},isDialog:{value:OSF._OfficeAppFactory.getHostInfo().isDialog},diagnostics:{value:OfficeExt.HostName.Host.getInstance().getDiagnostics(e.get_hostFullVersion())}}),n&&OSF.OUtil.defineEnumerableProperty(this,"license",{value:n}),e.ui&&OSF.OUtil.defineEnumerableProperty(this,"ui",{value:e.ui}),e.auth&&OSF.OUtil.defineEnumerableProperty(this,"auth",{value:e.auth}),e.webAuth&&OSF.OUtil.defineEnumerableProperty(this,"webAuth",{value:e.webAuth}),e.application&&OSF.OUtil.defineEnumerableProperty(this,"application",{value:e.application}),e.extensionLifeCycle&&OSF.OUtil.defineEnumerableProperty(this,"extensionLifeCycle",{value:e.extensionLifeCycle}),e.messaging&&OSF.OUtil.defineEnumerableProperty(this,"messaging",{value:e.messaging}),e.ui&&e.ui.taskPaneAction&&OSF.OUtil.defineEnumerableProperty(this,"taskPaneAction",{value:e.ui.taskPaneAction}),e.ui&&e.ui.ribbonGallery&&OSF.OUtil.defineEnumerableProperty(this,"ribbonGallery",{value:e.ui.ribbonGallery}),e.get_isDialog()){var i=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultDialogRequirementMatrix(e);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:i})}else{if(t&&OSF.OUtil.defineEnumerableProperty(this,"document",{value:t}),r){var a=r.displayName||"appOM";delete r.displayName,OSF.OUtil.defineEnumerableProperty(this,a,{value:r})}e.get_officeTheme()?OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return e.get_officeTheme()}}):o&&OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return o()}});i=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultRequirementMatrix(e);if(OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:i}),e.get_featureGates){var s=e.get_featureGates();if(s&&s.EnablePublicThemeManager){var c=new OSF.DDA.Theming.InternalThemeHandler;c.InitializeThemeManager(),OSF.OUtil.defineEnumerableProperty(this,"themeManager",{value:c})}}}},OSF.DDA.OutlookContext=function(e,t,n,r,o){var i;(OSF.DDA.OutlookContext.uber.constructor.call(this,e,null,n,r,o),e&&e.appOM&&e.appOM.initialData&&e.appOM.initialData.roamingSettings)?(i=OSF.InitializationHelper.prototype.deserializeSettings({SettingsKey:e.appOM.initialData.roamingSettings},!1),OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:i})):t&&OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:t});e.sensitivityLabelsCatalog&&OSF.OUtil.defineEnumerableProperty(this,"sensitivityLabelsCatalog",{value:e.sensitivityLabelsCatalog()})},OSF.OUtil.extend(OSF.DDA.OutlookContext,OSF.DDA.Context),OSF.DDA.OutlookAppOm=function(e,t,n){},OSF.DDA.Application=function(e){},OSF.DDA.Document=function(e,t){var n;switch(e.get_clientMode()){case OSF.ClientMode.ReadOnly:n=Microsoft.Office.WebExtension.DocumentMode.ReadOnly;break;case OSF.ClientMode.ReadWrite:n=Microsoft.Office.WebExtension.DocumentMode.ReadWrite}t&&OSF.OUtil.defineEnumerableProperty(this,"settings",{value:t}),OSF.OUtil.defineMutableProperties(this,{mode:{value:n},url:{value:e.get_docUrl()}})},OSF.DDA.JsomDocument=function(e,t,n){OSF.DDA.JsomDocument.uber.constructor.call(this,e,n),t&&OSF.OUtil.defineEnumerableProperty(this,"bindings",{get:function(){return t}});var r=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[r.GetSelectedDataAsync,r.SetSelectedDataAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged]))},OSF.OUtil.extend(OSF.DDA.JsomDocument,OSF.DDA.Document),OSF.OUtil.defineEnumerableProperty(Microsoft.Office.WebExtension,"context",{get:function(){var e;return OSF&&OSF._OfficeAppFactory&&(e=OSF._OfficeAppFactory.getContext()),e}}),OSF.DDA.License=function(e){OSF.OUtil.defineEnumerableProperty(this,"value",{value:e})},OSF.DDA.ApiMethodCall=function(e,t,n,r,o){var i=e.length,a=OSF.OUtil.delayExecutionAndCache((function(){return OSF.OUtil.formatString(Strings.OfficeOM.L_InvalidParameters,o)}));this.verifyArguments=function(e,t){for(var n in e){var r=e[n],o=t[n];if(r.enum)switch(typeof o){case"string":if(OSF.OUtil.listContainsValue(r.enum,o))break;case"undefined":throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration;default:throw a()}if(r.types&&!OSF.OUtil.listContainsValue(r.types,typeof o))throw a()}},this.extractRequiredArguments=function(t,n,r){if(t.length<i)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_MissingRequiredArguments);var o,s=[];for(o=0;o<i;o++)s.push(t[o]);this.verifyArguments(e,s);var c={};for(o=0;o<i;o++){var l=e[o],u=s[o];if(l.verify)if(!l.verify(u,n,r))throw a();c[l.name]=u}return c},this.fillOptions=function(e,n,r,o){for(var i in e=e||{},t)if(!OSF.OUtil.listContainsKey(e,i)){var a=void 0,s=t[i];s.calculate&&n&&(a=s.calculate(n,r,o)),a||void 0===s.defaultValue||(a=s.defaultValue),e[i]=a}return e},this.constructCallArgs=function(e,t,o,i){var a={};for(var s in e)a[s]=e[s];for(var c in t)a[c]=t[c];for(var l in n)a[l]=n[l](o,i);return r&&(a=r(a,o,i)),a}},OSF.OUtil.setNamespace("AsyncResultEnum",OSF.DDA),OSF.DDA.AsyncResultEnum.Properties={Context:"Context",Value:"Value",Status:"Status",Error:"Error"},Microsoft.Office.WebExtension.AsyncResultStatus={Succeeded:"succeeded",Failed:"failed"},OSF.DDA.AsyncResultEnum.ErrorCode={Success:0,Failed:1},OSF.DDA.AsyncResultEnum.ErrorProperties={Name:"Name",Message:"Message",Code:"Code"},OSF.DDA.AsyncMethodNames={},OSF.DDA.AsyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.AsyncMethodNames[t]=n}},OSF.DDA.AsyncMethodCall=function(e,t,n,r,o,i,a){var s=e.length,c=new OSF.DDA.ApiMethodCall(e,t,n,i,a);this.verifyAndExtractCall=function(e,n,r){var o=c.extractRequiredArguments(e,n,r),i=function(e,n,r,o){if(e.length>s+2)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var i,a,l=e.length-1;l>=s;l--){var u=e[l];switch(typeof u){case"object":if(i)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);i=u;break;case"function":if(a)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalFunction);a=u;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}if(i=c.fillOptions(i,n,r,o),a){if(i[Microsoft.Office.WebExtension.Parameters.Callback])throw Strings.OfficeOM.L_RedundantCallbackSpecification;i[Microsoft.Office.WebExtension.Parameters.Callback]=a}return c.verifyArguments(t,i),i}(e,o,n,r);return c.constructCallArgs(o,i,n,r)},this.processResponse=function(e,t,n,i){return e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?r?r(t,n,i):t:o?o(e,t):OSF.DDA.ErrorCodeManager.getErrorArgs(e)},this.getCallArgs=function(e){for(var t,n,r=e.length-1;r>=s;r--){var o=e[r];switch(typeof o){case"object":t=o;break;case"function":n=o}}return t=t||{},n&&(t[Microsoft.Office.WebExtension.Parameters.Callback]=n),t}},OSF.DDA.AsyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[],n=e.privateStateCallbacks?OSF.OUtil.createObject(e.privateStateCallbacks):[];return new OSF.DDA.AsyncMethodCall(e.requiredArguments||[],t,n,e.onSucceeded,e.onFailed,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.AsyncMethodCalls={},OSF.DDA.AsyncMethodCalls.define=function(e){OSF.DDA.AsyncMethodCalls[e.method.id]=OSF.DDA.AsyncMethodCallFactory.manufacture(e)},OSF.DDA.Error=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{name:{value:e},message:{value:t},code:{value:n}})},OSF.DDA.AsyncResult=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{value:{value:e[OSF.DDA.AsyncResultEnum.Properties.Value]},status:{value:t?Microsoft.Office.WebExtension.AsyncResultStatus.Failed:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded}}),e[OSF.DDA.AsyncResultEnum.Properties.Context]&&OSF.OUtil.defineEnumerableProperty(this,"asyncContext",{value:e[OSF.DDA.AsyncResultEnum.Properties.Context]}),t&&OSF.OUtil.defineEnumerableProperty(this,"error",{value:new OSF.DDA.Error(t[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])})},OSF.DDA.issueAsyncResult=function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Callback];if(r){var o,i={};i[OSF.DDA.AsyncResultEnum.Properties.Context]=e[Microsoft.Office.WebExtension.Parameters.AsyncContext],t==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?i[OSF.DDA.AsyncResultEnum.Properties.Value]=n:(o={},n=n||OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError),o[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=t||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,o[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=n.name||n,o[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=n.message||n),r(new OSF.DDA.AsyncResult(i,o))}},OSF.DDA.SyncMethodNames={},OSF.DDA.SyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.SyncMethodNames[t]=n}},OSF.DDA.SyncMethodCall=function(e,t,n,r,o){var i=e.length,a=new OSF.DDA.ApiMethodCall(e,t,n,r,o);this.verifyAndExtractCall=function(e,n,r){var o=a.extractRequiredArguments(e,n,r),s=function(e,n,r,o){if(e.length>i+1)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var s,c=e.length-1;c>=i;c--){var l=e[c];switch(typeof l){case"object":if(s)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);s=l;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}return s=a.fillOptions(s,n,r,o),a.verifyArguments(t,s),s}(e,o,n,r);return a.constructCallArgs(o,s,n,r)}},OSF.DDA.SyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[];return new OSF.DDA.SyncMethodCall(e.requiredArguments||[],t,e.privateStateCallbacks,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.SyncMethodCalls={},OSF.DDA.SyncMethodCalls.define=function(e){OSF.DDA.SyncMethodCalls[e.method.id]=OSF.DDA.SyncMethodCallFactory.manufacture(e)},OSF.DDA.ListType=function(){var e={};return{setListType:function(t,n){e[t]=n},isListType:function(t){return OSF.OUtil.listContainsKey(e,t)},getDescriptor:function(t){return e[t]}}}(),OSF.DDA.HostParameterMap=function(e,t){var n={};function r(o,i){var a=o?{}:void 0;for(var s in o){var c,l=o[s];if(OSF.DDA.ListType.isListType(s))for(var u in c=[],l)c.push(r(l[u],i));else if(OSF.OUtil.listContainsKey(n,s))c=n[s][i](l);else if("fromHost"==i&&e.preserveNesting(s))c=r(l,i);else{var d=t[s];if(d){var f=d[i];f&&void 0===(c=f[l])&&(c=l)}else c=l}a[s]=c}return a}function o(n,o,i){var a,s=t[n][i];if("toHost"==i)a=function n(r,o){var i;for(var a in o){var s;if(void 0!=(s=e.isComplexType(a)?n(r,t[a].toHost):r[a])){i||(i={});var c=o[a];"self"==c&&(c=a),i[c]=e.pack(a,s)}}return i}(r(o,i),s);else if("fromHost"==i){a=r(function n(r,o,i){for(var a in i||(i={}),o){var s,c,l=o[a];if("self"==l)s=r;else{if("sourceData"==l){i[a]=r.toArray();continue}s=r[l]}if(null===s||void 0===s)i[a]=void 0;else if(s=e.unpack(a,s),e.isComplexType(a))c=t[a].fromHost,e.preserveNesting(a)?i[a]=n(s,c):n(s,c,i);else if(OSF.DDA.ListType.isListType(a)){(c={})[OSF.DDA.ListType.getDescriptor(a)]="self";var u=new Array(s.length);for(var d in s)u[d]=n(s[d],c);i[a]=u}else i[a]=s}return i}(o,s),i)}return a}n[Microsoft.Office.WebExtension.Parameters.Data]={toHost:function(e){if(null!=e&&void 0!==e.rows){var t={};t[OSF.DDA.TableDataProperties.TableRows]=e.rows,t[OSF.DDA.TableDataProperties.TableHeaders]=e.headers,e=t}return e},fromHost:function(e){return e}},n[Microsoft.Office.WebExtension.Parameters.JsonData]={toHost:function(e){return e},fromHost:function(e){return"string"===typeof e?JSON.parse(e):e}},n[Microsoft.Office.WebExtension.Parameters.SampleData]=n[Microsoft.Office.WebExtension.Parameters.Data],t||(t={}),this.addMapping=function(e,n){var r,o;if(n.map)for(var i in o={},r=n.map){var a=r[i];"self"==a&&(a=i),o[a]=i}else r=n.toHost,o=n.fromHost;var s=t[e];if(s){var c=s.toHost;for(var l in c)r[l]=c[l];for(var u in c=s.fromHost)o[u]=c[u]}else s=t[e]={};s.toHost=r,s.fromHost=o},this.toHost=function(e,t){return o(e,t,"toHost")},this.fromHost=function(e,t){return o(e,t,"fromHost")},this.self="self",this.sourceData="sourceData",this.addComplexType=function(t){e.addComplexType(t)},this.getDynamicType=function(t){return e.getDynamicType(t)},this.setDynamicType=function(t,n){e.setDynamicType(t,n)},this.dynamicTypes=n,this.doMapValues=function(e,t){return r(e,t)}},OSF.DDA.SpecialProcessor=function(e,t){this.addComplexType=function(t){e.push(t)},this.getDynamicType=function(e){return t[e]},this.setDynamicType=function(e,n){t[e]=n},this.isComplexType=function(t){return OSF.OUtil.listContainsValue(e,t)},this.isDynamicType=function(e){return OSF.OUtil.listContainsKey(t,e)},this.preserveNesting=function(e){var t=[];return OSF.DDA.PropertyDescriptors&&t.push(OSF.DDA.PropertyDescriptors.Subset),OSF.DDA.DataNodeEventProperties&&(t=t.concat([OSF.DDA.DataNodeEventProperties.OldNode,OSF.DDA.DataNodeEventProperties.NewNode,OSF.DDA.DataNodeEventProperties.NextSiblingNode])),OSF.OUtil.listContainsValue(t,e)},this.pack=function(e,n){return this.isDynamicType(e)?t[e].toHost(n):n},this.unpack=function(e,n){return this.isDynamicType(e)?t[e].fromHost(n):n}},OSF.DDA.getDecoratedParameterMap=function(e,t){var n=new OSF.DDA.HostParameterMap(e);n.self;function r(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t}for(var o in n.define=function(e){var t={},o=r(e.toHost);e.invertible?t.map=o:e.canonical?t.toHost=t.fromHost=o:(t.toHost=o,t.fromHost=r(e.fromHost)),n.addMapping(e.type,t),e.isComplexType&&n.addComplexType(e.type)},t)n.define(t[o]);return n},OSF.OUtil.setNamespace("DispIdHost",OSF.DDA),OSF.DDA.DispIdHost.Methods={InvokeMethod:"invokeMethod",AddEventHandler:"addEventHandler",RemoveEventHandler:"removeEventHandler",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Delegates={ExecuteAsync:"executeAsync",RegisterEventAsync:"registerEventAsync",UnregisterEventAsync:"unregisterEventAsync",ParameterMap:"parameterMap",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Facade=function(e,t){var n={},r=OSF.DDA.AsyncMethodNames,o=OSF.DDA.MethodDispId,i={GoToByIdAsync:o.dispidNavigateToMethod,GetSelectedDataAsync:o.dispidGetSelectedDataMethod,SetSelectedDataAsync:o.dispidSetSelectedDataMethod,GetDocumentCopyChunkAsync:o.dispidGetDocumentCopyChunkMethod,ReleaseDocumentCopyAsync:o.dispidReleaseDocumentCopyMethod,GetDocumentCopyAsync:o.dispidGetDocumentCopyMethod,AddFromSelectionAsync:o.dispidAddBindingFromSelectionMethod,AddFromPromptAsync:o.dispidAddBindingFromPromptMethod,AddFromNamedItemAsync:o.dispidAddBindingFromNamedItemMethod,GetAllAsync:o.dispidGetAllBindingsMethod,GetByIdAsync:o.dispidGetBindingMethod,ReleaseByIdAsync:o.dispidReleaseBindingMethod,GetDataAsync:o.dispidGetBindingDataMethod,SetDataAsync:o.dispidSetBindingDataMethod,AddRowsAsync:o.dispidAddRowsMethod,AddColumnsAsync:o.dispidAddColumnsMethod,DeleteAllDataValuesAsync:o.dispidClearAllRowsMethod,RefreshAsync:o.dispidLoadSettingsMethod,SaveAsync:o.dispidSaveSettingsMethod,GetActiveViewAsync:o.dispidGetActiveViewMethod,GetFilePropertiesAsync:o.dispidGetFilePropertiesMethod,GetOfficeThemeAsync:o.dispidGetOfficeThemeMethod,GetDocumentThemeAsync:o.dispidGetDocumentThemeMethod,ClearFormatsAsync:o.dispidClearFormatsMethod,SetTableOptionsAsync:o.dispidSetTableOptionsMethod,SetFormatsAsync:o.dispidSetFormatsMethod,GetAccessTokenAsync:o.dispidGetAccessTokenMethod,GetAuthContextAsync:o.dispidGetAuthContextMethod,GetNestedAppAuthContextAsync:o.dispidGetNestedAppAuthContextMethod,ExecuteRichApiRequestAsync:o.dispidExecuteRichApiRequestMethod,AppCommandInvocationCompletedAsync:o.dispidAppCommandInvocationCompletedMethod,CloseContainerAsync:o.dispidCloseContainerMethod,OpenBrowserWindow:o.dispidOpenBrowserWindow,CreateDocumentAsync:o.dispidCreateDocumentMethod,InsertFormAsync:o.dispidInsertFormMethod,ExecuteFeature:o.dispidExecuteFeature,QueryFeature:o.dispidQueryFeature,AddDataPartAsync:o.dispidAddDataPartMethod,GetDataPartByIdAsync:o.dispidGetDataPartByIdMethod,GetDataPartsByNameSpaceAsync:o.dispidGetDataPartsByNamespaceMethod,GetPartXmlAsync:o.dispidGetDataPartXmlMethod,GetPartNodesAsync:o.dispidGetDataPartNodesMethod,DeleteDataPartAsync:o.dispidDeleteDataPartMethod,GetNodeValueAsync:o.dispidGetDataNodeValueMethod,GetNodeXmlAsync:o.dispidGetDataNodeXmlMethod,GetRelativeNodesAsync:o.dispidGetDataNodesMethod,SetNodeValueAsync:o.dispidSetDataNodeValueMethod,SetNodeXmlAsync:o.dispidSetDataNodeXmlMethod,AddDataPartNamespaceAsync:o.dispidAddDataNamespaceMethod,GetDataPartNamespaceAsync:o.dispidGetDataUriByPrefixMethod,GetDataPartPrefixAsync:o.dispidGetDataPrefixByUriMethod,GetNodeTextAsync:o.dispidGetDataNodeTextMethod,SetNodeTextAsync:o.dispidSetDataNodeTextMethod,GetSelectedTask:o.dispidGetSelectedTaskMethod,GetTask:o.dispidGetTaskMethod,GetWSSUrl:o.dispidGetWSSUrlMethod,GetTaskField:o.dispidGetTaskFieldMethod,GetSelectedResource:o.dispidGetSelectedResourceMethod,GetResourceField:o.dispidGetResourceFieldMethod,GetProjectField:o.dispidGetProjectFieldMethod,GetSelectedView:o.dispidGetSelectedViewMethod,GetTaskByIndex:o.dispidGetTaskByIndexMethod,GetResourceByIndex:o.dispidGetResourceByIndexMethod,SetTaskField:o.dispidSetTaskFieldMethod,SetResourceField:o.dispidSetResourceFieldMethod,GetMaxTaskIndex:o.dispidGetMaxTaskIndexMethod,GetMaxResourceIndex:o.dispidGetMaxResourceIndexMethod,CreateTask:o.dispidCreateTaskMethod};for(var a in i)r[a]&&(n[r[a].id]=i[a]);r=OSF.DDA.SyncMethodNames;var s={MessageParent:(o=OSF.DDA.MethodDispId).dispidMessageParentMethod,SendMessage:o.dispidSendMessageMethod};for(var a in s)r[a]&&(n[r[a].id]=s[a]);r=Microsoft.Office.WebExtension.EventType;var c={SettingsChanged:(o=OSF.DDA.EventDispId).dispidSettingsChangedEvent,DocumentSelectionChanged:o.dispidDocumentSelectionChangedEvent,BindingSelectionChanged:o.dispidBindingSelectionChangedEvent,BindingDataChanged:o.dispidBindingDataChangedEvent,ActiveViewChanged:o.dispidActiveViewChangedEvent,OfficeThemeChanged:o.dispidOfficeThemeChangedEvent,DocumentThemeChanged:o.dispidDocumentThemeChangedEvent,AppCommandInvoked:o.dispidAppCommandInvokedEvent,DialogMessageReceived:o.dispidDialogMessageReceivedEvent,DialogParentMessageReceived:o.dispidDialogParentMessageReceivedEvent,ObjectDeleted:o.dispidObjectDeletedEvent,ObjectSelectionChanged:o.dispidObjectSelectionChangedEvent,ObjectDataChanged:o.dispidObjectDataChangedEvent,ContentControlAdded:o.dispidContentControlAddedEvent,Suspend:o.dispidSuspend,Resume:o.dispidResume,RichApiMessage:o.dispidRichApiMessageEvent,ItemChanged:o.dispidOlkItemSelectedChangedEvent,RecipientsChanged:o.dispidOlkRecipientsChangedEvent,AppointmentTimeChanged:o.dispidOlkAppointmentTimeChangedEvent,RecurrenceChanged:o.dispidOlkRecurrenceChangedEvent,AttachmentsChanged:o.dispidOlkAttachmentsChangedEvent,EnhancedLocationsChanged:o.dispidOlkEnhancedLocationsChangedEvent,InfobarClicked:o.dispidOlkInfobarClickedEvent,SelectedItemsChanged:o.dispidOlkSelectedItemsChangedEvent,SensitivityLabelChanged:o.dispidOlkSensitivityLabelChangedEvent,TaskSelectionChanged:o.dispidTaskSelectionChangedEvent,ResourceSelectionChanged:o.dispidResourceSelectionChangedEvent,ViewSelectionChanged:o.dispidViewSelectionChangedEvent,DataNodeInserted:o.dispidDataNodeAddedEvent,DataNodeReplaced:o.dispidDataNodeReplacedEvent,DataNodeDeleted:o.dispidDataNodeDeletedEvent};for(var l in c)r[l]&&(n[r[l]]=c[l]);function u(e){return e==OSF.DDA.EventDispId.dispidObjectDeletedEvent||e==OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent||e==OSF.DDA.EventDispId.dispidObjectDataChangedEvent||e==OSF.DDA.EventDispId.dispidContentControlAddedEvent}function d(e,t,n,r){if("number"!=typeof e)throw e;r||(r=t.getCallArgs(n)),OSF.DDA.issueAsyncResult(r,e,OSF.DDA.ErrorCodeManager.getErrorArgs(e))}this[OSF.DDA.DispIdHost.Methods.InvokeMethod]=function(r,o,i,a){var s;try{var c=r.id,l=OSF.DDA.AsyncMethodCalls[c];s=l.verifyAndExtractCall(o,i,a);var u=n[c],f=e(c),p=null;if(window.Excel&&window.Office.context.requirements.isSetSupported("RedirectV1Api")&&(window.Excel._RedirectV1APIs=!0),window.Excel&&window.Excel._RedirectV1APIs&&(p=window.Excel._V1APIMap[c])){var h=OSF.OUtil.shallowCopy(s);delete h[Microsoft.Office.WebExtension.Parameters.AsyncContext],p.preprocess&&(h=p.preprocess(h));var m=new window.Excel.RequestContext,g=p.call(m,h);m.sync().then((function(){var e=g.value,t=e.status;delete e.status,delete e["@odata.type"],p.postprocess&&(e=p.postprocess(e,h)),0!=t&&(e=OSF.DDA.ErrorCodeManager.getErrorArgs(t)),OSF.DDA.issueAsyncResult(s,t,e)})).catch((function(e){OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeFailure,null)}))}else{var y;y=t.toHost?t.toHost(u,s):s;var v=(new Date).getTime();f[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]({dispId:u,hostCallArgs:y,onCalling:function(){},onReceiving:function(){},onComplete:function(e,n){var r;r=e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&t.fromHost?t.fromHost(u,n):n;var o=l.processResponse(e,r,i,s);OSF.DDA.issueAsyncResult(s,e,o),!OSF.AppTelemetry||OSF.ConstantNames&&OSF.ConstantNames.IsCustomFunctionsRuntime||OSF.AppTelemetry.onMethodDone(u,y,Math.abs((new Date).getTime()-v),e)}})}}catch(e){d(e,l,o,s)}},this[OSF.DDA.DispIdHost.Methods.AddEventHandler]=function(r,o,i,a){var s,c,l,f=!1;function p(e){var t;e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&((f?o.addObjectEventHandler(c,s[Microsoft.Office.WebExtension.Parameters.Id],l):o.addEventHandler(c,l))||(e=OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerAdditionFailed));e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(s,e,t)}try{var h=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.AddHandlerAsync.id];if(s=h.verifyAndExtractCall(r,i,o),c=s[Microsoft.Office.WebExtension.Parameters.EventType],l=s[Microsoft.Office.WebExtension.Parameters.Handler],a)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);var m=n[c],g=(f=u(m))?s[Microsoft.Office.WebExtension.Parameters.Id]:i.id||"";if(0==(f?o.getObjectEventHandlerCount(c,g):o.getEventHandlerCount(c)))(0,e(c)[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync])({eventType:c,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:p,onEvent:function(e){var n=null,r=OSF._OfficeAppFactory.getHostInfo();n=r&&"web"==r.hostPlatform.toLowerCase()&&m==OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent?e:t.fromHost(m,e),f?o.fireObjectEvent(g,OSF.DDA.OMFactory.manufactureEventArgs(c,g,n)):o.fireEvent(OSF.DDA.OMFactory.manufactureEventArgs(c,i,n))}});else p(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)}catch(e){d(e,h,r,s)}},this[OSF.DDA.DispIdHost.Methods.RemoveEventHandler]=function(t,r,o){var i,a,s,c=!1;function l(e){var t;e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(i,e,t)}try{var f=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.id];a=(i=f.verifyAndExtractCall(t,o,r))[Microsoft.Office.WebExtension.Parameters.EventType],s=i[Microsoft.Office.WebExtension.Parameters.Handler];var p,h,m=n[a],g=(c=u(m))?i[Microsoft.Office.WebExtension.Parameters.Id]:o.id||"";null===s?(h=c?r.clearObjectEventHandlers(a,g):r.clearEventHandlers(a),p=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):p=(h=c?r.removeObjectEventHandler(a,g,s):r.removeEventHandler(a,s))?OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess:OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist;var y=c?r.getObjectEventHandlerCount(a,g):r.getEventHandlerCount(a);if(h&&0==y)(0,e(a)[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:a,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:l});else l(p)}catch(e){d(e,f,t,i)}},this[OSF.DDA.DispIdHost.Methods.OpenDialog]=function(r,o,i,a){var s,c,l=null,u=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,f=Microsoft.Office.WebExtension.EventType.DialogEventReceived;function p(e){if(e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)n=OSF.DDA.ErrorCodeManager.getErrorArgs(e);else{var t={};t[Microsoft.Office.WebExtension.Parameters.Id]=c,t[Microsoft.Office.WebExtension.Parameters.Data]=o;var n=l.processResponse(e,t,i,s);OSF.DialogShownStatus.hasDialogShown=!0,o.clearEventHandlers(u),o.clearEventHandlers(f)}OSF.DDA.issueAsyncResult(s,e,n)}try{if(void 0!=u&&void 0!=f||p(OSF.DDA.ErrorCodeManager.ooeOperationNotSupported),a){if(null==OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);l=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.id]}else{if(null==OSF.DDA.AsyncMethodNames.DisplayDialogAsync)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);l=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayDialogAsync.id]}s=l.verifyAndExtractCall(r,i,o);var h=n[u],m=e(u),g=void 0!=m[OSF.DDA.DispIdHost.Delegates.OpenDialog]?m[OSF.DDA.DispIdHost.Delegates.OpenDialog]:m[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync];s.isModal=a,c=JSON.stringify(s),OSF.DialogShownStatus.hasDialogShown||(o.clearQueuedEvent(u),o.clearQueuedEvent(f),o.clearQueuedEvent(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived)),g({eventType:u,dispId:h,targetId:c,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:p,onEvent:function(e){var n=t.fromHost(h,e),r=OSF.DDA.OMFactory.manufactureEventArgs(u,i,n);if(r.type==f){var a=OSF.DDA.ErrorCodeManager.getErrorArgs(r.error),s={};s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=status||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=a.name||a,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=a.message||a,r.error=new OSF.DDA.Error(s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])}o.fireOrQueueEvent(r),n[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogClosed&&(o.clearEventHandlers(u),o.clearEventHandlers(f),o.clearEventHandlers(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived),OSF.DialogShownStatus.hasDialogShown=!1)}})}catch(e){d(e,l,r,s)}},this[OSF.DDA.DispIdHost.Methods.CloseDialog]=function(t,r,o,i){var a,s,c,l=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess;try{var u=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.CloseAsync.id];a=u.verifyAndExtractCall(t,i,o),s=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,c=Microsoft.Office.WebExtension.EventType.DialogEventReceived,o.clearEventHandlers(s),o.clearEventHandlers(c);var f=n[s],p=e(s);(void 0!=p[OSF.DDA.DispIdHost.Delegates.CloseDialog]?p[OSF.DDA.DispIdHost.Delegates.CloseDialog]:p[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:s,dispId:f,targetId:r,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:function(e){l=e,OSF.DialogShownStatus.hasDialogShown=!1}})}catch(e){d(e,u,t,a)}if(l!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)throw OSF.OUtil.formatString(Strings.OfficeOM.L_FunctionCallFailed,OSF.DDA.AsyncMethodNames.CloseAsync.displayName,l)},this[OSF.DDA.DispIdHost.Methods.MessageParent]=function(t,r){var o=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.MessageParent.id].verifyAndExtractCall(t,r,{});return(0,e(OSF.DDA.SyncMethodNames.MessageParent.id)[OSF.DDA.DispIdHost.Delegates.MessageParent])({dispId:n[OSF.DDA.SyncMethodNames.MessageParent.id],hostCallArgs:o,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})},this[OSF.DDA.DispIdHost.Methods.SendMessage]=function(t,r,o){var i=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.SendMessage.id].verifyAndExtractCall(t,o,{});return(0,e(OSF.DDA.SyncMethodNames.SendMessage.id)[OSF.DDA.DispIdHost.Delegates.SendMessage])({dispId:n[OSF.DDA.SyncMethodNames.SendMessage.id],hostCallArgs:i,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})}},OSF.DDA.DispIdHost.addAsyncMethods=function(e,t,n){for(var r in t){var o=t[r],i=o.displayName;e[i]||OSF.OUtil.defineEnumerableProperty(e,i,{value:function(t){return function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.InvokeMethod];r(t,arguments,e,n)}}(o)})}},OSF.DDA.DispIdHost.addEventSupport=function(e,t,n){var r=OSF.DDA.AsyncMethodNames.AddHandlerAsync.displayName,o=OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.displayName;e[r]||OSF.OUtil.defineEnumerableProperty(e,r,{value:function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.AddEventHandler];r(arguments,t,e,n)}}),e[o]||OSF.OUtil.defineEnumerableProperty(e,o,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.RemoveEventHandler];n(arguments,t,e)}})},function(e){var t=function(){function e(){}return e.isInstanceOfType=function(e,t){if("undefined"===typeof t||null===t)return!1;if(t instanceof e)return!0;var n=t.constructor;return n&&"function"===typeof n&&n.__typeName&&"Object"!==n.__typeName||(n=Object),!(n!==e)||n.__typeName&&e.__typeName&&n.__typeName===e.__typeName},e}();e.MsAjaxTypeHelper=t;var n=function(){function e(){}return e.create=function(e,t){var n=new Error(e);if(n.message=e,t)for(var r in t)n[r]=t[r];return n.popStackFrame(),n},e.parameterCount=function(t){var n="Sys.ParameterCountException: "+(t||"Parameter count mismatch."),r=e.create(n,{name:"Sys.ParameterCountException"});return r.popStackFrame(),r},e.argument=function(t,n){var o="Sys.ArgumentException: "+(n||"Value does not fall within the expected range.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentException",paramName:t});return i.popStackFrame(),i},e.argumentNull=function(t,n){var o="Sys.ArgumentNullException: "+(n||"Value cannot be null.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentNullException",paramName:t});return i.popStackFrame(),i},e.argumentOutOfRange=function(t,n,o){var i="Sys.ArgumentOutOfRangeException: "+(o||"Specified argument was out of the range of valid values.");t&&(i+="\n"+r.format("Parameter name: {0}",t)),"undefined"!==typeof n&&null!==n&&(i+="\n"+r.format("Actual value was {0}.",n));var a=e.create(i,{name:"Sys.ArgumentOutOfRangeException",paramName:t,actualValue:n});return a.popStackFrame(),a},e.argumentType=function(t,n,o,i){var a="Sys.ArgumentTypeException: ";a+=i||(n&&o?r.format("Object of type '{0}' cannot be converted to type '{1}'.",n.getName?n.getName():n,o.getName?o.getName():o):"Object cannot be converted to the required type."),t&&(a+="\n"+r.format("Parameter name: {0}",t));var s=e.create(a,{name:"Sys.ArgumentTypeException",paramName:t,actualType:n,expectedType:o});return s.popStackFrame(),s},e.argumentUndefined=function(t,n){var o="Sys.ArgumentUndefinedException: "+(n||"Value cannot be undefined.");t&&(o+="\n"+r.format("Parameter name: {0}",t));var i=e.create(o,{name:"Sys.ArgumentUndefinedException",paramName:t});return i.popStackFrame(),i},e.invalidOperation=function(t){var n="Sys.InvalidOperationException: "+(t||"Operation is not valid due to the current state of the object."),r=e.create(n,{name:"Sys.InvalidOperationException"});return r.popStackFrame(),r},e}();e.MsAjaxError=n;var r=function(){function e(){}return e.format=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=e;return r.replace(/{(\d+)}/gm,(function(e,n){var r=parseInt(n,10);return void 0===t[r]?"{"+n+"}":t[r]}))},e.startsWith=function(e,t){return e.substr(0,t.length)===t},e}();e.MsAjaxString=r;var o=function(){function e(){}return e.trace=function(e){"undefined"!==typeof Debug&&Debug.writeln&&Debug.writeln(e),window.console&&window.console.log&&window.console.log(e),window.opera&&window.opera.postError&&window.opera.postError(e),window.debugService&&window.debugService.trace&&window.debugService.trace(e);var t=document.getElementById("TraceConsole");t&&"TEXTAREA"===t.tagName.toUpperCase()&&t.appendChild(document.createTextNode(e+"\n"))},e}();if(e.MsAjaxDebug=o,!OsfMsAjaxFactory.isMsAjaxLoaded()){var i=function(e,t,n){void 0!==e.__typeName&&null!==e.__typeName||(e.__typeName=t),void 0!==e.__class&&null!==e.__class||(e.__class=n)};i(Function,"Function",!0),i(Error,"Error",!0),i(Object,"Object",!0),i(String,"String",!0),i(Boolean,"Boolean",!0),i(Date,"Date",!0),i(Number,"Number",!0),i(RegExp,"RegExp",!0),i(Array,"Array",!0),Function.createCallback||(Function.createCallback=function(e,t){var n=Function._validateParams(arguments,[{name:"method",type:Function},{name:"context",mayBeNull:!0}]);if(n)throw n;return function(){var n=arguments.length;if(n>0){for(var r=[],o=0;o<n;o++)r[o]=arguments[o];return r[n]=t,e.apply(this,r)}return e.call(this,t)}}),Function.createDelegate||(Function.createDelegate=function(e,t){var n=Function._validateParams(arguments,[{name:"instance",mayBeNull:!0},{name:"method",type:Function}]);if(n)throw n;return function(){return t.apply(e,arguments)}}),Function._validateParams||(Function._validateParams=function(e,t,n){var r,o=t.length;if(n=n||"undefined"===typeof n,r=Function._validateParameterCount(e,t,n))return r.popStackFrame(),r;for(var i=0,a=e.length;i<a;i++){var s=t[Math.min(i,o-1)],c=s.name;if(s.parameterArray)c+="["+(i-o+1)+"]";else if(!n&&i>=o)break;if(r=Function._validateParameter(e[i],s,c))return r.popStackFrame(),r}return null}),Function._validateParameterCount||(Function._validateParameterCount=function(e,t,r){var o,i,a=t.length,s=e.length;if(s<a){var c=a;for(o=0;o<a;o++){var l=t[o];(l.optional||l.parameterArray)&&c--}s<c&&(i=!0)}else if(r&&s>a)for(i=!0,o=0;o<a;o++)if(t[o].parameterArray){i=!1;break}if(i){var u=n.parameterCount();return u.popStackFrame(),u}return null}),Function._validateParameter||(Function._validateParameter=function(e,t,n){var r,o=t.type,i=!!t.integer,a=!!t.domElement,s=!!t.mayBeNull;if(r=Function._validateParameterType(e,o,i,a,s,n))return r.popStackFrame(),r;var c=t.elementType,l=!!t.elementMayBeNull;if(o===Array&&"undefined"!==typeof e&&null!==e&&(c||!l))for(var u=!!t.elementInteger,d=!!t.elementDomElement,f=0;f<e.length;f++){var p=e[f];if(r=Function._validateParameterType(p,c,u,d,l,n+"["+f+"]"))return r.popStackFrame(),r}return null}),Function._validateParameterType||(Function._validateParameterType=function(t,n,r,o,i,a){var s;return"undefined"===typeof t?i?null:((s=e.MsAjaxError.argumentUndefined(a)).popStackFrame(),s):null===t?i?null:((s=e.MsAjaxError.argumentNull(a)).popStackFrame(),s):n&&!e.MsAjaxTypeHelper.isInstanceOfType(n,t)?((s=e.MsAjaxError.argumentType(a,typeof t,n)).popStackFrame(),s):null}),window.Type||(window.Type=Function),Type.registerNamespace||(Type.registerNamespace=function(e){for(var t=e.split("."),n=window,r=0;r<t.length;r++)n[t[r]]=n[t[r]]||{},n=n[t[r]]}),Type.prototype.registerClass||(Type.prototype.registerClass=function(e){({})}),"undefined"===typeof Sys&&Type.registerNamespace("Sys"),Error.prototype.popStackFrame||(Error.prototype.popStackFrame=function(){if(0!==arguments.length)throw n.parameterCount();if("undefined"!==typeof this.stack&&null!==this.stack&&"undefined"!==typeof this.fileName&&null!==this.fileName&&"undefined"!==typeof this.lineNumber&&null!==this.lineNumber){for(var e=this.stack.split("\n"),t=e[0],r=this.fileName+":"+this.lineNumber;"undefined"!==typeof t&&null!==t&&-1===t.indexOf(r);)e.shift(),t=e[0];var o=e[1];if("undefined"!==typeof o&&null!==o){var i=o.match(/@(.*):(\d+)$/);"undefined"!==typeof i&&null!==i&&(this.fileName=i[1],this.lineNumber=parseInt(i[2]),e.shift(),this.stack=e.join("\n"))}}}),OsfMsAjaxFactory.msAjaxError=n,OsfMsAjaxFactory.msAjaxString=r,OsfMsAjaxFactory.msAjaxDebug=o}}(OfficeExt||(OfficeExt={})),OSF.OUtil.setNamespace("SafeArray",OSF.DDA),OSF.DDA.SafeArray.Response={Status:0,Payload:1},OSF.DDA.SafeArray.UniqueArguments={Offset:"offset",Run:"run",BindingSpecificData:"bindingSpecificData",MergedCellGuid:"{66e7831f-81b2-42e2-823c-89e872d541b3}"},OSF.OUtil.setNamespace("Delegate",OSF.DDA.SafeArray),OSF.DDA.SafeArray.Delegate._onException=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2147467259:n=t.dispId==OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent?OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened:OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;break;case-2146828283:case-2147209089:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidParam;break;case-2147208704:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}t.onComplete&&t.onComplete(n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)},OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}return n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError},OSF.DDA.SafeArray.Delegate.SpecialProcessor=function(){function e(e){var t;try{var n=e.ubound(1),r=e.ubound(2);if(e=e.toArray(),1==n&&1==r)t=[e];else{t=[];for(var o=0;o<n;o++){for(var i=[],a=0;a<r;a++){var s=e[o*r+a];s!=OSF.DDA.SafeArray.UniqueArguments.MergedCellGuid&&i.push(s)}i.length>0&&t.push(i)}}}catch(e){}return t}var t={};t[Microsoft.Office.WebExtension.Parameters.Data]=function(){return{toHost:function(e){if(OSF.DDA.TableDataProperties&&"string"!=typeof e&&void 0!==e[OSF.DDA.TableDataProperties.TableRows]){var t=[];t[0]=e[OSF.DDA.TableDataProperties.TableRows],t[1]=e[OSF.DDA.TableDataProperties.TableHeaders],e=t}return e},fromHost:function(t){var n;if(t.toArray)if(2===t.dimensions())n=e(t);else{var r=t.toArray();2===r.length&&(null!=r[0]&&r[0].toArray||null!=r[1]&&r[1].toArray)?((n={})[OSF.DDA.TableDataProperties.TableRows]=e(r[0]),n[OSF.DDA.TableDataProperties.TableHeaders]=e(r[1])):n=r}else n=t;return n}}}(),OSF.DDA.SafeArray.Delegate.SpecialProcessor.uber.constructor.call(this,[],t),this.unpack=function(e,n){var r;this.isComplexType(e)||OSF.DDA.ListType.isListType(e)?r=void 0!==n&&void 0!==n.toArray?n.toArray():n||{}:r=this.isDynamicType(e)?t[e].fromHost(n):n;return r}},OSF.OUtil.extend(OSF.DDA.SafeArray.Delegate.SpecialProcessor,OSF.DDA.SpecialProcessor),OSF.DDA.SafeArray.Delegate.ParameterMap=OSF.DDA.getDecoratedParameterMap(new OSF.DDA.SafeArray.Delegate.SpecialProcessor,[{type:Microsoft.Office.WebExtension.Parameters.ValueFormat,toHost:[{name:Microsoft.Office.WebExtension.ValueFormat.Unformatted,value:0},{name:Microsoft.Office.WebExtension.ValueFormat.Formatted,value:1}]},{type:Microsoft.Office.WebExtension.Parameters.FilterType,toHost:[{name:Microsoft.Office.WebExtension.FilterType.All,value:0}]}]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.AsyncResultStatus,fromHost:[{name:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded,value:0},{name:Microsoft.Office.WebExtension.AsyncResultStatus.Failed,value:1}]}),OSF.DDA.SafeArray.Delegate.executeAsync=function(e){function t(e){var n=e;if(null!=e&&e.toArray){var r=e.toArray();n=new Array(r.length);for(var o=0;o<r.length;o++)n[o]=t(r[o])}return n}try{e.onCalling&&e.onCalling(),OSF.ClientHostController.execute(e.dispId,function e(t){var n=t;if(OSF.OUtil.isArray(t))for(var r=n.length,o=0;o<r;o++)n[o]=e(n[o]);else if(OSF.OUtil.isDate(t))n=t.getVarDate();else if("object"===typeof t&&!OSF.OUtil.isArray(t))for(var i in n=[],t)OSF.OUtil.isFunction(t[i])||(n[i]=e(t[i]));return n}(e.hostCallArgs),(function(n,r){var o,i;if("number"===typeof n?(o=[],i=n):i=(o=n.toArray())[OSF.DDA.SafeArray.Response.Status],i==OSF.DDA.ErrorCodeManager.errorCodes.ooeChunkResult)return null!=(a=t(a=o[OSF.DDA.SafeArray.Response.Payload]))&&(e._chunkResultData||(e._chunkResultData=new Array),e._chunkResultData[a[0]]=a[1]),!1;if(e.onReceiving&&e.onReceiving(),e.onComplete){var a;if(i==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){if(o.length>2){a=[];for(var s=1;s<o.length;s++)a[s-1]=o[s]}else a=o[OSF.DDA.SafeArray.Response.Payload];if(e._chunkResultData&&null!=(a=t(a))){var c=a[a.length-1];e._chunkResultData.length==c?a[a.length-1]=e._chunkResultData:i=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}}else a=o[OSF.DDA.SafeArray.Response.Payload];e.onComplete(i,a)}return!0}))}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent=function(e,t){var n=(new Date).getTime();return function(r){t.onReceiving&&t.onReceiving();var o=r.toArray?r.toArray()[OSF.DDA.SafeArray.Response.Status]:r;t.onComplete&&t.onComplete(o),OSF.AppTelemetry&&OSF.AppTelemetry.onRegisterDone(e,t.dispId,Math.abs((new Date).getTime()-n),o)}},OSF.DDA.SafeArray.Delegate.registerEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);try{OSF.ClientHostController.registerEvent(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.unregisterEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.unregisterEvent(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.ClientMode={ReadWrite:0,ReadOnly:1},OSF.DDA.RichInitializationReason={1:Microsoft.Office.WebExtension.InitializationReason.Inserted,2:Microsoft.Office.WebExtension.InitializationReason.DocumentOpened},OSF.InitializationHelper=function(e,t,n,r,o){this._hostInfo=e,this._webAppState=t,this._context=n,this._settings=r,this._hostFacade=o,this._initializeSettings=this.initializeSettings},OSF.InitializationHelper.prototype.deserializeSettings=function(e,t){var n=OSF.OUtil.getSessionStorage();if(n){var r=n.getItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey());r?e=JSON.parse(r):(r=JSON.stringify(e),n.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r))}var o=OSF.DDA.SettingsManager.deserializeSettings(e);return t?new OSF.DDA.RefreshableSettings(o):new OSF.DDA.Settings(o)},OSF.InitializationHelper.prototype.saveAndSetDialogInfo=function(e){},OSF.InitializationHelper.prototype.setAgaveHostCommunication=function(){},OSF.InitializationHelper.prototype.prepareRightBeforeWebExtensionInitialize=function(e){this.prepareApiSurface(e),Microsoft.Office.WebExtension.initialize(this.getInitializationReason(e))},OSF.InitializationHelper.prototype.prepareApiSurface=function(e){var t,n,r=new OSF.DDA.License(e.get_eToken()),o=OSF.DDA.OfficeTheme&&OSF.DDA.OfficeTheme.getOfficeTheme?OSF.DDA.OfficeTheme.getOfficeTheme:null;if(e.get_isDialog()?OSF.DDA.UI.ChildUI&&(e.ui=new OSF.DDA.UI.ChildUI):OSF.DDA.UI.ParentUI&&(e.ui=new OSF.DDA.UI.ParentUI,OfficeExt.Container&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.CloseContainerAsync])),OSF.DDA.OpenBrowser&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.OpenBrowserWindow]),OSF.DDA.ExecuteFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.ExecuteFeature]),OSF.DDA.QueryFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.QueryFeature]),OSF.DDA.Auth){e.auth=new OSF.DDA.Auth;var i=[],a=OSF.DDA.AsyncMethodNames.GetAccessTokenAsync;a&&i.push(a);var s=OSF.DDA.AsyncMethodNames.GetNestedAppAuthContextAsync;s&&i.push(s),OSF.DDA.DispIdHost.addAsyncMethods(e.auth,i)}OSF._OfficeAppFactory.setContext(new OSF.DDA.Context(e,e.doc,r,null,o)),t=OSF.DDA.DispIdHost.getClientDelegateMethods,n=OSF.DDA.SafeArray.Delegate.ParameterMap,OSF._OfficeAppFactory.setHostFacade(new OSF.DDA.DispIdHost.Facade(t,n))},OSF.InitializationHelper.prototype.getInitializationReason=function(e){return OSF.DDA.RichInitializationReason[e.get_reason()]},OSF.DDA.DispIdHost.getClientDelegateMethods=function(e){var t={};if(t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.SafeArray.Delegate.executeAsync,t[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync]=OSF.DDA.SafeArray.Delegate.registerEventAsync,t[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync]=OSF.DDA.SafeArray.Delegate.unregisterEventAsync,t[OSF.DDA.DispIdHost.Delegates.OpenDialog]=OSF.DDA.SafeArray.Delegate.openDialog,t[OSF.DDA.DispIdHost.Delegates.CloseDialog]=OSF.DDA.SafeArray.Delegate.closeDialog,t[OSF.DDA.DispIdHost.Delegates.MessageParent]=OSF.DDA.SafeArray.Delegate.messageParent,t[OSF.DDA.DispIdHost.Delegates.SendMessage]=OSF.DDA.SafeArray.Delegate.sendMessage,OSF.DDA.AsyncMethodNames.RefreshAsync&&e==OSF.DDA.AsyncMethodNames.RefreshAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return"function"===typeof OSF.DDA.ClientSettingsManager.refresh?OSF.DDA.ClientSettingsManager.refresh(t,n):OSF.DDA.ClientSettingsManager.read(t,n)}))}if(OSF.DDA.AsyncMethodNames.SaveAsync&&e==OSF.DDA.AsyncMethodNames.SaveAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return OSF.DDA.ClientSettingsManager.write(e[OSF.DDA.SettingsManager.SerializedSettings],e[Microsoft.Office.WebExtension.Parameters.OverwriteIfStale],t,n)}))}return t},function(e){var t=function(){function e(){}return e.prototype.execute=function(e,t,n){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.Execute(e,t,n,OsfOMToken):window.external.Execute(e,t,n)},e.prototype.registerEvent=function(e,t,n,r){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.RegisterEvent(e,t,n,r,OsfOMToken):window.external.RegisterEvent(e,t,n,r)},e.prototype.unregisterEvent=function(e,t,n){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.UnregisterEvent(e,t,n,OsfOMToken):window.external.UnregisterEvent(e,t,n)},e.prototype.closeSdxDialog=function(e){OSF.OUtil.externalNativeFunctionExists(typeof window.external.closeSdxDialog)&&window.external.closeSdxDialog(e)},e.prototype.resizeSdxDialog=function(e,t){OSF.OUtil.externalNativeFunctionExists(typeof window.external.resizeSdxDialog)&&window.external.resizeSdxDialog(e,t)},e}();e.RichClientHostController=t}(OfficeExt||(OfficeExt={})),function(e){var t=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.messageParent=function(e){if(OSF.OUtil.externalNativeFunctionExists(typeof window.external.MessageParent2)){if(e){var t=e[Microsoft.Office.WebExtension.Parameters.MessageToParent];"boolean"===typeof t&&(!0===t?e[Microsoft.Office.WebExtension.Parameters.MessageToParent]="true":!1===t&&(e[Microsoft.Office.WebExtension.Parameters.MessageToParent]=""))}"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.MessageParent2(JSON.stringify(e),OsfOMToken):window.external.MessageParent2(JSON.stringify(e))}else{var n=e[Microsoft.Office.WebExtension.Parameters.MessageToParent];window.external.MessageParent(n)}},t.prototype.openDialog=function(e,t,n,r){this.registerEvent(e,t,n,r)},t.prototype.closeDialog=function(e,t,n){this.unregisterEvent(e,t,n)},t.prototype.sendMessage=function(e){if(OSF.OUtil.externalNativeFunctionExists(typeof window.external.MessageChild2))"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.MessageChild2(JSON.stringify(e),OsfOMToken):window.external.MessageChild2(JSON.stringify(e));else{var t=e[Microsoft.Office.WebExtension.Parameters.MessageContent];window.external.MessageChild(t)}},t}(e.RichClientHostController);e.Win32RichClientHostController=t}(OfficeExt||(OfficeExt={})),function(e){!function(t){var n=function(){function e(){this._osfOfficeTheme=null,this._osfOfficeThemeTimeStamp=null}return e.prototype.getOfficeTheme=function(){if(OSF.DDA._OsfControlContext){if(this._osfOfficeTheme&&this._osfOfficeThemeTimeStamp&&(new Date).getTime()-this._osfOfficeThemeTimeStamp<e._osfOfficeThemeCacheValidPeriod)OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",0);else{var t=(new Date).getTime(),n=OSF.DDA._OsfControlContext.GetOfficeThemeInfo(),r=(new Date).getTime();if(OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",Math.abs(r-t)),this._osfOfficeTheme=JSON.parse(n),OSF.DDA.Theming&&"function"===typeof OSF.DDA.Theming.ConvertToOfficeTheme)this._osfOfficeTheme=OSF.DDA.Theming.ConvertToOfficeTheme(this._osfOfficeTheme);else for(var o in this._osfOfficeTheme)this._osfOfficeTheme[o]=OSF.OUtil.convertIntToCssHexColor(this._osfOfficeTheme[o]);this._osfOfficeThemeTimeStamp=r}return this._osfOfficeTheme}},e.instance=function(){return null==e._instance&&(e._instance=new e),e._instance},e._osfOfficeThemeCacheValidPeriod=5e3,e._instance=null,e}();t.OfficeThemeManager=n,OSF.OUtil.setNamespace("OfficeTheme",OSF.DDA),OSF.DDA.OfficeTheme.getOfficeTheme=e.OfficeTheme.OfficeThemeManager.instance().getOfficeTheme}(e.OfficeTheme||(e.OfficeTheme={}))}(OfficeExt||(OfficeExt={})),OSF.initializeRichCommon=function(){OSF.DDA.ClientSettingsManager={getSettingsExecuteMethod:function(e){return function(t){var n;try{n=e(t.hostCallArgs,t.onCalling,(function(e,n){t.onReceiving&&t.onReceiving(),t.onComplete&&t.onComplete(e,n)}))}catch(e){var r=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;n={name:Strings.OfficeOM.L_InternalError,message:e},t.onComplete&&t.onComplete(r,n)}}},read:function(e,t){var n=[],r=[];e&&e(),"undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken).Read(n,r):OSF.DDA._OsfControlContext.GetSettings().Read(n,r);for(var o={},i=0;i<n.length;i++)o[n[i]]=r[i];return t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,o),o},write:function(e,t,n,r){var o,i=[],a=[];for(var s in e)i.push(s),a.push(e[s]);n&&n(),"undefined"!=typeof(o="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings()).WriteAsync?o.WriteAsync(i,a,r):(o.Write(i,a),r&&r(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess))},refresh:function(e,t){var n,r=[],o=[];e&&e(),n="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings();var i=function(){n.Read(r,o);for(var e={},i=0;i<r.length;i++)e[r[i]]=o[i];t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,e)};n.RefreshAsync?n.RefreshAsync((function(){i()})):i()}},OSF.InitializationHelper.prototype.initializeSettings=function(e){var t=OSF.DDA.ClientSettingsManager.read();return this.deserializeSettings(t,e)},OSF.InitializationHelper.prototype.getAppContext=function(e,t){var n,r,o="Warning: Office.js is loaded outside of Office client";try{if(!window.external||!OSF.OUtil.externalNativeFunctionExists(typeof window.external.GetContext))return void OsfMsAjaxFactory.msAjaxDebug.trace(o);r=OSF.DDA._OsfControlContext=window.external.GetContext()}catch(e){return void OsfMsAjaxFactory.msAjaxDebug.trace(o)}var i,a,s,c,l,u,d,f,p,h,m=r.GetAppType(),g=r.GetSolutionRef(),y=r.GetAppVersionMajor(),v=r.GetAppVersionMinor(),O=r.GetAppUILocale(),b=r.GetAppDataLocale(),S=r.GetDocUrl(),C=r.GetAppCapabilities(),_=r.GetActivationMode(),A=r.GetControlIntegrationLevel();try{i=r.GetSolutionToken()}catch(e){}if(OSF.OUtil.externalNativeFunctionExists(typeof r.GetCorrelationId)&&(a=r.GetCorrelationId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetInstanceId)&&(s=r.GetInstanceId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetTouchEnabled)&&(c=r.GetTouchEnabled()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetCommerceAllowed)&&(l=r.GetCommerceAllowed()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetSupportedMatrix)&&(u=r.GetSupportedMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostCustomMessage)&&(d=r.GetHostCustomMessage()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostFullVersion)&&(f=r.GetHostFullVersion()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetDialogRequirementMatrix)&&(p=r.GetDialogRequirementMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetFeaturesForSolution))try{var D=r.GetFeaturesForSolution();D&&(h=JSON.parse(D))}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("Exception while creating the SDX FeatureGates object. Details: "+e)}var E=0;OSF.OUtil.externalNativeFunctionExists(typeof r.GetInitialDisplayMode)&&(E=r.GetInitialDisplayMode()),i=i?i.toString():"",n=new OSF.OfficeAppContext(g,m,y,O,b,S,C,[],_,A,i,a,s,c,l,v,u,d,f,void 0,void 0,void 0,void 0,p,h,void 0,E),OSF.AppTelemetry&&OSF.AppTelemetry.initialize(n),t(n)}},OSF.OUtil.setNamespace("ExtensionLifeCycle",OSF),OSF.ExtensionLifeCycle.close=function(e){OSF.ClientHostController.closeSdxDialog(e)},OSF.ExtensionLifeCycle.resize=function(e,t){OSF.ClientHostController.resizeSdxDialog(e,t)},OSF.OUtil.setNamespace("Messaging",OSF),OSF.Messaging.sendMessage=function(e){var t=JSON.stringify(e);OSF.ClientHostController.execute(OSF.DDA.MethodDispId.dispidSdxSendMessage,[t],null)},OSF.Messaging.registerOnMessageEventHandler=function(e){OSF.ClientHostController.registerEvent(OSF.DDA.EventDispId.dispidOnSdxSendMessageEvent,"",(function(t,n){var r=n.toArray();e(JSON.parse(r[0]))}),null)},OSF.ClientHostController=new OfficeExt.Win32RichClientHostController,OSF.initializeRichCommon(),function(e){var t=function(){function e(e){this._table=e,this._fields={}}return Object.defineProperty(e.prototype,"Fields",{get:function(){return this._fields},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"Table",{get:function(){return this._table},enumerable:!0,configurable:!0}),e.prototype.SerializeFields=function(){},e.prototype.SetSerializedField=function(e,t){"undefined"!==typeof t&&null!==t&&(this._serializedFields[e]=t.toString())},e.prototype.SerializeRow=function(){return this._serializedFields={},this.SetSerializedField("Table",this._table),this.SerializeFields(),JSON.stringify(this._serializedFields)},e}();e.BaseUsageData=t;var n=function(e){function t(){return e.call(this,"AppActivated")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppId",{get:function(){return this.Fields.AppId},set:function(e){this.Fields.AppId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppInstanceId",{get:function(){return this.Fields.AppInstanceId},set:function(e){this.Fields.AppInstanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppURL",{get:function(){return this.Fields.AppURL},set:function(e){this.Fields.AppURL=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AssetId",{get:function(){return this.Fields.AssetId},set:function(e){this.Fields.AssetId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Browser",{get:function(){return this.Fields.Browser},set:function(e){this.Fields.Browser=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"UserId",{get:function(){return this.Fields.UserId},set:function(e){this.Fields.UserId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Host",{get:function(){return this.Fields.Host},set:function(e){this.Fields.Host=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostVersion",{get:function(){return this.Fields.HostVersion},set:function(e){this.Fields.HostVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ClientId",{get:function(){return this.Fields.ClientId},set:function(e){this.Fields.ClientId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeWidth",{get:function(){return this.Fields.AppSizeWidth},set:function(e){this.Fields.AppSizeWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeHeight",{get:function(){return this.Fields.AppSizeHeight},set:function(e){this.Fields.AppSizeHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"DocUrl",{get:function(){return this.Fields.DocUrl},set:function(e){this.Fields.DocUrl=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OfficeJSVersion",{get:function(){return this.Fields.OfficeJSVersion},set:function(e){this.Fields.OfficeJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostJSVersion",{get:function(){return this.Fields.HostJSVersion},set:function(e){this.Fields.HostJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"WacHostEnvironment",{get:function(){return this.Fields.WacHostEnvironment},set:function(e){this.Fields.WacHostEnvironment=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"IsFromWacAutomation",{get:function(){return this.Fields.IsFromWacAutomation},set:function(e){this.Fields.IsFromWacAutomation=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"IsMOS",{get:function(){return this.Fields.IsMOS},set:function(e){this.Fields.IsMOS=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("AppId",this.AppId),this.SetSerializedField("AppInstanceId",this.AppInstanceId),this.SetSerializedField("AppURL",this.AppURL),this.SetSerializedField("AssetId",this.AssetId),this.SetSerializedField("Browser",this.Browser),this.SetSerializedField("UserId",this.UserId),this.SetSerializedField("Host",this.Host),this.SetSerializedField("HostVersion",this.HostVersion),this.SetSerializedField("ClientId",this.ClientId),this.SetSerializedField("AppSizeWidth",this.AppSizeWidth),this.SetSerializedField("AppSizeHeight",this.AppSizeHeight),this.SetSerializedField("Message",this.Message),this.SetSerializedField("DocUrl",this.DocUrl),this.SetSerializedField("OfficeJSVersion",this.OfficeJSVersion),this.SetSerializedField("HostJSVersion",this.HostJSVersion),this.SetSerializedField("WacHostEnvironment",this.WacHostEnvironment),this.SetSerializedField("IsFromWacAutomation",this.IsFromWacAutomation),this.SetSerializedField("IsMOS",this.IsMOS)},t}(t);e.AppActivatedUsageData=n;var r=function(e){function t(){return e.call(this,"ScriptLoad")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ScriptId",{get:function(){return this.Fields.ScriptId},set:function(e){this.Fields.ScriptId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"StartTime",{get:function(){return this.Fields.StartTime},set:function(e){this.Fields.StartTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("ScriptId",this.ScriptId),this.SetSerializedField("StartTime",this.StartTime),this.SetSerializedField("ResponseTime",this.ResponseTime)},t}(t);e.ScriptLoadUsageData=r;var o=function(e){function t(){return e.call(this,"AppClosed")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"FocusTime",{get:function(){return this.Fields.FocusTime},set:function(e){this.Fields.FocusTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalWidth",{get:function(){return this.Fields.AppSizeFinalWidth},set:function(e){this.Fields.AppSizeFinalWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalHeight",{get:function(){return this.Fields.AppSizeFinalHeight},set:function(e){this.Fields.AppSizeFinalHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OpenTime",{get:function(){return this.Fields.OpenTime},set:function(e){this.Fields.OpenTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"CloseMethod",{get:function(){return this.Fields.CloseMethod},set:function(e){this.Fields.CloseMethod=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("FocusTime",this.FocusTime),this.SetSerializedField("AppSizeFinalWidth",this.AppSizeFinalWidth),this.SetSerializedField("AppSizeFinalHeight",this.AppSizeFinalHeight),this.SetSerializedField("OpenTime",this.OpenTime),this.SetSerializedField("CloseMethod",this.CloseMethod)},t}(t);e.AppClosedUsageData=o;var i=function(e){function t(){return e.call(this,"APIUsage")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIType",{get:function(){return this.Fields.APIType},set:function(e){this.Fields.APIType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIID",{get:function(){return this.Fields.APIID},set:function(e){this.Fields.APIID=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Parameters",{get:function(){return this.Fields.Parameters},set:function(e){this.Fields.Parameters=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ErrorType",{get:function(){return this.Fields.ErrorType},set:function(e){this.Fields.ErrorType=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("APIType",this.APIType),this.SetSerializedField("APIID",this.APIID),this.SetSerializedField("Parameters",this.Parameters),this.SetSerializedField("ResponseTime",this.ResponseTime),this.SetSerializedField("ErrorType",this.ErrorType)},t}(t);e.APIUsageUsageData=i;var a=function(e){function t(){return e.call(this,"AppInitialization")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SuccessCode",{get:function(){return this.Fields.SuccessCode},set:function(e){this.Fields.SuccessCode=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("SuccessCode",this.SuccessCode),this.SetSerializedField("Message",this.Message)},t}(t);e.AppInitializationUsageData=a;var s=function(e){function t(){return e.call(this,"CheckWACHost")||this}return __extends(t,e),Object.defineProperty(t.prototype,"isWacKnownHost",{get:function(){return this.Fields.isWacKnownHost},set:function(e){this.Fields.isWacKnownHost=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return this.Fields.instanceId},set:function(e){this.Fields.instanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostType",{get:function(){return this.Fields.hostType},set:function(e){this.Fields.hostType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostPlatform",{get:function(){return this.Fields.hostPlatform},set:function(e){this.Fields.hostPlatform=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isLocalStorageAvailable",{get:function(){return this.Fields.isLocalStorageAvailable},set:function(e){this.Fields.isLocalStorageAvailable=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"knownHostIndex",{get:function(){return this.Fields.knownHostIndex},set:function(e){this.Fields.knownHostIndex=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("isWacKnownHost",this.isWacKnownHost),this.SetSerializedField("instanceId",this.instanceId),this.SetSerializedField("hostType",this.hostType),this.SetSerializedField("hostPlatform",this.hostPlatform),this.SetSerializedField("isLocalStorageAvailable",this.isLocalStorageAvailable),this.SetSerializedField("knownHostIndex",this.knownHostIndex)},t}(t);e.CheckWACHostUsageData=s}(OSFLog||(OSFLog={})),function(e){"use strict";!function(e){e[e.info=0]="info",e[e.warning=1]="warning",e[e.error=2]="error"}(e.TraceLevel||(e.TraceLevel={})),function(e){e[e.none=0]="none",e[e.flush=1]="flush"}(e.SendFlag||(e.SendFlag={})),e.allowUploadingData=function(){},e.sendLog=function(e,t,n){};var t=function(){function e(){}return e.prototype.writeLog=function(e){},e.prototype.loadProxyFrame=function(){},e}();OSF.Logger||(OSF.Logger=e),e.ulsEndpoint=function(){try{return new t}catch(e){return null}}()}(Logger||(Logger={})),function(e){var t=[{name:"AppActivated",enabled:!0,critical:!0,points:[{name:"Browser",type:"string"},{name:"Message",type:"string"},{name:"Host",type:"string"},{name:"AppSizeWidth",type:"int64"},{name:"AppSizeHeight",type:"int64"},{name:"IsFromWacAutomation",type:"string"},{name:"IsMOS",type:"int64"}]},{name:"ScriptLoad",enabled:!0,critical:!1,points:[{name:"ScriptId",type:"string"},{name:"StartTime",type:"double"},{name:"ResponseTime",type:"double"}]},{name:"APIUsage",enabled:function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}(),critical:!1,points:[{name:"APIType",type:"string"},{name:"APIID",type:"int64"},{name:"Parameters",type:"string"},{name:"ResponseTime",type:"int64"},{name:"ErrorType",type:"int64"}]},{name:"AppInitialization",enabled:!0,critical:!1,points:[{name:"SuccessCode",type:"int64"},{name:"Message",type:"string"}]},{name:"AppClosed",enabled:!0,critical:!1,points:[{name:"FocusTime",type:"int64"},{name:"AppSizeFinalWidth",type:"int64"},{name:"AppSizeFinalHeight",type:"int64"},{name:"OpenTime",type:"int64"}]},{name:"CheckWACHost",enabled:!0,critical:!1,points:[{name:"isWacKnownHost",type:"int64"},{name:"knownHostIndex",type:"int64"},{name:"solutionId",type:"string"},{name:"hostType",type:"string"},{name:"hostPlatform",type:"string"},{name:"correlationId",type:"string"},{name:"isLocalStorageAvailable",type:"boolean"}]}];function n(e,t){var n=void 0===t.rename?t.name:t.rename,r=void 0;switch(t.type){case"string":r=oteljs.makeStringDataField(n,e);break;case"double":"string"===typeof e&&(e=parseFloat(e)),r=oteljs.makeDoubleDataField(n,e);break;case"int64":"string"===typeof e&&(e=parseInt(e)),r=oteljs.makeInt64DataField(n,e);break;case"boolean":"string"===typeof e&&(e="true"===e),r=oteljs.makeBooleanDataField(n,e)}return r}function r(e){for(var n=0,r=t;n<r.length;n++){var o=r[n];if(o.name===e)return o}}function o(e,t){(function(e){var t=r(e);return void 0!==t&&t.enabled})(e)&&"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var o=function(e,t){var o=r(e);if(void 0!==o){for(var i=[],a=0,s=o.points;a<s.length;a++){var c=s[a],l=t[c.name];if(void 0!==l){var u=n(l,c);void 0!==u&&i.push(u)}}var d={dataCategories:oteljs.DataCategories.ProductServiceUsage};return o.critical&&(d.samplingPolicy=oteljs.SamplingPolicy.CriticalBusinessImpact),d.diagnosticLevel=oteljs.DiagnosticLevel.NecessaryServiceDataEvent,{eventName:"Office.Extensibility.OfficeJs."+e+"X",dataFields:i,eventFlags:d}}}(e,t);void 0!==o&&Microsoft.Office.WebExtension.sendTelemetryEvent(o)}))}var i=function(){function e(){}return e.prototype.getAriaCDNLocation=function(){return OSF._OfficeAppFactory.getLoadScriptHelper().getOfficeJsBasePath()+"ariatelemetry/aria-web-telemetry.js"},e.getInstance=function(){return void 0===e.AriaLoggerObj&&(e.AriaLoggerObj=new e),e.AriaLoggerObj},e.prototype.isIUsageData=function(e){return void 0!==e.Fields},e.prototype.shouldSendDirectToAria=function(e,t){var n;if(!e)return!1;if("win32"===e.toLowerCase())n=[16,0,11601];else{if("mac"!==e.toLowerCase())return!0;n=[16,28]}if(!t)return!1;for(var r=t.split("."),o=0;o<n.length&&o<r.length;o++){var i=parseInt(r[o],10);if(isNaN(i))return!1;if(i<n[o])return!0;if(i>n[o])return!1}return!1},e.prototype.isDirectToAriaEnabled=function(){if(void 0===this.EnableDirectToAria||null===this.EnableDirectToAria){var e=void 0,t=void 0;OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&(e=OSF._OfficeAppFactory.getHostInfo().hostPlatform),window.external&&"undefined"!==typeof window.external.GetContext&&"undefined"!==typeof window.external.GetContext().GetHostFullVersion&&(t=window.external.GetContext().GetHostFullVersion()),this.EnableDirectToAria=this.shouldSendDirectToAria(e,t)}return this.EnableDirectToAria},e.prototype.sendTelemetry=function(t,n){e.EnableSendingTelemetryWithLegacyAria&&this.isDirectToAriaEnabled()&&OSF.OUtil.loadScript(this.getAriaCDNLocation(),(function(){try{if(!this.ALogger){this.ALogger=AWTLogManager.initialize("db334b301e7b474db5e0f02f07c51a47-a1b5bc36-1bbe-482f-a64a-c2d9cb606706-7439")}var e=new AWTEventProperties;for(var r in e.setName("Office.Extensibility.OfficeJS."+t),n)"table"!==r.toLowerCase()&&e.setProperty(r,n[r]);var o=new Date;e.setProperty("Date",o.toISOString()),this.ALogger.logEvent(e)}catch(e){}}),1e3),e.EnableSendingTelemetryWithOTel&&o(t,n)},e.prototype.logData=function(e){this.isIUsageData(e)?this.sendTelemetry(e.Table,e.Fields):this.sendTelemetry(e.Table,e)},e.EnableSendingTelemetryWithOTel=!0,e.EnableSendingTelemetryWithLegacyAria=!1,e}();e.AriaLogger=i}(OSFAriaLogger||(OSFAriaLogger={})),function(e){"use strict";var t,n=OSF.OUtil.Guid.generateNewGuid(),r="",o=new RegExp("^https?://store\\.office(ppe|-int)?\\.com/","i");e.enableTelemetry=!0;var i=function(){return function(){}}();e.AppInfo=i;var a=function(){return function(e,t){this.name=e,this.handler=t}}(),s=function(){function e(){this.clientIDKey="Office API client",this.logIdSetKey="Office App Log Id Set"}return e.prototype.getClientId=function(){var e=this.getValue(this.clientIDKey);return(!e||e.length<=0||e.length>40)&&(e=OSF.OUtil.Guid.generateNewGuid(),this.setValue(this.clientIDKey,e)),e},e.prototype.saveLog=function(e,t){var n=this.getValue(this.logIdSetKey);n=(n&&n.length>0?n+";":"")+e,this.setValue(this.logIdSetKey,n),this.setValue(e,t)},e.prototype.enumerateLog=function(e,t){var n=this.getValue(this.logIdSetKey);if(n){var r=n.split(";");for(var o in r){var i=r[o],a=this.getValue(i);a&&(e&&e(i,a),t&&this.remove(i))}t&&this.remove(this.logIdSetKey)}},e.prototype.getValue=function(e){var t=OSF.OUtil.getLocalStorage(),n="";return t&&(n=t.getItem(e)),n},e.prototype.setValue=function(e,t){var n=OSF.OUtil.getLocalStorage();n&&n.setItem(e,t)},e.prototype.remove=function(e){var t=OSF.OUtil.getLocalStorage();if(t)try{t.removeItem(e)}catch(e){}},e}(),c=function(){function t(){}return t.prototype.LogData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(t)}catch(e){}},t.prototype.LogRawData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(JSON.parse(t))}catch(e){}},t}();function l(e){return e&&(e=e.replace(/[{}]/g,"").toLowerCase()),e||""}function u(e,t){var o=new OSFLog.AppInitializationUsageData;o.CorrelationId=l(r),o.SessionId=n,o.SuccessCode=e?1:0,o.Message=t,(new c).LogData(o)}function d(){var e=0!=(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.PublicAddin);return e||!!t&&p(OSF._OfficeAppFactory.getHostInfo().hostPlatform,t.hostVersion)}function f(e,t){return d()||t!==e?t:"PRIVATE"}function p(e,t){var n=!1,r=/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/.exec(t);if(r){var o=parseInt(r[1]),i=parseInt(r[2]),a=parseInt(r[3]);"win32"==e?(o<16||16==o&&a<14225)&&(n=!0):"mac"==e&&(o<16||16==o&&(i<52||52==i&&a<808))&&(n=!0)}return n}function h(){return 0!=(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.IsMos)}e.initialize=function(r){if(e.enableTelemetry&&!t){t=new i,r.get_hostFullVersion()?t.hostVersion=r.get_hostFullVersion():t.hostVersion=r.get_appVersion(),t.appId=d()?r.get_id():"PRIVATE",t.marketplaceType=r._marketplaceType,t.browser=window.navigator.userAgent,t.correlationId=l(r.get_correlationId()),t.clientId=(new s).getClientId(),t.appInstanceId=r.get_appInstanceId(),t.appInstanceId&&(t.appInstanceId=l(t.appInstanceId),t.appInstanceId=f(r.get_id(),t.appInstanceId)),t.message=r.get_hostCustomMessage(),t.officeJSVersion=OSF.ConstantNames.FileVersion,t.hostJSVersion="16.0.17106.15020",r._wacHostEnvironment&&(t.wacHostEnvironment=r._wacHostEnvironment),void 0!==r._isFromWacAutomation&&null!==r._isFromWacAutomation&&(t.isFromWacAutomation=r._isFromWacAutomation.toString().toLowerCase());var c=r.get_docUrl();t.docUrl=o.test(c)?c:"";var u=location.href;u&&(u=u.split("?")[0].split("#")[0]),t.isMos=h(),t.appURL="",function(e,t){var n,r;t.assetId="",t.userId="";try{n=decodeURIComponent(e);var o=(r=(new DOMParser).parseFromString(n,"text/xml")).getElementsByTagName("t")[0].attributes.getNamedItem("cid"),i=r.getElementsByTagName("t")[0].attributes.getNamedItem("oid");o&&o.nodeValue?t.userId=o.nodeValue:i&&i.nodeValue&&(t.userId=i.nodeValue),t.assetId=r.getElementsByTagName("t")[0].attributes.getNamedItem("aid").nodeValue}catch(e){}finally{n=null,r=null,null}}(r.get_eToken(),t),t.sessionId=n,"undefined"!==typeof OTel&&OTel.OTelLogger.initialize(t),function(){var t=new Date,n=null,r=0,o=!1,i=function(){document.hasFocus()?null==n&&(n=new Date):n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null)},s=[];s.push(new a("focus",i)),s.push(new a("blur",i)),s.push(new a("focusout",i)),s.push(new a("focusin",i));var c=function(){for(var i=0;i<s.length;i++)OSF.OUtil.removeEventListener(window,s[i].name,s[i].handler);s.length=0,o||(document.hasFocus()&&n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null),e.onAppClosed(Math.abs((new Date).getTime()-t.getTime()),r),o=!0)};s.push(new a("beforeunload",c)),s.push(new a("unload",c));for(var l=0;l<s.length;l++)OSF.OUtil.addEventListener(window,s[l].name,s[l].handler);i()}(),e.onAppActivated()}},e.onAppActivated=function(){if(t){(new s).enumerateLog((function(e,t){return(new c).LogRawData(t)}),!0);var e=new OSFLog.AppActivatedUsageData;e.SessionId=n,e.AppId=t.appId,e.AssetId=t.assetId,e.AppURL="",e.UserId="",e.ClientId=t.clientId,e.Browser=t.browser,e.HostVersion=t.hostVersion,e.CorrelationId=l(t.correlationId),e.AppSizeWidth=window.innerWidth,e.AppSizeHeight=window.innerHeight,e.AppInstanceId=t.appInstanceId,e.Message=t.message,e.DocUrl=t.docUrl,e.OfficeJSVersion=t.officeJSVersion,e.HostJSVersion=t.hostJSVersion,t.wacHostEnvironment&&(e.WacHostEnvironment=t.wacHostEnvironment),void 0!==t.isFromWacAutomation&&null!==t.isFromWacAutomation&&(e.IsFromWacAutomation=t.isFromWacAutomation),e.IsMOS=t.isMos?1:0,(new c).LogData(e)}},e.onScriptDone=function(e,t,r,o){var i=new OSFLog.ScriptLoadUsageData;i.CorrelationId=l(o),i.SessionId=n,i.ScriptId=e,i.StartTime=t,i.ResponseTime=r,(new c).LogData(i)},e.onCallDone=function(e,o,i,a,s){if(t&&function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}()&&function(e,t){if("method"===t)switch(e){case 4:case 38:case 37:case 10:case 12:case-10:return!0;default:return!1}return!1}(o,e)){var u=new OSFLog.APIUsageUsageData;u.CorrelationId=l(r),u.SessionId=n,u.APIType=e,u.APIID=o,u.Parameters=i,u.ResponseTime=a,u.ErrorType=s,(new c).LogData(u)}},e.onMethodDone=function(e,t,n,r){var o=null;if(t)if("number"==typeof t)o=String(t);else if("object"===typeof t)for(var i in t)null!==o?o+=",":o="","number"==typeof t[i]&&(o+=String(t[i]));else o="";OSF.AppTelemetry.onCallDone("method",e,o,n,r)},e.onPropertyDone=function(e,t){OSF.AppTelemetry.onCallDone("property",-1,e,t)},e.onCheckWACHost=function(e,t,n,r,o,i){var a=new OSFLog.CheckWACHostUsageData;a.isWacKnownHost=e,a.knownHostIndex=t,a.instanceId=n,a.hostType=r,a.hostPlatform=o,a.isLocalStorageAvailable=i,(new c).LogData(a)},e.onEventDone=function(e,t){OSF.AppTelemetry.onCallDone("event",e,null,0,t)},e.onRegisterDone=function(e,t,n,r){OSF.AppTelemetry.onCallDone(e?"registerevent":"unregisterevent",t,null,n,r)},e.onAppClosed=function(e,o){if(t){var i=new OSFLog.AppClosedUsageData;i.CorrelationId=l(r),i.SessionId=n,i.FocusTime=o,i.OpenTime=e,i.AppSizeFinalWidth=window.innerWidth,i.AppSizeFinalHeight=window.innerHeight,(new s).saveLog(n,i.SerializeRow())}},e.setOsfControlAppCorrelationId=function(e){r=l(e)},e.doAppInitializationLogging=u,e.logAppCommonMessage=function(e){u(!1,e)},e.logAppException=function(e){u(!0,e)},e.canSendAddinId=d,e.getCompliantAppInstanceId=f,e._isComplianceExceptedHost=p,e.isMos=h,OSF.AppTelemetry=e}(OSFAppTelemetry||(OSFAppTelemetry={})),function(e){function t(e,t){if(t+="_Resource",void 0!==oteljs)return[oteljs.makeDoubleDataField(t+"_responseEnd",e.responseEnd),oteljs.makeDoubleDataField(t+"_responseStart",e.responseStart),oteljs.makeDoubleDataField(t+"_startTime",e.startTime),oteljs.makeDoubleDataField(t+"_transferSize",e.transferSize)]}e.sendPerformanceTelemetry=function(){var e,n;"undefined"!==typeof OTel&&OSF.AppTelemetry.enableTelemetry&&"undefined"!==typeof OSFPerformance&&"undefined"!=typeof performance&&performance.getEntriesByType&&(performance.getEntriesByType("resource").forEach((function(t){var r=t.name.toLowerCase();OSF.OUtil.stringEndsWith(r,OSFPerformance.hostSpecificFileName)?e=t:(OSF.OUtil.stringEndsWith(r,OSF.ConstantNames.OfficeDebugJS)||OSF.OUtil.stringEndsWith(r,OSF.ConstantNames.OfficeJS))&&(n=t)})),OTel.OTelLogger.onTelemetryLoaded((function(){var r=t(e,"HostJs");r=(r=r.concat(t(n,"OfficeJs"))).concat([oteljs.makeDoubleDataField("officeExecuteStartDate",OSFPerformance.officeExecuteStartDate),oteljs.makeDoubleDataField("officeExecuteStart",OSFPerformance.officeExecuteStart),oteljs.makeDoubleDataField("officeExecuteEnd",OSFPerformance.officeExecuteEnd),oteljs.makeDoubleDataField("hostInitializationStart",OSFPerformance.hostInitializationStart),oteljs.makeDoubleDataField("hostInitializationEnd",OSFPerformance.hostInitializationEnd),oteljs.makeDoubleDataField("totalJSHeapSize",OSFPerformance.totalJSHeapSize),oteljs.makeDoubleDataField("usedJSHeapSize",OSFPerformance.usedJSHeapSize),oteljs.makeDoubleDataField("jsHeapSizeLimit",OSFPerformance.jsHeapSizeLimit),oteljs.makeDoubleDataField("getAppContextStart",OSFPerformance.getAppContextStart),oteljs.makeDoubleDataField("getAppContextEnd",OSFPerformance.getAppContextEnd),oteljs.makeDoubleDataField("createOMEnd",OSFPerformance.createOMEnd),oteljs.makeDoubleDataField("officeOnReady",OSFPerformance.officeOnReady),oteljs.makeBooleanDataField("isSharedRuntime",0!==(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.SharedApp))]),Microsoft.Office.WebExtension.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.JSPerformanceTelemetryV06",dataFields:r,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage,diagnosticLevel:oteljs.DiagnosticLevel.NecessaryServiceDataEvent}})})))}}(OSFPerfUtil||(OSFPerfUtil={})),Microsoft.Office.WebExtension.EventType={},OSF.EventDispatch=function(e){if(this._eventHandlers={},this._objectEventHandlers={},this._queuedEventsArgs={},null!=e)for(var t=0;t<e.length;t++){var n=e[t];"objectDeleted"==n||"objectSelectionChanged"==n||"objectDataChanged"==n||"contentControlAdded"==n?this._objectEventHandlers[n]={}:this._eventHandlers[n]=[],this._queuedEventsArgs[n]=[]}},OSF.EventDispatch.prototype={getSupportedEvents:function(){var e=[];for(var t in this._eventHandlers)e.push(t);for(var t in this._objectEventHandlers)e.push(t);return e},supportsEvent:function(e){for(var t in this._eventHandlers)if(e==t)return!0;for(var t in this._objectEventHandlers)if(e==t)return!0;return!1},hasEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return!0;return!1},hasObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var o=r[t],i=0;null!=o&&i<o.length;i++)if(o[i]===n)return!0;return!1},addEventHandler:function(e,t){if("function"!=typeof t)return!1;var n=this._eventHandlers[e];return!(!n||this.hasEventHandler(e,t))&&(n.push(t),!0)},addObjectEventHandler:function(e,t,n){if("function"!=typeof n)return!1;var r=this._objectEventHandlers[e];return!(!r||this.hasObjectEventHandler(e,t,n))&&(null==r[t]&&(r[t]=[]),r[t].push(n),!0)},addEventHandlerAndFireQueuedEvent:function(e,t){var n=0==this._eventHandlers[e].length,r=this.addEventHandler(e,t);return n&&r&&this.fireQueuedEvent(e),r},removeEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return n.splice(r,1),!0;return!1},removeObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var o=r[t],i=0;null!=o&&i<o.length;i++)if(o[i]===n)return o.splice(i,1),!0;return!1},clearEventHandlers:function(e){return"undefined"!=typeof this._eventHandlers[e]&&this._eventHandlers[e].length>0&&(this._eventHandlers[e]=[],!0)},clearObjectEventHandlers:function(e,t){return null!=this._objectEventHandlers[e]&&null!=this._objectEventHandlers[e][t]&&(this._objectEventHandlers[e][t]=[],!0)},getEventHandlerCount:function(e){return void 0!=this._eventHandlers[e]?this._eventHandlers[e].length:-1},getObjectEventHandlerCount:function(e,t){return null==this._objectEventHandlers[e]||null==this._objectEventHandlers[e][t]?0:this._objectEventHandlers[e][t].length},fireEvent:function(e){if(void 0==e.type)return!1;var t=e.type;if(t&&this._eventHandlers[t]){for(var n=this._eventHandlers[t],r=0;r<n.length;r++)n[r](e);return!0}return!1},fireObjectEvent:function(e,t){if(void 0==t.type)return!1;var n=t.type;if(n&&this._objectEventHandlers[n]){var r=this._objectEventHandlers[n][e];if(null!=r){for(var o=0;o<r.length;o++)r[o](t);return!0}}return!1},fireOrQueueEvent:function(e){var t=e.type;if(t&&this._eventHandlers[t]){var n=this._eventHandlers[t],r=this._queuedEventsArgs[t];return 0==n.length?r.push(e):this.fireEvent(e),!0}return!1},fireQueuedEvent:function(e){if(e&&this._eventHandlers[e]){var t=this._eventHandlers[e],n=this._queuedEventsArgs[e];if(t.length>0){for(var r=t[0];n.length>0;){r(n.shift())}return!0}}return!1},clearQueuedEvent:function(e){e&&this._eventHandlers[e]&&(this._queuedEventsArgs[e]&&(this._queuedEventsArgs[e]=[]))}},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureEventArgs=function(e,t,n){var r;switch(e){case Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged:r=new OSF.DDA.DocumentSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.BindingSelectionChanged:r=new OSF.DDA.BindingSelectionChangedEventArgs(this.manufactureBinding(n,t.document),n[OSF.DDA.PropertyDescriptors.Subset]);break;case Microsoft.Office.WebExtension.EventType.BindingDataChanged:r=new OSF.DDA.BindingDataChangedEventArgs(this.manufactureBinding(n,t.document));break;case Microsoft.Office.WebExtension.EventType.SettingsChanged:r=new OSF.DDA.SettingsChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ActiveViewChanged:r=new OSF.DDA.ActiveViewChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.OfficeThemeChanged:r=new OSF.DDA.Theming.OfficeThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DocumentThemeChanged:r=new OSF.DDA.Theming.DocumentThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.Suspend:r=new OSF.DDA.SuspendEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.Resume:r=new OSF.DDA.ResumeEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppCommandInvoked:r=OSF.DDA.AppCommand.AppCommandInvokedEventArgs.create(n),"outlook"==OSF._OfficeAppFactory.getHostInfo().hostType&&"mac"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&OSF.DDA.convertOlkAppointmentTimeToDateFormat(r);break;case Microsoft.Office.WebExtension.EventType.ObjectDeleted:case Microsoft.Office.WebExtension.EventType.ObjectSelectionChanged:case Microsoft.Office.WebExtension.EventType.ObjectDataChanged:case Microsoft.Office.WebExtension.EventType.ContentControlAdded:r=new OSF.DDA.ObjectEventArgs(e,n[Microsoft.Office.WebExtension.Parameters.Id]);break;case Microsoft.Office.WebExtension.EventType.RichApiMessage:r=new OSF.DDA.RichApiMessageEventArgs(e,n);break;case Microsoft.Office.WebExtension.EventType.DataNodeInserted:r=new OSF.DDA.NodeInsertedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeReplaced:r=new OSF.DDA.NodeReplacedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeDeleted:r=new OSF.DDA.NodeDeletedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NextSiblingNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.TaskSelectionChanged:r=new OSF.DDA.TaskSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ResourceSelectionChanged:r=new OSF.DDA.ResourceSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ViewSelectionChanged:r=new OSF.DDA.ViewSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.DialogMessageReceived:r=new OSF.DDA.DialogEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived:r=new OSF.DDA.DialogParentEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.ItemChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkItemSelectedChangedEventArgs(n),t.initialize(r.initialData),"win32"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform&&"mac"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform||t.setCurrentItemNumber(r.itemNumber.itemNumber);break;case Microsoft.Office.WebExtension.EventType.RecipientsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecipientsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppointmentTimeChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAppointmentTimeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.RecurrenceChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecurrenceChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AttachmentsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAttachmentsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.EnhancedLocationsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkEnhancedLocationsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.InfobarClicked:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkInfobarClickedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.SelectedItemsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkSelectedItemsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.SensitivityLabelChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkSensitivityLabelChangedEventArgs(n);break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e))}return r},OSF.DDA.AsyncMethodNames.addNames({AddHandlerAsync:"addHandlerAsync",RemoveHandlerAsync:"removeHandlerAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RemoveHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Handler,value:{types:["function","object"],defaultValue:null}}],privateStateCallbacks:[]}),OSF.DialogShownStatus={hasDialogShown:!1,isWindowDialog:!1},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogMessageReceivedEvent:"DialogMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogMessageReceived:"dialogMessageReceived",DialogEventReceived:"dialogEventReceived"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{MessageType:"messageType",MessageContent:"messageContent",MessageOrigin:"messageOrigin"}),OSF.DDA.DialogEventType={},OSF.OUtil.augmentList(OSF.DDA.DialogEventType,{DialogClosed:"dialogClosed",NavigationFailed:"naviationFailed"}),OSF.DDA.AsyncMethodNames.addNames({DisplayDialogAsync:"displayDialogAsync",DisplayModalDialogAsync:"displayModalDialogAsync",CloseAsync:"close"}),OSF.DDA.SyncMethodNames.addNames({MessageParent:"messageParent",MessageChild:"messageChild",SendMessage:"sendMessage",AddMessageHandler:"addEventHandler"}),OSF.DDA.UI.ParentUI=function(){var e;e=null!=Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived?new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived,Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived]):new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived]);var t=this,n=function(n,r){t[n]||OSF.OUtil.defineEnumerableProperty(t,n,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.OpenDialog];n(arguments,e,t,r)}})};n(OSF.DDA.AsyncMethodNames.DisplayDialogAsync.displayName,!1),Microsoft.Office.WebExtension.FeatureGates.ModalWebDialogAPI&&n(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.displayName,!0),OSF.OUtil.finalizeProperties(this)},OSF.DDA.UI.ChildUI=function(e){var t=OSF.DDA.SyncMethodNames.MessageParent.displayName,n=this;n[t]||OSF.OUtil.defineEnumerableProperty(n,t,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.MessageParent];return e(arguments,n)}});var r=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;n[r]||"undefined"==typeof OSF.DialogParentMessageEventDispatch||OSF.DDA.DispIdHost.addEventSupport(n,OSF.DialogParentMessageEventDispatch,e),OSF.OUtil.finalizeProperties(this)},OSF.DialogHandler=function(){},OSF.DDA.DialogEventArgs=function(e){e[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogMessageReceived?OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}}):OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogEventReceived},error:{value:e[OSF.DDA.PropertyDescriptors.MessageType]}})},OSF.DDA.DialogParentEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}})};var DialogApiManager=function(){function e(){}return e.defineApi=function(e,t){OSF.DDA.AsyncMethodCalls.define({method:e,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:t,privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Id],o=e[Microsoft.Office.WebExtension.Parameters.Data],i=new OSF.DialogHandler,a=OSF.DDA.AsyncMethodNames.CloseAsync.displayName;OSF.OUtil.defineEnumerableProperty(i,a,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.CloseDialog];e(arguments,r,o,i)}});var s=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;if(OSF.OUtil.defineEnumerableProperty(i,s,{value:function(){var e=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.AddMessageHandler.id],t=e.verifyAndExtractCall(arguments,i,o),n=t[Microsoft.Office.WebExtension.Parameters.EventType],r=t[Microsoft.Office.WebExtension.Parameters.Handler];return o.addEventHandlerAndFireQueuedEvent(n,r)}}),!0===OSF.DDA.UI.EnableSendMessageDialogAPI){var c=OSF.DDA.SyncMethodNames.SendMessage.displayName;OSF.OUtil.defineEnumerableProperty(i,c,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,o,i)}})}if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var l=OSF.DDA.SyncMethodNames.MessageChild.displayName;OSF.OUtil.defineEnumerableProperty(i,l,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,o,i)}})}return i},checkCallArgs:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Width]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Width]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Width]>100&&(e[Microsoft.Office.WebExtension.Parameters.Width]=99),e[Microsoft.Office.WebExtension.Parameters.Height]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Height]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Height]>100&&(e[Microsoft.Office.WebExtension.Parameters.Height]=99),e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]||(e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]=!0),e}})},e.messageChildRichApiBridge=function(){if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,null,null)}},e.initOnce=function(){e.defineApi(OSF.DDA.AsyncMethodNames.DisplayDialogAsync,e.displayDialogAsyncApiSupportedOptions),e.defineApi(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync,e.displayModalDialogAsyncApiSupportedOptions)},e.displayDialogAsyncApiSupportedOptions=[{name:Microsoft.Office.WebExtension.Parameters.Width,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.Height,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.RequireHTTPs,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.DisplayInIframe,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.HideTitle,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.PromptBeforeOpen,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.EnforceAppDomain,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.UrlNoHostInfo,value:{types:["boolean"],defaultValue:!1}}],e.displayModalDialogAsyncApiSupportedOptions=e.displayDialogAsyncApiSupportedOptions.concat([{name:"abortWhenParentIsMinimized",value:{types:["boolean"],defaultValue:!1}},{name:"abortWhenDocIsInactive",value:{types:["boolean"],defaultValue:!1}}]),e}();DialogApiManager.initOnce(),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CloseAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.MessageParent,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageToParent,types:["string","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.AddMessageHandler,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.SendMessage,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageContent,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.openDialog=function(e){try{e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);OSF.ClientHostController.openDialog(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.closeDialog=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.closeDialog(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.messageParent=function(e){try{e.onCalling&&e.onCalling();var t=(new Date).getTime(),n=OSF.ClientHostController.messageParent(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),OSF.AppTelemetry&&OSF.AppTelemetry.onMethodDone(e.dispId,e.hostCallArgs,Math.abs((new Date).getTime()-t),n),n}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.sendMessage=function(e){try{e.onCalling&&e.onCalling();(new Date).getTime();var t=OSF.ClientHostController.sendMessage(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),t}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogParentMessageReceivedEvent:"DialogParentMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogParentMessageReceived:"dialogParentMessageReceived",DialogParentEventReceived:"dialogParentEventReceived"}),OSF.DialogParentMessageEventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived,Microsoft.Office.WebExtension.EventType.DialogParentEventReceived]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.UI.EnableMessageChildDialogAPI=!0,Microsoft.Office.WebExtension.TableData=function(e,t){function n(e){if(null==e||void 0==e)return null;try{for(var t=OSF.DDA.DataCoercion.findArrayDimensionality(e,2);t<2;t++)e=[e];return e}catch(e){}}OSF.OUtil.defineEnumerableProperties(this,{headers:{get:function(){return t},set:function(e){t=n(e)}},rows:{get:function(){return e},set:function(t){e=null==t||OSF.OUtil.isArray(t)&&0==t.length?[]:n(t)}}}),this.headers=t,this.rows=e},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureTableData=function(e){return new Microsoft.Office.WebExtension.TableData(e[OSF.DDA.TableDataProperties.TableRows],e[OSF.DDA.TableDataProperties.TableHeaders])},Microsoft.Office.WebExtension.CoercionType={Text:"text",Matrix:"matrix",Table:"table"},OSF.DDA.DataCoercion=function(){return{findArrayDimensionality:function(e){if(OSF.OUtil.isArray(e)){for(var t=0,n=0;n<e.length;n++)t=Math.max(t,OSF.DDA.DataCoercion.findArrayDimensionality(e[n]));return t+1}return 0},getCoercionDefaultForBinding:function(e){switch(e){case Microsoft.Office.WebExtension.BindingType.Matrix:return Microsoft.Office.WebExtension.CoercionType.Matrix;case Microsoft.Office.WebExtension.BindingType.Table:return Microsoft.Office.WebExtension.CoercionType.Table;case Microsoft.Office.WebExtension.BindingType.Text:default:return Microsoft.Office.WebExtension.CoercionType.Text}},getBindingDefaultForCoercion:function(e){switch(e){case Microsoft.Office.WebExtension.CoercionType.Matrix:return Microsoft.Office.WebExtension.BindingType.Matrix;case Microsoft.Office.WebExtension.CoercionType.Table:return Microsoft.Office.WebExtension.BindingType.Table;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:return Microsoft.Office.WebExtension.BindingType.Text}},determineCoercionType:function(e){if(null==e||void 0==e)return null;var t=null,n=typeof e;if(void 0!==e.rows)t=Microsoft.Office.WebExtension.CoercionType.Table;else if(OSF.OUtil.isArray(e))t=Microsoft.Office.WebExtension.CoercionType.Matrix;else{if("string"!=n&&"number"!=n&&"boolean"!=n&&!OSF.OUtil.isDate(e))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject;t=Microsoft.Office.WebExtension.CoercionType.Text}return t},coerceData:function(e,t,n){return(n=n||OSF.DDA.DataCoercion.determineCoercionType(e))&&n!=t&&(OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionBegin),e=OSF.DDA.DataCoercion._coerceDataFromTable(t,OSF.DDA.DataCoercion._coerceDataToTable(e,n)),OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionEnd)),e},_matrixToText:function(e){if(1==e.length&&1==e[0].length)return""+e[0][0];for(var t="",n=0;n<e.length;n++)t+=e[n].join("\t")+"\n";return t.substring(0,t.length-1)},_textToMatrix:function(e){for(var t=e.split("\n"),n=0;n<t.length;n++)t[n]=t[n].split("\t");return t},_tableToText:function(e){var t="";null!=e.headers&&(t=OSF.DDA.DataCoercion._matrixToText([e.headers])+"\n");var n=OSF.DDA.DataCoercion._matrixToText(e.rows);return""==n&&(t=t.substring(0,t.length-1)),t+n},_tableToMatrix:function(e){var t=e.rows;return null!=e.headers&&t.unshift(e.headers),t},_coerceDataFromTable:function(e,t){var n;switch(e){case Microsoft.Office.WebExtension.CoercionType.Table:n=t;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=OSF.DDA.DataCoercion._tableToMatrix(t);break;case Microsoft.Office.WebExtension.CoercionType.SlideRange:n=null,OSF.DDA.OMFactory.manufactureSlideRange&&(n=OSF.DDA.OMFactory.manufactureSlideRange(OSF.DDA.DataCoercion._tableToText(t))),null==n&&(n=OSF.DDA.DataCoercion._tableToText(t));break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=OSF.DDA.DataCoercion._tableToText(t)}return n},_coerceDataToTable:function(e,t){var n;switch(void 0==t&&(t=OSF.DDA.DataCoercion.determineCoercionType(e)),t){case Microsoft.Office.WebExtension.CoercionType.Table:n=e;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=new Microsoft.Office.WebExtension.TableData(e);break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=new Microsoft.Office.WebExtension.TableData(OSF.DDA.DataCoercion._textToMatrix(e))}return n}}}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Text,value:0},{name:Microsoft.Office.WebExtension.CoercionType.Matrix,value:1},{name:Microsoft.Office.WebExtension.CoercionType.Table,value:2}]}),OSF.DDA.AsyncMethodNames.addNames({GetSelectedDataAsync:"getSelectedDataAsync",SetSelectedDataAsync:"setSelectedDataAsync"}),function(){OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,enum:Microsoft.Office.WebExtension.CoercionType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{enum:Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{enum:Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}}],privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return OSF.DDA.TableDataProperties&&r&&(void 0!=r[OSF.DDA.TableDataProperties.TableRows]||void 0!=r[OSF.DDA.TableDataProperties.TableHeaders])&&(r=OSF.DDA.OMFactory.manufactureTableData(r)),void 0==(r=OSF.DDA.DataCoercion.coerceData(r,n[Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:{types:["number","boolean"],defaultValue:!1}}],privateStateCallbacks:[]})}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetSelectedDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:1},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetSelectedDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:2},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:3},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:4},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:5}]}),OSF.DDA.SettingsManager={SerializedSettings:"serializedSettings",RefreshingSettings:"refreshingSettings",DateJSONPrefix:"Date(",DataJSONSuffix:")",serializeSettings:function(e){return OSF.OUtil.serializeSettings(e)},deserializeSettings:function(e){return OSF.OUtil.deserializeSettings(e)}},OSF.DDA.Settings=function(e){e=e||{};var t=function(e){var t=OSF.OUtil.getSessionStorage();if(t){var n=OSF.DDA.SettingsManager.serializeSettings(e),r=JSON?JSON.stringify(n):Sys.Serialization.JavaScriptSerializer.serialize(n);t.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r)}};OSF.OUtil.defineEnumerableProperties(this,{get:{value:function(t){var n=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(n)throw n;var r=e[t];return"undefined"===typeof r?null:r}},set:{value:function(n,r){var o=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1},{name:"value",mayBeNull:!0}]);if(o)throw o;e[n]=r,t(e)}},remove:{value:function(n){var r=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(r)throw r;delete e[n],t(e)}}}),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.SaveAsync],e)},OSF.DDA.RefreshableSettings=function(e){OSF.DDA.RefreshableSettings.uber.constructor.call(this,e),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.RefreshAsync],e),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.SettingsChanged]))},OSF.OUtil.extend(OSF.DDA.RefreshableSettings,OSF.DDA.Settings),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{SettingsChanged:"settingsChanged"}),OSF.DDA.SettingsChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.SettingsChanged},settings:{value:e}})},OSF.DDA.AsyncMethodNames.addNames({RefreshAsync:"refreshAsync",SaveAsync:"saveAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RefreshAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.RefreshingSettings,value:function(e,t){return t}}],onSucceeded:function(e,t,n){var r=e[OSF.DDA.SettingsManager.SerializedSettings],o=OSF.DDA.SettingsManager.deserializeSettings(r),i=n[OSF.DDA.SettingsManager.RefreshingSettings];for(var a in i)t.remove(a);for(var a in o)t.set(a,o[a]);return t}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SaveAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:{types:["boolean"],defaultValue:!0}}],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:function(e,t){return OSF.DDA.SettingsManager.serializeSettings(t)}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidLoadSettingsMethod,fromHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSaveSettingsMethod,toHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SettingsManager.SerializedSettings},{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidSettingsChangedEvent}),OSF.DDA.AsyncMethodNames.addNames({GetOfficeThemeAsync:"getOfficeThemeAsync",GetDocumentThemeAsync:"getDocumentThemeAsync"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{OfficeThemeChanged:"officeThemeChanged",DocumentThemeChanged:"documentThemeChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.Parameters,{DocumentTheme:"documentTheme",OfficeTheme:"officeTheme"}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DocumentThemeChangedEvent:"DocumentThemeChangedEvent",OfficeThemeChangedEvent:"OfficeThemeChangedEvent"}),OSF.OUtil.setNamespace("Theming",OSF.DDA),OSF.DDA.Theming.OfficeThemeEnum={BodyForegroundColor:"bodyForegroundColor",BodyBackgroundColor:"bodyBackgroundColor",ControlForegroundColor:"controlForegroundColor",ControlBackgroundColor:"controlBackgroundColor",ThemeId:"themeId",IsDarkTheme:"isDarkTheme"},OSF.DDA.Theming.OfficeThemeEnumWac={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",IsDarkTheme:"isDarkTheme"},OSF.DDA.Theming.DocumentThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",Accent1:"accent1",Accent2:"accent2",Accent3:"accent3",Accent4:"accent4",Accent5:"accent5",Accent6:"accent6",Hyperlink:"hyperlink",FollowedHyperlink:"followedHyperlink",HeaderLatinFont:"headerLatinFont",HeaderEastAsianFont:"headerEastAsianFont",HeaderScriptFont:"headerScriptFont",HeaderLocalizedFont:"headerLocalizedFont",BodyLatinFont:"bodyLatinFont",BodyEastAsianFont:"bodyEastAsianFont",BodyScriptFont:"bodyScriptFont",BodyLocalizedFont:"bodyLocalizedFont"},OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor=function(e){var t="#"===e.charAt(0)?e.substring(1,7):e;return.299*parseInt(t.substring(0,2),16)+.587*parseInt(t.substring(2,4),16)+.114*parseInt(t.substring(4,6),16)<186},OSF.DDA.Theming.ConvertToDocumentTheme=function(e){for(var t=[{name:"primaryFontColor",needToConvertToHex:!0},{name:"primaryBackgroundColor",needToConvertToHex:!0},{name:"secondaryFontColor",needToConvertToHex:!0},{name:"secondaryBackgroundColor",needToConvertToHex:!0},{name:"accent1",needToConvertToHex:!0},{name:"accent2",needToConvertToHex:!0},{name:"accent3",needToConvertToHex:!0},{name:"accent4",needToConvertToHex:!0},{name:"accent5",needToConvertToHex:!0},{name:"accent6",needToConvertToHex:!0},{name:"hyperlink",needToConvertToHex:!0},{name:"followedHyperlink",needToConvertToHex:!0},{name:"headerLatinFont",needToConvertToHex:!1},{name:"headerEastAsianFont",needToConvertToHex:!1},{name:"headerScriptFont",needToConvertToHex:!1},{name:"headerLocalizedFont",needToConvertToHex:!1},{name:"bodyLatinFont",needToConvertToHex:!1},{name:"bodyEastAsianFont",needToConvertToHex:!1},{name:"bodyScriptFont",needToConvertToHex:!1},{name:"bodyLocalizedFont",needToConvertToHex:!1}],n={},r=0;r<t.length;r++)t[r].needToConvertToHex?n[t[r].name]=OSF.OUtil.convertIntToCssHexColor(e[t[r].name]):n[t[r].name]=e[t[r].name];return n},OSF.DDA.Theming.ConvertToOfficeTheme=function(e){var t={};if(e){var n=OSF.DDA.Theming.OfficeThemeEnum,r={bodyBackgroundColor:{name:n.BodyBackgroundColor,convertToHex:!0},bodyForegroundColor:{name:n.BodyForegroundColor,convertToHex:!0},controlBackgroundColor:{name:n.ControlBackgroundColor,convertToHex:!0},controlForegroundColor:{name:n.ControlForegroundColor,convertToHex:!0},primaryFontColor:{name:n.BodyForegroundColor,convertToHex:!0},primaryBackgroundColor:{name:n.BodyBackgroundColor,convertToHex:!0},secondaryFontColor:{name:n.ControlBackgroundColor,convertToHex:!0},secondaryBackgroundColor:{name:n.ControlForegroundColor,convertToHex:!0}};for(var o in e){var i=!1,a=o;r[o]&&(a=r[o].name,i=r[o].convertToHex),t[a]=i?OSF.OUtil.convertIntToCssHexColor(e[o]):e[o]}void 0==t[n.IsDarkTheme]&&(t[n.IsDarkTheme]=OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor(t[n.BodyBackgroundColor]))}return t},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToDocumentTheme}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToOfficeTheme}),OSF.DDA.Theming.OfficeThemeChangedEventArgs=function(e){var t=null,n=OSF._OfficeAppFactory.getHostInfo();if((t=n&&"web"==n.hostPlatform.toLowerCase()?e:OSF.DDA.Theming.ConvertToOfficeTheme(e)).isDarkTheme=OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor(t.bodyBackgroundColor),"web"==n.hostPlatform.toLowerCase()||"mac"==n.hostPlatform.toLowerCase()||"ios"==n.hostPlatform.toLowerCase()){var r=OSF._OfficeAppFactory.getContext();r&&r.officeTheme&&(r.officeTheme.bodyBackgroundColor=t.bodyBackgroundColor,r.officeTheme.bodyForegroundColor=t.bodyForegroundColor,r.officeTheme.controlBackgroundColor=t.controlBackgroundColor,r.officeTheme.controlBackgroundColor=t.controlBackgroundColor,r.officeTheme.isDarkTheme=t.isDarkTheme)}OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.OfficeThemeChanged},officeTheme:{value:t}})},OSF.DDA.Theming.DocumentThemeChangedEventArgs=function(e){var t=OSF.DDA.Theming.ConvertToDocumentTheme(e);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentThemeChanged},documentTheme:{value:t}})};var OSF_DDA_Theming_InternalThemeHandler=function(){function e(){this._pseudoDocumentObject=null,this._eventTarget=null,this._previousDocumentThemeData=null,this._previousOfficeThemeData=null,this._officeCss=null,this._asyncCallsCompleted=null,this._isPublicThemeManager=!1,this._onAsyncCallsCompleted=null}return e.prototype.InitializeThemeManager=function(){this._isPublicThemeManager=!0,this._eventTarget=this,OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged]))},e.prototype.InitializeAndChangeOnce=function(e){if(this._officeCss=this._getOfficeThemesCss(),this._officeCss){this._onAsyncCallsCompleted=e,this._pseudoDocumentObject={};var t=this._pseudoDocumentObject;this._isPublicThemeManager||(OSF.DDA.DispIdHost.addAsyncMethods(t,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]),OSF.DDA.DispIdHost.addEventSupport(t,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged]))),this._asyncCallsCompleted={},this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync]=!1,this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]=!1;var n=OSF._OfficeAppFactory.getHostInfo();this._isPublicThemeManager?(n&&n.hostType.toLowerCase()!=Microsoft.Office.WebExtension.HostType.Word.toLowerCase()&&this._getAndProcessThemeData(this._eventTarget.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync),this._getAndProcessThemeData(this._eventTarget.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync)):(n&&n.hostType.toLowerCase()!=Microsoft.Office.WebExtension.HostType.Word.toLowerCase()&&this._getAndProcessThemeData(t.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync),this._getAndProcessThemeData(t.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync))}else e&&e()},e.prototype._getOfficeThemesCss=function(){try{return function(){for(var e=0;e<document.styleSheets.length;e++){var t=document.styleSheets[e];if(!t.disabled&&t.href&&"officethemes.css"==t.href.substring(t.href.length-"officethemes.css".length,t.href.length).toLowerCase())return t.cssRules||t.rules?t:null}}()}catch(e){return null}},e.prototype._changeCss=function(e,t,n){for(var r=e.cssRules?e.cssRules.length:e.rules.length,o=0;o<r;o++){var i=(e.cssRules?e.cssRules[o]:e.rules[o]).selectorText;i&&i.toLowerCase()==t.toLowerCase()&&(e.cssRules?(e.deleteRule(o),e.insertRule(i+n,o)):(e.removeRule(o),e.addRule(i,n,o)))}},e.prototype._changeDocumentThemeData=function(e){for(var t=[{name:"primaryFontColor",cssSelector:".office-docTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-docTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-docTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-docTheme-secondary-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-color",cssProperty:"color"},{name:"accent2",cssSelector:".office-contentAccent2-color",cssProperty:"color"},{name:"accent3",cssSelector:".office-contentAccent3-color",cssProperty:"color"},{name:"accent4",cssSelector:".office-contentAccent4-color",cssProperty:"color"},{name:"accent5",cssSelector:".office-contentAccent5-color",cssProperty:"color"},{name:"accent6",cssSelector:".office-contentAccent6-color",cssProperty:"color"},{name:"accent1",cssSelector:".office-contentAccent1-bgColor",cssProperty:"background-color"},{name:"accent2",cssSelector:".office-contentAccent2-bgColor",cssProperty:"background-color"},{name:"accent3",cssSelector:".office-contentAccent3-bgColor",cssProperty:"background-color"},{name:"accent4",cssSelector:".office-contentAccent4-bgColor",cssProperty:"background-color"},{name:"accent5",cssSelector:".office-contentAccent5-bgColor",cssProperty:"background-color"},{name:"accent6",cssSelector:".office-contentAccent6-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-borderColor",cssProperty:"border-color"},{name:"accent2",cssSelector:".office-contentAccent2-borderColor",cssProperty:"border-color"},{name:"accent3",cssSelector:".office-contentAccent3-borderColor",cssProperty:"border-color"},{name:"accent4",cssSelector:".office-contentAccent4-borderColor",cssProperty:"border-color"},{name:"accent5",cssSelector:".office-contentAccent5-borderColor",cssProperty:"border-color"},{name:"accent6",cssSelector:".office-contentAccent6-borderColor",cssProperty:"border-color"},{name:"hyperlink",cssSelector:".office-a",cssProperty:"color"},{name:"followedHyperlink",cssSelector:".office-a:visited",cssProperty:"color"},{name:"headerLatinFont",cssSelector:".office-headerFont-latin",cssProperty:"font-family"},{name:"headerEastAsianFont",cssSelector:".office-headerFont-eastAsian",cssProperty:"font-family"},{name:"headerScriptFont",cssSelector:".office-headerFont-script",cssProperty:"font-family"},{name:"headerLocalizedFont",cssSelector:".office-headerFont-localized",cssProperty:"font-family"},{name:"bodyLatinFont",cssSelector:".office-bodyFont-latin",cssProperty:"font-family"},{name:"bodyEastAsianFont",cssSelector:".office-bodyFont-eastAsian",cssProperty:"font-family"},{name:"bodyScriptFont",cssSelector:".office-bodyFont-script",cssProperty:"font-family"},{name:"bodyLocalizedFont",cssSelector:".office-bodyFont-localized",cssProperty:"font-family"}],n=e.type==Microsoft.Office.WebExtension.EventType.DocumentThemeChanged?e.documentTheme:e,r=0;r<t.length;r++)if(null===this._previousDocumentThemeData||this._previousDocumentThemeData[t[r].name]!=n[t[r].name])if(null!=n[t[r].name]&&""!=n[t[r].name]){var o=n[t[r].name];"font-family"===t[r].cssProperty&&(o='"'+o.replace(new RegExp('"',"g"),'\\"')+'"'),this._changeCss(this._officeCss,t[r].cssSelector,"{"+t[r].cssProperty+":"+o+";}")}else this._changeCss(this._officeCss,t[r].cssSelector,"{}");this._previousDocumentThemeData=n},e.prototype._changeOfficeThemeData=function(e){for(var t=OSF.DDA.Theming.OfficeThemeEnum,n=[{name:t.BodyForegroundColor,cssSelector:".office-officeTheme-primary-fontColor",cssProperty:"color"},{name:t.BodyBackgroundColor,cssSelector:".office-officeTheme-primary-bgColor",cssProperty:"background-color"},{name:t.ControlForegroundColor,cssSelector:".office-officeTheme-secondary-fontColor",cssProperty:"color"},{name:t.ControlBackgroundColor,cssSelector:".office-officeTheme-secondary-bgColor",cssProperty:"background-color"}],r=e.type==Microsoft.Office.WebExtension.EventType.OfficeThemeChanged?e.officeTheme:e,o=0;o<n.length;o++)null!==this._previousOfficeThemeData&&this._previousOfficeThemeData[n[o].name]==r[n[o].name]||void 0!==r[n[o].name]&&this._changeCss(this._officeCss,n[o].cssSelector,"{"+n[o].cssProperty+":"+r[n[o].name]+";}");this._previousOfficeThemeData=r},e.prototype._getAndProcessThemeData=function(e,t,n){var r=OSF._OfficeAppFactory.getHostInfo();if(r&&"web"==r.hostPlatform.toLowerCase()){if(n==OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync){var o={},i=OSF._OfficeAppFactory.getContext();if(i&&i.officeTheme){var a=OSF.DDA.Theming.OfficeThemeEnum;o[a.BodyBackgroundColor]=i.officeTheme.bodyBackgroundColor,o[a.BodyForegroundColor]=i.officeTheme.bodyForegroundColor,o[a.ControlBackgroundColor]=i.officeTheme.controlBackgroundColor,o[a.ControlForegroundColor]=i.officeTheme.controlForegroundColor,o[a.IsDarkTheme]=i.officeTheme.isDarkTheme}t(o)}}else e(Function.createDelegate(this,(function(e){if("succeeded"==e.status){var r=e.value;t(r)}this._areAllCallsCompleted(n)&&this._onAsyncCallsCompleted&&(this._onAsyncCallsCompleted(),this._onAsyncCallsCompleted=null)})))},e.prototype._processOfficeThemeData=function(e){this._changeOfficeThemeData(e),this._isPublicThemeManager?this._eventTarget.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null):this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null)},e.prototype._processDocumentThemeData=function(e){this._changeDocumentThemeData(e),this._isPublicThemeManager?this._eventTarget.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null):this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null)},e.prototype._areAllCallsCompleted=function(e){var t;if(!(t=this._asyncCallsCompleted))return!0;for(var n in e&&t.hasOwnProperty(e)&&(t[e]=!0),t)if(!t.hasOwnProperty(n)||!t[n])return!1;return!0},e}();OSF.DDA.Theming.InternalThemeHandler=OSF_DDA_Theming_InternalThemeHandler;var parameterMap=OSF.DDA.SafeArray.Delegate.ParameterMap;parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetOfficeThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,value:parameterMap.self}],isComplexType:!0});var destKeys=OSF.DDA.Theming.DocumentThemeEnum;parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.DocumentTheme,fromHost:[{name:destKeys.PrimaryBackgroundColor,value:0},{name:destKeys.PrimaryFontColor,value:1},{name:destKeys.SecondaryBackgroundColor,value:2},{name:destKeys.SecondaryFontColor,value:3},{name:destKeys.Accent1,value:4},{name:destKeys.Accent2,value:5},{name:destKeys.Accent3,value:6},{name:destKeys.Accent4,value:7},{name:destKeys.Accent5,value:8},{name:destKeys.Accent6,value:9},{name:destKeys.Hyperlink,value:10},{name:destKeys.FollowedHyperlink,value:11},{name:destKeys.HeaderLatinFont,value:12},{name:destKeys.HeaderEastAsianFont,value:13},{name:destKeys.HeaderScriptFont,value:14},{name:destKeys.HeaderLocalizedFont,value:15},{name:destKeys.BodyLatinFont,value:16},{name:destKeys.BodyEastAsianFont,value:17},{name:destKeys.BodyScriptFont,value:18},{name:destKeys.BodyLocalizedFont,value:19}],isComplexType:!0}),destKeys=OSF.DDA.Theming.OfficeThemeEnum,parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.OfficeTheme,fromHost:[{name:destKeys.BodyForegroundColor,value:0},{name:destKeys.BodyBackgroundColor,value:1},{name:destKeys.ControlForegroundColor,value:2},{name:destKeys.ControlBackgroundColor,value:3}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}],isComplexType:!0}),Microsoft.Office.WebExtension.BindingType={Table:"table",Text:"text",Matrix:"matrix"},OSF.DDA.BindingProperties={Id:"BindingId",Type:Microsoft.Office.WebExtension.Parameters.BindingType},OSF.OUtil.augmentList(OSF.DDA.ListDescriptors,{BindingList:"BindingList"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{Subset:"subset",BindingProperties:"BindingProperties"}),OSF.DDA.ListType.setListType(OSF.DDA.ListDescriptors.BindingList,OSF.DDA.PropertyDescriptors.BindingProperties),OSF.DDA.BindingPromise=function(e,t){this._id=e,OSF.OUtil.defineEnumerableProperty(this,"onFail",{get:function(){return t},set:function(e){var n=typeof e;if("undefined"!=n&&"function"!=n)throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,n);t=e}})},OSF.DDA.BindingPromise.prototype={_fetch:function(e){if(this.binding)e&&e(this.binding);else if(!this._binding){var t=this;Microsoft.Office.WebExtension.context.document.bindings.getByIdAsync(this._id,(function(n){n.status==Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded?(OSF.OUtil.defineEnumerableProperty(t,"binding",{value:n.value}),e&&e(t.binding)):t.onFail&&t.onFail(n)}))}return this},getDataAsync:function(){var e=arguments;return this._fetch((function(t){t.getDataAsync.apply(t,e)})),this},setDataAsync:function(){var e=arguments;return this._fetch((function(t){t.setDataAsync.apply(t,e)})),this},addHandlerAsync:function(){var e=arguments;return this._fetch((function(t){t.addHandlerAsync.apply(t,e)})),this},removeHandlerAsync:function(){var e=arguments;return this._fetch((function(t){t.removeHandlerAsync.apply(t,e)})),this}},OSF.DDA.BindingFacade=function(e){this._eventDispatches=[],OSF.OUtil.defineEnumerableProperty(this,"document",{value:e});var t=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[t.AddFromSelectionAsync,t.AddFromNamedItemAsync,t.GetAllAsync,t.GetByIdAsync,t.ReleaseByIdAsync])},OSF.DDA.UnknownBinding=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{document:{value:t},id:{value:e}})},OSF.DDA.Binding=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{document:{value:t},id:{value:e}});var n=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[n.GetDataAsync,n.SetDataAsync]);var r=Microsoft.Office.WebExtension.EventType,o=t.bindings._eventDispatches;o[e]||(o[e]=new OSF.EventDispatch([r.BindingSelectionChanged,r.BindingDataChanged]));var i=o[e];OSF.DDA.DispIdHost.addEventSupport(this,i)},OSF.DDA.generateBindingId=function(){return"UnnamedBinding_"+OSF.OUtil.getUniqueId()+"_"+(new Date).getTime()},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureBinding=function(e,t){var n,r=e[OSF.DDA.BindingProperties.Id],o=e[OSF.DDA.BindingProperties.RowCount],i=e[OSF.DDA.BindingProperties.ColumnCount],a=e[OSF.DDA.BindingProperties.HasHeaders];switch(e[OSF.DDA.BindingProperties.Type]){case Microsoft.Office.WebExtension.BindingType.Text:n=new OSF.DDA.TextBinding(r,t);break;case Microsoft.Office.WebExtension.BindingType.Matrix:n=new OSF.DDA.MatrixBinding(r,t,o,i);break;case Microsoft.Office.WebExtension.BindingType.Table:n=new(function(){return OSF.DDA.ExcelDocument&&Microsoft.Office.WebExtension.context.document&&Microsoft.Office.WebExtension.context.document instanceof OSF.DDA.ExcelDocument}()&&OSF.DDA.ExcelTableBinding?OSF.DDA.ExcelTableBinding:OSF.DDA.TableBinding)(r,t,o,i,a);break;default:n=new OSF.DDA.UnknownBinding(r,t)}return n},OSF.DDA.AsyncMethodNames.addNames({AddFromSelectionAsync:"addFromSelectionAsync",AddFromNamedItemAsync:"addFromNamedItemAsync",GetAllAsync:"getAllAsync",GetByIdAsync:"getByIdAsync",ReleaseByIdAsync:"releaseByIdAsync",GetDataAsync:"getDataAsync",SetDataAsync:"setDataAsync"}),function(){function e(e){return OSF.DDA.OMFactory.manufactureBinding(e,Microsoft.Office.WebExtension.context.document)}function t(e){return e.id}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromSelectionAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.BindingType,enum:Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromNamedItemAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.ItemName,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.BindingType,enum:Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.FailOnCollision,value:function(){return!0}}],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAllAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(t){return OSF.OUtil.mapList(t[OSF.DDA.ListDescriptors.BindingList],e)}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=n[Microsoft.Office.WebExtension.Parameters.Id];delete t._eventDispatches[r]}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e,t){return OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)}}},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{enum:Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{enum:Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(e,t,n){if(0==e[Microsoft.Office.WebExtension.Parameters.StartRow]&&0==e[Microsoft.Office.WebExtension.Parameters.StartColumn]&&0==e[Microsoft.Office.WebExtension.Parameters.RowCount]&&0==e[Microsoft.Office.WebExtension.Parameters.ColumnCount]&&(delete e[Microsoft.Office.WebExtension.Parameters.StartRow],delete e[Microsoft.Office.WebExtension.Parameters.StartColumn],delete e[Microsoft.Office.WebExtension.Parameters.RowCount],delete e[Microsoft.Office.WebExtension.Parameters.ColumnCount]),e[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)&&(e[Microsoft.Office.WebExtension.Parameters.StartRow]||e[Microsoft.Office.WebExtension.Parameters.StartColumn]||e[Microsoft.Office.WebExtension.Parameters.RowCount]||e[Microsoft.Office.WebExtension.Parameters.ColumnCount]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return e},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:t}],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return OSF.DDA.TableDataProperties&&r&&(void 0!=r[OSF.DDA.TableDataProperties.TableRows]||void 0!=r[OSF.DDA.TableDataProperties.TableHeaders])&&(r=OSF.DDA.OMFactory.manufactureTableData(r)),void 0==(r=OSF.DDA.DataCoercion.coerceData(r,n[Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(e,t,n){if(0==e[Microsoft.Office.WebExtension.Parameters.StartRow]&&0==e[Microsoft.Office.WebExtension.Parameters.StartColumn]&&(delete e[Microsoft.Office.WebExtension.Parameters.StartRow],delete e[Microsoft.Office.WebExtension.Parameters.StartColumn]),e[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)&&(e[Microsoft.Office.WebExtension.Parameters.StartRow]||e[Microsoft.Office.WebExtension.Parameters.StartColumn]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return e},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:t}]})}(),OSF.OUtil.augmentList(OSF.DDA.BindingProperties,{RowCount:"BindingRowCount",ColumnCount:"BindingColumnCount",HasHeaders:"HasHeaders"}),OSF.DDA.MatrixBinding=function(e,t,n,r){OSF.DDA.MatrixBinding.uber.constructor.call(this,e,t),OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.BindingType.Matrix},rowCount:{value:n||0},columnCount:{value:r||0}})},OSF.OUtil.extend(OSF.DDA.MatrixBinding,OSF.DDA.Binding),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.BindingProperties,fromHost:[{name:OSF.DDA.BindingProperties.Id,value:0},{name:OSF.DDA.BindingProperties.Type,value:1},{name:OSF.DDA.SafeArray.UniqueArguments.BindingSpecificData,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.BindingType,toHost:[{name:Microsoft.Office.WebExtension.BindingType.Text,value:0},{name:Microsoft.Office.WebExtension.BindingType.Matrix,value:1},{name:Microsoft.Office.WebExtension.BindingType.Table,value:2}],invertible:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddBindingFromSelectionMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.BindingType,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddBindingFromNamedItemMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.ItemName,value:0},{name:Microsoft.Office.WebExtension.Parameters.Id,value:1},{name:Microsoft.Office.WebExtension.Parameters.BindingType,value:2},{name:Microsoft.Office.WebExtension.Parameters.FailOnCollision,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseBindingMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetBindingMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAllBindingsMethod,fromHost:[{name:OSF.DDA.ListDescriptors.BindingList,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetBindingDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:1},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:2},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:3},{name:OSF.DDA.PropertyDescriptors.Subset,value:4}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetBindingDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:1},{name:Microsoft.Office.WebExtension.Parameters.Data,value:2},{name:OSF.DDA.SafeArray.UniqueArguments.Offset,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.SafeArray.UniqueArguments.BindingSpecificData,fromHost:[{name:OSF.DDA.BindingProperties.RowCount,value:0},{name:OSF.DDA.BindingProperties.ColumnCount,value:1},{name:OSF.DDA.BindingProperties.HasHeaders,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.Subset,toHost:[{name:OSF.DDA.SafeArray.UniqueArguments.Offset,value:0},{name:OSF.DDA.SafeArray.UniqueArguments.Run,value:1}],canonical:!0,isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.SafeArray.UniqueArguments.Offset,toHost:[{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:0},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:1}],canonical:!0,isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.SafeArray.UniqueArguments.Run,toHost:[{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:0},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:1}],canonical:!0,isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddRowsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddColumnsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidClearAllRowsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{TableDataProperties:"TableDataProperties"}),OSF.OUtil.augmentList(OSF.DDA.BindingProperties,{RowCount:"BindingRowCount",ColumnCount:"BindingColumnCount",HasHeaders:"HasHeaders"}),OSF.DDA.TableDataProperties={TableRows:"TableRows",TableHeaders:"TableHeaders"},OSF.DDA.TableBinding=function(e,t,n,r,o){OSF.DDA.TableBinding.uber.constructor.call(this,e,t),OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.BindingType.Table},rowCount:{value:n||0},columnCount:{value:r||0},hasHeaders:{value:o||!1}});var i=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[i.AddRowsAsync,i.AddColumnsAsync,i.DeleteAllDataValuesAsync])},OSF.OUtil.extend(OSF.DDA.TableBinding,OSF.DDA.Binding),OSF.DDA.AsyncMethodNames.addNames({AddRowsAsync:"addRowsAsync",AddColumnsAsync:"addColumnsAsync",DeleteAllDataValuesAsync:"deleteAllDataValuesAsync"}),function(){function e(e){return e.id}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddRowsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddColumnsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.DeleteAllDataValuesAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]})}(),OSF.DDA.TextBinding=function(e,t){OSF.DDA.TextBinding.uber.constructor.call(this,e,t),OSF.OUtil.defineEnumerableProperty(this,"type",{value:Microsoft.Office.WebExtension.BindingType.Text})},OSF.OUtil.extend(OSF.DDA.TextBinding,OSF.DDA.Binding),OSF.DDA.AsyncMethodNames.addNames({AddFromPromptAsync:"addFromPromptAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromPromptAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.BindingType,enum:Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.PromptText,value:{types:["string"],calculate:function(){return Strings.OfficeOM.L_AddBindingFromPromptDefaultText}}},{name:Microsoft.Office.WebExtension.Parameters.SampleData,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[],onSucceeded:function(e){return OSF.DDA.OMFactory.manufactureBinding(e,Microsoft.Office.WebExtension.context.document)}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidAddBindingFromPromptMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.BindingType,value:1},{name:Microsoft.Office.WebExtension.Parameters.PromptText,value:2}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DocumentSelectionChanged:"documentSelectionChanged"}),OSF.DDA.DocumentSelectionChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged},document:{value:e}})},OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDeleted:"objectDeleted"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectSelectionChanged:"objectSelectionChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDataChanged:"objectDataChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ContentControlAdded:"contentControlAdded"}),OSF.DDA.ObjectEventArgs=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{type:{value:e},object:{value:t}})},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentSelectionChangedEvent}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDeletedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDataChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidContentControlAddedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{BindingSelectionChanged:"bindingSelectionChanged",BindingDataChanged:"bindingDataChanged"}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{BindingSelectionChangedEvent:"BindingSelectionChangedEvent"}),OSF.DDA.BindingSelectionChangedEventArgs=function(e,t){for(var n in OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.BindingSelectionChanged},binding:{value:e}}),t)OSF.OUtil.defineEnumerableProperty(this,n,{value:t[n]})},OSF.DDA.BindingDataChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.BindingDataChanged},binding:{value:e}})},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.BindingSelectionChangedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:0},{name:OSF.DDA.PropertyDescriptors.Subset,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidBindingSelectionChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.BindingSelectionChangedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidBindingDataChangedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.BindingProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.FilterType,{OnlyVisible:"onlyVisible"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FilterType,toHost:[{name:Microsoft.Office.WebExtension.FilterType.OnlyVisible,value:1}]}),Microsoft.Office.WebExtension.GoToType={Binding:"binding",NamedItem:"namedItem",Slide:"slide",Index:"index"},Microsoft.Office.WebExtension.SelectionMode={Default:"default",Selected:"selected",None:"none"},Microsoft.Office.WebExtension.Index={First:"first",Last:"last",Next:"next",Previous:"previous"},OSF.DDA.AsyncMethodNames.addNames({GoToByIdAsync:"goToByIdAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GoToByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string","number"]},{name:Microsoft.Office.WebExtension.Parameters.GoToType,enum:Microsoft.Office.WebExtension.GoToType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:{enum:Microsoft.Office.WebExtension.SelectionMode,defaultValue:Microsoft.Office.WebExtension.SelectionMode.Default}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.GoToType,toHost:[{name:Microsoft.Office.WebExtension.GoToType.Binding,value:0},{name:Microsoft.Office.WebExtension.GoToType.NamedItem,value:1},{name:Microsoft.Office.WebExtension.GoToType.Slide,value:2},{name:Microsoft.Office.WebExtension.GoToType.Index,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.SelectionMode,toHost:[{name:Microsoft.Office.WebExtension.SelectionMode.Default,value:0},{name:Microsoft.Office.WebExtension.SelectionMode.Selected,value:1},{name:Microsoft.Office.WebExtension.SelectionMode.None,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidNavigateToMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.GoToType,value:1},{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:2}]}),OSF.DDA.AsyncMethodNames.addNames({ExecuteRichApiRequestAsync:"executeRichApiRequestAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[]}),OSF.OUtil.setNamespace("RichApi",OSF.DDA),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteRichApiRequestMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{RichApiMessage:"richApiMessage"}),OSF.DDA.RichApiMessageEventArgs=function(e,t){var n=t[Microsoft.Office.WebExtension.Parameters.Data],r=[];if(n)for(var o=0;o<n.length;o++){var i=n[o];i.toArray&&(i=i.toArray()),r.push({messageCategory:i[0],messageType:i[1],targetId:i[2],message:i[3],id:i[4],isRemoteOverride:i[5]})}OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.RichApiMessage},entries:{value:r}})},function(e){var t=function(){function e(){this._eventDispatch=null,this._registerHandlers=[],this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.RichApiMessage]),OSF.DDA.DispIdHost.addEventSupport(this,this._eventDispatch)}return e.prototype.register=function(e){var t=this;return this._registerWithHostPromise||(this._registerWithHostPromise=new Office.Promise((function(e,n){t.addHandlerAsync(Microsoft.Office.WebExtension.EventType.RichApiMessage,(function(e){t._registerHandlers.forEach((function(t){t&&t(e)}))}),(function(t){"failed"==t.status?n(t.error):e()}))}))),this._registerWithHostPromise.then((function(){t._registerHandlers.push(e)}))},e}();e.RichApiMessageManager=t}(OfficeExt||(OfficeExt={})),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidRichApiMessageEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),Microsoft.Office.WebExtension.FileType={Text:"text",Compressed:"compressed",Pdf:"pdf"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FileProperties:"FileProperties",FileSliceProperties:"FileSliceProperties"}),OSF.DDA.FileProperties={Handle:"FileHandle",FileSize:"FileSize",SliceSize:Microsoft.Office.WebExtension.Parameters.SliceSize},OSF.DDA.File=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{size:{value:t},sliceCount:{value:Math.ceil(t/n)}});var r={};r[OSF.DDA.FileProperties.Handle]=e,r[OSF.DDA.FileProperties.SliceSize]=n;var o=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[o.GetDocumentCopyChunkAsync,o.ReleaseDocumentCopyAsync],r)},OSF.DDA.FileSliceOffset="fileSliceoffset",OSF.DDA.AsyncMethodNames.addNames({GetDocumentCopyAsync:"getFileAsync",GetDocumentCopyChunkAsync:"getSliceAsync",ReleaseDocumentCopyAsync:"closeAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.FileType,enum:Microsoft.Office.WebExtension.FileType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SliceSize,value:{types:["number"],defaultValue:4194304}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceSize];if(r<=0||r>4194304)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize;return e},onSucceeded:function(e,t,n){return new OSF.DDA.File(e[OSF.DDA.FileProperties.Handle],e[OSF.DDA.FileProperties.FileSize],n[Microsoft.Office.WebExtension.Parameters.SliceSize])}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyChunkAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.SliceIndex,types:["number"]}],privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}},{name:OSF.DDA.FileProperties.SliceSize,value:function(e,t){return t[OSF.DDA.FileProperties.SliceSize]}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceIndex];if(r<0||r>=t.sliceCount)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange;return e[OSF.DDA.FileSliceOffset]=parseInt((r*n[OSF.DDA.FileProperties.SliceSize]).toString()),e},onSucceeded:function(e,t,n){var r={};return OSF.OUtil.defineEnumerableProperties(r,{data:{value:e[Microsoft.Office.WebExtension.Parameters.Data]},index:{value:n[Microsoft.Office.WebExtension.Parameters.SliceIndex]},size:{value:e[OSF.DDA.FileProperties.SliceSize]}}),r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseDocumentCopyAsync,privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileProperties,fromHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileProperties.FileSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileSliceProperties,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0},{name:OSF.DDA.FileProperties.SliceSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FileType,toHost:[{name:Microsoft.Office.WebExtension.FileType.Text,value:0},{name:Microsoft.Office.WebExtension.FileType.Compressed,value:5},{name:Microsoft.Office.WebExtension.FileType.Pdf,value:6}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.FileType,value:0}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyChunkMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileSliceOffset,value:1},{name:OSF.DDA.FileProperties.SliceSize,value:2}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileSliceProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseDocumentCopyMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0}]}),OSF.DDA.FilePropertiesDescriptor={Url:"Url"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FilePropertiesDescriptor:"FilePropertiesDescriptor"}),Microsoft.Office.WebExtension.FileProperties=function(e){OSF.OUtil.defineEnumerableProperties(this,{url:{value:e[OSF.DDA.FilePropertiesDescriptor.Url]}})},OSF.DDA.AsyncMethodNames.addNames({GetFilePropertiesAsync:"getFilePropertiesAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:0}],requiredArguments:[],supportedOptions:[],onSucceeded:function(e,t,n){return new Microsoft.Office.WebExtension.FileProperties(e)}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,fromHost:[{name:OSF.DDA.FilePropertiesDescriptor.Url,value:0}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetFilePropertiesMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.ExcelTableBinding=function(e,t,n,r,o){var i=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[i.ClearFormatsAsync,i.SetTableOptionsAsync,i.SetFormatsAsync]),OSF.DDA.ExcelTableBinding.uber.constructor.call(this,e,t,n,r,o),OSF.OUtil.finalizeProperties(this)},OSF.OUtil.extend(OSF.DDA.ExcelTableBinding,OSF.DDA.TableBinding),function(){OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:{types:["object"],defaultValue:[]}},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:{types:["object"],defaultValue:[]}}],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:{types:["object"],defaultValue:[]}},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:{types:["object"],defaultValue:[]}}],checkCallArgs:function(e,t,n){var r=Microsoft.Office.WebExtension.Parameters;if(0==e[r.StartRow]&&0==e[r.StartColumn]&&OSF.OUtil.isArray(e[r.CellFormat])&&0===e[r.CellFormat].length&&OSF.OUtil.isArray(e[r.TableOptions])&&0===e[r.TableOptions].length&&(delete e[r.StartRow],delete e[r.StartColumn],delete e[r.CellFormat],delete e[r.TableOptions]),e[r.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)&&(e[r.StartRow]&&0!=e[r.StartRow]||e[r.StartColumn]&&0!=e[r.StartColumn]||e[r.CellFormat]||e[r.TableOptions]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return e},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:function(e){return e.id}}]}),OSF.DDA.BindingPromise.prototype.setTableOptionsAsync=function(){var e=arguments;return this._fetch((function(t){t.setTableOptionsAsync.apply(t,e)})),this},OSF.DDA.BindingPromise.prototype.setFormatsAsync=function(){var e=arguments;return this._fetch((function(t){t.setFormatsAsync.apply(t,e)})),this},OSF.DDA.BindingPromise.prototype.clearFormatsAsync=function(){var e=arguments;return this._fetch((function(t){t.clearFormatsAsync.apply(t,e)})),this}}(),function(){function e(e){return e.id}OSF.DDA.AsyncMethodNames.addNames({ClearFormatsAsync:"clearFormatsAsync",SetTableOptionsAsync:"setTableOptionsAsync",SetFormatsAsync:"setFormatsAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ClearFormatsAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetTableOptionsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.TableOptions,defaultValue:[]}],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetFormatsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.CellFormat,defaultValue:[]}],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]})}(),Microsoft.Office.WebExtension.Table={All:0,Data:1,Headers:2},function(){OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidClearFormatsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetTableOptionsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetFormatsMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:1}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetSelectedDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:2},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetBindingDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:1},{name:Microsoft.Office.WebExtension.Parameters.Data,value:2},{name:OSF.DDA.SafeArray.UniqueArguments.Offset,value:3},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:4},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:5}]});var e={headerRow:0,bandedRows:1,firstColumn:2,lastColumn:3,bandedColumns:4,filterButton:5,style:6,totalRow:7},t={row:0,column:1},n={alignHorizontal:{text:"alignHorizontal",type:1},alignVertical:{text:"alignVertical",type:2},backgroundColor:{text:"backgroundColor",type:101},borderStyle:{text:"borderStyle",type:201},borderColor:{text:"borderColor",type:202},borderTopStyle:{text:"borderTopStyle",type:203},borderTopColor:{text:"borderTopColor",type:204},borderBottomStyle:{text:"borderBottomStyle",type:205},borderBottomColor:{text:"borderBottomColor",type:206},borderLeftStyle:{text:"borderLeftStyle",type:207},borderLeftColor:{text:"borderLeftColor",type:208},borderRightStyle:{text:"borderRightStyle",type:209},borderRightColor:{text:"borderRightColor",type:210},borderOutlineStyle:{text:"borderOutlineStyle",type:211},borderOutlineColor:{text:"borderOutlineColor",type:212},borderInlineStyle:{text:"borderInlineStyle",type:213},borderInlineColor:{text:"borderInlineColor",type:214},fontFamily:{text:"fontFamily",type:301},fontStyle:{text:"fontStyle",type:302},fontSize:{text:"fontSize",type:303},fontUnderlineStyle:{text:"fontUnderlineStyle",type:304},fontColor:{text:"fontColor",type:305},fontDirection:{text:"fontDirection",type:306},fontStrikethrough:{text:"fontStrikethrough",type:307},fontSuperscript:{text:"fontSuperscript",type:308},fontSubscript:{text:"fontSubscript",type:309},fontNormal:{text:"fontNormal",type:310},indentLeft:{text:"indentLeft",type:401},indentRight:{text:"indentRight",type:402},numberFormat:{text:"numberFormat",type:501},width:{text:"width",type:701},height:{text:"height",type:702},wrapping:{text:"wrapping",type:703}},r=[{name:"none",value:0},{name:"thin",value:1},{name:"medium",value:2},{name:"dashed",value:3},{name:"dotted",value:4},{name:"thick",value:5},{name:"double",value:6},{name:"hair",value:7},{name:"medium dashed",value:8},{name:"dash dot",value:9},{name:"medium dash dot",value:10},{name:"dash dot dot",value:11},{name:"medium dash dot dot",value:12},{name:"slant dash dot",value:13}],o=[{name:"none",value:0},{name:"black",value:1},{name:"blue",value:2},{name:"gray",value:3},{name:"green",value:4},{name:"orange",value:5},{name:"pink",value:6},{name:"purple",value:7},{name:"red",value:8},{name:"teal",value:9},{name:"turquoise",value:10},{name:"violet",value:11},{name:"white",value:12},{name:"yellow",value:13},{name:"automatic",value:14}],i=OSF.DDA.SafeArray.Delegate.ParameterMap;i.define({type:n.alignHorizontal.text,toHost:[{name:"general",value:0},{name:"left",value:1},{name:"center",value:2},{name:"right",value:3},{name:"fill",value:4},{name:"justify",value:5},{name:"center across selection",value:6},{name:"distributed",value:7}]}),i.define({type:n.alignVertical.text,toHost:[{name:"top",value:0},{name:"center",value:1},{name:"bottom",value:2},{name:"justify",value:3},{name:"distributed",value:4}]}),i.define({type:n.backgroundColor.text,toHost:o}),i.define({type:n.borderStyle.text,toHost:r}),i.define({type:n.borderColor.text,toHost:o}),i.define({type:n.borderTopStyle.text,toHost:r}),i.define({type:n.borderTopColor.text,toHost:o}),i.define({type:n.borderBottomStyle.text,toHost:r}),i.define({type:n.borderBottomColor.text,toHost:o}),i.define({type:n.borderLeftStyle.text,toHost:r}),i.define({type:n.borderLeftColor.text,toHost:o}),i.define({type:n.borderRightStyle.text,toHost:r}),i.define({type:n.borderRightColor.text,toHost:o}),i.define({type:n.borderOutlineStyle.text,toHost:r}),i.define({type:n.borderOutlineColor.text,toHost:o}),i.define({type:n.borderInlineStyle.text,toHost:r}),i.define({type:n.borderInlineColor.text,toHost:o}),i.define({type:n.fontStyle.text,toHost:[{name:"regular",value:0},{name:"italic",value:1},{name:"bold",value:2},{name:"bold italic",value:3}]}),i.define({type:n.fontUnderlineStyle.text,toHost:[{name:"none",value:0},{name:"single",value:1},{name:"double",value:2},{name:"single accounting",value:3},{name:"double accounting",value:4}]}),i.define({type:n.fontColor.text,toHost:o}),i.define({type:n.fontDirection.text,toHost:[{name:"context",value:0},{name:"left-to-right",value:1},{name:"right-to-left",value:2}]}),i.define({type:n.width.text,toHost:[{name:"auto fit",value:-1}]}),i.define({type:n.height.text,toHost:[{name:"auto fit",value:-1}]}),i.define({type:Microsoft.Office.WebExtension.Parameters.TableOptions,toHost:[{name:"headerRow",value:0},{name:"bandedRows",value:1},{name:"firstColumn",value:2},{name:"lastColumn",value:3},{name:"bandedColumns",value:4},{name:"filterButton",value:5},{name:"style",value:6},{name:"totalRow",value:7}]}),i.dynamicTypes[Microsoft.Office.WebExtension.Parameters.CellFormat]={toHost:function(e){for(var t in e)e[t].format&&(e[t].format=i.doMapValues(e[t].format,"toHost"));return e},fromHost:function(e){return e}},i.setDynamicType(Microsoft.Office.WebExtension.Parameters.CellFormat,{toHost:function(e){var r=[];for(var o in e){var i=e[o],a=[];if("undefined"!==typeof i.cells){var s,c=i.cells;if("object"===typeof i.cells)for(var l in s=[],c)"undefined"!==typeof t[l]&&(s[t[l]]=c[l]);else s=c;a[0]=s}if(i.format){var u=i.format,d=[];for(var f in u)"undefined"!==typeof n[f]&&d.push([n[f].type,u[f]]);a[1]=d}r[o]=a}return r},fromHost:function(e){return e}}),i.setDynamicType(Microsoft.Office.WebExtension.Parameters.TableOptions,{toHost:function(t){var n=[];for(var r in t)"undefined"!==typeof e[r]&&(n[e[r]]=t[r]);return n},fromHost:function(e){return e}})}(),function(e){!function(t){var n=function(){function n(){var e=this;this._pseudoDocument=null,this._eventDispatch=null,this._useAssociatedActionsOnly=null,this._processAppCommandInvocation=function(t){var n=e._verifyManifestCallback(t.callbackName);if(n.errorCode==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){var r=e._constructEventObjectForCallback(t);r?window.setTimeout((function(){n.callback(r)}),0):e._invokeAppCommandCompletedMethod(t.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,"")}else e._invokeAppCommandCompletedMethod(t.appCommandId,n.errorCode,"")}}return n.initializeOsfDda=function(){OSF.DDA.AsyncMethodNames.addNames({AppCommandInvocationCompletedAsync:"appCommandInvocationCompletedAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.Status,types:["number"]},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,types:["string"]}]}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{AppCommandInvokedEvent:"AppCommandInvokedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{AppCommandInvoked:"appCommandInvoked"}),OSF.OUtil.setNamespace("AppCommand",OSF.DDA),OSF.DDA.AppCommand.AppCommandInvokedEventArgs=e.AppCommand.AppCommandInvokedEventArgs},n.prototype.initializeAndChangeOnce=function(e){t.registerDdaFacade(),this._pseudoDocument={},OSF.DDA.DispIdHost.addAsyncMethods(this._pseudoDocument,[OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync]),this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.AppCommandInvoked]);OSF.DDA.DispIdHost.addEventSupport(this._pseudoDocument,this._eventDispatch),this._pseudoDocument.addHandlerAsync(Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this._processAppCommandInvocation,(function(t){e&&("succeeded"==t.status?e(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):e(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError))}))},n.prototype._verifyManifestCallback=function(e){var t={callback:null,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCallback};e=e.trim();try{var n=this._getCallbackFunc(e);if("function"!=typeof n)return t}catch(e){return t}return{callback:n,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess}},n.prototype._getUseAssociatedActionsOnly=function(){if(null==this._useAssociatedActionsOnly){this._useAssociatedActionsOnly=!1;try{!0===window.useAssociatedActionsOnly?this._useAssociatedActionsOnly=!0:this._useAssociatedActionsOnly=OSF._OfficeAppFactory.getLoadScriptHelper().getUseAssociatedActionsOnlyDefined()}catch(e){}}return this._useAssociatedActionsOnly},n.prototype._getCallbackFuncFromWindow=function(e){for(var t=e.split("."),n=window,r=0;r<t.length-1;r++){if(!n[t[r]]||"object"!=typeof n[t[r]]&&"function"!=typeof n[t[r]])return null;n=n[t[r]]}return n[t[t.length-1]]},n.prototype._getCallbackFuncFromActionAssociateTable=function(e){var t=e.toUpperCase();return Office.actions._association.mappings[t]},n.prototype._getCallbackFunc=function(e){var t=this,r=null,o=!1;if(this._getUseAssociatedActionsOnly()||(r=this._getCallbackFuncFromWindow(e)),r||(r=this._getCallbackFuncFromActionAssociateTable(e))&&(o=!0),!n.isTelemetrySubmitted){n.isTelemetrySubmitted=!0;try{if(OTel&&oteljs&&Microsoft.Office.WebExtension.sendTelemetryEvent){var i="Outlook"==OTel.OTelLogger.getHost()?.1:.2;Math.random()<i&&OTel.OTelLogger.onTelemetryLoaded((function(){var e=[oteljs.makeBooleanDataField("UseAction",!0===t._useAssociatedActionsOnly),oteljs.makeBooleanDataField("UseAssociateTable",o)];Microsoft.Office.WebExtension.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.AppCommandDefinition",dataFields:e,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage,diagnosticLevel:oteljs.DiagnosticLevel.NecessaryServiceDataEvent}})}))}}catch(e){}}return r},n.prototype._invokeAppCommandCompletedMethod=function(e,t,n){this._pseudoDocument.appCommandInvocationCompletedAsync(e,t,n)},n.prototype._constructEventObjectForCallback=function(e){var t=this,n=new o;try{var r=JSON.parse(e.eventObjStr);this._translateEventObjectInternal(r,n),Object.defineProperty(n,"completed",{value:function(r){n.completedContext=r;var o=JSON.stringify(n);t._invokeAppCommandCompletedMethod(e.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,o)},enumerable:!0})}catch(e){n=null}return n},n.prototype._translateEventObjectInternal=function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];"object"==typeof r&&null!=r?(OSF.OUtil.defineEnumerableProperty(t,n,{value:{}}),this._translateEventObjectInternal(r,t[n])):Object.defineProperty(t,n,{value:r,enumerable:!0,writable:!0})}},n.prototype._constructObjectByTemplate=function(e,t){var n={};if(!e||!t)return n;for(var r in e)if(e.hasOwnProperty(r)&&(n[r]=null,null!=t[r])){var o=e[r],i=t[r],a=typeof i;"object"==typeof o&&null!=o?n[r]=this._constructObjectByTemplate(o,i):"number"!=a&&"string"!=a&&"boolean"!=a||(n[r]=i)}return n},n.instance=function(){return null==n._instance&&(n._instance=new n),n._instance},n.isTelemetrySubmitted=!1,n._instance=null,n}();t.AppCommandManager=n;var r=function(){function e(e,t,n){this.type=Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this.appCommandId=e,this.callbackName=t,this.eventObjStr=n}return e.create=function(n){return new e(n[t.AppCommandInvokedEventEnums.AppCommandId],n[t.AppCommandInvokedEventEnums.CallbackName],n[t.AppCommandInvokedEventEnums.EventObjStr])},e}();t.AppCommandInvokedEventArgs=r;var o=function(){return function(){}}();t.AppCommandCallbackEventArgs=o,t.AppCommandInvokedEventEnums={AppCommandId:"appCommandId",CallbackName:"callbackName",EventObjStr:"eventObjStr"}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),OfficeExt.AppCommand.AppCommandManager.initializeOsfDda(),function(e){!function(t){t.registerDdaFacade=function(){if(OSF.DDA.SafeArray){var t=OSF.DDA.SafeArray.Delegate.ParameterMap;t.define({type:OSF.DDA.MethodDispId.dispidAppCommandInvocationCompletedMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Status,value:1},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,value:2}]}),t.define({type:OSF.DDA.EventDispId.dispidAppCommandInvokedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,value:t.self}],isComplexType:!0}),t.define({type:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,fromHost:[{name:e.AppCommand.AppCommandInvokedEventEnums.AppCommandId,value:0},{name:e.AppCommand.AppCommandInvokedEventEnums.CallbackName,value:1},{name:e.AppCommand.AppCommandInvokedEventEnums.EventObjStr,value:2}],isComplexType:!0})}}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Image:"image"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{XmlSvg:"xmlSvg"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Image,value:8},{name:Microsoft.Office.WebExtension.CoercionType.XmlSvg,value:9}]}),Microsoft.Office.WebExtension.AccountTypeFilter={NoFilter:"noFilter",AAD:"aad",MSA:"msa"},OSF.DDA.AsyncMethodNames.addNames({GetAccessTokenAsync:"getAccessTokenAsync"}),OSF.DDA.Auth=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAccessTokenAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:{types:["string"],defaultValue:""}},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.EnableNewHosts,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.AccountTypeFilter,value:{enum:Microsoft.Office.WebExtension.AccountTypeFilter,defaultValue:Microsoft.Office.WebExtension.AccountTypeFilter.NoFilter}}],checkCallArgs:function(e,t,n){var r,o=OSF._OfficeAppFactory.getInitializationHelper()._appContext;if(o&&o._wopiHostOriginForSingleSignOn){var i=OSF.OUtil.Guid.generateNewGuid();window.parent.parent.postMessage('{"MessageId":"AddinTrustedOrigin","AddinTrustId":"'+i+'"}',o._wopiHostOriginForSingleSignOn),e[Microsoft.Office.WebExtension.Parameters.AddinTrustId]=i}if(window.Office.context.requirements.isSetSupported("JsonPayloadSSO")){for(var a=((r={})[Microsoft.Office.WebExtension.Parameters.ForceConsent]=!1,r[Microsoft.Office.WebExtension.Parameters.ForceAddAccount]=!1,r[Microsoft.Office.WebExtension.Parameters.AuthChallenge]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.EnableNewHosts]=!0,r[Microsoft.Office.WebExtension.Parameters.AccountTypeFilter]=!0,r),s={},c=0,l=Object.keys(a);c<l.length;c++){var u=l[c];a[u]&&(s[u]=e[u]),delete e[u]}e[Microsoft.Office.WebExtension.Parameters.JsonPayload]=JSON.stringify(s)}return e},onSucceeded:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Data]}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAccessTokenMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.JsonPayload,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:1},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:2},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:3},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:4},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:5}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.AsyncMethodNames.addNames({GetNestedAppAuthContextAsync:"getAuthContextAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetNestedAppAuthContextAsync,requiredArguments:[],supportedOptions:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.JsonData];return{userObjectId:r.userObjectId||"",tenantId:r.tenantId||"",userPrincipalName:r.userPrincipalName||"",authorityType:r.authorityType||""}}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetNestedAppAuthContextMethod,toHost:[],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.JsonData,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.AsyncMethodNames.addNames({OpenBrowserWindow:"openBrowserWindow"}),OSF.DDA.OpenBrowser=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.OpenBrowserWindow,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Reserved,value:{types:["number"],defaultValue:0}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidOpenBrowserWindow,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Reserved,value:0},{name:Microsoft.Office.WebExtension.Parameters.Url,value:1}]}),OSF.DDA.AsyncMethodNames.addNames({ExecuteFeature:"executeFeatureAsync",QueryFeature:"queryFeatureAsync"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FeatureProperties:"FeatureProperties",TcidEnabled:"TcidEnabled",TcidVisible:"TcidVisible"}),OSF.DDA.ExecuteFeature=function(){},OSF.DDA.QueryFeature=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteFeature,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,types:["number"]}],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.QueryFeature,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,types:["number"]}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FeatureProperties,fromHost:[{name:OSF.DDA.PropertyDescriptors.TcidEnabled,value:0},{name:OSF.DDA.PropertyDescriptors.TcidVisible,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteFeature,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidQueryFeature,fromHost:[{name:OSF.DDA.PropertyDescriptors.FeatureProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,value:0}]}),function(e){!function(e){var t=function(){return function(e,t,n){this.id=e,this.payload=t,this.targetId=n}}();e.ExtensionMessage=t;var n=function(){function e(){this.onMessage=null}return e.prototype.sendMessage=function(e){OSF.Messaging&&OSF.Messaging.sendMessage&&OSF.Messaging.sendMessage(e)},e.prototype.registerOnMessageEventHandler=function(e){this.onMessage=e,OSF.Messaging&&OSF.Messaging.registerOnMessageEventHandler&&OSF.Messaging.registerOnMessageEventHandler(e)},e}();e.ExtensionCommunicationManager=n}(e.Messaging||(e.Messaging={}))}(OfficeExt||(OfficeExt={})),OSF.DDA.ExcelDocument=function(e,t){var n=new OSF.DDA.BindingFacade(this);OSF.DDA.DispIdHost.addAsyncMethods(n,[OSF.DDA.AsyncMethodNames.AddFromPromptAsync]),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GoToByIdAsync]),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync]),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync]),OSF.DDA.ExcelDocument.uber.constructor.call(this,e,n,t),OSF.OUtil.finalizeProperties(this)},OSF.OUtil.extend(OSF.DDA.ExcelDocument,OSF.DDA.JsomDocument),OSF.InitializationHelper.prototype.prepareRightAfterWebExtensionInitialize=function(e){e&&e.get_isDialog()||OfficeExt.AppCommand.AppCommandManager.instance().initializeAndChangeOnce();if(e&&e.get_featureGates){var t=e.get_featureGates();if(t&&t.EnableExcelAddInTheme)if(t.EnablePublicThemeManager)"undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.themeManager&&window.Office.context.themeManager.InitializeAndChangeOnce();else(new OSF.DDA.Theming.InternalThemeHandler).InitializeAndChangeOnce()}},OSF.InitializationHelper.prototype.loadAppSpecificScriptAndCreateOM=function(e,t,n){OSF.DDA.ErrorCodeManager.initializeErrorMessages(Strings.OfficeOM),e.doc=new OSF.DDA.ExcelDocument(e,this._initializeSettings(!0)),e.messaging=new OfficeExt.Messaging.ExtensionCommunicationManager,OSF.DDA.DispIdHost.addAsyncMethods(OSF.DDA.RichApi,[OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync]),e.get_isDialog()||(OSF.DDA.RichApi.richApiMessageManager=new OfficeExt.RichApiMessageManager),t()},function(){OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.CellFormat,value:{types:["number","object"],defaultValue:[]}},{name:Microsoft.Office.WebExtension.Parameters.TableOptions,value:{types:["number","object"],defaultValue:[]}},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:{types:["number","boolean"],defaultValue:!1}}],privateStateCallbacks:[]})}();var OfficeExtension;__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t;!function(e){e.OfficeRequire=function(){return null}()}(e._Internal||(e._Internal={})),function(e){!function(t){t.Init=function(){return function(){"use strict";function t(e){return"function"===typeof e}var n,r=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)},o=0,i=function(e,t){u[o]=e,u[o+1]=t,2===(o+=2)&&(n?n(d):l())};var a=("undefined"!==typeof window?window:void 0)||{},s=(a.MutationObserver||a.WebKitMutationObserver,"undefined"!==typeof process&&"[object process]"==={}.toString.call(process)),c="undefined"!==typeof Uint8ClampedArray&&"undefined"!==typeof importScripts&&"undefined"!==typeof MessageChannel;var l,u=new Array(1e3);function d(){for(var e=0;e<o;e+=2){(0,u[e])(u[e+1]),u[e]=void 0,u[e+1]=void 0}o=0}function f(){}l=s?function(){var e=process.nextTick,t=process.versions.node.match(/^(?:(\d+)\.)?(?:(\d+)\.)?(\*|\d+)$/);return Array.isArray(t)&&"0"===t[1]&&"10"===t[2]&&(e=window.setImmediate),function(){e(d)}}():c?function(){var e=new MessageChannel;return e.port1.onmessage=d,function(){e.port2.postMessage(0)}}():function(){return function(){setTimeout(d,1)}}();var p=new S;function h(e,n){if(n.constructor===e.constructor)!function(e,t){1===t._state?y(e,t._result):2===t._state?v(e,t._result):O(t,void 0,(function(t){m(e,t)}),(function(t){v(e,t)}))}(e,n);else{var r=function(e){try{return e.then}catch(e){return p.error=e,p}}(n);r===p?v(e,p.error):void 0===r?y(e,n):t(r)?function(e,t,n){i((function(e){var r=!1,o=function(e,t,n,r){try{e.call(t,n,r)}catch(e){return e}}(n,t,(function(n){r||(r=!0,t!==n?m(e,n):y(e,n))}),(function(t){r||(r=!0,v(e,t))}),e._label);!r&&o&&(r=!0,v(e,o))}),e)}(e,n,r):y(e,n)}}function m(e,t){e===t?v(e,function(){return new TypeError("You cannot resolve a promise with itself")}()):!function(e){return"function"===typeof e||"object"===typeof e&&null!==e}(t)?y(e,t):h(e,t)}function g(e){e._onerror&&e._onerror(e._result),b(e)}function y(e,t){void 0===e._state&&(e._result=t,e._state=1,0!==e._subscribers.length&&i(b,e))}function v(e,t){void 0===e._state&&(e._state=2,e._result=t,i(g,e))}function O(e,t,n,r){var o=e._subscribers,a=o.length;e._onerror=null,o[a]=t,o[a+1]=n,o[a+2]=r,0===a&&e._state&&i(b,e)}function b(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var r,o,i=e._result,a=0;a<t.length;a+=3)r=t[a],o=t[a+n],r?_(n,r,o,i):o(i);e._subscribers.length=0}}function S(){this.error=null}var C=new S;function _(e,n,r,o){var i,a,s,c,l=t(r);if(l){if((i=function(e,t){try{return e(t)}catch(e){return C.error=e,C}}(r,o))===C?(c=!0,a=i.error,i=null):s=!0,n===i)return void v(n,function(){return new TypeError("A promises callback cannot return that same promise.")}())}else i=o,s=!0;void 0!==n._state||(l&&s?m(n,i):c?v(n,a):1===e?y(n,i):2===e&&v(n,i))}function A(e,t){this._instanceConstructor=e,this.promise=new e(f),this._validateInput(t)?(this._input=t,this.length=t.length,this._remaining=t.length,this._init(),0===this.length?y(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&y(this.promise,this._result))):v(this.promise,this._validationError())}A.prototype._validateInput=function(e){return r(e)},A.prototype._validationError=function(){return new e.Error("Array Methods must be provided an Array")},A.prototype._init=function(){this._result=new Array(this.length)};var D=A;A.prototype._enumerate=function(){for(var e=this.length,t=this.promise,n=this._input,r=0;void 0===t._state&&r<e;r++)this._eachEntry(n[r],r)},A.prototype._eachEntry=function(e,t){var n=this._instanceConstructor;!function(e){return"object"===typeof e&&null!==e}(e)?(this._remaining--,this._result[t]=e):e.constructor===n&&void 0!==e._state?(e._onerror=null,this._settledAt(e._state,t,e._result)):this._willSettleAt(n.resolve(e),t)},A.prototype._settledAt=function(e,t,n){var r=this.promise;void 0===r._state&&(this._remaining--,2===e?v(r,n):this._result[t]=n),0===this._remaining&&y(r,this._result)},A.prototype._willSettleAt=function(e,t){var n=this;O(e,void 0,(function(e){n._settledAt(1,t,e)}),(function(e){n._settledAt(2,t,e)}))};var E=function(e){return new D(this,e).promise};var F=function(e){var t=new this(f);if(!r(e))return v(t,new TypeError("You must pass an array to race.")),t;var n=e.length;function o(e){m(t,e)}function i(e){v(t,e)}for(var a=0;void 0===t._state&&a<n;a++)O(this.resolve(e[a]),void 0,o,i);return t};var P=function(e){if(e&&"object"===typeof e&&e.constructor===this)return e;var t=new this(f);return m(t,e),t};var R=function(e){var t=new this(f);return v(t,e),t},I=0;var x=T;function T(e){this._id=I++,this._state=void 0,this._result=void 0,this._subscribers=[],f!==e&&(t(e)||function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof T||function(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}(),function(e,t){try{t((function(t){m(e,t)}),(function(t){v(e,t)}))}catch(t){v(e,t)}}(this,e))}return T.all=E,T.race=F,T.resolve=P,T.reject=R,T._setScheduler=function(e){n=e},T._setAsap=function(e){i=e},T._asap=i,T.prototype={constructor:T,then:function(e,t){var n=this,r=n._state;if(1===r&&!e||2===r&&!t)return this;var o=new this.constructor(f),a=n._result;if(r){var s=arguments[r-1];i((function(){_(r,o,s,a)}))}else O(n,o,e,t);return o},catch:function(e){return this.then(null,e)}},x}.call(this)}}(e.PromiseImpl||(e.PromiseImpl={}))}(e._Internal||(e._Internal={})),function(e){e.OfficePromise=function(){return"undefined"===typeof window&&"function"===typeof Promise?Promise:"undefined"!==typeof window&&window.Promise?function(){var e=window.navigator.userAgent,t=e.indexOf("Edge/");return t>=0&&(e=e.substring(t+5,e.length))<"14.14393"}()?e.PromiseImpl.Init():window.Promise:e.PromiseImpl.Init()}()}(t=e._Internal||(e._Internal={}));var n=t.OfficePromise;e.Promise=n}(OfficeExtension||(OfficeExtension={})),function(e){var t=function(){function e(){}return e.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},e.prototype._createRequestExecutorOrNull=function(){return null},e.prototype.getEventRegistration=function(e){return null},e}();e.SessionBase=t;var n=function(){function e(){}return e.setCustomSendRequestFunc=function(t){e.s_customSendRequestFunc=t},e.xhrSendRequestFunc=function(e){return l.createPromise((function(t,n){var o=new XMLHttpRequest;if(o.open(e.method,e.url),o.onload=function(){var e={statusCode:o.status,headers:l._parseHttpResponseHeaders(o.getAllResponseHeaders()),body:o.responseText};t(e)},o.onerror=function(){n(new r.RuntimeError({code:i.connectionFailure,httpStatusCode:o.status,message:l._getResourceString(a.connectionFailureWithStatus,o.statusText)}))},e.headers)for(var s in e.headers)o.setRequestHeader(s,e.headers[s]);o.send(l._getRequestBodyText(e))}))},e.fetchSendRequestFunc=function(e){var t=l._getRequestBodyText(e);return""===t&&(t=void 0),fetch(e.url,{method:e.method,headers:e.headers,body:t}).then((function(e){return e.text().then((function(t){var n=e.status,r={};return e.headers.forEach((function(e,t){r[t]=e})),{statusCode:n,headers:r,body:t}}))}))},e.sendRequest=function(t){e.validateAndNormalizeRequest(t);var n=e.s_customSendRequestFunc;return n||(n="undefined"!==typeof fetch?e.fetchSendRequestFunc:e.xhrSendRequestFunc),n(t)},e.setCustomSendLocalDocumentRequestFunc=function(t){e.s_customSendLocalDocumentRequestFunc=t},e.sendLocalDocumentRequest=function(t){return e.validateAndNormalizeRequest(t),(e.s_customSendLocalDocumentRequestFunc||e.officeJsSendLocalDocumentRequestFunc)(t)},e.officeJsSendLocalDocumentRequestFunc=function(e){e=l._validateLocalDocumentRequest(e);var t=l._buildRequestMessageSafeArray(e);return l.createPromise((function(e,n){OSF.DDA.RichApi.executeRichApiRequestAsync(t,(function(t){var n;n="succeeded"==t.status?{statusCode:c.getResponseStatusCode(t),headers:c.getResponseHeaders(t),body:c.getResponseBody(t)}:c.buildHttpResponseFromOfficeJsError(t.error.code,t.error.message),l.log("Response:"),l.log(JSON.stringify(n)),e(n)}))}))},e.validateAndNormalizeRequest=function(e){if(l.isNullOrUndefined(e))throw r.RuntimeError._createInvalidArgError({argumentName:"request"});l.isNullOrEmptyString(e.method)&&(e.method="GET"),e.method=e.method.toUpperCase();var t=!1;if("object"===typeof e.headers&&e.headers[s.testRequestNameHeader]&&(t=!0),!t){var n=u._getCurrentTestNameWithSequenceId();n&&(e.headers||(e.headers={}),e.headers[s.testRequestNameHeader]=n)}},e.logRequest=function(t){if(l._logEnabled){if(l.log("---HTTP Request---"),l.log(t.method+" "+t.url),t.headers)for(var n in t.headers)l.log(n+": "+t.headers[n]);e._logBodyEnabled&&l.log(l._getRequestBodyText(t))}},e.logResponse=function(t){if(l._logEnabled){if(l.log("---HTTP Response---"),l.log(""+t.statusCode),t.headers)for(var n in t.headers)l.log(n+": "+t.headers[n]);e._logBodyEnabled&&l.log(t.body)}},e._logBodyEnabled=!1,e}();e.HttpUtility=n;var r,o=function(){function e(e){var t=this;this.m_bridge=e,this.m_promiseResolver={},this.m_handlers=[],this.m_bridge.onMessageFromHost=function(e){var n=JSON.parse(e);if(3==n.type){var r=n.message;if(r&&r.entries)for(var o=0;o<r.entries.length;o++){var i=r.entries[o];if(Array.isArray(i)){var a={messageCategory:i[0],messageType:i[1],targetId:i[2],message:i[3],id:i[4]};r.entries[o]=a}}}t.dispatchMessage(n)}}return e.init=function(t){if("object"===typeof t&&t){var r=new e(t);e.s_instance=r,n.setCustomSendLocalDocumentRequestFunc((function(t){t=l._validateLocalDocumentRequest(t);var n=0;l.isReadonlyRestRequest(t.method)||(n=1);var o=t.url.indexOf("?");if(o>=0){var i=t.url.substr(o+1),a=l._parseRequestFlagsAndCustomDataFromQueryStringIfAny(i);a.flags>=0&&(n=a.flags)}"string"===typeof t.body&&(t.body=JSON.parse(t.body));var s={id:e.nextId(),type:1,flags:n,message:t};return r.sendMessageToHostAndExpectResponse(s).then((function(e){return e.message}))}));for(var o=0;o<e.s_onInitedHandlers.length;o++)e.s_onInitedHandlers[o](r)}},Object.defineProperty(e,"instance",{get:function(){return e.s_instance},enumerable:!0,configurable:!0}),e.prototype.sendMessageToHost=function(e){this.m_bridge.sendMessageToHost(JSON.stringify(e))},e.prototype.sendMessageToHostAndExpectResponse=function(e){var t=this,n=l.createPromise((function(n,r){t.m_promiseResolver[e.id]=n}));return this.m_bridge.sendMessageToHost(JSON.stringify(e)),n},e.prototype.addHostMessageHandler=function(e){this.m_handlers.push(e)},e.prototype.removeHostMessageHandler=function(e){var t=this.m_handlers.indexOf(e);t>=0&&this.m_handlers.splice(t,1)},e.onInited=function(t){e.s_onInitedHandlers.push(t),e.s_instance&&t(e.s_instance)},e.prototype.dispatchMessage=function(e){if("number"===typeof e.id){var t=this.m_promiseResolver[e.id];if(t)return t(e),void delete this.m_promiseResolver[e.id]}for(var n=0;n<this.m_handlers.length;n++)this.m_handlers[n](e)},e.nextId=function(){return e.s_nextId++},e.s_onInitedHandlers=[],e.s_nextId=1,e}();e.HostBridge=o,"object"===typeof _richApiNativeBridge&&_richApiNativeBridge&&o.init(_richApiNativeBridge),function(e){var t=function(t){function n(e){var r=t.call(this,"string"===typeof e?e:e.message)||this;if(Object.setPrototypeOf(r,n.prototype),r.name="RichApi.Error","string"===typeof e?r.message=e:(r.code=e.code,r.message=e.message,r.traceMessages=e.traceMessages||[],r.innerError=e.innerError||null,r.debugInfo=r._createDebugInfo(e.debugInfo||{}),r.httpStatusCode=e.httpStatusCode,r.data=e.data),l.isNullOrUndefined(r.httpStatusCode)||200===r.httpStatusCode){var o={};o[i.accessDenied]=401,o[i.connectionFailure]=500,o[i.generalException]=500,o[i.invalidArgument]=400,o[i.invalidObjectPath]=400,o[i.invalidOrTimedOutSession]=408,o[i.invalidRequestContext]=400,o[i.timeout]=408,o[i.valueNotLoaded]=400,r.httpStatusCode=o[r.code]}return l.isNullOrUndefined(r.httpStatusCode)&&(r.httpStatusCode=500),r}return __extends(n,t),n.prototype.toString=function(){return this.code+": "+this.message},n.prototype._createDebugInfo=function(t){var n={code:this.code,message:this.message,toString:function(){return JSON.stringify(this)}};for(var r in t)n[r]=t[r];return this.innerError&&(this.innerError instanceof e.RuntimeError?n.innerError=this.innerError.debugInfo:n.innerError=this.innerError),n},n._createInvalidArgError=function(t){return new e.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l.isNullOrEmptyString(t.argumentName)?l._getResourceString(a.invalidArgumentGeneric):l._getResourceString(a.invalidArgument,t.argumentName),debugInfo:t.errorLocation?{errorLocation:t.errorLocation}:{},innerError:t.innerError})},n}(Error);e.RuntimeError=t}(r=e._Internal||(e._Internal={})),e.Error=r.RuntimeError;var i=function(){function e(){}return e.apiNotFound="ApiNotFound",e.accessDenied="AccessDenied",e.generalException="GeneralException",e.activityLimitReached="ActivityLimitReached",e.invalidArgument="InvalidArgument",e.connectionFailure="ConnectionFailure",e.timeout="Timeout",e.invalidOrTimedOutSession="InvalidOrTimedOutSession",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e.requestPayloadSizeLimitExceeded="RequestPayloadSizeLimitExceeded",e.responsePayloadSizeLimitExceeded="ResponsePayloadSizeLimitExceeded",e.writeNotSupportedWhenModalDialogOpen="WriteNotSupportedWhenModalDialogOpen",e}();e.CoreErrorCodes=i;var a=function(){function e(){}return e.apiNotFoundDetails="ApiNotFoundDetails",e.connectionFailureWithStatus="ConnectionFailureWithStatus",e.connectionFailureWithDetails="ConnectionFailureWithDetails",e.invalidArgument="InvalidArgument",e.invalidArgumentGeneric="InvalidArgumentGeneric",e.timeout="Timeout",e.invalidOrTimedOutSessionMessage="InvalidOrTimedOutSessionMessage",e.invalidSheetName="InvalidSheetName",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e}();e.CoreResourceStrings=a;var s=function(){function e(){}return e.flags="flags",e.sourceLibHeader="SdkVersion",e.processQuery="ProcessQuery",e.localDocument="http://document.localhost/",e.localDocumentApiPrefix="http://document.localhost/_api/",e.customData="customdata",e.testRequestNameHeader="x-test-request-name",e}();e.CoreConstants=s;var c=function(){function e(){}return e.buildMessageArrayForIRequestExecutor=function(t,n,r,o){var i=JSON.stringify(r.Body);l.log("Request:"),l.log(i);var a={};return l._copyHeaders(r.Headers,a),a[s.sourceLibHeader]=o,e.buildRequestMessageSafeArray(t,n,"POST",s.processQuery,a,i)},e.buildResponseOnSuccess=function(e,t){var n={HttpStatusCode:200,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return n.Body=JSON.parse(e),n.Headers=t,n},e.buildResponseOnError=function(t,n){var r={HttpStatusCode:500,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return r.ErrorCode=i.generalException,r.ErrorMessage=n,t==e.OfficeJsErrorCode_ooeNoCapability?(r.ErrorCode=i.accessDenied,r.HttpStatusCode=401):t==e.OfficeJsErrorCode_ooeActivityLimitReached?(r.ErrorCode=i.activityLimitReached,r.HttpStatusCode=429):t==e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession?(r.ErrorCode=i.invalidOrTimedOutSession,r.HttpStatusCode=408,r.ErrorMessage=l._getResourceString(a.invalidOrTimedOutSessionMessage)):t==e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded?(r.ErrorCode=i.requestPayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded?(r.ErrorCode=i.responsePayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen?(r.ErrorCode=i.writeNotSupportedWhenModalDialogOpen,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeInvalidSheetName&&(r.ErrorCode=i.invalidRequestContext,r.HttpStatusCode=400,r.ErrorMessage=l._getResourceString(a.invalidSheetName)),r},e.buildHttpResponseFromOfficeJsError=function(t,n){var r=500,o={error:{}};return o.error.code=i.generalException,o.error.message=n,t===e.OfficeJsErrorCode_ooeNoCapability?(r=403,o.error.code=i.accessDenied):t===e.OfficeJsErrorCode_ooeActivityLimitReached&&(r=429,o.error.code=i.activityLimitReached),{statusCode:r,headers:{},body:JSON.stringify(o)}},e.buildRequestMessageSafeArray=function(e,t,n,r,o,i){var a=[];if(o)for(var s in o)a.push(s),a.push(o[s]);return[e,n,r,a,i,0,t,"","","","","",""]},e.getResponseBody=function(t){return e.getResponseBodyFromSafeArray(t.value.data)},e.getResponseHeaders=function(t){return e.getResponseHeadersFromSafeArray(t.value.data)},e.getResponseBodyFromSafeArray=function(e){var t=e[2];return"string"===typeof t?t:t.join("")},e.getResponseHeadersFromSafeArray=function(e){var t=e[1];if(!t)return null;for(var n={},r=0;r<t.length-1;r+=2)n[t[r]]=t[r+1];return n},e.getResponseStatusCode=function(t){return e.getResponseStatusCodeFromSafeArray(t.value.data)},e.getResponseStatusCodeFromSafeArray=function(e){return e[0]},e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession=5012,e.OfficeJsErrorCode_ooeActivityLimitReached=5102,e.OfficeJsErrorCode_ooeNoCapability=7e3,e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded=5103,e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded=5104,e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen=5016,e.OfficeJsErrorCode_ooeInvalidSheetName=1014,e}();e.RichApiMessageUtility=c,function(e){e.getPromiseType=function(){if("undefined"!==typeof Promise)return Promise;if("undefined"!==typeof Office&&Office.Promise)return Office.Promise;if("undefined"!==typeof OfficeExtension&&OfficeExtension.Promise)return OfficeExtension.Promise;throw new e.Error("No Promise implementation found")}}(r=e._Internal||(e._Internal={}));var l=function(){function e(){}return e.log=function(t){e._logEnabled&&"undefined"!==typeof console&&console.log&&console.log(t)},e.checkArgumentNull=function(t,n){if(e.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:n})},e.isNullOrUndefined=function(e){return null===e||"undefined"===typeof e},e.isUndefined=function(e){return"undefined"===typeof e},e.isNullOrEmptyString=function(e){return null===e||("undefined"===typeof e||0==e.length)},e.isPlainJsonObject=function(t){if(e.isNullOrUndefined(t))return!1;if("object"!==typeof t)return!1;if("[object Object]"!==Object.prototype.toString.apply(t))return!1;if(t.constructor&&!Object.prototype.hasOwnProperty.call(t,"constructor")&&!Object.prototype.hasOwnProperty.call(t.constructor.prototype,"hasOwnProperty"))return!1;for(var n in t)if(!Object.prototype.hasOwnProperty.call(t,n))return!1;return!0},e.trim=function(e){return e.replace(new RegExp("^\\s+|\\s+$","g"),"")},e.caseInsensitiveCompareString=function(t,n){return e.isNullOrUndefined(t)?e.isNullOrUndefined(n):!e.isNullOrUndefined(n)&&t.toUpperCase()==n.toUpperCase()},e.isReadonlyRestRequest=function(t){return e.caseInsensitiveCompareString(t,"GET")},e._getResourceString=function(t,n){var r;if("undefined"!==typeof window&&window.Strings&&window.Strings.OfficeOM){var o="L_"+t,i=window.Strings.OfficeOM[o];i&&(r=i)}if(r||(r=e.s_resourceStringValues[t]),r||(r=t),!e.isNullOrUndefined(n))if(Array.isArray(n)){var a=n;r=e._formatString(r,a)}else r=r.replace("{0}",n);return r},e._formatString=function(e,t){return e.replace(/\{\d\}/g,(function(e){var n=parseInt(e.substr(1,e.length-2));if(n<t.length)return t[n];throw r.RuntimeError._createInvalidArgError({argumentName:"format"})}))},Object.defineProperty(e,"Promise",{get:function(){return r.getPromiseType()},enumerable:!0,configurable:!0}),e.createPromise=function(t){return new e.Promise(t)},e._createPromiseFromResult=function(t){return e.createPromise((function(e,n){e(t)}))},e._createPromiseFromException=function(t){return e.createPromise((function(e,n){n(t)}))},e._createTimeoutPromise=function(t){return e.createPromise((function(e,n){setTimeout((function(){e(null)}),t)}))},e._createInvalidArgError=function(e){return r.RuntimeError._createInvalidArgError(e)},e._isLocalDocumentUrl=function(t){return e._getLocalDocumentUrlPrefixLength(t)>0},e._getLocalDocumentUrlPrefixLength=function(e){for(var t=["http://document.localhost","https://document.localhost","//document.localhost"],n=e.toLowerCase().trim(),r=0;r<t.length;r++){if(n===t[r])return t[r].length;if(n.substr(0,t[r].length+1)===t[r]+"/")return t[r].length+1}return 0},e._validateLocalDocumentRequest=function(t){var n=e._getLocalDocumentUrlPrefixLength(t.url);if(n<=0)throw r.RuntimeError._createInvalidArgError({argumentName:"request"});var o=t.url.substr(n),i=o.toLowerCase();return"_api"===i?o="":"_api/"===i.substr(0,"_api/".length)&&(o=o.substr("_api/".length)),{method:t.method,url:o,headers:t.headers,body:t.body}},e._parseRequestFlagsAndCustomDataFromQueryStringIfAny=function(e){for(var t={flags:-1,customData:""},n=e.split("&"),r=0;r<n.length;r++){var o=n[r].split("=");if(o[0].toLowerCase()===s.flags){var i=parseInt(o[1]);i&=8191,t.flags=i}else o[0].toLowerCase()===s.customData&&(t.customData=decodeURIComponent(o[1]))}return t},e._getRequestBodyText=function(e){var t="";return"string"===typeof e.body?t=e.body:e.body&&"object"===typeof e.body&&(t=JSON.stringify(e.body)),t},e._parseResponseBody=function(t){if("string"===typeof t.body){var n=e.trim(t.body);return JSON.parse(n)}return t.body},e._buildRequestMessageSafeArray=function(t){var n=0;e.isReadonlyRestRequest(t.method)||(n=1);var r="";if(t.url.substr(0,s.processQuery.length).toLowerCase()===s.processQuery.toLowerCase()){var o=t.url.indexOf("?");if(o>0){var i=t.url.substr(o+1),a=e._parseRequestFlagsAndCustomDataFromQueryStringIfAny(i);a.flags>=0&&(n=a.flags),r=a.customData}}return c.buildRequestMessageSafeArray(r,n,t.method,t.url,t.headers,e._getRequestBodyText(t))},e._parseHttpResponseHeaders=function(t){var n={};if(!e.isNullOrEmptyString(t))for(var r=new RegExp("\r?\n"),o=t.split(r),i=0;i<o.length;i++){var a=o[i];if(null!=a){var s=a.indexOf(":");if(s>0){var c=a.substr(0,s),l=a.substr(s+1);c=e.trim(c),l=e.trim(l),n[c.toUpperCase()]=l}}}return n},e._parseErrorResponse=function(t){var n=e._parseErrorResponseBody(t),r=t.statusCode.toString();if(e.isNullOrUndefined(n)||"object"!==typeof n||!n.error)return e._createDefaultErrorResponse(r);var o=n.error,i=o.innerError;return i&&i.code?e._createErrorResponse(i.code,r,i.message):o.code?e._createErrorResponse(o.code,r,o.message):e._createDefaultErrorResponse(r)},e._parseErrorResponseBody=function(t){if(e.isPlainJsonObject(t.body))return t.body;if(!e.isNullOrEmptyString(t.body)){var n=e.trim(t.body);try{return JSON.parse(n)}catch(t){e.log("Error when parse "+n)}}},e._createDefaultErrorResponse=function(t){return{errorCode:i.connectionFailure,errorMessage:e._getResourceString(a.connectionFailureWithStatus,t)}},e._createErrorResponse=function(t,n,r){return{errorCode:t,errorMessage:e._getResourceString(a.connectionFailureWithDetails,[n,t,r])}},e._copyHeaders=function(e,t){if(e&&t)for(var n in e)t[n]=e[n]},e.addResourceStringValues=function(t){for(var n in t)e.s_resourceStringValues[n]=t[n]},e._logEnabled=!1,e.s_resourceStringValues={ApiNotFoundDetails:"The method or property {0} is part of the {1} requirement set, which is not available in your version of {2}.",ConnectionFailureWithStatus:"The request failed with status code of {0}.",ConnectionFailureWithDetails:"The request failed with status code of {0}, error code {1} and the following error message: {2}",InvalidArgument:"The argument '{0}' doesn't work for this situation, is missing, or isn't in the right format.",InvalidObjectPath:'The object path \'{0}\' isn\'t working for what you\'re trying to do. If you\'re using the object across multiple "context.sync" calls and outside the sequential execution of a ".run" batch, please use the "context.trackedObjects.add()" and "context.trackedObjects.remove()" methods to manage the object\'s lifetime.',InvalidRequestContext:"Cannot use the object across different request contexts.",Timeout:"The operation has timed out.",ValueNotLoaded:'The value of the result object has not been loaded yet. Before reading the value property, call "context.sync()" on the associated request context.'},e}();e.CoreUtility=l;var u=function(){function e(){}return e.setMock=function(t){e.s_isMock=t},e.isMock=function(){return e.s_isMock},e._setCurrentTestName=function(t){e.s_currentTestName=t,e.s_currentTestSequenceId=0},e._getCurrentTestNameWithSequenceId=function(){return e.s_currentTestName?(e.s_currentTestSequenceId++,e.s_currentTestName+"."+e.s_currentTestSequenceId):null},e}();e.TestUtility=u,e._internalConfig={showDisposeInfoInDebugInfo:!1,showInternalApiInDebugInfo:!1,enableEarlyDispose:!0,alwaysPolyfillClientObjectUpdateMethod:!1,alwaysPolyfillClientObjectRetrieveMethod:!1,enableConcurrentFlag:!0,enableUndoableFlag:!0,appendTypeNameToObjectPathInfo:!1,enablePreviewExecution:!1},e.config={extendedErrorLogging:!1};var d=function(){function t(){}return t.createSetPropertyAction=function(t,n,r,o,i){C.validateObjectPath(n);var a={Id:t._nextId(),ActionType:4,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},s=[o],c=C.setMethodArguments(t,a.ArgumentInfo,s);C.validateReferencedObjectPaths(c);var l=new p(a,0,i);if(l.referencedObjectPath=n._objectPath,l.referencedArgumentObjectPaths=c,e._internalConfig.enablePreviewExecution&&0!==(16&i)){var u={Id:t._nextId(),ActionType:4,Name:r,ObjectId:"",ObjectType:"",Arguments:[o]};n._addPreviewExecutionAction(u)}return n._addAction(l)},t.createQueryAction=function(e,t,n,r){C.validateObjectPath(t);var o={Id:e._nextId(),ActionType:2,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},i=new p(o,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i,r)},t.createQueryAsJsonAction=function(e,t,n,r){C.validateObjectPath(t);var o={Id:e._nextId(),ActionType:7,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},i=new p(o,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i,r)},t.createUpdateAction=function(e,t,n){C.validateObjectPath(t);var r={Id:e._nextId(),ActionType:9,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},o=new p(r,0,0);return o.referencedObjectPath=t._objectPath,t._addAction(o)},t}();e.CommonActionFactory=d;var f=function(){function t(e,t){this.m_contextBase=e,this.m_objectPath=t}return Object.defineProperty(t.prototype,"_objectPath",{get:function(){return this.m_objectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_context",{get:function(){return this.m_contextBase},enumerable:!0,configurable:!0}),t.prototype._addAction=function(e,t){var n=this;return void 0===t&&(t=null),l.createPromise((function(r,o){n._context._addServiceApiAction(e,t,r,o)}))},t.prototype._addPreviewExecutionAction=function(e){},t.prototype._retrieve=function(t,n){var r=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;r||(r=!C.isSetSupported("RichApiRuntime","1.1"));var o=m._parseQueryOption(t);return r?d.createQueryAction(this._context,this,o,n):d.createQueryAsJsonAction(this._context,this,o,n)},t.prototype._recursivelyUpdate=function(t){var n=e._internalConfig.alwaysPolyfillClientObjectUpdateMethod;n||(n=!C.isSetSupported("RichApiRuntime","1.2"));try{var o=this[S.scalarPropertyNames];o||(o=[]);var s=this[S.scalarPropertyUpdateable];if(!s){s=[];for(var c=0;c<o.length;c++)s.push(!1)}var u=this[S.navigationPropertyNames];u||(u=[]);var f={},p={},h=0;for(var m in t){var g=o.indexOf(m);if(g>=0){if(!s[g])throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(_.attemptingToSetReadOnlyProperty,m),debugInfo:{errorLocation:m}});f[m]=t[m],++h}else{if(!(u.indexOf(m)>=0))throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(_.propertyDoesNotExist,m),debugInfo:{errorLocation:m}});p[m]=t[m]}}if(h>0)if(n)for(c=0;c<o.length;c++){var y=f[m=o[c]];C.isUndefined(y)||d.createSetPropertyAction(this._context,this,m,y)}else d.createUpdateAction(this._context,this,f);for(var m in p){var v=this[m],O=p[m];v._recursivelyUpdate(O)}}catch(e){throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".update"},innerError:e})}},t}();e.ClientObjectBase=f;var p=function(){function e(e,t,n){this.m_actionInfo=e,this.m_operationType=t,this.m_flags=n}return Object.defineProperty(e.prototype,"actionInfo",{get:function(){return this.m_actionInfo},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),e}();e.Action=p;var h=function(){function t(e,t,n,r,o,i){this.m_objectPathInfo=e,this.m_parentObjectPath=t,this.m_isCollection=n,this.m_isInvalidAfterRequest=r,this.m_isValid=!0,this.m_operationType=o,this.m_flags=i}return Object.defineProperty(t.prototype,"id",{get:function(){var e=this.m_objectPathInfo.ArgumentInfo;if(e){var t=e.Arguments;if(t)return t[0]}},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parent",{get:function(){var e=this.m_parentObjectPath;if(e)return e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentId",{get:function(){return this.parent?this.parent.id:void 0},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"objectPathInfo",{get:function(){return this.m_objectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isCollection",{get:function(){return this.m_isCollection},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isInvalidAfterRequest",{get:function(){return this.m_isInvalidAfterRequest},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentObjectPath",{get:function(){return this.m_parentObjectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"argumentObjectPaths",{get:function(){return this.m_argumentObjectPaths},set:function(e){this.m_argumentObjectPaths=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isValid",{get:function(){return this.m_isValid},set:function(e){this.m_isValid=e,!e&&6===this.m_objectPathInfo.ObjectPathType&&this.m_savedObjectPathInfo&&(t.copyObjectPathInfo(this.m_savedObjectPathInfo.pathInfo,this.m_objectPathInfo),this.m_parentObjectPath=this.m_savedObjectPathInfo.parent,this.m_isValid=!0,this.m_savedObjectPathInfo=null)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"originalObjectPathInfo",{get:function(){return this.m_originalObjectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"getByIdMethodName",{get:function(){return this.m_getByIdMethodName},set:function(e){this.m_getByIdMethodName=e},enumerable:!0,configurable:!0}),t.prototype._updateAsNullObject=function(){this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=7,this.m_objectPathInfo.Name="",this.m_parentObjectPath=null},t.prototype.saveOriginalObjectPathInfo=function(){e.config.extendedErrorLogging&&!this.m_originalObjectPathInfo&&(this.m_originalObjectPathInfo={},t.copyObjectPathInfo(this.m_objectPathInfo,this.m_originalObjectPathInfo))},t.prototype.updateUsingObjectData=function(e,n){var r=e[S.referenceId];if(!l.isNullOrEmptyString(r)){if(!this.m_savedObjectPathInfo&&!this.isInvalidAfterRequest&&t.isRestorableObjectPath(this.m_objectPathInfo.ObjectPathType)){var o={};t.copyObjectPathInfo(this.m_objectPathInfo,o),this.m_savedObjectPathInfo={pathInfo:o,parent:this.m_parentObjectPath}}return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=6,this.m_objectPathInfo.Name=r,delete this.m_objectPathInfo.ParentObjectPathId,void(this.m_parentObjectPath=null)}if(n){var i=n[S.collectionPropertyPath];if(!l.isNullOrEmptyString(i)&&n.context){var a=C.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!l.isNullOrUndefined(a)){for(var s=i.split("."),c=n.context[s[0]],u=1;u<s.length;u++)c=c[s[u]];return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_parentObjectPath=c._objectPath,this.m_objectPathInfo.ParentObjectPathId=this.m_parentObjectPath.objectPathInfo.Id,this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name="",void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}}}var d=this.parentObjectPath&&this.parentObjectPath.isCollection,f=this.getByIdMethodName;if(d||!l.isNullOrEmptyString(f)){a=C.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!l.isNullOrUndefined(a))return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),l.isNullOrEmptyString(f)?(this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name=""):(this.m_objectPathInfo.ObjectPathType=3,this.m_objectPathInfo.Name=f),void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}},t.prototype.resetForUpdateUsingObjectData=function(){this.m_isInvalidAfterRequest=!1,this.m_isValid=!0,this.m_operationType=1,this.m_flags=4,this.m_objectPathInfo.ArgumentInfo={},this.m_argumentObjectPaths=null,this.m_getByIdMethodName=null},t.isRestorableObjectPath=function(e){return 1===e||5===e||3===e||4===e},t.copyObjectPathInfo=function(e,t){t.Id=e.Id,t.ArgumentInfo=e.ArgumentInfo,t.Name=e.Name,t.ObjectPathType=e.ObjectPathType,t.ParentObjectPathId=e.ParentObjectPathId},t}();e.ObjectPath=h;var m=function(){function e(){this.m_nextId=0}return e.prototype._nextId=function(){return++this.m_nextId},e.prototype._addServiceApiAction=function(e,t,n,r){this.m_serviceApiQueue||(this.m_serviceApiQueue=new O(this)),this.m_serviceApiQueue.add(e,t,n,r)},e._parseQueryOption=function(t){var n={};if("string"===typeof t){var o=t;n.Select=C._parseSelectExpand(o)}else if(Array.isArray(t))n.Select=t;else if("object"===typeof t){var i=t;if(e.isLoadOption(i)){if("string"===typeof i.select)n.Select=C._parseSelectExpand(i.select);else if(Array.isArray(i.select))n.Select=i.select;else if(!C.isNullOrUndefined(i.select))throw r.RuntimeError._createInvalidArgError({argumentName:"option.select"});if("string"===typeof i.expand)n.Expand=C._parseSelectExpand(i.expand);else if(Array.isArray(i.expand))n.Expand=i.expand;else if(!C.isNullOrUndefined(i.expand))throw r.RuntimeError._createInvalidArgError({argumentName:"option.expand"});if("number"===typeof i.top)n.Top=i.top;else if(!C.isNullOrUndefined(i.top))throw r.RuntimeError._createInvalidArgError({argumentName:"option.top"});if("number"===typeof i.skip)n.Skip=i.skip;else if(!C.isNullOrUndefined(i.skip))throw r.RuntimeError._createInvalidArgError({argumentName:"option.skip"})}else n=e.parseStrictLoadOption(t)}else if(!C.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:"option"});return n},e.isLoadOption=function(e){if(!C.isUndefined(e.select)&&("string"===typeof e.select||Array.isArray(e.select)))return!0;if(!C.isUndefined(e.expand)&&("string"===typeof e.expand||Array.isArray(e.expand)))return!0;if(!C.isUndefined(e.top)&&"number"===typeof e.top)return!0;if(!C.isUndefined(e.skip)&&"number"===typeof e.skip)return!0;for(var t in e)return!1;return!0},e.parseStrictLoadOption=function(t){var n={Select:[]};return e.parseStrictLoadOptionHelper(n,"","option",t),n},e.combineQueryPath=function(e,t,n){return 0===e.length?t:e+n+t},e.parseStrictLoadOptionHelper=function(t,n,o,i){for(var a in i){var s=i[a];if("$all"===a){if("boolean"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});s&&t.Select.push(e.combineQueryPath(n,"*","/"))}else if("$top"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});t.Top=s}else if("$skip"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});t.Skip=s}else if("boolean"===typeof s)s&&t.Select.push(e.combineQueryPath(n,a,"/"));else{if("object"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(o,a,".")});e.parseStrictLoadOptionHelper(t,e.combineQueryPath(n,a,"/"),e.combineQueryPath(o,a,"."),s)}}},e}();e.ClientRequestContextBase=m;var g=function(){function e(e){this.m_objectPath=e}return e.prototype._handleResult=function(e){l.isNullOrUndefined(e)?this.m_objectPath._updateAsNullObject():this.m_objectPath.updateUsingObjectData(e,null)},e}(),y=function(){function t(e){this.m_contextBase=e,this.m_actions=[],this.m_actionResultHandler={},this.m_referencedObjectPaths={},this.m_instantiatedObjectPaths={},this.m_preSyncPromises=[],this.m_previewExecutionActions=[]}return t.prototype.addAction=function(e){this.m_actions.push(e),1==e.actionInfo.ActionType&&(this.m_instantiatedObjectPaths[e.actionInfo.ObjectPathId]=e)},t.prototype.addPreviewExecutionAction=function(e){this.m_previewExecutionActions.push(e)},Object.defineProperty(t.prototype,"hasActions",{get:function(){return this.m_actions.length>0},enumerable:!0,configurable:!0}),t.prototype._getLastAction=function(){return this.m_actions[this.m_actions.length-1]},t.prototype.ensureInstantiateObjectPath=function(e){if(e){if(this.m_instantiatedObjectPaths[e.objectPathInfo.Id])return;if(this.ensureInstantiateObjectPath(e.parentObjectPath),this.ensureInstantiateObjectPaths(e.argumentObjectPaths),!this.m_instantiatedObjectPaths[e.objectPathInfo.Id]){var t={Id:this.m_contextBase._nextId(),ActionType:1,Name:"",ObjectPathId:e.objectPathInfo.Id},n=new p(t,1,4);n.referencedObjectPath=e,this.addReferencedObjectPath(e),this.addAction(n);var r=new g(e);this.addActionResultHandler(n,r)}}},t.prototype.ensureInstantiateObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.ensureInstantiateObjectPath(e[t])},t.prototype.addReferencedObjectPath=function(e){if(e&&!this.m_referencedObjectPaths[e.objectPathInfo.Id]){if(!e.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,C.getObjectPathExpression(e)),debugInfo:{errorLocation:C.getObjectPathExpression(e)}});for(;e;)this.m_referencedObjectPaths[e.objectPathInfo.Id]=e,3==e.objectPathInfo.ObjectPathType&&this.addReferencedObjectPaths(e.argumentObjectPaths),e=e.parentObjectPath}},t.prototype.addReferencedObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.addReferencedObjectPath(e[t])},t.prototype.addActionResultHandler=function(e,t){this.m_actionResultHandler[e.actionInfo.Id]=t},t.prototype.aggregrateRequestFlags=function(e,t,n){return 0===t&&(e|=1,0===(2&n)&&(e&=-17),0===(8&n)&&(e&=-257),e&=-5),1&n&&(e|=2),0===(4&n)&&(e&=-5),e},t.prototype.finallyNormalizeFlags=function(t){return 0===(1&t)&&(t&=-17,t&=-257),e._internalConfig.enableConcurrentFlag||(t&=-5),e._internalConfig.enableUndoableFlag||(t&=-17),C.isSetSupported("RichApiRuntimeFlag","1.1")||(t&=-5,t&=-17),C.isSetSupported("RichApiRuntimeFlag","1.2")||(t&=-257),"number"===typeof this.m_flagsForTesting&&(t=this.m_flagsForTesting),t},t.prototype.buildRequestMessageBodyAndRequestFlags=function(){e._internalConfig.enableEarlyDispose&&t._calculateLastUsedObjectPathIds(this.m_actions);var n=276,r={};for(var o in this.m_referencedObjectPaths)n=this.aggregrateRequestFlags(n,this.m_referencedObjectPaths[o].operationType,this.m_referencedObjectPaths[o].flags),r[o]=this.m_referencedObjectPaths[o].objectPathInfo;for(var i=[],a=!1,s=0;s<this.m_actions.length;s++){var c=this.m_actions[s];3===c.actionInfo.ActionType&&c.actionInfo.Name===S.keepReference&&(a=!0),n=this.aggregrateRequestFlags(n,c.operationType,c.flags),i.push(c.actionInfo)}n=this.finallyNormalizeFlags(n);var l={AutoKeepReference:this.m_contextBase._autoCleanup&&a,Actions:i,ObjectPaths:r};return this.m_previewExecutionActions.length>0&&(l.PreviewExecutionActions=this.m_previewExecutionActions,n|=4096),{body:l,flags:n}},t.prototype.processResponse=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t],r=this.m_actionResultHandler[n.ActionId];r&&r._handleResult(n.Value)}},t.prototype.invalidatePendingInvalidObjectPaths=function(){for(var e in this.m_referencedObjectPaths)this.m_referencedObjectPaths[e].isInvalidAfterRequest&&(this.m_referencedObjectPaths[e].isValid=!1)},t.prototype._addPreSyncPromise=function(e){this.m_preSyncPromises.push(e)},Object.defineProperty(t.prototype,"_preSyncPromises",{get:function(){return this.m_preSyncPromises},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_actions",{get:function(){return this.m_actions},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_objectPaths",{get:function(){return this.m_referencedObjectPaths},enumerable:!0,configurable:!0}),t.prototype._removeKeepReferenceAction=function(e){for(var t=this.m_actions.length-1;t>=0;t--){var n=this.m_actions[t].actionInfo;if(n.ObjectPathId===e&&3===n.ActionType&&n.Name===S.keepReference){this.m_actions.splice(t,1);break}}},t._updateLastUsedActionIdOfObjectPathId=function(e,n,r){for(;n;){if(e[n.objectPathInfo.Id])return;e[n.objectPathInfo.Id]=r;var o=n.argumentObjectPaths;if(o)for(var i=o.length,a=0;a<i;a++)t._updateLastUsedActionIdOfObjectPathId(e,o[a],r);n=n.parentObjectPath}},t._calculateLastUsedObjectPathIds=function(e){for(var n={},r=e.length,o=r-1;o>=0;--o){var i=(f=e[o]).actionInfo.Id;f.referencedObjectPath&&t._updateLastUsedActionIdOfObjectPathId(n,f.referencedObjectPath,i);var a=f.referencedArgumentObjectPaths;if(a)for(var s=a.length,c=0;c<s;c++)t._updateLastUsedActionIdOfObjectPathId(n,a[c],i)}var l={};for(var u in n){var d=l[i=n[u]];d||(d=[],l[i]=d),d.push(parseInt(u))}for(o=0;o<r;o++){var f,p=l[(f=e[o]).actionInfo.Id];p&&p.length>0?f.actionInfo.L=p:f.actionInfo.L&&delete f.actionInfo.L}},t}();e.ClientRequestBase=y;var v=function(){function e(e){this.m_type=e}return Object.defineProperty(e.prototype,"value",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:i.valueNotLoaded,httpStatusCode:400,message:l._getResourceString(a.valueNotLoaded),debugInfo:{errorLocation:"clientResult.value"}});return this.m_value},enumerable:!0,configurable:!0}),e.prototype._handleResult=function(e){this.m_isLoaded=!0,"object"===typeof e&&e&&e._IsNull||(1===this.m_type?this.m_value=C.adjustToDateTime(e):this.m_value=e)},e}();e.ClientResult=v;var O=function(){function e(e){this.m_context=e,this.m_actions=[]}return e.prototype.add=function(e,t,n,r){var o=this;this.m_actions.push({action:e,resultHandler:t,resolve:n,reject:r}),1===this.m_actions.length&&setTimeout((function(){return o.processActions()}),0)},e.prototype.processActions=function(){var e=this;if(0!==this.m_actions.length){var t=this.m_actions;this.m_actions=[];for(var n=new y(this.m_context),r=0;r<t.length;r++){var o=t[r];n.ensureInstantiateObjectPath(o.action.referencedObjectPath),n.ensureInstantiateObjectPaths(o.action.referencedArgumentObjectPaths),n.addAction(o.action),n.addReferencedObjectPath(o.action.referencedObjectPath),n.addReferencedObjectPaths(o.action.referencedArgumentObjectPaths)}var i=n.buildRequestMessageBodyAndRequestFlags(),a=i.body,c=i.flags,u={Url:s.localDocumentApiPrefix,Headers:null,Body:a};l.log("Request:"),l.log(JSON.stringify(a)),(new b).executeAsync(this.m_context._customData,c,u).then((function(r){e.processResponse(n,t,r)})).catch((function(e){for(var n=0;n<t.length;n++){t[n].reject(e)}}))}},e.prototype.processResponse=function(e,t,n){var r=this.getErrorFromResponse(n),o=null;n.Body.Results?o=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(o=n.Body.ProcessedResults.Results),o||(o=[]),this.processActionResults(e,t,o,r)},e.prototype.getErrorFromResponse=function(e){return l.isNullOrEmptyString(e.ErrorCode)?e.Body&&e.Body.Error?new r.RuntimeError({code:e.Body.Error.Code,httpStatusCode:e.Body.Error.HttpStatusCode,message:e.Body.Error.Message}):null:new r.RuntimeError({code:e.ErrorCode,httpStatusCode:e.HttpStatusCode,message:e.ErrorMessage})},e.prototype.processActionResults=function(e,t,n,r){e.processResponse(n);for(var o=0;o<t.length;o++){for(var i=t[o],a=i.action.actionInfo.Id,s=!1,c=0;c<n.length;c++)if(a==n[c].ActionId){var l=n[c].Value;i.resultHandler&&(i.resultHandler._handleResult(l),l=i.resultHandler.value),i.resolve&&i.resolve(l),s=!0;break}!s&&i.reject&&(r?i.reject(r):i.reject("No response for the action."))}},e}(),b=function(){function e(){}return e.prototype.getRequestUrl=function(e,t){return"/"!=e.charAt(e.length-1)&&(e+="/"),e=(e+=s.processQuery)+"?"+s.flags+"="+t.toString()},e.prototype.executeAsync=function(t,r,o){var i={method:"POST",url:this.getRequestUrl(o.Url,r),headers:{},body:o.Body};if(i.headers[s.sourceLibHeader]=e.SourceLibHeaderValue,i.headers["CONTENT-TYPE"]="application/json",o.Headers)for(var a in o.Headers)i.headers[a]=o.Headers[a];return(l._isLocalDocumentUrl(i.url)?n.sendLocalDocumentRequest:n.sendRequest)(i).then((function(e){var t;if(200===e.statusCode)t={HttpStatusCode:e.statusCode,ErrorCode:null,ErrorMessage:null,Headers:e.headers,Body:l._parseResponseBody(e)};else{l.log("Error Response:"+e.body);var n=l._parseErrorResponse(e);t={HttpStatusCode:e.statusCode,ErrorCode:n.errorCode,ErrorMessage:n.errorMessage,Headers:e.headers,Body:null,RawErrorResponseBody:l._parseErrorResponseBody(e)}}return t}))},e.SourceLibHeaderValue="officejs-rest",e}();e.HttpRequestExecutor=b;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.collectionPropertyPath="_collectionPropertyPath",t.id="Id",t.idLowerCase="id",t.idPrivate="_Id",t.keepReference="_KeepReference",t.objectPathIdPrivate="_ObjectPathId",t.referenceId="_ReferenceId",t.items="_Items",t.itemsLowerCase="items",t.scalarPropertyNames="_scalarPropertyNames",t.scalarPropertyOriginalNames="_scalarPropertyOriginalNames",t.navigationPropertyNames="_navigationPropertyNames",t.scalarPropertyUpdateable="_scalarPropertyUpdateable",t.previewExecutionObjectId="_previewExecutionObjectId",t}(s);e.CommonConstants=S;var C=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.validateObjectPath=function(e){for(var n=e._objectPath;n;){if(!n.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(n)),debugInfo:{errorLocation:t.getObjectPathExpression(n)}});n=n.parentObjectPath}},t.validateReferencedObjectPaths=function(e){if(e)for(var n=0;n<e.length;n++)for(var o=e[n];o;){if(!o.isValid)throw new r.RuntimeError({code:i.invalidObjectPath,httpStatusCode:400,message:l._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(o))});o=o.parentObjectPath}},t._toCamelLowerCase=function(e){if(l.isNullOrEmptyString(e))return e;for(var t=0;t<e.length&&e.charCodeAt(t)>=65&&e.charCodeAt(t)<=90;)t++;return t<e.length?e.substr(0,t).toLowerCase()+e.substr(t):e.toLowerCase()},t.adjustToDateTime=function(e){if(l.isNullOrUndefined(e))return null;if("string"===typeof e)return new Date(e);if(Array.isArray(e)){for(var n=e,r=0;r<n.length;r++)n[r]=t.adjustToDateTime(n[r]);return n}throw l._createInvalidArgError({argumentName:"date"})},t.tryGetObjectIdFromLoadOrRetrieveResult=function(e){var t=e[S.id];return l.isNullOrUndefined(t)&&(t=e[S.idLowerCase]),l.isNullOrUndefined(t)&&(t=e[S.idPrivate]),t},t.getObjectPathExpression=function(e){for(var n="";e;){switch(e.objectPathInfo.ObjectPathType){case 1:n=n;break;case 2:n="new()"+(n.length>0?".":"")+n;break;case 3:n=t.normalizeName(e.objectPathInfo.Name)+"()"+(n.length>0?".":"")+n;break;case 4:n=t.normalizeName(e.objectPathInfo.Name)+(n.length>0?".":"")+n;break;case 5:n="getItem()"+(n.length>0?".":"")+n;break;case 6:n="_reference()"+(n.length>0?".":"")+n}e=e.parentObjectPath}return n},t.setMethodArguments=function(e,n,r){if(l.isNullOrUndefined(r))return null;var o=new Array,i=new Array,a=t.collectObjectPathInfos(e,r,o,i);return n.Arguments=r,a&&(n.ReferencedObjectPathIds=i),o},t.validateContext=function(e,t){if(e&&t&&t._context!==e)throw new r.RuntimeError({code:i.invalidRequestContext,httpStatusCode:400,message:l._getResourceString(a.invalidRequestContext)})},t.isSetSupported=function(e,n){return"function"===typeof t.isSetSupportedOverride?t.isSetSupportedOverride(e,n):!("undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.requirements)||window.Office.context.requirements.isSetSupported(e,n)},t.throwIfApiNotSupported=function(e,n,o,s){if(t._doApiNotSupportedCheck&&!t.isSetSupported(n,o)){var c=l._getResourceString(a.apiNotFoundDetails,[e,n+" "+o,s]);throw new r.RuntimeError({code:i.apiNotFound,httpStatusCode:404,message:c,debugInfo:{errorLocation:e}})}},t.calculateApiFlags=function(e,n,r){var o=window&&window.location&&window.location.href&&-1!==window.location.href.indexOf("eed0a086-3498-4f91-a377-1e0265ecc0cc");return("function"===typeof t.isSetSupportedOverride?t.isSetSupportedOverride(n,r):!o&&t.isSetSupported(n,r))||(e&=-3),e},t._parseSelectExpand=function(e){var t=[];if(!l.isNullOrEmptyString(e))for(var n=e.split(","),r=0;r<n.length;r++){var o=n[r];(o=i(o.trim())).length>0&&t.push(o)}return t;function i(e){var t=e.toLowerCase();if("items"===t||"items/"===t)return"*";return("items/"===t.substr(0,6)||"items."===t.substr(0,6))&&(e=e.substr(6)),e.replace(new RegExp("[/.]items[/.]","gi"),"/")}},t.changePropertyNameToCamelLowerCase=function(e){if(Array.isArray(e)){for(var n=[],r=0;r<e.length;r++)n.push(this.changePropertyNameToCamelLowerCase(e[r]));return n}if("object"===typeof e&&null!==e){n={};for(var o in e){var i=e[o];if(o===S.items){(n={})[S.itemsLowerCase]=this.changePropertyNameToCamelLowerCase(i);break}n[t._toCamelLowerCase(o)]=this.changePropertyNameToCamelLowerCase(i)}return n}return e},t.purifyJson=function(e){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(this.purifyJson(e[n]));return t}if("object"===typeof e&&null!==e){t={};for(var r in e)if(95!==r.charCodeAt(0)){var o=e[r];"object"===typeof o&&null!==o&&Array.isArray(o.items)&&(o=o.items),t[r]=this.purifyJson(o)}return t}return e},t.collectObjectPathInfos=function(e,n,r,o){for(var i=!1,a=0;a<n.length;a++)if(n[a]instanceof f){var s=n[a];t.validateContext(e,s),n[a]=s._objectPath.objectPathInfo.Id,o.push(s._objectPath.objectPathInfo.Id),r.push(s._objectPath),i=!0}else if(Array.isArray(n[a])){var c=new Array;t.collectObjectPathInfos(e,n[a],r,c)?(o.push(c),i=!0):o.push(0)}else l.isPlainJsonObject(n[a])?(o.push(0),t.replaceClientObjectPropertiesWithObjectPathIds(n[a],r)):o.push(0);return i},t.replaceClientObjectPropertiesWithObjectPathIds=function(e,n){var r,o;for(var i in e){var a=e[i];if(a instanceof f)n.push(a._objectPath),e[i]=((r={})[S.objectPathIdPrivate]=a._objectPath.objectPathInfo.Id,r);else if(Array.isArray(a))for(var s=0;s<a.length;s++)if(a[s]instanceof f){var c=a[s];n.push(c._objectPath),a[s]=((o={})[S.objectPathIdPrivate]=c._objectPath.objectPathInfo.Id,o)}else l.isPlainJsonObject(a[s])&&t.replaceClientObjectPropertiesWithObjectPathIds(a[s],n);else l.isPlainJsonObject(a)&&t.replaceClientObjectPropertiesWithObjectPathIds(a,n)}},t.normalizeName=function(e){return e.substr(0,1).toLowerCase()+e.substr(1)},t._doApiNotSupportedCheck=!1,t}(l);e.CommonUtility=C;var _=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyDoesNotExist="PropertyDoesNotExist",t.attemptingToSetReadOnlyProperty="AttemptingToSetReadOnlyProperty",t}(a);e.CommonResourceStrings=_;var A=function(e){function t(t){var n=e.call(this)||this;return n.m_shouldPolyfill=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.m_shouldPolyfill&&(this.m_value=C.changePropertyNameToCamelLowerCase(this.m_value)),this.m_value=this.removeItemNodes(this.m_value)},t.prototype.removeItemNodes=function(e){return"object"===typeof e&&null!==e&&e[S.itemsLowerCase]&&(e=e[S.itemsLowerCase]),C.purifyJson(e)},t}(v);e.ClientRetrieveResult=A;var D=function(){function e(e){this.callback=e}return e.prototype._handleResult=function(e){this.callback&&this.callback()},e}(),E=function(e){function t(t){var n=e.call(this)||this;return n.callback=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.callback()},t}(v);e.ClientResultCallback=E;var F=function(){function t(){}return t.invokeMethod=function(e,t,n,r,o,i){return void 0===n&&(n=0),void 0===r&&(r=[]),void 0===o&&(o=0),void 0===i&&(i=0),l.createPromise((function(i,a){var s=new v,c={Id:e._context._nextId(),ActionType:3,Name:t,ObjectPathId:e._objectPath.objectPathInfo.Id,ArgumentInfo:{}},l=C.setMethodArguments(e._context,c.ArgumentInfo,r),u=new p(c,n,o);u.referencedObjectPath=e._objectPath,u.referencedArgumentObjectPaths=l,e._context._addServiceApiAction(u,s,i,a)}))},t.invokeMethodWithClientResultCallback=function(e,t,n){var r=[];return l.createPromise((function(o,i){var a=new E(e),s={Id:t._context._nextId(),ActionType:3,Name:n,ObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=C.setMethodArguments(t._context,s.ArgumentInfo,r),l=new p(s,0,0);l.referencedObjectPath=t._objectPath,l.referencedArgumentObjectPaths=c,t._context._addServiceApiAction(l,a,o,i)}))},t.invokeRetrieve=function(n,r){var o,i=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(i||(i=!C.isSetSupported("RichApiRuntime","1.1")),"object"===typeof r[0]&&r[0].hasOwnProperty("$all")){if(!r[0].$all)throw e.Error._createInvalidArgError({});o=r[0]}else o=t._parseSelectOption(r);return n._retrieve(o,new A(i))},t._parseSelectOption=function(n){if(!n||!n[0])throw e.Error._createInvalidArgError({});var r=n[0]&&"string"!==typeof n[0]?n[0]:n;return Array.isArray(r)?r:t.parseRecursiveSelect(r)},t.parseRecursiveSelect=function(e){var t=function(e){return Object.keys(e).reduce((function(n,r){var o=e[r];return"object"===typeof o?n.concat(t(o).map((function(e){return r+"/"+e}))):o?n.concat(r):n}),[])};return t(e)},t.invokeRecursiveUpdate=function(e,t){return l.createPromise((function(n,r){e._recursivelyUpdate(t);var o={Id:e._context._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},i=new p(o,1,4);e._context._addServiceApiAction(i,null,n,r)}))},t.createRootServiceObject=function(e,t){var n={Id:t._nextId(),ObjectPathType:1,Name:""};return new e(t,new h(n,null,!1,!1,1,4))},t.createTopLevelServiceObject=function(e,t,n,r,o){var i={Id:t._nextId(),ObjectPathType:2,Name:n};return new e(t,new h(i,null,r,!1,1,4|o))},t.createPropertyObject=function(e,t,n,r,o){var i={Id:t._context._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id},a=new h(i,t._objectPath,r,!1,1,4|o);return new e(t._context,a)},t.createIndexerObject=function(e,t,n){var r={Id:t._context._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};r.ArgumentInfo.Arguments=n;var o=new h(r,t._objectPath,!1,!1,1,4);return new e(t._context,o)},t.createMethodObject=function(e,t,n,r,o,i,a,s,c){var l={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},u=C.setMethodArguments(t._context,l.ArgumentInfo,o),d=new h(l,t._objectPath,i,a,r,c);return d.argumentObjectPaths=u,d.getByIdMethodName=s,new e(t._context,d)},t.createAndInstantiateMethodObject=function(e,t,n,r,o,i,a,s,c){return l.createPromise((function(l,u){var d={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},f=C.setMethodArguments(t._context,d.ArgumentInfo,o),m=new h(d,t._objectPath,i,a,r,c);m.argumentObjectPaths=f,m.getByIdMethodName=s;var g=new v,y={Id:t._context._nextId(),ActionType:1,Name:"",ObjectPathId:m.objectPathInfo.Id,QueryInfo:{}},O=new p(y,1,4);O.referencedObjectPath=m,t._context._addServiceApiAction(O,g,(function(){return l(new e(t._context,m))}),u)}))},t.createTraceAction=function(e,t){return l.createPromise((function(n,r){var o={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},i=new p(o,1,4),a=new D(t);e._addServiceApiAction(i,a,n,r)}))},t.localDocumentContext=new m,t}();e.OperationalApiHelper=F;var P=function(){function e(e,t,n){this.eventId=e,this.targetId=t,this.eventArgumentTransform=n,this.registeredCallbacks=[]}return e.prototype.add=function(e){this.hasZero()&&q.getGenericEventRegistration("").register(this.eventId,this.targetId,this.registerCallback),this.registeredCallbacks.push(e)},e.prototype.remove=function(e){var t=this.registeredCallbacks.lastIndexOf(e);-1!==t&&this.registeredCallbacks.splice(t,1)},e.prototype.removeAll=function(){this.registeredCallbacks=[],q.getGenericEventRegistration("").unregister(this.eventId,this.targetId,this.registerCallback)},e.prototype.hasZero=function(){return 0===this.registeredCallbacks.length},Object.defineProperty(e.prototype,"registerCallback",{get:function(){var e=this;return this.outsideCallback||(this.outsideCallback=function(t){e.call(t)}),this.outsideCallback},enumerable:!0,configurable:!0}),e.prototype.call=function(t){var n=this;this.eventArgumentTransform(t).then((function(t){var r=n.registeredCallbacks.map((function(n){return e.callCallback(n,t)}));l.Promise.all(r)}))},e.callCallback=function(t,n){return l._createPromiseFromResult(null).then(e.wrapCallbackInFunction(t,n)).catch((function(e){l.log("Error when invoke handler: "+JSON.stringify(e))}))},e.wrapCallbackInFunction=function(e,t){return function(){return e(t)}},e}();e.GenericEventRegistryOperational=P;var R=function(){function e(){this.eventToTargetToHandlerMap={}}return Object.defineProperty(e,"globalEventRegistry",{get:function(){return e.singleton||(e.singleton=new e),e.singleton},enumerable:!0,configurable:!0}),e.getGlobalEventRegistry=function(t,n,r){var o=e.globalEventRegistry.eventToTargetToHandlerMap;o.hasOwnProperty(t)||(o[t]={});var i=o[t];return i.hasOwnProperty(n)||(i[n]=new P(t,n,r)),i[n]},e.singleton=void 0,e}();e.GlobalEventRegistryOperational=R;var I=function(){function e(e){this.genericEventInfo=e}return e.prototype.add=function(e){var t=this,n=void 0,r=l.createPromise((function(e){n=e}));return this.register(),this.createTrace((function(){var r=t.genericEventInfo.eventType,o=t.genericEventInfo.getTargetIdFunc();R.getGlobalEventRegistry(r,o,t.genericEventInfo.eventArgsTransformFunc).add(e),n()})),r},e.prototype.remove=function(e){var t=this;this.register(),this.createTrace((function(){var n=t.genericEventInfo.eventType,r=t.genericEventInfo.getTargetIdFunc();R.getGlobalEventRegistry(n,r,t.genericEventInfo.eventArgsTransformFunc).remove(e)}))},e.prototype.removeAll=function(){var e=this;this.unregister(),this.createTrace((function(){var t=e.genericEventInfo.eventType,n=e.genericEventInfo.getTargetIdFunc();R.getGlobalEventRegistry(t,n,e.genericEventInfo.eventArgsTransformFunc).removeAll()}))},e.prototype.createTrace=function(e){F.createTraceAction(this.genericEventInfo.object._context,e)},e.prototype.register=function(){F.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.register,0,[],0),q.getGenericEventRegistration("").isReady||q.getGenericEventRegistration("").ready()},e.prototype.unregister=function(){F.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.unregister)},e}();e.GenericEventHandlerOperational=I;var x=function(){function e(){}return e.invokeOn=function(e,t,n){var r=void 0,o=l.createPromise((function(e,t){r=e}));return e.add(t).then((function(){r({})})),o},e.invokeOff=function(t,n,r,o){if(!r&&!o){var i=Object.keys(t).map((function(e){return t[e]}));return e.invokeAllOff(i)}return r?(o?n.remove(o):n.removeAll(),l.createPromise((function(e,t){return e()}))):l._createPromiseFromException(r+" must be supplied if handler is supplied.")},e.invokeAllOff=function(e){return e.forEach((function(e){e.removeAll()})),l.createPromise((function(e,t){return e()}))},e}();e.EventHelper=x;var T=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.cannotRegisterEvent="CannotRegisterEvent",t.invalidOrTimedOutSession="InvalidOrTimedOutSession",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(i);e.ErrorCodes=T;var w=function(){function e(e){this.m_callback=e}return e.prototype._handleResult=function(e){this.m_callback&&this.m_callback()},e}(),M=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.createMethodAction=function(t,n,r,o,i,a){Z.validateObjectPath(n);var s={Id:t._nextId(),ActionType:3,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=Z.setMethodArguments(t,s.ArgumentInfo,i);Z.validateReferencedObjectPaths(c);var l=Z._fixupApiFlags(a),u=new p(s,o,l);if(u.referencedObjectPath=n._objectPath,u.referencedArgumentObjectPaths=c,n._addAction(u),e._internalConfig.enablePreviewExecution&&0!==(16&l)){var d={Id:t._nextId(),ActionType:3,Name:r,Arguments:i,ObjectId:"",ObjectType:""};n._addPreviewExecutionAction(d)}return u},n.createRecursiveQueryAction=function(e,t,n){Z.validateObjectPath(t);var r={Id:e._nextId(),ActionType:6,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,RecursiveQueryInfo:n},o=new p(r,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o),o},n.createEnsureUnchangedAction=function(e,t,n){Z.validateObjectPath(t);var r={Id:e._nextId(),ActionType:8,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},o=new p(r,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o),o},n.createInstantiateAction=function(e,t){Z.validateObjectPath(t),e._pendingRequest.ensureInstantiateObjectPath(t._objectPath.parentObjectPath),e._pendingRequest.ensureInstantiateObjectPaths(t._objectPath.argumentObjectPaths);var n={Id:e._nextId(),ActionType:1,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id},r=new p(n,1,4);return r.referencedObjectPath=t._objectPath,t._addAction(r,new J(t),!0),r},n.createTraceAction=function(e,t,n){var r={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},o=new p(r,1,4);return e._pendingRequest.addAction(o),n&&e._pendingRequest.addTrace(r.Id,t),o},n.createTraceMarkerForCallback=function(e,t){var r=n.createTraceAction(e,null,!1);e._pendingRequest.addActionResultHandler(r,new w(t))},n}(d);e.ActionFactory=M;var k=function(t){function n(n,r){var o=t.call(this,n,r)||this;return Z.checkArgumentNull(n,"context"),o.m_context=n,o._objectPath&&(!n._processingResult&&n._pendingRequest&&(M.createInstantiateAction(n,o),n._autoCleanup&&o._KeepReference&&n.trackedObjects._autoAdd(o)),e._internalConfig.appendTypeNameToObjectPathInfo&&o._objectPath.objectPathInfo&&o._className&&(o._objectPath.objectPathInfo.T=o._className)),o}return __extends(n,t),Object.defineProperty(n.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNull",{get:function(){return("undefined"!==typeof this.m_isNull||!u.isMock())&&(Z.throwIfNotLoaded("isNull",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNullObject",{get:function(){return("undefined"!==typeof this.m_isNull||!u.isMock())&&(Z.throwIfNotLoaded("isNullObject",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isNull",{get:function(){return this.m_isNull},set:function(e){this.m_isNull=e,e&&this._objectPath&&this._objectPath._updateAsNullObject()},enumerable:!0,configurable:!0}),n.prototype._addAction=function(e,t,n){return void 0===t&&(t=null),n||(this.context._pendingRequest.ensureInstantiateObjectPath(this._objectPath),this.context._pendingRequest.ensureInstantiateObjectPaths(e.referencedArgumentObjectPaths)),this.context._pendingRequest.addAction(e),this.context._pendingRequest.addReferencedObjectPath(this._objectPath),this.context._pendingRequest.addReferencedObjectPaths(e.referencedArgumentObjectPaths),this.context._pendingRequest.addActionResultHandler(e,t),l._createPromiseFromResult(null)},n.prototype._addPreviewExecutionAction=function(e){if(!Z.isUndefined(this._className)){e.ObjectType=this._className;var t=Z._getPropertyValueWithoutCheckLoaded(this,H.idLowerCase);Z.isUndefined(t)&&(t=Z._getPropertyValueWithoutCheckLoaded(this,H.idPrivate)),Z.isUndefined(t)&&(t=Z._getPropertyValueWithoutCheckLoaded(this,H.previewExecutionObjectId)),e.ObjectId=t,this.context._pendingRequest.addPreviewExecutionAction(e)}},n.prototype._handleResult=function(e){this._isNull=Z.isNullOrUndefined(e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleIdResult=function(e){this._isNull=Z.isNullOrUndefined(e),Z.fixObjectPathIfNecessary(this,e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleRetrieveResult=function(e,t){this._handleIdResult(e)},n.prototype._recursivelySet=function(e,t,o,s,c){var u=e instanceof n,d=e;if(u){if(Object.getPrototypeOf(this)!==Object.getPrototypeOf(e))throw r.RuntimeError._createInvalidArgError({argumentName:"properties",errorLocation:this._className+".set"});e=JSON.parse(JSON.stringify(e))}try{for(var f,p=0;p<o.length;p++)f=o[p],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]&&(this[f]=e[f]);for(p=0;p<s.length;p++)if(f=s[p],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]){var h=u?d[f]:e[f];this[f].set(h,t)}var m=!u;t&&!Z.isNullOrUndefined(m)&&(m=t.throwOnReadOnly);for(p=0;p<c.length;p++)if(f=c[p],e.hasOwnProperty(f)&&"undefined"!==typeof e[f]&&m)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString($.cannotApplyPropertyThroughSetMethod,f),debugInfo:{errorLocation:f}});for(f in e)if(o.indexOf(f)<0&&s.indexOf(f)<0){var g=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(this),f);if(!g)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(_.propertyDoesNotExist,f),debugInfo:{errorLocation:f}});if(m&&!g.set)throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(_.attemptingToSetReadOnlyProperty,f),debugInfo:{errorLocation:f}})}}catch(e){throw new r.RuntimeError({code:i.invalidArgument,httpStatusCode:400,message:l._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".set"},innerError:e})}},n}(f);e.ClientObject=k;var N=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(e,t,n){var r={url:s.processQuery,method:"POST",headers:n.Headers,body:n.Body},i="";n.Headers&&(i=n.Headers[H.officeControlId]);var a={id:o.nextId(),type:1,flags:t,controlId:i,message:r};return l.log(JSON.stringify(a)),this.m_session.sendMessageToHost(a).then((function(e){l.log("Received response: "+JSON.stringify(e));var t,n=e.message;if(200===n.statusCode)t={HttpStatusCode:n.statusCode,ErrorCode:null,ErrorMessage:null,Headers:n.headers,Body:l._parseResponseBody(n)};else{l.log("Error Response:"+n.body);var r=l._parseErrorResponse(n);t={HttpStatusCode:n.statusCode,ErrorCode:r.errorCode,ErrorMessage:r.errorMessage,Headers:n.headers,Body:null}}return t}))},e}(),j=function(e){function t(t){var n=e.call(this)||this;return n.m_bridge=t,n.m_bridge.addHostMessageHandler((function(e){if(3===e.type){var t=e.controlId;if(l.isNullOrEmptyString(t))q.getGenericEventRegistration(t)._handleRichApiMessage(e.message);else{var n=q.peekGenericEventRegistrationOrNull(t);n&&n._handleRichApiMessage(e.message),(n=q.peekGenericEventRegistrationOrNull(""))&&n._handleRichApiMessage(e.message)}}})),n}return __extends(t,e),t.getInstanceIfHostBridgeInited=function(){return o.instance?((l.isNullOrUndefined(t.s_instance)||t.s_instance.m_bridge!==o.instance)&&(t.s_instance=new t(o.instance)),t.s_instance):null},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},t.prototype._createRequestExecutorOrNull=function(){return l.log("NativeBridgeSession::CreateRequestExecutor"),new N(this)},t.prototype.getEventRegistration=function(e){return q.getGenericEventRegistration(e)},t.prototype.sendMessageToHost=function(e){return this.m_bridge.sendMessageToHostAndExpectResponse(e)},t}(t);e.HostBridgeSession=j;var U=function(n){function o(e){var i=n.call(this)||this;if(i.m_customRequestHeaders={},i.m_batchMode=0,i._onRunFinishedNotifiers=[],t._overrideSession)i.m_requestUrlAndHeaderInfoResolver=t._overrideSession;else if((Z.isNullOrUndefined(e)||"string"===typeof e&&0===e.length)&&((e=o.defaultRequestUrlAndHeaders)||(e={url:s.localDocument,headers:{}})),"string"===typeof e)i.m_requestUrlAndHeaderInfo={url:e,headers:{}};else if(o.isRequestUrlAndHeaderInfoResolver(e))i.m_requestUrlAndHeaderInfoResolver=e;else{if(!o.isRequestUrlAndHeaderInfo(e))throw r.RuntimeError._createInvalidArgError({argumentName:"url"});var a=e;i.m_requestUrlAndHeaderInfo={url:a.url,headers:{}},l._copyHeaders(a.headers,i.m_requestUrlAndHeaderInfo.headers)}return!i.m_requestUrlAndHeaderInfoResolver&&i.m_requestUrlAndHeaderInfo&&l._isLocalDocumentUrl(i.m_requestUrlAndHeaderInfo.url)&&j.getInstanceIfHostBridgeInited()&&(i.m_requestUrlAndHeaderInfo=null,i.m_requestUrlAndHeaderInfoResolver=j.getInstanceIfHostBridgeInited()),i.m_requestUrlAndHeaderInfoResolver instanceof t&&(i.m_session=i.m_requestUrlAndHeaderInfoResolver),i._processingResult=!1,i._customData=H.iterativeExecutor,i.sync=i.sync.bind(i),i}return __extends(o,n),Object.defineProperty(o.prototype,"session",{get:function(){return this.m_session},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"eventRegistration",{get:function(){return this.m_session?this.m_session.getEventRegistration(this._controlId):r.officeJsEventRegistration},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_url",{get:function(){return this.m_requestUrlAndHeaderInfo?this.m_requestUrlAndHeaderInfo.url:null},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_pendingRequest",{get:function(){return null==this.m_pendingRequest&&(this.m_pendingRequest=new B(this)),this.m_pendingRequest},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_controlId",{get:function(){var e=this.m_customRequestHeaders[H.officeControlId];return l.isNullOrUndefined(e)&&(e=""),e},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"debugInfo",{get:function(){return{pendingStatements:new Y(this._rootObjectPropertyName,this._pendingRequest._objectPaths,this._pendingRequest._actions,e._internalConfig.showDisposeInfoInDebugInfo).process()}},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"trackedObjects",{get:function(){return this.m_trackedObjects||(this.m_trackedObjects=new X(this)),this.m_trackedObjects},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"requestHeaders",{get:function(){return this.m_customRequestHeaders},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"batchMode",{get:function(){return this.m_batchMode},enumerable:!0,configurable:!0}),o.prototype.ensureInProgressBatchIfBatchMode=function(){if(1===this.m_batchMode&&!this.m_explicitBatchInProgress)throw Z.createRuntimeError(i.generalException,l._getResourceString($.notInsideBatch),null)},o.prototype.load=function(e,t){Z.validateContext(this,e);var n=o._parseQueryOption(t);d.createQueryAction(this,e,n,e)},o.prototype.loadRecursive=function(e,t,n){if(!Z.isPlainJsonObject(t))throw r.RuntimeError._createInvalidArgError({argumentName:"options"});var i={};for(var a in t)i[a]=o._parseQueryOption(t[a]);var s=M.createRecursiveQueryAction(this,e,{Queries:i,MaxDepth:n});this._pendingRequest.addActionResultHandler(s,e)},o.prototype.trace=function(e){M.createTraceAction(this,e,!0)},o.prototype._processOfficeJsErrorResponse=function(e,t){},o.prototype.ensureRequestUrlAndHeaderInfo=function(){var e=this;return Z._createPromiseFromResult(null).then((function(){if(!e.m_requestUrlAndHeaderInfo)return e.m_requestUrlAndHeaderInfoResolver._resolveRequestUrlAndHeaderInfo().then((function(t){if(e.m_requestUrlAndHeaderInfo=t,e.m_requestUrlAndHeaderInfo||(e.m_requestUrlAndHeaderInfo={url:s.localDocument,headers:{}}),Z.isNullOrEmptyString(e.m_requestUrlAndHeaderInfo.url)&&(e.m_requestUrlAndHeaderInfo.url=s.localDocument),e.m_requestUrlAndHeaderInfo.headers||(e.m_requestUrlAndHeaderInfo.headers={}),"function"===typeof e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull){var n=e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull();n&&(e._requestExecutor=n)}}))}))},o.prototype.syncPrivateMain=function(){var e=this;return this.ensureRequestUrlAndHeaderInfo().then((function(){var t=e._pendingRequest;return e.m_pendingRequest=null,e.processPreSyncPromises(t).then((function(){return e.syncPrivate(t)}))}))},o.prototype.syncPrivate=function(t){var n=this;if(u.isMock())return l._createPromiseFromResult(null);if(!t.hasActions)return this.processPendingEventHandlers(t);var o=t.buildRequestMessageBodyAndRequestFlags(),i=o.body,a=o.flags;this._requestFlagModifier&&(a|=this._requestFlagModifier),this._requestExecutor||(l._isLocalDocumentUrl(this.m_requestUrlAndHeaderInfo.url)?this._requestExecutor=new Q(this):this._requestExecutor=new b);var c=this._requestExecutor,d={};l._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,d),l._copyHeaders(this.m_customRequestHeaders,d),delete this.m_customRequestHeaders[H.officeScriptEventId];var f=u._getCurrentTestNameWithSequenceId();f&&(d[s.testRequestNameHeader]=f);var p={Url:this.m_requestUrlAndHeaderInfo.url,Headers:d,Body:i};t.invalidatePendingInvalidObjectPaths();var h=null,m=null;return this._lastSyncStart="undefined"===typeof performance?Date.now():performance.now(),this._lastRequestFlags=a,c.executeAsync(this._customData,a,p).then((function(r){return n._lastSyncEnd="undefined"===typeof performance?Date.now():performance.now(),e.config.executePerfLogFunc&&e.config.executePerfLogFunc({syncStart:n._lastSyncStart,syncEnd:n._lastSyncEnd}),h=n.processRequestExecutorResponseMessage(t,r),n.processPendingEventHandlers(t).catch((function(e){l.log("Error in processPendingEventHandlers"),l.log(JSON.stringify(e)),m=e}))})).then((function(){if(h)throw l.log("Throw error from response: "+JSON.stringify(h)),h;if(m){l.log("Throw error from ProcessEventHandler: "+JSON.stringify(m));var e=null;if(m instanceof r.RuntimeError)(e=m).traceMessages=t._responseTraceMessages;else{var n=null;n="string"===typeof m?m:m.message,Z.isNullOrEmptyString(n)&&(n=l._getResourceString($.cannotRegisterEvent)),e=new r.RuntimeError({code:T.cannotRegisterEvent,httpStatusCode:400,message:n,traceMessages:t._responseTraceMessages})}throw e}}))},o.prototype.processRequestExecutorResponseMessage=function(t,n){n.Body&&n.Body.TraceIds&&t._setResponseTraceIds(n.Body.TraceIds);var o=t._responseTraceMessages,i=null;if(n.Body){if(n.Body.Error&&n.Body.Error.ActionIndex>=0){var a=new Y(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!0),s=a.processForDebugStatementInfo(n.Body.Error.ActionIndex);i={statement:s.statement,surroundingStatements:s.surroundingStatements,fullStatements:["Please enable config.extendedErrorLogging to see full statements."]},e.config.extendedErrorLogging&&(a=new Y(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!1),i.fullStatements=a.process())}var c=null;if(n.Body.Results?c=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(c=n.Body.ProcessedResults.Results),c){this._processingResult=!0;try{t.processResponse(c)}finally{this._processingResult=!1}}}if(!Z.isNullOrEmptyString(n.ErrorCode))return new r.RuntimeError({code:n.ErrorCode,httpStatusCode:n.HttpStatusCode,message:n.ErrorMessage,traceMessages:o,data:{responseBody:n.RawErrorResponseBody}});if(n.Body&&n.Body.Error){var l={errorLocation:n.Body.Error.Location};return i&&(l.statement=i.statement,l.surroundingStatements=i.surroundingStatements,l.fullStatements=i.fullStatements),new r.RuntimeError({code:n.Body.Error.Code,httpStatusCode:n.Body.Error.HttpStatusCode,message:n.Body.Error.Message,traceMessages:o,debugInfo:l})}return null},o.prototype.processPendingEventHandlers=function(e){for(var t=Z._createPromiseFromResult(null),n=0;n<e._pendingProcessEventHandlers.length;n++){var r=e._pendingProcessEventHandlers[n];t=t.then(this.createProcessOneEventHandlersFunc(r,e))}return t},o.prototype.createProcessOneEventHandlersFunc=function(e,t){return function(){return e._processRegistration(t)}},o.prototype.processPreSyncPromises=function(e){for(var t=Z._createPromiseFromResult(null),n=0;n<e._preSyncPromises.length;n++){var r=e._preSyncPromises[n];t=t.then(this.createProcessOneProSyncFunc(r))}return t},o.prototype.createProcessOneProSyncFunc=function(e){return function(){return e}},o.prototype.sync=function(e){return u.isMock()?l._createPromiseFromResult(e):this.syncPrivateMain().then((function(){return e}))},o.prototype.batch=function(e){var t=this;if(1!==this.m_batchMode)return l._createPromiseFromException(Z.createRuntimeError(i.generalException,null,null));if(this.m_explicitBatchInProgress)return l._createPromiseFromException(Z.createRuntimeError(i.generalException,l._getResourceString($.pendingBatchInProgress),null));if(Z.isNullOrUndefined(e))return Z._createPromiseFromResult(null);this.m_explicitBatchInProgress=!0;var n,r,o,a=this.m_pendingRequest;this.m_pendingRequest=new B(this);try{n=e(this._rootObject,this)}catch(e){return this.m_explicitBatchInProgress=!1,this.m_pendingRequest=a,l._createPromiseFromException(e)}return"object"===typeof n&&n&&"function"===typeof n.then?o=Z._createPromiseFromResult(null).then((function(){return n})).then((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,e})).catch((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,l._createPromiseFromException(e)})):(this.m_explicitBatchInProgress=!1,r=this.m_pendingRequest,this.m_pendingRequest=a,o=Z._createPromiseFromResult(n)),o.then((function(e){return t.ensureRequestUrlAndHeaderInfo().then((function(){return t.syncPrivate(r)})).then((function(){return e}))}))},o._run=function(e,t,n,r,i,a){return void 0===n&&(n=3),void 0===r&&(r=5e3),o._runCommon("run",null,e,0,t,n,r,null,i,a)},o.isValidRequestInfo=function(e){return"string"===typeof e||o.isRequestUrlAndHeaderInfo(e)||o.isRequestUrlAndHeaderInfoResolver(e)},o.isRequestUrlAndHeaderInfo=function(e){return"object"===typeof e&&null!==e&&Object.getPrototypeOf(e)===Object.getPrototypeOf({})&&!Z.isNullOrUndefined(e.url)},o.isRequestUrlAndHeaderInfoResolver=function(e){return"object"===typeof e&&null!==e&&"function"===typeof e._resolveRequestUrlAndHeaderInfo},o._runBatch=function(e,t,n,r,i,a,s,c){return void 0===i&&(i=3),void 0===a&&(a=5e3),o._runBatchCommon(0,e,t,n,i,a,r,s,c)},o._runExplicitBatch=function(e,t,n,r,i,a,s,c){return void 0===i&&(i=3),void 0===a&&(a=5e3),o._runBatchCommon(1,e,t,n,i,a,r,s,c)},o._runBatchCommon=function(e,t,n,r,i,a,s,c,l){var u,d;void 0===i&&(i=3),void 0===a&&(a=5e3);var f=null,p=null,h=0,m=null;if(n.length>0)if(o.isValidRequestInfo(n[0]))f=n[0],h=1;else if(Z.isPlainJsonObject(n[0])){if(null!=(f=(m=n[0]).session)&&!o.isValidRequestInfo(f))return o.createErrorPromise(t);p=m.previousObjects,h=1}if(n.length==h+1)d=n[h+0];else{if(null!=m||n.length!=h+2)return o.createErrorPromise(t);p=n[h+0],d=n[h+1]}if(null!=p)if(p instanceof k)u=function(){return p.context};else if(p instanceof o)u=function(){return p};else{if(!Array.isArray(p))return o.createErrorPromise(t);var g=p;if(0==g.length)return o.createErrorPromise(t);for(var y=0;y<g.length;y++){if(!(g[y]instanceof k))return o.createErrorPromise(t);if(g[y].context!=g[0].context)return o.createErrorPromise(t,$.invalidRequestContext)}u=function(){return g[0].context}}else u=r;var v=null;return s&&(v=function(e){return s(m||{},e)}),o._runCommon(t,f,u,e,d,i,a,v,c,l)},o.createErrorPromise=function(e,t){return void 0===t&&(t=a.invalidArgument),l._createPromiseFromException(Z.createRuntimeError(t,l._getResourceString(t),e))},o._runCommon=function(n,r,i,a,s,c,u,d,f,p){t._overrideSession&&(r=t._overrideSession);var h,m,g,y=l.createPromise((function(e,t){e()})),v=!1;return y.then((function(){if((h=i(r))._autoCleanup)return new e.Promise((function(e,t){h._onRunFinishedNotifiers.push((function(){h._autoCleanup=!0,e()}))}));h._autoCleanup=!0})).then((function(){return"function"!==typeof s?o.createErrorPromise(n):(g=h.m_batchMode,h.m_batchMode=a,d&&d(h),e=s(1==a?h.batch.bind(h):h),(Z.isNullOrUndefined(e)||"function"!==typeof e.then)&&Z.throwError($.runMustReturnPromise),e);var e})).then((function(e){return 1===a?e:h.sync(e)})).then((function(e){v=!0,m=e})).catch((function(e){m=e})).then((function(){var e=h.trackedObjects._retrieveAndClearAutoCleanupList();for(var t in h._autoCleanup=!1,h.m_batchMode=g,e)e[t]._objectPath.isValid=!1;var n=0;if(Z._synchronousCleanup||o.isRequestUrlAndHeaderInfoResolver(r))return i();function i(){n++;var t=h.m_pendingRequest,r=h.m_batchMode,o=new B(h);h.m_pendingRequest=o,h.m_batchMode=0;try{for(var a in e)h.trackedObjects.remove(e[a])}finally{h.m_batchMode=r,h.m_pendingRequest=t}return h.syncPrivate(o).then((function(){f&&f(n)})).catch((function(){p&&p(n),n<c&&setTimeout((function(){i()}),u)}))}i()})).then((function(){h._onRunFinishedNotifiers&&h._onRunFinishedNotifiers.length>0&&h._onRunFinishedNotifiers.shift()();if(v)return m;throw m}))},o}(m);e.ClientRequestContext=U;var L=function(){function e(e,t){this.m_proxy=e,this.m_shouldPolyfill=t;var n=e[H.scalarPropertyNames],r=e[H.navigationPropertyNames],o=e[H.className],i=e[H.isCollection];if(n)for(var a=0;a<n.length;a++)Z.definePropertyThrowUnloadedException(this,o,n[a]);if(r)for(a=0;a<r.length;a++)Z.definePropertyThrowUnloadedException(this,o,r[a]);i&&Z.definePropertyThrowUnloadedException(this,o,H.itemsLowerCase)}return Object.defineProperty(e.prototype,"$proxy",{get:function(){return this.m_proxy},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"$isNullObject",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:T.valueNotLoaded,httpStatusCode:400,message:l._getResourceString($.valueNotLoaded),debugInfo:{errorLocation:"retrieveResult.$isNullObject"}});return this.m_isNullObject},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){if(this.m_isLoaded)return this.m_isNullObject?null:(Z.isUndefined(this.m_json)&&(this.m_json=Z.purifyJson(this.m_value)),this.m_json)},e.prototype.toString=function(){return JSON.stringify(this.toJSON())},e.prototype._handleResult=function(e){this.m_isLoaded=!0,null===e||"object"===typeof e&&e&&e._IsNull?(this.m_isNullObject=!0,e=null):this.m_isNullObject=!1,this.m_shouldPolyfill&&(e=Z.changePropertyNameToCamelLowerCase(e)),this.m_value=e,this.m_proxy._handleRetrieveResult(e,this)},e}(),H=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.getItemAt="GetItemAt",t.index="_Index",t.iterativeExecutor="IterativeExecutor",t.isTracked="_IsTracked",t.eventMessageCategory=65536,t.eventWorkbookId="Workbook",t.eventSourceRemote="Remote",t.proxy="$proxy",t.className="_className",t.isCollection="_isCollection",t.collectionPropertyPath="_collectionPropertyPath",t.objectPathInfoDoNotKeepReferenceFieldName="D",t.officeScriptEventId="X-OfficeScriptEventId",t.officeScriptFireRecordingEvent="X-OfficeScriptFireRecordingEvent",t.officeControlId="X-OfficeControlId",t}(S);e.Constants=H;var B=function(e){function t(t){var n=e.call(this,t)||this;return n.m_context=t,n.m_pendingProcessEventHandlers=[],n.m_pendingEventHandlerActions={},n.m_traceInfos={},n.m_responseTraceIds={},n.m_responseTraceMessages=[],n}return __extends(t,e),Object.defineProperty(t.prototype,"traceInfos",{get:function(){return this.m_traceInfos},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceMessages",{get:function(){return this.m_responseTraceMessages},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceIds",{get:function(){return this.m_responseTraceIds},enumerable:!0,configurable:!0}),t.prototype._setResponseTraceIds=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t];this.m_responseTraceIds[n]=n;var r=this.m_traceInfos[n];l.isNullOrUndefined(r)||this.m_responseTraceMessages.push(r)}},t.prototype.addTrace=function(e,t){this.m_traceInfos[e]=t},t.prototype._addPendingEventHandlerAction=function(e,t){this.m_pendingEventHandlerActions[e._id]||(this.m_pendingEventHandlerActions[e._id]=[],this.m_pendingProcessEventHandlers.push(e)),this.m_pendingEventHandlerActions[e._id].push(t)},Object.defineProperty(t.prototype,"_pendingProcessEventHandlers",{get:function(){return this.m_pendingProcessEventHandlers},enumerable:!0,configurable:!0}),t.prototype._getPendingEventHandlerActions=function(e){return this.m_pendingEventHandlerActions[e._id]},t}(y);e.ClientRequest=B;var W=function(){function e(e,t,n,r){var o=this;this.m_id=e._nextId(),this.m_context=e,this.m_name=n,this.m_handlers=[],this.m_registered=!1,this.m_eventInfo=r,this.m_callback=function(e){o.m_eventInfo.eventArgsTransformFunc(e).then((function(e){return o.fireEvent(e)}))}}return Object.defineProperty(e.prototype,"_registered",{get:function(){return this.m_registered},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_id",{get:function(){return this.m_id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_handlers",{get:function(){return this.m_handlers},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_callback",{get:function(){return this.m_callback},enumerable:!0,configurable:!0}),e.prototype.add=function(e){var t=M.createTraceAction(this.m_context,null,!1);return this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:0}),new G(this.m_context,this,e)},e.prototype.remove=function(e){var t=M.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:1})},e.prototype.removeAll=function(){var e=M.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:e.actionInfo.Id,handler:null,operation:2})},e.prototype._processRegistration=function(e){var t=this,n=l._createPromiseFromResult(null),r=e._getPendingEventHandlerActions(this);if(!r)return n;for(var o=[],i=0;i<this.m_handlers.length;i++)o.push(this.m_handlers[i]);var a=!1;for(i=0;i<r.length;i++)if(e._responseTraceIds[r[i].id])switch(a=!0,r[i].operation){case 0:o.push(r[i].handler);break;case 1:for(var s=o.length-1;s>=0;s--)if(o[s]===r[i].handler){o.splice(s,1);break}break;case 2:o=[]}return a&&(!this.m_registered&&o.length>0?n=n.then((function(){return t.m_eventInfo.registerFunc(t.m_callback)})).then((function(){return t.m_registered=!0})):this.m_registered&&0==o.length&&(n=n.then((function(){return t.m_eventInfo.unregisterFunc(t.m_callback)})).catch((function(e){l.log("Error when unregister event: "+JSON.stringify(e))})).then((function(){return t.m_registered=!1}))),n=n.then((function(){return t.m_handlers=o}))),n},e.prototype.fireEvent=function(e){for(var t=[],n=0;n<this.m_handlers.length;n++){var r=this.m_handlers[n],o=l._createPromiseFromResult(null).then(this.createFireOneEventHandlerFunc(r,e)).catch((function(e){l.log("Error when invoke handler: "+JSON.stringify(e))}));t.push(o)}l.Promise.all(t)},e.prototype.createFireOneEventHandlerFunc=function(e,t){return function(){return e(t)}},e}();e.EventHandlers=W;var G=function(){function e(e,t,n){this.m_context=e,this.m_allHandlers=t,this.m_handler=n}return Object.defineProperty(e.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),e.prototype.remove=function(){this.m_allHandlers&&this.m_handler&&(this.m_allHandlers.remove(this.m_handler),this.m_allHandlers=null,this.m_handler=null)},e}();e.EventHandlerResult=G,function(e){var t=function(){function t(){}return t.prototype.register=function(t,n,r){switch(t){case 4:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingDataChanged,r,t)}))}));case 3:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingSelectionChanged,r,t)}))}));case 2:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.DocumentSelectionChanged,r,e)}));case 1:return Z.promisify((function(e){return Office.context.document.settings.addHandlerAsync(Office.EventType.SettingsChanged,r,e)}));case 5:return OSF.DDA.RichApi.richApiMessageManager.register(r);case 13:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDeleted,r,{id:n},e)}));case 14:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectSelectionChanged,r,{id:n},e)}));case 15:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDataChanged,r,{id:n},e)}));case 16:return Z.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ContentControlAdded,r,{id:n},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t.prototype.unregister=function(t,n,r){switch(t){case 4:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingDataChanged,{handler:r},t)}))}));case 3:return Z.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Z.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingSelectionChanged,{handler:r},t)}))}));case 2:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.DocumentSelectionChanged,{handler:r},e)}));case 1:return Z.promisify((function(e){return Office.context.document.settings.removeHandlerAsync(Office.EventType.SettingsChanged,{handler:r},e)}));case 5:return Z.promisify((function(e){return OSF.DDA.RichApi.richApiMessageManager.removeHandlerAsync("richApiMessage",{handler:r},e)}));case 13:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDeleted,{id:n,handler:r},e)}));case 14:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectSelectionChanged,{id:n,handler:r},e)}));case 15:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDataChanged,{id:n,handler:r},e)}));case 16:return Z.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ContentControlAdded,{id:n,handler:r},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t}();e.officeJsEventRegistration=new t}(r=e._Internal||(e._Internal={}));var V=function(){function e(e,t){this.m_handlersByEventByTarget={},this.m_registerEventImpl=e,this.m_unregisterEventImpl=t}return e.getTargetIdOrDefault=function(e){return Z.isNullOrUndefined(e)?"":e},e.prototype.getHandlers=function(t,n){n=e.getTargetIdOrDefault(n);var r=this.m_handlersByEventByTarget[t];r||(r={},this.m_handlersByEventByTarget[t]=r);var o=r[n];return o||(o=[],r[n]=o),o},e.prototype.callHandlers=function(e,t,n){for(var r=this.getHandlers(e,t),o=0;o<r.length;o++)r[o](n)},e.prototype.hasHandlers=function(e,t){return this.getHandlers(e,t).length>0},e.prototype.register=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});var o=this.getHandlers(e,t);return o.push(n),1===o.length?this.m_registerEventImpl(e,t):Z._createPromiseFromResult(null)},e.prototype.unregister=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});for(var o=this.getHandlers(e,t),i=o.length-1;i>=0;i--)if(o[i]===n){o.splice(i,1);break}return 0===o.length?this.m_unregisterEventImpl(e,t):Z._createPromiseFromResult(null)},e}();e.EventRegistration=V;var q=function(){function e(){this.m_eventRegistration=new V(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this)),this.m_richApiMessageHandler=this._handleRichApiMessage.bind(this)}return e.prototype.ready=function(){var t=this;return this.m_ready||(e._testReadyImpl?this.m_ready=e._testReadyImpl().then((function(){t.m_isReady=!0})):o.instance?this.m_ready=Z._createPromiseFromResult(null).then((function(){t.m_isReady=!0})):this.m_ready=r.officeJsEventRegistration.register(5,"",this.m_richApiMessageHandler).then((function(){t.m_isReady=!0}))),this.m_ready},Object.defineProperty(e.prototype,"isReady",{get:function(){return this.m_isReady},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.register(e,t,n)}))},e.prototype.unregister=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.unregister(e,t,n)}))},e.prototype._registerEventImpl=function(e,t){return Z._createPromiseFromResult(null)},e.prototype._unregisterEventImpl=function(e,t){return Z._createPromiseFromResult(null)},e.prototype._handleRichApiMessage=function(e){if(e&&e.entries)for(var t=0;t<e.entries.length;t++){var n=e.entries[t];if(n.messageCategory==H.eventMessageCategory){l._logEnabled&&l.log(JSON.stringify(n));var r=n.messageType,o=n.targetId;if(this.m_eventRegistration.hasHandlers(r,o)){var i=JSON.parse(n.message);n.isRemoteOverride&&(i.source=H.eventSourceRemote),this.m_eventRegistration.callHandlers(r,o,i)}}}},e.getGenericEventRegistration=function(t){l.isNullOrUndefined(t)&&(t="");var n=e.s_genericEventRegistrations[t];return n||(n=new e,e.s_genericEventRegistrations[t]=n),n},e.peekGenericEventRegistrationOrNull=function(t){return l.isNullOrUndefined(t)&&(t=""),e.s_genericEventRegistrations[t]},e.richApiMessageEventCategory=65536,e.s_genericEventRegistrations={},e}();e.GenericEventRegistration=q,e._testSetRichApiMessageReadyImpl=function(e){q._testReadyImpl=e},e._testTriggerRichApiMessageEvent=function(e){q.getGenericEventRegistration("")._handleRichApiMessage(e)};var z=function(e){function t(t,n,r,o){var i=e.call(this,t,n,r,o)||this;return i.m_genericEventInfo=o,i}return __extends(t,e),t.prototype.add=function(e){var t=this;0==this._handlers.length&&this.m_genericEventInfo.registerFunc&&this.m_genericEventInfo.registerFunc();var n=this._context._controlId;return q.getGenericEventRegistration(n).isReady||this._context._pendingRequest._addPreSyncPromise(q.getGenericEventRegistration(n).ready()),M.createTraceMarkerForCallback(this._context,(function(){t._handlers.push(e),1==t._handlers.length&&q.getGenericEventRegistration(n).register(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)})),new G(this._context,this,e)},t.prototype.remove=function(e){var t=this;1==this._handlers.length&&this.m_genericEventInfo.unregisterFunc&&this.m_genericEventInfo.unregisterFunc();var n=this._context._controlId;M.createTraceMarkerForCallback(this._context,(function(){for(var r=t._handlers,o=r.length-1;o>=0;o--)if(r[o]===e){r.splice(o,1);break}0==r.length&&q.getGenericEventRegistration(n).unregister(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)}))},t.prototype.removeAll=function(){},t}(W);e.GenericEventHandlers=z;var J=function(){function e(e){this.m_clientObject=e}return e.prototype._handleResult=function(e){this.m_clientObject._handleIdResult(e)},e}(),K=function(){function e(){}return e.createGlobalObjectObjectPath=function(e){var t={Id:e._nextId(),ObjectPathType:1,Name:""};return new h(t,null,!1,!1,1,4)},e.createNewObjectObjectPath=function(e,t,n,r){var o={Id:e._nextId(),ObjectPathType:2,Name:t};return new h(o,null,n,!1,1,Z._fixupApiFlags(r))},e.createPropertyObjectPath=function(e,t,n,r,o,i){var a={Id:e._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id};return new h(a,t._objectPath,r,o,1,Z._fixupApiFlags(i))},e.createIndexerObjectPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t._objectPath,!1,!1,1,4)},e.createIndexerObjectPathUsingParentPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t,!1,!1,1,4)},e.createMethodObjectPath=function(e,t,n,r,o,i,a,s,c){var l={Id:e._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},u=Z.setMethodArguments(e,l.ArgumentInfo,o),d=new h(l,t._objectPath,i,a,r,Z._fixupApiFlags(c));return d.argumentObjectPaths=u,d.getByIdMethodName=s,d},e.createReferenceIdObjectPath=function(e,t){var n={Id:e._nextId(),ObjectPathType:6,Name:t,ArgumentInfo:{}};return new h(n,null,!1,!1,1,4)},e.createChildItemObjectPathUsingIndexerOrGetItemAt=function(t,n,r,o,i){var a=Z.tryGetObjectIdFromLoadOrRetrieveResult(o);return t&&!Z.isNullOrUndefined(a)?e.createChildItemObjectPathUsingIndexer(n,r,o):e.createChildItemObjectPathUsingGetItemAt(n,r,o,i)},e.createChildItemObjectPathUsingIndexer=function(e,t,n){var r=Z.tryGetObjectIdFromLoadOrRetrieveResult(n),o=o={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return o.ArgumentInfo.Arguments=[r],new h(o,t._objectPath,!1,!1,1,4)},e.createChildItemObjectPathUsingGetItemAt=function(e,t,n,r){var o=n[H.index];o&&(r=o);var i={Id:e._nextId(),ObjectPathType:3,Name:H.getItemAt,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return i.ArgumentInfo.Arguments=[r],new h(i,t._objectPath,!1,!1,1,4)},e}();e.ObjectPathFactory=K;var Q=function(){function t(e){this.m_context=e}return t.prototype.executeAsync=function(n,r,o){var i=this,a=c.buildMessageArrayForIRequestExecutor(n,r,o,t.SourceLibHeaderValue);return new e.Promise((function(e,t){OSF.DDA.RichApi.executeRichApiRequestAsync(a,(function(t){var n;l.log("Response:"),l.log(JSON.stringify(t)),"succeeded"==t.status?n=c.buildResponseOnSuccess(c.getResponseBody(t),c.getResponseHeaders(t)):(n=c.buildResponseOnError(t.error.code,t.error.message),i.m_context._processOfficeJsErrorResponse(t.error.code,n)),e(n)}))}))},t.SourceLibHeaderValue="officejs",t}(),X=function(){function e(e){this._autoCleanupList={},this.m_context=e}return e.prototype.add=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._addCommon(e,!0)})):this._addCommon(e,!0)},e.prototype._autoAdd=function(e){this._addCommon(e,!1),this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e},e.prototype._autoTrackIfNecessaryWhenHandleObjectResultValue=function(e,t){this.m_context._autoCleanup&&!e[H.isTracked]&&e!==this.m_context._rootObject&&t&&!Z.isNullOrEmptyString(t[H.referenceId])&&(this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e,e[H.isTracked]=!0)},e.prototype._addCommon=function(e,t){if(e[H.isTracked])t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id];else{var n=e[H.referenceId];if(e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName])throw Z.createRuntimeError(i.generalException,l._getResourceString($.objectIsUntracked),null);Z.isNullOrEmptyString(n)&&e._KeepReference&&(e._KeepReference(),M.createInstantiateAction(this.m_context,e),t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id],e[H.isTracked]=!0)}},e.prototype.remove=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._removeCommon(e)})):this._removeCommon(e)},e.prototype._removeCommon=function(e){e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName]=!0,e.context._pendingRequest._removeKeepReferenceAction(e._objectPath.objectPathInfo.Id);var t=e[H.referenceId];if(!Z.isNullOrEmptyString(t)){var n=this.m_context._rootObject;n._RemoveReference&&n._RemoveReference(t)}delete e[H.isTracked]},e.prototype._retrieveAndClearAutoCleanupList=function(){var e=this._autoCleanupList;return this._autoCleanupList={},e},e}();e.TrackedObjects=X;var Y=function(){function t(e,t,n,r,o){e||(e="root"),this.m_globalObjName=e,this.m_referencedObjectPaths=t,this.m_actions=n,this.m_statements=[],this.m_variableNameForObjectPathMap={},this.m_variableNameToObjectPathMap={},this.m_declaredObjectPathMap={},this.m_showDispose=r,this.m_removePII=o}return t.prototype.process=function(){this.m_showDispose&&B._calculateLastUsedObjectPathIds(this.m_actions);for(var e=0;e<this.m_actions.length;e++)this.processOneAction(this.m_actions[e]);return this.m_statements},t.prototype.processForDebugStatementInfo=function(e){this.m_showDispose&&B._calculateLastUsedObjectPathIds(this.m_actions);this.m_statements=[];for(var t=-1,n=0;n<this.m_actions.length&&(this.processOneAction(this.m_actions[n]),e==n&&(t=this.m_statements.length-1),!(t>=0&&this.m_statements.length>t+5+1));n++);if(t<0)return null;var r=t-5;r<0&&(r=0);var o=t+1+5;o>this.m_statements.length&&(o=this.m_statements.length);var i=[];0!=r&&i.push("...");for(var a=r;a<t;a++)i.push(this.m_statements[a]);i.push("// >>>>>"),i.push(this.m_statements[t]),i.push("// <<<<<");for(var s=t+1;s<o;s++)i.push(this.m_statements[s]);return o<this.m_statements.length&&i.push("..."),{statement:this.m_statements[t],surroundingStatements:i}},t.prototype.processOneAction=function(e){switch(e.actionInfo.ActionType){case 1:this.processInstantiateAction(e);break;case 3:this.processMethodAction(e);break;case 2:this.processQueryAction(e);break;case 7:this.processQueryAsJsonAction(e);break;case 6:this.processRecursiveQueryAction(e);break;case 4:this.processSetPropertyAction(e);break;case 5:this.processTraceAction(e);break;case 8:this.processEnsureUnchangedAction(e);break;case 9:this.processUpdateAction(e)}},t.prototype.processInstantiateAction=function(e){var t=e.actionInfo.ObjectPathId,n=this.m_referencedObjectPaths[t],r=this.getObjVarName(t);if(this.m_declaredObjectPathMap[t]){o="// Instantiate {"+r+"}";o=this.appendDisposeCommentIfRelevant(o,e),this.m_statements.push(o)}else{var o="var "+r+" = "+this.buildObjectPathExpressionWithParent(n)+";";o=this.appendDisposeCommentIfRelevant(o,e),this.m_statements.push(o),this.m_declaredObjectPathMap[t]=r}},t.prototype.processMethodAction=function(t){var n=t.actionInfo.Name;if("_KeepReference"===n){if(!e._internalConfig.showInternalApiInDebugInfo)return;n="track"}var r=this.getObjVarName(t.actionInfo.ObjectPathId)+"."+Z._toCamelLowerCase(n)+"("+this.buildArgumentsExpression(t.actionInfo.ArgumentInfo)+");";r=this.appendDisposeCommentIfRelevant(r,t),this.m_statements.push(r)},t.prototype.processQueryAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".load("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processQueryAsJsonAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".retrieve("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processRecursiveQueryAction=function(e){var t="";e.actionInfo.RecursiveQueryInfo&&(t=JSON.stringify(e.actionInfo.RecursiveQueryInfo));var n=this.getObjVarName(e.actionInfo.ObjectPathId)+".loadRecursive("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processSetPropertyAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+"."+Z._toCamelLowerCase(e.actionInfo.Name)+" = "+this.buildArgumentsExpression(e.actionInfo.ArgumentInfo)+";";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processTraceAction=function(e){var t="context.trace();";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processEnsureUnchangedAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".ensureUnchanged("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processUpdateAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".update("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.appendDisposeCommentIfRelevant=function(e,t){var n=this;if(this.m_showDispose){var r=t.actionInfo.L;if(r&&r.length>0)return e+" // And then dispose {"+r.map((function(e){return n.getObjVarName(e)})).join(", ")+"}"}return e},t.prototype.buildQueryExpression=function(e){if(e.actionInfo.QueryInfo){var t={};return t.select=e.actionInfo.QueryInfo.Select,t.expand=e.actionInfo.QueryInfo.Expand,t.skip=e.actionInfo.QueryInfo.Skip,t.top=e.actionInfo.QueryInfo.Top,"undefined"===typeof t.top&&"undefined"===typeof t.skip&&"undefined"===typeof t.expand?"undefined"===typeof t.select?"":JSON.stringify(t.select):JSON.stringify(t)}return""},t.prototype.buildObjectPathExpressionWithParent=function(e){return(5==e.objectPathInfo.ObjectPathType||3==e.objectPathInfo.ObjectPathType||4==e.objectPathInfo.ObjectPathType)&&e.objectPathInfo.ParentObjectPathId?this.getObjVarName(e.objectPathInfo.ParentObjectPathId)+"."+this.buildObjectPathExpression(e):this.buildObjectPathExpression(e)},t.prototype.buildObjectPathExpression=function(e){var t=this.buildObjectPathInfoExpression(e.objectPathInfo),n=e.originalObjectPathInfo;return n&&(t=t+" /* originally "+this.buildObjectPathInfoExpression(n)+" */"),t},t.prototype.buildObjectPathInfoExpression=function(e){switch(e.ObjectPathType){case 1:return"context."+this.m_globalObjName;case 5:return"getItem("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 3:return Z._toCamelLowerCase(e.Name)+"("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 2:return e.Name+".newObject()";case 7:return"null";case 4:return Z._toCamelLowerCase(e.Name);case 6:return"context."+this.m_globalObjName+"._getObjectByReferenceId("+JSON.stringify(e.Name)+")"}},t.prototype.buildArgumentsExpression=function(e){var t="";if(!e.Arguments||0===e.Arguments.length)return t;if(this.m_removePII)return"undefined"===typeof e.Arguments[0]?t:"...";for(var n=0;n<e.Arguments.length;n++)n>0&&(t+=", "),t+=this.buildArgumentLiteral(e.Arguments[n],e.ReferencedObjectPathIds?e.ReferencedObjectPathIds[n]:null);return"undefined"===t&&(t=""),t},t.prototype.buildArgumentLiteral=function(e,t){return"number"==typeof e&&e===t?this.getObjVarName(t):JSON.stringify(e)},t.prototype.getObjVarNameBase=function(e){var t="v",n=this.m_referencedObjectPaths[e];if(n)switch(n.objectPathInfo.ObjectPathType){case 1:t=this.m_globalObjName;break;case 4:t=Z._toCamelLowerCase(n.objectPathInfo.Name);break;case 3:var r=n.objectPathInfo.Name;r.length>3&&"Get"===r.substr(0,3)&&(r=r.substr(3)),t=Z._toCamelLowerCase(r);break;case 5:var o=this.getObjVarNameBase(n.objectPathInfo.ParentObjectPathId);t="s"===o.charAt(o.length-1)?o.substr(0,o.length-1):o+"Item"}return t},t.prototype.getObjVarName=function(e){if(this.m_variableNameForObjectPathMap[e])return this.m_variableNameForObjectPathMap[e];var t=this.getObjVarNameBase(e);if(!this.m_variableNameToObjectPathMap[t])return this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t;for(var n=1;this.m_variableNameToObjectPathMap[t+n.toString()];)n++;return t+=n.toString(),this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t},t}(),$=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.cannotRegisterEvent="CannotRegisterEvent",t.connectionFailureWithStatus="ConnectionFailureWithStatus",t.connectionFailureWithDetails="ConnectionFailureWithDetails",t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.moreInfoInnerError="MoreInfoInnerError",t.cannotApplyPropertyThroughSetMethod="CannotApplyPropertyThroughSetMethod",t.invalidOperationInCellEditMode="InvalidOperationInCellEditMode",t.objectIsUntracked="ObjectIsUntracked",t.customFunctionDefintionMissing="CustomFunctionDefintionMissing",t.customFunctionImplementationMissing="CustomFunctionImplementationMissing",t.customFunctionNameContainsBadChars="CustomFunctionNameContainsBadChars",t.customFunctionNameCannotSplit="CustomFunctionNameCannotSplit",t.customFunctionUnexpectedNumberOfEntriesInResultBatch="CustomFunctionUnexpectedNumberOfEntriesInResultBatch",t.customFunctionCancellationHandlerMissing="CustomFunctionCancellationHandlerMissing",t.customFunctionInvalidFunction="CustomFunctionInvalidFunction",t.customFunctionInvalidFunctionMapping="CustomFunctionInvalidFunctionMapping",t.customFunctionWindowMissing="CustomFunctionWindowMissing",t.customFunctionDefintionMissingOnWindow="CustomFunctionDefintionMissingOnWindow",t.pendingBatchInProgress="PendingBatchInProgress",t.notInsideBatch="NotInsideBatch",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(_);e.ResourceStrings=$,l.addResourceStringValues({CannotRegisterEvent:"The event handler cannot be registered.",PropertyNotLoaded:"The property '{0}' is not available. Before reading the property's value, call the load method on the containing object and call \"context.sync()\" on the associated request context.",RunMustReturnPromise:'The batch function passed to the ".run" method didn\'t return a promise. The function must return a promise, so that any automatically-tracked objects can be released at the completion of the batch operation. Typically, you return a promise by returning the response from "context.sync()".',InvalidOrTimedOutSessionMessage:"Your Office Online session has expired or is invalid. To continue, refresh the page.",InvalidOperationInCellEditMode:"Excel is in cell-editing mode. Please exit the edit mode by pressing ENTER or TAB or selecting another cell, and then try again.",InvalidSheetName:"The request cannot be processed because the specified worksheet cannot be found. Please try again.",CustomFunctionDefintionMissing:"A property with the name '{0}' that represents the function's definition must exist on Excel.Script.CustomFunctions.",CustomFunctionDefintionMissingOnWindow:"A property with the name '{0}' that represents the function's definition must exist on the window object.",CustomFunctionImplementationMissing:"The property with the name '{0}' on Excel.Script.CustomFunctions that represents the function's definition must contain a 'call' property that implements the function.",CustomFunctionNameContainsBadChars:"The function name may only contain letters, digits, underscores, and periods.",CustomFunctionNameCannotSplit:"The function name must contain a non-empty namespace and a non-empty short name.",CustomFunctionUnexpectedNumberOfEntriesInResultBatch:"The batching function returned a number of results that doesn't match the number of parameter value sets that were passed into it.",CustomFunctionCancellationHandlerMissing:"The cancellation handler onCanceled is missing in the function. The handler must be present as the function is defined as cancelable.",CustomFunctionInvalidFunction:"The property with the name '{0}' that represents the function's definition is not a valid function.",CustomFunctionInvalidFunctionMapping:"The property with the name '{0}' on CustomFunctionMappings that represents the function's definition is not a valid function.",CustomFunctionWindowMissing:"The window object was not found.",PendingBatchInProgress:"There is a pending batch in progress. The batch method may not be called inside another batch, or simultaneously with another batch.",NotInsideBatch:"Operations may not be invoked outside of a batch method.",CannotUpdateReadOnlyProperty:"The property '{0}' is read-only and it cannot be updated.",ObjectIsUntracked:"The object is untracked."});var Z=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.fixObjectPathIfNecessary=function(e,t){e&&e._objectPath&&t&&e._objectPath.updateUsingObjectData(t,e)},n.load=function(e,t){return e.context.load(e,t),e},n.loadAndSync=function(e,t){return e.context.load(e,t),e.context.sync().then((function(){return e}))},n.retrieve=function(t,r){var o=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;o||(o=!n.isSetSupported("RichApiRuntime","1.1"));var i=new L(t,o);return t._retrieve(r,i),i},n.retrieveAndSync=function(e,t){var r=n.retrieve(e,t);return e.context.sync().then((function(){return r}))},n.toJson=function(e,t,r,o){var i={};for(var a in t){"undefined"!==typeof(s=t[a])&&(i[a]=s)}for(var a in r){var s;"undefined"!==typeof(s=r[a])&&(s[n.fieldName_isCollection]&&"undefined"!==typeof s[n.fieldName_m__items]?i[a]=s.toJSON().items:i[a]=s.toJSON())}return o&&(i.items=o.map((function(e){return e.toJSON()}))),i},n.throwError=function(e,t,n){throw new r.RuntimeError({code:e,httpStatusCode:400,message:l._getResourceString(e,t),debugInfo:n?{errorLocation:n}:void 0})},n.createRuntimeError=function(e,t,n,o,i){return new r.RuntimeError({code:e,httpStatusCode:o,message:t,debugInfo:{errorLocation:n},data:i})},n.throwIfNotLoaded=function(e,t,r,o){if(!o&&l.isUndefined(t)&&e.charCodeAt(0)!=n.s_underscoreCharCode&&!n.s_suppressPropertyNotLoadedException)throw n.createPropertyNotLoadedException(r,e)},n._getPropertyValueWithoutCheckLoaded=function(e,t){n.s_suppressPropertyNotLoadedException=!0;try{return e[t]}finally{n.s_suppressPropertyNotLoadedException=!1}},n.createPropertyNotLoadedException=function(e,t){return new r.RuntimeError({code:T.propertyNotLoaded,httpStatusCode:400,message:l._getResourceString($.propertyNotLoaded,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.createCannotUpdateReadOnlyPropertyException=function(e,t){return new r.RuntimeError({code:T.cannotUpdateReadOnlyProperty,httpStatusCode:400,message:l._getResourceString($.cannotUpdateReadOnlyProperty,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.promisify=function(t){return new e.Promise((function(e,n){t((function(t){"failed"==t.status?n(t.error):e(t.value)}))}))},n._addActionResultHandler=function(e,t,n){e.context._pendingRequest.addActionResultHandler(t,n)},n._handleNavigationPropertyResults=function(e,t,n){for(var r=0;r<n.length-1;r+=2)l.isUndefined(t[n[r+1]])||e[n[r]]._handleResult(t[n[r+1]])},n._fixupApiFlags=function(e){return"boolean"===typeof e&&(e=e?1:0),e},n.definePropertyThrowUnloadedException=function(e,t,r){Object.defineProperty(e,r,{configurable:!0,enumerable:!0,get:function(){throw n.createPropertyNotLoadedException(t,r)},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(t,r)}})},n.defineReadOnlyPropertyWithValue=function(e,t,r){Object.defineProperty(e,t,{configurable:!0,enumerable:!0,get:function(){return r},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(null,t)}})},n.processRetrieveResult=function(e,t,r,o){if(!l.isNullOrUndefined(t))if(o){var i=t[H.itemsLowerCase];if(Array.isArray(i)){for(var a=[],s=0;s<i.length;s++){var c=o(i[s],s),u={};u[H.proxy]=c,c._handleRetrieveResult(i[s],u),a.push(u)}n.defineReadOnlyPropertyWithValue(r,H.itemsLowerCase,a)}}else{var d=e[H.scalarPropertyNames],f=e[H.navigationPropertyNames],p=e[H.className];if(d)for(s=0;s<d.length;s++){var h=t[m=d[s]];l.isUndefined(h)?n.definePropertyThrowUnloadedException(r,p,m):n.defineReadOnlyPropertyWithValue(r,m,h)}if(f)for(s=0;s<f.length;s++){var m;h=t[m=f[s]];if(l.isUndefined(h))n.definePropertyThrowUnloadedException(r,p,m);else{var g=e[m],y={};g._handleRetrieveResult(h,y),y[H.proxy]=g,Array.isArray(y[H.itemsLowerCase])&&(y=y[H.itemsLowerCase]),n.defineReadOnlyPropertyWithValue(r,m,y)}}}},n.setMockData=function(e,t,r,o){if(l.isNullOrUndefined(t))e._handleResult(t);else{if(e[H.scalarPropertyOriginalNames]){for(var i={},a=e[H.scalarPropertyOriginalNames],s=e[H.scalarPropertyNames],c=0;c<s.length;c++)"undefined"!==typeof t[s[c]]&&(i[a[c]]=t[s[c]]);e._handleResult(i)}if(e[H.navigationPropertyNames]){var u=e[H.navigationPropertyNames];for(c=0;c<u.length;c++)if("undefined"!==typeof t[u[c]]){var d=e[u[c]];d.setMockData&&d.setMockData(t[u[c]])}}if(e[H.isCollection]&&r){var f=Array.isArray(t)?t:t[H.itemsLowerCase];if(Array.isArray(f)){var p=[];for(c=0;c<f.length;c++){var h=r(f,c);n.setMockData(h,f[c]),p.push(h)}o(p)}}}},n.applyMixin=function(e,t){Object.getOwnPropertyNames(t.prototype).forEach((function(n){"constructor"!==n&&Object.defineProperty(e.prototype,n,Object.getOwnPropertyDescriptor(t.prototype,n))}))},n.ensureTypeInitialized=function(e){var t=new U;new e(t,K.createNewObjectObjectPath(t,"Temp",!1,0))},n.fieldName_m__items="m__items",n.fieldName_isCollection="_isCollection",n._synchronousCleanup=!1,n.s_underscoreCharCode="_".charCodeAt(0),n.s_suppressPropertyNotLoadedException=!1,n}(C);e.Utility=Z;var ee=function(){function e(){}return e.invokeMethod=function(e,t,n,r,o,i){var a=M.createMethodAction(e.context,e,t,n,r,o),s=new v(i);return Z._addActionResultHandler(e,a,s),s},e.invokeEnsureUnchanged=function(e,t){M.createEnsureUnchangedAction(e.context,e,t)},e.invokeSetProperty=function(e,t,n,r){M.createSetPropertyAction(e.context,e,t,n,r)},e.createRootServiceObject=function(e,t){return new e(t,K.createGlobalObjectObjectPath(t))},e.createObjectFromReferenceId=function(e,t,n){return new e(t,K.createReferenceIdObjectPath(t,n))},e.createTopLevelServiceObject=function(e,t,n,r,o){return new e(t,K.createNewObjectObjectPath(t,n,r,o))},e.createPropertyObject=function(e,t,n,r,o){var i=K.createPropertyObjectPath(t.context,t,n,r,!1,o);return new e(t.context,i)},e.createIndexerObject=function(e,t,n){var r=K.createIndexerObjectPath(t.context,t,n);return new e(t.context,r)},e.createMethodObject=function(e,t,n,r,o,i,a,s,c){var l=K.createMethodObjectPath(t.context,t,n,r,o,i,a,s,c);return new e(t.context,l)},e.createChildItemObject=function(e,t,n,r,o){var i=K.createChildItemObjectPathUsingIndexerOrGetItemAt(t,n.context,n,r,o);return new e(n.context,i)},e}();e.BatchApiHelper=ee;var te=function(){function t(e){if(this.m_namespaceMap={},this.m_namespace=e.metadata.name,this.m_targetNamespaceObject=e.targetNamespaceObject,this.m_namespaceMap[this.m_namespace]=e.targetNamespaceObject,e.namespaceMap)for(var t in e.namespaceMap)this.m_namespaceMap[t]=e.namespaceMap[t];this.m_defaultApiSetName=e.metadata.defaultApiSetName,this.m_hostName=e.metadata.hostName;var n=e.metadata;if(n.enumTypes)for(var r=0;r<n.enumTypes.length;r++)this.buildEnumType(n.enumTypes[r]);if(n.apiSets){for(r=0;r<n.apiSets.length;r++){var o=n.apiSets[r];Array.isArray(o)&&(n.apiSets[r]={version:o[0],name:o[1]||this.m_defaultApiSetName})}this.m_apiSets=n.apiSets}if(this.m_strings=n.strings,n.clientObjectTypes)for(r=0;r<n.clientObjectTypes.length;r++){o=n.clientObjectTypes[r];Array.isArray(o)&&(this.ensureArraySize(o,11),n.clientObjectTypes[r]={name:this.getString(o[0]),behaviorFlags:o[1],collectionPropertyPath:this.getString(o[6]),newObjectServerTypeFullName:this.getString(o[9]),newObjectApiFlags:o[10],childItemTypeFullName:this.getString(o[7]),scalarProperties:o[2],navigationProperties:o[3],scalarMethods:o[4],navigationMethods:o[5],events:o[8]}),this.buildClientObjectType(n.clientObjectTypes[r],e.fullyInitialize)}}return t.prototype.ensureArraySize=function(e,t){for(var n=t-e.length;n>0;)e.push(0),n--},t.prototype.getString=function(e){return"number"===typeof e?e>0?this.m_strings[e-1]:null:e},t.prototype.buildEnumType=function(e){var t;if(Array.isArray(e)){(t={name:e[0],fields:e[2]}).fields||(t.fields={});var n=e[1];if(Array.isArray(n))for(var r=0;r<n.length;r++)t.fields[n[r]]=this.toSimpleCamelUpperCase(n[r])}else t=e;this.m_targetNamespaceObject[t.name]=t.fields},t.prototype.buildClientObjectType=function(n,r){var o=this,i=function(t,r){k.apply(this,arguments),o.m_targetNamespaceObject[n.name]._typeInited||(o.buildPrototype(o.m_targetNamespaceObject[n.name],n),o.m_targetNamespaceObject[n.name]._typeInited=!0),e._internalConfig.appendTypeNameToObjectPathInfo&&this._objectPath&&this._objectPath.objectPathInfo&&this._className&&(this._objectPath.objectPathInfo.T=this._className)};(this.m_targetNamespaceObject[n.name]=i,this.extendsType(i,k),this.buildNewObject(i,n),0!==(2&n.behaviorFlags)&&(i.prototype._KeepReference=function(){ee.invokeMethod(this,"_KeepReference",1,[],0,0)}),0!==(32&n.behaviorFlags))&&this.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_StaticCustomize").call(null,i);r&&(this.buildPrototype(i,n),i._typeInited=!0)},t.prototype.extendsType=function(e,t){function n(){this.constructor=e}e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},t.prototype.findObjectUnderPath=function(t,n,r){for(var o=t,i=r;i<n.length;i++){if("object"!==typeof o)throw new e.Error("Cannot find "+n.join("."));o=o[n[i]]}return o},t.prototype.getFunction=function(t){var n=this.resolveObjectByFullName(t);if("function"!==typeof n)throw new e.Error("Cannot find function or type: "+t);return n},t.prototype.resolveObjectByFullName=function(e){var t=e.split(".");if(1===t.length)return this.m_targetNamespaceObject[t[0]];var n=t[0];return n===this.m_namespace?this.findObjectUnderPath(this.m_targetNamespaceObject,t,1):this.m_namespaceMap[n]?this.findObjectUnderPath(this.m_namespaceMap[n],t,1):this.findObjectUnderPath(this.m_targetNamespaceObject,t,0)},t.prototype.evaluateSimpleExpression=function(t,n){if(Z.isNullOrUndefined(t))return null;var r=t.split(".");if(3===r.length&&"OfficeExtension"===r[0]&&"Constants"===r[1])return H[r[2]];if("this"===r[0]){for(var o=n,i=1;i<r.length;i++)o="toString()"==r[i]?o.toString():"()"===r[i].substr(r[i].length-2)?o[r[i].substr(0,r[i].length-2)]():o[r[i]];return o}throw new e.Error("Cannot evaluate: "+t)},t.prototype.evaluateEventTargetId=function(e,t){return Z.isNullOrEmptyString(e)?"":this.evaluateSimpleExpression(e,t)},t.prototype.isAllDigits=function(e){for(var t="0".charCodeAt(0),n="9".charCodeAt(0),r=0;r<e.length;r++)if(e.charCodeAt(r)<t||e.charCodeAt(r)>n)return!1;return!0},t.prototype.evaluateEventType=function(t){if(Z.isNullOrEmptyString(t))return 0;if(this.isAllDigits(t))return parseInt(t);var n=this.resolveObjectByFullName(t);if("number"!==typeof n)throw new e.Error("Invalid event type: "+t);return n},t.prototype.buildPrototype=function(e,t){this.buildScalarProperties(e,t),this.buildNavigationProperties(e,t),this.buildScalarMethods(e,t),this.buildNavigationMethods(e,t),this.buildEvents(e,t),this.buildHandleResult(e,t),this.buildHandleIdResult(e,t),this.buildHandleRetrieveResult(e,t),this.buildLoad(e,t),this.buildRetrieve(e,t),this.buildSetMockData(e,t),this.buildEnsureUnchanged(e,t),this.buildUpdate(e,t),this.buildSet(e,t),this.buildToJSON(e,t),this.buildItems(e,t),this.buildTypeMetadataInfo(e,t),this.buildTrackUntrack(e,t),this.buildMixin(e,t)},t.prototype.toSimpleCamelUpperCase=function(e){return e.substr(0,1).toUpperCase()+e.substr(1)},t.prototype.ensureOriginalName=function(e){null===e.originalName&&(e.originalName=this.toSimpleCamelUpperCase(e.name))},t.prototype.getFieldName=function(e){return"m_"+e.name},t.prototype.throwIfApiNotSupported=function(e,t){if(this.m_apiSets&&t.apiSetInfoOrdinal>0){var n=this.m_apiSets[t.apiSetInfoOrdinal-1];n&&Z.throwIfApiNotSupported(e.name+"."+t.name,n.name,n.version,this.m_hostName)}},t.prototype.buildScalarProperties=function(e,t){if(Array.isArray(t.scalarProperties))for(var n=0;n<t.scalarProperties.length;n++){var r=t.scalarProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,6),t.scalarProperties[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],originalName:this.getString(r[3]),setMethodApiFlags:r[4],undoableApiSetInfoOrdinal:r[5]}),this.buildScalarProperty(e,t,t.scalarProperties[n])}},t.prototype.calculateApiFlags=function(e,t){if(t>0){var n=this.m_apiSets[t-1];n&&(e=C.calculateApiFlags(e,n.name,n.version))}return e},t.prototype.buildScalarProperty=function(e,n,r){this.ensureOriginalName(r);var o=this,i=this.getFieldName(r),a={get:function(){return Z.throwIfNotLoaded(r.name,this[i],n.name,this._isNull),o.throwIfApiNotSupported(n,r),this[i]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[i]=e;var a=o.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildNavigationProperties=function(e,t){if(Array.isArray(t.navigationProperties))for(var n=0;n<t.navigationProperties.length;n++){var r=t.navigationProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,8),t.navigationProperties[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[4]),getMethodApiFlags:r[5],setMethodApiFlags:r[6],propertyTypeFullName:this.getString(r[1]),undoableApiSetInfoOrdinal:r[7]}),this.buildNavigationProperty(e,t,t.navigationProperties[n])}},t.prototype.buildNavigationProperty=function(e,n,r){this.ensureOriginalName(r);var o=this,i=this.getFieldName(r),a={get:function(){(this[o.getFieldName(r)]||(o.throwIfApiNotSupported(n,r),this[i]=ee.createPropertyObject(o.getFunction(r.propertyTypeFullName),this,r.originalName,0!==(16&r.behaviorFlags),r.getMethodApiFlags)),64&r.behaviorFlags)&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Get").call(this,this,this[i]);return this[i]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[i]=e;var a=o.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildScalarMethods=function(e,t){if(Array.isArray(t.scalarMethods))for(var n=0;n<t.scalarMethods.length;n++){var r=t.scalarMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.scalarMethods[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[5]),apiFlags:r[4],parameterCount:r[1],undoableApiSetInfoOrdinal:r[6]}),this.buildScalarMethod(e,t,t.scalarMethods[n])}},t.prototype.buildScalarMethod=function(e,n,r){this.ensureOriginalName(r);var o=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var i=0;i<r.parameterCount-1;i++)e.push(arguments[i]);var a=[];for(i=r.parameterCount-1;i<arguments.length;i++)a.push(arguments[i]);e.push(a)}else for(i=0;i<arguments.length;i++)e.push(arguments[i]);if(1&r.behaviorFlags){var s=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(i=0;i<e.length;i++)c.push(e[i]);var l=s.apply(this,c),u=l.handled,d=l.result;if(u)return d}o.throwIfApiNotSupported(n,r);var f=0;32&r.behaviorFlags&&(f=1);var p=0;2&r.behaviorFlags&&(p=1);var h=o.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.invokeMethod(this,r.originalName,p,e,h,f)}},t.prototype.buildNavigationMethods=function(e,t){if(Array.isArray(t.navigationMethods))for(var n=0;n<t.navigationMethods.length;n++){var r=t.navigationMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,9),t.navigationMethods[n]={name:this.getString(r[0]),behaviorFlags:r[3],apiSetInfoOrdinal:r[4],originalName:this.getString(r[6]),apiFlags:r[5],parameterCount:r[2],returnTypeFullName:this.getString(r[1]),returnObjectGetByIdMethodName:this.getString(r[7]),undoableApiSetInfoOrdinal:r[8]}),this.buildNavigationMethod(e,t,t.navigationMethods[n])}},t.prototype.buildNavigationMethod=function(e,n,r){this.ensureOriginalName(r);var o=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var i=0;i<r.parameterCount-1;i++)e.push(arguments[i]);var a=[];for(i=r.parameterCount-1;i<arguments.length;i++)a.push(arguments[i]);e.push(a)}else for(i=0;i<arguments.length;i++)e.push(arguments[i]);if(1&r.behaviorFlags){var s=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(i=0;i<e.length;i++)c.push(e[i]);var l=s.apply(this,c),u=l.handled,d=l.result;if(u)return d}if(o.throwIfApiNotSupported(n,r),0!==(16&r.behaviorFlags))return ee.createIndexerObject(o.getFunction(r.returnTypeFullName),this,e);var f=0;2&r.behaviorFlags&&(f=1);var p=o.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.createMethodObject(o.getFunction(r.returnTypeFullName),this,r.originalName,f,e,0!==(4&r.behaviorFlags),0!==(8&r.behaviorFlags),r.returnObjectGetByIdMethodName,p)}},t.prototype.buildHandleResult=function(e,n){var r=this;e.prototype._handleResult=function(e){if(k.prototype._handleResult.call(this,e),!Z.isNullOrUndefined(e)){if(Z.fixObjectPathIfNecessary(this,e),8&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleResult").call(this,this,e);if(n.scalarProperties)for(var o=0;o<n.scalarProperties.length;o++)Z.isUndefined(e[n.scalarProperties[o].originalName])||(0!==(8&n.scalarProperties[o].behaviorFlags)?this[r.getFieldName(n.scalarProperties[o])]=Z.adjustToDateTime(e[n.scalarProperties[o].originalName]):this[r.getFieldName(n.scalarProperties[o])]=e[n.scalarProperties[o].originalName]);if(n.navigationProperties){for(var i=[],a=0;a<n.navigationProperties.length;a++)i.push(n.navigationProperties[a].name),i.push(n.navigationProperties[a].originalName);Z._handleNavigationPropertyResults(this,e,i)}if(0!==(1&n.behaviorFlags)){var s=r.hasIndexMethod(n);if(!Z.isNullOrUndefined(e[H.items])){this.m__items=[];for(var c=e[H.items],l=r.getFunction(n.childItemTypeFullName),u=0;u<c.length;u++){var d=ee.createChildItemObject(l,s,this,c[u],u);d._handleResult(c[u]),this.m__items.push(d)}}}}}},t.prototype.buildHandleRetrieveResult=function(e,t){var n=this;e.prototype._handleRetrieveResult=function(e,r){if(k.prototype._handleRetrieveResult.call(this,e,r),!Z.isNullOrUndefined(e)){if(t.scalarProperties)for(var o=0;o<t.scalarProperties.length;o++)8&t.scalarProperties[o].behaviorFlags&&(Z.isNullOrUndefined(e[t.scalarProperties[o].name])||(e[t.scalarProperties[o].name]=Z.adjustToDateTime(e[t.scalarProperties[o].name])));if(1&t.behaviorFlags){var i=n.hasIndexMethod(t),a=n.getFunction(t.childItemTypeFullName),s=this;Z.processRetrieveResult(s,e,r,(function(e,t){return ee.createChildItemObject(a,i,s,e,t)}))}else Z.processRetrieveResult(this,e,r)}}},t.prototype.buildHandleIdResult=function(e,n){var r=this;e.prototype._handleIdResult=function(e){if(k.prototype._handleIdResult.call(this,e),!Z.isNullOrUndefined(e)){if(16&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleIdResult").call(this,this,e);if(n.scalarProperties)for(var o=0;o<n.scalarProperties.length;o++){var i=n.scalarProperties[o].originalName;"Id"!==i&&"_Id"!==i&&"_ReferenceId"!==i||Z.isNullOrUndefined(e[n.scalarProperties[o].originalName])||(this[r.getFieldName(n.scalarProperties[o])]=e[n.scalarProperties[o].originalName])}}}},t.prototype.buildLoad=function(e,t){e.prototype.load=function(e){return Z.load(this,e)}},t.prototype.buildRetrieve=function(e,t){e.prototype.retrieve=function(e){return Z.retrieve(this,e)}},t.prototype.buildNewObject=function(e,t){Z.isNullOrEmptyString(t.newObjectServerTypeFullName)||(e.newObject=function(n){return ee.createTopLevelServiceObject(e,n,t.newObjectServerTypeFullName,0!==(1&t.behaviorFlags),t.newObjectApiFlags)})},t.prototype.buildSetMockData=function(e,t){var n=this;if(1&t.behaviorFlags){var r=n.hasIndexMethod(t);e.prototype.setMockData=function(e){var o=this;Z.setMockData(o,e,(function(e,i){return ee.createChildItemObject(n.getFunction(t.childItemTypeFullName),r,o,e,i)}),(function(e){o.m__items=e}))}}else e.prototype.setMockData=function(e){Z.setMockData(this,e)}},t.prototype.buildEnsureUnchanged=function(e,t){e.prototype.ensureUnchanged=function(e){ee.invokeEnsureUnchanged(this,e)}},t.prototype.buildUpdate=function(e,t){e.prototype.update=function(e){this._recursivelyUpdate(e)}},t.prototype.buildSet=function(e,t){if(0===(1&t.behaviorFlags)){var n=[],r=[];if(t.scalarProperties)for(var o=0;o<t.scalarProperties.length;o++)0===(2&t.scalarProperties[o].behaviorFlags)&&0!==(1&t.scalarProperties[o].behaviorFlags)?r.push(t.scalarProperties[o].name):n.push(t.scalarProperties[o].name);var i=[];if(t.navigationProperties)for(o=0;o<t.navigationProperties.length;o++)0!==(16&t.navigationProperties[o].behaviorFlags)||0===(1&t.navigationProperties[o].behaviorFlags)||0===(32&t.navigationProperties[o].behaviorFlags)?n.push(t.navigationProperties[o].name):i.push(t.navigationProperties[o].name);0===i.length&&0===r.length||(e.prototype.set=function(e,t){this._recursivelySet(e,t,r,i,n)})}},t.prototype.buildItems=function(e,t){0!==(1&t.behaviorFlags)&&Object.defineProperty(e.prototype,"items",{get:function(){return Z.throwIfNotLoaded("items",this.m__items,t.name,this._isNull),this.m__items},enumerable:!0,configurable:!0})},t.prototype.buildToJSON=function(e,t){var n=this;0===(1&t.behaviorFlags)?e.prototype.toJSON=function(){var e={};if(t.scalarProperties)for(var r=0;r<t.scalarProperties.length;r++)0!==(1&t.scalarProperties[r].behaviorFlags)&&(e[t.scalarProperties[r].name]=this[n.getFieldName(t.scalarProperties[r])]);var o={};if(t.navigationProperties)for(r=0;r<t.navigationProperties.length;r++)0!==(1&t.navigationProperties[r].behaviorFlags)&&(o[t.navigationProperties[r].name]=this[n.getFieldName(t.navigationProperties[r])]);return Z.toJson(this,e,o)}:e.prototype.toJSON=function(){return Z.toJson(this,{},{},this.m__items)}},t.prototype.buildTypeMetadataInfo=function(e,t){Object.defineProperty(e.prototype,"_className",{get:function(){return t.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_isCollection",{get:function(){return 0!==(1&t.behaviorFlags)},enumerable:!0,configurable:!0}),Z.isNullOrEmptyString(t.collectionPropertyPath)||Object.defineProperty(e.prototype,"_collectionPropertyPath",{get:function(){return t.collectionPropertyPath},enumerable:!0,configurable:!0}),t.scalarProperties&&t.scalarProperties.length>0&&(Object.defineProperty(e.prototype,"_scalarPropertyNames",{get:function(){return this.m__scalarPropertyNames||(this.m__scalarPropertyNames=t.scalarProperties.map((function(e){return e.name}))),this.m__scalarPropertyNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyOriginalNames",{get:function(){return this.m__scalarPropertyOriginalNames||(this.m__scalarPropertyOriginalNames=t.scalarProperties.map((function(e){return e.originalName}))),this.m__scalarPropertyOriginalNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyUpdateable",{get:function(){return this.m__scalarPropertyUpdateable||(this.m__scalarPropertyUpdateable=t.scalarProperties.map((function(e){return 0===(2&e.behaviorFlags)}))),this.m__scalarPropertyUpdateable},enumerable:!0,configurable:!0})),t.navigationProperties&&t.navigationProperties.length>0&&Object.defineProperty(e.prototype,"_navigationPropertyNames",{get:function(){return this.m__navigationPropertyNames||(this.m__navigationPropertyNames=t.navigationProperties.map((function(e){return e.name}))),this.m__navigationPropertyNames},enumerable:!0,configurable:!0})},t.prototype.buildTrackUntrack=function(e,t){2&t.behaviorFlags&&(e.prototype.track=function(){return this.context.trackedObjects.add(this),this},e.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this})},t.prototype.buildMixin=function(e,t){if(4&t.behaviorFlags){var n=this.getFunction(t.name+"Custom");Z.applyMixin(e,n)}},t.prototype.getOnEventName=function(e){return"_"===e[0]?"_on"+e.substr(1):"on"+e},t.prototype.buildEvents=function(e,t){if(t.events)for(var n=0;n<t.events.length;n++){var r=t.events[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.events[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],typeExpression:this.getString(r[3]),targetIdExpression:this.getString(r[4]),register:this.getString(r[5]),unregister:this.getString(r[6])}),this.buildEvent(e,t,t.events[n])}},t.prototype.buildEvent=function(e,t,n){1&n.behaviorFlags?this.buildV0Event(e,t,n):this.buildV2Event(e,t,n)},t.prototype.buildV2Event=function(e,n,r){var o=this,i=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,i,{get:function(){if(!this[a]){o.throwIfApiNotSupported(n,r);var e=this,i=null;"null"!==r.register&&(i=this[r.register].bind(this));var s=null;"null"!==r.unregister&&(s=this[r.unregister].bind(this));var c=null;2&r.behaviorFlags&&(c=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));var l=o.evaluateEventType(r.typeExpression);this[a]=new z(this.context,this,r.name,{eventType:l,getTargetIdFunc:function(){return o.evaluateEventTargetId(r.targetIdExpression,e)},registerFunc:i,unregisterFunc:s,eventArgsTransformFunc:function(t){return c&&(t=c.call(e,e,t)),Z._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.buildV0Event=function(e,n,r){var o=this,i=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,i,{get:function(){if(!this[a]){o.throwIfApiNotSupported(n,r);var e=this,i=null;if(Z.isNullOrEmptyString(r.register)){var s=o.evaluateEventType(r.typeExpression);i=function(t){var n=o.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.register(s,n,t)}}else if("null"!==r.register){var c=o.getFunction(r.register);i=function(t){return c.call(e,e,t)}}var l=null;if(Z.isNullOrEmptyString(r.unregister)){var u=o.evaluateEventType(r.typeExpression);l=function(t){var n=o.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.unregister(u,n,t)}}else if("null"!==r.unregister){var d=o.getFunction(r.unregister);l=function(t){return d.call(e,e,t)}}var f=null;2&r.behaviorFlags&&(f=o.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));this[a]=new W(this.context,this,r.name,{registerFunc:i,unregisterFunc:l,eventArgsTransformFunc:function(t){return f&&(t=f.call(e,e,t)),Z._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.hasIndexMethod=function(e){var t=!1;if(e.navigationMethods)for(var n=0;n<e.navigationMethods.length;n++)if(0!==(16&e.navigationMethods[n].behaviorFlags)){t=!0;break}return t},t.CustomizationCodeNamespace="_CC",t}();e.LibraryBuilder=te;var ne,re=1,oe=function(e){return e.DdaMethod.Version=re,e},ie=function(e){return re=e.Version,e.Error&&(e.error={},e.error.Code=e.Error),e};!function(e){e.SendingId="sId",e.RespondingId="rId",e.CommandKey="command",e.SessionInfoKey="sessionInfo",e.ParamsKey="params",e.ApiReadyCommand="apiready",e.ExecuteMethodCommand="executeMethod",e.GetAppContextCommand="getAppContext",e.RegisterEventCommand="registerEvent",e.UnregisterEventCommand="unregisterEvent",e.FireEventCommand="fireEvent"}(ne||(ne={}));var ae=function(){function e(){}return e.sessionContext="sc",e.embeddingPageOrigin="EmbeddingPageOrigin",e.embeddingPageSessionInfo="EmbeddingPageSessionInfo",e}();e.EmbeddedConstants=ae;var se=function(e){function t(t,n){var r=e.call(this)||this;return r.m_chosenWindow=null,r.m_chosenOrigin=null,r.m_enabled=!0,r.m_onMessageHandler=r._onMessage.bind(r),r.m_callbackList={},r.m_id=0,r.m_timeoutId=-1,r.m_appContext=null,r.m_url=t,r.m_options=n,r.m_options||(r.m_options={sessionKey:Math.random().toString()}),r.m_options.sessionKey||(r.m_options.sessionKey=Math.random().toString()),r.m_options.container||(r.m_options.container=document.body),r.m_options.timeoutInMilliseconds||(r.m_options.timeoutInMilliseconds=6e4),r.m_options.height||(r.m_options.height="400px"),r.m_options.width||(r.m_options.width="100%"),r.m_options.webApplication&&r.m_options.webApplication.accessToken&&r.m_options.webApplication.accessTokenTtl||(r.m_options.webApplication=null),r}return __extends(t,e),t.prototype._getIFrameSrc=function(){var e=window.location.protocol+"//"+window.location.host,t=ae.embeddingPageOrigin+"="+encodeURIComponent(e)+"&"+ae.embeddingPageSessionInfo+"="+encodeURIComponent(this.m_options.sessionKey),n=!1;(this.m_url.toLowerCase().indexOf("/_layouts/preauth.aspx")>0||this.m_url.toLowerCase().indexOf("/_layouts/15/preauth.aspx")>0)&&(n=!0);var r=document.createElement("a");if(r.href=this.m_url,this.m_options.webApplication){var o=ae.embeddingPageOrigin+"="+e+"&"+ae.embeddingPageSessionInfo+"="+this.m_options.sessionKey;0===r.search.length||"?"===r.search?r.search="?"+ae.sessionContext+"="+encodeURIComponent(o):r.search=r.search+"&"+ae.sessionContext+"="+encodeURIComponent(o)}else n?0===r.hash.length||"#"===r.hash?r.hash="#"+t:r.hash=r.hash+"&"+t:0===r.search.length||"?"===r.search?r.search="?"+t:r.search=r.search+"&"+t;return r.href},t.prototype.init=function(){var e=this;window.addEventListener("message",this.m_onMessageHandler);var t=this._getIFrameSrc();return l.createPromise((function(n,r){var o=document.createElement("iframe");if(e.m_options.id&&(o.id=e.m_options.id,o.name=e.m_options.id),o.style.height=e.m_options.height,o.style.width=e.m_options.width,e.m_options.webApplication){var s=document.createElement("form");s.setAttribute("action",t),s.setAttribute("method","post"),s.setAttribute("target",o.name),e.m_options.container.appendChild(s);var c=document.createElement("input");c.setAttribute("type","hidden"),c.setAttribute("name","access_token"),c.setAttribute("value",e.m_options.webApplication.accessToken),s.appendChild(c);var u=document.createElement("input");u.setAttribute("type","hidden"),u.setAttribute("name","access_token_ttl"),u.setAttribute("value",e.m_options.webApplication.accessTokenTtl),s.appendChild(u),e.m_options.container.appendChild(o),s.submit()}else o.src=t,e.m_options.container.appendChild(o);e.m_timeoutId=window.setTimeout((function(){e.close();var t=Z.createRuntimeError(i.timeout,l._getResourceString(a.timeout),"EmbeddedSession.init");r(t)}),e.m_options.timeoutInMilliseconds),e.m_promiseResolver=n}))},t.prototype._invoke=function(e,t,n){this.m_enabled?(oe&&(n=oe(n)),this._sendMessageWithCallback(this.m_id++,e,n,(function(e){ie&&(e=ie(e));var n=e.Error;delete e.Error,t(n||0,e)}))):t(5001,null)},t.prototype.close=function(){window.removeEventListener("message",this.m_onMessageHandler),window.clearTimeout(this.m_timeoutId),this.m_enabled=!1},t.prototype.getEventRegistration=function(e){return this.m_sessionEventManager||(this.m_sessionEventManager=new V(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this))),this.m_sessionEventManager},t.prototype._createRequestExecutorOrNull=function(){return new ce(this)},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return l._createPromiseFromResult(null)},t.prototype._registerEventImpl=function(e,t){var n=this;return l.createPromise((function(r,o){n._sendMessageWithCallback(n.m_id++,ne.RegisterEventCommand,{EventId:e,TargetId:t},(function(){r(null)}))}))},t.prototype._unregisterEventImpl=function(e,t){var n=this;return l.createPromise((function(r,o){n._sendMessageWithCallback(n.m_id++,ne.UnregisterEventCommand,{EventId:e,TargetId:t},(function(){r()}))}))},t.prototype._onMessage=function(e){var t=this;if(this.m_enabled&&(!this.m_chosenWindow||this.m_chosenWindow===e.source&&this.m_chosenOrigin===e.origin)){var n=e.data;if(n&&n[ne.CommandKey]===ne.ApiReadyCommand)!this.m_chosenWindow&&this._isValidDescendant(e.source)&&n[ne.SessionInfoKey]===this.m_options.sessionKey&&(this.m_chosenWindow=e.source,this.m_chosenOrigin=e.origin,this._sendMessageWithCallback(this.m_id++,ne.GetAppContextCommand,null,(function(e){t._setupContext(e),window.clearTimeout(t.m_timeoutId),t.m_promiseResolver()})));else if(n&&n[ne.CommandKey]===ne.FireEventCommand){var r=n[ne.ParamsKey],o=r.EventId,i=r.TargetId,a=r.Data;if(this.m_sessionEventManager)for(var s=this.m_sessionEventManager.getHandlers(o,i),c=0;c<s.length;c++)s[c](a)}else if(n&&n.hasOwnProperty(ne.RespondingId)){var l=n[ne.RespondingId];if(this.m_callbackList.hasOwnProperty(l)){var u=this.m_callbackList[l];"function"===typeof u&&u(n[ne.ParamsKey]),delete this.m_callbackList[l]}}}},t.prototype._sendMessageWithCallback=function(e,t,n,r){this.m_callbackList[e]=r;var o={};o[ne.SendingId]=e,o[ne.CommandKey]=t,o[ne.ParamsKey]=n,this.m_chosenWindow.postMessage(JSON.stringify(o),this.m_chosenOrigin)},t.prototype._isValidDescendant=function(e){function t(n){if(n===e)return!0;for(var r=0,o=n.frames.length;r<o;r++)if(t(n.frames[r]))return!0;return!1}for(var n=(this.m_options.container||document.body).getElementsByTagName("iframe"),r=0,o=n.length;r<o;r++)if(t(n[r].contentWindow))return!0;return!1},t.prototype._setupContext=function(e){this.m_appContext=e},t}(t);e.EmbeddedSession=se;var ce=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(t,n,r){var o=this,i=c.buildMessageArrayForIRequestExecutor(t,n,r,e.SourceLibHeaderValue);return l.createPromise((function(t,n){o.m_session._invoke(ne.ExecuteMethodCommand,(function(e,n){var r;l.log("Response:"),l.log(JSON.stringify(n)),r=0==e?c.buildResponseOnSuccess(c.getResponseBodyFromSafeArray(n.Data),c.getResponseHeadersFromSafeArray(n.Data)):c.buildResponseOnError(n.error.Code,n.error.Message),t(r)}),e._transformMessageArrayIntoParams(i))}))},e._transformMessageArrayIntoParams=function(t){return{ArrayData:t,DdaMethod:{DispatchId:e.DispidExecuteRichApiRequestMethod}}},e.DispidExecuteRichApiRequestMethod=93,e.SourceLibHeaderValue="Embedded",e}()}(OfficeExtension||(OfficeExtension={}));__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();var OfficeFirstPartyDialog,OfficeFirstPartyAuth,OfficeCore,Office,OfficeFirstParty,__awaiter=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(o,i){function a(e){try{c(r.next(e))}catch(e){i(e)}}function s(e){try{c(r.throw(e))}catch(e){i(e)}}function c(e){e.done?o(e.value):new n((function(t){t(e.value)})).then(a,s)}c((r=r.apply(e,t||[])).next())}))},__generator=this&&this.__generator||function(e,t){var n,r,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"===typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,r=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!(o=(o=a.trys).length>0&&o[o.length-1])&&(6===i[0]||2===i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}};!function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),o=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),i=OfficeExtension.Utility.fixObjectPathIfNecessary,a=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),s=function(s){function c(){return null!==s&&s.apply(this,arguments)||this}return __extends(c,s),Object.defineProperty(c.prototype,"_className",{get:function(){return"BiShim"},enumerable:!0,configurable:!0}),c.prototype.initialize=function(e){n(this,"Initialize",0,[e],0,0)},c.prototype.getData=function(){return n(this,"getData",1,[],4,0)},c.prototype.setVisualObjects=function(e){n(this,"setVisualObjects",0,[e],2,0)},c.prototype.setVisualObjectsToPersist=function(e){n(this,"setVisualObjectsToPersist",0,[e],2,0)},c.prototype._handleResult=function(e){(s.prototype._handleResult.call(this,e),r(e))||i(this,e)},c.prototype._handleRetrieveResult=function(e,t){s.prototype._handleRetrieveResult.call(this,e,t),a(this,e,t)},c.newObject=function(n){return t(e.BiShim,n,"Microsoft.AgaveVisual.BiShim",!1,4)},c.prototype.toJSON=function(){return o(this,{},{})},c}(OfficeExtension.ClientObject);e.BiShim=s,function(e){e.generalException1="GeneralException"}(e.AgaveVisualErrorCodes||(e.AgaveVisualErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject;var t=OfficeExtension.BatchApiHelper.createMethodObject,n=(OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),o=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,i=(OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),a=OfficeExtension.Utility.isUndefined,s=OfficeExtension.Utility.throwIfNotLoaded,c=(OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load),l=OfficeExtension.Utility.retrieve,u=OfficeExtension.Utility.toJson,d=OfficeExtension.Utility.fixObjectPathIfNecessary,f=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),p=function(o){function a(){return null!==o&&o.apply(this,arguments)||this}return __extends(a,o),Object.defineProperty(a.prototype,"_className",{get:function(){return"FlightingService"},enumerable:!0,configurable:!0}),a.prototype.getClientSessionId=function(){return r(this,"GetClientSessionId",1,[],4,0)},a.prototype.getDeferredFlights=function(){return r(this,"GetDeferredFlights",1,[],4,0)},a.prototype.getFeature=function(n,r,o,i){return t(e.ABType,this,"GetFeature",1,[n,r,o,i],!1,!1,null,4)},a.prototype.getFeatureGate=function(n,r){return t(e.ABType,this,"GetFeatureGate",1,[n,r],!1,!1,null,4)},a.prototype.resetOverride=function(e){r(this,"ResetOverride",0,[e],0,0)},a.prototype.setOverride=function(e,t,n){r(this,"SetOverride",0,[e,t,n],0,0)},a.prototype._handleResult=function(e){(o.prototype._handleResult.call(this,e),i(e))||d(this,e)},a.prototype._handleRetrieveResult=function(e,t){o.prototype._handleRetrieveResult.call(this,e,t),f(this,e,t)},a.newObject=function(t){return n(e.FlightingService,t,"Microsoft.Experiment.FlightingService",!1,4)},a.prototype.toJSON=function(){return u(this,{},{})},a}(OfficeExtension.ClientObject);e.FlightingService=p;var h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"ABType"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return s("value",this._V,"ABType",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!i(t)){var n=t;d(this,n),a(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return c(this,e)},t.prototype.retrieve=function(e){return l(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),f(this,t,n)},t.prototype.toJSON=function(){return u(this,{value:this._V},{})},t.prototype.ensureUnchanged=function(e){o(this,e)},t}(OfficeExtension.ClientObject);e.ABType=h,function(e){e.boolean="Boolean",e.integer="Integer",e.string="String"}(e.FeatureType||(e.FeatureType={})),function(e){e.generalException="GeneralException"}(e.ExperimentErrorCodes||(e.ExperimentErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t,n=function(){function e(e){this._dialogService=e}return e.prototype.close=function(){return this._dialogService.close(),this._dialogService.context.sync()},e.prototype.messageChild=function(e,t){DialogApiManager&&DialogApiManager.messageChildRichApiBridge&&DialogApiManager.messageChildRichApiBridge(e,t)},e}();e.Dialog=n,e.displayWebDialog=function(t,n){return void 0===n&&(n={}),new OfficeExtension.CoreUtility.Promise((function(o,i){if(n.width&&n.height&&(!r(n.width)||!r(n.height)))throw new OfficeExtension.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var a=new OfficeExtension.ClientRequestContext,s=OfficeCore.FirstPartyDialogService.newObject(a),c=new e.Dialog(s),l=s.onDialogMessage.add((function(e){OfficeExtension.Utility.log("dialogMessageHandler:"+JSON.stringify(e));var t=JSON.parse(e.message),r=t.errorCode?new OfficeExtension.Error(function(e){var t,n=((t={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},t[12003]={code:"InvalidUrl",message:"HTTPS is required."},t[12004]={code:"Untrusted",message:"Domain is not trusted."},t[12005]={code:"InvalidUrl",message:"HTTPS is required."},t[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},t);return n[e]?n[e]:{code:"Unknown",message:"An unknown error has occured with code: "+e}}(t.errorCode)):null,s=t.type,u=t.origin,d=t.message;switch(s){case 17:r?i(r):o(c);break;case 12:n.onMessage&&n.onMessage(d,c,u);break;case 10:default:12006===t.errorCode?(l&&(l.remove(),a.sync()),n.onClose&&n.onClose()):n.onRuntimeError&&(n.onRuntimeError(r,c),i(r))}return OfficeExtension.CoreUtility.Promise.resolve()}));return a.sync().then((function(){var e={width:n.width?parseInt(n.width):50,height:n.height?parseInt(n.height):50,displayInIFrame:n.displayInIFrame,dialogTitle:n.dialogTitle};return s.displayDialog(t,e),a.sync()})).catch((function(e){i(e)}))}));function r(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}},function(e){e[e.dialogMessageReceived=0]="dialogMessageReceived",e[e.dialogEventReceived=1]="dialogEventReceived"}(t||(t={}))}(OfficeFirstPartyDialog||(OfficeFirstPartyDialog={})),function(e){e.OfficeOnlineDomainList=["*.dod.online.office365.us","*.gov.online.office365.us","*.officeapps-df.live.com","*.officeapps.live.com","*.online.office.de","*.partner.officewebapps.cn"],e.isHostOriginTrusted=function(){if("undefined"===typeof window.external||"undefined"===typeof window.external.GetContext){var t=OSF.getClientEndPoint()._targetUrl,n=function(e){return e.split("/")[2].split(":")[0].split("?")[0]}(t);return 0!=t.indexOf("https:")||e.OfficeOnlineDomainList.forEach((function(e){if(0==e.indexOf("*.")&&(e=e.substring(2)),n.indexOf(e)==n.length-e.length)return!0})),!1}return!0}}(OfficeCore||(OfficeCore={})),function(e){var t=function(){function t(e){this.context=e}return Object.defineProperty(t.prototype,"roamingSettings",{get:function(){return this.m_roamingSettings||(this.m_roamingSettings=e.AuthenticationService.newObject(this.context).roamingSettings),this.m_roamingSettings},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"tap",{get:function(){return this.m_tap||(this.m_tap=e.Tap.newObject(this.context)),this.m_tap},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"skill",{get:function(){return this.m_skill||(this.m_skill=e.Skill.newObject(this.context)),this.m_skill},enumerable:!0,configurable:!0}),t}();e.FirstPartyApis=t;var n=function(n){function r(e){return n.call(this,e)||this}return __extends(r,n),Object.defineProperty(r.prototype,"firstParty",{get:function(){return this.m_firstPartyApis||(this.m_firstPartyApis=new t(this)),this.m_firstPartyApis},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flighting",{get:function(){return this.flightingService},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"telemetry",{get:function(){return this.m_telemetry||(this.m_telemetry=e.TelemetryService.newObject(this)),this.m_telemetry},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ribbon",{get:function(){return this.m_ribbon||(this.m_ribbon=e.DynamicRibbon.newObject(this)),this.m_ribbon},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"bi",{get:function(){return this.m_biShim||(this.m_biShim=e.BiShim.newObject(this)),this.m_biShim},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flightingService",{get:function(){return this.m_flightingService||(this.m_flightingService=e.FlightingService.newObject(this)),this.m_flightingService},enumerable:!0,configurable:!0}),r}(OfficeExtension.ClientRequestContext);e.RequestContext=n,e.run=function(t,n){return OfficeExtension.ClientRequestContext._runBatch("OfficeCore.run",arguments,(function(t){return new e.RequestContext(t)}))}}(OfficeCore||(OfficeCore={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.isFeatureEnabled=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),i=o.isFeatureEnabled(e,n),[4,r.sync()];case 1:return a.sent(),[2,i.value]}}))}))},e.getFeatureTier=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),i=o.getFeatureTier(e,n),[4,r.sync()];case 1:return a.sent(),[2,i.value]}}))}))},e.isFreemiumUpsellEnabled=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.License.newObject(e),r=n.isFreemiumUpsellEnabled(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))},e.launchUpsellExperience=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.License.newObject(n).launchUpsellExperience(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onFeatureStateChanged=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return r=t(),o=OfficeCore.License.newObject(r),(i=o.getLicenseFeature(e)).onStateChanged.add(n),a=function(){return i.onStateChanged.remove(n),null},[4,r.sync()];case 1:return s.sent(),[2,a]}}))}))},e.getMsaDeviceTicket=function(e,n,r){return __awaiter(this,void 0,void 0,(function(){var o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return o=t(),i=OfficeCore.License.newObject(o),a=i.getMsaDeviceTicket(e,n,r),[4,o.sync()];case 1:return s.sent(),[2,a.value]}}))}))}}(e.license||(e.license={}))}(Office||(Office={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t,n=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),o=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),i=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function l(){return null!==c&&c.apply(this,arguments)||this}return __extends(l,c),Object.defineProperty(l.prototype,"_className",{get:function(){return"Skill"},enumerable:!0,configurable:!0}),l.prototype.executeAction=function(e,t,n){return r(this,"ExecuteAction",1,[e,t,n],5,0)},l.prototype.notifyPaneEvent=function(e,t){r(this,"NotifyPaneEvent",1,[e,t],5,0)},l.prototype.registerHostSkillEvent=function(){r(this,"RegisterHostSkillEvent",0,[],1,0)},l.prototype.testFireEvent=function(){r(this,"TestFireEvent",0,[],1,0)},l.prototype.unregisterHostSkillEvent=function(){r(this,"UnregisterHostSkillEvent",0,[],1,0)},l.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),o(e))||a(this,e)},l.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},l.newObject=function(t){return n(e.Skill,t,"Microsoft.SkillApi.Skill",!1,4)},Object.defineProperty(l.prototype,"onHostSkillEvent",{get:function(){var e=this;return this.m_hostSkillEvent||(this.m_hostSkillEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"HostSkillEvent",{eventType:65538,registerFunc:function(){return e.registerHostSkillEvent()},unregisterFunc:function(){return e.unregisterHostSkillEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(n){var r=t.Skill_HostSkillEvent_EventArgsTransform(e,n);return OfficeExtension.Utility._createPromiseFromResult(r)}})),this.m_hostSkillEvent},enumerable:!0,configurable:!0}),l.prototype.toJSON=function(){return i(this,{},{})},l}(OfficeExtension.ClientObject));e.Skill=c,function(e){e.Skill_HostSkillEvent_EventArgsTransform=function(e,t){return{type:t.type,data:t.data}}}(t=e._CC||(e._CC={})),function(e){e.generalException="GeneralException"}(e.SkillErrorCodes||(e.SkillErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),o=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported),i=(OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function l(){return null!==c&&c.apply(this,arguments)||this}return __extends(l,c),Object.defineProperty(l.prototype,"_className",{get:function(){return"TelemetryService"},enumerable:!0,configurable:!0}),l.prototype.sendCustomerContent=function(e,t,r,i,a){o("TelemetryService.sendCustomerContent","Telemetry","1.3","OfficeCore"),n(this,"SendCustomerContent",1,[e,t,r,i,a],4,0)},l.prototype.sendTelemetryEvent=function(e,t,r,o,i){n(this,"SendTelemetryEvent",1,[e,t,r,o,i],4,0)},l.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),r(e))||a(this,e)},l.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},l.newObject=function(n){return t(e.TelemetryService,n,"Microsoft.Telemetry.TelemetryService",!1,4)},l.prototype.toJSON=function(){return i(this,{},{})},l}(OfficeExtension.ClientObject));e.TelemetryService=c,function(e){e.unset="Unset",e.string="String",e.boolean="Boolean",e.int64="Int64",e.double="Double"}(e.DataFieldType||(e.DataFieldType={})),function(e){e.generalException="GeneralException"}(e.TelemetryErrorCodes||(e.TelemetryErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t=!1;function n(n,o){return new OfficeExtension.CoreUtility.Promise((function(i,a){if(OSF.WebAuth&&"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform){var s=!1;try{if(!Office||!Office.context||!Office.context.webAuth)return void a({code:"GetAuthContextAsyncMissing",message:"Office:["+!Office+"],Office.context:["+!Office.context+"],Office.context.webAuth:["+!Office.context.webAuth+"]"});Office.context.webAuth.getAuthContextAsync((function(c){if("succeeded"===c.status){s=!0;var l=c.value;if(!l||l.isAnonymous)return void a({code:"CannotGetAuthContext",message:l.Error});var u="msa"===l.authorityType.toLowerCase();if(OSF.WebAuth.config={authFlow:e.authFlow,authVersion:e.authVersion?e.authVersion:null,msal:e.msal,delayWebAuth:e.delay,delayMsal:e.delayMsal,debugging:e.debugging,authority:e.authorityOverride?e.authorityOverride:l.authority,idp:l.authorityType.toLowerCase(),appIds:[u&&l.msaAppId?l.msaAppId:l.appId],redirectUri:n||null,upn:l.upn,puid:l.userId,prefetch:o,telemetryInstance:"otel",autoPopup:e.autoPopup,enableUpnCheck:e.upnCheck,enableConsoleLogging:e.debugging},OSF.WebAuth.load().then((function(e){r(e,t=!0),i()})).catch((function(e){r(e,t),a({code:"PackageNotLoaded",message:e instanceof Event?e.type:e})})),"implicit"===e.authFlow){var d=n||window.location.href.split("?")[0],f=sessionStorage.getItem("officeWebAuthReplyUrls");f||""===f?f=d:f+=", "+d,f&&sessionStorage.setItem("officeWebAuthReplyUrls",f)}}else OSF.WebAuth.config=null,a({code:"CannotGetAuthContext",message:c.status})}))}catch(e){OSF.WebAuth.config=null,OSF.WebAuth.load().then((function(){i()})).catch((function(){a({code:s?"CannotGetAuthContext":"FailedToLoad",message:e})}))}}else i()}))}function r(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",{authFlow:OSF.WebAuth.config.authFlow,authVersion:OSF.WebAuth.config.authVersion,msal:OSF.WebAuth.config.msal,autoPopup:OSF.WebAuth.config.autoPopup,enableUpnCheck:OSF.WebAuth.config.upnCheck}),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:"")];if(e&&!(e instanceof Event)&&e.Telemetry)for(var r in e.Telemetry)if(e.Telemetry[r])switch(r){case"succeeded":n.push(oteljs.makeBooleanDataField(r,e.Telemetry[r]));break;case"loadedApplicationCount":case"timeToLoad":n.push(oteljs.makeInt64DataField(r,e.Telemetry[r]));break;default:n.push(oteljs.makeStringDataField(r,e.Telemetry[r]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.Load",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}function o(e,t,n){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var r=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",{authFlow:OSF.WebAuth.config.authFlow,authVersion:OSF.WebAuth.config.authVersion,msal:OSF.WebAuth.config.msal,autoPopup:OSF.WebAuth.config.autoPopup,enableUpnCheck:OSF.WebAuth.config.upnCheck}),oteljs.makeBooleanDataField("Popup","boolean"===typeof n&&n),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:e.ErrorCode)];if(e&&!(e instanceof Event)&&e.Telemetry)for(var o in e.Telemetry)if(e.Telemetry[o])switch(o){case"succeeded":r.push(oteljs.makeBooleanDataField(o,e.Telemetry[o]));break;case"timeToGetToken":r.push(oteljs.makeInt64DataField(o,e.Telemetry[o]));break;default:r.push(oteljs.makeStringDataField(o,e.Telemetry[o]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.GetAccessToken",dataFields:r,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}e.authFlow="authcode",e.autoPopup=!1,e.upnCheck=!0,e.msal="https://alcdn.msauth.net/browser-1p/2.28.1/js/msal-browser-1p.min.js",e.debugging=!1,e.delay=0,e.delayMsal=0,e.load=n,e.getAccessToken=function(e,n){return new OfficeExtension.CoreUtility.Promise((function(r,i){if("web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform)Office.context.webAuth.getAuthContextAsync((function(a){var s=!1;"succeeded"===a.status&&(a.value.supportsAuthToken&&(s=!0));if(s){var c=new OfficeCore.RequestContext,l=OfficeCore.AuthenticationService.newObject(c);c._customData="WacPartition";var u=l.getAccessToken(e,null);c.sync().then((function(){r(u.value)}))}else OSF.WebAuth&&t?OSF.WebAuth.config.appIds[0]&&OSF.WebAuth.getToken(e.resource,OSF.WebAuth.config.appIds[0],OSF._OfficeAppFactory.getHostInfo().osfControlAppCorrelationId,n&&n.popup?n.popup:null,e&&e.authChallenge?e.authChallenge:null).then((function(e){o(e,!0,!(!n||!n.popup)&&n.popup),r({accessToken:e.Token,tokenIdenityType:"msa"==OSF.WebAuth.config.idp.toLowerCase()?OfficeCore.IdentityType.microsoftAccount:OfficeCore.IdentityType.organizationAccount})})).catch((function(e){o(e,!1,!(!n||!n.popup)&&n.popup),i({code:e.ErrorCode,message:e instanceof Event?e.type:e.ErrorMessage})})):function(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeBooleanDataField("Loaded",e),oteljs.makeInt64DataField("LoadAttempts","number"===typeof t?t:0)];OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.UnexpectedAcquire",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}(t,OSF.WebAuth.loadAttempts)}));else{var a=new OfficeCore.RequestContext,s=OfficeCore.AuthenticationService.newObject(a),c=s.onTokenReceived.add((function(e){if(!OfficeExtension.CoreUtility.isNullOrUndefined(e))if(c.remove(),a.sync().catch((function(){})),0==e.code)r(e.tokenValue);else if(OfficeExtension.CoreUtility.isNullOrUndefined(e.errorInfo))i({code:e.code});else try{i(JSON.parse(e.errorInfo))}catch(t){i({code:e.code,message:e.errorInfo})}return null}));a.sync().then((function(){var t=s.getAccessToken(e,s._targetId);return a.sync().then((function(){if(OfficeExtension.CoreUtility.isNullOrUndefined(t.value))return null;var e=t.value.accessToken;OfficeExtension.CoreUtility.isNullOrUndefined(e)||r(t.value)}))})).catch((function(e){i(e)}))}}))},e.getPrimaryIdentityInfo=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e);e._customData="WacPartition";var n=t.getPrimaryIdentityInfo();return e.sync().then((function(){return n.value}))},e.getIdentities=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e).getIdentities();return e.sync().then((function(){return t.value}))},e.onIdentityChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r=this;return __generator(this,(function(o){switch(o.label){case 0:return o.trys.push([0,3,,4]),"web"===OSF._OfficeAppFactory.getHostInfo().hostPlatform?[3,2]:(t=new OfficeCore.RequestContext,n=OfficeCore.AuthenticationService.newObject(t),n.onIdentityChanged.add(e),[4,t.sync()]);case 1:return o.sent(),[2,function(){return __awaiter(r,void 0,void 0,(function(){return __generator(this,(function(r){switch(r.label){case 0:return n.onIdentityChanged.remove(e),[4,t.sync()];case 1:return r.sent(),[2]}}))}))}];case 2:return[3,4];case 3:return o.sent(),[3,4];case 4:return[2,function(){return Promise.resolve()}]}}))}))},"undefined"!==typeof window&&window.OSF&&function(){try{if("undefined"===typeof window||!window.sessionStorage)return;var e=sessionStorage.getItem("officeWebAuthReplyUrls");null!==e&&-1!==e.indexOf(window.location.origin+window.location.pathname)&&n()}catch(e){console.error(e)}}()}(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={})),function(e){!function(e){var t;!function(e){e[e.UnsupportedUserIdentity=13003]="UnsupportedUserIdentity",e[e.UserAborted=13004]="UserAborted",e[e.InteractionRequired=13005]="InteractionRequired",e[e.ClientError=13006]="ClientError",e[e.ServerError=13007]="ServerError",e[e.NotAvailable=13012]="NotAvailable",e[e.InternalError=5001]="InternalError"}(t=e.AuthErrorCode||(e.AuthErrorCode={}));var n={ACCOUNT_UNAVAILABLE:t.UnsupportedUserIdentity,USER_CANCEL:t.UserAborted,USER_INTERACTION_REQUIRED:t.InteractionRequired,PERSISTENT_ERROR:t.ClientError,NO_NETWORK:t.ServerError,TRANSIENT_ERROR:t.ServerError,NESTED_APP_AUTH_UNAVAILABLE:t.NotAvailable},r=!1,o={},i=function(e){try{var r=JSON.parse(e);if(r.requestId){var i=r.requestId;if(o.hasOwnProperty(i)){var a=t.InternalError,s=o[i],c=s[0],l=s[1];delete o[i];var u=r.body;if(u){if(!0===r.success&&u.access_token&&"number"==typeof u.expires_in)return void c({accessToken:u.access_token,expiresOn:new Date(Date.now()+1e3*u.expires_in)});var d=u.status;n[d]&&(a=n[d])}l({code:a})}}}catch(e){}};function a(e,n){var a=OSF.OUtil.Guid.generateNewGuid();return new Promise((function(s,c){if("undefined"!==typeof nestedAppAuthBridge){var l={messageType:"NestedAppAuthRequest",method:n?"GetToken":"GetTokenPopup",requestId:a,clientLibrary:"officejs",body:{clientId:e.clientId,scope:e.scope,correlationId:e.correlationId,claims:e.claims}};r||(nestedAppAuthBridge.addEventListener("message",i),r=!0),o[a]=[s,c],nestedAppAuthBridge.postMessage(JSON.stringify(l))}else c(OSF.DDA.ErrorCodeManager.getErrorArgs(t.NotAvailable))}))}e.getAccessToken=function(e){return a(e,!0).catch((function(n){if(n.code==t.InteractionRequired&&!1===e.silent)return a(e,!1);throw n}))}}(e.NestedAppAuth||(e.NestedAppAuth={}))}(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={})),function(e){var t,n=OfficeExtension.BatchApiHelper.createPropertyObject,r=OfficeExtension.BatchApiHelper.createMethodObject,o=OfficeExtension.BatchApiHelper.createIndexerObject,i=(OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),a=OfficeExtension.BatchApiHelper.createChildItemObject,s=OfficeExtension.BatchApiHelper.invokeMethod,c=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,l=OfficeExtension.BatchApiHelper.invokeSetProperty,u=OfficeExtension.Utility.isNullOrUndefined,d=OfficeExtension.Utility.isUndefined,f=OfficeExtension.Utility.throwIfNotLoaded,p=OfficeExtension.Utility.throwIfApiNotSupported,h=OfficeExtension.Utility.load,m=OfficeExtension.Utility.retrieve,g=OfficeExtension.Utility.toJson,y=OfficeExtension.Utility.fixObjectPathIfNecessary,v=OfficeExtension.Utility._handleNavigationPropertyResults,O=OfficeExtension.Utility.adjustToDateTime,b=OfficeExtension.Utility.processRetrieveResult,S=OfficeExtension.Utility.setMockData,C=OfficeExtension.CommonUtility.calculateApiFlags,_=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"DialogPage"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_Id",{get:function(){return f("_Id",this.__I,"DialogPage",this._isNull),this.__I},enumerable:!0,configurable:!0}),n.prototype.close=function(){s(this,"Close",1,[],4,0)},n.prototype.readyToShow=function(){s(this,"ReadyToShow",1,[],4,0)},n.prototype.registerOnShow=function(){s(this,"RegisterOnShow",1,[],4,0)},n.prototype.sendMessageToHost=function(e){s(this,"SendMessageToHost",1,[e],4,0)},n.prototype.unregisterOnShow=function(){s(this,"UnregisterOnShow",1,[],4,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n._Id)||(this.__I=n._Id)}},n.prototype.load=function(e){return h(this,e)},n.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),u(e)||d(e._Id)||(this.__I=e._Id)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.DialogPage,t,"Microsoft.Office.DialogPage.DialogPage",!1,4)},Object.defineProperty(n.prototype,"onOnShowEvent",{get:function(){var e=this;return this.m_onShowEvent||(this.m_onShowEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"OnShowEvent",{eventType:1,registerFunc:function(){return e.registerOnShow()},unregisterFunc:function(){return e.unregisterOnShow()},getTargetIdFunc:function(){return e._Id},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_onShowEvent},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.DialogPage=_,function(e){e.unknown="Unknown",e.basic="Basic",e.premium="Premium"}(t=e.LicenseFeatureTier||(e.LicenseFeatureTier={}));var A=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"License"},enumerable:!0,configurable:!0}),n.prototype.getFeatureTier=function(e,t){return s(this,"GetFeatureTier",1,[e,t],4,0)},n.prototype.getLicenseFeature=function(t){return r(e.LicenseFeature,this,"GetLicenseFeature",1,[t],!1,!1,null,4)},n.prototype.getMsaDeviceTicket=function(e,t,n){return s(this,"GetMsaDeviceTicket",1,[e,t,n],5,0)},n.prototype.isFeatureEnabled=function(e,t){return s(this,"IsFeatureEnabled",1,[e,t],4,0)},n.prototype.isFreemiumUpsellEnabled=function(){return s(this,"IsFreemiumUpsellEnabled",1,[],4,0)},n.prototype.launchUpsellExperience=function(e){s(this,"LaunchUpsellExperience",1,[e],4,0)},n.prototype._TestFireStateChangedEvent=function(e){s(this,"_TestFireStateChangedEvent",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.License,t,"Microsoft.Office.Licensing.License",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.License=A;var D,E=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LicenseFeature"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return f("id",this._I,"LicenseFeature",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype._RegisterStateChange=function(){s(this,"_RegisterStateChange",1,[],4,0)},t.prototype._UnregisterStateChange=function(){s(this,"_UnregisterStateChange",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),u(t)||d(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},Object.defineProperty(t.prototype,"onStateChanged",{get:function(){var e=this;return this.m_stateChanged||(this.m_stateChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"StateChanged",{eventType:1,registerFunc:function(){return e._RegisterStateChange()},unregisterFunc:function(){return e._UnregisterStateChange()},getTargetIdFunc:function(){return e.id},eventArgsTransformFunc:function(t){var n=D.LicenseFeature_StateChanged_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_stateChanged},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return g(this,{id:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.LicenseFeature=E,function(e){e.LicenseFeature_StateChanged_EventArgsTransform=function(e,n){var r={feature:n.featureName,isEnabled:n.isEnabled,tier:n.tierName};return n.tierName&&(r.tier=0==n.tierName?t.unknown:1==n.tierName?t.basic:2==n.tierName?t.premium:n.tierName),r}}(D=e._CC||(e._CC={}));var F=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"MsaDeviceTicketOptions"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"scopes",{get:function(){return f("scopes",this._S,"MsaDeviceTicketOptions",this._isNull),this._S},set:function(e){this._S=e,l(this,"Scopes",e,0)},enumerable:!0,configurable:!0}),n.prototype.set=function(e,t){this._recursivelySet(e,t,["scopes"],[],[])},n.prototype.update=function(e){this._recursivelyUpdate(e)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.Scopes)||(this._S=n.Scopes)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.MsaDeviceTicketOptions,t,"Microsoft.Office.Licensing.MsaDeviceTicketOptions",!1,4)},n.prototype.toJSON=function(){return g(this,{scopes:this._S},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.MsaDeviceTicketOptions=F;var P=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimePersistenceService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeStartState=function(){return s(this,"GetAppRuntimeStartState",1,[],4,0)},n.prototype.setAppRuntimeStartState=function(e){s(this,"SetAppRuntimeStartState",0,[e],C(2,"SharedRuntimeInternal","1.2"),0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.AppRuntimePersistenceService,t,"Microsoft.AppRuntime.AppRuntimePersistenceService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimePersistenceService=P;var R=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimeService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeState=function(){return s(this,"GetAppRuntimeState",1,[],4,0)},n.prototype.getContentSnapshotAsBase64=function(){return p("AppRuntimeService.getContentSnapshotAsBase64","SnapshotControl","1.1","Office"),s(this,"GetContentSnapshotAsBase64",1,[],4,0)},n.prototype.getSnapshotEnabled=function(){return p("AppRuntimeService.getSnapshotEnabled","SnapshotControl","1.1","Office"),s(this,"GetSnapshotEnabled",1,[],4,0)},n.prototype.setAppRuntimeState=function(e){s(this,"SetAppRuntimeState",0,[e],C(2,"SharedRuntimeInternal","1.2"),0)},n.prototype.setSnapshotEnabled=function(e){p("AppRuntimeService.setSnapshotEnabled","SnapshotControl","1.1","Office"),s(this,"SetSnapshotEnabled",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.AppRuntimeService,t,"Microsoft.AppRuntime.AppRuntimeService",!1,4)},Object.defineProperty(n.prototype,"onSnapshotImageReady",{get:function(){return p("AppRuntimeService.onSnapshotImageReady","SnapshotControl","1.1","Office"),this.m_snapshotImageReady||(this.m_snapshotImageReady=new OfficeExtension.GenericEventHandlers(this.context,this,"SnapshotImageReady",{eventType:65547,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={imageBase64:e.imageBase64};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_snapshotImageReady},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onVisibilityChanged",{get:function(){return this.m_visibilityChanged||(this.m_visibilityChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"VisibilityChanged",{eventType:65539,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={visibility:e.visibility};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_visibilityChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimeService=R,function(e){e.inactive="Inactive",e.background="Background",e.visible="Visible"}(e.AppRuntimeState||(e.AppRuntimeState={})),function(e){e.hidden="Hidden",e.visible="Visible"}(e.Visibility||(e.Visibility={}));var I=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ThemeService"},enumerable:!0,configurable:!0}),n.prototype.registerOfficeThemeChangedEvent=function(){s(this,"RegisterOfficeThemeChangedEvent",0,[],0,0)},n.prototype.unregisterOfficeThemeChangedEvent=function(){s(this,"UnregisterOfficeThemeChangedEvent",0,[],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ThemeService,t,"Microsoft.Theme.ThemeService",!1,4)},Object.defineProperty(n.prototype,"onOfficeThemeChanged",{get:function(){var e=this;return this.m_officeThemeChanged||(this.m_officeThemeChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"OfficeThemeChanged",{eventType:65548,registerFunc:function(){return e.registerOfficeThemeChangedEvent()},unregisterFunc:function(){return e.unregisterOfficeThemeChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(t){var n=D.ThemeService_OfficeThemeChanged_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_officeThemeChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ThemeService=I,function(e){e.ThemeService_OfficeThemeChanged_EventArgsTransform=function(e,t){return{bodyBackgroundColor:t.bodyBackgroundColor,bodyForegroundColor:t.bodyForegroundColor,controlBackgroundColor:t.controlBackgroundColor,controlForegroundColor:t.controlForegroundColor}}}(D=e._CC||(e._CC={}));var x=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Tap"},enumerable:!0,configurable:!0}),n.prototype.getEnterpriseUserInfo=function(){return s(this,"GetEnterpriseUserInfo",1,[],5,0)},n.prototype.getMruFriendlyPath=function(e){return s(this,"GetMruFriendlyPath",1,[e],5,0)},n.prototype.launchFileUrlInOfficeApp=function(e,t){return s(this,"LaunchFileUrlInOfficeApp",1,[e,t],5,0)},n.prototype.performLocalSearch=function(e,t,n,r){return s(this,"PerformLocalSearch",1,[e,t,n,r],5,0)},n.prototype.readSearchCache=function(e,t,n){return s(this,"ReadSearchCache",1,[e,t,n],5,0)},n.prototype.writeSearchCache=function(e,t,n){return s(this,"WriteSearchCache",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.Tap,t,"Microsoft.TapRichApi.Tap",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.Tap=x,function(e){e.unknown="Unknown",e.chart="Chart",e.smartArt="SmartArt",e.table="Table",e.image="Image",e.slide="Slide",e.ole="OLE",e.text="Text"}(e.ObjectType||(e.ObjectType={})),function(e){e.placeHolderRendered="PlaceHolderRendered",e.initialCardRendered="InitialCardRendered"}(e.PersonaCardPerfPoint||(e.PersonaCardPerfPoint={})),function(e){e.notSet="NotSet",e.free="Free",e.idle="Idle",e.busy="Busy",e.idleBusy="IdleBusy",e.doNotDisturb="DoNotDisturb",e.unalertable="Unalertable",e.unavailable="Unavailable"}(e.UnifiedCommunicationAvailability||(e.UnifiedCommunicationAvailability={})),function(e){e.online="Online",e.notOnline="NotOnline",e.away="Away",e.busy="Busy",e.beRightBack="BeRightBack",e.onThePhone="OnThePhone",e.outToLunch="OutToLunch",e.inAMeeting="InAMeeting",e.outOfOffice="OutOfOffice",e.doNotDisturb="DoNotDisturb",e.inAConference="InAConference",e.getting="Getting",e.notABuddy="NotABuddy",e.disconnected="Disconnected",e.notInstalled="NotInstalled",e.urgentInterruptionsOnly="UrgentInterruptionsOnly",e.mayBeAvailable="MayBeAvailable",e.idle="Idle",e.inPresentation="InPresentation"}(e.UnifiedCommunicationStatus||(e.UnifiedCommunicationStatus={})),function(e){e.free="Free",e.busy="Busy",e.idle="Idle",e.doNotDistrub="DoNotDistrub",e.blocked="Blocked",e.notSet="NotSet",e.outOfOffice="OutOfOffice"}(e.UnifiedCommunicationPresence||(e.UnifiedCommunicationPresence={})),function(e){e.unknown="Unknown",e.free="Free",e.busy="Busy",e.elsewhere="Elsewhere",e.tentative="Tentative",e.outOfOffice="OutOfOffice"}(e.FreeBusyCalendarState||(e.FreeBusyCalendarState={})),function(e){e.unknown="Unknown",e.enterprise="Enterprise",e.contact="Contact",e.bot="Bot",e.phoneOnly="PhoneOnly",e.oneOff="OneOff",e.distributionList="DistributionList",e.personalDistributionList="PersonalDistributionList",e.anonymous="Anonymous",e.unifiedGroup="UnifiedGroup"}(e.PersonaType||(e.PersonaType={})),function(e){e.workPhone="WorkPhone",e.homePhone="HomePhone",e.mobilePhone="MobilePhone",e.businessFax="BusinessFax",e.otherPhone="OtherPhone"}(e.PhoneType||(e.PhoneType={})),function(e){e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress"}(e.AddressType||(e.AddressType={})),function(e){e.unknown="Unknown",e.individual="Individual",e.group="Group"}(e.MemberType||(e.MemberType={}));var T,w=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"MemberInfoList"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isWarmedUp",{get:function(){return f("isWarmedUp",this._I,"MemberInfoList",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isWarmingUp",{get:function(){return f("isWarmingUp",this._Is,"MemberInfoList",this._isNull),this._Is},enumerable:!0,configurable:!0}),n.prototype.getPersonaForMember=function(t){return r(e.Persona,this,"GetPersonaForMember",1,[t],!1,!1,null,4)},n.prototype.items=function(){return s(this,"Items",1,[],4,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.IsWarmedUp)||(this._I=n.IsWarmedUp),d(n.IsWarmingUp)||(this._Is=n.IsWarmingUp)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.prototype.toJSON=function(){return g(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.MemberInfoList=w,function(e){e.hostId="HostId",e.type="Type",e.photo="Photo",e.personaInfo="PersonaInfo",e.unifiedCommunicationInfo="UnifiedCommunicationInfo",e.organization="Organization",e.unifiedGroupInfo="UnifiedGroupInfo",e.members="Members",e.membership="Membership",e.capabilities="Capabilities",e.customizations="Customizations",e.viewableSources="ViewableSources",e.placeholder="Placeholder"}(T=e.PersonaDataUpdated||(e.PersonaDataUpdated={}));var M=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaActions"},enumerable:!0,configurable:!0}),t.prototype.addContact=function(){s(this,"AddContact",0,[],0,0)},t.prototype.callPhoneNumber=function(e){s(this,"CallPhoneNumber",0,[e],0,0)},t.prototype.composeEmail=function(e){s(this,"ComposeEmail",0,[e],0,0)},t.prototype.composeInstantMessage=function(e){s(this,"ComposeInstantMessage",0,[e],0,0)},t.prototype.editContact=function(){s(this,"EditContact",0,[],0,0)},t.prototype.editContactByIdentifier=function(e){s(this,"EditContactByIdentifier",0,[e],0,0)},t.prototype.editUnifiedGroup=function(){s(this,"EditUnifiedGroup",0,[],0,0)},t.prototype.getChangePhotoUrlAndOpenInBrowser=function(){s(this,"GetChangePhotoUrlAndOpenInBrowser",0,[],0,0)},t.prototype.hideHoverCardForPersona=function(){s(this,"HideHoverCardForPersona",0,[],0,0)},t.prototype.joinUnifiedGroup=function(){s(this,"JoinUnifiedGroup",0,[],0,0)},t.prototype.leaveUnifiedGroup=function(){s(this,"LeaveUnifiedGroup",0,[],0,0)},t.prototype.openGroupCalendar=function(){s(this,"OpenGroupCalendar",0,[],0,0)},t.prototype.openLinkContactUx=function(){s(this,"OpenLinkContactUx",0,[],0,0)},t.prototype.openOutlookProperties=function(){s(this,"OpenOutlookProperties",0,[],0,0)},t.prototype.pinPersonaToQuickContacts=function(){s(this,"PinPersonaToQuickContacts",0,[],0,0)},t.prototype.scheduleMeeting=function(){s(this,"ScheduleMeeting",0,[],0,0)},t.prototype.showContactCard=function(e,t,n,r,o,i){s(this,"ShowContactCard",0,[e,t,n,r,o,i],0,0)},t.prototype.showContextMenu=function(e,t,n,r,o,i){s(this,"ShowContextMenu",0,[e,t,n,r,o,i],0,0)},t.prototype.showExpandedCard=function(e,t,n,r,o,i){s(this,"ShowExpandedCard",0,[e,t,n,r,o,i],0,0)},t.prototype.showHoverCardForPersona=function(e,t,n,r,o,i){s(this,"ShowHoverCardForPersona",0,[e,t,n,r,o,i],0,0)},t.prototype.startAudioCall=function(){s(this,"StartAudioCall",0,[],0,0)},t.prototype.startVideoCall=function(){s(this,"StartVideoCall",0,[],0,0)},t.prototype.subscribeToGroup=function(){s(this,"SubscribeToGroup",0,[],0,0)},t.prototype.toggleTagForAlerts=function(){s(this,"ToggleTagForAlerts",0,[],0,0)},t.prototype.unsubscribeFromGroup=function(){s(this,"UnsubscribeFromGroup",0,[],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),u(t))||y(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaActions=M;var k=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaInfoSource"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","phones","addresses","webSites","notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","Phones","Addresses","WebSites","Notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"addresses",{get:function(){return f("addresses",this._A,"PersonaInfoSource",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthday",{get:function(){return f("birthday",this._B,"PersonaInfoSource",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthdays",{get:function(){return f("birthdays",this._Bi,"PersonaInfoSource",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"companyName",{get:function(){return f("companyName",this._C,"PersonaInfoSource",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"displayName",{get:function(){return f("displayName",this._D,"PersonaInfoSource",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"email",{get:function(){return f("email",this._E,"PersonaInfoSource",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailAddresses",{get:function(){return f("emailAddresses",this._Em,"PersonaInfoSource",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"jobInfoDepartment",{get:function(){return f("jobInfoDepartment",this._J,"PersonaInfoSource",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedCompanyNames",{get:function(){return f("linkedCompanyNames",this._L,"PersonaInfoSource",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedDepartments",{get:function(){return f("linkedDepartments",this._Li,"PersonaInfoSource",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedOffices",{get:function(){return f("linkedOffices",this._Lin,"PersonaInfoSource",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedTitles",{get:function(){return f("linkedTitles",this._Link,"PersonaInfoSource",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"notes",{get:function(){return f("notes",this._N,"PersonaInfoSource",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"office",{get:function(){return f("office",this._O,"PersonaInfoSource",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"phones",{get:function(){return f("phones",this._P,"PersonaInfoSource",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"sipAddresses",{get:function(){return f("sipAddresses",this._S,"PersonaInfoSource",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"title",{get:function(){return f("title",this._T,"PersonaInfoSource",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"webSites",{get:function(){return f("webSites",this._W,"PersonaInfoSource",this._isNull),this._W},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Addresses)||(this._A=n.Addresses),d(n.Birthday)||(this._B=n.Birthday),d(n.Birthdays)||(this._Bi=n.Birthdays),d(n.CompanyName)||(this._C=n.CompanyName),d(n.DisplayName)||(this._D=n.DisplayName),d(n.Email)||(this._E=n.Email),d(n.EmailAddresses)||(this._Em=n.EmailAddresses),d(n.JobInfoDepartment)||(this._J=n.JobInfoDepartment),d(n.LinkedCompanyNames)||(this._L=n.LinkedCompanyNames),d(n.LinkedDepartments)||(this._Li=n.LinkedDepartments),d(n.LinkedOffices)||(this._Lin=n.LinkedOffices),d(n.LinkedTitles)||(this._Link=n.LinkedTitles),d(n.Notes)||(this._N=n.Notes),d(n.Office)||(this._O=n.Office),d(n.Phones)||(this._P=n.Phones),d(n.SipAddresses)||(this._S=n.SipAddresses),d(n.Title)||(this._T=n.Title),d(n.WebSites)||(this._W=n.WebSites)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{addresses:this._A,birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,phones:this._P,sipAddresses:this._S,title:this._T,webSites:this._W},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.PersonaInfoSource=k;var N=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","webSites","notes","isPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","WebSites","Notes","IsPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["sources"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sources",{get:function(){return this._So||(this._So=n(e.PersonaInfoSource,this,"Sources",!1,4)),this._So},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthday",{get:function(){return f("birthday",this._B,"PersonaInfo",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthdays",{get:function(){return f("birthdays",this._Bi,"PersonaInfo",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"companyName",{get:function(){return f("companyName",this._C,"PersonaInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"displayName",{get:function(){return f("displayName",this._D,"PersonaInfo",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"email",{get:function(){return f("email",this._E,"PersonaInfo",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"emailAddresses",{get:function(){return f("emailAddresses",this._Em,"PersonaInfo",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isPersonResolved",{get:function(){return f("isPersonResolved",this._I,"PersonaInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"jobInfoDepartment",{get:function(){return f("jobInfoDepartment",this._J,"PersonaInfo",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedCompanyNames",{get:function(){return f("linkedCompanyNames",this._L,"PersonaInfo",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedDepartments",{get:function(){return f("linkedDepartments",this._Li,"PersonaInfo",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedOffices",{get:function(){return f("linkedOffices",this._Lin,"PersonaInfo",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedTitles",{get:function(){return f("linkedTitles",this._Link,"PersonaInfo",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"notes",{get:function(){return f("notes",this._N,"PersonaInfo",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"office",{get:function(){return f("office",this._O,"PersonaInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sipAddresses",{get:function(){return f("sipAddresses",this._S,"PersonaInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"title",{get:function(){return f("title",this._T,"PersonaInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"webSites",{get:function(){return f("webSites",this._W,"PersonaInfo",this._isNull),this._W},enumerable:!0,configurable:!0}),r.prototype.getAddresses=function(){return s(this,"GetAddresses",1,[],4,0)},r.prototype.getPhones=function(){return s(this,"GetPhones",1,[],4,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.Birthday)||(this._B=O(n.Birthday)),d(n.Birthdays)||(this._Bi=O(n.Birthdays)),d(n.CompanyName)||(this._C=n.CompanyName),d(n.DisplayName)||(this._D=n.DisplayName),d(n.Email)||(this._E=n.Email),d(n.EmailAddresses)||(this._Em=n.EmailAddresses),d(n.IsPersonResolved)||(this._I=n.IsPersonResolved),d(n.JobInfoDepartment)||(this._J=n.JobInfoDepartment),d(n.LinkedCompanyNames)||(this._L=n.LinkedCompanyNames),d(n.LinkedDepartments)||(this._Li=n.LinkedDepartments),d(n.LinkedOffices)||(this._Lin=n.LinkedOffices),d(n.LinkedTitles)||(this._Link=n.LinkedTitles),d(n.Notes)||(this._N=n.Notes),d(n.Office)||(this._O=n.Office),d(n.SipAddresses)||(this._S=n.SipAddresses),d(n.Title)||(this._T=n.Title),d(n.WebSites)||(this._W=n.WebSites),v(this,n,["sources","Sources"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){if(t.prototype._handleRetrieveResult.call(this,e,n),!u(e)){var r=e;d(r.Birthday)||(r.birthday=O(r.birthday)),d(r.Birthdays)||(r.birthdays=O(r.birthdays)),b(this,e,n)}},r.prototype.toJSON=function(){return g(this,{birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,isPersonResolved:this._I,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,sipAddresses:this._S,title:this._T,webSites:this._W},{sources:this._So})},r.prototype.setMockData=function(e){S(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.PersonaInfo=N;var j=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaUnifiedCommunicationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["availability","status","isSelf","isTagged","customStatusString","isBlocked","presenceTooltip","isOutOfOffice","outOfOfficeNote","timezone","meetingLocation","meetingSubject","timezoneBias","idleStartTime","overallCapability","isOnBuddyList","presenceNote","voiceMailUri","availabilityText","availabilityTooltip","isDurationInAvailabilityText","freeBusyStatus","calendarState","presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Availability","Status","IsSelf","IsTagged","CustomStatusString","IsBlocked","PresenceTooltip","IsOutOfOffice","OutOfOfficeNote","Timezone","MeetingLocation","MeetingSubject","TimezoneBias","IdleStartTime","OverallCapability","IsOnBuddyList","PresenceNote","VoiceMailUri","AvailabilityText","AvailabilityTooltip","IsDurationInAvailabilityText","FreeBusyStatus","CalendarState","Presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availability",{get:function(){return f("availability",this._A,"PersonaUnifiedCommunicationInfo",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityText",{get:function(){return f("availabilityText",this._Av,"PersonaUnifiedCommunicationInfo",this._isNull),this._Av},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityTooltip",{get:function(){return f("availabilityTooltip",this._Ava,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ava},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"calendarState",{get:function(){return f("calendarState",this._C,"PersonaUnifiedCommunicationInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"customStatusString",{get:function(){return f("customStatusString",this._Cu,"PersonaUnifiedCommunicationInfo",this._isNull),this._Cu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"freeBusyStatus",{get:function(){return f("freeBusyStatus",this._F,"PersonaUnifiedCommunicationInfo",this._isNull),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"idleStartTime",{get:function(){return f("idleStartTime",this._I,"PersonaUnifiedCommunicationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isBlocked",{get:function(){return f("isBlocked",this._Is,"PersonaUnifiedCommunicationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isDurationInAvailabilityText",{get:function(){return f("isDurationInAvailabilityText",this._IsD,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsD},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOnBuddyList",{get:function(){return f("isOnBuddyList",this._IsO,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsO},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOutOfOffice",{get:function(){return f("isOutOfOffice",this._IsOu,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsOu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isSelf",{get:function(){return f("isSelf",this._IsS,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsS},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isTagged",{get:function(){return f("isTagged",this._IsT,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsT},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingLocation",{get:function(){return f("meetingLocation",this._M,"PersonaUnifiedCommunicationInfo",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingSubject",{get:function(){return f("meetingSubject",this._Me,"PersonaUnifiedCommunicationInfo",this._isNull),this._Me},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"outOfOfficeNote",{get:function(){return f("outOfOfficeNote",this._O,"PersonaUnifiedCommunicationInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"overallCapability",{get:function(){return f("overallCapability",this._Ov,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ov},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presence",{get:function(){return f("presence",this._P,"PersonaUnifiedCommunicationInfo",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceNote",{get:function(){return f("presenceNote",this._Pr,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pr},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceTooltip",{get:function(){return f("presenceTooltip",this._Pre,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pre},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"status",{get:function(){return f("status",this._S,"PersonaUnifiedCommunicationInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezone",{get:function(){return f("timezone",this._T,"PersonaUnifiedCommunicationInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezoneBias",{get:function(){return f("timezoneBias",this._Ti,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ti},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"voiceMailUri",{get:function(){return f("voiceMailUri",this._V,"PersonaUnifiedCommunicationInfo",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Availability)||(this._A=n.Availability),d(n.AvailabilityText)||(this._Av=n.AvailabilityText),d(n.AvailabilityTooltip)||(this._Ava=n.AvailabilityTooltip),d(n.CalendarState)||(this._C=n.CalendarState),d(n.CustomStatusString)||(this._Cu=n.CustomStatusString),d(n.FreeBusyStatus)||(this._F=n.FreeBusyStatus),d(n.IdleStartTime)||(this._I=O(n.IdleStartTime)),d(n.IsBlocked)||(this._Is=n.IsBlocked),d(n.IsDurationInAvailabilityText)||(this._IsD=n.IsDurationInAvailabilityText),d(n.IsOnBuddyList)||(this._IsO=n.IsOnBuddyList),d(n.IsOutOfOffice)||(this._IsOu=n.IsOutOfOffice),d(n.IsSelf)||(this._IsS=n.IsSelf),d(n.IsTagged)||(this._IsT=n.IsTagged),d(n.MeetingLocation)||(this._M=n.MeetingLocation),d(n.MeetingSubject)||(this._Me=n.MeetingSubject),d(n.OutOfOfficeNote)||(this._O=n.OutOfOfficeNote),d(n.OverallCapability)||(this._Ov=n.OverallCapability),d(n.Presence)||(this._P=n.Presence),d(n.PresenceNote)||(this._Pr=n.PresenceNote),d(n.PresenceTooltip)||(this._Pre=n.PresenceTooltip),d(n.Status)||(this._S=n.Status),d(n.Timezone)||(this._T=n.Timezone),d(n.TimezoneBias)||(this._Ti=n.TimezoneBias),d(n.VoiceMailUri)||(this._V=n.VoiceMailUri)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){if(e.prototype._handleRetrieveResult.call(this,t,n),!u(t)){var r=t;d(r.IdleStartTime)||(r.idleStartTime=O(r.idleStartTime)),b(this,t,n)}},t.prototype.toJSON=function(){return g(this,{availability:this._A,availabilityText:this._Av,availabilityTooltip:this._Ava,calendarState:this._C,customStatusString:this._Cu,freeBusyStatus:this._F,idleStartTime:this._I,isBlocked:this._Is,isDurationInAvailabilityText:this._IsD,isOnBuddyList:this._IsO,isOutOfOffice:this._IsOu,isSelf:this._IsS,isTagged:this._IsT,meetingLocation:this._M,meetingSubject:this._Me,outOfOfficeNote:this._O,overallCapability:this._Ov,presence:this._P,presenceNote:this._Pr,presenceTooltip:this._Pre,status:this._S,timezone:this._T,timezoneBias:this._Ti,voiceMailUri:this._V},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.PersonaUnifiedCommunicationInfo=j;var U=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaPhotoInfo"},enumerable:!0,configurable:!0}),t.prototype.getImageUri=function(e){return s(this,"getImageUri",1,[e],4,0)},t.prototype.getImageUriWithMetadata=function(e){return s(this,"getImageUriWithMetadata",1,[e],4,0)},t.prototype.getPlaceholderUri=function(e){return s(this,"getPlaceholderUri",1,[e],4,0)},t.prototype.setPlaceholderColor=function(e){s(this,"setPlaceholderColor",0,[e],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),u(t))||y(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaPhotoInfo=U;var L=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PersonaCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return f("items",this.m__items,"PersonaCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return o(e.Persona,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!u(n)){var r=n;if(y(this,r),!u(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],i=0;i<o.length;i++){var s=a(e.Persona,!0,this,o[i],i);s._handleResult(o[i]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.Persona,!0,o,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.Persona,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.PersonaCollection=L;var H=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaOrganizationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["hierarchy","manager","directReports"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"directReports",{get:function(){return this._D||(this._D=n(e.PersonaCollection,this,"DirectReports",!0,4)),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"hierarchy",{get:function(){return this._H||(this._H=n(e.PersonaCollection,this,"Hierarchy",!0,4)),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"manager",{get:function(){return this._M||(this._M=n(e.Persona,this,"Manager",!1,4)),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmedUp",{get:function(){return f("isWarmedUp",this._I,"PersonaOrganizationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmingUp",{get:function(){return f("isWarmingUp",this._Is,"PersonaOrganizationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.IsWarmedUp)||(this._I=n.IsWarmedUp),d(n.IsWarmingUp)||(this._Is=n.IsWarmingUp),v(this,n,["directReports","DirectReports","hierarchy","Hierarchy","manager","Manager"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},r.prototype.toJSON=function(){return g(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},r.prototype.setMockData=function(e){S(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.PersonaOrganizationInfo=H,function(e){e.email="Email",e.workPhone="WorkPhone",e.workPhone2="WorkPhone2",e.workFax="WorkFax",e.mobilePhone="MobilePhone",e.homePhone="HomePhone",e.homePhone2="HomePhone2",e.otherPhone="OtherPhone",e.sipAddress="SipAddress",e.profile="Profile",e.office="Office",e.company="Company",e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress",e.birthday="Birthday"}(e.CustomizedData||(e.CustomizedData={}));var B=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"UnifiedGroupInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Description","OneDrive","OneNote","IsPublic","AmIOwner","AmIMember","AmISubscribed","MemberCount","OwnerCount","HasGuests","Site","Planner","Classification","SubscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIMember",{get:function(){return f("amIMember",this._A,"UnifiedGroupInfo",this._isNull),this._A},set:function(e){this._A=e,l(this,"AmIMember",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIOwner",{get:function(){return f("amIOwner",this._Am,"UnifiedGroupInfo",this._isNull),this._Am},set:function(e){this._Am=e,l(this,"AmIOwner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amISubscribed",{get:function(){return f("amISubscribed",this._AmI,"UnifiedGroupInfo",this._isNull),this._AmI},set:function(e){this._AmI=e,l(this,"AmISubscribed",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"classification",{get:function(){return f("classification",this._C,"UnifiedGroupInfo",this._isNull),this._C},set:function(e){this._C=e,l(this,"Classification",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"description",{get:function(){return f("description",this._D,"UnifiedGroupInfo",this._isNull),this._D},set:function(e){this._D=e,l(this,"Description",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hasGuests",{get:function(){return f("hasGuests",this._H,"UnifiedGroupInfo",this._isNull),this._H},set:function(e){this._H=e,l(this,"HasGuests",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isPublic",{get:function(){return f("isPublic",this._I,"UnifiedGroupInfo",this._isNull),this._I},set:function(e){this._I=e,l(this,"IsPublic",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"memberCount",{get:function(){return f("memberCount",this._M,"UnifiedGroupInfo",this._isNull),this._M},set:function(e){this._M=e,l(this,"MemberCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneDrive",{get:function(){return f("oneDrive",this._O,"UnifiedGroupInfo",this._isNull),this._O},set:function(e){this._O=e,l(this,"OneDrive",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneNote",{get:function(){return f("oneNote",this._On,"UnifiedGroupInfo",this._isNull),this._On},set:function(e){this._On=e,l(this,"OneNote",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ownerCount",{get:function(){return f("ownerCount",this._Ow,"UnifiedGroupInfo",this._isNull),this._Ow},set:function(e){this._Ow=e,l(this,"OwnerCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"planner",{get:function(){return f("planner",this._P,"UnifiedGroupInfo",this._isNull),this._P},set:function(e){this._P=e,l(this,"Planner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"site",{get:function(){return f("site",this._S,"UnifiedGroupInfo",this._isNull),this._S},set:function(e){this._S=e,l(this,"Site",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"subscriptionEnabled",{get:function(){return f("subscriptionEnabled",this._Su,"UnifiedGroupInfo",this._isNull),this._Su},set:function(e){this._Su=e,l(this,"SubscriptionEnabled",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.AmIMember)||(this._A=n.AmIMember),d(n.AmIOwner)||(this._Am=n.AmIOwner),d(n.AmISubscribed)||(this._AmI=n.AmISubscribed),d(n.Classification)||(this._C=n.Classification),d(n.Description)||(this._D=n.Description),d(n.HasGuests)||(this._H=n.HasGuests),d(n.IsPublic)||(this._I=n.IsPublic),d(n.MemberCount)||(this._M=n.MemberCount),d(n.OneDrive)||(this._O=n.OneDrive),d(n.OneNote)||(this._On=n.OneNote),d(n.OwnerCount)||(this._Ow=n.OwnerCount),d(n.Planner)||(this._P=n.Planner),d(n.Site)||(this._S=n.Site),d(n.SubscriptionEnabled)||(this._Su=n.SubscriptionEnabled)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{amIMember:this._A,amIOwner:this._Am,amISubscribed:this._AmI,classification:this._C,description:this._D,hasGuests:this._H,isPublic:this._I,memberCount:this._M,oneDrive:this._O,oneNote:this._On,ownerCount:this._Ow,planner:this._P,site:this._S,subscriptionEnabled:this._Su},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.UnifiedGroupInfo=B;var W;!function(e){e[e.immediate=0]="immediate",e[e.load=3]="load"}(W=e.PersonaPromiseType||(e.PersonaPromiseType={}));var G=function(){return function(){}}();e.PersonaInfoAndSource=G;var V=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return __extends(o,t),Object.defineProperty(o.prototype,"_className",{get:function(){return"Persona"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["hostId","type","capabilities","diagnosticId","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["HostId","Type","Capabilities","DiagnosticId","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["photo","personaInfo","unifiedCommunicationInfo","organization","unifiedGroupInfo","actions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"actions",{get:function(){return this._A||(this._A=n(e.PersonaActions,this,"Actions",!1,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"organization",{get:function(){return this._O||(this._O=n(e.PersonaOrganizationInfo,this,"Organization",!1,4)),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"personaInfo",{get:function(){return this._P||(this._P=n(e.PersonaInfo,this,"PersonaInfo",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"photo",{get:function(){return this._Ph||(this._Ph=n(e.PersonaPhotoInfo,this,"Photo",!1,4)),this._Ph},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"unifiedCommunicationInfo",{get:function(){return this._U||(this._U=n(e.PersonaUnifiedCommunicationInfo,this,"UnifiedCommunicationInfo",!1,4)),this._U},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"unifiedGroupInfo",{get:function(){return this._Un||(this._Un=n(e.UnifiedGroupInfo,this,"UnifiedGroupInfo",!1,4)),this._Un},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"capabilities",{get:function(){return f("capabilities",this._C,"Persona",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"diagnosticId",{get:function(){return f("diagnosticId",this._D,"Persona",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"hostId",{get:function(){return f("hostId",this._H,"Persona",this._isNull),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"instanceId",{get:function(){return f("instanceId",this._I,"Persona",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"type",{get:function(){return f("type",this._T,"Persona",this._isNull),this._T},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,[],["unifiedGroupInfo"],["actions","organization","personaInfo","photo","unifiedCommunicationInfo"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.dispose=function(){s(this,"Dispose",0,[],0,0)},o.prototype.getCustomizations=function(){return s(this,"GetCustomizations",1,[],4,0)},o.prototype.getMembers=function(){return r(e.MemberInfoList,this,"GetMembers",1,[],!1,!1,null,4)},o.prototype.getMembership=function(){return r(e.MemberInfoList,this,"GetMembership",1,[],!1,!1,null,4)},o.prototype.getViewableSources=function(){return s(this,"GetViewableSources",1,[],4,0)},o.prototype.reportTimeForRender=function(e,t){s(this,"ReportTimeForRender",0,[e,t],0,0)},o.prototype.warmup=function(e){s(this,"Warmup",0,[e],0,0)},o.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.Capabilities)||(this._C=n.Capabilities),d(n.DiagnosticId)||(this._D=n.DiagnosticId),d(n.HostId)||(this._H=n.HostId),d(n.InstanceId)||(this._I=n.InstanceId),d(n.Type)||(this._T=n.Type),v(this,n,["actions","Actions","organization","Organization","personaInfo","PersonaInfo","photo","Photo","unifiedCommunicationInfo","UnifiedCommunicationInfo","unifiedGroupInfo","UnifiedGroupInfo"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},o.prototype.toJSON=function(){return g(this,{capabilities:this._C,diagnosticId:this._D,hostId:this._H,instanceId:this._I,type:this._T},{organization:this._O,personaInfo:this._P,unifiedCommunicationInfo:this._U,unifiedGroupInfo:this._Un})},o.prototype.setMockData=function(e){S(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.Persona=V;var q=function(){function t(){}return t.prototype.performAsyncOperation=function(e,t,n,r){var o=this;e!=W.immediate?r().then((function(e){if(e)n();else{var i=o;i.load("hostId"),i.context.sync().then((function(){var e=i.hostId;o.getPersonaLifetime().then((function(o){var a=function(s){return new OfficeExtension.CoreUtility.Promise((function(c,l){if(s.sendingPersonaHostId==e)for(var u=0;u<s.dataUpdated.length;++u){var d=s.dataUpdated[u];if(t==d)return void r().then((function(e){e&&(n(),o.onPersonaUpdated.remove(a),i.context.sync()),c(e)}))}c(!1)}))};o.onPersonaUpdated.add(a),i.context.sync()}))}))}})):n()},t.prototype.getOrganizationAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.organization,(function(){var e=o.organization;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=o.organization;n.load("isWarmedUp"),o.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getIsPersonaInfoResolvedCheck=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.personaInfo;r.load("isPersonResolved"),e.context.sync().then((function(){t(r.isPersonResolved)}))}))},t.prototype.getPersonaInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=o.personaInfo;e.load(),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getPersonaInfoWithSourceAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=new G;e.info=o.personaInfo,e.info.load(),e.source=o.personaInfo.sources,e.source.load(),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedCommunicationInfo=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=o.unifiedCommunicationInfo;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedGroupInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=o.unifiedGroupInfo;e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getTypeAsync=function(t){var n=this;return new OfficeExtension.CoreUtility.Promise((function(r,o){var i=n;n.performAsyncOperation(t,T.personaInfo,(function(){i.load("type"),i.context.sync().then((function(){r(e.PersonaType[i.type.valueOf()])}))}),(function(){return n.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getCustomizationsAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=o.getCustomizations();o.context.sync().then((function(){n(e.value)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getMembersAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.members,(function(){var e=o.getMembers();e.load("isWarmedUp"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=o.getMembers();n.load("isWarmedUp"),o.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getMembershipAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var o=t;t.performAsyncOperation(e,T.membership,(function(){var e=o.getMembership();e.load("*"),o.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e){var t=o.getMembership();t.load("isWarmedUp"),o.context.sync().then((function(){e(t.isWarmedUp)}))}))}))}))},t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e;r.load("instanceId"),r.context.sync().then((function(){new Q(r.context,r.instanceId).getPersonaLifetime().then((function(e){t(e)}))}))}))},t}();e.PersonaCustom=q,OfficeExtension.Utility.applyMixin(V,q);var z=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PersonaLifetime"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"instanceId",{get:function(){return f("instanceId",this._I,"PersonaLifetime",this._isNull),this._I},enumerable:!0,configurable:!0}),n.prototype.getPersona=function(t){return r(e.Persona,this,"GetPersona",1,[t],!1,!1,null,4)},n.prototype.getPersonaForOrgByEntryId=function(t,n,o,i){return r(e.Persona,this,"GetPersonaForOrgByEntryId",1,[t,n,o,i],!1,!1,null,4)},n.prototype.getPersonaForOrgEntry=function(t,n,o,i){return r(e.Persona,this,"GetPersonaForOrgEntry",1,[t,n,o,i],!1,!1,null,4)},n.prototype.getPolicies=function(){return s(this,"GetPolicies",1,[],4,0)},n.prototype.getTextScaleFactor=function(){return s(this,"GetTextScaleFactor",1,[],4,0)},n.prototype._RegisterPersonaUpdatedEvent=function(){s(this,"_RegisterPersonaUpdatedEvent",0,[],0,0)},n.prototype._UnregisterPersonaUpdatedEvent=function(){s(this,"_UnregisterPersonaUpdatedEvent",0,[],0,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.InstanceId)||(this._I=n.InstanceId)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},Object.defineProperty(n.prototype,"onPersonaUpdated",{get:function(){var e=this;return this.m_personaUpdated||(this.m_personaUpdated=new OfficeExtension.GenericEventHandlers(this.context,this,"PersonaUpdated",{eventType:3502,registerFunc:function(){return e._RegisterPersonaUpdatedEvent()},unregisterFunc:function(){return e._UnregisterPersonaUpdatedEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={dataUpdated:e.dataUpdated,sendingPersonaHostId:e.sendingPersonaHostId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_personaUpdated},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{instanceId:this._I},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.PersonaLifetime=z;var J=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LokiTokenProvider"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["emailOrUpn","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["EmailOrUpn","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailOrUpn",{get:function(){return f("emailOrUpn",this._E,"LokiTokenProvider",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return f("instanceId",this._I,"LokiTokenProvider",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.requestClientAccessToken=function(){s(this,"RequestClientAccessToken",0,[],0,0)},t.prototype.requestIdentityUniqueId=function(){s(this,"RequestIdentityUniqueId",0,[],0,0)},t.prototype.requestToken=function(){s(this,"RequestToken",0,[],0,0)},t.prototype._RegisterClientAccessTokenAvailableEvent=function(){s(this,"_RegisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._RegisterIdentityUniqueIdAvailableEvent=function(){s(this,"_RegisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._RegisterLokiTokenAvailableEvent=function(){s(this,"_RegisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterClientAccessTokenAvailableEvent=function(){s(this,"_UnregisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterIdentityUniqueIdAvailableEvent=function(){s(this,"_UnregisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._UnregisterLokiTokenAvailableEvent=function(){s(this,"_UnregisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.EmailOrUpn)||(this._E=n.EmailOrUpn),d(n.InstanceId)||(this._I=n.InstanceId)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},Object.defineProperty(t.prototype,"onClientAccessTokenAvailable",{get:function(){var e=this;return this.m_clientAccessTokenAvailable||(this.m_clientAccessTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"ClientAccessTokenAvailable",{eventType:3505,registerFunc:function(){return e._RegisterClientAccessTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterClientAccessTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={clientAccessToken:e.clientAccessToken,isAvailable:e.isAvailable,tokenTTLInSeconds:e.tokenTTLInSeconds};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_clientAccessTokenAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onIdentityUniqueIdAvailable",{get:function(){var e=this;return this.m_identityUniqueIdAvailable||(this.m_identityUniqueIdAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"IdentityUniqueIdAvailable",{eventType:3504,registerFunc:function(){return e._RegisterIdentityUniqueIdAvailableEvent()},unregisterFunc:function(){return e._UnregisterIdentityUniqueIdAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,uniqueId:e.uniqueId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_identityUniqueIdAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onLokiTokenAvailable",{get:function(){var e=this;return this.m_lokiTokenAvailable||(this.m_lokiTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"LokiTokenAvailable",{eventType:3503,registerFunc:function(){return e._RegisterLokiTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterLokiTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,lokiAutoDiscoverUrl:e.lokiAutoDiscoverUrl,lokiToken:e.lokiToken};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_lokiTokenAvailable},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return g(this,{emailOrUpn:this._E,instanceId:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.LokiTokenProvider=J;var K=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LokiTokenProviderFactory"},enumerable:!0,configurable:!0}),n.prototype.getLokiTokenProvider=function(t){return r(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.LokiTokenProviderFactory,t,"Microsoft.People.LokiTokenProviderFactory",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LokiTokenProviderFactory=K;var Q=function(){function t(e,t){this.context=e,this.instanceId=t}return Object.defineProperty(t.prototype,"serviceContext",{get:function(){return this.m_serviceConext||(this.m_serviceConext=e.ServiceContext.newObject(this.context)),this.m_serviceConext},enumerable:!0,configurable:!0}),t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getPersonaLifetime(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t.prototype.getInitialPersona=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getInitialPersona(e.instanceId);e.context.sync().then((function(){t(r)}))}))},t.prototype.getLokiTokenProvider=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getLokiTokenProvider(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t}();e.PeopleApiContext=Q;var X=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ServiceContext"},enumerable:!0,configurable:!0}),n.prototype.accountEmailOrUpn=function(e){return s(this,"AccountEmailOrUpn",1,[e],4,0)},n.prototype.dispose=function(e){s(this,"Dispose",0,[e],0,0)},n.prototype.getInitialPersona=function(t){return r(e.Persona,this,"GetInitialPersona",1,[t],!1,!1,null,4)},n.prototype.getLokiTokenProvider=function(t){return r(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},n.prototype.getPersonaLifetime=function(t){return r(e.PersonaLifetime,this,"GetPersonaLifetime",1,[t],!1,!1,null,4)},n.prototype.getPersonaPolicies=function(){return s(this,"GetPersonaPolicies",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ServiceContext,t,"Microsoft.People.ServiceContext",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ServiceContext=X;var Y=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RichapiPcxFeatureChecks"},enumerable:!0,configurable:!0}),n.prototype.isAddChangePhotoLinkOnLpcPersonaImageFlightEnabled=function(){return s(this,"IsAddChangePhotoLinkOnLpcPersonaImageFlightEnabled",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.RichapiPcxFeatureChecks,t,"Microsoft.People.RichapiPcxFeatureChecks",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.RichapiPcxFeatureChecks=Y;var $=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return __extends(o,t),Object.defineProperty(o.prototype,"_className",{get:function(){return"Comment"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","text","created","level","resolved","author","mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Text","Created","Level","Resolved","Author","Mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1,!1,!0,!1,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["parent","parentOrNullObject","replies"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parent",{get:function(){return this._P||(this._P=n(e.Comment,this,"Parent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"parentOrNullObject",{get:function(){return this._Pa||(this._Pa=n(e.Comment,this,"ParentOrNullObject",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"replies",{get:function(){return this._R||(this._R=n(e.CommentCollection,this,"Replies",!0,4)),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"author",{get:function(){return f("author",this._A,"Comment",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"created",{get:function(){return f("created",this._C,"Comment",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return f("id",this._I,"Comment",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"level",{get:function(){return f("level",this._L,"Comment",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"mentions",{get:function(){return f("mentions",this._M,"Comment",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"resolved",{get:function(){return f("resolved",this._Re,"Comment",this._isNull),this._Re},set:function(e){this._Re=e,l(this,"Resolved",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"text",{get:function(){return f("text",this._T,"Comment",this._isNull),this._T},set:function(e){this._T=e,l(this,"Text",e,0)},enumerable:!0,configurable:!0}),o.prototype.set=function(e,t){this._recursivelySet(e,t,["text","resolved"],[],["parent","parentOrNullObject","replies"])},o.prototype.update=function(e){this._recursivelyUpdate(e)},o.prototype.delete=function(){s(this,"Delete",0,[],0,0)},o.prototype.getParentOrSelf=function(){return r(e.Comment,this,"GetParentOrSelf",1,[],!1,!1,null,4)},o.prototype.getRichText=function(e){return s(this,"GetRichText",1,[e],4,0)},o.prototype.reply=function(t,n){return r(e.Comment,this,"Reply",0,[t,n],!1,!1,null,0)},o.prototype.setRichText=function(e,t){return s(this,"SetRichText",0,[e,t],0,0)},o.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),d(n.Author)||(this._A=n.Author),d(n.Created)||(this._C=O(n.Created)),d(n.Id)||(this._I=n.Id),d(n.Level)||(this._L=n.Level),d(n.Mentions)||(this._M=n.Mentions),d(n.Resolved)||(this._Re=n.Resolved),d(n.Text)||(this._T=n.Text),v(this,n,["parent","Parent","parentOrNullObject","ParentOrNullObject","replies","Replies"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),u(e)||d(e.Id)||(this._I=e.Id)},o.prototype._handleRetrieveResult=function(e,n){if(t.prototype._handleRetrieveResult.call(this,e,n),!u(e)){var r=e;d(r.Created)||(r.created=O(r.created)),b(this,e,n)}},o.prototype.toJSON=function(){return g(this,{author:this._A,created:this._C,id:this._I,level:this._L,mentions:this._M,resolved:this._Re,text:this._T},{replies:this._R})},o.prototype.setMockData=function(e){S(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.Comment=$;var Z=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"CommentCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return f("items",this.m__items,"CommentCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return o(e.Comment,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!u(n)){var r=n;if(y(this,r),!u(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],i=0;i<o.length;i++){var s=a(e.Comment,!0,this,o[i],i);s._handleResult(o[i]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.Comment,!0,o,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.Comment,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.CommentCollection=Z;var ee=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ExtensionLifeCycle"},enumerable:!0,configurable:!0}),n.prototype.launchExtensionComponent=function(e,t,n){s(this,"LaunchExtensionComponent",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ExtensionLifeCycle,t,"Microsoft.OfficeSharedApi.ExtensionLifeCycle",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ExtensionLifeCycle=ee,function(e){e.plain="Plain",e.markdown="Markdown",e.delta="Delta"}(e.CommentTextFormat||(e.CommentTextFormat={})),function(e){e.shortTime="ShortTime",e.longTime="LongTime",e.shortDate="ShortDate",e.longDate="LongDate"}(e.TimeStringFormat||(e.TimeStringFormat={}));var te=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LocaleApi"},enumerable:!0,configurable:!0}),n.prototype.formatDateTimeString=function(e,t,n){return s(this,"FormatDateTimeString",1,[e,t,n],4,0)},n.prototype.getLocaleDateTimeFormattingInfo=function(e){return s(this,"GetLocaleDateTimeFormattingInfo",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.LocaleApi,t,"Microsoft.LocaleApi.LocaleApi",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LocaleApi=te;var ne=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"FirstPartyDialogService"},enumerable:!0,configurable:!0}),n.prototype.close=function(){s(this,"Close",1,[],5,0)},n.prototype.displayDialog=function(e,t){s(this,"DisplayDialog",1,[e,t],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.FirstPartyDialogService,t,"Microsoft.FirstPartyDialog.FirstPartyDialogService",!1,4)},Object.defineProperty(n.prototype,"onDialogMessage",{get:function(){var e=this;return this.m_dialogMessage||(this.m_dialogMessage=new OfficeExtension.GenericEventHandlers(this.context,this,"DialogMessage",{eventType:65536,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(t){var n=D.FirstPartyDialogService_DialogMessage_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_dialogMessage},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.FirstPartyDialogService=ne,function(e){e.FirstPartyDialogService_DialogMessage_EventArgsTransform=function(e,t){return{message:t.message}}}(D=e._CC||(e._CC={}));var re=function(t){function o(){return null!==t&&t.apply(this,arguments)||this}return __extends(o,t),Object.defineProperty(o.prototype,"_className",{get:function(){return"DynamicRibbon"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["buttons"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"buttons",{get:function(){return this._B||(this._B=n(e.RibbonButtonCollection,this,"Buttons",!0,4)),this._B},enumerable:!0,configurable:!0}),o.prototype.executeRequestCreate=function(e){p("DynamicRibbon.executeRequestCreate","DynamicRibbon","1.2","Office"),s(this,"ExecuteRequestCreate",1,[e],4,0)},o.prototype.executeRequestUpdate=function(e){s(this,"ExecuteRequestUpdate",1,[e],4,0)},o.prototype.getButton=function(t){return r(e.RibbonButton,this,"GetButton",1,[t],!1,!1,null,4)},o.prototype.getTab=function(t){return r(e.RibbonTab,this,"GetTab",1,[t],!1,!1,null,4)},o.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),v(this,n,["buttons","Buttons"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},o.newObject=function(t){return i(e.DynamicRibbon,t,"Microsoft.DynamicRibbon.DynamicRibbon",!1,4)},o.prototype.toJSON=function(){return g(this,{},{buttons:this._B})},o}(OfficeExtension.ClientObject);e.DynamicRibbon=re;var oe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonTab"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return f("id",this._I,"RibbonTab",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.setVisibility=function(e){s(this,"SetVisibility",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),u(t)||d(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{id:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RibbonTab=oe;var ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonButton"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","enabled","label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Enabled","Label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"enabled",{get:function(){return f("enabled",this._E,"RibbonButton",this._isNull),this._E},set:function(e){this._E=e,l(this,"Enabled",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return f("id",this._I,"RibbonButton",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"label",{get:function(){return f("label",this._L,"RibbonButton",this._isNull),this._L},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["enabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype.setEnabled=function(e){s(this,"SetEnabled",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Enabled)||(this._E=n.Enabled),d(n.Id)||(this._I=n.Id),d(n.Label)||(this._L=n.Label)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),u(t)||d(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{enabled:this._E,id:this._I,label:this._L},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RibbonButton=ie;var ae=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RibbonButtonCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return f("items",this.m__items,"RibbonButtonCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return o(e.RibbonButton,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!u(n)){var r=n;if(y(this,r),!u(r[OfficeExtension.Constants.items])){this.m__items=[];for(var o=r[OfficeExtension.Constants.items],i=0;i<o.length;i++){var s=a(e.RibbonButton,!0,this,o[i],i);s._handleResult(o[i]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var o=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.RibbonButton,!0,o,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.RibbonButton,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.RibbonButtonCollection=ae,function(e){e.ariaBrowserPipeUrl="AriaBrowserPipeUrl",e.ariaUploadUrl="AriaUploadUrl",e.ariaVNextUploadUrl="AriaVNextUploadUrl",e.lokiAutoDiscoverUrl="LokiAutoDiscoverUrl"}(e.ServiceProvider||(e.ServiceProvider={}));var se=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ServiceUrlProvider"},enumerable:!0,configurable:!0}),n.prototype.getServiceUrl=function(e,t){return s(this,"GetServiceUrl",1,[e,t],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ServiceUrlProvider,t,"Microsoft.DesktopCompliance.ServiceUrlProvider",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ServiceUrlProvider=se;var ce=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LinkedIn"},enumerable:!0,configurable:!0}),n.prototype.isEnabledForOffice=function(){return s(this,"IsEnabledForOffice",1,[],4,0)},n.prototype.recordLinkedInSettingsCompliance=function(e,t){s(this,"RecordLinkedInSettingsCompliance",0,[e,t],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.LinkedIn,t,"Microsoft.DesktopCompliance.LinkedIn",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LinkedIn=ce;var le=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"NetworkUsage"},enumerable:!0,configurable:!0}),n.prototype.isInDisconnectedMode=function(){return s(this,"IsInDisconnectedMode",1,[],4,0)},n.prototype.isInOnlineMode=function(){return s(this,"IsInOnlineMode",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.NetworkUsage,t,"Microsoft.DesktopCompliance.NetworkUsage",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.NetworkUsage=le;var ue=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"BeforeDocumentCloseNotification"},enumerable:!0,configurable:!0}),n.prototype.disable=function(){s(this,"Disable",1,[],4,0)},n.prototype.enable=function(){s(this,"Enable",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.BeforeDocumentCloseNotification,t,"Microsoft.BeforeDocumentCloseNotification.BeforeDocumentCloseNotification",!1,4)},Object.defineProperty(n.prototype,"onBeforeCloseNotificationCancelled",{get:function(){return this.m_beforeCloseNotificationCancelled||(this.m_beforeCloseNotificationCancelled=new OfficeExtension.GenericEventHandlers(this.context,this,"BeforeCloseNotificationCancelled",{eventType:65540,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_beforeCloseNotificationCancelled},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.BeforeDocumentCloseNotification=ue,function(e){e.organizationAccount="OrganizationAccount",e.microsoftAccount="MicrosoftAccount",e.unsupported="Unsupported"}(e.IdentityType||(e.IdentityType={}));var de=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"AuthenticationService"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["roamingSettings"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"roamingSettings",{get:function(){return this._R||(this._R=n(e.RoamingSettingCollection,this,"RoamingSettings",!1,4)),this._R},enumerable:!0,configurable:!0}),r.prototype.getAccessToken=function(e,t){return s(this,"GetAccessToken",1,[e,t],5,0)},r.prototype.getIdentities=function(){return p("AuthenticationService.getIdentities","FirstPartyAuthentication","1.3","Office"),s(this,"GetIdentities",1,[],5,0)},r.prototype.getPrimaryIdentityInfo=function(){return p("AuthenticationService.getPrimaryIdentityInfo","FirstPartyAuthentication","1.2","Office"),s(this,"GetPrimaryIdentityInfo",1,[],5,0)},r.prototype.registerIdentityChangedEvent=function(){p("AuthenticationService.registerIdentityChangedEvent","FirstPartyAuthentication","1.5","Office"),s(this,"RegisterIdentityChangedEvent",0,[],1,0)},r.prototype.unregisterIdentityChangedEvent=function(){p("AuthenticationService.unregisterIdentityChangedEvent","FirstPartyAuthentication","1.5","Office"),s(this,"UnregisterIdentityChangedEvent",0,[],1,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!u(e)){var n=e;y(this,n),v(this,n,["roamingSettings","RoamingSettings"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},r.newObject=function(t){return i(e.AuthenticationService,t,"Microsoft.Authentication.AuthenticationService",!1,4)},Object.defineProperty(r.prototype,"onIdentityChanged",{get:function(){var e=this;return p("AuthenticationService.onIdentityChanged","FirstPartyAuthentication","1.5","Office"),this.m_identityChanged||(this.m_identityChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"IdentityChanged",{eventType:65545,registerFunc:function(){return e.registerIdentityChangedEvent()},unregisterFunc:function(){return e.unregisterIdentityChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={email:e.email,environment:e.environment,uniqueId:e.uniqueId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_identityChanged},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"onTokenReceived",{get:function(){var e=this;return p("AuthenticationService.onTokenReceived","FirstPartyAuthentication","1.2","Office"),this.m_tokenReceived||(this.m_tokenReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"TokenReceived",{eventType:3001,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return e._targetId},eventArgsTransformFunc:function(t){var n=D.AuthenticationService_TokenReceived_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_tokenReceived},enumerable:!0,configurable:!0}),r.prototype.toJSON=function(){return g(this,{},{})},r}(OfficeExtension.ClientObject);e.AuthenticationService=de;var fe=function(){function e(){}return Object.defineProperty(e.prototype,"_targetId",{get:function(){return void 0==this.m_targetId&&("undefined"!==typeof OSF&&OSF.OUtil?this.m_targetId=OSF.OUtil.Guid.generateNewGuid():this.m_targetId=""+this.context._nextId()),this.m_targetId},enumerable:!0,configurable:!0}),e}();e.AuthenticationServiceCustom=fe,OfficeExtension.Utility.applyMixin(de,fe),function(e){e.AuthenticationService_TokenReceived_EventArgsTransform=function(e,t){var n=t;return{tokenValue:n.tokenValue,code:n.code,errorInfo:n.errorInfo}}}(D=e._CC||(e._CC={}));var pe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RoamingSetting"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return f("id",this._I,"RoamingSetting",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return f("value",this._V,"RoamingSetting",this._isNull),this._V},set:function(e){this._V=e,l(this,"Value",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["value"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!u(t)){var n=t;y(this,n),d(n.Id)||(this._I=n.Id),d(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),u(t)||d(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{id:this._I,value:this._V},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RoamingSetting=pe;var he=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RoamingSettingCollection"},enumerable:!0,configurable:!0}),n.prototype.getItem=function(t){return r(e.RoamingSetting,this,"GetItem",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.RoamingSetting,this,"GetItemOrNullObject",1,[t],!1,!1,null,4)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.RoamingSettingCollection=he;var me=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SharedFilePicker"},enumerable:!0,configurable:!0}),n.prototype.getSharedFilePickerResponse=function(e){return s(this,"GetSharedFilePickerResponse",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.SharedFilePicker,t,"Microsoft.Office.SharedFilePicker",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.SharedFilePicker=me;var ge=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ActionService"},enumerable:!0,configurable:!0}),n.prototype.areShortcutsInUse=function(e){return s(this,"AreShortcutsInUse",0,[e],0,0)},n.prototype.getShortcuts=function(){return s(this,"GetShortcuts",1,[],4,0)},n.prototype.replaceShortcuts=function(e){s(this,"ReplaceShortcuts",0,[e],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ActionService,t,"Microsoft.Office.ActionService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ActionService=ge;var ye=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Auth"},enumerable:!0,configurable:!0}),n.prototype.getAccessTokenFirstPartyOAuth=function(e,t){return s(this,"GetAccessTokenFirstPartyOAuth",1,[e,t],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.Auth,t,"Microsoft.Office.Auth",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.Auth=ye;var ve=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AugLoopEventService"},enumerable:!0,configurable:!0}),n.prototype.sendMessage=function(e){s(this,"SendMessage",1,[e],5,0)},n.prototype._RegisterHostMessageReceivedEvent=function(){s(this,"_RegisterHostMessageReceivedEvent",1,[],5,0)},n.prototype._UnregisterHostMessageReceivedEvent=function(){s(this,"_UnregisterHostMessageReceivedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.AugLoopEventService,t,"Microsoft.Office.AugLoopEventService",!1,5)},Object.defineProperty(n.prototype,"onHostMessageReceived",{get:function(){var e=this;return this.m_hostMessageReceived||(this.m_hostMessageReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"HostMessageReceived",{eventType:65542,registerFunc:function(){return e._RegisterHostMessageReceivedEvent()},unregisterFunc:function(){return e._UnregisterHostMessageReceivedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={data:e.data};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_hostMessageReceived},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AugLoopEventService=ve;var Oe=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"UndoService"},enumerable:!0,configurable:!0}),n.prototype.endCopilotOperation=function(e){s(this,"EndCopilotOperation",0,[e],1,0)},n.prototype.startCopilotOperation=function(e){return s(this,"StartCopilotOperation",0,[e],1,0)},n.prototype.undo=function(){return s(this,"Undo",0,[],1,0)},n.prototype._RegisterUndoStackChangedEvent=function(){s(this,"_RegisterUndoStackChangedEvent",1,[],5,0)},n.prototype._UnregisterUndoStackChangedEvent=function(){s(this,"_UnregisterUndoStackChangedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.UndoService,t,"Microsoft.Office.UndoService",!1,5)},Object.defineProperty(n.prototype,"onCopilotOperationStarted",{get:function(){return this.m_copilotOperationStarted||(this.m_copilotOperationStarted=new OfficeExtension.GenericEventHandlers(this.context,this,"CopilotOperationStarted",{eventType:65544,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={batchId:e.batchId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_copilotOperationStarted},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onUndoStackChanged",{get:function(){var e=this;return this.m_undoStackChanged||(this.m_undoStackChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"UndoStackChanged",{eventType:65543,registerFunc:function(){return e._RegisterUndoStackChangedEvent()},unregisterFunc:function(){return e._UnregisterUndoStackChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_undoStackChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.UndoService=Oe,function(e){e.notSet="NotSet",e.true="True",e.false="False"}(e.TriStateOption||(e.TriStateOption={})),function(e){e.like="Like",e.dislike="Dislike",e.idea="Idea",e.unclassified="Unclassified"}(e.UserFeedbackType||(e.UserFeedbackType={})),function(e){e.modalDialog="ModalDialog",e.taskpane="Taskpane"}(e.UserFeedbackUIType||(e.UserFeedbackUIType={}));var be=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"UserFeedbackService"},enumerable:!0,configurable:!0}),n.prototype.canCollectUserFeedback=function(){return s(this,"CanCollectUserFeedback",1,[],5,0)},n.prototype.collectUserFeedback=function(e,t,n,r){s(this,"CollectUserFeedback",1,[e,t,n,r],5,0)},n.prototype._RegisterUserFeedbackResponseEvent=function(){s(this,"_RegisterUserFeedbackResponseEvent",1,[],5,0)},n.prototype._RegisterUserFeedbackUIDismissedEvent=function(){s(this,"_RegisterUserFeedbackUIDismissedEvent",1,[],5,0)},n.prototype._UnregisterUserFeedbackResponseEvent=function(){s(this,"_UnregisterUserFeedbackResponseEvent",1,[],5,0)},n.prototype._UnregisterUserFeedbackUIDismissedEvent=function(){s(this,"_UnregisterUserFeedbackUIDismissedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.UserFeedbackService,t,"Microsoft.Office.UserFeedbackService",!1,5)},Object.defineProperty(n.prototype,"onUserFeedbackResponse",{get:function(){var e=this;return this.m_userFeedbackResponse||(this.m_userFeedbackResponse=new OfficeExtension.GenericEventHandlers(this.context,this,"UserFeedbackResponse",{eventType:65550,registerFunc:function(){return e._RegisterUserFeedbackResponseEvent()},unregisterFunc:function(){return e._UnregisterUserFeedbackResponseEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={responseData:e.responseData};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_userFeedbackResponse},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onUserFeedbackUIDismissed",{get:function(){var e=this;return this.m_userFeedbackUIDismissed||(this.m_userFeedbackUIDismissed=new OfficeExtension.GenericEventHandlers(this.context,this,"UserFeedbackUIDismissed",{eventType:65546,registerFunc:function(){return e._RegisterUserFeedbackUIDismissedEvent()},unregisterFunc:function(){return e._UnregisterUserFeedbackUIDismissedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={isFeedbackSent:e.isFeedbackSent};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_userFeedbackUIDismissed},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.UserFeedbackService=be;var Se=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"NotificationService"},enumerable:!0,configurable:!0}),n.prototype.addNotification=function(e,t){return s(this,"AddNotification",0,[e,t],1,0)},n.prototype.removeNotification=function(e){s(this,"RemoveNotification",0,[e],1,0)},n.prototype.updateNotification=function(e,t){s(this,"UpdateNotification",0,[e,t],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.NotificationService,t,"Microsoft.Office.NotificationService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.NotificationService=Se;var Ce=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SensitivityService"},enumerable:!0,configurable:!0}),n.prototype.getHighestSensitivityLabel=function(e){return s(this,"GetHighestSensitivityLabel",0,[e],1,0)},n.prototype.getLabel=function(){return s(this,"GetLabel",0,[],1,0)},n.prototype.tryUpgradeLabel=function(e,t){s(this,"TryUpgradeLabel",0,[e,t],1,0)},n.prototype._RegisterSensitivityLabelChangedEvent=function(){s(this,"_RegisterSensitivityLabelChangedEvent",1,[],5,0)},n.prototype._UnregisterSensitivityLabelChangedEvent=function(){s(this,"_UnregisterSensitivityLabelChangedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.SensitivityService,t,"Microsoft.Office.SensitivityService",!1,5)},Object.defineProperty(n.prototype,"onLabelChanged",{get:function(){var e=this;return this.m_labelChanged||(this.m_labelChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"LabelChanged",{eventType:65549,registerFunc:function(){return e._RegisterSensitivityLabelChangedEvent()},unregisterFunc:function(){return e._UnregisterSensitivityLabelChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={context:e.context,error:e.error,newLabel:e.newLabel,previousLabel:e.previousLabel};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_labelChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.SensitivityService=Ce;var _e=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"CopilotService"},enumerable:!0,configurable:!0}),n.prototype.launchHelpPaneByArticleId=function(e){s(this,"LaunchHelpPaneByArticleId",0,[e],1,0)},n.prototype.launchHelpPaneByArticleIdString=function(e){s(this,"LaunchHelpPaneByArticleIdString",0,[e],1,0)},n.prototype.launchHelpPaneByQuery=function(e){s(this,"LaunchHelpPaneByQuery",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.CopilotService,t,"Microsoft.Office.CopilotService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.CopilotService=_e;var Ae=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PrivateApiService"},enumerable:!0,configurable:!0}),n.prototype.execute=function(e){return s(this,"Execute",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.PrivateApiService,t,"Microsoft.Office.PrivateApiService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.PrivateApiService=Ae;var De=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ExternalCodeService"},enumerable:!0,configurable:!0}),n.prototype.executePythonCode=function(e){return s(this,"ExecutePythonCode",0,[e],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),u(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return i(e.ExternalCodeService,t,"Microsoft.Office.ExternalCodeService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ExternalCodeService=De,function(e){e.apiNotAvailable="ApiNotAvailable",e.clientError="ClientError",e.controlIdNotFound="ControlIdNotFound",e.entryIdRequired="EntryIdRequired",e.generalException="GeneralException",e.hostRestartNeeded="HostRestartNeeded",e.instanceNotFound="InstanceNotFound",e.interactiveFlowAborted="InteractiveFlowAborted",e.invalidArgument="InvalidArgument",e.invalidGrant="InvalidGrant",e.invalidResourceUrl="InvalidResourceUrl",e.invalidRibbonDefinition="InvalidRibbonDefinition",e.objectNotFound="ObjectNotFound",e.resourceNotSupported="ResourceNotSupported",e.serverError="ServerError",e.serviceUrlNotFound="ServiceUrlNotFound",e.sharedRuntimeNotAvailable="SharedRuntimeNotAvailable",e.ticketInvalidParams="TicketInvalidParams",e.ticketNetworkError="TicketNetworkError",e.ticketUnauthorized="TicketUnauthorized",e.ticketUninitialized="TicketUninitialized",e.ticketUnknownError="TicketUnknownError",e.unexpectedError="UnexpectedError",e.unsupportedUserIdentity="UnsupportedUserIdentity",e.userNotSignedIn="UserNotSignedIn"}(e.ErrorCodes||(e.ErrorCodes={})),e.Interfaces||(e.Interfaces={})}(OfficeCore||(OfficeCore={})),function(e){var t,n;!function(e){e.hidden="Hidden",e.taskpane="Taskpane"}(t=e.VisibilityMode||(e.VisibilityMode={})),function(e){e.none="None",e.load="Load"}(n=e.StartupBehavior||(e.StartupBehavior={})),function(e){function r(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}function o(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=r(!0),OfficeCore.AppRuntimeService.newObject(t).setAppRuntimeState(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}var i;function a(e){return e===OfficeCore.Visibility.visible?t.taskpane:t.hidden}e.setStartupBehavior=function(e){return __awaiter(this,void 0,void 0,(function(){var t,o;return __generator(this,(function(i){switch(i.label){case 0:if(e!==n.load&&e!==n.none)throw OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.invalidArgument,null,null);return t=e==n.load?OfficeCore.AppRuntimeState.background:OfficeCore.AppRuntimeState.inactive,o=r(!1),OfficeCore.AppRuntimePersistenceService.newObject(o).setAppRuntimeStartState(t),[4,o.sync()];case 1:return i.sent(),[2]}}))}))},e.getStartupBehavior=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,o,i;return __generator(this,(function(a){switch(a.label){case 0:return e=r(!1),t=OfficeCore.AppRuntimePersistenceService.newObject(e),o=t.getAppRuntimeStartState(),[4,e.sync()];case 1:return a.sent(),i=o.value,[2,i==OfficeCore.AppRuntimeState.inactive?n.none:n.load]}}))}))},e.setSnapshotEnabled=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=r(!0),OfficeCore.AppRuntimeService.newObject(t).setSnapshotEnabled(e),[4,t.sync()];case 1:return n.sent(),[2,Promise.resolve()]}}))}))},e.getSnapshotEnabled=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,n;return __generator(this,(function(o){switch(o.label){case 0:return e=r(!0),t=OfficeCore.AppRuntimeService.newObject(e),n=t.getSnapshotEnabled(),[4,e.sync()];case 1:return o.sent(),[2,n.value]}}))}))},e.getContentSnapshotAsBase64=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){return[2,new OfficeExtension.CoreUtility.Promise((function(e,t){var n=r(!0),o=OfficeCore.AppRuntimeService.newObject(n),i=setTimeout((function(){a.remove(),n.sync().catch((function(){})),t(OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.generalException,"timeout","getContentSnapshotAsBase64"))}),7e3),a=o.onSnapshotImageReady.add((function(r){return clearTimeout(i),a.remove(),OfficeExtension.CoreUtility.isNullOrUndefined(r)?(n.sync().catch((function(){})),t(OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.generalException,"execution failed","getContentSnapshotAsBase64"))):(n.sync().catch((function(){})),e(r.imageBase64)),null}));n.sync().then((function(){o.getContentSnapshotAsBase64();return n.sync().then((function(){return null}))})).catch((function(e){t(e)}))}))]}))}))},e._getState=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,n;return __generator(this,(function(o){switch(o.label){case 0:return e=r(!0),t=OfficeCore.AppRuntimeService.newObject(e),n=t.getAppRuntimeState(),[4,e.sync()];case 1:return o.sent(),[2,n.value]}}))}))},e.showAsTaskpane=function(){return o(OfficeCore.AppRuntimeState.visible)},e.hide=function(){return o(OfficeCore.AppRuntimeState.background)},e.onVisibilityModeChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,o=this;return __generator(this,(function(s){switch(s.label){case 0:return t=function(){if(!i){var e=r(!0);i=OfficeCore.AppRuntimeService.newObject(e)}return i}(),n=t.onVisibilityChanged.add((function(t){if(e){var n={visibilityMode:a(t.visibility)};e(n)}return null})),[4,t.context.sync()];case 1:return s.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return n.remove(),[4,t.context.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))},function(e){function t(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}e.enable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).enable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.disable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).disable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onCloseActionCancelled=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i,a=this;return __generator(this,(function(s){switch(s.label){case 0:return n=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(n=!0),r=t(n),o=OfficeCore.BeforeDocumentCloseNotification.newObject(r),i=o.onBeforeCloseNotificationCancelled.add((function(t){return e&&e(),null})),[4,r.sync()];case 1:return s.sent(),[2,function(){return __awaiter(a,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return i.remove(),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.beforeDocumentCloseNotification||(e.beforeDocumentCloseNotification={}))}(e.addin||(e.addin={}))}(Office||(Office={})),function(e){var t;!function(e){e.taskpane="Taskpane",e.dialog="Dialog"}(t||(t={})),function(e){function n(e){return new OfficeCore.RequestContext}e.launchTaskpane=function(e){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=n(),o=OfficeCore.ExtensionLifeCycle.newObject(r),i=e.settings,e.settings=i&&OSF.OUtil.serializeSettings(i),o.launchExtensionComponent("",t.taskpane,e),[4,r.sync()];case 1:return a.sent(),[2]}}))}))},e.launchDialog=function(e){return __awaiter(this,void 0,void 0,(function(){var r,o,i;return __generator(this,(function(a){switch(a.label){case 0:return r=n(),o=OfficeCore.ExtensionLifeCycle.newObject(r),i=e.settings,e.settings=i&&OSF.OUtil.serializeSettings(i),o.launchExtensionComponent("",t.dialog,e),[4,r.sync()];case 1:return a.sent(),[2]}}))}))}}(e.extensionLifeCycle||(e.extensionLifeCycle={}))}(Office||(Office={})),function(e){!function(e){e.executePythonCode=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(o){switch(o.label){case 0:return t=function(){return new OfficeCore.RequestContext}(),n=OfficeCore.ExternalCodeService.newObject(t),r=n.executePythonCode(e),[4,t.sync()];case 1:return o.sent(),[2,r.value]}}))}))}}(e.externalCodeService||(e.externalCodeService={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.requestUpdate=function(e){var n=t(),r=n.ribbon;function o(e){void 0!==e.controls&&void 0!==e.controls.length&&e.controls.length&&e.controls.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getButton(e.id);void 0!==e.enabled&&null!==e.enabled&&(t.enabled=e.enabled)}))}return e.tabs.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getTab(e.id);void 0!==e.visible&&null!==e.visible&&t.setVisibility(e.visible),e.groups&&e.groups.length?e.groups.filter((function(e){return!!e.id})).forEach((function(e){o(e)})):o(e)})),n.sync()},e.requestCreateControls=function(e){var n=t();return n.ribbon.executeRequestCreate(JSON.stringify(e)),function(e){return new Promise((function(t,n){return setTimeout((function(){return t()}),e)}))}(250).then((function(){return n.sync()}))}}(e.ribbon||(e.ribbon={}))}(Office||(Office={})),function(e){var t;OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject,OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod,OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined,OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson,OfficeExtension.Utility.fixObjectPathIfNecessary,OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult,OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags;!function(e){e.generalException="GeneralException"}(t||(t={}));new OfficeExtension.LibraryBuilder({metadata:{version:"1.0.0",name:"OfficeCore",defaultApiSetName:"OfficeSharedApi",hostName:"Office",apiSets:[],strings:["AddinInternalService"],enumTypes:[],clientObjectTypes:[[1,0,0,0,[["notifyActionHandlerReady",0,2,0,4]],0,0,0,0,"Microsoft.InternalService.AddinInternalService",4]]},targetNamespaceObject:e})}(OfficeCore||(OfficeCore={})),function(e){var t;!function(t){var n,r=OfficeExtension.Utility.isNullOrUndefined;function o(e){if(e){var t=e.toUpperCase(),o=n.mappings[t];if(!r(o)&&"function"===typeof o)return o}throw OfficeExtension.Utility.createRuntimeError("invalidOperation","sourceData","ActionProxy._getFunction")}function i(e){try{OfficeExtension.Utility.log("ActionProxy._handleMessage"),OfficeExtension.Utility.checkArgumentNull(e,"args");for(var t=e.entries,n=0;n<t.length;n++)if(2===t[n].messageCategory)if("string"===typeof t[n].message&&(t[n].message=JSON.parse(t[n].message)),1e3===t[n].messageType){var r=null,i=o(t[n].message[0]);if(t[n].message.length>=2){var s=t[n].message[1];s&&(r=a(s)?JSON.parse(s):s)}"undefined"!==typeof OSF&&OSF.AppTelemetry&&OSF.AppTelemetry.CallOnAppActivatedIfPending&&OSF.AppTelemetry.CallOnAppActivatedIfPending(),i.apply(null,[r])}else OfficeExtension.Utility.log("ActionProxy._handleMessage unknown message type "+t[n].messageType)}catch(e){throw function(e){var t=function(e){var t="Unknown Error";if(e)try{e.toString&&(t=e.toString()),t=t+" "+JSON.stringify(e)}catch(e){t="Unexpected Error"}return t}(e);OfficeExtension.Utility.log(t)}(e),e}return OfficeExtension.Utility._createPromiseFromResult(null)}function a(e){return"string"===typeof e&&"{"===e[0]}function s(){try{Microsoft.Office.WebExtension.onReadyInternal().then((function(){return function(){if("undefined"!==typeof OSF&&OSF.DDA&&OSF.DDA.RichApi&&OSF.DDA.RichApi.richApiMessageManager)return(new OfficeExtension.ClientRequestContext).eventRegistration.register(5,"",i)}()})).then((function(){var e=OSF._OfficeAppFactory.getHostInfo();return!0===e.isDialog||"web"===e.hostPlatform&&"word"!==e.hostType&&"excel"!==e.hostType?void 0:function(){var e=new OfficeExtension.ClientRequestContext,t=OfficeCore.AddinInternalService.newObject(e);return e._customData="WacPartition",t.notifyActionHandlerReady(),e.sync()}()}))}catch(e){}}!function(){OfficeExtension.Utility.log("ActionProxy.initOnce"),"undefined"!=typeof e.actions&&function(e){n=e}(e.actions._association),"undefined"!==typeof document&&(document.readyState&&"loading"!==document.readyState?(OfficeExtension.Utility.log("ActionProxy.initOnce: document.readyState is not loading state"),s()):document.addEventListener&&document.addEventListener("DOMContentLoaded",(function(){OfficeExtension.Utility.log("ActionProxy.initOnce: DOMContentLoaded event triggered"),s()}))),OfficeExtension.HostBridge.onInited((function(e){!function(e){e.addHostMessageHandler((function(e){3===e.type&&i(e.message)}))}(e)}))}()}(t||(t={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.areShortcutsInUse=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return n=t(),r=OfficeCore.ActionService.newObject(n),o=r.areShortcutsInUse(e),[4,n.sync()];case 1:for(s.sent(),i=[],a=0;a<e.length;a++)i.push({shortcut:e[a],inUse:o.value[a]});return[2,i]}}))}))},e.replaceShortcuts=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.ActionService.newObject(n).replaceShortcuts(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.getShortcuts=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.ActionService.newObject(e),r=n.getShortcuts(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))}}(e.actions||(e.actions={}))}(Office||(Office={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.SendMessage=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.AugLoopEventService.newObject(n).sendMessage(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onHostMessageReceived=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i=this;return __generator(this,(function(a){switch(a.label){case 0:return n=t(),r=OfficeCore.AugLoopEventService.newObject(n),o=function(t){if(e){var n=t.data;e(n)}return null},r.onHostMessageReceived.add(o),[4,r.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return r.onHostMessageReceived.remove(o),[4,n.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.AugLoop||(e.AugLoop={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return e._customData="SkipUndoRecording",e}var n;function r(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){return"undefined"!==typeof n&&(n(),n=void 0),[2]}))}))}e.undo=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.UndoService.newObject(e),r=n.undo(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))},e.onUndoStackChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o=this;return __generator(this,(function(i){switch(i.label){case 0:return n=t(),(r=OfficeCore.UndoService.newObject(n)).onUndoStackChanged.add(e),[4,n.sync()];case 1:return i.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(t){switch(t.label){case 0:return r.onUndoStackChanged.remove(e),[4,n.sync()];case 1:return t.sent(),[2]}}))}))}]}}))}))},e.startCopilotOperation=function(){return __awaiter(this,void 0,void 0,(function(){var e,o,i,a,s;return __generator(this,(function(c){switch(c.label){case 0:if("undefined"!==typeof n)throw new Error("startCopilotOperation is already inprogress");e=new Promise((function(e){n=e})),c.label=1;case 1:return c.trys.push([1,4,,5]),o=t(),(i=OfficeCore.UndoService.newObject(o)).onCopilotOperationStarted.add(r),[4,o.sync()];case 2:return c.sent(),a=i.startCopilotOperation(""),[4,o.sync()];case 3:return c.sent(),a.value?[2,e]:(n=void 0,[3,5]);case 4:throw s=c.sent(),n=void 0,s;case 5:return[2]}}))}))},e.endCopilotOperation=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(n){switch(n.label){case 0:return e=t(),OfficeCore.UndoService.newObject(e).endCopilotOperation(""),[4,e.sync()];case 1:return n.sent(),[2]}}))}))}}(e.Undo||(e.Undo={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){e.close=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).close(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.readyToShow=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).readyToShow(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.onShow=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(o){switch(o.label){case 0:return t=new OfficeCore.RequestContext,(n=OfficeCore.DialogPage.newObject(t)).onOnShowEvent.add(e),r=function(){return n.onOnShowEvent.remove(e),null},[4,t.sync()];case 1:return o.sent(),[2,r]}}))}))},e.sendMessageToHost=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(t).sendMessageToHost(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}}(e.dialogPage||(e.dialogPage={}))}(Office||(Office={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.CollectUserFeedback=function(e,n,r,o){return __awaiter(this,void 0,void 0,(function(){var i;return __generator(this,(function(a){switch(a.label){case 0:return i=t(),OfficeCore.UserFeedbackService.newObject(i).collectUserFeedback(e,n,r,o),[4,i.sync()];case 1:return a.sent(),[2]}}))}))},e.onUserFeedbackUIDismissed=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.isFeedbackSent;e(n)}return null},r=t(),(o=OfficeCore.UserFeedbackService.newObject(r)).onUserFeedbackUIDismissed.add(n),[4,o.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return o.onUserFeedbackUIDismissed.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))},e.CanCollectUserFeedback=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.UserFeedbackService.newObject(e),r=n.canCollectUserFeedback(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))},e.onUserFeedbackResponse=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.responseData;e(n)}return null},r=t(),(o=OfficeCore.UserFeedbackService.newObject(r)).onUserFeedbackResponse.add(n),[4,o.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return o.onUserFeedbackResponse.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.UserFeedback||(e.UserFeedback={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){var t=function(){return function(){}}();function n(){var e=new OfficeCore.RequestContext;return e._customData="WacPartition",e}function r(e){return JSON.stringify(e instanceof t?{type:"callout",params:e.params}:{type:"custom",props:e})}e.callout=function(e){var n=new t;return n.params=e,n},e.addNotification=function(e,t){return __awaiter(this,void 0,void 0,(function(){var o,i,a;return __generator(this,(function(s){switch(s.label){case 0:return o=n(),i=OfficeCore.NotificationService.newObject(o),a=i.addNotification(r(e),function(e){return JSON.stringify(e)}(t)),[4,o.sync()];case 1:return s.sent(),[2,a.value]}}))}))},e.updateNotification=function(e,t){return __awaiter(this,void 0,void 0,(function(){var o;return __generator(this,(function(i){switch(i.label){case 0:return o=n(),OfficeCore.NotificationService.newObject(o).updateNotification(e,r(t)),[4,o.sync()];case 1:return i.sent(),[2]}}))}))},e.removeNotification=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(r){switch(r.label){case 0:return t=n(),OfficeCore.NotificationService.newObject(t).removeNotification(e),[4,t.sync()];case 1:return r.sent(),[2]}}))}))}}(e.Notification||(e.Notification={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.getLabel=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(o){switch(o.label){case 0:return e=t(),n=OfficeCore.SensitivityService.newObject(e),r=n.getLabel(),[4,e.sync()];case 1:return o.sent(),[2,r.value]}}))}))},e.tryUpgradeLabel=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r;return __generator(this,(function(o){switch(o.label){case 0:return r=t(),OfficeCore.SensitivityService.newObject(r).tryUpgradeLabel(e,n),[4,r.sync()];case 1:return o.sent(),[2]}}))}))},e.getHighestSensitivityLabel=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o;return __generator(this,(function(i){switch(i.label){case 0:return n=t(),r=OfficeCore.SensitivityService.newObject(n),o=r.getHighestSensitivityLabel(e),[4,n.sync()];case 1:return i.sent(),[2,o.value]}}))}))},e.onLabelChangedEvent=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,o,i=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.previousLabel,r=t.newLabel,o=t.context,i=t.error;e(n,r,o,i)}return null},r=t(),(o=OfficeCore.SensitivityService.newObject(r)).onLabelChanged.add(n),[4,o.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return o.onLabelChanged.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.Sensitivity||(e.Sensitivity={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.launchHelpPaneByQuery=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(o){switch(o.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByQuery(e),[4,n.sync()];case 1:return o.sent(),[2]}}))}))},e.launchHelpPaneByArticleId=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(o){switch(o.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByArticleId(e),[4,n.sync()];case 1:return o.sent(),[2]}}))}))},e.launchHelpPaneByArticleIdString=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(o){switch(o.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByArticleIdString(e),[4,n.sync()];case 1:return o.sent(),[2]}}))}))}}(e.Copilot||(e.Copilot={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){e.execute=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(o){switch(o.label){case 0:return t=function(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}(),n=OfficeCore.PrivateApiService.newObject(t),r=n.execute(e),[4,t.sync()];case 1:return o.sent(),[2,r.value]}}))}))}}(e.PrivateApi||(e.PrivateApi={}))}(OfficeFirstParty||(OfficeFirstParty={}));__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();var Excel,__assign=this&&this.__assign||function(){return(__assign=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)},_BeginExcel="_BeginExcel";!function(e){function t(e,t){var r=f("OfficeOnline")?new n:new h;return g(e,r),OfficeExtension.CoreUtility.Promise.resolve().then((function(){return t(r)})).then(r.sync)}!function(e){e.JPG="JPG",e.PNG="PNG"}(e.Base64EncodingType||(e.Base64EncodingType={})),function(e){e.unknown="Unknown",e.dataTypeRestrictedDomain="DataTypeRestrictedDomain",e.dataTypePrivacySetting="DataTypePrivacySetting",e.dataTypeUnsupportedApp="DataTypeUnsupportedApp",e.externalLinksGeneric="ExternalLinksGeneric",e.richDataLinkDisabled="RichDataLinkDisabled",e.signInError="SignInError",e.noLicense="NoLicense"}(e.BlockedErrorCellValueSubType||(e.BlockedErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.externalLinksGeneric="ExternalLinksGeneric",e.loadingImage="LoadingImage"}(e.BusyErrorCellValueSubType||(e.BusyErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.arrayOfArrays="ArrayOfArrays",e.arrayOfRanges="ArrayOfRanges",e.emptyArray="EmptyArray",e.unsupportedLifting="UnsupportedLifting",e.dataTableReferencedPendingFormula="DataTableReferencedPendingFormula",e.tooManyCells="TooManyCells",e.lambdaInCell="LambdaInCell",e.tooDeeplyNested="TooDeeplyNested",e.textOverflow="TextOverflow"}(e.CalcErrorCellValueSubType||(e.CalcErrorCellValueSubType={})),function(e){e.entity="Entity",e.array="Array"}(e.EntityCardLayoutType||(e.EntityCardLayoutType={})),function(e){e.generic="Generic",e.accessibility="Accessibility",e.airplane="Airplane",e.airplaneTakeOff="AirplaneTakeOff",e.album="Album",e.alert="Alert",e.alertUrgent="AlertUrgent",e.animal="Animal",e.animalCat="AnimalCat",e.animalDog="AnimalDog",e.animalRabbit="AnimalRabbit",e.animalTurtle="AnimalTurtle",e.appFolder="AppFolder",e.appGeneric="AppGeneric",e.apple="Apple",e.approvalsApp="ApprovalsApp",e.archive="Archive",e.archiveMultiple="ArchiveMultiple",e.arrowTrendingLines="ArrowTrendingLines",e.art="Art",e.atom="Atom",e.attach="Attach",e.automobile="Automobile",e.autosum="Autosum",e.backpack="Backpack",e.badge="Badge",e.balloon="Balloon",e.bank="Bank",e.barcodeScanner="BarcodeScanner",e.basketball="Basketball",e.battery0="Battery0",e.battery10="Battery10",e.beach="Beach",e.beaker="Beaker",e.bed="Bed",e.binFull="BinFull",e.bird="Bird",e.bluetooth="Bluetooth",e.board="Board",e.boardGames="BoardGames",e.book="Book",e.bookmark="Bookmark",e.bookmarkMultiple="BookmarkMultiple",e.bot="Bot",e.bowlChopsticks="BowlChopsticks",e.box="Box",e.boxMultiple="BoxMultiple",e.brainCircuit="BrainCircuit",e.branch="Branch",e.branchFork="BranchFork",e.branchRequest="BranchRequest",e.bridge="Bridge",e.briefcase="Briefcase",e.briefcaseMedical="BriefcaseMedical",e.broadActivityFeed="BroadActivityFeed",e.broom="Broom",e.bug="Bug",e.building="Building",e.buildingBank="BuildingBank",e.buildingFactory="BuildingFactory",e.buildingGovernment="BuildingGovernment",e.buildingHome="BuildingHome",e.buildingLighthouse="BuildingLighthouse",e.buildingMultiple="BuildingMultiple",e.buildingRetail="BuildingRetail",e.buildingRetailMore="BuildingRetailMore",e.buildingRetailToolbox="BuildingRetailToolbox",e.buildingShop="BuildingShop",e.buildingSkyscraper="BuildingSkyscraper",e.calculator="Calculator",e.calendarLtr="CalendarLtr",e.calendarRtl="CalendarRtl",e.call="Call",e.calligraphyPen="CalligraphyPen",e.camera="Camera",e.cameraDome="CameraDome",e.car="Car",e.cart="Cart",e.cat="Cat",e.certificate="Certificate",e.chartMultiple="ChartMultiple",e.chat="Chat",e.chatMultiple="ChatMultiple",e.chatVideo="ChatVideo",e.check="Check",e.checkboxChecked="CheckboxChecked",e.checkboxUnchecked="CheckboxUnchecked",e.checkmark="Checkmark",e.chess="Chess",e.city="City",e.class="Class",e.classification="Classification",e.clipboard="Clipboard",e.clipboardDataBar="ClipboardDataBar",e.clipboardPulse="ClipboardPulse",e.clipboardTask="ClipboardTask",e.clock="Clock",e.clockAlarm="ClockAlarm",e.cloud="Cloud",e.cloudWords="CloudWords",e.code="Code",e.collections="Collections",e.comment="Comment",e.commentMultiple="CommentMultiple",e.communication="Communication",e.compassNorthwest="CompassNorthwest",e.conferenceRoom="ConferenceRoom",e.connector="Connector",e.constellation="Constellation",e.contactCard="ContactCard",e.cookies="Cookies",e.couch="Couch",e.creditCardPerson="CreditCardPerson",e.creditCardToolbox="CreditCardToolbox",e.cube="Cube",e.cubeMultiple="CubeMultiple",e.cubeTree="CubeTree",e.currencyDollarEuro="CurrencyDollarEuro",e.currencyDollarRupee="CurrencyDollarRupee",e.dataArea="DataArea",e.database="Database",e.databaseMultiple="DatabaseMultiple",e.dataFunnel="DataFunnel",e.dataHistogram="DataHistogram",e.dataLine="DataLine",e.dataPie="DataPie",e.dataScatter="DataScatter",e.dataSunburst="DataSunburst",e.dataTreemap="DataTreemap",e.dataWaterfall="DataWaterfall",e.dataWhisker="DataWhisker",e.dentist="Dentist",e.designIdeas="DesignIdeas",e.desktop="Desktop",e.desktopMac="DesktopMac",e.developerBoard="DeveloperBoard",e.deviceMeetingRoom="DeviceMeetingRoom",e.diagram="Diagram",e.dialpad="Dialpad",e.diamond="Diamond",e.dinosaur="Dinosaur",e.directions="Directions",e.disaster="Disaster",e.diversity="Diversity",e.dNA="DNA",e.doctor="Doctor",e.document="Document",e.documentData="DocumentData",e.documentLandscape="DocumentLandscape",e.documentMultiple="DocumentMultiple",e.documentPdf="DocumentPdf",e.documentQueue="DocumentQueue",e.documentText="DocumentText",e.dog="Dog",e.door="Door",e.doorTag="DoorTag",e.drafts="Drafts",e.drama="Drama",e.drinkBeer="DrinkBeer",e.drinkCoffee="DrinkCoffee",e.drinkMargarita="DrinkMargarita",e.drinkToGo="DrinkToGo",e.drinkWine="DrinkWine",e.driveTrain="DriveTrain",e.drop="Drop",e.dualScreen="DualScreen",e.dumbbell="Dumbbell",e.earth="Earth",e.emoji="Emoji",e.emojiAngry="EmojiAngry",e.emojiHand="EmojiHand",e.emojiLaugh="EmojiLaugh",e.emojiMeh="EmojiMeh",e.emojiMultiple="EmojiMultiple",e.emojiSad="EmojiSad",e.emojiSadSlight="EmojiSadSlight",e.emojiSmileSlight="EmojiSmileSlight",e.emojiSparkle="EmojiSparkle",e.emojiSurprise="EmojiSurprise",e.engine="Engine",e.eraser="Eraser",e.eye="Eye",e.eyedropper="Eyedropper",e.fax="Fax",e.fingerprint="Fingerprint",e.firstAid="FirstAid",e.flag="Flag",e.flash="Flash",e.flashlight="Flashlight",e.flow="Flow",e.flowchart="Flowchart",e.folder="Folder",e.folderOpen="FolderOpen",e.folderOpenVertical="FolderOpenVertical",e.folderPerson="FolderPerson",e.folderZip="FolderZip",e.food="Food",e.foodApple="FoodApple",e.foodCake="FoodCake",e.foodEgg="FoodEgg",e.foodGrains="FoodGrains",e.foodPizza="FoodPizza",e.foodToast="FoodToast",e.galaxy="Galaxy",e.games="Games",e.ganttChart="GanttChart",e.gas="Gas",e.gasPump="GasPump",e.gauge="Gauge",e.gavel="Gavel",e.gift="Gift",e.giftCard="GiftCard",e.glasses="Glasses",e.globe="Globe",e.globeSurface="GlobeSurface",e.grid="Grid",e.gridDots="GridDots",e.gridKanban="GridKanban",e.guardian="Guardian",e.guest="Guest",e.guitar="Guitar",e.handLeft="HandLeft",e.handRight="HandRight",e.handshake="Handshake",e.hardDrive="HardDrive",e.hatGraduation="HatGraduation",e.headphones="Headphones",e.headphonesSoundWave="HeadphonesSoundWave",e.headset="Headset",e.headsetVr="HeadsetVr",e.heart="Heart",e.heartBroken="HeartBroken",e.heartCircle="HeartCircle",e.heartHuman="HeartHuman",e.heartPulse="HeartPulse",e.history="History",e.home="Home",e.homeMore="HomeMore",e.homePerson="HomePerson",e.icons="Icons",e.image="Image",e.imageGlobe="ImageGlobe",e.imageMultiple="ImageMultiple",e.iot="Iot",e.joystick="Joystick",e.justice="Justice",e.key="Key",e.keyboard="Keyboard",e.keyboardLayoutSplit="KeyboardLayoutSplit",e.keyMultiple="KeyMultiple",e.languages="Languages",e.laptop="Laptop",e.lasso="Lasso",e.launcherSettings="LauncherSettings",e.layer="Layer",e.leaf="Leaf",e.leafOne="LeafOne",e.leafThree="LeafThree",e.leafTwo="LeafTwo",e.library="Library",e.lightbulb="Lightbulb",e.lightbulbFilament="LightbulbFilament",e.likert="Likert",e.link="Link",e.localLanguage="LocalLanguage",e.location="Location",e.lockClosed="LockClosed",e.lockMultiple="LockMultiple",e.lockOpen="LockOpen",e.lottery="Lottery",e.luggage="Luggage",e.mail="Mail",e.mailInbox="MailInbox",e.mailMultiple="MailMultiple",e.map="Map",e.mapPin="MapPin",e.markdown="Markdown",e.mathFormula="MathFormula",e.mathSymbols="MathSymbols",e.max="Max",e.megaphone="Megaphone",e.megaphoneLoud="MegaphoneLoud",e.mention="Mention",e.mic="Mic",e.microscope="Microscope",e.midi="Midi",e.molecule="Molecule",e.money="Money",e.moneyHand="MoneyHand",e.mountain="Mountain",e.movieCamera="MovieCamera",e.moviesAndTv="MoviesAndTv",e.musicNote="MusicNote",e.musicNote1="MusicNote1",e.musicNote2="MusicNote2",e.myLocation="MyLocation",e.nByN="NByN",e.nByOne="NByOne",e.news="News",e.notablePeople="NotablePeople",e.note="Note",e.notebook="Notebook",e.notepad="Notepad",e.notepadPerson="NotepadPerson",e.oneByN="OneByN",e.oneByOne="OneByOne",e.options="Options",e.organization="Organization",e.organizationHorizontal="OrganizationHorizontal",e.oval="Oval",e.paintBrush="PaintBrush",e.paintBucket="PaintBucket",e.partlySunnyWeather="PartlySunnyWeather",e.password="Password",e.patch="Patch",e.patient="Patient",e.payment="Payment",e.pen="Pen",e.pentagon="Pentagon",e.people="People",e.peopleAudience="PeopleAudience",e.peopleCall="PeopleCall",e.peopleCommunity="PeopleCommunity",e.peopleMoney="PeopleMoney",e.peopleQueue="PeopleQueue",e.peopleTeam="PeopleTeam",e.peopleToolbox="PeopleToolbox",e.person="Person",e.personBoard="PersonBoard",e.personCall="PersonCall",e.personChat="PersonChat",e.personFeedback="PersonFeedback",e.personSupport="PersonSupport",e.personVoice="PersonVoice",e.phone="Phone",e.phoneDesktop="PhoneDesktop",e.phoneLaptop="PhoneLaptop",e.phoneShake="PhoneShake",e.phoneTablet="PhoneTablet",e.phoneVibrate="PhoneVibrate",e.photoFilter="PhotoFilter",e.pi="Pi",e.pictureInPicture="PictureInPicture",e.pilates="Pilates",e.pill="Pill",e.pin="Pin",e.pipeline="Pipeline",e.planet="Planet",e.playingCards="PlayingCards",e.plugConnected="PlugConnected",e.plugDisconnected="PlugDisconnected",e.pointScan="PointScan",e.poll="Poll",e.power="Power",e.predictions="Predictions",e.premium="Premium",e.presenter="Presenter",e.previewLink="PreviewLink",e.print="Print",e.production="Production",e.prohibited="Prohibited",e.projectionScreen="ProjectionScreen",e.protocolHandler="ProtocolHandler",e.pulse="Pulse",e.pulseSquare="PulseSquare",e.puzzlePiece="PuzzlePiece",e.qrCode="QrCode",e.radar="Radar",e.ram="Ram",e.readingList="ReadingList",e.realEstate="RealEstate",e.receipt="Receipt",e.reward="Reward",e.rhombus="Rhombus",e.ribbon="Ribbon",e.ribbonStar="RibbonStar",e.roadCone="RoadCone",e.rocket="Rocket",e.router="Router",e.rss="Rss",e.ruler="Ruler",e.run="Run",e.running="Running",e.satellite="Satellite",e.save="Save",e.savings="Savings",e.scales="Scales",e.scan="Scan",e.scratchpad="Scratchpad",e.screenPerson="ScreenPerson",e.screenshot="Screenshot",e.search="Search",e.serialPort="SerialPort",e.server="Server",e.serverMultiple="ServerMultiple",e.serviceBell="ServiceBell",e.settings="Settings",e.shapes="Shapes",e.shield="Shield",e.shieldTask="ShieldTask",e.shoppingBag="ShoppingBag",e.signature="Signature",e.sim="Sim",e.sleep="Sleep",e.smartwatch="Smartwatch",e.soundSource="SoundSource",e.soundWaveCircle="SoundWaveCircle",e.sparkle="Sparkle",e.speaker0="Speaker0",e.speaker2="Speaker2",e.sport="Sport",e.sportAmericanFootball="SportAmericanFootball",e.sportBaseball="SportBaseball",e.sportBasketball="SportBasketball",e.sportHockey="SportHockey",e.sportSoccer="SportSoccer",e.squareMultiple="SquareMultiple",e.squareShadow="SquareShadow",e.squaresNested="SquaresNested",e.stack="Stack",e.stackStar="StackStar",e.star="Star",e.starFilled="StarFilled",e.starHalf="StarHalf",e.starLineHorizontal3="StarLineHorizontal3",e.starOneQuarter="StarOneQuarter",e.starThreeQuarter="StarThreeQuarter",e.status="Status",e.steps="Steps",e.stethoscope="Stethoscope",e.sticker="Sticker",e.storage="Storage",e.stream="Stream",e.streamInput="StreamInput",e.streamInputOutput="StreamInputOutput",e.streamOutput="StreamOutput",e.styleGuide="StyleGuide",e.subGrid="SubGrid",e.subtitles="Subtitles",e.surfaceEarbuds="SurfaceEarbuds",e.surfaceHub="SurfaceHub",e.symbols="Symbols",e.syringe="Syringe",e.system="System",e.tabDesktop="TabDesktop",e.tabInprivateAccount="TabInprivateAccount",e.table="Table",e.tableImage="TableImage",e.tableMultiple="TableMultiple",e.tablet="Tablet",e.tabs="Tabs",e.tag="Tag",e.tagCircle="TagCircle",e.tagMultiple="TagMultiple",e.target="Target",e.targetArrow="TargetArrow",e.teddy="Teddy",e.temperature="Temperature",e.tent="Tent",e.tetrisApp="TetrisApp",e.textbox="Textbox",e.textQuote="TextQuote",e.thinking="Thinking",e.thumbDislike="ThumbDislike",e.thumbLike="ThumbLike",e.ticketDiagonal="TicketDiagonal",e.ticketHorizontal="TicketHorizontal",e.timeAndWeather="TimeAndWeather",e.timeline="Timeline",e.timer="Timer",e.toolbox="Toolbox",e.topSpeed="TopSpeed",e.translate="Translate",e.transmission="Transmission",e.treeDeciduous="TreeDeciduous",e.treeEvergreen="TreeEvergreen",e.trophy="Trophy",e.tv="Tv",e.tvUsb="TvUsb",e.umbrella="Umbrella",e.usbPlug="UsbPlug",e.usbStick="UsbStick",e.vault="Vault",e.vehicleBicycle="VehicleBicycle",e.vehicleBus="VehicleBus",e.vehicleCab="VehicleCab",e.vehicleCar="VehicleCar",e.vehicleCarCollision="VehicleCarCollision",e.vehicleCarProfileLtr="VehicleCarProfileLtr",e.vehicleCarProfileRtl="VehicleCarProfileRtl",e.vehicleShip="VehicleShip",e.vehicleSubway="VehicleSubway",e.vehicleTruck="VehicleTruck",e.vehicleTruckBag="VehicleTruckBag",e.vehicleTruckCube="VehicleTruckCube",e.vehicleTruckProfile="VehicleTruckProfile",e.video="Video",e.video360="Video360",e.videoChat="VideoChat",e.videoClip="VideoClip",e.videoClipMultiple="VideoClipMultiple",e.videoPerson="VideoPerson",e.videoRecording="VideoRecording",e.videoSecurity="VideoSecurity",e.viewDesktop="ViewDesktop",e.viewDesktopMobile="ViewDesktopMobile",e.violin="Violin",e.virtualNetwork="VirtualNetwork",e.voicemail="Voicemail",e.vote="Vote",e.walkieTalkie="WalkieTalkie",e.wallet="Wallet",e.walletCreditCard="WalletCreditCard",e.wallpaper="Wallpaper",e.wand="Wand",e.warning="Warning",e.weatherBlowingSnow="WeatherBlowingSnow",e.weatherCloudy="WeatherCloudy",e.weatherDrizzle="WeatherDrizzle",e.weatherDuststorm="WeatherDuststorm",e.weatherFog="WeatherFog",e.weatherHailDay="WeatherHailDay",e.weatherHailNight="WeatherHailNight",e.weatherHaze="WeatherHaze",e.weatherMoon="WeatherMoon",e.weatherPartlyCloudyDay="WeatherPartlyCloudyDay",e.weatherPartlyCloudyNight="WeatherPartlyCloudyNight",e.weatherRain="WeatherRain",e.weatherRainShowersDay="WeatherRainShowersDay",e.weatherRainShowersNight="WeatherRainShowersNight",e.weatherRainSnow="WeatherRainSnow",e.weatherSnow="WeatherSnow",e.weatherSnowflake="WeatherSnowflake",e.weatherSnowShowerDay="WeatherSnowShowerDay",e.weatherSnowShowerNight="WeatherSnowShowerNight",e.weatherSqualls="WeatherSqualls",e.weatherSunnyHigh="WeatherSunnyHigh",e.weatherSunnyLow="WeatherSunnyLow",e.weatherThunderstorm="WeatherThunderstorm",e.webAsset="WebAsset",e.whiteboard="Whiteboard",e.wifi1="Wifi1",e.wifi2="Wifi2",e.window="Window",e.windowMultiple="WindowMultiple",e.windowWrench="WindowWrench",e.wrench="Wrench",e.wrenchScrewdriver="WrenchScrewdriver",e.xray="Xray",e.yoga="Yoga"}(e.EntityCompactLayoutIcons||(e.EntityCompactLayoutIcons={})),function(e){e.array="Array",e.entity="Entity",e.root="Root"}(e.ReferenceValueType||(e.ReferenceValueType={})),function(e){e.array="Array",e.boolean="Boolean",e.double="Double",e.entity="Entity",e.empty="Empty",e.error="Error",e.externalCodeServiceObject="ExternalCodeServiceObject",e.formattedNumber="FormattedNumber",e.linkedEntity="LinkedEntity",e.localImage="LocalImage",e.reference="Reference",e.string="String",e.notAvailable="NotAvailable",e.webImage="WebImage"}(e.CellValueType||(e.CellValueType={})),function(e){e.unknown="Unknown",e.serviceError="ServiceError",e.externalLinks="ExternalLinks",e.externalLinksNonCloudLocation="ExternalLinksNonCloudLocation",e.dataTypeNoConnection="DataTypeNoConnection",e.dataTypeServiceError="DataTypeServiceError",e.missingContent="MissingContent",e.requestThrottle="RequestThrottle",e.externalLinksFailedToRefresh="ExternalLinksFailedToRefresh",e.externalLinksAccessFailed="ExternalLinksAccessFailed",e.externalLinksServerError="ExternalLinksServerError",e.externalLinksInvalidRequest="ExternalLinksInvalidRequest",e.externalLinksUnAuthenticated="ExternalLinksUnAuthenticated",e.externalLinksThrottledByHost="ExternalLinksThrottledByHost",e.externalLinksFileTooLarge="ExternalLinksFileTooLarge",e.outdatedLinkedEntity="OutdatedLinkedEntity",e.genericServerError="GenericServerError"}(e.ConnectErrorCellValueSubType||(e.ConnectErrorCellValueSubType={})),function(e){e.blocked="Blocked",e.busy="Busy",e.calc="Calc",e.connect="Connect",e.div0="Div0",e.external="External",e.field="Field",e.gettingData="GettingData",e.notAvailable="NotAvailable",e.name="Name",e.null="Null",e.num="Num",e.placeholder="Placeholder",e.python="Python",e.ref="Ref",e.spill="Spill",e.timeout="Timeout",e.value="Value"}(e.ErrorCellValueType||(e.ErrorCellValueType={})),function(e){e.unknown="Unknown"}(e.ExternalErrorCellValueSubType||(e.ExternalErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.webImageMissingFilePart="WebImageMissingFilePart",e.dataProviderError="DataProviderError",e.richValueRelMissingFilePart="RichValueRelMissingFilePart"}(e.FieldErrorCellValueSubType||(e.FieldErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.arrayTooLarge="ArrayTooLarge"}(e.NumErrorCellValueSubType||(e.NumErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.externalLinksStructuredRef="ExternalLinksStructuredRef",e.externalLinksCalculatedRef="ExternalLinksCalculatedRef"}(e.RefErrorCellValueSubType||(e.RefErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.collision="Collision",e.indeterminateSize="IndeterminateSize",e.worksheetEdge="WorksheetEdge",e.outOfMemoryWhileCalc="OutOfMemoryWhileCalc",e.table="Table",e.mergedCell="MergedCell"}(e.SpillErrorCellValueSubType||(e.SpillErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.pythonTimeoutLimitReached="PythonTimeoutLimitReached"}(e.TimeoutErrorCellValueSubType||(e.TimeoutErrorCellValueSubType={})),function(e){e.unknown="Unknown",e.vlookupColumnIndexLessThanOne="VlookupColumnIndexLessThanOne",e.vlookupResultNotFound="VlookupResultNotFound",e.hlookupRowIndexLessThanOne="HlookupRowIndexLessThanOne",e.hlookupResultNotFound="HlookupResultNotFound",e.coerceStringToNumberInvalid="CoerceStringToNumberInvalid",e.coerceStringToBoolInvalid="CoerceStringToBoolInvalid",e.coerceStringToInvalidType="CoerceStringToInvalidType",e.subArrayStartRowMissingEndRowNot="SubArrayStartRowMissingEndRowNot",e.subArrayStartColumnMissingEndColumnNot="SubArrayStartColumnMissingEndColumnNot",e.invalidImageUrl="InvalidImageUrl",e.stockHistoryNonTradingDays="StockHistoryNonTradingDays",e.stockHistoryNotAStock="StockHistoryNotAStock",e.stockHistoryInvalidDate="StockHistoryInvalidDate",e.stockHistoryEndBeforeStart="StockHistoryEndBeforeStart",e.stockHistoryStartInFuture="StockHistoryStartInFuture",e.stockHistoryInvalidEnum="StockHistoryInvalidEnum",e.stockHistoryOnlyDateRequested="StockHistoryOnlyDateRequested",e.stockHistoryNotFound="StockHistoryNotFound",e.lambdaWrongParamCount="LambdaWrongParamCount"}(e.ValueErrorCellValueSubType||(e.ValueErrorCellValueSubType={}));var n=function(e){function t(t){var n=e.call(this,t)||this;return n._customData="WacPartition",n.m_wacWorkbook=A(r,n),n._rootObject=n.m_wacWorkbook,n._rootObjectPropertyName="wacWorkbook",n}return __extends(t,e),Object.defineProperty(t.prototype,"wacWorkbook",{get:function(){return this.m_wacWorkbook},enumerable:!0,configurable:!0}),t}(OfficeCore.RequestContext),r=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.createAndOpenWorkbook=function(e){D(this,"CreateAndOpenWorkbook",0,[e],0,0)},t}(OfficeExtension.ClientObject);function o(e){return e[0].toLowerCase()+e.slice(1)}e.createWorkbook=function(e){return R("Excel.createWorkbook",C,"1.8",S),t({delayForCellEdit:!0},(function(t){t instanceof n?t.wacWorkbook.createAndOpenWorkbook(e):t.workbook.application.createWorkbook(e).open()}))};var i,a,s,c=[["RedDownArrow","YellowSideArrow","GreenUpArrow"],["GrayDownArrow","GraySideArrow","GrayUpArrow"],["RedFlag","YellowFlag","GreenFlag"],["RedCircleWithBorder","YellowCircle","GreenCircle"],["RedTrafficLight","YellowTrafficLight","GreenTrafficLight"],["RedDiamond","YellowTriangle","GreenCircle"],["RedCrossSymbol","YellowExclamationSymbol","GreenCheckSymbol"],["RedCross","YellowExclamation","GreenCheck"],["RedDownArrow","YellowDownInclineArrow","YellowUpInclineArrow","GreenUpArrow"],["GrayDownArrow","GrayDownInclineArrow","GrayUpInclineArrow","GrayUpArrow"],["BlackCircle","GrayCircle","PinkCircle","RedCircle"],["OneBar","TwoBars","ThreeBars","FourBars"],["BlackCircleWithBorder","RedCircleWithBorder","YellowCircle","GreenCircle"],["RedDownArrow","YellowDownInclineArrow","YellowSideArrow","YellowUpInclineArrow","GreenUpArrow"],["GrayDownArrow","GrayDownInclineArrow","GraySideArrow","GrayUpInclineArrow","GrayUpArrow"],["NoBars","OneBar","TwoBars","ThreeBars","FourBars"],["WhiteCircleAllWhiteQuarters","CircleWithThreeWhiteQuarters","CircleWithTwoWhiteQuarters","CircleWithOneWhiteQuarter","BlackCircle"],["SilverStar","HalfGoldStar","GoldStar"],["RedDownTriangle","YellowDash","GreenUpTriangle"],["NoFilledBoxes","OneFilledBox","TwoFilledBoxes","ThreeFilledBoxes","FourFilledBoxes"]];function l(e,t,n,r){if(Array.isArray(n)&&n.length>0&&Array.isArray(n[0])&&n.length*n[0].length>1500&&d()){var o=Math.max(1,Math.round(1500/n[0].length));e._ValidateArraySize(n.length,n[0].length);for(var i=0;i<n.length;i+=o){var a=o;i+a>n.length&&(a=n.length-i);var s=e.getRow(i).untrack().getBoundingRect(e.getRow(i+a-1).untrack()).untrack(),c=n.slice(i,i+a);E(s,t,c,null!=r?r:0)}return!0}return!1}function u(e){return OfficeExtension.Utility.isSetSupported("ExcelApi",e.toString())}function d(){return u(1.3)}function f(e){return!("undefined"===typeof window||!window.Office||!window.Office.context)&&window.Office.context.platform===e}e.icons={},["ThreeArrows","ThreeArrowsGray","ThreeFlags","ThreeTrafficLights1","ThreeTrafficLights2","ThreeSigns","ThreeSymbols","ThreeSymbols2","FourArrows","FourArrowsGray","FourRedToBlack","FourRating","FourTrafficLights","FiveArrows","FiveArrowsGray","FiveRating","FiveQuarters","ThreeStars","ThreeTriangles","FiveBoxes"].map((function(t,n){var r=o(t);e.icons[r]=[],c[n].map((function(n,i){n=o(n);var a={set:t,index:i};e.icons[r].push(a),e.icons[r][n]=a}))})),function(e){e.NotStarted="notStarted",e.Running="running",e.Succeeded="succeeded",e.Failed="failed"}(i||(i={})),function(e){e[e.OK=200]="OK",e[e.Created=201]="Created",e[e.Accepted=202]="Accepted",e[e.NoContent=204]="NoContent",e[e.HighestSuccessCode=299]="HighestSuccessCode",e[e.TooManyRequests=429]="TooManyRequests",e[e.InternalServerError=500]="InternalServerError",e[e.ServiceUnavailable=503]="ServiceUnavailable",e[e.GatewayTimeout=504]="GatewayTimeout"}(a||(a={})),function(e){e.Close="Session.close",e.CommitChanges="Session.commitChanges",e.Create="Session.resolveRequestUrlAndHeaderInfo",e.Refresh="Session.refreshSession"}(s=e.SessionOperation||(e.SessionOperation={}));var p=function(){function e(e,t,n){var r=void 0===n?{}:n,o=r.persistChanges,i=void 0===o||o,a=r.commitExplicitly,s=void 0===a||a;this.m_requestId="",this.m_workbookUrl=e?this.ensureUrlFormatEndWithSlash(e):"",this.m_requestHeaders=t||{},this.m_persistChanges=i,this.m_commitExplicitly=s}return Object.defineProperty(e.prototype,"requestId",{get:function(){return this.m_requestId},enumerable:!0,configurable:!0}),e.prototype.close=function(){var t=this;if(this.m_requestUrlAndHeaderInfo&&!OfficeExtension.Utility._isLocalDocumentUrl(this.m_requestUrlAndHeaderInfo.url)){var n={method:"POST",url:this.ensureUrlFormatEndWithSlash(this.m_requestUrlAndHeaderInfo.url)+e.CLOSE_SESSION,headers:this.m_requestUrlAndHeaderInfo.headers,body:""};return OfficeExtension.HttpUtility.sendRequest(n).then((function(n){if(n.statusCode!==a.NoContent)throw t.createErrorFromResponseInfo(n,s.Close);for(var r in t.m_requestUrlAndHeaderInfo=null,t.m_requestHeaders)if(r.toLowerCase()===e.WorkbookSessionIdHeaderNameLower){delete t.m_requestHeaders[r];break}}))}return OfficeExtension.Utility._createPromiseFromResult(null)},e.prototype.commitChanges=function(t){var n=this;if(void 0===t&&(t={}),!this.m_commitExplicitly)throw this.createError(a.InternalServerError,"Can not call commitChanges() if commitExplicitly is not set.",s.CommitChanges);if(!this.m_workbookUrl||OfficeExtension.Utility._isLocalDocumentUrl(this.m_workbookUrl))throw this.createError(a.InternalServerError,"Not supported for local documents.",s.CommitChanges);if(!this.m_requestUrlAndHeaderInfo)throw this.createError(a.InternalServerError,"Need to call this._resolveRequestUrlAndHeaderInfo() to get the session id first.",s.CommitChanges);var r=this.createCommitChangesRequestInfo(t);return OfficeExtension.HttpUtility.sendRequest(r).then((function(r){var o=r.statusCode;if(o===a.Accepted)return n.delay(e.POLL_DELAY).then((function(o){return n.pollResourceLocation(n.getHeaderIgnoreCase(r.headers,e.LOCATION_HEADER),s.CommitChanges,t)})).then((function(e){if(JSON.parse(e.body).status===i.Failed)throw n.createErrorFromResponseInfo(e,s.CommitChanges);return n.parseCooldownTime(e)}));if(o>=a.OK&&o<=a.HighestSuccessCode)return n.parseCooldownTime(r);throw n.createErrorFromResponseInfo(r,s.CommitChanges)}))},e.prototype._resolveRequestUrlAndHeaderInfo=function(t){var n=this;if(void 0===t&&(t={}),this.m_requestUrlAndHeaderInfo)return OfficeExtension.Utility._createPromiseFromResult(this.m_requestUrlAndHeaderInfo);if(!this.m_workbookUrl||OfficeExtension.Utility._isLocalDocumentUrl(this.m_workbookUrl))return this.m_requestUrlAndHeaderInfo={url:this.m_workbookUrl,headers:this.m_requestHeaders},OfficeExtension.Utility._createPromiseFromResult(this.m_requestUrlAndHeaderInfo);if(this.getHeaderIgnoreCase(this.m_requestHeaders,e.WorkbookSessionIdHeaderNameLower))return this.m_requestUrlAndHeaderInfo={url:this.m_workbookUrl,headers:this.m_requestHeaders},OfficeExtension.Utility._createPromiseFromResult(this.m_requestUrlAndHeaderInfo);var r=this.createAsyncGraphSessionRequestInfo(t);return OfficeExtension.HttpUtility.sendRequest(r).then((function(r){if(n.m_requestId=n.getHeaderIgnoreCase(r.headers,e.REQUEST_ID_HEADER),r.statusCode!==a.Accepted&&r.statusCode!==a.Created)throw n.createErrorFromResponseInfo(r,s.Create);return r.statusCode===a.Created?(n.formatRequestUrlAndHeaderInfo(r),n.m_requestUrlAndHeaderInfo):n.delay(e.POLL_DELAY).then((function(o){return n.pollResourceLocation(n.getHeaderIgnoreCase(r.headers,e.LOCATION_HEADER),s.Create,t)})).then((function(r){var o=JSON.parse(r.body);if(o.status===i.Failed)throw n.createErrorFromResponseInfo(r,s.Create);var a={method:"GET",url:o.resourceLocation,headers:__assign({},t,{Authorization:n.getHeaderIgnoreCase(n.m_requestHeaders,e.AUTHORIZATION_HEADER)}),body:void 0};return OfficeExtension.HttpUtility.sendRequest(a).then((function(e){return n.formatRequestUrlAndHeaderInfo(e),n.m_requestUrlAndHeaderInfo}))}))}))},e.prototype.refreshSession=function(){var e=this;if(!this.m_workbookUrl||OfficeExtension.Utility._isLocalDocumentUrl(this.m_workbookUrl))throw this.createError(a.InternalServerError,"Not supported for local documents.",s.Refresh);if(!this.m_requestUrlAndHeaderInfo)throw this.createError(a.InternalServerError,"Need to call this._resolveRequestUrlAndHeaderInfo() to get the session id first.",s.Refresh);var t=this.createRefreshSessionRequestInfo();return OfficeExtension.HttpUtility.sendRequest(t).then((function(t){if(t.statusCode!=a.NoContent)throw e.createErrorFromResponseInfo(t,s.Refresh);return OfficeExtension.Utility._createPromiseFromResult(null)}))},e.prototype.getHeaderIgnoreCase=function(e,t){var n=Object.keys(e).filter((function(e){return e.toLowerCase()===t.toLowerCase()}));return n.length>0?e[n[0]]:void 0},e.prototype.createCommitChangesRequestInfo=function(t){void 0===t&&(t={});var n=this.getCorrectGraphVersionUrl()+e.COMMIT_CHANGES,r={};return OfficeExtension.Utility._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,r),OfficeExtension.Utility._copyHeaders(t,r),r[e.PREFER_HEADER]=e.PREFER_HEADER_VAL,{url:n,method:"POST",headers:r,body:{}}},e.prototype.createAsyncGraphSessionRequestInfo=function(t){void 0===t&&(t={});var n=this.getCorrectGraphVersionUrl()+e.CREATE_SESSION,r={};return OfficeExtension.Utility._copyHeaders(this.m_requestHeaders,r),OfficeExtension.Utility._copyHeaders(t,r),r[e.CONTENT_TYPE_HEADER]=e.CONTENT_TYPE_HEADER_VAL,r[e.PREFER_HEADER]=e.PREFER_HEADER_VAL,{url:n,method:"POST",headers:r,body:{persistChanges:this.m_persistChanges,commitExplicitly:this.m_commitExplicitly}}},e.prototype.createRefreshSessionRequestInfo=function(){var t=this.getCorrectGraphVersionUrl()+e.REFRESH_SESSION,n={};return OfficeExtension.Utility._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,n),n[e.CONTENT_TYPE_HEADER]=e.CONTENT_TYPE_HEADER_VAL,{url:t,method:"POST",headers:n,body:{}}},e.prototype.getCorrectGraphVersionUrl=function(){return this.m_workbookUrl.replace(new RegExp("graph.microsoft.com/.*?/"),"graph.microsoft.com/"+e.ASYNC_API_GRAPH_VERSION+"/")},e.prototype.pollResourceLocation=function(t,n,r,o){var s=this;if(void 0===r&&(r={}),void 0===o&&(o=0),o>=e.MAX_POLL_ATTEMPTS)throw this.createError(a.InternalServerError,"Timout while polling for the resource location.",n);var c={method:"GET",url:t,headers:__assign({},r,{Authorization:this.getHeaderIgnoreCase(this.m_requestHeaders,e.AUTHORIZATION_HEADER)}),body:void 0};return OfficeExtension.HttpUtility.sendRequest(c).then((function(c){if(c.statusCode!==a.OK)return s.pollResourceLocation(t,n,r,o+1);switch(JSON.parse(c.body).status){case i.Succeeded:case i.Failed:return c;case i.NotStarted:case i.Running:return s.delay(e.POLL_DELAY).then((function(e){return s.pollResourceLocation(t,n,r,o+1)}));default:throw s.createErrorFromResponseInfo(c,n)}}))},e.prototype.parseCooldownTime=function(t){var n=this.getHeaderIgnoreCase(t.headers,e.RETRY_AFTER_HEADER);return n?1e3*parseInt(n):e.DEFAULT_COMMIT_CHANGES_RETRY_AFTER},e.prototype.formatRequestUrlAndHeaderInfo=function(t){if(t.statusCode!==a.OK&&t.statusCode!==a.Created)throw this.createErrorFromResponseInfo(t,s.Create);var n=JSON.parse(t.body).id,r={};OfficeExtension.Utility._copyHeaders(this.m_requestHeaders,r),r[e.WorkbookSessionIdHeaderName]=n,this.m_requestUrlAndHeaderInfo={url:this.getCorrectGraphVersionUrl(),headers:r}},e.prototype.ensureUrlFormatEndWithSlash=function(e){return"/"!==e.charAt(e.length-1)&&(e+="/"),e},e.prototype.delay=function(e){return new OfficeExtension.CoreUtility.Promise((function(t,n){return setTimeout((function(){return t()}),e)}))},e.prototype.createErrorFromResponseInfo=function(t,n){var r=OfficeExtension.Utility._parseErrorResponse(t),o={retryAfter:this.getHeaderIgnoreCase(t.headers,e.RETRY_AFTER_HEADER),responseBody:OfficeExtension.Utility._parseErrorResponseBody(t)};return OfficeExtension.Utility.createRuntimeError(r.errorCode,r.errorMessage,n,t.statusCode,o)},e.prototype.createError=function(e,t,n){return OfficeExtension.Utility.createRuntimeError(""+e,t,n)},e.WorkbookSessionIdHeaderName="Workbook-Session-Id",e.WorkbookSessionIdHeaderNameLower="workbook-session-id",e.ASYNC_API_GRAPH_VERSION="beta",e.POLL_DELAY=1e4,e.MAX_POLL_ATTEMPTS=10,e.DEFAULT_COMMIT_CHANGES_RETRY_AFTER=1e4,e.LOCATION_HEADER="location",e.AUTHORIZATION_HEADER="authorization",e.REQUEST_ID_HEADER="request-id",e.RETRY_AFTER_HEADER="retry-after",e.PREFER_HEADER="Prefer",e.PREFER_HEADER_VAL="respond-async",e.CONTENT_TYPE_HEADER="Content-Type",e.CONTENT_TYPE_HEADER_VAL="application/json",e.CLOSE_SESSION="closeSession",e.COMMIT_CHANGES="commitChanges",e.CREATE_SESSION="createSession",e.REFRESH_SESSION="refreshSession",e}();e.Session=p;var h=function(t){function n(n){var r=t.call(this,n)||this;return r.m_workbook=A(e.Workbook,r),r._rootObject=r.m_workbook,r._rootObjectPropertyName="workbook",r}return __extends(n,t),n.prototype._processOfficeJsErrorResponse=function(e,t){5004===e&&(t.ErrorCode=W.invalidOperationInCellEditMode,t.HttpStatusCode=400,t.ErrorMessage=OfficeExtension.Utility._getResourceString(OfficeExtension.ResourceStrings.invalidOperationInCellEditMode))},Object.defineProperty(n.prototype,"workbook",{get:function(){return this.m_workbook},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"application",{get:function(){return this.workbook.application},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"runtime",{get:function(){return this.workbook._Runtime},enumerable:!0,configurable:!0}),n}(OfficeCore.RequestContext);e.RequestContext=h;var m=function(){function e(){}return e.enableMacroRecordingEvent=function(e){OfficeExtension._internalConfig.appendTypeNameToObjectPathInfo=!0;var t=function(e){return e.requestHeaders[OfficeExtension.Constants.officeScriptFireRecordingEvent]="true",e.workbook.onRecordingStateChangedEvent.add((function(e){return OfficeExtension._internalConfig.appendTypeNameToObjectPathInfo=e.recording,OfficeExtension.Utility._createPromiseFromResult(null)})),OfficeExtension.Utility._createPromiseFromResult(null)};return void 0!==e&&null!==e?t(e):y((function(e){return t(e)}))},e}();function g(e,t){var n=e;n.delayForCellEdit&&OfficeExtension.CommonUtility.isSetSupported("DelayForCellEdit")?t._requestFlagModifier|=64:t._requestFlagModifier&=-65,n._makerSafe&&(t._requestFlagModifier|=1024)}function y(t,n){return OfficeExtension.ClientRequestContext._runBatch("Excel.run",arguments,(function(t){return new e.RequestContext(t)}),g)}function v(e){var t={BindingColumnCount:e.bindingColumnCount,BindingId:e.bindingId,BindingRowCount:e.bindingRowCount,bindingType:e.bindingType,HasHeaders:e.hasHeaders};return window.OSF.DDA.OMFactory.manufactureBinding(t,window.Microsoft.Office.WebExtension.context.document)}function O(e,t){var n;return n=null==e.headers?e.rows:e,void 0===(n=window.OSF.DDA.DataCoercion.coerceData(n,t[window.Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:n}function b(e){if(!("undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.diagnostics&&window.Office.context.diagnostics.version))return!1;var t=window.Office.context.diagnostics.platform.toLowerCase();if("officeonline"===t)return!1;var n=e[t];null==n&&(n=e.general);var r=window.Office.context.diagnostics.version,o=/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/.exec(r);if(o){var i=parseInt(o[1]),a=parseInt(o[2]),s=parseInt(o[3]);if(i<n.desiredMajor)return!0;if(i===n.desiredMajor&&a<n.desiredMinor)return!0;if(i===n.desiredMajor&&a===n.desiredMinor&&s<n.desiredBuild){var c=o[4];if(/^3\d\d\d+$/.exec(c))return!0}}return!1}e.Recorder=m,e.run=y,e.runBatch=function(t,n){return OfficeExtension.ClientRequestContext._runExplicitBatch("Excel.runBatch",arguments,(function(t){return new e.RequestContext(t)}),g)},e._RedirectV1APIs=!1,e._V1APIMap={GetDataAsync:{call:function(e,t){return e.workbook._V1Api.bindingGetData(t)},postprocess:O},GetSelectedDataAsync:{call:function(e,t){return e.workbook._V1Api.getSelectedData(t)},postprocess:O},GoToByIdAsync:{call:function(e,t){return e.workbook._V1Api.gotoById(t)}},AddColumnsAsync:{call:function(e,t){return e.workbook._V1Api.bindingAddColumns(t)}},AddFromSelectionAsync:{call:function(e,t){return e.workbook._V1Api.bindingAddFromSelection(t)},postprocess:v},AddFromNamedItemAsync:{call:function(e,t){return e.workbook._V1Api.bindingAddFromNamedItem(t)},postprocess:v},AddFromPromptAsync:{call:function(e,t){return b({ios:{desiredMajor:2,desiredMinor:20,desiredBuild:0}})&&OfficeExtension.CommonUtility.isSetSupported("DelayForCellEdit")&&(e._requestFlagModifier|=64),e.workbook._V1Api.bindingAddFromPrompt(t)},postprocess:v},AddRowsAsync:{call:function(e,t){return e.workbook._V1Api.bindingAddRows(t)}},GetByIdAsync:{call:function(e,t){return e.workbook._V1Api.bindingGetById(t)},postprocess:v},ReleaseByIdAsync:{call:function(e,t){return e.workbook._V1Api.bindingReleaseById(t)}},GetAllAsync:{call:function(e){return e.workbook._V1Api.bindingGetAll()},postprocess:function(e){return e.bindings.map((function(e){return v(e)}))}},DeleteAllDataValuesAsync:{call:function(e,t){return e.workbook._V1Api.bindingDeleteAllDataValues(t)}},SetSelectedDataAsync:{preprocess:function(e){var t=e.cellFormat;return"undefined"!==typeof window&&window.OSF.DDA.SafeArray?window.OSF.OUtil.listContainsKey(window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)):"undefined"!==typeof window&&window.OSF.DDA.WAC&&window.OSF.OUtil.listContainsKey(window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)),e},call:function(e,t){return e.workbook._V1Api.setSelectedData(t)}},SetDataAsync:{preprocess:function(e){var t=e.cellFormat;return"undefined"!==typeof window&&window.OSF.DDA.SafeArray?window.OSF.OUtil.listContainsKey(window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)):"undefined"!==typeof window&&window.OSF.DDA.WAC&&window.OSF.OUtil.listContainsKey(window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)),e},call:function(e,t){return e.workbook._V1Api.bindingSetData(t)}},SetFormatsAsync:{preprocess:function(e){var t=e.cellFormat;return"undefined"!==typeof window&&window.OSF.DDA.SafeArray?window.OSF.OUtil.listContainsKey(window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.SafeArray.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)):"undefined"!==typeof window&&window.OSF.DDA.WAC&&window.OSF.OUtil.listContainsKey(window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes,"cellFormat")&&(e.cellFormat=window.OSF.DDA.WAC.Delegate.ParameterMap.dynamicTypes.cellFormat.toHost(t)),e},call:function(e,t){return e.workbook._V1Api.bindingSetFormats(t)}},SetTableOptionsAsync:{call:function(e,t){return e.workbook._V1Api.bindingSetTableOptions(t)}},ClearFormatsAsync:{call:function(e,t){return e.workbook._V1Api.bindingClearFormats(t)}},GetFilePropertiesAsync:{call:function(e){return e.workbook._V1Api.getFilePropertiesAsync()}}};!function(e){e.office10EventIdBindingSelectionChangedEvent=3,e.office10EventIdBindingDataChangedEvent=4,e.office10EventIdDocumentSelectionChangedEvent=2,e.office10EventIdRichApiMessageEvent=5,e.office10EventIdSettingsChangedEvent=1}(e._CC||(e._CC={}));var S="Excel",C="ExcelApi",_=(OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject),A=(OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject),D=(OfficeExtension.BatchApiHelper.createTopLevelServiceObject,OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),E=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty),F=OfficeExtension.Utility.isNullOrUndefined,P=OfficeExtension.Utility.isUndefined,R=(OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported),I=OfficeExtension.Utility.load,x=(OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson,OfficeExtension.Utility.fixObjectPathIfNecessary,OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult,OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags),T=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),e}();e.RangeValuesPreviewCustom=T,function(e){e.Application_SuspendApiCalculationUntilNextSync=function(e){return f("Mac")&&u(1.6)&&!u(1.7)?{handled:!0}:{handled:!1}}}(e._CC||(e._CC={})),function(t){t.Workbook_EnableOfficeScriptRecording=function(e,t){return this.context.eventId=t,{handled:!1}},t.Workbook_RecordAction=function(e,t){return this.context.sdxPayload=t,{handled:!1}},t.Workbook_SelectionChanged_EventArgsTransform=function(e,t){return{workbook:e}},t.Workbook_WACOperationEvent_EventArgsTransform=function(t,n){return{eventId:n.eventId,payload:n.payload,type:e.EventType.wacoperationEvent}},t.Workbook__Message_EventArgsTransform=function(e,t){return{entries:t.entries,workbook:e}}}(e._CC||(e._CC={})),function(t){t.Worksheet_Charts_Get=function(e,t){t._ParentObject=e},t.Worksheet_Comments_Get=function(e,t){t._ParentObject=e},t.Worksheet_Names_Get=function(e,t){t._ParentObject=e},t.Worksheet_PivotTables_Get=function(e,t){t._ParentObject=e},t.Worksheet_RangeValuesPreview_Get=function(e,t){t._ParentObject=e},t.Worksheet_Shapes_Get=function(e,t){t._ParentObject=e},t.Worksheet_ShowGridlines_Set=function(e,t){return e.m_showGridlines=t,E(e,"Gridlines",t,x(2,"ExcelApiUndo","1.16")),{handled:!0}},t.Worksheet_ShowHeadings_Set=function(e,t){return e.m_showHeadings=t,E(e,"Headings",t,0),{handled:!0}},t.Worksheet_Tables_Get=function(e,t){t._ParentObject=e},t.Worksheet_Visuals_Get=function(e,t){t._ParentObject=e},t.Worksheet_Changed_EventArgsTransform=function(t,n){var r,o,i,a,s=n;return null==s.valueBefore&&null==s.valueAfter||(r={valueBefore:s.valueBefore,valueAfter:s.valueAfter,valueTypeBefore:s.valueTypeBefore,valueTypeAfter:s.valueTypeAfter,valueAsJsonBefore:s.valueAsJsonBefore,valueAsJsonAfter:s.valueAsJsonAfter}),s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellLeft?o=e.DeleteShiftDirection.left:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellUp?o=e.DeleteShiftDirection.up:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellRight?i=e.InsertShiftDirection.right:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellDown&&(i=e.InsertShiftDirection.down),s.shiftDirection!=e.InsertDeleteCellsShiftDirection.none&&(a={deleteShiftDirection:o,insertShiftDirection:i}),{type:e.EventType.worksheetChanged,changeType:s.changeType,source:s.source,worksheetId:t.id,address:s.address,getRange:function(e){return R("WorksheetChangedEventArgs.getRange",C,"1.8",S),e.workbook._GetRangeForEventByReferenceId(s.referenceId)},getRangeOrNullObject:function(e){return R("WorksheetChangedEventArgs.getRangeOrNullObject",C,"1.8",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(s.referenceId)},details:r,triggerSource:s.triggerSource,changeDirectionState:a}},t.Worksheet_FormatChanged_EventArgsTransform=function(t,n){var r=n;return{type:e.EventType.worksheetFormatChanged,source:r.source,worksheetId:t.id,address:r.address,getRange:function(e){return R("WorksheetFormatChangedEventArgs.getRange",C,"1.9",S),e.workbook._GetRangeForEventByReferenceId(r.referenceId)},getRangeOrNullObject:function(e){return R("WorksheetFormatChangedEventArgs.getRangeOrNullObject",C,"1.9",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(r.referenceId)}}},t.Worksheet_FormulaChanged_EventArgsTransform=function(t,n){var r,o=n;return null!=o.formulaDetails&&(r=o.formulaDetails),{type:e.EventType.worksheetFormulaChanged,source:o.source,worksheetId:o.worksheetId,formulaDetails:r}}}(e._CC||(e._CC={})),function(t){function n(e,t,n){return!f("OfficeOnline")&&!u(1.12)||f("OfficeOnline")&&!u(1.11)?(R("WorksheetCollection."+t,C,n,S),D(e,t,0,[],0,0),{handled:!0}):{handled:!1}}t.WorksheetCollection__RegisterActivatedEvent=function(e){return u(1.9)?{handled:!1}:(R("WorksheetCollection._RegisterActivatedEvent",C,"1.7",S),D(e,"_RegisterActivatedEvent",0,[],0,0),{handled:!0})},t.WorksheetCollection__RegisterAddedEvent=function(e){return n(e,"_RegisterAddedEvent","1.7")},t.WorksheetCollection__RegisterColumnSortedEvent=function(e){return n(e,"_RegisterColumnSortedEvent","1.10")},t.WorksheetCollection__RegisterDataChangedEvent=function(e){return n(e,"_RegisterDataChangedEvent","1.9")},t.WorksheetCollection__RegisterDeletedEvent=function(e){return n(e,"_RegisterDeletedEvent","1.7")},t.WorksheetCollection__RegisterRowSortedEvent=function(e){return n(e,"_RegisterRowSortedEvent","1.10")},t.WorksheetCollection__UnregisterAddedEvent=function(e){return n(e,"_UnregisterAddedEvent","1.7")},t.WorksheetCollection__UnregisterColumnSortedEvent=function(e){return n(e,"_UnregisterColumnSortedEvent","1.10")},t.WorksheetCollection__UnregisterDataChangedEvent=function(e){return n(e,"_UnregisterDataChangedEvent","1.9")},t.WorksheetCollection__UnregisterDeletedEvent=function(e){return n(e,"_UnregisterDeletedEvent","1.7")},t.WorksheetCollection__UnregisterRowSortedEvent=function(e){return n(e,"_UnregisterRowSortedEvent","1.10")},t.WorksheetCollection_Changed_EventArgsTransform=function(t,n){var r,o,i,a,s=n;return null==s.valueBefore&&null==s.valueAfter||(r={valueBefore:s.valueBefore,valueAfter:s.valueAfter,valueTypeBefore:s.valueTypeBefore,valueTypeAfter:s.valueTypeAfter,valueAsJsonBefore:s.valueAsJsonBefore,valueAsJsonAfter:s.valueAsJsonAfter}),s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellLeft?o=e.DeleteShiftDirection.left:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellUp?o=e.DeleteShiftDirection.up:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellRight?i=e.InsertShiftDirection.right:s.shiftDirection==e.InsertDeleteCellsShiftDirection.shiftCellDown&&(i=e.InsertShiftDirection.down),s.shiftDirection!=e.InsertDeleteCellsShiftDirection.none&&(a={deleteShiftDirection:o,insertShiftDirection:i}),{type:e.EventType.worksheetChanged,changeType:s.changeType,source:s.source,worksheetId:s.worksheetId,address:s.address,getRange:function(e){return R("WorksheetChangedEventArgs.getRange",C,"1.9",S),e.workbook._GetRangeForEventByReferenceId(s.referenceId)},getRangeOrNullObject:function(e){return R("WorksheetChangedEventArgs.getRangeOrNullObject",C,"1.9",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(s.referenceId)},details:r,triggerSource:s.triggerSource,changeDirectionState:a}},t.WorksheetCollection_FormatChanged_EventArgsTransform=function(t,n){var r=n;return{type:e.EventType.worksheetFormatChanged,source:r.source,worksheetId:r.worksheetId,address:r.address,getRange:function(e){return R("WorksheetFormatChangedEventArgs.getRange",C,"1.9",S),e.workbook._GetRangeForEventByReferenceId(r.referenceId)},getRangeOrNullObject:function(e){return R("WorksheetFormatChangedEventArgs.getRangeOrNullObject",C,"1.9",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(r.referenceId)}}},t.WorksheetCollection_FormulaChanged_EventArgsTransform=function(t,n){var r,o=n;return null!=o.formulaDetails&&(r=o.formulaDetails),{type:e.EventType.worksheetFormulaChanged,source:o.source,worksheetId:o.worksheetId,formulaDetails:r}}}(e._CC||(e._CC={})),function(e){e.WorksheetProtection_Protect=function(e,t,n){return b({mac:{desiredMajor:16,desiredMinor:7,desiredBuild:17101600},ios:{desiredMajor:2,desiredMinor:7,desiredBuild:1016},general:{desiredMajor:16,desiredMinor:0,desiredBuild:8716}})?(D(e,"Protect",0,[t],0,0),{handled:!0}):{handled:!1}}}(e._CC||(e._CC={}));var w=function(){function t(){}return t.prototype._ensureInteger=function(t,n){"number"===typeof t&&isFinite(t)&&Math.floor(t)===t||OfficeExtension.Utility.throwError(e.ErrorCodes.invalidArgument,t,n)},t.prototype._getAdjacentRange=function(e,t,n,r,o){var i;null==t&&(t=1),this._ensureInteger(t,e);var a=0,s=0;return t>0?i=n.getOffsetRange(r,o):(i=n,a=r,s=o),1===Math.abs(t)?i:i.getBoundingRect(n.getOffsetRange(r*t+a,o*t+s))},t}();e.RangeCustom=w,function(t){t.Range_HandleResult=function(e,t){P(t.isEntireColumn)||(e.m_isEntireColumn=t.isEntireColumn),P(t.isEntireRow)||(e.m_isEntireRow=t.isEntireRow)},t.Range_GetColumnsAfter=function(t,n){return d()?{handled:!1,result:null}:(null==n&&(n=1),t._ensureInteger(n,"RowsAbove"),0===n&&OfficeExtension.Utility.throwError(e.ErrorCodes.invalidArgument,"count","RowsAbove"),{handled:!0,result:t._getAdjacentRange("getColumnsAfter",n,t.getLastColumn(),0,1)})},t.Range_GetColumnsBefore=function(t,n){return d()?{handled:!1,result:null}:(null==n&&(n=1),t._ensureInteger(n,"RowsAbove"),0===n&&OfficeExtension.Utility.throwError(e.ErrorCodes.invalidArgument,"count","RowsAbove"),{handled:!0,result:t._getAdjacentRange("getColumnsBefore",n,t.getColumn(0),0,-1)})},t.Range_GetResizedRange=function(e,t,n){return d()?{handled:!1,result:null}:(e._ensureInteger(t,"getResizedRange"),e._ensureInteger(n,"getResizedRange"),{handled:!0,result:(t>=0&&n>=0?e:e.getCell(0,0)).getBoundingRect(e.getLastCell().getOffsetRange(t,n))})},t.Range_GetRowsAbove=function(t,n){return d()?{handled:!1,result:null}:(null==n&&(n=1),t._ensureInteger(n,"RowsAbove"),0===n&&OfficeExtension.Utility.throwError(e.ErrorCodes.invalidArgument,"count","RowsAbove"),{handled:!0,result:t._getAdjacentRange("getRowsAbove",n,t.getRow(0),-1,0)})},t.Range_GetRowsBelow=function(t,n){return d()?{handled:!1,result:null}:(null==n&&(n=1),t._ensureInteger(n,"RowsAbove"),0===n&&OfficeExtension.Utility.throwError(e.ErrorCodes.invalidArgument,"count","RowsAbove"),{handled:!0,result:this._getAdjacentRange("getRowsBelow",n,t.getLastRow(),1,0)})},t.Range_Formulas_Set=function(e,t){return e.m_formulas=t,l(e,"Formulas",t)?{handled:!0}:{handled:!1}},t.Range_FormulasLocal_Set=function(e,t){return e.m_formulasLocal=t,l(e,"FormulasLocal",t)?{handled:!0}:{handled:!1}},t.Range_FormulasR1C1_Set=function(e,t){return e.m_formulasR1C1=t,l(e,"FormulasR1C1",t)?{handled:!0}:{handled:!1}},t.Range_NumberFormat_Set=function(e,t){return e.m_numberFormat=t,l(e,"NumberFormat",t,x(2,"ExcelApiUndo","1.7"))?{handled:!0}:{handled:!1}},t.Range_Values_Set=function(e,t){return e.m_values=t,l(e,"Values",t,x(2,"ExcelApiUndo","1.7"))?{handled:!0}:{handled:!1}},t.Range_ValuesAsJson_Set=function(e,t){return e.m_valuesAsJson=t,l(e,"ValuesAsJson",t,x(2,"ExcelApiUndo","1.7"))?{handled:!0}:{handled:!1}},t.Range_ValuesAsJsonLocal_Set=function(e,t){return e.m_valuesAsJsonLocal=t,l(e,"ValuesAsJsonLocal",t,x(2,"ExcelApiUndo","1.7"))?{handled:!0}:{handled:!1}}}(e._CC||(e._CC={})),function(t){t.SettingCollection_Add=function(n,r,o){return o=t._replaceDateWithStringDate(o),{handled:!0,result:_(e.Setting,n,"Add",0,[r,o],!1,!0,null,0)}},t.SettingCollection_SettingsChanged_EventArgsTransform=function(e,t){return{settings:e}}}(e._CC||(e._CC={})),function(e){function t(e){var t=JSON.stringify(e,(function(e,t){return this[e]instanceof Date?"Date("+this[e].getTime()+")":t}));return e=JSON.parse(t)}e._replaceDateWithStringDate=t,e.Setting_HandleResult=function(e,t){P(t.Value)||(t.Value=function(e){var t=JSON.stringify(e);return e=JSON.parse(t,(function(e,t){var n;return"string"===typeof t&&t&&t.length>6&&"Date("===t.slice(0,5)&&")"===t.slice(-1)&&(n=new Date(parseInt(t.slice(5,-1))))?n:t}))}(t.Value))},e.Setting_Value_Set=function(e,n){if(!F(n)){e.m_value=n;var r=t(n);return E(e,"Value",r,0),{handled:!0}}return{handled:!1}}}(e._CC||(e._CC={}));var M=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_eventTargetId",{get:function(){return this._ParentObject?this._ParentObject.id:OfficeExtension.Constants.eventWorkbookId},enumerable:!0,configurable:!0}),e}();e.NamedItemCollectionCustom=M,function(e){e.Binding_DataChanged_EventArgsTransform=function(e,t){return{binding:e}},e.Binding_SelectionChanged_EventArgsTransform=function(e,t){return{binding:e,columnCount:t.columnCount,rowCount:t.rowCount,startColumn:t.startColumn,startRow:t.startRow}}}(e._CC||(e._CC={}));var k=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_eventTargetId",{get:function(){return this._ParentObject?this._ParentObject.id:OfficeExtension.Constants.eventWorkbookId},enumerable:!0,configurable:!0}),e}();e.TableCollectionCustom=k,function(t){t.TableCollection_Changed_EventArgsTransform=function(t,n){var r,o=n;return null==o.valueBefore&&null==o.valueAfter||(r={valueBefore:o.valueBefore,valueAfter:o.valueAfter,valueTypeBefore:o.valueTypeBefore,valueTypeAfter:o.valueTypeAfter,valueAsJsonBefore:o.valueAsJsonBefore,valueAsJsonAfter:o.valueAsJsonAfter}),{type:e.EventType.tableChanged,changeType:o.changeType,source:o.source,worksheetId:o.worksheetId,tableId:o.tableId,address:o.address,getRange:function(e){return R("TableChangedEventArgs.getRange",C,"1.8",S),e.workbook._GetRangeForEventByReferenceId(o.referenceId)},getRangeOrNullObject:function(e){return R("TableChangedEventArgs.getRangeOrNullObject",C,"1.8",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(o.referenceId)},details:r}}}(e._CC||(e._CC={})),function(t){t.Table_HandleIdResult=function(e,t){P(t.Id)||(t.Id=t.Id.toString())},t.Table_HandleResult=function(e,t){P(t.Id)||(t.Id=t.Id.toString())},t.Table_Changed_EventArgsTransform=function(t,n){var r,o=n;return null==o.valueBefore&&null==o.valueAfter||(r={valueBefore:o.valueBefore,valueAfter:o.valueAfter,valueTypeBefore:o.valueTypeBefore,valueTypeAfter:o.valueTypeAfter,valueAsJsonBefore:o.valueAsJsonBefore,valueAsJsonAfter:o.valueAsJsonAfter}),{type:e.EventType.tableChanged,changeType:o.changeType,source:o.source,worksheetId:o.worksheetId,tableId:o.tableId,address:o.address,getRange:function(e){return R("TableChangedEventArgs.getRange",C,"1.8",S),e.workbook._GetRangeForEventByReferenceId(o.referenceId)},getRangeOrNullObject:function(e){return R("TableChangedEventArgs.getRangeOrNullObject",C,"1.8",S),e.workbook._GetRangeOrNullObjectForEventByReferenceId(o.referenceId)},details:r}},t.Table_SelectionChanged_EventArgsTransform=function(t,n){var r=n,o=!r.address||0===r.address.length;return{type:e.EventType.tableSelectionChanged,isInsideTable:!o,worksheetId:r.worksheetId,tableId:t.id,address:r.address}}}(e._CC||(e._CC={}));var N=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),e}();e.ChartCollectionCustom=N,function(t){t.ChartCollection_Add=function(t,n,r,o){if(!(r instanceof e.Range))throw OfficeExtension.Utility.createRuntimeError(OfficeExtension.ResourceStrings.invalidArgument,"sourceData","Charts.Add");return{handled:!1,result:null}}}(e._CC||(e._CC={})),function(t){t.Chart_SetData=function(t,n,r){if(!(n instanceof e.Range))throw OfficeExtension.Utility.createRuntimeError(OfficeExtension.ResourceStrings.invalidArgument,"sourceData","Chart.setData");return{handled:!1}}}(e._CC||(e._CC={}));var j=function(){function e(){}return e.prototype.load=function(e){return I(this,e),this},e}();e.ChartFillCustom=j;var U=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),e}();e.VisualCollectionCustom=U,function(e){e.VisualCollection_AgaveVisualUpdate_EventArgsTransform=function(e,t){var n=t;return{type:n.type,payload:n.payload}}}(e._CC||(e._CC={})),function(t){t.Visual_ChangeNotification_EventArgsTransform=function(t,n){var r=n;return{targetId:r.targetId,changeType:r.changeType,payload:r.payload,type:e.EventType.visualChange}}}(e._CC||(e._CC={}));var L=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_eventTargetId",{get:function(){return this._ParentObject?this._ParentObject.id:OfficeExtension.Constants.eventWorkbookId},enumerable:!0,configurable:!0}),e}();e.PivotTableCollectionCustom=L,function(t){t.PivotLayout_GetColumnLabelRange=function(t){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:{handled:!0,result:_(e.Range,t,"GetColumnLabelRange",0,[],!1,!1,null,0)}},t.PivotLayout_GetDataBodyRange=function(t){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:{handled:!0,result:_(e.Range,t,"GetDataBodyRange",0,[],!1,!1,null,0)}},t.PivotLayout_GetDataHierarchy=function(t,n){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:(R("PivotLayout.getDataHierarchy",C,"1.9",S),{handled:!0,result:_(e.DataPivotHierarchy,t,"GetDataHierarchy",0,[n],!1,!1,null,0)})},t.PivotLayout_GetFilterAxisRange=function(t){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:{handled:!0,result:_(e.Range,t,"GetFilterAxisRange",0,[],!1,!1,null,0)}},t.PivotLayout_GetRange=function(t){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:{handled:!0,result:_(e.Range,t,"GetRange",0,[],!1,!1,null,0)}},t.PivotLayout_GetRowLabelRange=function(t){return OfficeExtension.Utility.isSetSupported("Pivot","1.5")?{handled:!1,result:void 0}:{handled:!0,result:_(e.Range,t,"GetRowLabelRange",0,[],!1,!1,null,0)}}}(e._CC||(e._CC={})),function(e){e.PivotField_SortByLabels=function(e,t){return"string"===typeof t&&(t="ascending"===t.toLowerCase()),D(e,"SortByLabels",0,[t],0,0),{handled:!0}}}(e._CC||(e._CC={})),function(t){t.NumberFormattingService_GetFormatter=function(t,n){return OfficeExtension.Utility.isSetSupported("NumberFormatting","1.2")?{handled:!1,result:void 0}:(R("NumberFormatting.GetFormatter","NumberFormatting","1.1",S),{handled:!0,result:_(e.NumberFormatter,t,"GetFormatter",0,[n],!1,!1,null,0)})}}(e._CC||(e._CC={})),function(e){e.NumberFormatter_Format=function(e,t){return OfficeExtension.Utility.isSetSupported("NumberFormatting","1.2")?{handled:!1,result:void 0}:(R("NumberFormatter.Format","NumberFormatting","1.1",S),{handled:!0,result:D(e,"Format",0,[t],0,0)})}}(e._CC||(e._CC={}));var H=function(){function n(){}return n.register=function(n,r){return R("CustomFunctionManager.register","CustomFunctions","1.3",S),t({delayForCellEdit:!0},(function(t){return e.CustomFunctionManager.newObject(t).register(n,r)}))},n.getStatus=function(){return R("CustomFunctionManager.register","CustomFunctions","1.3",S),t({delayForCellEdit:!0},(function(t){var n=e.CustomFunctionManager.newObject(t).load("status");return t.sync().then((function(){return n.status}))}))},n}();e.CustomFunctionManagerCustom=H,function(e){e.CustomFunctionManager_StaticCustomize=function(e){e.register=H.register,e.getStatus=H.getStatus}}(e._CC||(e._CC={})),function(e){e.Style_TextOrientation_Set=function(e,t){return e.m_textOrientation=t,E(e,"Orientation",t,0),{handled:!0}}}(e._CC||(e._CC={})),function(e){e.InternalTest_Test1Event_EventArgsTransform=function(e,t){var n=t;return{prop1:n.prop1,worksheet:e.context.workbook.worksheets.getItem(n.worksheetId)}},e.InternalTest_TestEvent_EventArgsTransform=function(e,t){var n=t;return{prop1:n.prop1,worksheet:e.context.workbook.worksheets.getItem(n.worksheetId)}}}(e._CC||(e._CC={}));var B=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_eventTargetId",{get:function(){return this._ParentObject?this._ParentObject.id:OfficeExtension.Constants.eventWorkbookId},enumerable:!0,configurable:!0}),e}();e.CommentCollectionCustom=B;var W,G=function(){function e(){}return Object.defineProperty(e.prototype,"_ParentObject",{get:function(){return this.m__ParentObject},set:function(e){this.m__ParentObject=e},enumerable:!0,configurable:!0}),e}();e.ShapeCollectionCustom=G,function(e){e.accessDenied="AccessDenied",e.apiNotFound="ApiNotFound",e.conflict="Conflict",e.emptyChartSeries="EmptyChartSeries",e.filteredRangeConflict="FilteredRangeConflict",e.formulaLengthExceedsLimit="FormulaLengthExceedsLimit",e.generalException="GeneralException",e.inactiveWorkbook="InactiveWorkbook",e.insertDeleteConflict="InsertDeleteConflict",e.invalidArgument="InvalidArgument",e.invalidBinding="InvalidBinding",e.invalidOperation="InvalidOperation",e.invalidReference="InvalidReference",e.invalidSelection="InvalidSelection",e.itemAlreadyExists="ItemAlreadyExists",e.itemNotFound="ItemNotFound",e.mergedRangeConflict="MergedRangeConflict",e.nonBlankCellOffSheet="NonBlankCellOffSheet",e.notImplemented="NotImplemented",e.openWorkbookLinksBlocked="OpenWorkbookLinksBlocked",e.operationCellsExceedLimit="OperationCellsExceedLimit",e.pivotTableRangeConflict="PivotTableRangeConflict",e.powerQueryRefreshResourceChallenge="PowerQueryRefreshResourceChallenge",e.rangeExceedsLimit="RangeExceedsLimit",e.refreshWorkbookLinksBlocked="RefreshWorkbookLinksBlocked",e.requestAborted="RequestAborted",e.responsePayloadSizeLimitExceeded="ResponsePayloadSizeLimitExceeded",e.unsupportedFeature="UnsupportedFeature",e.unsupportedFillType="UnsupportedFillType",e.unsupportedOperation="UnsupportedOperation",e.unsupportedSheet="UnsupportedSheet",e.invalidOperationInCellEditMode="InvalidOperationInCellEditMode"}(W=e.ErrorCodes||(e.ErrorCodes={})),e.Interfaces||(e.Interfaces={});new OfficeExtension.LibraryBuilder({metadata:{version:"1.0.0",name:"Excel",defaultApiSetName:"ExcelApi",hostName:"Excel",apiSets:[["1.19","ExcelApiUndo"],["1.1","Recorder"],["99.9"],["1.20","ExcelApiUndo"],["1.4","ExcelApiUndo"],["1.8"],["1.9"],["1.11"],["1.18"],["1.6"],["1.6","ExcelApiUndo"],["1.7"],["1.1","ExcelApiUndo"],["1.2"],["1.3"],["1.4"],["1.5"],["1.10"],["1.14"],["1.1","ExcelApiOnline"],["1.1","Experiment52"],["1.1","CustomFunctions"],["1.1","WACOperationEvents"],["1.3","ExcelApiUndo"],["1.13"],["1.16"],["1.8","ExcelApiUndo"],["1.16","ExcelApiUndo"],["1.12"],["1.2","ExcelApiOnline"],["1.2","ExcelApiUndo"],["1.17"],["1.7","ExcelApiUndo"],["1.10","ExcelApiUndo"],["1.14","ExcelApiUndo"],["1.15","ExcelApiUndo"],["1.22","ExcelApiUndo"],["1.15"],["1.17","ExcelApiUndo"],["99.99","ExcelApiUndo"],["1.9","ExcelApiUndo"],["1.11","ExcelApiUndo"],["1.21","ExcelApiUndo"],["1.12","ExcelApiUndo"],["1.13","ExcelApiUndo"],["1.18","ExcelApiUndo"]],strings:[],enumTypes:[["ExternalCodeServiceAutoShowDiagnostics",["enabled","disabled"]],["UndoChangeType",["undoAction","redoAction","undoOrRedoCleared","undoGroupAdded"]],["SDX",["guidedReapply"]],["BusinessBarEntryType",[],{officeScriptsRunningStatus:0,msFormsDataSyncRunningStatus:1}],["FormulaReferenceStyle",["a1","r1C1"]],["NavigationObjectType",["table","pivotTable","chart","shape","namedRange"]],["UserActivityType",["none","insertSheet","deleteSheet","renameSheet","changeCell","insertRow","insertColumn","deleteRow","deleteColumn","insertPartialRow","insertPartialColumn","insertPartialColumnRightToLeft","deletePartialRow","deletePartialColumn","deletePartialColumnRightToLeft","move","sort","mergeCells","unmergeCells","unknownOperation","genericEdit"]],["LineageEndOfLogStatus",["loadInProgress","success","endOfLog","purged","trimmed","unsupported","cleared","error"]],["LineageLoadType",["new","next","previous","latest"]],["LoadToType",["connectionOnly","table","pivotTable","pivotChart"]],["QueryError",["unknown","none","failedLoadToWorksheet","failedLoadToDataModel","failedDownload","failedToCompleteDownload"]],["RangeOptimizationType",["other","numberFormat","textAlignment","textProperties","cellBorder","fillColor","sheetProtection","rowHeight","rowVisibility"]],["WorkbookLinksHardToFindMessages",["none","containsDefinedNames","hiddenOrVeryHiddenSheet","hiddenFloatingObjects","lockedFloatingObjectsThroughVba","protectedSheet","containsConditionalFormatting","containsDataValidation","hiddenRowsAndColumns"]],["WorkbookLinksIconState",["ok","moreInfo","warning"]],["WorkbookLinksRefreshSettings",["ask","always","never"]],["WorkbookConditionalFormattingRulesManagerScope",["defaultScope","selectedRange","activatedWorksheet","activatedTable","activatedPivotTable"]],["WorkbookLinksRefreshMode",["manual","automatic"]],["HelpTopic",["showChanges","guidedReapply","externalCodeServiceDiagnostics","pythonInExcelHelp"]],["DocumentTaskChangeAction",[],{unknown:"unknown",create:"create",assign:"assign",unassign:"unassign",unassignAll:"unassignAll",setSchedule:"setSchedule",setPercentComplete:"setPercentComplete",setPriority:"setPriority",remove:"remove",restore:"restore",setTitle:"setTitle",undo:"undo"}],["DataSourceType",["unknown","cube","localRange","localTable","oledbDefault"]],["DateFilterCondition",["unknown","equals","before","beforeOrEqualTo","after","afterOrEqualTo","between","tomorrow","today","yesterday","nextWeek","thisWeek","lastWeek","nextMonth","thisMonth","lastMonth","nextQuarter","thisQuarter","lastQuarter","nextYear","thisYear","lastYear","yearToDate","allDatesInPeriodQuarter1","allDatesInPeriodQuarter2","allDatesInPeriodQuarter3","allDatesInPeriodQuarter4","allDatesInPeriodJanuary","allDatesInPeriodFebruary","allDatesInPeriodMarch","allDatesInPeriodApril","allDatesInPeriodMay","allDatesInPeriodJune","allDatesInPeriodJuly","allDatesInPeriodAugust","allDatesInPeriodSeptember","allDatesInPeriodOctober","allDatesInPeriodNovember","allDatesInPeriodDecember"]],["LabelFilterCondition",["unknown","equals","beginsWith","endsWith","contains","greaterThan","greaterThanOrEqualTo","lessThan","lessThanOrEqualTo","between"]],["PivotFilterType",["unknown","value","manual","label","date"]],["TopBottomSelectionType",["items","percent","sum"]],["ValueFilterCondition",["unknown","equals","greaterThan","greaterThanOrEqualTo","lessThan","lessThanOrEqualTo","between","topN","bottomN"]],["BuiltInPivotTableStyle",["none","light1","light2","light3","light4","light5","light6","light7","light8","light9","light10","light11","light12","light13","light14","light15","light16","light17","light18","light19","light20","light21","light22","light23","light24","light25","light26","light27","light28","medium1","medium2","medium3","medium4","medium5","medium6","medium7","medium8","medium9","medium10","medium11","medium12","medium13","medium14","medium15","medium16","medium17","medium18","medium19","medium20","medium21","medium22","medium23","medium24","medium25","medium26","medium27","medium28","dark1","dark2","dark3","dark4","dark5","dark6","dark7","dark8","dark9","dark10","dark11","dark12","dark13","dark14","dark15","dark16","dark17","dark18","dark19","dark20","dark21","dark22","dark23","dark24","dark25","dark26","dark27","dark28"]],["BuiltInSlicerStyle",["light1","light2","light3","light4","light5","light6","other1","other2","dark1","dark2","dark3","dark4","dark5","dark6"]],["BuiltInTableStyle",["light1","light2","light3","light4","light5","light6","light7","light8","light9","light10","light11","light12","light13","light14","light15","light16","light17","light18","light19","light20","light21","medium1","medium2","medium3","medium4","medium5","medium6","medium7","medium8","medium9","medium10","medium11","medium12","medium13","medium14","medium15","medium16","medium17","medium18","medium19","medium20","medium21","medium22","medium23","medium24","medium25","medium26","medium27","medium28","dark1","dark2","dark3","dark4","dark5","dark6","dark7","dark8","dark9","dark10","dark11"]],["ChartSeriesDimension",["categories","values","bubbleSizes"],{xvalues:"XValues",yvalues:"YValues"}],["PivotTableDateGroupBy",["invalid","bySeconds","byMinutes","byHours","byDays","byMonths","byQuarters","byYears"]],["PivotFilterTopBottomCriterion",["invalid","topItems","topPercent","topSum","bottomItems","bottomPercent","bottomSum"]],["SortBy",["ascending","descending"]],["AggregationFunction",["unknown","automatic","sum","count","average","max","min","product","countNumbers","standardDeviation","standardDeviationP","variance","varianceP"]],["ShowAsCalculation",["unknown","none","percentOfGrandTotal","percentOfRowTotal","percentOfColumnTotal","percentOfParentRowTotal","percentOfParentColumnTotal","percentOfParentTotal","percentOf","runningTotal","percentRunningTotal","differenceFrom","percentDifferenceFrom","rankAscending","rankDecending","index"]],["PivotAxis",["unknown","row","column","data","filter"]],["LinkedDataTypeRefreshMode",["unknown","manual","onLoad","periodic"]],["LinkedEntityDataDomainRefreshMode",["unknown","manual","onLoad","periodic"]],["AxisType",["invalid","category","value","series"]],["AxisGroup",["primary","secondary"]],["AxisScaleType",["linear","logarithmic"]],["AxisCrosses",["automatic","maximum","minimum","custom"]],["AxisTickMark",["none","cross","inside","outside"]],["AxisTickLabelPosition",["nextToAxis","high","low","none"]],["TrendlineType",["linear","exponential","logarithmic","movingAverage","polynomial","power"]],["ChartAxisType",["invalid","category","value","series"]],["ChartAxisGroup",["primary","secondary"]],["ChartAxisScaleType",["linear","logarithmic"]],["ChartAxisPosition",["automatic","maximum","minimum","custom"]],["ChartAxisTickMark",["none","cross","inside","outside"]],["CalculationState",["done","calculating","pending"]],["ChartAxisTickLabelPosition",["nextToAxis","high","low","none"]],["ChartAxisDisplayUnit",["none","hundreds","thousands","tenThousands","hundredThousands","millions","tenMillions","hundredMillions","billions","trillions","custom"]],["ChartAxisTimeUnit",["days","months","years"]],["ChartBoxQuartileCalculation",["inclusive","exclusive"]],["ChartAxisCategoryType",["automatic","textAxis","dateAxis"]],["ChartBinType",["category","auto","binWidth","binCount"]],["ChartLineStyle",["none","continuous","dash","dashDot","dashDotDot","dot","grey25","grey50","grey75","automatic","roundDot"]],["ChartDataLabelPosition",["invalid","none","center","insideEnd","insideBase","outsideEnd","left","right","top","bottom","bestFit","callout"]],["ChartErrorBarsInclude",["both","minusValues","plusValues"]],["ChartErrorBarsType",["fixedValue","percent","stDev","stError","custom"]],["ChartMapAreaLevel",["automatic","dataOnly","city","county","state","country","continent","world"]],["ChartGradientStyle",["twoPhaseColor","threePhaseColor"]],["ChartGradientStyleType",["extremeValue","number","percent"]],["ChartTitlePosition",["automatic","top","bottom","left","right"]],["ChartLegendPosition",["invalid","top","bottom","left","right","corner","custom"]],["ChartMarkerStyle",["invalid","automatic","none","square","diamond","triangle","star","dot","dash","circle","plus","picture"],{x:"X"}],["ChartPlotAreaPosition",["automatic","custom"]],["ChartMapLabelStrategy",["none","bestFit","showAll"]],["ChartMapProjectionType",["automatic","mercator","miller","robinson","albers"]],["ChartParentLabelStrategy",["none","banner","overlapping"]],["ChartSeriesBy",["auto","columns","rows"]],["ChartDataSourceType",["localRange","externalRange","list","unknown"]],["ChartTextHorizontalAlignment",["center","left","right","justify","distributed"]],["ChartTextVerticalAlignment",["center","bottom","top","justify","distributed"]],["ChartTickLabelAlignment",["center","left","right"]],["ChartType",["invalid","columnClustered","columnStacked","columnStacked100","barClustered","barStacked","barStacked100","lineStacked","lineStacked100","lineMarkers","lineMarkersStacked","lineMarkersStacked100","pieOfPie","pieExploded","barOfPie","areaStacked","areaStacked100","doughnutExploded","radarMarkers","radarFilled","surface","surfaceWireframe","surfaceTopView","surfaceTopViewWireframe","bubble","bubble3DEffect","stockHLC","stockOHLC","stockVHLC","stockVOHLC","cylinderColClustered","cylinderColStacked","cylinderColStacked100","cylinderBarClustered","cylinderBarStacked","cylinderBarStacked100","cylinderCol","coneColClustered","coneColStacked","coneColStacked100","coneBarClustered","coneBarStacked","coneBarStacked100","coneCol","pyramidColClustered","pyramidColStacked","pyramidColStacked100","pyramidBarClustered","pyramidBarStacked","pyramidBarStacked100","pyramidCol","line","pie","area","doughnut","radar","histogram","boxwhisker","pareto","regionMap","treemap","waterfall","sunburst","funnel"],{_3DColumnClustered:"3DColumnClustered",_3DColumnStacked:"3DColumnStacked",_3DColumnStacked100:"3DColumnStacked100",_3DBarClustered:"3DBarClustered",_3DBarStacked:"3DBarStacked",_3DBarStacked100:"3DBarStacked100",_3DPieExploded:"3DPieExploded",xyscatterSmooth:"XYScatterSmooth",xyscatterSmoothNoMarkers:"XYScatterSmoothNoMarkers",xyscatterLines:"XYScatterLines",xyscatterLinesNoMarkers:"XYScatterLinesNoMarkers",_3DAreaStacked:"3DAreaStacked",_3DAreaStacked100:"3DAreaStacked100",_3DColumn:"3DColumn",_3DLine:"3DLine",_3DPie:"3DPie",xyscatter:"XYScatter",_3DArea:"3DArea"}],["ChartUnderlineStyle",["none","single"]],["ChartDisplayBlanksAs",["notPlotted","zero","interplotted"]],["ChartPlotBy",["rows","columns"]],["ChartSplitType",["splitByPosition","splitByValue","splitByPercentValue","splitByCustomSplit"]],["ChartColorScheme",["colorfulPalette1","colorfulPalette2","colorfulPalette3","colorfulPalette4","monochromaticPalette1","monochromaticPalette2","monochromaticPalette3","monochromaticPalette4","monochromaticPalette5","monochromaticPalette6","monochromaticPalette7","monochromaticPalette8","monochromaticPalette9","monochromaticPalette10","monochromaticPalette11","monochromaticPalette12","monochromaticPalette13"]],["ChartTrendlineType",["linear","exponential","logarithmic","movingAverage","polynomial","power"]],["ShapeZOrder",["bringToFront","bringForward","sendToBack","sendBackward"]],["ShapeType",["unsupported","image","geometricShape","group","line"]],["ShapeScaleType",["currentSize","originalSize"]],["ShapeScaleFrom",["scaleFromTopLeft","scaleFromMiddle","scaleFromBottomRight"]],["ShapeFillType",["noFill","solid","gradient","pattern","pictureAndTexture","mixed"]],["ShapeFontUnderlineStyle",["none","single","double","heavy","dotted","dottedHeavy","dash","dashHeavy","dashLong","dashLongHeavy","dotDash","dotDashHeavy","dotDotDash","dotDotDashHeavy","wavy","wavyHeavy","wavyDouble"]],["PictureFormat",[],{unknown:"UNKNOWN",bmp:"BMP",jpeg:"JPEG",gif:"GIF",png:"PNG",svg:"SVG"}],["ShapeLineStyle",["single","thickBetweenThin","thickThin","thinThick","thinThin"]],["ShapeLineDashStyle",["dash","dashDot","dashDotDot","longDash","longDashDot","roundDot","solid","squareDot","longDashDotDot","systemDash","systemDot","systemDashDot"]],["ArrowheadLength",["short","medium","long"]],["ArrowheadStyle",["none","triangle","stealth","diamond","oval","open"]],["ArrowheadWidth",["narrow","medium","wide"]],["PremiumLicenseName",["python"]],["BindingType",["range","table","text"]],["BorderIndex",["edgeTop","edgeBottom","edgeLeft","edgeRight","insideVertical","insideHorizontal","diagonalDown","diagonalUp"]],["BorderLineStyle",["none","continuous","dash","dashDot","dashDotDot","dot","double","slantDashDot"]],["BorderWeight",["hairline","thin","medium","thick"]],["CalculationMode",["automatic","automaticExceptTables","manual"]],["RuntimeCalculationMode",[],{undefined:0,automatic:1,automaticExceptTables:2,manual:3}],["CalculationType",["recalculate","full","fullRebuild"]],["ClearApplyTo",["all","formats","contents","hyperlinks","removeHyperlinks"]],["VisualCategory",["column","bar","line","area","pie","donut","scatter","bubble","statistical","stock","combo","hierarchy","surface","map","funnel","radar","waterfall","threeD","other"]],["VisualPropertyType",["object","collection","string","double","int","bool","enum","color"]],["VisualChangeType",["dataChange","propertyChange","genericChange","selectionChange"]],["BoolMetaPropertyType",["writeOnly","readOnly","hideEntireSubtreeUI","hideMeButShowChildrenUI","expandableUI","nextPropOnSameLine","hideLabel","showResetUI","hasOwnExpandableSection","nextPropOnSameLineFOTP","showResetUIFOTP","untransferable","ignoreDuringChangeChartType","notTriviallyUndoable","volatileEnum","exceptionCollection","metaOnly","showHideCollection","errorMessage","infoMessage"]],["ConditionalDataBarAxisFormat",["automatic","none","cellMidPoint"]],["ConditionalDataBarDirection",["context","leftToRight","rightToLeft"]],["ConditionalFormatDirection",["top","bottom"]],["ConditionalFormatType",["custom","dataBar","colorScale","iconSet","topBottom","presetCriteria","containsText","cellValue"]],["ConditionalFormatRuleType",["invalid","automatic","lowestValue","highestValue","number","percent","formula","percentile"]],["ConditionalFormatIconRuleType",["invalid","number","percent","formula","percentile"]],["ConditionalFormatColorCriterionType",["invalid","lowestValue","highestValue","number","percent","formula","percentile"]],["ConditionalTopBottomCriterionType",["invalid","topItems","topPercent","bottomItems","bottomPercent"]],["ConditionalFormatPresetCriterion",["invalid","blanks","nonBlanks","errors","nonErrors","yesterday","today","tomorrow","lastSevenDays","lastWeek","thisWeek","nextWeek","lastMonth","thisMonth","nextMonth","aboveAverage","belowAverage","equalOrAboveAverage","equalOrBelowAverage","oneStdDevAboveAverage","oneStdDevBelowAverage","twoStdDevAboveAverage","twoStdDevBelowAverage","threeStdDevAboveAverage","threeStdDevBelowAverage","uniqueValues","duplicateValues"]],["ConditionalTextOperator",["invalid","contains","notContains","beginsWith","endsWith"]],["ConditionalCellValueOperator",["invalid","between","notBetween","equalTo","notEqualTo","greaterThan","lessThan","greaterThanOrEqual","lessThanOrEqual"]],["ConditionalIconCriterionOperator",["invalid","greaterThan","greaterThanOrEqual"]],["ConditionalRangeBorderIndex",["edgeTop","edgeBottom","edgeLeft","edgeRight"]],["ConditionalRangeBorderLineStyle",["none","continuous","dash","dashDot","dashDotDot","dot"]],["ConditionalRangeFontUnderlineStyle",["none","single","double"]],["CustomFunctionType",["invalid","script","webService"]],["CustomFunctionMetadataFormat",["invalid","openApi"]],["DataValidationType",["none","wholeNumber","decimal","list","date","time","textLength","custom","inconsistent","mixedCriteria"]],["DataValidationOperator",["between","notBetween","equalTo","notEqualTo","greaterThan","lessThan","greaterThanOrEqualTo","lessThanOrEqualTo"]],["DataValidationAlertStyle",["stop","warning","information"]],["DeleteShiftDirection",["up","left"]],["DynamicFilterCriteria",["unknown","aboveAverage","allDatesInPeriodApril","allDatesInPeriodAugust","allDatesInPeriodDecember","allDatesInPeriodFebruray","allDatesInPeriodJanuary","allDatesInPeriodJuly","allDatesInPeriodJune","allDatesInPeriodMarch","allDatesInPeriodMay","allDatesInPeriodNovember","allDatesInPeriodOctober","allDatesInPeriodQuarter1","allDatesInPeriodQuarter2","allDatesInPeriodQuarter3","allDatesInPeriodQuarter4","allDatesInPeriodSeptember","belowAverage","lastMonth","lastQuarter","lastWeek","lastYear","nextMonth","nextQuarter","nextWeek","nextYear","thisMonth","thisQuarter","thisWeek","thisYear","today","tomorrow","yearToDate","yesterday"]],["FilterDatetimeSpecificity",["year","month","day","hour","minute","second"]],["FilterOn",["bottomItems","bottomPercent","cellColor","dynamic","fontColor","values","topItems","topPercent","icon","custom"]],["FilterOperator",["and","or"]],["HorizontalAlignment",["general","left","center","right","fill","justify","centerAcrossSelection","distributed"]],["IconSet",["invalid","threeArrows","threeArrowsGray","threeFlags","threeTrafficLights1","threeTrafficLights2","threeSigns","threeSymbols","threeSymbols2","fourArrows","fourArrowsGray","fourRedToBlack","fourRating","fourTrafficLights","fiveArrows","fiveArrowsGray","fiveRating","fiveQuarters","threeStars","threeTriangles","fiveBoxes"]],["ImageFittingMode",["fit","fitAndCenter","fill"]],["InsertShiftDirection",["down","right"]],["NamedItemScope",["worksheet","workbook"]],["NamedItemType",["string","integer","double","boolean","range","error","array"]],["RangeUnderlineStyle",["none","single","double","singleAccountant","doubleAccountant"]],["SheetVisibility",["visible","hidden","veryHidden"]],["EventTriggerSource",["unknown","thisLocalAddin"]],["RangeValueType",["unknown","empty","string","integer","double","boolean","error","richValue"]],["KeyboardDirection",["left","right","up","down"]],["SearchDirection",["forward","backwards"]],["SortOrientation",["rows","columns"]],["SortOn",["value","cellColor","fontColor","icon"]],["SortDataOption",["normal","textAsNumber"]],["SortMethod",["pinYin","strokeCount"]],["VerticalAlignment",["top","center","bottom","justify","distributed"]],["MessageCategory",[],{none:0,customFunction:1,action:2,event:65536}],["MessageType",[],{none:0,testEvent:1,test1Event:2,worksheetDataChangedEvent:10,worksheetActivatedEvent:11,worksheetDeactivatedEvent:12,worksheetAddedEvent:13,worksheetSelectionChangedEvent:14,worksheetDeletedEvent:15,worksheetCalculatedEvent:16,worksheetFilteredEvent:17,worksheetFormatChangedEvent:18,worksheetRowSortedEvent:19,worksheetColumnSortedEvent:20,worksheetSingleClickedEvent:21,worksheetRowHiddenChangedEvent:22,worksheetFormulaChangedEvent:23,worksheetProtectionChangedEvent:24,worksheetNameChangedEvent:25,worksheetVisibilityChangedEvent:26,worksheetMovedEvent:27,worksheetNavigationObjectChangedEvent:28,worksheetRowHeightChangedEvent:29,workbookFormulaReferenceStyleChangedEvent:30,chartAddedEvent:50,chartActivatedEvent:51,chartDeactivatedEvent:52,chartDeletedEvent:53,tableSelectionChangedEvent:100,tableDataChangedEvent:101,tableAddedEvent:102,tableDeletedEvent:103,tableFilteredEvent:104,agaveVisualUpdateEvent:150,customFunctionExecutionBeginEvent:200,customFunctionExecutionEndEvent:201,commentAddedEvent:250,commentDeletedEvent:251,commentChangedEvent:252,invocationMessage:1e3,cancellationMessage:1001,metadataMessage:1002,visualSelectionChangedEvent:2e3,visualChangeEvent:2001,visualTrackerModelChangedEvent:2002,shapeSelectionChangedEvent:2100,shapeActivatedEvent:2101,shapeDeactivatedEvent:2102,shapeAddedEvent:2103,shapeDeletedEvent:2104,workbookAutoSaveSettingChangedEvent:2200,wacoperationEvent:2201,recordingStateChangedEvent:2202,workbookActivatedEvent:2203,workbookNavigationObjectChangedEvent:2204,ribbonCommandExecutedEvent:2300,linkedDataTypeRefreshRequestCompletedEvent:2500,linkedDataTypeRefreshModeChangedEvent:2501,linkedDataTypeLinkedDataTypeAddedEvent:2502,linkedWorkbookWorkbookLinksChangedEvent:2600,linkedWorkbookRefreshCompletedEvent:2601,rangePickerSelectionChangedEvent:2700,rangePickerDeactivatedEvent:2701,lineageActivityUpdateAvailableEvent:2800,lineageActivityFilterUpdatedEvent:2801,lineageActivityLoadCompletedEvent:2802,pivotTableAddedEvent:2900,pivotTableDeletedEvent:2901,namedItemAddedEvent:3e3,namedItemDeletedEvent:3001,guidedReapplyManagerUpdateAvailableEvent:3100,vbaRecorderRecordingChangedEvent:3200,vbaRecorderRecordingChanged2Event:3202,workbookActionRecordedEvent:3201,externalCodeServiceDiagnosticsNewEntryEvent:3300,externalCodeServiceDiagnosticsFilterUpdatedEvent:3301,rangeValuesPreviewDismissedEvent:3400,applicationUndoChangedEvent:3500,linkedEntityDataDomainLinkedEntityDataDomainAddedEvent:3600,linkedEntityDataDomainRefreshCompletedEvent:3601,linkedEntityDataDomainRefreshModeChangedEvent:3602,appRuntimeVisibilityChangedEvent:65539,beforeCloseNotifiactionCancelledEvent:65540,augmentationLoopAnnotationAddedEvent:65541}],["InsertDeleteCellsShiftDirection",["none","shiftCellLeft","shiftCellUp","shiftCellRight","shiftCellDown"]],["DocumentPropertyType",["number","boolean","date","string","float"]],["EventSource",["local","remote"]],["DataChangeType",["unknown","rangeEdited","rowInserted","rowDeleted","columnInserted","columnDeleted","cellInserted","cellDeleted"]],["RowHiddenChangeType",["unhidden","hidden"]],["CommentChangeType",["commentEdited","commentResolved","commentReopened","replyAdded","replyDeleted","replyEdited"]],["EventType",["worksheetChanged","worksheetSelectionChanged","worksheetAdded","worksheetActivated","worksheetDeactivated","tableChanged","tableSelectionChanged","worksheetDeleted","chartAdded","chartActivated","chartDeactivated","chartDeleted","worksheetCalculated","visualSelectionChanged","agaveVisualUpdate","tableAdded","tableDeleted","tableFiltered","worksheetFiltered","shapeActivated","shapeDeactivated","visualChange","workbookAutoSaveSettingChanged","worksheetFormatChanged","ribbonCommandExecuted","worksheetRowSorted","worksheetColumnSorted","worksheetSingleClicked","worksheetRowHiddenChanged","recordingStateChangedEvent","commentAdded","commentDeleted","commentChanged","linkedDataTypeRefreshRequestCompleted","linkedDataTypeRefreshModeChanged","linkedDataTypeLinkedDataTypeAdded","worksheetFormulaChanged","workbookActivated","linkedWorkbookWorkbookLinksChanged","linkedWorkbookRefreshCompleted","worksheetProtectionChanged","worksheetNameChanged","worksheetVisibilityChanged","worksheetMoved","lineageActivityUpdateAvailable","lineageActivityFilterUpdated","lineageActivityLoadCompleted","shapeAdded","shapeDeleted","pivotTableAdded","pivotTableDeleted","namedItemAdded","namedItemDeleted","worksheetNavigationObjectChanged","workbookNavigationObjectChanged","worksheetRowHeightChanged","workbookFormulaReferenceStyleChanged","guidedReapplyManagerUpdateAvailable","vbaRecorderRecordingChanged","rangeValuesPreviewDismissed","annotationAdded","workbookActionRecorded","applicationUndoChanged","vbaRecorderRecordingChanged2","linkedEntityDataDomainLinkedEntityDataDomainAdded","linkedEntityDataDomainRefreshCompleted","linkedEntityDataDomainRefreshModeChanged"],{wacoperationEvent:"WACOperationEvent"}],["DocumentPropertyItem",["title","subject","author","keywords","comments","template","lastAuth","revision","appName","lastPrint","creation","lastSave","category","format","manager","company"]],["SubtotalLocationType",["atTop","atBottom","off"]],["PivotLayoutType",["compact","tabular","outline"]],["ProtectionSelectionMode",["normal","unlocked","none"]],["PageOrientation",["portrait","landscape"]],["PaperType",["letter","letterSmall","tabloid","ledger","legal","statement","executive","a3","a4","a4Small","a5","b4","b5","folio","quatro","paper10x14","paper11x17","note","envelope9","envelope10","envelope11","envelope12","envelope14","csheet","dsheet","esheet","envelopeDL","envelopeC5","envelopeC3","envelopeC4","envelopeC6","envelopeC65","envelopeB4","envelopeB5","envelopeB6","envelopeItaly","envelopeMonarch","envelopePersonal","fanfoldUS","fanfoldStdGerman","fanfoldLegalGerman"]],["ReadingOrder",["context","leftToRight","rightToLeft"]],["BuiltInStyle",["normal","comma","currency","percent","wholeComma","wholeDollar","hlink","hlinkTrav","note","warningText","emphasis1","emphasis2","emphasis3","sheetTitle","heading1","heading2","heading3","heading4","input","output","calculation","checkCell","linkedCell","total","good","bad","neutral","accent1","accent1_20","accent1_40","accent1_60","accent2","accent2_20","accent2_40","accent2_60","accent3","accent3_20","accent3_40","accent3_60","accent4","accent4_20","accent4_40","accent4_60","accent5","accent5_20","accent5_40","accent5_60","accent6","accent6_20","accent6_40","accent6_60","explanatoryText"]],["PrintErrorType",["asDisplayed","blank","dash","notAvailable"]],["WorksheetPositionType",["none","before","after","beginning","end"]],["PrintComments",["noComments","endSheet","inPlace"]],["PrintOrder",["downThenOver","overThenDown"]],["PrintMarginUnit",["points","inches","centimeters"]],["HeaderFooterState",["default","firstAndDefault","oddAndEven","firstOddAndEven"]],["AutoFillType",["fillDefault","fillCopy","fillSeries","fillFormats","fillValues","fillDays","fillWeekdays","fillMonths","fillYears","linearTrend","growthTrend","flashFill"]],["GroupOption",["byRows","byColumns"]],["RangeCopyType",["all","formulas","values","formats","link","columnWidths"]],["LinkedDataTypeState",["none","validLinkedData","disambiguationNeeded","brokenLinkedData","fetchingData"]],["GeometricShapeType",["lineInverse","triangle","rightTriangle","rectangle","diamond","parallelogram","trapezoid","nonIsoscelesTrapezoid","pentagon","hexagon","heptagon","octagon","decagon","dodecagon","star4","star5","star6","star7","star8","star10","star12","star16","star24","star32","roundRectangle","round1Rectangle","round2SameRectangle","round2DiagonalRectangle","snipRoundRectangle","snip1Rectangle","snip2SameRectangle","snip2DiagonalRectangle","plaque","ellipse","teardrop","homePlate","chevron","pieWedge","pie","blockArc","donut","noSmoking","rightArrow","leftArrow","upArrow","downArrow","stripedRightArrow","notchedRightArrow","bentUpArrow","leftRightArrow","upDownArrow","leftUpArrow","leftRightUpArrow","quadArrow","leftArrowCallout","rightArrowCallout","upArrowCallout","downArrowCallout","leftRightArrowCallout","upDownArrowCallout","quadArrowCallout","bentArrow","uturnArrow","circularArrow","leftCircularArrow","leftRightCircularArrow","curvedRightArrow","curvedLeftArrow","curvedUpArrow","curvedDownArrow","swooshArrow","cube","can","lightningBolt","heart","sun","moon","smileyFace","irregularSeal1","irregularSeal2","foldedCorner","bevel","frame","halfFrame","corner","diagonalStripe","chord","arc","leftBracket","rightBracket","leftBrace","rightBrace","bracketPair","bracePair","callout1","callout2","callout3","accentCallout1","accentCallout2","accentCallout3","borderCallout1","borderCallout2","borderCallout3","accentBorderCallout1","accentBorderCallout2","accentBorderCallout3","wedgeRectCallout","wedgeRRectCallout","wedgeEllipseCallout","cloudCallout","cloud","ribbon","ribbon2","ellipseRibbon","ellipseRibbon2","leftRightRibbon","verticalScroll","horizontalScroll","wave","doubleWave","plus","flowChartProcess","flowChartDecision","flowChartInputOutput","flowChartPredefinedProcess","flowChartInternalStorage","flowChartDocument","flowChartMultidocument","flowChartTerminator","flowChartPreparation","flowChartManualInput","flowChartManualOperation","flowChartConnector","flowChartPunchedCard","flowChartPunchedTape","flowChartSummingJunction","flowChartOr","flowChartCollate","flowChartSort","flowChartExtract","flowChartMerge","flowChartOfflineStorage","flowChartOnlineStorage","flowChartMagneticTape","flowChartMagneticDisk","flowChartMagneticDrum","flowChartDisplay","flowChartDelay","flowChartAlternateProcess","flowChartOffpageConnector","actionButtonBlank","actionButtonHome","actionButtonHelp","actionButtonInformation","actionButtonForwardNext","actionButtonBackPrevious","actionButtonEnd","actionButtonBeginning","actionButtonReturn","actionButtonDocument","actionButtonSound","actionButtonMovie","gear6","gear9","funnel","mathPlus","mathMinus","mathMultiply","mathDivide","mathEqual","mathNotEqual","cornerTabs","squareTabs","plaqueTabs","chartX","chartStar","chartPlus"]],["ConnectorType",["straight","elbow","curve"]],["ContentType",["plain","mention"]],["SpecialCellType",["conditionalFormats","dataValidations","blanks","constants","formulas","sameConditionalFormat","sameDataValidation","visible"]],["SpecialCellValueType",["all","errors","errorsLogical","errorsNumbers","errorsText","errorsLogicalNumber","errorsLogicalText","errorsNumberText","logical","logicalNumbers","logicalText","logicalNumbersText","numbers","numbersText","text"]],["Placement",["twoCell","oneCell","absolute"]],["FillPattern",["none","solid","gray50","gray75","gray25","horizontal","vertical","down","up","checker","semiGray75","lightHorizontal","lightVertical","lightDown","lightUp","grid","crissCross","gray16","gray8","linearGradient","rectangularGradient"]],["ShapeTextHorizontalAlignment",["left","center","right","justify","justifyLow","distributed","thaiDistributed"]],["ShapeTextVerticalAlignment",["top","middle","bottom","justified","distributed"]],["ShapeTextVerticalOverflow",["overflow","ellipsis","clip"]],["ShapeTextHorizontalOverflow",["overflow","clip"]],["ShapeTextReadingOrder",["leftToRight","rightToLeft"]],["ShapeTextOrientation",["horizontal","vertical","vertical270","wordArtVertical","eastAsianVertical","mongolianVertical","wordArtVerticalRTL"]],["ShapeAutoSize",["autoSizeNone","autoSizeTextToFitShape","autoSizeShapeToFitText","autoSizeMixed"]],["CloseBehavior",["save","skipSave"]],["SaveBehavior",["save","prompt"]],["SlicerSortType",["dataSourceOrder","ascending","descending"]],["RibbonTab",["others","home","insert","draw","pageLayout","formulas","data","review","view","developer","addIns","help"]],["NumberFormatCategory",["general","number","currency","accounting","date","time","percentage","fraction","scientific","text","special","custom"]]],clientObjectTypes:[["UndoScope",0,0,0,[["close",0,0,0,2],["open",1,0,0,2]]],["RangeValuesPreview",4,0,0,[["_RegisterEventDismissed",0,0,0,2,0,1],["_UnregisterEventDismissed",0,0,0,2,0,1],["dismiss",0,2,0,4],["show",3,2,0,4]],0,0,0,[["Dismissed",0,0,"MessageType.rangeValuesPreviewDismissedEvent","this._ParentObject.id","_RegisterEventDismissed","_UnregisterEventDismissed"]]],["AugmentationLoop",0,0,0,[["_RegisterAnnotationAddedEvent",0,2,0,4],["_UnregisterAnnotationAddedEvent",0,2,0,4],["activateAnnotation",1,2,0,4],["submitSignal",1,2,0,4]],0,0,0,[["AnnotationAdded",0,0,"MessageType.augmentationLoopAnnotationAddedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterAnnotationAddedEvent","_UnregisterAnnotationAddedEvent"]]],["ExternalCodeService",0,[["autoShowDiagnostics"]],[["diagnostics","ExternalCodeServiceDiagnostics",2,0,0,4]]],["ExternalCodeServiceDiagnostics",0,[["id",2]],0,[["_RegisterEventNewEntry",0,0,0,2,0,1],["_UnregisterEventNewEntry",0,0,0,2,0,1],["clear",0,2,0,4],["fireStoredEntries",0,2,0,4],["_RegisterEventFilterUpdated",0,0,0,2,0,1],["_UnregisterEventFilterUpdated",0,0,0,2,0,1]],0,0,0,[["FilterUpdated",0,0,"MessageType.externalCodeServiceDiagnosticsFilterUpdatedEvent","this.id","_RegisterEventFilterUpdated","_UnregisterEventFilterUpdated"],["NewEntry",0,0,"MessageType.externalCodeServiceDiagnosticsNewEntryEvent","this.id","_RegisterEventNewEntry","_UnregisterEventNewEntry"]]],["VbaRecorder",0,[["id",2]],0,[["_RegisterEventRecordingChanged",0,0,0,2,0,1],["_UnregisterEventRecordingChanged",0,0,0,2,0,1],["_RegisterEventRecordingChanged2",0,2,2,4],["_UnregisterEventRecordingChanged2",0,2,2,4]],0,0,0,[["RecordingChanged",0,0,"MessageType.vbaRecorderRecordingChangedEvent","this.id","_RegisterEventRecordingChanged","_UnregisterEventRecordingChanged"],["RecordingChanged2",0,2,"MessageType.vbaRecorderRecordingChanged2Event","this.id","_RegisterEventRecordingChanged2","_UnregisterEventRecordingChanged2"]]],["WorksheetOptimizationScanResult",0,[["allocatedCells",2],["optimizableCells",2]],[["ranges","RangeOptimizationCollection",18,0,0,4]]],["UserActivityCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","UserActivity",1,2,0,4]],0,"UserActivity"],["GuidedReapplyManager",0,0,[["activities","UserActivityCollection",18,0,0,4],["summaryCardUserActivity","SummaryCardUserActivity",2,0,0,4],["unappliedActivities","UserActivityCollection",18,0,0,4],["reappliedActivities","UserActivityCollection",18,0,0,4],["reappliedSummaryCardUserActivity","SummaryCardUserActivity",2,0,0,4],["unappliedSummaryCardUserActivity","SummaryCardUserActivity",2,0,0,4]],[["openSavedFile",0,2,0,4],["updateActivities",0,2,0,4],["_RegisterEventUpdateAvailable",0,2,0,4],["_UnregisterEventUpdateAvailable",0,2,0,4],["discardActivites",0,2,0,4],["reapplyActivity",1,2,0,4],["saveActivities",0,2,0,4],["reapplyActivities",0,2,0,4]],[["getState","GuidedReapplyState",0,2,0,4]],0,0,[["UpdateAvailable",0,0,"MessageType.guidedReapplyManagerUpdateAvailableEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventUpdateAvailable","_UnregisterEventUpdateAvailable"]]],["GuidedReapplyState",0,[["dimAppliedUnsavedChangesButton",2],["dimOpenBackupButton",2]]],["BusinessBar",0,0,0,[["hide",2],["show",2]]],["UserActivity",0,[["activityId",2],["activityType",2],["author",2],["createdDateTime",10],["guid",2],["rangeAddress",2],["sheetName",2],["valueChangeData",2],["authorEmail",2],["locationDeleted",2]],[["highlightRangeAreas","RangeAreas",2,0,0,4]]],["LineageActivityCollection",1,0,0,[["_RegisterEventUpdateAvailable",0,2,0,4],["_UnregisterEventUpdateAvailable",0,2,0,4],["clear",0,2,0,4],["getCount",0,2,0,4],["getState",0,2,0,4],["loadActivities",1,2,0,4],["loadLatestActivities",0,2,0,4],["loadNextActivities",0,2,0,4],["loadPreviousActivities",0,2,0,4],["updateActivities",0,2,0,4],["_RegisterEventFilterUpdated",0,2,0,4],["_RegisterEventLoadCompleted",0,2,0,4],["_UnregisterEventFilterUpdated",0,2,0,4],["_UnregisterEventLoadCompleted",0,2,0,4]],[["getItemAt","UserActivity",1,2,0,4]],0,"UserActivity",[["FilterUpdated",0,0,"MessageType.lineageActivityFilterUpdatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventFilterUpdated","_UnregisterEventFilterUpdated"],["LoadCompleted",0,0,"MessageType.lineageActivityLoadCompletedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventLoadCompleted","_UnregisterEventLoadCompleted"],["UpdateAvailable",0,0,"MessageType.lineageActivityUpdateAvailableEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventUpdateAvailable","_UnregisterEventUpdateAvailable"]]],["SummaryItemUserActivity",0,[["activityType",2],["rangeAddresses",2],["sheetName",2],["valueChangeData",2]]],["SummaryItemUserActivityCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","SummaryItemUserActivity",1,2,0,4]],0,"SummaryItemUserActivity"],["SummaryCardUserActivity",0,[["authors",2],["currentUser",2],["displayTime",10],["numberOfDetailedCard",2],["summaryUnviewableData",2]],[["summaryItemUserActivities","SummaryItemUserActivityCollection",18,0,0,4]]],["AllowEditRange",0,[["address",1],["isPasswordProtected",3],["title",1]],0,[["delete"],["pauseProtection",1],["setPassword",1]]],["AllowEditRangeCollection",1,0,0,[["add",3],["getCount",0,2,0,4],["pauseProtection",1]],[["getItem","AllowEditRange",1,18,0,4],["getItemAt","AllowEditRange",1,2,0,4],["getItemOrNullObject","AllowEditRange",1,2,0,4]],0,"AllowEditRange"],["Query",0,[["loadedTo",2],["loadedToDataModel",2],["name",2],["refreshDate",10],["rowsLoadedCount",2],["error",2]]],["QueryCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","Query",1,18,0,4]],0,"Query"],["VisualTracker",0,[["id",2]],0,[["_RegisterEventModelChanged",0,2],["_UnregisterEventModelChanged",0,2],["requestTrackingAlteration",2,2,0,4]],0,0,0,[["ModelChanged",0,0,"MessageType.visualTrackerModelChangedEvent","this.id","_RegisterEventModelChanged","_UnregisterEventModelChanged"]]],["NumberFormatProperty",0,[["key",3],["currency",3],["dateTime",3],["dateTimeHasDayOfWeek",3],["dateTimeHasMonth",3],["dateTimeHasYear",3],["numeric",3],["percent",3],["text",3]]],["NumberFormatPropertyCollection",1,0,0,0,[["getItemAt","NumberFormatProperty",1,2,0,4]],0,"NumberFormatProperty"],["RangeOptimization",0,[["optimizationTypes",2],["range",2]]],["RangeOptimizationCollection",1,[["allocatedCells",2],["optimizableCells",2]],0,[["getCount",0,2,0,4]],[["getItemAt","RangeOptimization",1,2,0,4]],0,"RangeOptimization"],["WorksheetOptimization",0,0,0,[["formatCellCounts",1,2,0,4]],[["optimize","WorksheetOptimizationResult",0,0,0,2],["scan","RangeOptimizationCollection",0,6,0,4],["scanExtended","WorksheetOptimizationScanResult",0,2,0,4]]],["WorksheetOptimizationResult",0,[["allocatedCells",2],["optimizedCells",2]]],["LinkedWorkbook",0,[["displayUrl",2,3],["fileName",3,3],["id",2],["longErrorDescription",2,3],["refreshEnabled",2,3],["refreshing",2,3],["statusMessage",2,3],["excelIconState",2,3],["hardToFindErrorMessages",2,3],["lastUpdated",10,3]],0,[["_RegisterRefreshCompletedEvent",0,0,3,2,0,1],["_UnregisterRefreshCompletedEvent",0,0,3,2,0,1],["breakLinks",0,0,0,2,0,4],["changeSource",1,0,3,2,0,4],["findNextLink",0,2,3,4],["openWorkbook",0,2,3,4],["refresh"],["openChangeSourceDialog",0,0,3,2,0,4],["closeChangeSourceDialog",0,2,3,4]],0,0,0,[["RefreshCompleted",0,3,"MessageType.linkedWorkbookRefreshCompletedEvent","this.id","_RegisterRefreshCompletedEvent","_UnregisterRefreshCompletedEvent"]]],["LinkedWorkbookCollection",1,[["breakAllLinksEnabled",0,3],["refreshAllEnabled",0,3],["workbookLinksRefreshMode"],["workbookLinksRefreshSettings",0,3],["containsNonWorkbookLinks",0,3]],0,[["_RegisterWorkbookLinksChangedEvent",0,2,3,4],["_UnregisterWorkbookLinksChangedEvent",0,2,3,4],["breakAllLinks",0,0,0,2,0,4],["getCount",0,2,3,4],["refreshAll"],["openEditLinksDialog",0,2,3,4]],[["getItem","LinkedWorkbook",1,18,0,4],["getItemAt","LinkedWorkbook",1,2,3,4],["getItemOrNullObject","LinkedWorkbook",1]],0,"LinkedWorkbook",[["WorkbookLinksChanged",0,3,"MessageType.linkedWorkbookWorkbookLinksChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterWorkbookLinksChangedEvent","_UnregisterWorkbookLinksChangedEvent"]]],["DocumentTaskChange",0,[["type",2],["changedBy",2],["commentId",2],["createdDateTime",10],["id",2],["assignee",2],["undoChangeId",2],["priority",2],["title",2],["percentComplete",2],["startDateTime",10],["dueDateTime",10]],0,0,0,0,0,0,"Microsoft.ExcelServices.DocumentTaskChange",4],["DocumentTaskChangeCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","DocumentTaskChange",1,2,0,4]],0,"DocumentTaskChange"],["RangePicker",0,0,0,[["activate",1,0,0,2,0,5],["deactivate",0,0,0,2,0,5],["updateSelection",1,0,0,2,0,5],["updateSelectionWithNavigation",4,0,0,2,0,5],["_RegisterEventSelectionChanged",0,0,0,2,0,5],["_UnregisterEventSelectionChanged",0,0,0,2,0,5],["_RegisterEventDeactivated",0,2,0,4],["_UnregisterEventDeactivated",0,2,0,4]],0,0,0,[["Deactivated",0,0,"MessageType.rangePickerDeactivatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventDeactivated","_UnregisterEventDeactivated"],["SelectionChanged",0,0,"MessageType.rangePickerSelectionChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventSelectionChanged","_UnregisterEventSelectionChanged"]]],["DocumentTask",0,[["startAndDueDateTime"],["id",2],["percentComplete"],["priority"],["title"],["assignees",2],["completedBy",2],["completedDateTime",10],["createdBy",2],["createdDateTime",10]],[["changes","DocumentTaskChangeCollection",18,0,0,4],["comment","Comment",2,0,0,4]],[["assign",1],["unassign",1],["unassignAll"]]],["DocumentTaskCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","DocumentTask",1,18,0,4],["getItemOrNullObject","DocumentTask",1,2,0,4],["getItemAt","DocumentTask",1,2,0,4]],0,"DocumentTask"],["DataConnection",0,[["connectionString",2],["name",2],["commandText",2],["dataSourceType",2]]],["Runtime",0,[["enableEvents",1,6]]],["Application",0,[["calculationMode",1],["calculationEngineVersion",3,7],["calculationState",3,7],["decimalSeparator",3,8],["thousandsSeparator",3,8],["useSystemSeparators",3,8],["formatStaleValues",1,9]],[["iterativeCalculation","IterativeCalculation",35,7,0,4],["ribbon","Ribbon",35,7,0,4],["cultureInfo","CultureInfo",3,8,0,4],["undoScope","UndoScope",3,3,0,4]],[["calculate",1],["suspendApiCalculationUntilNextSync",0,1,10,2,0,11],["suspendScreenUpdatingUntilNextSync",0,0,7,2,0,11],["hasLicense",1,2,9,4],["redo",0,0,3,2],["explorePremiumLicense",1,2,9,4],["undo",0,0,3,2],["_RegisterEventUndoChanged",0,2,3,4],["_UnregisterEventUndoChanged",0,2,3,4]],[["createWorkbook","WorkbookCreated",1,10,6,0,0,"_GetWorkbookCreatedById"],["_GetWorkbookCreatedById","WorkbookCreated",1,2,6,4]],0,0,[["UndoChanged",0,3,"MessageType.applicationUndoChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventUndoChanged","_UnregisterEventUndoChanged"]]],["IterativeCalculation",0,[["enabled",1],["maxIteration",1],["maxChange",1]]],["Workbook",0,[["name",3,12],["readOnly",3,6],["isDirty",1,7],["use1904DateSystem",1,9],["chartDataPointTrack",1,7],["usePrecisionAsDisplayed",1,7],["calculationEngineVersion",3,7],["autoSave",3,7],["previouslySaved",3,7],["showPivotFieldList",0,9,0,2,13],["formulaReferenceStyle",2,3],["externalCodeServiceTimeout",0,9,0,2]],[["worksheets","WorksheetCollection",19,0,0,4],["names","NamedItemCollection",19,0,0,4],["tables","TableCollection",19,0,0,4],["application","Application",2,0,0,4],["bindings","BindingCollection",19,0,0,4],["functions","Functions",2,14,0,4],["_V1Api","_V1Api",2,15,0,4],["pivotTables","PivotTableCollection",19,15,0,4],["settings","SettingCollection",19,16,0,4],["customXmlParts","CustomXmlPartCollection",19,17,0,4],["internalTest","InternalTest",2,10,0,4],["properties","DocumentProperties",35,12,0,4],["styles","StyleCollection",19,12,0,4],["protection","WorkbookProtection",3,12,0,4],["dataConnections","DataConnectionCollection",3,12,0,4],["_Runtime","Runtime",2,17,0,4],["comments","CommentCollection",19,18,0,4],["slicers","SlicerCollection",19,18,0,4],["tableStyles","TableStyleCollection",19,18,0,4],["pivotTableStyles","PivotTableStyleCollection",19,18,0,4],["slicerStyles","SlicerStyleCollection",19,18,0,4],["timelineStyles","TimelineStyleCollection",19,18,0,4],["tasks","DocumentTaskCollection",18,9,0,4],["linkedDataTypes","LinkedDataTypeCollection",18,9,0,4],["queries","QueryCollection",18,19,0,4],["linkedWorkbooks","LinkedWorkbookCollection",18,20,0,4],["rangePicker","RangePicker",2,9,0,4,0,5],["lineageActivities","LineageActivityCollection",18,3,0,4],["businessBar","BusinessBar",2,9,0,4],["guidedReapply","GuidedReapplyManager",2,3,0,4],["vbaRecorder","VbaRecorder",2,9,0,4],["externalCodeService","ExternalCodeService",2,9,0,4],["augmentationLoop","AugmentationLoop",2,9,0,4],["linkedEntityDataDomains","LinkedEntityDataDomainCollection",18,21,0,4]],[["_RemoveReference",1,2],["_GetObjectByReferenceId",1,2,0,4],["_GetObjectTypeNameByReferenceId",1,2,0,4],["_RemoveAllReferences",0,2],["_GetReferenceCount",0,2,0,4],["getIsActiveCollabSession",0,0,7],["registerCustomFunctions",7,0,22,8],["_SetOsfControlContainerReadyForCustomFunctions",0,0,22],["close",1,0,8],["save",1,0,8],["_RegisterAutoSaveSettingChangedEvent",0,0,7,2,0,1],["_UnregisterAutoSaveSettingChangedEvent",0,0,7,2,0,1],["_RegisterWACOperationEvent",0,2,23,4],["_UnregisterWACOperationEvent",0,2,23,4],["_RegisterRecordingStateChangedEvent",0,0,23,2,0,24],["_UnregisterRecordingStateChangedEvent",0,0,23,2,0,24],["_RegisterActivatedEvent",0,2,25],["_UnregisterActivatedEvent",0,2,25],["insertWorksheetsFromBase64",2,0,25],["enableOfficeScriptRecording",1,1,20],["recordAction",1,3,0,4],["focus",0,2,3,4],["_RegisterNavigationObjectChangedEvent",0,0,3,2,0,1],["_UnregisterNavigationObjectChangedEvent",0,0,3,2,0,1],["showHelp",1,2,3,4],["getLinkedEntityCellValue",1,2,26,4],["getThemeColors",0,2,9,4],["_RegisterEventFormulaReferenceStyleChanged",0,2,3,4],["_UnregisterEventFormulaReferenceStyleChanged",0,2,3,4],["notifySDXLoaded",1,2,3,4],["openConditionalFormattingRulesManager",1,0,3],["openNameManager",0,0,3],["_RegisterEventActionRecorded",0,2,2,4],["_UnregisterEventActionRecorded",0,2,2,4]],[["getSelectedRange","Range",0,10,0,4],["getActiveCell","Range",0,10,12,4],["_GetRangeForEventByReferenceId","Range",1,2,0,4],["_GetRangeOrNullObjectForEventByReferenceId","Range",1,2,0,4],["getActiveChart","Chart",0,2,7,4],["getActiveChartOrNullObject","Chart",0,2,7,4],["getSelectedRanges","RangeAreas",0,10,7,4],["_GetRangesForEventByReferenceId","RangeAreas",1,2,7,4],["_GetRangesOrNullObjectForEventByReferenceId","RangeAreas",1,2,7,4],["getActiveSlicer","Slicer",0,2,18,4],["getActiveSlicerOrNullObject","Slicer",0,2,18,4]],0,0,[["ActionRecorded",0,2,"MessageType.workbookActionRecordedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventActionRecorded","_UnregisterEventActionRecorded"],["Activated",0,25,"MessageType.workbookActivatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["AutoSaveSettingChanged",0,7,"MessageType.workbookAutoSaveSettingChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterAutoSaveSettingChangedEvent","_UnregisterAutoSaveSettingChangedEvent"],["FormulaReferenceStyleChanged",0,3,"MessageType.workbookFormulaReferenceStyleChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventFormulaReferenceStyleChanged","_UnregisterEventFormulaReferenceStyleChanged"],["NavigationObjectChanged",0,3,"MessageType.workbookNavigationObjectChangedEvent","this.id","_RegisterNavigationObjectChangedEvent","_UnregisterNavigationObjectChangedEvent"],["RecordingStateChangedEvent",0,23,"MessageType.recordingStateChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterRecordingStateChangedEvent","_UnregisterRecordingStateChangedEvent"],["SelectionChanged",3,15,"_CC.office10EventIdDocumentSelectionChangedEvent","","",""],["WACOperationEvent",2,23,"MessageType.wacoperationEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterWACOperationEvent","_UnregisterWACOperationEvent"],["_Message",3,12,"_CC.office10EventIdRichApiMessageEvent","","",""]]],["WorkbookProtection",0,[["protected",3]],0,[["protect",1],["unprotect",1]]],["WorkbookCreated",0,[["id",3]],0,[["open",0,2,0,4]]],["Worksheet",0,[["name",1],["id",3],["position",1],["visibility",1],["tabColor",1,12,0,2,27],["standardWidth",1,12],["standardHeight",3,12],["showGridlines",5,6,0,2,28],["showHeadings",5,6],["enableCalculation",1,7],["tabId",3,19],["showDataTypeIcons",0,21,0,2]],[["charts","ChartCollection",83,0,0,4],["tables","TableCollection",83,0,0,4],["protection","WorksheetProtection",3,14,0,4],["pivotTables","PivotTableCollection",83,15,0,4],["names","NamedItemCollection",83,16,0,4],["freezePanes","WorksheetFreezePanes",3,12,0,4],["pageLayout","PageLayout",35,7,0,4],["visuals","VisualCollection",83,18,0,4],["shapes","ShapeCollection",83,7,0,4],["horizontalPageBreaks","PageBreakCollection",19,7,0,4],["verticalPageBreaks","PageBreakCollection",19,7,0,4],["autoFilter","AutoFilter",3,7,0,4],["slicers","SlicerCollection",19,18,0,4],["comments","CommentCollection",83,18,0,4],["customProperties","WorksheetCustomPropertyCollection",19,29,0,4],["namedSheetViews","NamedSheetViewCollection",18,20,0,4],["optimization","WorksheetOptimization",2,9,0,4],["tasks","DocumentTaskCollection",18,9,0,4],["visualTracker","VisualTracker",2,30,0,4],["rangeValuesPreview","RangeValuesPreview",66,9,0,4]],[["delete"],["activate",0,2],["calculate",1,0,10],["_RegisterDataChangedEvent",0,0,12,2,0,11],["_UnregisterDataChangedEvent",0,0,12,2,0,11],["_RegisterActivatedEvent",0,0,12,2,0,1],["_UnregisterActivatedEvent",0,0,12,2,0,1],["_RegisterDeactivatedEvent",0,0,12,2,0,1],["_UnregisterDeactivatedEvent",0,0,12,2,0,1],["_RegisterSelectionChangedEvent",0,0,12,2,0,31],["_UnregisterSelectionChangedEvent",0,0,12,2,0,31],["_RegisterCalculatedEvent",0,0,6,2,0,1],["_UnregisterCalculatedEvent",0,0,6,2,0,1],["replaceAll",3,0,7],["_RegisterFilteredEvent",0,0,9,2,0,1],["_UnregisterFilteredEvent",0,0,9,2,0,1],["_RegisterFormatChangedEvent",0,0,7,2,0,1],["_UnregisterFormatChangedEvent",0,0,7,2,0,1],["_RegisterRowSortedEvent",0,0,18,2,0,1],["_UnregisterRowSortedEvent",0,0,18,2,0,1],["_RegisterColumnSortedEvent",0,0,18,2,0,1],["_UnregisterColumnSortedEvent",0,0,18,2,0,1],["_RegisterSingleClickedEvent",0,0,18,2,0,1],["_UnregisterSingleClickedEvent",0,0,18,2,0,1],["_RegisterRowHiddenChangedEvent",0,0,8,2,0,1],["_UnregisterRowHiddenChangedEvent",0,0,8,2,0,1],["showOutlineLevels",2,0,18],["_RegisterFormulaChangedEvent",0,2,25],["_UnregisterFormulaChangedEvent",0,2,25],["_RegisterProtectionChangedEvent",0,2,19],["_UnregisterProtectionChangedEvent",0,2,19],["_RegisterEventNameChanged",0,0,32,2,0,1],["_RegisterEventVisibilityChanged",0,0,32,2,0,1],["_UnregisterEventNameChanged",0,0,32,2,0,1],["_UnregisterEventVisibilityChanged",0,0,32,2,0,1],["_RegisterNavigationObjectChangedEvent",0,0,3,2,0,1],["_UnregisterNavigationObjectChangedEvent",0,0,3,2,0,1],["_RegisterEventRowHeightChanged",0,2,9],["_UnregisterEventRowHeightChanged",0,2,9]],[["getRange","Range",1,10,0,4],["getUsedRange","Range",1,10,0,4],["getCell","Range",2,10,0,4],["getUsedRangeOrNullObject","Range",1,10,16,4],["getRangeByIndexes","Range",4,10,12,4],["getPrevious","Worksheet",1,10,17,4,0,"_GetSheetById"],["getPreviousOrNullObject","Worksheet",1,10,17,4,0,"_GetSheetById"],["getNext","Worksheet",1,10,17,4,0,"_GetSheetById"],["getNextOrNullObject","Worksheet",1,10,17,4,0,"_GetSheetById"],["_GetSheetById","Worksheet",1,2,12,4],["copy","Worksheet",2,0,12,0,0,"_GetAnotherWorksheetById"],["_GetAnotherWorksheetById","Worksheet",1,0,12],["findAll","RangeAreas",2,10,7,4],["findAllOrNullObject","RangeAreas",2,10,7,4],["getRanges","RangeAreas",1,10,7,4],["getUsedRangeAreas","RangeAreas",1,0,3],["getRangeR1C1","Range",1,2,3,4],["getRangesR1C1","RangeAreas",1,2,3,4],["getUsedRangeAreasOrNullObject","RangeAreas",1,0,3]],"workbook.worksheets",0,[["Activated",0,12,"MessageType.worksheetActivatedEvent","this.id","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["Calculated",0,6,"MessageType.worksheetCalculatedEvent","this.id","_RegisterCalculatedEvent","_UnregisterCalculatedEvent"],["Changed",2,12,"MessageType.worksheetDataChangedEvent","this.id","_RegisterDataChangedEvent","_UnregisterDataChangedEvent"],["ColumnSorted",0,18,"MessageType.worksheetColumnSortedEvent","this.id","_RegisterColumnSortedEvent","_UnregisterColumnSortedEvent"],["Deactivated",0,12,"MessageType.worksheetDeactivatedEvent","this.id","_RegisterDeactivatedEvent","_UnregisterDeactivatedEvent"],["Filtered",0,9,"MessageType.worksheetFilteredEvent","this.id","_RegisterFilteredEvent","_UnregisterFilteredEvent"],["FormatChanged",2,7,"MessageType.worksheetFormatChangedEvent","this.id","_RegisterFormatChangedEvent","_UnregisterFormatChangedEvent"],["FormulaChanged",2,25,"MessageType.worksheetFormulaChangedEvent","this.id","_RegisterFormulaChangedEvent","_UnregisterFormulaChangedEvent"],["NameChanged",0,32,"MessageType.worksheetNameChangedEvent","this.id","_RegisterEventNameChanged","_UnregisterEventNameChanged"],["NavigationObjectChanged",0,3,"MessageType.worksheetNavigationObjectChangedEvent","this.id","_RegisterNavigationObjectChangedEvent","_UnregisterNavigationObjectChangedEvent"],["ProtectionChanged",0,19,"MessageType.worksheetProtectionChangedEvent","this.id","_RegisterProtectionChangedEvent","_UnregisterProtectionChangedEvent"],["RowHeightChanged",0,9,"MessageType.worksheetRowHeightChangedEvent","this.id","_RegisterEventRowHeightChanged","_UnregisterEventRowHeightChanged"],["RowHiddenChanged",0,8,"MessageType.worksheetRowHiddenChangedEvent","this.id","_RegisterRowHiddenChangedEvent","_UnregisterRowHiddenChangedEvent"],["RowSorted",0,18,"MessageType.worksheetRowSortedEvent","this.id","_RegisterRowSortedEvent","_UnregisterRowSortedEvent"],["SelectionChanged",0,12,"MessageType.worksheetSelectionChangedEvent","this.id","_RegisterSelectionChangedEvent","_UnregisterSelectionChangedEvent"],["SingleClicked",0,18,"MessageType.worksheetSingleClickedEvent","this.id","_RegisterSingleClickedEvent","_UnregisterSingleClickedEvent"],["VisibilityChanged",0,32,"MessageType.worksheetVisibilityChangedEvent","this.id","_RegisterEventVisibilityChanged","_UnregisterEventVisibilityChanged"]]],["WorksheetCollection",1,0,0,[["getCount",1,2,16,4],["_RegisterAddedEvent",0,3,12],["_UnregisterAddedEvent",0,3,12],["_RegisterActivatedEvent",0,3,12],["_UnregisterActivatedEvent",0,0,12,2,0,31],["_RegisterDeactivatedEvent",0,0,12,2,0,31],["_UnregisterDeactivatedEvent",0,0,12,2,0,31],["_RegisterDeletedEvent",0,3,12],["_UnregisterDeletedEvent",0,3,12],["_RegisterCalculatedEvent",0,0,6,2,0,1],["_UnregisterCalculatedEvent",0,0,6,2,0,1],["_RegisterDataChangedEvent",0,3,7],["_UnregisterDataChangedEvent",0,3,7],["_RegisterSelectionChangedEvent",0,0,7,2,0,31],["_UnregisterSelectionChangedEvent",0,0,7,2,0,31],["addFromBase64",4,0,9],["_RegisterFilteredEvent",0,0,9,2,0,1],["_UnregisterFilteredEvent",0,0,9,2,0,1],["_RegisterFormatChangedEvent",0,0,7,2,0,1],["_UnregisterFormatChangedEvent",0,0,7,2,0,1],["_RegisterRowSortedEvent",0,3,18],["_UnregisterRowSortedEvent",0,3,18],["_RegisterColumnSortedEvent",0,3,18],["_UnregisterColumnSortedEvent",0,3,18],["_RegisterSingleClickedEvent",0,0,18,2,0,31],["_UnregisterSingleClickedEvent",0,0,18,2,0,31],["_RegisterRowHiddenChangedEvent",0,0,8,2,0,1],["_UnregisterRowHiddenChangedEvent",0,0,8,2,0,1],["_RegisterFormulaChangedEvent",0,2,25],["_UnregisterFormulaChangedEvent",0,2,25],["_RegisterProtectionChangedEvent",0,2,19],["_UnregisterProtectionChangedEvent",0,2,19],["_RegisterEventNameChanged",0,2,32,4],["_RegisterEventVisibilityChanged",0,2,32,4],["_UnregisterEventNameChanged",0,2,32,4],["_UnregisterEventVisibilityChanged",0,2,32,4],["_RegisterEventMoved",0,0,32,2,0,1],["_UnregisterEventMoved",0,0,32,2,0,1],["_RegisterEventRowHeightChanged",0,2,9],["_UnregisterEventRowHeightChanged",0,2,9]],[["getItem","Worksheet",1,18,0,4],["add","Worksheet",1,8,0,2,0,0,31],["getActiveWorksheet","Worksheet",0,2,0,4],["getItemOrNullObject","Worksheet",1,2,16,4],["getFirst","Worksheet",1,10,17,4],["getLast","Worksheet",1,10,17,4]],0,"Worksheet",[["Activated",0,12,"MessageType.worksheetActivatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["Added",0,12,"MessageType.worksheetAddedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterAddedEvent","_UnregisterAddedEvent"],["Calculated",0,6,"MessageType.worksheetCalculatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterCalculatedEvent","_UnregisterCalculatedEvent"],["Changed",2,7,"MessageType.worksheetDataChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterDataChangedEvent","_UnregisterDataChangedEvent"],["ColumnSorted",0,18,"MessageType.worksheetColumnSortedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterColumnSortedEvent","_UnregisterColumnSortedEvent"],["Deactivated",0,12,"MessageType.worksheetDeactivatedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterDeactivatedEvent","_UnregisterDeactivatedEvent"],["Deleted",0,12,"MessageType.worksheetDeletedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterDeletedEvent","_UnregisterDeletedEvent"],["Filtered",0,9,"MessageType.worksheetFilteredEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterFilteredEvent","_UnregisterFilteredEvent"],["FormatChanged",2,7,"MessageType.worksheetFormatChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterFormatChangedEvent","_UnregisterFormatChangedEvent"],["FormulaChanged",2,25,"MessageType.worksheetFormulaChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterFormulaChangedEvent","_UnregisterFormulaChangedEvent"],["Moved",0,32,"MessageType.worksheetMovedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventMoved","_UnregisterEventMoved"],["NameChanged",0,32,"MessageType.worksheetNameChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventNameChanged","_UnregisterEventNameChanged"],["ProtectionChanged",0,19,"MessageType.worksheetProtectionChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterProtectionChangedEvent","_UnregisterProtectionChangedEvent"],["RowHeightChanged",0,9,"MessageType.worksheetRowHeightChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventRowHeightChanged","_UnregisterEventRowHeightChanged"],["RowHiddenChanged",0,8,"MessageType.worksheetRowHiddenChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterRowHiddenChangedEvent","_UnregisterRowHiddenChangedEvent"],["RowSorted",0,18,"MessageType.worksheetRowSortedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterRowSortedEvent","_UnregisterRowSortedEvent"],["SelectionChanged",0,7,"MessageType.worksheetSelectionChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterSelectionChangedEvent","_UnregisterSelectionChangedEvent"],["SingleClicked",0,18,"MessageType.worksheetSingleClickedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterSingleClickedEvent","_UnregisterSingleClickedEvent"],["VisibilityChanged",0,32,"MessageType.worksheetVisibilityChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventVisibilityChanged","_UnregisterEventVisibilityChanged"]]],["WorksheetProtection",0,[["protected",3],["options",3],["canPauseProtection",3,20],["isPasswordProtected",3,20],["isPaused",3,20],["savedOptions",3,20]],[["allowEditRanges","AllowEditRangeCollection",19,20,0,4]],[["protect",2,1],["unprotect",1],["checkPassword",1,2,20,4],["pauseProtection",1,0,20],["resumeProtection",0,0,20],["setPassword",1,0,20],["updateOptions",1,0,20]]],["WorksheetFreezePanes",0,0,0,[["unfreeze"],["freezeAt",1],["freezeRows",1],["freezeColumns",1]],[["getLocation","Range",0,10,0,4],["getLocationOrNullObject","Range",0,10,0,4]]],["Range",14,[["numberFormat",5,0,0,2,33],["numberFormatLocal",1,12,0,2,33],["values",5,0,0,2,33],["text",3],["formulas",5,0,0,2,34],["formulasLocal",5,0,0,2,34],["rowIndex",3],["columnIndex",3],["rowCount",3],["columnCount",3],["address",3],["addressLocal",3],["cellCount",3],["_ReferenceId",2],["valueTypes",3],["formulasR1C1",5,14],["hidden",3,14],["rowHidden",1,14,0,2,34],["columnHidden",1,14,0,2,34],["isEntireColumn",3,12],["isEntireRow",3,12],["hyperlink",1,12,0,2,35],["style",1,12,0,2,34],["linkedDataTypeState",3,7],["hasSpill",3,29],["top",3,18],["left",3,18],["height",3,18],["width",3,18],["savedAsArray",3,29],["numberFormatCategories",3,29],["valuesAsJson",5,26],["valuesAsJsonLocal",5,26],["addressR1C1",2,3]],[["format","RangeFormat",35,0,0,4],["worksheet","Worksheet",2,0,0,4],["sort","RangeSort",3,14,0,4],["conditionalFormats","ConditionalFormatCollection",19,10,0,4],["dataValidation","DataValidation",35,6,0,4]],[["clear",1,0,0,2,0,34],["delete",1,0,0,2,0,36],["select",0,2],["_KeepReference",0,2],["merge",1,0,14,2,0,34],["unmerge",0,0,14],["_ValidateArraySize",2,2,15,4],["calculate",0,0,10],["showCard",0,0,12],["getImage",0,2,12,4],["replaceAll",3,0,7,2,0,34],["copyFrom",4,0,7,2,0,28],["convertToLinkedDataType",2,0,7],["convertDataTypeToText",0,0,7],["setDirty",0,0,7],["getCellProperties",1,0,7],["getRowProperties",1,0,7],["getColumnProperties",1,0,7],["setCellProperties",1,0,7],["setRowProperties",1,0,7],["setColumnProperties",1,0,7],["autoFill",2,0,7,2,0,37],["showTeachingCallout",2,0,7],["flashFill",0,0,7],["group",1,0,18],["ungroup",1,0,18],["showGroupDetails",1,0,18],["hideGroupDetails",1,0,18],["moveTo",1,0,8,2,0,28],["getDataClassificationIds",0,2,20,4],["setExternalCodeServiceFormulasWithoutLicense",1,0,9,1],["getPythonObjectReferenceIds",0,0,9,1]],[["getCell","Range",2,10,0,4],["getUsedRange","Range",1,10,0,4],["insert","Range",1,8,0,2,0,0,36],["getEntireColumn","Range",0,10,0,4],["getEntireRow","Range",0,10,0,4],["getOffsetRange","Range",2,10,0,4],["getRow","Range",1,10,0,4],["getColumn","Range",1,10,0,4],["getIntersection","Range",1,10,0,4],["getBoundingRect","Range",1,10,0,4],["getLastCell","Range",0,10,0,4],["getLastColumn","Range",0,10,0,4],["getLastRow","Range",0,10,0,4],["getIntersectionOrNullObject","Range",1,10,16,4],["getRowsAbove","Range",1,11,15,4],["getRowsBelow","Range",1,11,15,4],["getColumnsBefore","Range",1,11,15,4],["getColumnsAfter","Range",1,11,15,4],["getResizedRange","Range",2,11,15,4],["getVisibleView","RangeView",0,2,15,4],["getUsedRangeOrNullObject","Range",1,10,16,4],["getSurroundingRegion","Range",0,10,12,4],["getAbsoluteResizedRange","Range",2,10,12,4],["getTables","TableScopedCollection",1,6,7,4],["find","Range",2,10,7,4],["findOrNullObject","Range",2,10,7,4],["removeDuplicates","RemoveDuplicatesResult",2,8,7,2,0,0,35],["getSpecialCells","RangeAreas",2,10,7,4],["getSpecialCellsOrNullObject","RangeAreas",2,10,7,4],["getSpillingToRange","Range",0,10,29,4],["getSpillParent","Range",0,10,29,4],["getSpillingToRangeOrNullObject","Range",0,10,29,4],["getSpillParentOrNullObject","Range",0,10,29,4],["getMergedAreas","RangeAreas",0,10,20,4],["getPivotTables","PivotTableScopedCollection",1,6,29,4],["getPrecedents","WorkbookRangeAreas",0,10,19,4],["getDirectPrecedents","WorkbookRangeAreas",0,10,29,4],["getDependents","WorkbookRangeAreas",0,10,38,4],["getDirectDependents","WorkbookRangeAreas",0,10,25,4],["getExtendedRange","Range",2,10,25,4],["getRangeEdge","Range",2,10,25,4],["getNumberFormatProperties","NumberFormatPropertyCollection",0,6,9,4],["getSurroundingDataRegion","Range",0,2,9,4],["getMergedAreasOrNullObject","RangeAreas",0,0,25,2,0,0,33]]],["RangeAreas",2,[["_ReferenceId",2],["address",3],["addressLocal",3],["areaCount",3],["cellCount",3],["isEntireColumn",3],["isEntireRow",3],["style",1],["addressR1C1",2,3]],[["areas","RangeCollection",19,0,0,4],["conditionalFormats","ConditionalFormatCollection",19,0,0,4],["format","RangeFormat",35,0,0,4],["dataValidation","DataValidation",35,0,0,4],["worksheet","Worksheet",2,0,0,4]],[["_KeepReference",0,2],["calculate"],["clear",1],["setDirty"],["copyFrom",4],["convertToLinkedDataType",2],["convertDataTypeToText"],["select",0,2,9]],[["getEntireColumn","RangeAreas",0,10,0,4],["getEntireRow","RangeAreas",0,10,0,4],["getIntersection","RangeAreas",1,10,0,4],["getIntersectionOrNullObject","RangeAreas",1,10,0,4],["getOffsetRangeAreas","RangeAreas",2,10,0,4],["getUsedRangeAreas","RangeAreas",1,10,0,4],["getUsedRangeAreasOrNullObject","RangeAreas",1,10,0,4],["getTables","TableScopedCollection",1,6,0,4],["getSpecialCells","RangeAreas",2,10,0,4],["getSpecialCellsOrNullObject","RangeAreas",2,10,0,4]]],["WorkbookRangeAreas",2,[["_ReferenceId",2],["addresses",3]],[["ranges","RangeCollection",19,0,0,4],["areas","RangeAreasCollection",19,0,0,4]],[["_KeepReference",0,2]],[["getRangeAreasBySheet","RangeAreas",1,10,0,4],["getRangeAreasOrNullObjectBySheet","RangeAreas",1,10,0,4]]],["RangeView",0,[["numberFormat",1],["values",1],["text",3],["formulas",1],["formulasLocal",1],["formulasR1C1",1],["valueTypes",3],["rowCount",3],["columnCount",3],["cellAddresses",3],["index",3],["valuesAsJson",1,26],["valuesAsJsonLocal",1,26]],[["rows","RangeViewCollection",19,0,0,4]],0,[["getRange","Range",0,10,0,4]]],["RangeViewCollection",1,0,0,[["getCount",0,2,16,4]],[["getItemAt","RangeView",1,2,0,4]],0,"RangeView"],["SettingCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","Setting",1,18,0,4],["add","Setting",2,9],["getItemOrNullObject","Setting",1,2,0,4]],0,"Setting",[["SettingsChanged",3,0,"_CC.office10EventIdSettingsChangedEvent","","",""]]],["Setting",8,[["key",3],["value",5],["_Id",2]],0,[["delete"]]],["NamedItemCollection",5,0,0,[["getCount",0,2,16,4],["_RegisterAddedEvent",0,0,3,2,0,1],["_RegisterDeletedEvent",0,0,3,2,0,1],["_UnregisterAddedEvent",0,0,3,2,0,1],["_UnregisterDeletedEvent",0,0,3,2,0,1]],[["getItem","NamedItem",1,18,0,4],["getItemOrNullObject","NamedItem",1,2,16,4],["add","NamedItem",3,8,16],["addFormulaLocal","NamedItem",3,0,16]],0,"NamedItem",[["Added",0,3,"MessageType.namedItemAddedEvent","this._eventTargetId","_RegisterAddedEvent","_UnregisterAddedEvent"],["Deleted",0,3,"MessageType.namedItemDeletedEvent","this._eventTargetId","_RegisterDeletedEvent","_UnregisterDeletedEvent"]]],["NamedItem",0,[["name",3],["type",3],["value",3],["visible",1],["_Id",2],["comment",1,16],["scope",3,16],["formula",1,12],["valueAsJson",3,26],["valueAsJsonLocal",3,26]],[["worksheet","Worksheet",2,16,0,4],["worksheetOrNullObject","Worksheet",2,16,0,4],["arrayValues","NamedItemArrayValues",3,12,0,4]],[["delete",0,0,16]],[["getRange","Range",0,10,0,4],["getRangeOrNullObject","Range",0,10,16,4]]],["NamedItemArrayValues",0,[["values",3],["types",3],["valuesAsJson",3,26],["valuesAsJsonLocal",3,26]]],["Binding",0,[["id",3],["type",3]],0,[["getText",0,2,0,4],["delete",0,0,15]],[["getTable","Table",0,2,0,4],["getRange","Range",0,2,0,4]],0,0,[["DataChanged",3,15,"_CC.office10EventIdBindingDataChangedEvent","this.id","",""],["SelectionChanged",3,15,"_CC.office10EventIdBindingSelectionChangedEvent","this.id","",""]]],["BindingCollection",1,[["count",3]],0,[["getCount",0,2,16,4]],[["getItem","Binding",1,18,0,4],["getItemAt","Binding",1,2,0,4],["add","Binding",3,8,15],["addFromNamedItem","Binding",3,0,15],["addFromSelection","Binding",2,0,15],["getItemOrNullObject","Binding",1,2,16,4]],0,"Binding"],["TableCollection",5,[["count",3]],0,[["getCount",0,2,16,4],["_RegisterDataChangedEvent",0,0,12,2,0,1],["_UnregisterDataChangedEvent",0,0,12,2,0,1],["_RegisterAddedEvent",0,0,7,2,0,1],["_UnregisterAddedEvent",0,0,7,2,0,1],["_RegisterDeletedEvent",0,0,7,2,0,1],["_UnregisterDeletedEvent",0,0,7,2,0,1],["_RegisterFilteredEvent",0,0,9,2,0,1],["_UnregisterFilteredEvent",0,0,9,2,0,1]],[["getItem","Table",1,18,0,4],["getItemAt","Table",1,2,0,4],["add","Table",2,8,0,2,0,0,35],["getItemOrNullObject","Table",1,2,16,4],["addQueryTable","Table",2,0,9]],0,"Table",[["Added",0,7,"MessageType.tableAddedEvent","this._eventTargetId","_RegisterAddedEvent","_UnregisterAddedEvent"],["Changed",2,12,"MessageType.tableDataChangedEvent","this._eventTargetId","_RegisterDataChangedEvent","_UnregisterDataChangedEvent"],["Deleted",0,7,"MessageType.tableDeletedEvent","this._eventTargetId","_RegisterDeletedEvent","_UnregisterDeletedEvent"],["Filtered",0,9,"MessageType.tableFilteredEvent","this._eventTargetId","_RegisterFilteredEvent","_UnregisterFilteredEvent"]]],["TableScopedCollection",1,0,0,[["getCount",0,2,0,4]],[["getFirst","Table",0,10,0,4],["getItem","Table",1,18,0,4],["getItemOrNullObject","Table",1,2,19,4]],0,"Table"],["Table",24,[["id",3],["name",1,0,0,2,28],["showHeaders",1,0,0,2,35],["showTotals",1,0,0,2,35],["style",1,0,0,2,35],["highlightFirstColumn",1,15,0,2,35],["highlightLastColumn",1,15,0,2,35],["showBandedRows",1,15,0,2,35],["showBandedColumns",1,15,0,2,35],["showFilterButton",1,15,0,2,35],["legacyId",3,6],["isMsFormConnected",0,9],["maxMsFormResponseId",0,9],["msFormId",0,9]],[["columns","TableColumnCollection",19,0,0,4],["rows","TableRowCollection",19,0,0,4],["sort","TableSort",3,14,0,4],["worksheet","Worksheet",2,14,0,4],["autoFilter","AutoFilter",3,7,0,4],["tableStyle","TableStyle",35,9,0,4]],[["delete",0,0,0,2,0,28],["clearFilters",0,0,14],["reapplyFilters",0,0,14,2,0,28],["_RegisterSelectionChangedEvent",0,0,12,2,0,1],["_UnregisterSelectionChangedEvent",0,0,12,2,0,1],["_RegisterDataChangedEvent",0,0,12,2,0,1],["_UnregisterDataChangedEvent",0,0,12,2,0,1],["clearStyle",0,0,9],["_RegisterFilteredEvent",0,0,9,2,0,1],["_UnregisterFilteredEvent",0,0,9,2,0,1],["resize",1,0,25,2,0,28],["setStyle",1,0,9],["applyPowerQueryTableUpdatePlan",1,0,3,2]],[["getRange","Range",0,10,0,4],["getHeaderRowRange","Range",0,10,0,4],["getDataBodyRange","Range",0,10,0,4],["getTotalRowRange","Range",0,10,0,4],["convertToRange","Range",0,8,14,2,0,0,28]],"workbook.tables",0,[["Changed",2,12,"MessageType.tableDataChangedEvent","this.id","_RegisterDataChangedEvent","_UnregisterDataChangedEvent"],["Filtered",0,9,"MessageType.tableFilteredEvent","this.id","_RegisterFilteredEvent","_UnregisterFilteredEvent"],["SelectionChanged",2,12,"MessageType.tableSelectionChangedEvent","this.id","_RegisterSelectionChangedEvent","_UnregisterSelectionChangedEvent"]]],["TableColumnCollection",1,[["count",3]],0,[["getCount",0,2,16,4]],[["getItem","TableColumn",1,18,0,4],["getItemAt","TableColumn",1,2,0,4],["add","TableColumn",3,8,0,2,0,0,36],["getItemOrNullObject","TableColumn",1,2,16,4],["addAsJson","TableColumn",3,0,26]],0,"TableColumn"],["TableColumn",0,[["id",3],["index",3],["values",1],["name",1],["valuesAsJson",1,26],["valuesAsJsonLocal",1,26],["msFormQuestionId",0,9]],[["filter","Filter",3,14,0,4]],[["delete",0,0,0,2,0,36]],[["getRange","Range",0,10,0,4],["getHeaderRowRange","Range",0,10,0,4],["getDataBodyRange","Range",0,10,0,4],["getTotalRowRange","Range",0,10,0,4]]],["TableRowCollection",1,[["count",3]],0,[["getCount",0,2,16,4],["deleteRows",1,0,20],["deleteRowsAt",2,0,20,2,0,28]],[["getItemAt","TableRow",1,2,0,4],["add","TableRow",3,8,0,2,0,0,36],["addAsJson","TableRow",3,0,26]],0,"TableRow"],["TableRow",0,[["index",3],["values",1],["valuesAsJson",1,26],["valuesAsJsonLocal",1,26]],0,[["delete",0,0,0,2,0,36]],[["getRange","Range",0,10,0,4]]],["DataValidation",0,[["type",3],["rule",1],["prompt",1],["errorAlert",1],["ignoreBlanks",1],["valid",3]],0,[["clear"]],[["getInvalidCells","RangeAreas",0,10,7,4],["getInvalidCellsOrNullObject","RangeAreas",0,10,7,4]]],["RemoveDuplicatesResult",0,[["removed",3],["uniqueRemaining",3]]],["RangeFormat",0,[["wrapText",1,0,0,2,34],["horizontalAlignment",1,0,0,2,34],["verticalAlignment",1,0,0,2,34],["columnWidth",1,14,0,2,34],["rowHeight",1,14,0,2,34],["textOrientation",1,12,0,2,34],["useStandardHeight",1,12],["useStandardWidth",1,12],["readingOrder",1,7],["shrinkToFit",1,7],["indentLevel",1,7,0,2,34],["autoIndent",1,7]],[["fill","RangeFill",35,0,0,4],["font","RangeFont",35,0,0,4],["borders","RangeBorderCollection",51,0,0,4],["protection","FormatProtection",35,14,0,4]],[["autofitColumns",0,0,14,2,0,34],["autofitRows",0,0,14,2,0,34],["adjustIndent",1,0,8,2,0,36]]],["FormatProtection",0,[["locked",1],["formulaHidden",1]]],["RangeFill",0,[["color",1,0,0,2,34],["tintAndShade",1,7],["patternTintAndShade",1,7],["pattern",1,7],["patternColor",1,7]],0,[["clear",0,0,0,2,0,34]]],["RangeBorder",0,[["sideIndex",3],["style",1,0,0,2,34],["weight",1,0,0,2,34],["color",1,0,0,2,34],["tintAndShade",1,7]]],["RangeBorderCollection",1,[["count",3],["tintAndShade",1,7]],0,0,[["getItem","RangeBorder",1,18,0,4],["getItemAt","RangeBorder",1,2,0,4]],0,"RangeBorder"],["RangeFont",0,[["name",1,0,0,2,34],["size",1,0,0,2,34],["color",1,0,0,2,13],["italic",1,0,0,2,34],["bold",1,0,0,2,34],["underline",1,0,0,2,34],["strikethrough",1,7,0,2,34],["subscript",1,7],["superscript",1,7],["tintAndShade",1,7]]],["ChartCollection",5,[["count",3]],0,[["getCount",0,2,16,4],["_RegisterAddedEvent",0,0,6,2,0,1],["_UnregisterAddedEvent",0,0,6,2,0,1],["_RegisterActivatedEvent",0,0,6,2,0,31],["_UnregisterActivatedEvent",0,0,6,2,0,31],["_RegisterDeactivatedEvent",0,0,6,2,0,31],["_UnregisterDeactivatedEvent",0,0,6,2,0,31],["_RegisterDeletedEvent",0,0,6,2,0,31],["_UnregisterDeletedEvent",0,0,6,2,0,31]],[["add","Chart",3,9,0,2,0,0,39],["getItemAt","Chart",1,2,0,4],["_GetItem","Chart",1,18,0,4],["getItem","Chart",1,2,0,4],["getItemOrNullObject","Chart",1,2,16,4]],0,"Chart",[["Activated",0,6,"MessageType.chartActivatedEvent","this._ParentObject.id","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["Added",0,6,"MessageType.chartAddedEvent","this._ParentObject.id","_RegisterAddedEvent","_UnregisterAddedEvent"],["Deactivated",0,6,"MessageType.chartDeactivatedEvent","this._ParentObject.id","_RegisterDeactivatedEvent","_UnregisterDeactivatedEvent"],["Deleted",0,6,"MessageType.chartDeletedEvent","this._ParentObject.id","_RegisterDeletedEvent","_UnregisterDeletedEvent"]]],["Chart",0,[["name",1,0,0,2,37],["top",1,0,0,2,39],["left",1,0,0,2,39],["width",1,0,0,2,39],["height",1,0,0,2,39],["id",3,12],["showAllFieldButtons",1,12,0,2,39],["chartType",1,12,0,2,37],["showDataLabelsOverMaximum",1,6,0,2,40],["categoryLabelLevel",1,6,0,2,40],["style",1,6,0,2,40],["displayBlanksAs",1,6,0,2,40],["plotBy",1,6,0,2,37],["plotVisibleOnly",1,6,0,2,40],["seriesNameLevel",1,6,0,2,40]],[["title","ChartTitle",35,0,0,4],["dataLabels","ChartDataLabels",35,0,0,4],["legend","ChartLegend",35,0,0,4],["series","ChartSeriesCollection",19,0,0,4],["axes","ChartAxes",35,0,0,4],["format","ChartAreaFormat",35,0,0,4],["worksheet","Worksheet",2,14,0,4],["plotArea","ChartPlotArea",35,6,0,4],["pivotOptions","ChartPivotOptions",35,7,0,4]],[["setData",2,1,0,2,0,39],["delete",0,0,0,2,0,39],["setPosition",2,0,0,2,0,39],["getImage",3,2,14,4],["_RegisterActivatedEvent",0,0,6,2,0,1],["_UnregisterActivatedEvent",0,0,6,2,0,1],["_RegisterDeactivatedEvent",0,0,6,2,0,1],["_UnregisterDeactivatedEvent",0,0,6,2,0,1],["activate",0,2,7],["getDataRange",0,0,30],["getDataRangeOrNullObject",0,0,30]],[["getDataTable","ChartDataTable",0,2,19,4],["getDataTableOrNullObject","ChartDataTable",0,2,19,4]],0,0,[["Activated",0,6,"MessageType.chartActivatedEvent","this.id","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["Deactivated",0,6,"MessageType.chartDeactivatedEvent","this.id","_RegisterDeactivatedEvent","_UnregisterDeactivatedEvent"]]],["ChartPivotOptions",0,[["showAxisFieldButtons",1,0,0,2,40],["showLegendFieldButtons",1,0,0,2,40],["showReportFilterFieldButtons",1,0,0,2,40],["showValueFieldButtons",1,0,0,2,40]]],["ChartAreaFormat",0,[["roundedCorners",1,7,0,2,37],["colorScheme",1,7,0,2,40]],[["fill","ChartFill",3,0,0,4],["font","ChartFont",35,0,0,4],["border","ChartBorder",35,12,0,4]]],["ChartSeriesCollection",1,[["count",3]],0,[["getCount",0,2,16,4]],[["getItemAt","ChartSeries",1,2,0,4],["add","ChartSeries",2,8,12,2,0,0,39]],0,"ChartSeries"],["ChartSeries",0,[["name",1,0,0,2,39],["chartType",1,12,0,2,11],["hasDataLabels",1,12,0,2,37],["filtered",1,12,0,2,40],["markerSize",1,12,0,2,39],["markerStyle",1,12,0,2,39],["showShadow",1,12,0,2,37],["markerBackgroundColor",1,12,0,2,39],["markerForegroundColor",1,12,0,2,39],["smooth",1,12,0,2,37],["plotOrder",1,12,0,2,37],["gapWidth",1,12,0,2,39],["doughnutHoleSize",1,12,0,2,39],["axisGroup",1,6,0,2,39],["explosion",1,6,0,2,37],["firstSliceAngle",1,6,0,2,37],["invertIfNegative",1,6,0,2,37],["bubbleScale",1,7,0,2,37],["secondPlotSize",1,6,0,2,37],["splitType",1,6,0,2,37],["splitValue",1,7,0,2,37],["varyByCategories",1,6,0,2,37],["showLeaderLines",1,7,0,2,40],["overlap",1,6,0,2,39],["gradientStyle",1,7,0,2,40],["gradientMinimumType",1,7,0,2,40],["gradientMidpointType",1,7,0,2,40],["gradientMaximumType",1,7,0,2,40],["gradientMinimumValue",1,7,0,2,40],["gradientMidpointValue",1,7,0,2,40],["gradientMaximumValue",1,7,0,2,40],["gradientMinimumColor",1,7,0,2,40],["gradientMidpointColor",1,7,0,2,40],["gradientMaximumColor",1,7,0,2,40],["parentLabelStrategy",1,7,0,2,37],["showConnectorLines",1,7,0,2,37],["invertColor",1,7,0,2,37]],[["points","ChartPointsCollection",19,0,0,4],["format","ChartSeriesFormat",35,0,0,4],["trendlines","ChartTrendlineCollection",19,12,0,4],["xErrorBars","ChartErrorBars",35,7,0,4],["yErrorBars","ChartErrorBars",35,7,0,4],["dataLabels","ChartDataLabels",35,6,0,4],["binOptions","ChartBinOptions",35,7,0,4],["mapOptions","ChartMapOptions",35,7,0,4],["boxwhiskerOptions","ChartBoxwhiskerOptions",35,7,0,4]],[["delete",0,0,12,2,0,39],["setXAxisValues",1,0,12,2,0,39],["setValues",1,0,12,2,0,39],["setBubbleSizes",1,0,12,2,0,40],["getDimensionValues",1,0,29,2,0,40],["getDimensionDataSourceString",1,0,38],["getDimensionDataSourceType",1,0,38]]],["ChartSeriesFormat",0,0,[["fill","ChartFill",3,0,0,4],["line","ChartLineFormat",35,0,0,4]]],["ChartPointsCollection",1,[["count",3]],0,[["getCount",0,2,16,4]],[["getItemAt","ChartPoint",1,2,0,4]],0,"ChartPoint"],["ChartPoint",0,[["value",3],["hasDataLabel",1,12,0,2,37],["markerStyle",1,12,0,2,39],["markerSize",1,12,0,2,39],["markerBackgroundColor",1,12,0,2,39],["markerForegroundColor",1,12,0,2,39]],[["format","ChartPointFormat",35,0,0,4],["dataLabel","ChartDataLabel",35,12,0,4]]],["ChartPointFormat",0,0,[["fill","ChartFill",3,0,0,4],["border","ChartBorder",35,12,0,4]]],["ChartAxes",0,0,[["categoryAxis","ChartAxis",35,0,0,4],["seriesAxis","ChartAxis",35,0,0,4],["valueAxis","ChartAxis",35,0,0,4]],0,[["getItem","ChartAxis",2,2,12,4]]],["ChartAxis",0,[["majorUnit",1,0,0,2,37],["maximum",1,0,0,2,39],["minimum",1,0,0,2,39],["minorUnit",1,0,0,2,37],["displayUnit",1,12,0,2,39],["showDisplayUnitLabel",1,12,0,2,37],["customDisplayUnit",3,12],["type",3,12],["minorTimeUnitScale",1,12,0,2,37],["majorTimeUnitScale",1,12,0,2,37],["baseTimeUnit",1,12,0,2,37],["categoryType",1,12,0,2,37],["axisGroup",3,12],["scaleType",1,12,0,2,37],["logBase",1,12,0,2,37],["left",3,12],["top",3,12],["height",3,12],["width",3,12],["reversePlotOrder",1,12,0,2,39],["crosses",1,12,0,2,39],["crossesAt",3,12],["visible",1,12,0,2,37],["isBetweenCategories",1,6,0,2,39],["majorTickMark",1,12,0,2,37],["minorTickMark",1,12,0,2,37],["tickMarkSpacing",1,12,0,2,37],["tickLabelPosition",1,12,0,2,39],["tickLabelSpacing",1,12,0,2,37],["alignment",1,6,0,2,37],["multiLevel",1,6,0,2,37],["numberFormat",1,6,0,2,37],["linkNumberFormat",1,7,0,2,37],["offset",1,6,0,2,37],["textOrientation",1,6,0,2,37],["position",1,6,0,2,39],["positionAt",3,6]],[["majorGridlines","ChartGridlines",35,0,0,4],["minorGridlines","ChartGridlines",35,0,0,4],["title","ChartAxisTitle",35,0,0,4],["format","ChartAxisFormat",35,0,0,4]],[["setCategoryNames",1,0,12,2,0,40],["setCustomDisplayUnit",1,0,12,2,0,40],["setCrossesAt",1,0,12,2,0,37],["setPositionAt",1,0,6,2,0,37]]],["ChartAxisFormat",0,0,[["font","ChartFont",35,0,0,4],["line","ChartLineFormat",35,0,0,4],["fill","ChartFill",3,6,0,4]]],["ChartAxisTitle",0,[["text",1,0,0,2,39],["visible",1,0,0,2,37],["textOrientation",1,29,0,2,37]],[["format","ChartAxisTitleFormat",35,0,0,4]],[["setFormula",1,0,6,2,0,37]]],["ChartAxisTitleFormat",0,0,[["font","ChartFont",35,0,0,4],["fill","ChartFill",3,6,0,4],["border","ChartBorder",35,6,0,4]]],["ChartDataLabels",0,[["position",1,0,0,2,37],["showValue",1,0,0,2,37],["showSeriesName",1,0,0,2,40],["showCategoryName",1,0,0,2,37],["showLegendKey",1,0,0,2,37],["showPercentage",1,0,0,2,37],["showBubbleSize",1,0,0,2,37],["separator",1,0,0,2,37],["numberFormat",1,6,0,2,37],["linkNumberFormat",1,7,0,2,37],["textOrientation",1,6,0,2,37],["autoText",1,6,0,2,37],["horizontalAlignment",1,6,0,2,37],["verticalAlignment",1,6,0,2,37],["showAsDataCallout",3,21,0,2,40],["geometricShapeType",1,21,0,2,40]],[["format","ChartDataLabelFormat",35,0,0,4]]],["ChartDataLabel",0,[["position",1,0,0,2,37],["showValue",1,0,0,2,37],["showSeriesName",1,0,0,2,37],["showCategoryName",1,0,0,2,37],["showLegendKey",1,0,0,2,37],["showPercentage",1,0,0,2,37],["showBubbleSize",1,0,0,2,37],["separator",1,0,0,2,37],["top",1,6,0,2,37],["left",1,6,0,2,37],["width",3,6],["height",3,6],["formula",1,6,0,2,37],["textOrientation",1,6,0,2,37],["horizontalAlignment",1,6,0,2,37],["verticalAlignment",1,6,0,2,37],["text",1,6,0,2,37],["autoText",1,6,0,2,37],["numberFormat",1,6,0,2,37],["linkNumberFormat",1,7,0,2,37],["geometricShapeType",1,21,0,2,40],["showAsDataCallout",3,21,0,2,40]],[["format","ChartDataLabelFormat",35,6,0,4]],0,[["getSubstring","ChartFormatString",2,2,21,4]]],["ChartDataLabelFormat",0,0,[["font","ChartFont",35,0,0,4],["fill","ChartFill",3,0,0,4],["border","ChartBorder",35,6,0,4]]],["ChartDataTable",0,[["visible",1,0,0,2,37],["showLegendKey",1,0,0,2,37],["showHorizontalBorder",1,0,0,2,37],["showVerticalBorder",1,0,0,2,37],["showOutlineBorder",1,0,0,2,37]],[["format","ChartDataTableFormat",35,0,0,4]]],["ChartDataTableFormat",0,0,[["fill","ChartFill",3,0,0,4],["font","ChartFont",35,0,0,4],["border","ChartBorder",35,0,0,4]]],["ChartErrorBars",0,[["endStyleCap",1,0,0,2,37],["include",1,0,0,2,37],["type",1,0,0,2,37],["visible",1,0,0,2,37]],[["format","ChartErrorBarsFormat",35,0,0,4]]],["ChartErrorBarsFormat",0,0,[["line","ChartLineFormat",35,0,0,4]]],["ChartGridlines",0,[["visible",1,0,0,2,39]],[["format","ChartGridlinesFormat",35,0,0,4]]],["ChartGridlinesFormat",0,0,[["line","ChartLineFormat",35,0,0,4]]],["ChartLegend",0,[["visible",1,0,0,2,39],["position",1,0,0,2,39],["overlay",1,0,0,2,37],["left",1,12,0,2,37],["top",1,12,0,2,37],["width",1,12,0,2,37],["height",1,12,0,2,37],["showShadow",1,12,0,2,37]],[["format","ChartLegendFormat",35,0,0,4],["legendEntries","ChartLegendEntryCollection",19,12,0,4]]],["ChartLegendEntry",0,[["visible",1,0,0,2,37],["left",3,6],["top",3,6],["width",3,6],["height",3,6],["index",3,6]]],["ChartLegendEntryCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","ChartLegendEntry",1,2,0,4]],0,"ChartLegendEntry"],["ChartLegendFormat",0,0,[["font","ChartFont",35,0,0,4],["fill","ChartFill",3,0,0,4],["border","ChartBorder",35,6,0,4]]],["ChartMapOptions",0,[["level",1,0,0,2,40],["labelStrategy",1,0,0,2,40],["projectionType",1,0,0,2,40]]],["ChartTitle",0,[["visible",1,0,0,2,37],["text",1,0,0,2,39],["overlay",1,0,0,2,37],["horizontalAlignment",1,12,0,2,37],["top",1,12,0,2,37],["left",1,12,0,2,37],["width",3,12],["height",3,12],["verticalAlignment",1,12,0,2,37],["textOrientation",1,12,0,2,37],["position",1,12,0,2,37],["showShadow",1,12,0,2,37]],[["format","ChartTitleFormat",35,0,0,4]],[["setFormula",1,0,12,2,0,37]],[["getSubstring","ChartFormatString",2,2,12,4]]],["ChartFormatString",0,0,[["font","ChartFont",35,0,0,4]]],["ChartTitleFormat",0,0,[["font","ChartFont",35,0,0,4],["fill","ChartFill",3,0,0,4],["border","ChartBorder",35,12,0,4]]],["ChartFill",4,0,0,[["setSolidColor",1,0,0,2,0,39],["clear",0,0,0,2,0,37],["getSolidColor",0,0,26,2,0,39]]],["ChartBorder",0,[["color",1,0,0,2,39],["lineStyle",1,0,0,2,39],["weight",1,0,0,2,39]],0,[["clear",0,0,6,2,0,37]]],["ChartBinOptions",0,[["type",1,0,0,2,39],["width",1,0,0,2,39],["count",1,0,0,2,39],["allowOverflow",1,0,0,2,39],["allowUnderflow",1,0,0,2,39],["overflowValue",1,0,0,2,39],["underflowValue",1,0,0,2,39]]],["ChartBoxwhiskerOptions",0,[["showInnerPoints",1,0,0,2,37],["showOutlierPoints",1,0,0,2,37],["showMeanMarker",1,0,0,2,37],["showMeanLine",1,0,0,2,37],["quartileCalculation",1,0,0,2,37]]],["ChartLineFormat",0,[["color",1,0,0,2,39],["lineStyle",1,12,0,2,39],["weight",1,12,0,2,39]],0,[["clear",0,0,0,2,0,37]]],["ChartFont",0,[["bold",1,0,0,2,37],["color",1,0,0,2,39],["italic",1,0,0,2,37],["name",1,0,0,2,37],["size",1,0,0,2,37],["underline",1,0,0,2,37]]],["ChartTrendline",0,[["type",1,0,0,2,37],["polynomialOrder",1,0,0,2,37],["movingAveragePeriod",1,0,0,2,37],["_Id",2],["showEquation",1,6,0,2,37],["showRSquared",1,6,0,2,37],["forwardPeriod",1,6,0,2,37],["backwardPeriod",1,6,0,2,37],["name",1,0,0,2,37],["intercept",1,0,0,2,37]],[["format","ChartTrendlineFormat",35,0,0,4],["label","ChartTrendlineLabel",35,6,0,4]],[["delete",0,0,0,2,0,37]]],["ChartTrendlineCollection",1,0,0,[["getCount",0,2,0,4]],[["add","ChartTrendline",1,8,0,2,0,0,39],["getItem","ChartTrendline",1,18,0,4]],0,"ChartTrendline"],["ChartTrendlineFormat",0,0,[["line","ChartLineFormat",35,0,0,4]]],["ChartTrendlineLabel",0,[["top",1,0,0,2,37],["left",1,0,0,2,37],["width",3],["height",3],["formula",1,0,0,2,40],["textOrientation",1,0,0,2,37],["horizontalAlignment",1,0,0,2,37],["verticalAlignment",1,0,0,2,37],["text",1,0,0,2,40],["autoText",1,0,0,2,37],["numberFormat",1,0,0,2,37],["linkNumberFormat",1,7,0,2,37]],[["format","ChartTrendlineLabelFormat",35,0,0,4]]],["ChartTrendlineLabelFormat",0,0,[["fill","ChartFill",3,0,0,4],["border","ChartBorder",35,0,0,4],["font","ChartFont",35,0,0,4]]],["ChartPlotArea",0,[["left",1,0,0,2,37],["top",1,0,0,2,37],["width",1,0,0,2,37],["height",1,0,0,2,37],["insideLeft",1,0,0,2,37],["insideTop",1,0,0,2,37],["insideWidth",1,0,0,2,37],["insideHeight",1,0,0,2,37],["position",1,0,0,2,37]],[["format","ChartPlotAreaFormat",35,0,0,4]]],["ChartPlotAreaFormat",0,0,[["border","ChartBorder",35,0,0,4],["fill","ChartFill",3,0,0,4]]],["VisualCollection",5,0,0,[["getDefinitions",0,2,0,4],["getPreview",4,2,0,4],["bootstrapAgaveVisual",0,0,0,2],["getCount",0,2,0,4],["_RegisterSelectionChangedEvent",0,2],["_UnregisterSelectionChangedEvent",0,2]],[["add","Visual",3,8,0,2],["_GetItem","Visual",1,18,0,4],["getSelectedOrNullObject","Visual",0,2,0,4]],0,"Visual",[["AgaveVisualUpdate",2,0,"MessageType.agaveVisualUpdateEvent","","null","null"],["SelectionChanged",0,0,"MessageType.visualSelectionChangedEvent","this._ParentObject.id","_RegisterSelectionChangedEvent","_UnregisterSelectionChangedEvent"]]],["Visual",0,[["id",3],["isSupportedInVisualTaskpane",3]],[["properties","VisualPropertyCollection",18,0,0,4]],[["delete",0,0,0,2],["getProperty",1,2,0,4],["setProperty",2,0,0,2],["changeDataSource",2,0,0,2],["getDataSource",0,2,0,4],["setPropertyToDefault",1,0,0,2],["_RegisterChangeEvent",0,2],["_UnregisterChangeEvent",0,2],["serializeProperties",0,2,0,4],["deserializeProperties",1,0,0,2],["addChildProperty",2,0,20,2],["removeChildProperty",2,0,20,2],["getDataFieldAssignments",0,0,3],["getDataConfig",0,2,3,4],["modifyDataConfig",1,0,3,2]],[["getChildProperties","VisualPropertyCollection",2,6,0,4],["getDataControllerClient","DataControllerClient",0,2,0,4],["getElementChildProperties","VisualPropertyCollection",3,6,0,4]],0,0,[["ChangeNotification",2,0,"MessageType.visualChangeEvent","this.id","_RegisterChangeEvent","_UnregisterChangeEvent"]]],["VisualProperty",0,[["type",3],["value",3],["id",3],["localizedName",3],["options",3],["localizedOptions",3],["hasDefault",3],["isDefault",3],["min",3],["max",3],["stepSize",3],["hideMeButShowChildrenUI",3],["expandableUI",3],["nextPropOnSameLine",3],["showResetUI",3],["size",3,20],["minSize",3,20],["maxSize",3,20],["index",3,20],["parentName",3,20]],0,[["getBoolMetaProperty",1,2,0,4]]],["VisualPropertyCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","VisualProperty",1,18,0,4],["getItemAt","VisualProperty",1,2,0,4]],0,"VisualProperty"],["DataControllerClient",0,0,0,[["getWells",0,2,0,4],["getAssociatedFields",1,2,0,4],["getAvailableFields",1,2,0,4],["addField",3,0,0,2],["removeField",2,0,0,2],["moveField",3,0,0,2]]],["RangeSort",0,0,0,[["apply",5,0,0,2,0,34]]],["TableSort",0,[["matchCase",3],["method",3],["fields",3]],0,[["apply",3,0,0,2,0,28],["clear"],["reapply"]]],["Filter",0,[["criteria",3]],0,[["apply",1],["clear",0,0,0,2,0,36],["applyBottomItemsFilter",1,0,0,2,0,36],["applyBottomPercentFilter",1,0,0,2,0,36],["applyCellColorFilter",1,0,0,2,0,36],["applyDynamicFilter",1,0,0,2,0,36],["applyFontColorFilter",1,0,0,2,0,36],["applyValuesFilter",1,0,0,2,0,36],["applyTopItemsFilter",1,0,0,2,0,36],["applyTopPercentFilter",1,0,0,2,0,36],["applyIconFilter",1,0,0,2,0,36],["applyCustomFilter",3,0,0,2,0,36]]],["AutoFilter",0,[["enabled",3],["isDataFiltered",3],["criteria",3]],0,[["apply",3,0,0,2,0,35],["reapply",0,0,0,2,0,28],["remove",0,0,0,2,0,28],["clearCriteria",0,0,0,2,0,28],["clearColumnCriteria",1,0,19]],[["getRange","Range",0,10,0,4],["getRangeOrNullObject","Range",0,10,0,4]]],["CultureInfo",0,[["name",3]],[["numberFormat","NumberFormatInfo",3,0,0,4],["datetimeFormat","DatetimeFormatInfo",3,29,0,4]]],["NumberFormatInfo",0,[["numberDecimalSeparator",3],["numberGroupSeparator",3],["currencySymbol",3,32]]],["DatetimeFormatInfo",0,[["dateSeparator",3],["longDatePattern",3],["shortDatePattern",3],["timeSeparator",3],["longTimePattern",3]]],["CustomXmlPartScopedCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","CustomXmlPart",1,18,0,4],["getItemOrNullObject","CustomXmlPart",1,2,0,4],["getOnlyItem","CustomXmlPart",0,2,0,4],["getOnlyItemOrNullObject","CustomXmlPart",0,2,0,4]],0,"CustomXmlPart"],["CustomXmlPartCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","CustomXmlPart",1,18,0,4],["add","CustomXmlPart",1,8],["getByNamespace","CustomXmlPartScopedCollection",1,6,0,4],["getItemOrNullObject","CustomXmlPart",1,2,0,4]],0,"CustomXmlPart"],["CustomXmlPart",0,[["id",3],["namespaceUri",3]],0,[["delete"],["getXml",0,2,0,4],["setXml",1]]],["_V1Api",0,0,0,[["bindingGetData",1,2,0,4],["getSelectedData",1,2,0,4],["gotoById",1,2,0,4],["bindingAddFromSelection",1,2],["bindingGetById",1,2,0,4],["bindingReleaseById",1,2],["bindingGetAll",0,2,0,4],["bindingAddFromNamedItem",1,2],["bindingAddFromPrompt",1,2],["bindingDeleteAllDataValues",1],["setSelectedData",1],["bindingClearFormats",1],["bindingSetData",1],["bindingSetFormats",1],["bindingSetTableOptions",1],["bindingAddRows",1],["bindingAddColumns",1],["getFilePropertiesAsync",0,2,10,4]]],["PivotTableScopedCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","PivotTable",1,18,0,4],["getFirst","PivotTable",0,10,0,4],["getItemOrNullObject","PivotTable",1,2,0,4],["getFirstOrNullObject","PivotTable",0,2,38,4]],0,"PivotTable"],["PivotTableCollection",5,0,0,[["refreshAll",0,0,0,2,0,13],["getCount",0,2,16,4],["_RegisterAddedEvent",0,0,3,2,0,1],["_RegisterDeletedEvent",0,0,3,2,0,1],["_UnregisterAddedEvent",0,0,3,2,0,1],["_UnregisterDeletedEvent",0,0,3,2,0,1]],[["getItem","PivotTable",1,18,0,4],["getItemOrNullObject","PivotTable",1,2,16,4],["add","PivotTable",3,8,6,2,0,0,13]],0,"PivotTable",[["Added",0,3,"MessageType.pivotTableAddedEvent","this._eventTargetId","_RegisterAddedEvent","_UnregisterAddedEvent"],["Deleted",0,3,"MessageType.pivotTableDeletedEvent","this._eventTargetId","_RegisterDeletedEvent","_UnregisterDeletedEvent"]]],["PivotTable",0,[["name",1,0,0,2,13],["id",3,17],["useCustomSortLists",1,7,0,2,13],["enableDataValueEditing",1,7,0,2,13],["refreshOnOpen",0,25,0,2,31],["allowMultipleFiltersPerField",0,29,0,2,13]],[["worksheet","Worksheet",2,0,0,4],["hierarchies","PivotHierarchyCollection",19,6,0,4],["rowHierarchies","RowColumnPivotHierarchyCollection",19,6,0,4],["columnHierarchies","RowColumnPivotHierarchyCollection",19,6,0,4],["dataHierarchies","DataPivotHierarchyCollection",19,6,0,4],["filterHierarchies","FilterPivotHierarchyCollection",19,6,0,4],["layout","PivotLayout",2,6,0,4]],[["refresh",0,0,0,2,0,13],["delete",0,0,6,2,0,13],["getDataSourceString",0,2,38,4],["getDataSourceType",0,2,38,4]],[["addDateGroup","PivotHierarchy",2,0,9,2,0,0,41]]],["PivotLayout",0,[["showColumnGrandTotals",1,0,0,2,13],["showRowGrandTotals",1,0,0,2,13],["enableFieldList",1,18,0,2,13],["subtotalLocation",1,0,0,2,13],["layoutType",1,0,0,2,13],["autoFormat",1,7,0,2,13],["preserveFormatting",1,7,0,2,13],["altTextDescription",0,25,0,2,31],["altTextTitle",0,25,0,2,31],["emptyCellText",0,25,0,2,31],["fillEmptyCells",0,25,0,2,31],["showFieldHeaders",0,25,0,2,31],["tabularValues",3,9],["tabularText",3,9],["tabularNumberFormat",3,9],["tabularNumberFormatLocal",3,9]],[["pivotStyle","PivotTableStyle",35,9,0,4]],[["setAutoSortOnCell",2,0,7,2,0,13],["setStyle",1,0,9,2,0,13],["displayBlankLineAfterEachItem",1,0,25,2,0,31],["repeatAllItemLabels",1,0,25,2,0,31]],[["getRange","Range",0,3],["getRowLabelRange","Range",0,3],["getColumnLabelRange","Range",0,3],["getFilterAxisRange","Range",0,3],["getDataBodyRange","Range",0,3],["getCell","Range",3,2,9],["getPivotItems","PivotItemCollection",2,4,7],["getDataHierarchy","DataPivotHierarchy",1,3,7]]],["PivotHierarchyCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","PivotHierarchy",1,18,0,4],["getItemOrNullObject","PivotHierarchy",1,2,0,4]],0,"PivotHierarchy"],["PivotHierarchy",0,[["id",3],["name",1,0,0,2,13]],[["fields","PivotFieldCollection",19,0,0,4]]],["RowColumnPivotHierarchyCollection",1,0,0,[["getCount",0,2,0,4],["remove",1,0,0,2,0,13]],[["getItem","RowColumnPivotHierarchy",1,18,0,4],["getItemOrNullObject","RowColumnPivotHierarchy",1,2,0,4],["add","RowColumnPivotHierarchy",1,8,0,2,0,0,13]],0,"RowColumnPivotHierarchy"],["RowColumnPivotHierarchy",0,[["id",3],["name",1,0,0,2,13],["position",1,0,0,2,13]],[["fields","PivotFieldCollection",19,0,0,4]],[["setToDefault",0,0,0,2,0,13]]],["FilterPivotHierarchyCollection",1,0,0,[["getCount",0,2,0,4],["remove",1,0,0,2,0,13]],[["getItem","FilterPivotHierarchy",1,18,0,4],["getItemOrNullObject","FilterPivotHierarchy",1,2,0,4],["add","FilterPivotHierarchy",1,8,0,2,0,0,13]],0,"FilterPivotHierarchy"],["FilterPivotHierarchy",0,[["id",3],["name",1,0,0,2,13],["position",1,0,0,2,13],["enableMultipleFilterItems",1,0,0,2,13]],[["fields","PivotFieldCollection",19,0,0,4]],[["setToDefault",0,0,0,2,0,13]]],["DataPivotHierarchyCollection",1,0,0,[["getCount",0,2,0,4],["remove",1,0,0,2,0,13]],[["getItem","DataPivotHierarchy",1,18,0,4],["getItemOrNullObject","DataPivotHierarchy",1,2,0,4],["add","DataPivotHierarchy",1,8,0,2,0,0,13]],0,"DataPivotHierarchy"],["DataPivotHierarchy",0,[["id",3],["name",1,0,0,2,13],["position",1,0,0,2,13],["numberFormat",1,0,0,2,13],["summarizeBy",1,0,0,2,13],["showAs",1,0,0,2,13]],[["field","PivotField",35,0,0,4]],[["setToDefault",0,0,0,2,0,13]]],["PivotFieldCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","PivotField",1,18,0,4],["getItemOrNullObject","PivotField",1,2,0,4]],0,"PivotField"],["PivotField",0,[["id",3],["name",1,0,0,2,13],["subtotals",1,0,0,2,13],["showAllItems",1,0,0,2,13]],[["items","PivotItemCollection",19,0,0,4]],[["sortByLabels",1,1,0,2,0,13],["sortByValues",3,0,7,2,0,13],["applyFilter",1,0,29,2,0,13],["clearAllFilters",0,0,29,2,0,13],["clearFilter",1,0,29,2,0,13],["getFilters",0,0,29],["isFiltered",1,0,29]]],["PivotItemCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","PivotItem",1,18,0,4],["getItemOrNullObject","PivotItem",1,2,0,4]],0,"PivotItem"],["PivotItem",0,[["id",3],["name",1,0,0,2,13],["isExpanded",1,0,0,2,13],["visible",1,0,0,2,13]]],["WorksheetCustomProperty",0,[["key",3],["value",1],["_Id",2]],0,[["delete"]]],["WorksheetCustomPropertyCollection",1,0,0,[["getCount",0,2,0,4]],[["getItem","WorksheetCustomProperty",1,18,0,4],["getItemOrNullObject","WorksheetCustomProperty",1],["add","WorksheetCustomProperty",2,8]],0,"WorksheetCustomProperty"],["DocumentProperties",0,[["title",1],["subject",1],["author",1],["keywords",1],["comments",1],["lastAuthor",3],["revisionNumber",1],["creationDate",11],["category",1],["manager",1],["company",1]],[["custom","CustomPropertyCollection",19,0,0,4]]],["CustomProperty",0,[["key",3],["value",1],["type",3]],0,[["delete"]]],["CustomPropertyCollection",1,0,0,[["getCount",0,2,0,4],["deleteAll"]],[["getItemOrNullObject","CustomProperty",1,2,0,4],["add","CustomProperty",2,8],["getItem","CustomProperty",1,18,0,4]],0,"CustomProperty"],["ConditionalFormatCollection",1,0,0,[["getCount",0,2,0,4],["clearAll",0,0,0,2,0,42]],[["getItemAt","ConditionalFormat",1,2,0,4],["add","ConditionalFormat",1,8,0,2,0,0,42],["getItem","ConditionalFormat",1,18,0,4],["getItemOrNullObject","ConditionalFormat",1,2,19,4]],0,"ConditionalFormat"],["ConditionalFormat",0,[["stopIfTrue",1],["priority",1,0,0,2,43],["type",3],["id",3]],[["dataBarOrNullObject","DataBarConditionalFormat",35,0,0,4],["dataBar","DataBarConditionalFormat",35,0,0,4],["customOrNullObject","CustomConditionalFormat",35,0,0,4],["custom","CustomConditionalFormat",35,0,0,4],["iconSet","IconSetConditionalFormat",35,0,0,4],["iconSetOrNullObject","IconSetConditionalFormat",35,0,0,4],["colorScale","ColorScaleConditionalFormat",35,0,0,4],["colorScaleOrNullObject","ColorScaleConditionalFormat",35,0,0,4],["topBottom","TopBottomConditionalFormat",35,0,0,4],["topBottomOrNullObject","TopBottomConditionalFormat",35,0,0,4],["preset","PresetCriteriaConditionalFormat",35,0,0,4],["presetOrNullObject","PresetCriteriaConditionalFormat",35,0,0,4],["textComparison","TextConditionalFormat",35,0,0,4],["textComparisonOrNullObject","TextConditionalFormat",35,0,0,4],["cellValue","CellValueConditionalFormat",35,0,0,4],["cellValueOrNullObject","CellValueConditionalFormat",35,0,0,4]],[["delete",0,0,0,2,0,44],["changeRuleToCellValue",1,0,32],["changeRuleToColorScale",0,0,32],["changeRuleToContainsText",1,0,32],["changeRuleToCustom",1,0,32],["changeRuleToDataBar",0,0,32],["changeRuleToIconSet",0,0,32],["changeRuleToPresetCriteria",1,0,32],["changeRuleToTopBottom",1,0,32],["setRanges",1,0,32]],[["getRange","Range",0,10,0,4],["getRangeOrNullObject","Range",0,10,0,4],["getRanges","RangeAreas",0,10,7,4]]],["DataBarConditionalFormat",0,[["showDataBarOnly",1,0,0,2,44],["barDirection",1,0,0,2,45],["axisFormat",1,0,0,2,45],["axisColor",1,0,0,2,45],["lowerBoundRule",1,0,0,2,45],["upperBoundRule",1,0,0,2,45]],[["positiveFormat","ConditionalDataBarPositiveFormat",35,0,0,4],["negativeFormat","ConditionalDataBarNegativeFormat",35,0,0,4]]],["ConditionalDataBarPositiveFormat",0,[["fillColor",1,0,0,2,44],["gradientFill",1,0,0,2,44],["borderColor",1,0,0,2,44]]],["ConditionalDataBarNegativeFormat",0,[["fillColor",1,0,0,2,44],["matchPositiveFillColor",1,0,0,2,44],["borderColor",1,0,0,2,44],["matchPositiveBorderColor",1,0,0,2,44]]],["CustomConditionalFormat",0,0,[["rule","ConditionalFormatRule",35,0,0,4],["format","ConditionalRangeFormat",35,0,0,4]]],["ConditionalFormatRule",0,[["formula",1,0,0,2,45],["formulaLocal",1],["formulaR1C1",1]]],["IconSetConditionalFormat",0,[["reverseIconOrder",1,0,0,2,45],["showIconOnly",1,0,0,2,45],["style",1,0,0,2,45],["criteria",1,0,0,2,45]]],["ColorScaleConditionalFormat",0,[["threeColorScale",3],["criteria",1,0,0,2,45]]],["TopBottomConditionalFormat",0,[["rule",1,0,0,2,45]],[["format","ConditionalRangeFormat",35,0,0,4]]],["PresetCriteriaConditionalFormat",0,[["rule",1,0,0,2,45]],[["format","ConditionalRangeFormat",35,0,0,4]]],["TextConditionalFormat",0,[["rule",1,0,0,2,45]],[["format","ConditionalRangeFormat",35,0,0,4]]],["CellValueConditionalFormat",0,[["rule",1,0,0,2,45]],[["format","ConditionalRangeFormat",35,0,0,4]]],["ConditionalRangeFormat",0,[["numberFormat",1]],[["fill","ConditionalRangeFill",35,0,0,4],["font","ConditionalRangeFont",35,0,0,4],["borders","ConditionalRangeBorderCollection",51,0,0,4]],[["clearFormat",0,0,32]]],["ConditionalRangeFont",0,[["color",1,0,0,2,46],["italic",1,0,0,2,46],["bold",1,0,0,2,46],["underline",1,0,0,2,46],["strikethrough",1,0,0,2,46]],0,[["clear",0,0,0,2,0,46]]],["ConditionalRangeFill",0,[["color",1,0,0,2,46]],0,[["clear",0,0,0,2,0,46]]],["ConditionalRangeBorder",0,[["sideIndex",3],["style",1,0,0,2,46],["color",1,0,0,2,46]]],["ConditionalRangeBorderCollection",1,[["count",3]],[["top","ConditionalRangeBorder",35,0,0,4],["bottom","ConditionalRangeBorder",35,0,0,4],["left","ConditionalRangeBorder",35,0,0,4],["right","ConditionalRangeBorder",35,0,0,4]],0,[["getItem","ConditionalRangeBorder",1,18,0,4],["getItemAt","ConditionalRangeBorder",1,2,0,4]],0,"ConditionalRangeBorder"],["NumberFormattingService",0,0,0,0,[["getFormatter","NumberFormatter",1,3]],0,0,0,"Microsoft.ExcelServices.NumberFormattingService",4],["NumberFormatter",0,[["isDateTime",3],["isPercent",3],["isCurrency",3],["isNumeric",3],["isText",3],["hasYear",3],["hasMonth",3],["hasDayOfWeek",3]],0,[["format",1,3]]],["CustomFunctionManager",36,[["status",2]],0,[["register",2]],0,0,0,0,"Microsoft.ExcelServices.CustomFunctionManager",4],["Style",0,[["builtIn",3],["formulaHidden",1],["horizontalAlignment",1],["includeAlignment",1],["includeBorder",1],["includeFont",1],["includeNumber",1],["includePatterns",1],["includeProtection",1],["indentLevel",1],["locked",1],["name",3],["numberFormat",1],["numberFormatLocal",1],["readingOrder",1],["shrinkToFit",1],["verticalAlignment",1],["wrapText",1],["textOrientation",5,6],["autoIndent",1,6]],[["borders","RangeBorderCollection",51,0,0,4],["font","RangeFont",35,0,0,4],["fill","RangeFill",35,0,0,4]],[["delete"]]],["StyleCollection",1,0,0,[["add",1],["getCount",0,2,7,4]],[["getItem","Style",1,18,0,4],["getItemAt","Style",1,2,7,4],["getItemOrNullObject","Style",1,2,19,4]],0,"Style"],["TableStyleCollection",1,0,0,[["getCount",0,2,0,4],["setDefault",1]],[["getItem","TableStyle",1,18,0,4],["getItemOrNullObject","TableStyle",1,2,0,4],["add","TableStyle",2,8],["getDefault","TableStyle"]],0,"TableStyle"],["TableStyle",0,[["name",1],["readOnly",3],["_Id",2]],0,[["delete"]],[["duplicate","TableStyle"]]],["PivotTableStyleCollection",1,0,0,[["getCount",0,2,0,4],["setDefault",1]],[["getItem","PivotTableStyle",1,18,0,4],["getItemOrNullObject","PivotTableStyle",1,2,0,4],["add","PivotTableStyle",2,8],["getDefault","PivotTableStyle"]],0,"PivotTableStyle"],["PivotTableStyle",0,[["name",1],["readOnly",3],["_Id",2]],0,[["delete"]],[["duplicate","PivotTableStyle"]]],["SlicerStyleCollection",1,0,0,[["getCount",0,2,0,4],["setDefault",1]],[["getItem","SlicerStyle",1,18,0,4],["getItemOrNullObject","SlicerStyle",1,2,0,4],["add","SlicerStyle",2,8],["getDefault","SlicerStyle"]],0,"SlicerStyle"],["SlicerStyle",0,[["name",1],["readOnly",3],["_Id",2]],0,[["delete"]],[["duplicate","SlicerStyle"]]],["TimelineStyleCollection",1,0,0,[["getCount",0,2,0,4],["setDefault",1]],[["getItem","TimelineStyle",1,18,0,4],["getItemOrNullObject","TimelineStyle",1,2,0,4],["add","TimelineStyle",2,8],["getDefault","TimelineStyle"]],0,"TimelineStyle"],["TimelineStyle",0,[["name",1],["readOnly",3],["_Id",2]],0,[["delete"]],[["duplicate","TimelineStyle"]]],["InternalTest",0,0,0,[["delay",1],["triggerMessage",4,0,12],["_RegisterTestEvent",0,0,12,2,0,1],["_UnregisterTestEvent",0,0,12,2,0,1],["triggerTestEvent",2,0,12],["triggerPostProcess",0,0,12],["_RegisterTest1Event",0,0,12,2,0,1],["_UnregisterTest1Event",0,0,12,2,0,1],["triggerTestEventWithFilter",3,0,12],["firstPartyMethod",0,2,12,5],["_RegisterCustomFunctionExecutionBeginEvent",0,0,22,2,0,1],["_UnregisterCustomFunctionExecutionBeginEvent",0,0,22,2,0,1],["_RegisterCustomFunctionExecutionEndEvent",0,0,22,2,0,1],["_UnregisterCustomFunctionExecutionEndEvent",0,0,22,2,0,1],["unregisterAllCustomFunctionExecutionEvents",0,0,22],["updateRangeValueOnCurrentSheet",2,0,3,2],["triggerUserUndo",0,2,3],["triggerUserRedo",0,2,3],["enterCellEdit",1,0,7],["installCustomFunctionsFromCache",0,0,7],["recalc",2,0,7],["recalcBySolutionId",1,0,7],["safeForCellEditModeMethod",1,0,7],["exitCellEdit",0,0,7],["noPermissionMethod",1,0,7],["verifyCustomFunctionListExist",0,0,7],["enableContentWorkbookLink",0,0,3],["previewExecutionMethod",1,0,9,16],["setRapidJsonEnabled",1,0,9],["triggerVbaRecorderRecordingChanged",2,0,9]],0,0,0,[["CustomFunctionExecutionBeginEvent",0,22,"MessageType.customFunctionExecutionBeginEvent","","_RegisterCustomFunctionExecutionBeginEvent","_UnregisterCustomFunctionExecutionBeginEvent"],["CustomFunctionExecutionEndEvent",0,22,"MessageType.customFunctionExecutionEndEvent","","_RegisterCustomFunctionExecutionEndEvent","_UnregisterCustomFunctionExecutionEndEvent"],["Test1Event",2,12,"MessageType.test1Event","","_RegisterTest1Event","_UnregisterTest1Event"],["TestEvent",2,12,"MessageType.testEvent","","_RegisterTestEvent","_UnregisterTestEvent"]],"Microsoft.ExcelServices.InternalTest",4],["PageLayout",0,[["orientation",1],["paperSize",1],["blackAndWhite",1],["printErrors",1],["zoom",1],["centerHorizontally",1],["centerVertically",1],["printHeadings",1],["printGridlines",1],["leftMargin",1],["rightMargin",1],["topMargin",1],["bottomMargin",1],["headerMargin",1],["footerMargin",1],["printComments",1],["draftMode",1],["firstPageNumber",1],["printOrder",1]],[["headersFooters","HeaderFooterGroup",35,0,0,4]],[["setPrintMargins",2],["setPrintArea",1],["setPrintTitleRows",1],["setPrintTitleColumns",1]],[["getPrintArea","RangeAreas",0,10,0,4],["getPrintAreaOrNullObject","RangeAreas",0,10,0,4],["getPrintTitleRows","Range",0,10,0,4],["getPrintTitleRowsOrNullObject","Range",0,10,0,4],["getPrintTitleColumns","Range",0,10,0,4],["getPrintTitleColumnsOrNullObject","Range",0,10,0,4]]],["HeaderFooter",0,[["leftHeader",1],["centerHeader",1],["rightHeader",1],["leftFooter",1],["centerFooter",1],["rightFooter",1]]],["HeaderFooterGroup",0,[["state",1],["useSheetMargins",1],["useSheetScale",1]],[["defaultForAllPages","HeaderFooter",35,0,0,4],["firstPage","HeaderFooter",35,0,0,4],["evenPages","HeaderFooter",35,0,0,4],["oddPages","HeaderFooter",35,0,0,4]]],["PageBreak",0,[["_Id",2],["columnIndex",3],["rowIndex",3]],0,[["delete"]],[["getCellAfterBreak","Range",0,10,0,4]]],["PageBreakCollection",1,0,0,[["removePageBreaks"],["getCount",0,2,0,4]],[["getItem","PageBreak",1,18,0,4],["add","PageBreak",1,8]],0,"PageBreak"],["DataConnectionCollection",0,0,0,[["refreshAll"]],[["add","DataConnection",4,8,9,2,0,0,13]]],["RangeCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","Range",1,2,0,4]],0,"Range"],["RangeAreasCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","RangeAreas",1,2,0,4]],0,"RangeAreas"],["CommentCollection",5,0,0,[["getCount",0,2,0,4],["_RegisterAddedEvent",0,2,29],["_UnregisterAddedEvent",0,2,29],["_RegisterDeletedEvent",0,2,29],["_UnregisterDeletedEvent",0,2,29],["_RegisterChangedEvent",0,2,29],["_UnregisterChangedEvent",0,2,29]],[["getItem","Comment",1,18,0,4],["getItemAt","Comment",1,2,0,4],["add","Comment",3,8],["getItemByReplyId","Comment",1,2,0,4],["getItemByCell","Comment",1,2,0,4],["getItemOrNullObject","Comment",1,2,19,4]],0,"Comment",[["Added",0,29,"MessageType.commentAddedEvent","this._eventTargetId","_RegisterAddedEvent","_UnregisterAddedEvent"],["Changed",0,29,"MessageType.commentChangedEvent","this._eventTargetId","_RegisterChangedEvent","_UnregisterChangedEvent"],["Deleted",0,29,"MessageType.commentDeletedEvent","this._eventTargetId","_RegisterDeletedEvent","_UnregisterDeletedEvent"]]],["Comment",0,[["id",3],["content",1],["authorName",3],["authorEmail",3],["creationDate",11],["resolved",1,8],["richContent",3,8],["mentions",3,8],["contentType",3,29]],[["replies","CommentReplyCollection",19,0,0,4]],[["delete"],["updateMentions",1,0,8]],[["getLocation","Range",0,10,0,4],["assignTask","DocumentTask",1,0,9],["getTask","DocumentTask",0,10,9,4],["getTaskOrNullObject","DocumentTask",0,10,9,4]]],["CommentReplyCollection",1,0,0,[["getCount",0,2,0,4]],[["add","CommentReply",2,8],["getItem","CommentReply",1,18,0,4],["getItemAt","CommentReply",1,2,0,4],["getItemOrNullObject","CommentReply",1,2,19,4]],0,"CommentReply"],["CommentReply",0,[["id",3],["content",1],["authorName",3],["authorEmail",3],["creationDate",11],["resolved",3,8],["richContent",3,8],["mentions",3,8],["contentType",3,29]],0,[["delete"],["updateMentions",1,0,8]],[["getLocation","Range",0,10,0,4],["getParentComment","Comment"],["assignTask","DocumentTask",1,0,9],["getTask","DocumentTask",0,10,9,4],["getTaskOrNullObject","DocumentTask",0,10,9,4]]],["ShapeCollection",5,0,0,[["getCount",0,2,0,4],["_RegisterAddedEvent",0,0,3,2,0,1],["_RegisterDeletedEvent",0,0,3,2,0,1],["_UnregisterAddedEvent",0,0,3,2,0,1],["_UnregisterDeletedEvent",0,0,3,2,0,1]],[["addImage","Shape",1],["_GetItem","Shape",1,18,0,4],["addGeometricShape","Shape",1],["addTextBox","Shape",1],["addSvg","Shape",1,0,9],["addGroup","Shape",1],["getItemAt","Shape",1,2,0,4],["getItem","Shape",1,2,0,4],["addLine","Shape",5],["getItemOrNullObject","Shape",1,2,19,4]],0,"Shape",[["Added",0,3,"MessageType.shapeAddedEvent","this._ParentObject.id","_RegisterAddedEvent","_UnregisterAddedEvent"],["Deleted",0,3,"MessageType.shapeDeletedEvent","this._ParentObject.id","_RegisterDeletedEvent","_UnregisterDeletedEvent"]]],["Shape",0,[["id",3],["name",1],["left",1],["top",1],["width",1],["height",1],["rotation",1],["zOrderPosition",3],["altTextTitle",1],["altTextDescription",1,0,0,2,39],["type",3],["lockAspectRatio",1],["placement",1,18],["geometricShapeType",1],["visible",1],["level",3],["connectionSiteCount",3],["scriptLink",1,9,0,2,40],["displayName",3,38]],[["geometricShape","GeometricShape",2,0,0,4],["image","Image",2,0,0,4],["textFrame","TextFrame",2,0,0,4],["fill","ShapeFill",35,0,0,4],["group","ShapeGroup",2,0,0,4],["parentGroup","Shape",2,0,0,4],["line","Line",2,0,0,4],["lineFormat","ShapeLineFormat",35,0,0,4]],[["setZOrder",1],["incrementLeft",1],["incrementTop",1],["incrementRotation",1],["scaleHeight",3],["scaleWidth",3],["delete"],["getAsImage",1],["_RegisterActivatedEvent",0,0,0,2,0,1],["_UnregisterActivatedEvent",0,0,0,2,0,1],["_RegisterDeactivatedEvent",0,0,0,2,0,1],["_UnregisterDeactivatedEvent",0,0,0,2,0,1],["activate",0,0,3]],[["copyTo","Shape",1,8,18,0,0,"_GetShapeById"],["_GetShapeById","Shape",1,2,18,4]],0,0,[["Activated",0,0,"MessageType.shapeActivatedEvent","this.id","_RegisterActivatedEvent","_UnregisterActivatedEvent"],["Deactivated",0,0,"MessageType.shapeDeactivatedEvent","this.id","_RegisterDeactivatedEvent","_UnregisterDeactivatedEvent"]]],["GeometricShape",0,[["id",3]],[["shape","Shape",2,0,0,4]]],["Image",0,[["id",3],["format",3,0,"format"]],[["shape","Shape",2,0,0,4]]],["ShapeGroup",0,[["id",3]],[["shapes","GroupShapeCollection",19,0,0,4],["shape","Shape",2,0,0,4]],[["ungroup"]]],["GroupShapeCollection",1,0,0,[["getCount",0,2,0,4]],[["_GetItem","Shape",1,18,0,4],["getItemAt","Shape",1,2,0,4],["getItem","Shape",1,2,0,4],["getItemOrNullObject","Shape",1,2,19,4]],0,"Shape"],["Line",0,[["id",3],["connectorType",1,0,"connectorType"],["beginArrowheadLength",1],["beginArrowheadStyle",1],["beginArrowheadWidth",1],["endArrowheadLength",1],["endArrowheadStyle",1],["endArrowheadWidth",1],["isBeginConnected",3],["beginConnectedSite",3],["isEndConnected",3],["endConnectedSite",3]],[["shape","Shape",2,0,0,4],["beginConnectedShape","Shape",2,0,0,4],["endConnectedShape","Shape",2,0,0,4]],[["connectBeginShape",2],["disconnectBeginShape"],["connectEndShape",2],["disconnectEndShape"]]],["ShapeFill",0,[["foregroundColor",1],["type",3],["transparency",1]],0,[["clear"],["setSolidColor",1]]],["ShapeLineFormat",0,[["visible",1],["color",1],["style",1],["weight",1],["dashStyle",1],["transparency",1]]],["TextFrame",0,[["leftMargin",1],["rightMargin",1],["topMargin",1],["bottomMargin",1],["horizontalAlignment",1],["horizontalOverflow",1],["verticalAlignment",1],["verticalOverflow",1],["orientation",1],["readingOrder",1],["hasText",3],["autoSizeSetting",1]],[["textRange","TextRange",2,0,0,4]],[["deleteText"]]],["TextRange",0,[["text",1]],[["font","ShapeFont",35,0,0,4]],0,[["getSubstring","TextRange",2]]],["ShapeFont",0,[["size",1],["name",1],["color",1],["bold",1],["italic",1],["underline",1]]],["Slicer",0,[["id",3],["name",1],["caption",1],["left",1],["top",1],["width",1],["height",1],["nameInFormula",1,9],["isFilterCleared",3],["style",1],["sortBy",1],["sortUsingCustomLists",1,3],["columnCount",1,3],["disableMoveResizeUI",1,3],["displayHeader",1,3],["rowHeight",1,3],["shapeId",2,3]],[["slicerItems","SlicerItemCollection",19,0,0,4],["worksheet","Worksheet",35,0,0,4],["slicerStyle","SlicerStyle",35,9,0,4]],[["delete"],["clearFilters"],["getSelectedItems"],["selectItems",1],["activate",0,2,3],["setStyle",1,0,9]]],["SlicerCollection",1,0,0,[["getCount",0,2,0,4]],[["add","Slicer",3,8],["getItemAt","Slicer",1,2,0,4],["getItem","Slicer",1,18,0,4],["getItemOrNullObject","Slicer",1,2,0,4]],0,"Slicer"],["SlicerItem",0,[["key",3],["name",3],["isSelected",1],["hasData",3]]],["SlicerItemCollection",1,0,0,[["getCount",0,2,0,4]],[["getItemAt","SlicerItem",1,2,0,4],["getItem","SlicerItem",1,18,0,4],["getItemOrNullObject","SlicerItem",1,2,0,4]],0,"SlicerItem"],["Ribbon",0,[["activeTab",1]],0,[["executeCommand",2],["showTeachingCallout",3],["_RegisterCommandExecutedEvent",0,0,0,2,0,1],["_UnregisterCommandExecutedEvent",0,0,0,2,0,1],["showChartDialog",1,2,9,4]],0,0,0,[["CommandExecuted",0,0,"MessageType.ribbonCommandExecutedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterCommandExecutedEvent","_UnregisterCommandExecutedEvent"]]],["LinkedDataType",0,[["dataProvider",2],["serviceId",2],["lastRefreshed",10],["name",2],["periodicRefreshInterval",2],["refreshDataLoadWarnings",2],["refreshMode",2],["supportedRefreshModes",2],["refreshErrors",2]],0,[["requestRefresh",0,0,0,2],["requestSetRefreshMode",1,0,0,2]]],["LinkedDataTypeCollection",1,0,0,[["getCount",0,2,0,4],["requestRefreshAll",0,0,0,2],["_RegisterRefreshRequestCompletedEvent",0,2,0,4],["_UnregisterRefreshRequestCompletedEvent",0,2,0,4],["_RegisterRefreshModeChangedEvent",0,2,0,4],["_UnregisterRefreshModeChangedEvent",0,2,0,4],["_RegisterLinkedDataTypeAddedEvent",0,2,0,4],["_UnregisterLinkedDataTypeAddedEvent",0,2,0,4]],[["getItem","LinkedDataType",1,18,0,4],["getItemOrNullObject","LinkedDataType",1],["getItemAt","LinkedDataType",1,2,0,4]],0,"LinkedDataType",[["LinkedDataTypeAdded",0,0,"MessageType.linkedDataTypeLinkedDataTypeAddedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterLinkedDataTypeAddedEvent","_UnregisterLinkedDataTypeAddedEvent"],["RefreshModeChanged",0,0,"MessageType.linkedDataTypeRefreshModeChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterRefreshModeChangedEvent","_UnregisterRefreshModeChangedEvent"],["RefreshRequestCompleted",0,0,"MessageType.linkedDataTypeRefreshRequestCompletedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterRefreshRequestCompletedEvent","_UnregisterRefreshRequestCompletedEvent"]]],["LinkedEntityDataDomain",0,[["dataProvider",2],["id",2],["lastRefreshed",10],["loadFunctionId",2],["name",2],["periodicRefreshInterval",2],["refreshErrors",2],["refreshMode",0,0,0,2],["refreshModeWarnings",2],["serviceId",2],["supportedRefreshModes",2]],0,[["delete",0,0,0,2],["refresh",0,0,0,2]]],["LinkedEntityDataDomainCollection",1,0,0,[["_RegisterEventLinkedEntityDataDomainAdded",0,2,0,4],["_RegisterEventRefreshCompleted",0,2,0,4],["_RegisterEventRefreshModeChanged",0,2,0,4],["_UnregisterEventLinkedEntityDataDomainAdded",0,2,0,4],["_UnregisterEventRefreshCompleted",0,2,0,4],["_UnregisterEventRefreshModeChanged",0,2,0,4],["add",1,0,0,2],["getCount",0,2,0,4],["refreshAll",0,0,0,2]],[["getItem","LinkedEntityDataDomain",1,18,0,4],["getItemAt","LinkedEntityDataDomain",1,2,0,4],["getItemByName","LinkedEntityDataDomain",1,2,0,4],["getItemByNameOrNullObject","LinkedEntityDataDomain",1,2,0,4],["getItemOrNullObject","LinkedEntityDataDomain",1,2,0,4]],0,"LinkedEntityDataDomain",[["LinkedEntityDataDomainAdded",0,0,"MessageType.linkedEntityDataDomainLinkedEntityDataDomainAddedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventLinkedEntityDataDomainAdded","_UnregisterEventLinkedEntityDataDomainAdded"],["RefreshCompleted",0,0,"MessageType.linkedEntityDataDomainRefreshCompletedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventRefreshCompleted","_UnregisterEventRefreshCompleted"],["RefreshModeChanged",0,0,"MessageType.linkedEntityDataDomainRefreshModeChangedEvent","OfficeExtension.Constants.eventWorkbookId","_RegisterEventRefreshModeChanged","_UnregisterEventRefreshModeChanged"]]],["SheetView",0,[["name"]],0,[["activate"],["delete"]],[["duplicate","SheetView",1]]],["SheetViewCollection",1,0,0,[["getCount",0,2,0,4],["exit"]],[["add","SheetView",1,8],["enterTemporary","SheetView"],["getActive","SheetView"],["getItem","SheetView",1,18,0,4],["getItemAt","SheetView",1,2,0,4]],0,"SheetView"],["NamedSheetView",0,[["name"]],0,[["activate"],["delete"]],[["duplicate","NamedSheetView",1]]],["NamedSheetViewCollection",1,0,0,[["getCount",0,2,0,4],["exit"]],[["add","NamedSheetView",1,8],["enterTemporary","NamedSheetView"],["getActive","NamedSheetView"],["getItem","NamedSheetView",1,18,0,4],["getItemAt","NamedSheetView",1,2,0,4],["getItemOrNullObject","NamedSheetView",1,2,30,4]],0,"NamedSheetView"],["FunctionResult",0,[["error",3],["value",3]]],["Functions",0,0,0,0,[["count","FunctionResult",1,72],["if","FunctionResult",3,8],["isNA","FunctionResult",1,8],["isError","FunctionResult",1,8],["sum","FunctionResult",1,72],["average","FunctionResult",1,72],["min","FunctionResult",1,72],["max","FunctionResult",1,72],["na","FunctionResult",0,8],["npv","FunctionResult",2,72],["dollar","FunctionResult",2,8],["fixed","FunctionResult",3,8],["sin","FunctionResult",1,8],["cos","FunctionResult",1,8],["tan","FunctionResult",1,8],["atan","FunctionResult",1,8],["pi","FunctionResult",0,8],["sqrt","FunctionResult",1,8],["exp","FunctionResult",1,8],["ln","FunctionResult",1,8],["log10","FunctionResult",1,8],["abs","FunctionResult",1,8],["int","FunctionResult",1,8],["sign","FunctionResult",1,8],["round","FunctionResult",2,8],["lookup","FunctionResult",3,8],["rept","FunctionResult",2,8],["mid","FunctionResult",3,8],["len","FunctionResult",1,8],["value","FunctionResult",1,8],["true","FunctionResult",0,8],["false","FunctionResult",0,8],["and","FunctionResult",1,72],["or","FunctionResult",1,72],["not","FunctionResult",1,8],["mod","FunctionResult",2,8],["dcount","FunctionResult",3,8,0,0,"DCount"],["dsum","FunctionResult",3,8,0,0,"DSum"],["daverage","FunctionResult",3,8,0,0,"DAverage"],["dmin","FunctionResult",3,8,0,0,"DMin"],["dmax","FunctionResult",3,8,0,0,"DMax"],["dstDev","FunctionResult",3,8,0,0,"DStDev"],["dvar","FunctionResult",3,8,0,0,"DVar"],["text","FunctionResult",2,8],["pv","FunctionResult",5,8],["fv","FunctionResult",5,8],["nper","FunctionResult",5,8,0,0,"NPer"],["pmt","FunctionResult",5,8],["rate","FunctionResult",6,8],["mirr","FunctionResult",3,8,0,0,"MIrr"],["irr","FunctionResult",2,8],["rand","FunctionResult",0,8],["match","FunctionResult",3,8],["date","FunctionResult",3,8],["time","FunctionResult",3,8],["day","FunctionResult",1,8],["month","FunctionResult",1,8],["year","FunctionResult",1,8],["weekday","FunctionResult",2,8],["hour","FunctionResult",1,8],["minute","FunctionResult",1,8],["second","FunctionResult",1,8],["now","FunctionResult",0,8],["areas","FunctionResult",1,8],["rows","FunctionResult",1,8],["columns","FunctionResult",1,8],["type","FunctionResult",1,8],["atan2","FunctionResult",2,8],["asin","FunctionResult",1,8],["acos","FunctionResult",1,8],["choose","FunctionResult",2,72],["hlookup","FunctionResult",4,8,0,0,"HLookup"],["vlookup","FunctionResult",4,8,0,0,"VLookup"],["isref","FunctionResult",1,8],["log","FunctionResult",2,8],["char","FunctionResult",1,8],["lower","FunctionResult",1,8],["upper","FunctionResult",1,8],["proper","FunctionResult",1,8],["left","FunctionResult",2,8],["right","FunctionResult",2,8],["exact","FunctionResult",2,8],["trim","FunctionResult",1,8],["replace","FunctionResult",4,8],["substitute","FunctionResult",4,8],["code","FunctionResult",1,8],["find","FunctionResult",3,8],["isErr","FunctionResult",1,8],["isText","FunctionResult",1,8],["isNumber","FunctionResult",1,8],["t","FunctionResult",1,8,0,0,"T"],["n","FunctionResult",1,8,0,0,"N"],["datevalue","FunctionResult",1,8],["timevalue","FunctionResult",1,8],["sln","FunctionResult",3,8],["syd","FunctionResult",4,8],["ddb","FunctionResult",5,8],["clean","FunctionResult",1,8],["ipmt","FunctionResult",6,8],["ppmt","FunctionResult",6,8],["countA","FunctionResult",1,72],["product","FunctionResult",1,72],["fact","FunctionResult",1,8],["dproduct","FunctionResult",3,8,0,0,"DProduct"],["isNonText","FunctionResult",1,8],["dstDevP","FunctionResult",3,8,0,0,"DStDevP"],["dvarP","FunctionResult",3,8,0,0,"DVarP"],["trunc","FunctionResult",2,8],["isLogical","FunctionResult",1,8],["dcountA","FunctionResult",3,8,0,0,"DCountA"],["usdollar","FunctionResult",2,8,0,0,"USDollar"],["findB","FunctionResult",3,8],["replaceB","FunctionResult",4,8],["leftb","FunctionResult",2,8],["rightb","FunctionResult",2,8],["midb","FunctionResult",3,8],["lenb","FunctionResult",1,8],["roundUp","FunctionResult",2,8],["roundDown","FunctionResult",2,8],["asc","FunctionResult",1,8],["dbcs","FunctionResult",1,8],["days360","FunctionResult",3,8],["today","FunctionResult",0,8],["vdb","FunctionResult",7,8],["median","FunctionResult",1,72],["sinh","FunctionResult",1,8],["cosh","FunctionResult",1,8],["tanh","FunctionResult",1,8],["asinh","FunctionResult",1,8],["acosh","FunctionResult",1,8],["atanh","FunctionResult",1,8],["dget","FunctionResult",3,8,0,0,"DGet"],["db","FunctionResult",5,8],["error_Type","FunctionResult",1,8],["aveDev","FunctionResult",1,72],["gammaLn","FunctionResult",1,8],["combin","FunctionResult",2,8],["even","FunctionResult",1,8],["fisher","FunctionResult",1,8],["fisherInv","FunctionResult",1,8],["standardize","FunctionResult",3,8],["odd","FunctionResult",1,8],["permut","FunctionResult",2,8],["devSq","FunctionResult",1,72],["geoMean","FunctionResult",1,72],["harMean","FunctionResult",1,72],["sumSq","FunctionResult",1,72],["kurt","FunctionResult",1,72],["skew","FunctionResult",1,72],["large","FunctionResult",2,8],["small","FunctionResult",2,8],["trimMean","FunctionResult",2,8],["concatenate","FunctionResult",1,72],["power","FunctionResult",2,8],["radians","FunctionResult",1,8],["degrees","FunctionResult",1,8],["subtotal","FunctionResult",2,72],["sumIf","FunctionResult",3,8],["countIf","FunctionResult",2,8],["countBlank","FunctionResult",1,8],["ispmt","FunctionResult",4,8],["roman","FunctionResult",2,8],["hyperlink","FunctionResult",2,8],["averageA","FunctionResult",1,72],["maxA","FunctionResult",1,72],["minA","FunctionResult",1,72],["stDevPA","FunctionResult",1,72],["varPA","FunctionResult",1,72],["stDevA","FunctionResult",1,72],["varA","FunctionResult",1,72],["bahtText","FunctionResult",1,8],["hex2Bin","FunctionResult",2,8],["hex2Dec","FunctionResult",1,8],["hex2Oct","FunctionResult",2,8],["dec2Bin","FunctionResult",2,8],["dec2Hex","FunctionResult",2,8],["dec2Oct","FunctionResult",2,8],["oct2Bin","FunctionResult",2,8],["oct2Hex","FunctionResult",2,8],["oct2Dec","FunctionResult",1,8],["bin2Dec","FunctionResult",1,8],["bin2Oct","FunctionResult",2,8],["bin2Hex","FunctionResult",2,8],["imSub","FunctionResult",2,8],["imDiv","FunctionResult",2,8],["imPower","FunctionResult",2,8],["imAbs","FunctionResult",1,8],["imSqrt","FunctionResult",1,8],["imLn","FunctionResult",1,8],["imLog2","FunctionResult",1,8],["imLog10","FunctionResult",1,8],["imSin","FunctionResult",1,8],["imCos","FunctionResult",1,8],["imExp","FunctionResult",1,8],["imArgument","FunctionResult",1,8],["imConjugate","FunctionResult",1,8],["imaginary","FunctionResult",1,8],["imReal","FunctionResult",1,8],["complex","FunctionResult",3,8],["imSum","FunctionResult",1,72],["imProduct","FunctionResult",1,72],["seriesSum","FunctionResult",4,8],["factDouble","FunctionResult",1,8],["sqrtPi","FunctionResult",1,8],["quotient","FunctionResult",2,8],["delta","FunctionResult",2,8],["geStep","FunctionResult",2,8],["isEven","FunctionResult",1,8],["isOdd","FunctionResult",1,8],["mround","FunctionResult",2,8,0,0,"MRound"],["erf","FunctionResult",2,8],["erfC","FunctionResult",1,8],["besselJ","FunctionResult",2,8],["besselK","FunctionResult",2,8],["besselY","FunctionResult",2,8],["besselI","FunctionResult",2,8],["xirr","FunctionResult",3,8],["xnpv","FunctionResult",3,8],["priceMat","FunctionResult",6,8],["yieldMat","FunctionResult",6,8],["intRate","FunctionResult",5,8],["received","FunctionResult",5,8],["disc","FunctionResult",5,8],["priceDisc","FunctionResult",5,8],["yieldDisc","FunctionResult",5,8],["tbillEq","FunctionResult",3,8,0,0,"TBillEq"],["tbillPrice","FunctionResult",3,8,0,0,"TBillPrice"],["tbillYield","FunctionResult",3,8,0,0,"TBillYield"],["price","FunctionResult",7,8],["yield","FunctionResult",7,8],["dollarDe","FunctionResult",2,8],["dollarFr","FunctionResult",2,8],["nominal","FunctionResult",2,8],["effect","FunctionResult",2,8],["cumPrinc","FunctionResult",6,8],["cumIPmt","FunctionResult",6,8],["edate","FunctionResult",2,8,0,0,"EDate"],["eoMonth","FunctionResult",2,8],["yearFrac","FunctionResult",3,8],["coupDayBs","FunctionResult",4,8],["coupDays","FunctionResult",4,8],["coupDaysNc","FunctionResult",4,8],["coupNcd","FunctionResult",4,8],["coupNum","FunctionResult",4,8],["coupPcd","FunctionResult",4,8],["duration","FunctionResult",6,8],["mduration","FunctionResult",6,8,0,0,"MDuration"],["oddLPrice","FunctionResult",8,8],["oddLYield","FunctionResult",8,8],["oddFPrice","FunctionResult",9,8],["oddFYield","FunctionResult",9,8],["randBetween","FunctionResult",2,8],["weekNum","FunctionResult",2,8],["amorDegrc","FunctionResult",7,8],["amorLinc","FunctionResult",7,8],["convert","FunctionResult",3,8],["accrInt","FunctionResult",8,8],["accrIntM","FunctionResult",5,8],["workDay","FunctionResult",3,8],["networkDays","FunctionResult",3,8],["gcd","FunctionResult",1,72],["multiNomial","FunctionResult",1,72],["lcm","FunctionResult",1,72],["fvschedule","FunctionResult",2,8,0,0,"FVSchedule"],["countIfs","FunctionResult",1,72],["sumIfs","FunctionResult",2,72],["averageIf","FunctionResult",3,8],["averageIfs","FunctionResult",2,72],["binom_Dist","FunctionResult",4,8],["binom_Inv","FunctionResult",3,8],["confidence_Norm","FunctionResult",3,8],["confidence_T","FunctionResult",3,8],["expon_Dist","FunctionResult",3,8],["gamma_Dist","FunctionResult",4,8],["gamma_Inv","FunctionResult",3,8],["norm_Dist","FunctionResult",4,8],["norm_Inv","FunctionResult",3,8],["percentile_Exc","FunctionResult",2,8],["percentile_Inc","FunctionResult",2,8],["percentRank_Exc","FunctionResult",3,8],["percentRank_Inc","FunctionResult",3,8],["poisson_Dist","FunctionResult",3,8],["quartile_Exc","FunctionResult",2,8],["quartile_Inc","FunctionResult",2,8],["rank_Avg","FunctionResult",3,8],["rank_Eq","FunctionResult",3,8],["stDev_S","FunctionResult",1,72],["stDev_P","FunctionResult",1,72],["t_Dist","FunctionResult",3,8],["t_Dist_2T","FunctionResult",2,8],["t_Dist_RT","FunctionResult",2,8],["t_Inv","FunctionResult",2,8],["t_Inv_2T","FunctionResult",2,8],["var_S","FunctionResult",1,72],["var_P","FunctionResult",1,72],["weibull_Dist","FunctionResult",4,8],["networkDays_Intl","FunctionResult",4,8],["workDay_Intl","FunctionResult",4,8],["ecma_Ceiling","FunctionResult",2,8,0,0,"ECMA_Ceiling"],["iso_Ceiling","FunctionResult",2,8,0,0,"ISO_Ceiling"],["beta_Dist","FunctionResult",6,8],["beta_Inv","FunctionResult",5,8],["chiSq_Dist","FunctionResult",3,8],["chiSq_Dist_RT","FunctionResult",2,8],["chiSq_Inv","FunctionResult",2,8],["chiSq_Inv_RT","FunctionResult",2,8],["f_Dist","FunctionResult",4,8],["f_Dist_RT","FunctionResult",3,8],["f_Inv","FunctionResult",3,8],["f_Inv_RT","FunctionResult",3,8],["hypGeom_Dist","FunctionResult",5,8],["logNorm_Dist","FunctionResult",4,8],["logNorm_Inv","FunctionResult",3,8],["negBinom_Dist","FunctionResult",4,8],["norm_S_Dist","FunctionResult",2,8],["norm_S_Inv","FunctionResult",1,8],["z_Test","FunctionResult",3,8],["erf_Precise","FunctionResult",1,8],["erfC_Precise","FunctionResult",1,8],["gammaLn_Precise","FunctionResult",1,8],["ceiling_Precise","FunctionResult",2,8],["floor_Precise","FunctionResult",2,8],["acot","FunctionResult",1,8],["acoth","FunctionResult",1,8],["cot","FunctionResult",1,8],["coth","FunctionResult",1,8],["csc","FunctionResult",1,8],["csch","FunctionResult",1,8],["sec","FunctionResult",1,8],["sech","FunctionResult",1,8],["imTan","FunctionResult",1,8],["imCot","FunctionResult",1,8],["imCsc","FunctionResult",1,8],["imCsch","FunctionResult",1,8],["imSec","FunctionResult",1,8],["imSech","FunctionResult",1,8],["bitand","FunctionResult",2,8],["bitor","FunctionResult",2,8],["bitxor","FunctionResult",2,8],["bitlshift","FunctionResult",2,8],["bitrshift","FunctionResult",2,8],["permutationa","FunctionResult",2,8],["combina","FunctionResult",2,8],["xor","FunctionResult",1,72],["pduration","FunctionResult",3,8,0,0,"PDuration"],["base","FunctionResult",3,8],["decimal","FunctionResult",2,8],["days","FunctionResult",2,8],["binom_Dist_Range","FunctionResult",4,8],["gamma","FunctionResult",1,8],["skew_p","FunctionResult",1,72],["gauss","FunctionResult",1,8],["phi","FunctionResult",1,8],["rri","FunctionResult",3,8],["unichar","FunctionResult",1,8],["unicode","FunctionResult",1,8],["arabic","FunctionResult",1,8],["isoWeekNum","FunctionResult",1,8],["numberValue","FunctionResult",3,8],["sheet","FunctionResult",1,8],["sheets","FunctionResult",1,8],["isFormula","FunctionResult",1,8],["ceiling_Math","FunctionResult",3,8],["floor_Math","FunctionResult",3,8],["imSinh","FunctionResult",1,8],["imCosh","FunctionResult",1,8]]]]},targetNamespaceObject:e})}(Excel||(Excel={}));var _EndExcel="_EndExcel";if("undefined"!==typeof window&&window.OSF&&window.OSF._OfficeAppFactory&&window.OSF._OfficeAppFactory.getHostInfo&&window.OSF._OfficeAppFactory.getHostInfo()){var hostPlatform=window.OSF._OfficeAppFactory.getHostInfo().hostPlatform;"web"===hostPlatform&&(OfficeExtension._internalConfig.enablePreviewExecution=!0)}function exposeOfficeRuntimeThroughOfficeNamespace(e,t){var n,r;"undefined"===typeof e&&"undefined"!==typeof window&&(e=null===window||void 0===window?void 0:window.OfficeRuntime),"undefined"===typeof e&&(e={}),"undefined"!==typeof t&&(t.storage=t.storage||(null===e||void 0===e?void 0:e.storage),t.auth=t.auth||(null===e||void 0===e?void 0:e.auth),t.getAccessToken=t.getAccessToken||(null===(n=null===e||void 0===e?void 0:e.auth)||void 0===n?void 0:n.getAccessToken),t.addin=t.addin||(null===e||void 0===e?void 0:e.addin),t.isSetSupported=t.isSetSupported||(null===(r=null===e||void 0===e?void 0:e.apiInformation)||void 0===r?void 0:r.isSetSupported),t.license=t.license||(null===e||void 0===e?void 0:e.license),t.message=t.message||(null===e||void 0===e?void 0:e.message))}!function(e){var t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,n),o.l=!0,o.exports}n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)n.d(r,o,function(t){return e[t]}.bind(null,o));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=1)}([function(e,t){e.exports=OfficeExtensionBatch},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),n(2),"undefined"==typeof CustomFunctionMappings&&(window.CustomFunctionMappings={}),"undefined"==typeof Promise&&(window.Promise=Office.Promise),window.OfficeExtensionBatch=window.OfficeExtensionBatch||window.OfficeExtension;var r=n(3);!function(){var e=!1;"undefined"!=typeof OSF&&OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&0!=(2&(OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo().flags))&&(e=!0),(0,r.default)(e)}()},function(e,t){!function(e){"use strict";if(!e.fetch){var t="URLSearchParams"in e,n="Symbol"in e&&"iterator"in Symbol,r="FileReader"in e&&"Blob"in e&&function(){try{return new Blob,!0}catch(e){return!1}}(),o="FormData"in e,i="ArrayBuffer"in e;if(i)var a=["[object Int8Array]","[object Uint8Array]","[object Uint8ClampedArray]","[object Int16Array]","[object Uint16Array]","[object Int32Array]","[object Uint32Array]","[object Float32Array]","[object Float64Array]"],s=function(e){return e&&DataView.prototype.isPrototypeOf(e)},c=ArrayBuffer.isView||function(e){return e&&a.indexOf(Object.prototype.toString.call(e))>-1};h.prototype.append=function(e,t){e=d(e),t=f(t);var n=this.map[e];this.map[e]=n?n+","+t:t},h.prototype.delete=function(e){delete this.map[d(e)]},h.prototype.get=function(e){return e=d(e),this.has(e)?this.map[e]:null},h.prototype.has=function(e){return this.map.hasOwnProperty(d(e))},h.prototype.set=function(e,t){this.map[d(e)]=f(t)},h.prototype.forEach=function(e,t){for(var n in this.map)this.map.hasOwnProperty(n)&&e.call(t,this.map[n],n,this)},h.prototype.keys=function(){var e=[];return this.forEach((function(t,n){e.push(n)})),p(e)},h.prototype.values=function(){var e=[];return this.forEach((function(t){e.push(t)})),p(e)},h.prototype.entries=function(){var e=[];return this.forEach((function(t,n){e.push([n,t])})),p(e)},n&&(h.prototype[Symbol.iterator]=h.prototype.entries);var l=["DELETE","GET","HEAD","OPTIONS","POST","PUT"];b.prototype.clone=function(){return new b(this,{body:this._bodyInit})},O.call(b.prototype),O.call(C.prototype),C.prototype.clone=function(){return new C(this._bodyInit,{status:this.status,statusText:this.statusText,headers:new h(this.headers),url:this.url})},C.error=function(){var e=new C(null,{status:0,statusText:""});return e.type="error",e};var u=[301,302,303,307,308];C.redirect=function(e,t){if(-1===u.indexOf(t))throw new RangeError("Invalid status code");return new C(null,{status:t,headers:{location:e}})},e.Headers=h,e.Request=b,e.Response=C,e.fetch=function(e,t){return new Promise((function(n,o){var i=new b(e,t),a=new XMLHttpRequest;a.onload=function(){var e,t,r={status:a.status,statusText:a.statusText,headers:(e=a.getAllResponseHeaders()||"",t=new h,e.split(/\r?\n/).forEach((function(e){var n=e.split(":"),r=n.shift().trim();if(r){var o=n.join(":").trim();t.append(r,o)}})),t)};r.url="responseURL"in a?a.responseURL:r.headers.get("X-Request-URL");var o="response"in a?a.response:a.responseText;n(new C(o,r))},a.onerror=function(){o(new TypeError("Network request failed"))},a.ontimeout=function(){o(new TypeError("Network request failed"))},a.open(i.method,i.url,!0),"include"===i.credentials&&(a.withCredentials=!0),"responseType"in a&&r&&(a.responseType="blob"),i.headers.forEach((function(e,t){a.setRequestHeader(t,e)})),a.send(void 0===i._bodyInit?null:i._bodyInit)}))},e.fetch.polyfill=!0}function d(e){if("string"!=typeof e&&(e=String(e)),/[^a-z0-9\-#$%&'*+.\^_`|~]/i.test(e))throw new TypeError("Invalid character in header field name");return e.toLowerCase()}function f(e){return"string"!=typeof e&&(e=String(e)),e}function p(e){var t={next:function(){var t=e.shift();return{done:void 0===t,value:t}}};return n&&(t[Symbol.iterator]=function(){return t}),t}function h(e){this.map={},e instanceof h?e.forEach((function(e,t){this.append(t,e)}),this):Array.isArray(e)?e.forEach((function(e){this.append(e[0],e[1])}),this):e&&Object.getOwnPropertyNames(e).forEach((function(t){this.append(t,e[t])}),this)}function m(e){if(e.bodyUsed)return Promise.reject(new TypeError("Already read"));e.bodyUsed=!0}function g(e){return new Promise((function(t,n){e.onload=function(){t(e.result)},e.onerror=function(){n(e.error)}}))}function y(e){var t=new FileReader,n=g(t);return t.readAsArrayBuffer(e),n}function v(e){if(e.slice)return e.slice(0);var t=new Uint8Array(e.byteLength);return t.set(new Uint8Array(e)),t.buffer}function O(){return this.bodyUsed=!1,this._initBody=function(e){if(this._bodyInit=e,e)if("string"==typeof e)this._bodyText=e;else if(r&&Blob.prototype.isPrototypeOf(e))this._bodyBlob=e;else if(o&&FormData.prototype.isPrototypeOf(e))this._bodyFormData=e;else if(t&&URLSearchParams.prototype.isPrototypeOf(e))this._bodyText=e.toString();else if(i&&r&&s(e))this._bodyArrayBuffer=v(e.buffer),this._bodyInit=new Blob([this._bodyArrayBuffer]);else{if(!i||!ArrayBuffer.prototype.isPrototypeOf(e)&&!c(e))throw new Error("unsupported BodyInit type");this._bodyArrayBuffer=v(e)}else this._bodyText="";this.headers.get("content-type")||("string"==typeof e?this.headers.set("content-type","text/plain;charset=UTF-8"):this._bodyBlob&&this._bodyBlob.type?this.headers.set("content-type",this._bodyBlob.type):t&&URLSearchParams.prototype.isPrototypeOf(e)&&this.headers.set("content-type","application/x-www-form-urlencoded;charset=UTF-8"))},r&&(this.blob=function(){var e=m(this);if(e)return e;if(this._bodyBlob)return Promise.resolve(this._bodyBlob);if(this._bodyArrayBuffer)return Promise.resolve(new Blob([this._bodyArrayBuffer]));if(this._bodyFormData)throw new Error("could not read FormData body as blob");return Promise.resolve(new Blob([this._bodyText]))},this.arrayBuffer=function(){return this._bodyArrayBuffer?m(this)||Promise.resolve(this._bodyArrayBuffer):this.blob().then(y)}),this.text=function(){var e,t,n,r=m(this);if(r)return r;if(this._bodyBlob)return e=this._bodyBlob,n=g(t=new FileReader),t.readAsText(e),n;if(this._bodyArrayBuffer)return Promise.resolve(function(e){for(var t=new Uint8Array(e),n=new Array(t.length),r=0;r<t.length;r++)n[r]=String.fromCharCode(t[r]);return n.join("")}(this._bodyArrayBuffer));if(this._bodyFormData)throw new Error("could not read FormData body as text");return Promise.resolve(this._bodyText)},o&&(this.formData=function(){return this.text().then(S)}),this.json=function(){return this.text().then(JSON.parse)},this}function b(e,t){var n,r,o=(t=t||{}).body;if(e instanceof b){if(e.bodyUsed)throw new TypeError("Already read");this.url=e.url,this.credentials=e.credentials,t.headers||(this.headers=new h(e.headers)),this.method=e.method,this.mode=e.mode,o||null==e._bodyInit||(o=e._bodyInit,e.bodyUsed=!0)}else this.url=String(e);if(this.credentials=t.credentials||this.credentials||"omit",!t.headers&&this.headers||(this.headers=new h(t.headers)),this.method=(r=(n=t.method||this.method||"GET").toUpperCase(),l.indexOf(r)>-1?r:n),this.mode=t.mode||this.mode||null,this.referrer=null,("GET"===this.method||"HEAD"===this.method)&&o)throw new TypeError("Body not allowed for GET or HEAD requests");this._initBody(o)}function S(e){var t=new FormData;return e.trim().split("&").forEach((function(e){if(e){var n=e.split("="),r=n.shift().replace(/\+/g," "),o=n.join("=").replace(/\+/g," ");t.append(decodeURIComponent(r),decodeURIComponent(o))}})),t}function C(e,t){t||(t={}),this.type="default",this.status="status"in t?t.status:200,this.ok=this.status>=200&&this.status<300,this.statusText="statusText"in t?t.statusText:"OK",this.headers=new h(t.headers),this.url=t.url||"",this._initBody(e)}}("undefined"!=typeof self?self:this)},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var r=n(4);t.default=function(e){function t(){Office.onReady((function(e){e.host===Office.HostType.Excel?function e(){CustomFunctionMappings&&CustomFunctionMappings.__delay__?setTimeout(e,50):r.CustomFunctions.initialize()}():console.warn("Warning: Expected to be loaded inside of an Excel add-in.")}))}window.CustomFunctions=window.CustomFunctions||{},window.CustomFunctions.setCustomFunctionInvoker=r.setCustomFunctionInvoker,window.CustomFunctions.Error=r.CustomFunctionError,window.CustomFunctions.ErrorCode=r.ErrorCode,window.CustomFunctions.FormattedNumber=r.CustomFunctionFormattedNumber,window.CustomFunctions.Entity=r.CustomFunctionEntity,window.CustomFunctions.WebImage=r.CustomFunctionWebImage,window.CustomFunctions.Attribution=r.CustomFunctionAttribution,window.CustomFunctions.Provider=r.CustomFunctionProvider,r.setCustomFunctionAssociation(window.CustomFunctions._association),e&&("loading"===document.readyState?document.addEventListener("DOMContentLoaded",t):t())}},function(e,t,n){"use strict";var r,o=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0}),t.CustomFunctionsContainer=t.CustomFunctions=t.setCustomFunctionInvoker=t.setCustomFunctionAssociation=t.customFunctionProxy=t.CustomFunctionProxy=t.CreateCustomFunctionInstance=t.CustomFunctionProvider=t.CustomFunctionAttribution=t.CustomFunctionWebImage=t.CustomFunctionFormattedNumber=t.CustomFunctionEntity=t.CustomFunctionError=t.ErrorCode=t.InvocationContext=t.Script=void 0;var i=n(0),a=n(0),s=i.BatchApiHelper.createPropertyObject,c=(i.BatchApiHelper.createMethodObject,i.BatchApiHelper.createIndexerObject,i.BatchApiHelper.createRootServiceObject),l=i.BatchApiHelper.createTopLevelServiceObject,u=(i.BatchApiHelper.createChildItemObject,i.BatchApiHelper.invokeMethod),d=(i.BatchApiHelper.invokeEnsureUnchanged,i.BatchApiHelper.invokeSetProperty,i.Utility.isNullOrUndefined),f=(i.Utility.isUndefined,i.Utility.throwIfNotLoaded,i.Utility.throwIfApiNotSupported),p=i.Utility.load,h=(i.Utility.retrieve,i.Utility.toJson),m=i.Utility.fixObjectPathIfNecessary,g=i.Utility._handleNavigationPropertyResults,y=(i.Utility.adjustToDateTime,i.Utility.processRetrieveResult),v=(i.Utility.setMockData,i.CommonUtility.calculateApiFlags,function(e){function t(t){var n=e.call(this,t)||this;return n.m_customFunctions=x.newObject(n),n.m_container=c(w,n),n._rootObject=n.m_container,n._rootObjectPropertyName="customFunctionsContainer",n._requestFlagModifier=2176,n}return o(t,e),Object.defineProperty(t.prototype,"customFunctions",{get:function(){return this.m_customFunctions},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"customFunctionsContainer",{get:function(){return this.m_container},enumerable:!1,configurable:!0}),t.prototype._processOfficeJsErrorResponse=function(e,t){5004===e&&(t.ErrorCode=T.invalidOperationInCellEditMode,t.ErrorMessage=i.Utility._getResourceString(i.ResourceStrings.invalidOperationInCellEditMode))},t}(i.ClientRequestContext));t.Script={_CustomFunctionMetadata:{}};var O,b=function(){function e(e,t,n,r,o){this._functionName=e,d(t)||(this._address=t),d(n)||(this._parameterAddresses=n),this.setResult=r,this.setError=o}return Object.defineProperty(e.prototype,"onCanceled",{get:function(){if(!d(this._onCanceled)&&"function"==typeof this._onCanceled)return this._onCanceled},set:function(e){this._onCanceled=e},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"functionName",{get:function(){return this._functionName},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"address",{get:function(){return this._address},enumerable:!1,configurable:!0}),Object.defineProperty(e.prototype,"parameterAddresses",{get:function(){return this._parameterAddresses},enumerable:!1,configurable:!0}),e}();t.InvocationContext=b,function(e){e.Info="Medium",e.Error="Unexpected",e.Verbose="Verbose"}(O||(O={}));var S,C=function(e,t){this.Severity=e,this.Message=t},_=function(){function e(){}return e.logEvent=function(t,n,r){if(e.s_shouldLog||i.CoreUtility._logEnabled){var o=t.Severity+" "+t.Message+n;if(r&&(o=o+" "+r),i.Utility.log(o),e.s_shouldLog)switch(t.Severity){case O.Verbose:null!==console.log&&console.log(o);break;case O.Info:null!==console.info&&console.info(o);break;case O.Error:null!==console.error&&console.error(o)}}},e.shouldLog=function(){try{return!d(console)&&!d(window)&&window.name&&"string"==typeof window.name&&JSON.parse(window.name)[e.CustomFunctionLoggingFlag]}catch(e){return i.Utility.log(JSON.stringify(e)),!1}},e.CustomFunctionLoggingFlag="CustomFunctionsRuntimeLogging",e.s_shouldLog=e.shouldLog(),e}();!function(e){e.invalidValue="#VALUE!",e.notAvailable="#N/A",e.divisionByZero="#DIV/0!",e.invalidNumber="#NUM!",e.nullReference="#NULL!",e.invalidName="#NAME?",e.invalidReference="#REF!"}(S=t.ErrorCode||(t.ErrorCode={}));var A=function(e){function t(n,r,o){var i=e.call(this,r||"")||this;return i.type=t.valueType,i.basicType=t.valueType,Object.setPrototypeOf(i,t.prototype),i.code=n||S.invalidValue,i.basicValue=n||S.invalidValue,i.errorSubType=o,i.stack=void 0,i}return o(t,e),t.prototype.toJSON=function(){return{valueType:"CustomFunctionError",code:this.code,type:this.type,basicValue:this.basicValue,basicType:this.type,errorSubType:this.errorSubType,message:this._getMessage(),errorType:this._getErrorType()}},t.prototype._getErrorType=function(){switch(this.basicValue){case S.invalidValue:return"Value";case S.divisionByZero:return"Div0";case S.notAvailable:return"NotAvailable";case S.invalidNumber:return"Num";case S.invalidName:return"Name";case S.invalidReference:return"Ref";case S.nullReference:return"Null";default:return}},t.prototype._getMessage=function(){switch(this.basicValue){case S.invalidValue:case S.notAvailable:return""==this.message?void 0:this.message;case S.divisionByZero:case S.invalidNumber:case S.invalidName:case S.invalidReference:case S.nullReference:default:return}},t.valueType="Error",t}(Error);t.CustomFunctionError=A;var D=function(){function e(t,n){this.type=e.valueType,this.basicValue="#VALUE!",this.basicType="Error",Object.setPrototypeOf(this,e.prototype),this.text=t,this.properties=n}return e.prototype.toJSON=function(){return{type:this.type,text:this.text,basicValue:this.basicValue,basicType:this.basicType,properties:this.properties}},e.valueType="Entity",e}();t.CustomFunctionEntity=D;var E=function(){function e(t,n){this.type=e.valueType,this.basicValue=t,this.numberFormat=n}return e.prototype.toJSON=function(){return{type:this.type,basicValue:this.basicValue,numberFormat:this.numberFormat}},e.valueType="FormattedNumber",e}();t.CustomFunctionFormattedNumber=E;var F=function(){function e(t,n,r,o,i){this.type=e.valueType,this.basicValue="#VALUE!",this.basicType="Error",this.address=t,null!=o&&(this.attribution=o),null!=i&&(this.provider=i),null!=n&&(this.altText=n),null!=r&&(this.relatedImagesAddress=r)}return e.prototype.toJSON=function(){return{type:this.type,basicValue:this.basicValue,basicType:this.basicType,address:this.address,altText:this.altText,relatedImagesAddress:this.relatedImagesAddress,attribution:null==this.attribution?void 0:this.attribution.map((function(e){return e.toJSON()})),provider:null==this.provider?void 0:this.provider.toJSON()}},e.valueType="WebImage",e}();t.CustomFunctionWebImage=F;var P=function(){function e(e,t,n,r){null!=e&&(this.licenseAddress=e),null!=t&&(this.licenseText=t),null!=n&&(this.sourceAddress=n),null!=r&&(this.sourceText=r)}return e.prototype.toJSON=function(){return{licenseAddress:this.licenseAddress,licenseText:this.licenseText,sourceAddress:this.sourceAddress,sourceText:this.sourceText}},e}();t.CustomFunctionAttribution=P;var R=function(){function e(e,t,n){this.description=e,null!=t&&(this.logoSourceAddress=t),null!=n&&(this.logoTargetAddress=n)}return e.prototype.toJSON=function(){return{description:this.description,logoSourceAddress:this.logoSourceAddress,logoTargetAddress:this.logoTargetAddress}},e}();t.CustomFunctionProvider=R,t.CreateCustomFunctionInstance=function e(t){if(t instanceof Array)return t.map((function(t){return e(t)}));if(!(t instanceof Object))return t;var n=JSON.parse(t.value);switch(n.type){case D.valueType:return new D(n.text,n.properties);case E.valueType:return new E(n.primitive,n.numberFormat);case A.valueType:return new A(n.primitive,void 0,n.errorSubCode);case F.valueType:return new F(n.address,n.altText,n.relatedImagesAddress,n.attribution,n.provider);case"Double":case"String":case"Boolean":return n.primitive;default:throw i.Utility.createRuntimeError(T.generalException,"message","CustomFunctionProxy.createRichDataFromJsonString")}};var I=function(){function e(){this._whenInit=void 0,this._isInit=!1,this._setResultsDelayMillis=50,this._setResultsOverdueDelayMillis=2e3,this._maxContextSyncExecutionDurationMills=15e3,this._minContextSyncIntervalMills=500,this._smallerMinContextSyncIntervalMills=200,this._maxContextSyncIntervalMills=2e3,this._setResultsLifeMillis=6e4,this._ensureInitRetryDelayMillis=500,this._resultEntryBuffer={},this._resultEntryRetryBuffer={},this._retryBufferBodySize=0,this._isSetResultsTaskScheduled=!1,this._setResultsTaskOverdueTime=0,this._inProgressContextSyncExpectedFinishTime=0,this._batchQuotaMillis=1e3,this._invocationContextMap={},this._maxResultSize=2e6}return e.prototype._initSettings=function(){if("object"==typeof t.Script&&"object"==typeof t.Script._CustomFunctionSettings){if("number"==typeof t.Script._CustomFunctionSettings.setResultsDelayMillis){var e=t.Script._CustomFunctionSettings.setResultsDelayMillis;e=Math.max(0,e),e=Math.min(1e3,e),this._setResultsDelayMillis=e}if("number"==typeof t.Script._CustomFunctionSettings.ensureInitRetryDelayMillis){var n=t.Script._CustomFunctionSettings.ensureInitRetryDelayMillis;n=Math.max(0,n),n=Math.min(2e3,n),this._ensureInitRetryDelayMillis=n}if("number"==typeof t.Script._CustomFunctionSettings.setResultsLifeMillis){var r=t.Script._CustomFunctionSettings.setResultsLifeMillis;r=Math.max(0,r),r=Math.min(6e5,r),this._setResultsLifeMillis=r}if("number"==typeof t.Script._CustomFunctionSettings.batchQuotaMillis){var o=t.Script._CustomFunctionSettings.batchQuotaMillis;o=Math.max(0,o),o=Math.min(1e3,o),this._batchQuotaMillis=o}}},e.prototype.ensureInit=function(e){var t=this;return this._initSettings(),void 0===this._whenInit&&(this._whenInit=i.Utility._createPromiseFromResult(null).then((function(){if(!t._isInit)return e.eventRegistration.register(5,"",t._handleMessage.bind(t))})).then((function(){t._isInit=!0}))),this._isInit||e._pendingRequest._addPreSyncPromise(this._whenInit),this._whenInit},e.prototype.setCustomFunctionInvoker=function(e){"object"==typeof CustomFunctionMappings&&delete CustomFunctionMappings.__delay__,this._invoker=e},e.prototype.setCustomFunctionAssociation=function(e){var t=this;this._customFunctionMappingsUpperCase=void 0,this._association=e,this._association&&this._association.onchange((function(){t._customFunctionMappingsUpperCase=void 0}))},e.prototype._initFromHostBridge=function(e){var t=this;this._initSettings(),e.addHostMessageHandler((function(e){3===e.type?t._handleMessage(e.message):4===e.type&&t._handleSettings(e.message)})),this._isInit=!0,this._whenInit=i.CoreUtility.Promise.resolve()},e.prototype._handleSettings=function(e){i.Utility.log("CustomFunctionProxy._handleSettings:"+JSON.stringify(e)),e&&"object"==typeof e&&(_.s_shouldLog=e[_.CustomFunctionLoggingFlag])},e.prototype._handleMessage=function(t){try{i.Utility.log("CustomFunctionProxy._handleMessage"),i.Utility.checkArgumentNull(t,"args");for(var n=t.entries,r=[],o=[],a=[],s=0;s<n.length;s++)1===n[s].messageCategory&&("string"==typeof n[s].message&&(n[s].message=JSON.parse(n[s].message)),1e3===n[s].messageType?r.push(n[s]):1001===n[s].messageType?o.push(n[s]):1002===n[s].messageType?a.push(n[s]):i.Utility.log("CustomFunctionProxy._handleMessage unknown message type "+n[s].messageType));if(a.length>0&&this._handleMetadataEntries(a),r.length>0){var c=this._batchInvocationEntries(r);c.length>0&&this._invokeRemainingBatchEntries(c,0)}o.length>0&&this._handleCancellationEntries(o)}catch(t){throw e._tryLog(t),t}return i.Utility._createPromiseFromResult(null)},e.toLogMessage=function(e){var t="Unknown Error";if(e)try{e.toString&&(t=e.toString()),t=t+" "+JSON.stringify(e)}catch(e){t="Unexpected Error"}return t},e._tryLog=function(t){var n=e.toLogMessage(t);i.Utility.log(n)},e.prototype._handleMetadataEntries=function(e){for(var n=0;n<e.length;n++){var r=e[n].message;if(d(r))throw i.Utility.createRuntimeError(T.generalException,"message","CustomFunctionProxy._handleMetadataEntries");t.Script._CustomFunctionMetadata[r.functionName]={options:{stream:r.isStream,cancelable:r.isCancelable}}}},e.prototype._handleCancellationEntries=function(t){for(var n=0;n<t.length;n++){var r=t[n].message;if(d(r))throw i.Utility.createRuntimeError(T.generalException,"message","CustomFunctionProxy._handleCancellationEntries");var o=r.invocationId,a=this._invocationContextMap[o];d(a)||(delete this._invocationContextMap[o],_.logEvent(e.CustomFunctionCancellation,a.functionName),d(a.onCanceled)||a.onCanceled())}},e.prototype._transferCustomFunctionError=function(e){var t=this;return e.map((function(e,n){return null===e?e:null!=e.code&&"CustomFunctionError"==e.type?new A(e.code):e instanceof Array?t._transferCustomFunctionError(e):e}))},e.prototype._transferCustomFunctionRichData=function(e){var t=this;return e.map((function(e,n){return e instanceof Array?t._transferCustomFunctionRichData(e):e instanceof Object?JSON.parse(e.value):e}))},e.prototype._batchInvocationEntries=function(n){for(var r=this,o=[],a=function(a){var c,l=n[a].message;if(Array.isArray(l)?(c={invocationId:l[0],functionName:l[1],parameterValues:l[2],address:l[3],flags:l[4],parameterAddresses:null},d(l[5])||(c.parameterAddresses=l[5])):c=l,d(c))throw i.Utility.createRuntimeError(T.generalException,"message","CustomFunctionProxy._batchInvocationEntries");if(d(c.invocationId)||c.invocationId<0)throw i.Utility.createRuntimeError(T.generalException,"invocationId","CustomFunctionProxy._batchInvocationEntries");if(d(c.functionName))throw i.Utility.createRuntimeError(T.generalException,"functionName","CustomFunctionProxy._batchInvocationEntries");var u=null,f=!1,p=!1,h=!1;if("number"==typeof c.flags)f=0!=(1&c.flags),p=0!=(2&c.flags),h=0!=(4&c.flags),0!=(8&c.flags)&&(c.parameterValues=s._transferCustomFunctionRichData(c.parameterValues)),h&&(c.parameterValues=s._transferCustomFunctionError(c.parameterValues));else{var m=t.Script._CustomFunctionMetadata[c.functionName];if(d(m))return _.logEvent(e.CustomFunctionExecutionNotFoundLog,c.functionName),i.Utility.isSetSupported("CustomFunctions","1.8")?s._setError(c.invocationId,null,9):s._setError(c.invocationId,"N/A",1),"continue";f=m.options.cancelable,p=m.options.stream}if(s._invoker&&!s._customFunctionMappingsContains(c.functionName))return s._invokeFunctionUsingInvoker(c),"continue";try{u=s._getFunction(c.functionName)}catch(t){return _.logEvent(e.CustomFunctionExecutionNotFoundLog,c.functionName),i.Utility.isSetSupported("CustomFunctions","1.8")?s._setError(c.invocationId,t,10):s._setError(c.invocationId,t,1),"continue"}var g=void 0;if(p||f){var y=void 0,v=void 0;p&&(y=function(t){r._invocationContextMap[c.invocationId]?r._setResult(c.invocationId,t):_.logEvent(e.CustomFunctionAlreadyCancelled,c.functionName)},v=function(t){r._invocationContextMap[c.invocationId]?r._setError(c.invocationId,t.message,r._getCustomFunctionResultErrorCodeFromErrorCode(t.code)):_.logEvent(e.CustomFunctionAlreadyCancelled,c.functionName)}),g=new b(c.functionName,c.address,c.parameterAddresses,y,v),s._invocationContextMap[c.invocationId]=g}else g=new b(c.functionName,c.address,c.parameterAddresses);c.parameterValues.push(g),o.push({call:u,isBatching:!1,isStreaming:p,invocationIds:[c.invocationId],parameterValueSets:[c.parameterValues],functionName:c.functionName})},s=this,c=0;c<n.length;c++)a(c);return o},e.prototype._invokeFunctionUsingInvoker=function(e){var t=this,n=0!=(1&e.flags),r=0!=(2&e.flags),o=e.invocationId,i=void 0,a=void 0;if(r)i=function(e){t._invocationContextMap[o]&&t._setResult(o,e)},a=function(e){t._invocationContextMap[o]&&t._setError(o,e.message,t._getCustomFunctionResultErrorCodeFromErrorCode(e.code))};else{var s=!1;i=function(e){s||t._setResult(o,e),s=!0},a=function(e){s||t._setError(o,e.message,t._getCustomFunctionResultErrorCodeFromErrorCode(e.code)),s=!0}}var c=new b(e.functionName,e.address,e.parameterAddresses,i,a);(r||n)&&(this._invocationContextMap[o]=c),this._invoker.invoke(e.functionName,e.parameterValues,c)},e.prototype._ensureCustomFunctionMappingsUpperCase=function(){if(d(this._customFunctionMappingsUpperCase)){if(this._customFunctionMappingsUpperCase={},"object"==typeof CustomFunctionMappings)for(var t in i.CoreUtility.log("CustomFunctionMappings.Keys="+JSON.stringify(Object.keys(CustomFunctionMappings))),CustomFunctionMappings)this._customFunctionMappingsUpperCase[t.toUpperCase()]&&_.logEvent(e.CustomFunctionDuplicatedName,t),this._customFunctionMappingsUpperCase[t.toUpperCase()]=CustomFunctionMappings[t];if(this._association)for(var t in i.CoreUtility.log("CustomFunctionAssociateMappings.Keys="+JSON.stringify(Object.keys(this._association.mappings))),this._association.mappings)this._customFunctionMappingsUpperCase[t.toUpperCase()]&&_.logEvent(e.CustomFunctionDuplicatedName,t),this._customFunctionMappingsUpperCase[t.toUpperCase()]=this._association.mappings[t]}},e.prototype._customFunctionMappingsContains=function(e){this._ensureCustomFunctionMappingsUpperCase();var t=e.toUpperCase();if(!d(this._customFunctionMappingsUpperCase[t]))return!0;if("undefined"!=typeof window){for(var n=window,r=e.split("."),o=0;o<r.length-1;o++)if(n=n[r[o]],d(n)||"object"!=typeof n)return!1;if("function"==typeof n[r[r.length-1]])return!0}return!1},e.prototype._getCustomFunctionMappings=function(e){this._ensureCustomFunctionMappingsUpperCase();var t=e.toUpperCase();if(!d(this._customFunctionMappingsUpperCase[t])){if("function"==typeof this._customFunctionMappingsUpperCase[t])return this._customFunctionMappingsUpperCase[t];throw i.Utility.createRuntimeError(T.invalidOperation,i.Utility._getResourceString(i.ResourceStrings.customFunctionInvalidFunctionMapping,e),"CustomFunctionProxy._getCustomFunctionMappings")}},e.prototype._getFunction=function(e){return this._getCustomFunctionMappings(e)},e.prototype._invokeRemainingBatchEntries=function(e,t){i.Utility.log("CustomFunctionProxy._invokeRemainingBatchEntries");for(var n=Date.now(),r=t;r<e.length;r++){if(!(Date.now()-n<this._batchQuotaMillis)){i.Utility.log("setTimeout(CustomFunctionProxy._invokeRemainingBatchEntries)"),setTimeout(this._invokeRemainingBatchEntries.bind(this),0,e,r);break}this._invokeFunctionAndSetResult(e[r])}},e.prototype._invokeFunctionAndSetResult=function(t){var n,r=this;_.logEvent(e.CustomFunctionExecutionStartLog,t.functionName);var o=Date.now();try{n=t.isBatching?t.call.call(null,t.parameterValueSets):[t.call.apply(null,t.parameterValueSets[0])]}catch(n){var a=[];a.push(Date.now()-o);for(var s=0;s<t.invocationIds.length;s++)n instanceof A?this._setErrorWithOutboundData(t.invocationIds[s],n.message,this._getCustomFunctionResultErrorCodeFromErrorCode(n.code),a):this._setErrorWithOutboundData(t.invocationIds[s],n,2,a);return void _.logEvent(e.CustomFunctionExecutionExceptionThrownLog,t.functionName,e.toLogMessage(n))}var c=[];if(x.isFeatureEnabled(3)||c.push(Date.now()-o),t.isStreaming);else if(n.length===t.parameterValueSets.length){var l=function(i){d(n[i])||"object"!=typeof n[i]||"function"!=typeof n[i].then?(x.isFeatureEnabled(3)&&c.push(Date.now()-o),_.logEvent(e.CustomFunctionExecutionFinishLog,t.functionName),u._setResultWithOutboundData(t.invocationIds[i],n[i],c)):n[i].then((function(n){x.isFeatureEnabled(3)&&c.push(Date.now()-o),_.logEvent(e.CustomFunctionExecutionFinishLog,t.functionName),r._setResultWithOutboundData(t.invocationIds[i],n,c)}),(function(n){x.isFeatureEnabled(3)&&c.push(Date.now()-o),_.logEvent(e.CustomFunctionExecutionRejectedPromoseLog,t.functionName,e.toLogMessage(n)),n instanceof A?r._setErrorWithOutboundData(t.invocationIds[i],n,r._getCustomFunctionResultErrorCodeFromErrorCode(n.code),c):r._setErrorWithOutboundData(t.invocationIds[i],n,3,c)}))},u=this;for(s=0;s<n.length;s++)l(s)}else for(x.isFeatureEnabled(3)&&c.push(Date.now()-o),_.logEvent(e.CustomFunctionExecutionBatchMismatchLog,t.functionName),s=0;s<t.invocationIds.length;s++)this._setErrorWithOutboundData(t.invocationIds[s],i.Utility._getResourceString(i.ResourceStrings.customFunctionUnexpectedNumberOfEntriesInResultBatch),4,c)},e.prototype._setResult=function(e,t){var n=[];n.push(0),this._setResultWithOutboundData(e,t,n)},e.prototype._setResultWithOutboundData=function(t,n,r){var o={id:t,value:n,outboundData:r};"number"==typeof n?isNaN(n)?(o.failed=!0,o.value="NaN"):isFinite(n)||(o.failed=!0,o.value="Infinity",o.errorCode=6):n instanceof A||n instanceof D||n instanceof E||n instanceof F?(o.failed=!1,o.value=n.toJSON()):n instanceof Error&&(o.failed=!0,o.value=e.toLogMessage(n),o.errorCode=0);var i=Date.now();this._resultEntryBuffer[t]={timeCreated:i,result:o},this._ensureSetResultsTaskIsScheduled(i)},e.prototype._setError=function(e,t,n){var r=[];r.push(0),this._setErrorWithOutboundData(e,t,n,r)},e.prototype._setErrorWithOutboundData=function(e,t,n,r){var o="";d(t)||(t instanceof A&&!d(t.message)?o=t.message:"string"==typeof t&&(o=t));var i={id:e,failed:!0,value:o,errorCode:n,outboundData:r},a=Date.now();this._resultEntryBuffer[e]={timeCreated:a,result:i},this._ensureSetResultsTaskIsScheduled(a)},e.prototype._getCustomFunctionResultErrorCodeFromErrorCode=function(e){var t;switch(e){case S.notAvailable:t=1;break;case S.divisionByZero:t=5;break;case S.invalidValue:t=7;break;case S.invalidNumber:t=6;break;case S.nullReference:t=8;break;default:t=7}return t},e.prototype._ensureSetResultsTaskIsScheduled=function(e){if(this._setResultsTaskOverdueTime>0&&e>this._setResultsTaskOverdueTime)return i.Utility.log("SetResultsTask overdue"),void this._executeSetResultsTask();this._isSetResultsTaskScheduled||(i.Utility.log("setTimeout(CustomFunctionProxy._executeSetResultsTask)"),setTimeout(this._executeSetResultsTask.bind(this),this._setResultsDelayMillis),this._isSetResultsTaskScheduled=!0,this._setResultsTaskOverdueTime=e+this._setResultsDelayMillis+this._setResultsOverdueDelayMillis)},e.prototype._convertCustomFunctionInvocationResultToArray=function(e){var t=[];return t.push(e.id),t.push(!e.failed),i.CoreUtility.isUndefined(e.value)?t.push(null):t.push(e.value),e.failed&&(i.CoreUtility.isUndefined(e.errorCode)?t.push(0):t.push(e.errorCode)),i.Utility.isSetSupported("CustomFunctions","1.9")&&t.push(e.outboundData),t},e.prototype._executeSetResultsTask=function(){var e=this;i.Utility.log("CustomFunctionProxy._executeSetResultsTask");var t=Date.now();if(this._inProgressContextSyncExpectedFinishTime>0&&this._inProgressContextSyncExpectedFinishTime>t)return i.Utility.log("context.sync() is in progress. setTimeout(CustomFunctionProxy._executeSetResultsTask)"),setTimeout(this._executeSetResultsTask.bind(this),this._setResultsDelayMillis),void(this._setResultsTaskOverdueTime=t+this._setResultsDelayMillis+this._setResultsOverdueDelayMillis);this._isSetResultsTaskScheduled=!1,this._setResultsTaskOverdueTime=0;var n={},r=!1;x.isFeatureEnabled(1)&&Object.keys(this._resultEntryRetryBuffer).length>0?(n=this._resultEntryRetryBuffer,this._resultEntryRetryBuffer={},this._retryBufferBodySize=2,r=!0):(n=this._resultEntryBuffer,this._resultEntryBuffer={});var o=i.Utility.isSetSupported("CustomFunctions","1.7"),a=[];for(var s in n)o?a.push(this._convertCustomFunctionInvocationResultToArray(n[s].result)):a.push(n[s].result);if(0!==a.length){var c=new v;o?c.customFunctions.setInvocationArrayResults(a):c.customFunctions.setInvocationResults(a);var l=Date.now();this._inProgressContextSyncExpectedFinishTime=l+this._maxContextSyncExecutionDurationMills,c.sync().then((function(t){var n=Date.now();e._clearInProgressContextSyncExpectedFinishTimeAfterMinInterval(n-l),r&&e._ensureSetResultsTaskIsScheduled(n)}),(function(t){var r=Date.now();e._clearInProgressContextSyncExpectedFinishTimeAfterMinInterval(r-l),x.isFeatureEnabled(1)&&t.code==i.ErrorCodes.requestPayloadSizeLimitExceeded?e._restoreAndSliceResultEntries(r,n):e._restoreResultEntries(r,n),e._ensureSetResultsTaskIsScheduled(r)}))}},e.prototype._restoreResultEntries=function(e,t){for(var n in t){var r=t[n];e-r.timeCreated<=this._setResultsLifeMillis&&(this._resultEntryBuffer[n]||(this._resultEntryBuffer[n]=r))}},e.prototype._restoreAndSliceResultEntries=function(e,t){for(var n in t){var r=t[n],o=void 0;if(e-r.timeCreated<=this._setResultsLifeMillis&&!this._resultEntryBuffer[n]){try{o=JSON.stringify(this._convertCustomFunctionInvocationResultToArray(r.result)).length+1}catch(e){this._resultEntryBuffer[n]=r,i.Utility.log("Result can't pass in JSON.stringify");continue}this._retryBufferBodySize+o<this._maxResultSize?(this._resultEntryRetryBuffer[n]=r,this._retryBufferBodySize+=o):this._resultEntryBuffer[n]=r}}},e.prototype._clearInProgressContextSyncExpectedFinishTimeAfterMinInterval=function(e){var t=this,n=x.isFeatureEnabled(2)?this._smallerMinContextSyncIntervalMills:this._minContextSyncIntervalMills,r=Math.max(n,2*e),o=x.isFeatureEnabled(4)?Math.min(this._maxContextSyncIntervalMills,r):r;i.Utility.log("setTimeout(clearInProgressContestSyncExpectedFinishedTime,"+r+")"),setTimeout((function(){i.Utility.log("clearInProgressContestSyncExpectedFinishedTime"),t._inProgressContextSyncExpectedFinishTime=0}),o)},e.CustomFunctionExecutionStartLog=new C(O.Verbose,"CustomFunctions [Execution] [Begin] Function="),e.CustomFunctionExecutionFailureLog=new C(O.Error,"CustomFunctions [Execution] [End] [Failure] Function="),e.CustomFunctionExecutionRejectedPromoseLog=new C(O.Error,"CustomFunctions [Execution] [End] [Failure] [RejectedPromise] Function="),e.CustomFunctionExecutionExceptionThrownLog=new C(O.Error,"CustomFunctions [Execution] [End] [Failure] [ExceptionThrown] Function="),e.CustomFunctionExecutionBatchMismatchLog=new C(O.Error,"CustomFunctions [Execution] [End] [Failure] [BatchMismatch] Function="),e.CustomFunctionExecutionFinishLog=new C(O.Info,"CustomFunctions [Execution] [End] [Success] Function="),e.CustomFunctionExecutionNotFoundLog=new C(O.Error,"CustomFunctions [Execution] [NotFound] Function="),e.CustomFunctionCancellation=new C(O.Info,"CustomFunctions [Cancellation] Function="),e.CustomFunctionAlreadyCancelled=new C(O.Info,"CustomFunctions [AlreadyCancelled] Function="),e.CustomFunctionDuplicatedName=new C(O.Error,"CustomFunctions [DuplicatedName] Function="),e.CustomFunctionInvalidArg=new C(O.Error,"CustomFunctions [InvalidArg] Name="),e}();t.CustomFunctionProxy=I,t.customFunctionProxy=new I,t.setCustomFunctionAssociation=t.customFunctionProxy.setCustomFunctionAssociation.bind(t.customFunctionProxy),t.setCustomFunctionInvoker=t.customFunctionProxy.setCustomFunctionInvoker.bind(t.customFunctionProxy),a.HostBridge.onInited((function(e){t.customFunctionProxy._initFromHostBridge(e)}));var x=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return o(n,e),Object.defineProperty(n.prototype,"_className",{get:function(){return"CustomFunctions"},enumerable:!1,configurable:!0}),n.isFeatureEnabled=function(e){return this._enabledFeature instanceof Array&&this._enabledFeature.indexOf(e)>=0},n.initialize=function(){var e=this,r=new v;return t.customFunctionProxy.ensureInit(r).then((function(){var o;return r.customFunctions._SetOsfControlContainerReadyForCustomFunctions(),i.Utility.isSetSupported("CustomFunctions","1.9")&&(o=r.customFunctions._GetEnabledFeatures()),i.Utility.log("OsfControl activation lifecycle: Set OsfControlContainer ready for CustomFunctions"),r._customData="SetOsfControlContainerReadyForCustomFunctions",r.sync().then((function(){d(o)||(e._enabledFeature=o.value)})).catch((function(e){!function(e,r){var o=e instanceof i.Error&&e.code===T.invalidOperationInCellEditMode;if(i.CoreUtility.log("Error on starting custom functions: "+e),o){i.CoreUtility.log("Was in cell-edit mode, will try again");var a=t.customFunctionProxy._ensureInitRetryDelayMillis;return new i.CoreUtility.Promise((function(e){return setTimeout(e,a)})).then((function(){return n.initialize()}))}throw e}(e)}))}))},n.prototype.setInvocationArrayResults=function(e){f("CustomFunctions.setInvocationArrayResults","CustomFunctions","1.4","Excel"),u(this,"SetInvocationArrayResults",0,[e],2,0)},n.prototype.setInvocationResults=function(e){u(this,"SetInvocationResults",0,[e],2,0)},n.prototype._GetEnabledFeatures=function(){return f("CustomFunctions._GetEnabledFeatures","CustomFunctions","1.4","Excel"),u(this,"_GetEnabledFeatures",1,[],4,0)},n.prototype._SetInvocationError=function(e,t){u(this,"_SetInvocationError",0,[e,t],2,0)},n.prototype._SetInvocationResult=function(e,t){u(this,"_SetInvocationResult",0,[e,t],2,0)},n.prototype._SetOsfControlContainerReadyForCustomFunctions=function(){u(this,"_SetOsfControlContainerReadyForCustomFunctions",0,[],10,0)},n.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),d(t)||m(this,t)},n.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),y(this,t,n)},n.newObject=function(e){return l(n,e,"Microsoft.ExcelServices.CustomFunctions",!1,4)},n.prototype.toJSON=function(){return h(this,{},{})},n}(i.ClientObject);t.CustomFunctions=x;var T,w=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"CustomFunctionsContainer"},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"_navigationPropertyNames",{get:function(){return["customFunctions"]},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"customFunctions",{get:function(){return f("CustomFunctionsContainer.customFunctions","CustomFunctions","1.2","Excel"),this._C||(this._C=s(x,this,"CustomFunctions",!1,4)),this._C},enumerable:!1,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!d(t)){var n=t;m(this,n),g(this,n,["customFunctions","CustomFunctions"])}},t.prototype.load=function(e){return p(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),y(this,t,n)},t.prototype.toJSON=function(){return h(this,{},{})},t}(i.ClientObject);t.CustomFunctionsContainer=w,function(e){e.generalException="GeneralException",e.invalidOperation="InvalidOperation",e.invalidOperationInCellEditMode="InvalidOperationInCellEditMode"}(T||(T={}))}]),OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithOTel=!0,OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithLegacyAria=!1,window.OfficeExtensionBatch=window.OfficeExtension,function(e){var t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,n),o.l=!0,o.exports}n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)n.d(r,o,function(t){return e[t]}.bind(null,o));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=1)}([function(e,t){e.exports=OfficeExtensionBatch},function(e,t,n){"use strict";var r=this&&this.__assign||function(){return(r=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var o in t=arguments[n])Object.prototype.hasOwnProperty.call(t,o)&&(e[o]=t[o]);return e}).apply(this,arguments)};Object.defineProperty(t,"__esModule",{value:!0});var o,i,a=n(2),s=n(4),c=n(5),l=n(6),u=n(7),d=n(8),f=n(9),p=n(12),h=n(13);"undefined"!=typeof OSF&&OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&0!=(1&OSF._OfficeAppFactory.getHostInfo().flags)?(o=l,i=u.storage):(o=c.AsyncStorage,i=c.storage),window._OfficeRuntimeNative=r(r({},window.OfficeRuntime),{displayWebDialog:s.displayWebDialog,AsyncStorage:o,storage:i,experimentation:d.experimentation,apiInformation:a.apiInformation,message:f.Message.instance,ui:p.ui,auth:h.Auth.instance}),Object.freeze(window._OfficeRuntimeNative)},function(e,t,n){"use strict";(function(e){function n(e){var t,n=e.split("."),r=0,o=0;if(n.length<2&&isNaN(Number(e)))throw"version format incorrect";if(t=Number(n[0]),n.length>=2&&(r=Number(n[1])),n.length>=3&&(o=Number(n[2])),isNaN(t)||isNaN(r)||isNaN(o))throw"version format incorrect";return{major:t,minor:r,patch:o}}Object.defineProperty(t,"__esModule",{value:!0}),t.apiInformation=void 0,t.apiInformation={isSetSupported:function(t,r){if("string"!=typeof t)return!1;if(null==r&&(r="0.0.0"),void 0===e.__apiSets)return!1;var o=e.__apiSets,i=Object.keys(o).map((function(e){return e.toLowerCase()})).indexOf(t.toLowerCase());if(i>-1){var a=o[Object.keys(o)[i]];try{var s,c=n(r);if((s=Array.isArray(a)?function(e,t){for(var r=0;r<e.length;r++){var o=n(e[r]);if(o.major==t)return o}return{major:0,minor:0,patch:0}}(a,c.major):n(a)).major>0){if(s.major>c.major)return!0;if(s.major==c.major&&s.minor>c.minor)return!0;if(s.major==c.major&&s.minor==c.minor&&s.patch>=c.patch)return!0}}catch(e){return!1}}return!1}}}).call(this,n(3))},function(e,t){var n;n=function(){return this}();try{n=n||new Function("return this")()}catch(e){"object"==typeof window&&(n=window)}e.exports=n},function(e,t,n){"use strict";var r,o=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0}),t.DialogErrorCodes=t.DialogService=t.displayWebDialog=t.Dialog=void 0;var i=n(0),a=(i.BatchApiHelper.createPropertyObject,i.BatchApiHelper.createMethodObject,i.BatchApiHelper.createIndexerObject,i.BatchApiHelper.createRootServiceObject,i.BatchApiHelper.createTopLevelServiceObject),s=(i.BatchApiHelper.createChildItemObject,i.BatchApiHelper.invokeMethod),c=(i.BatchApiHelper.invokeEnsureUnchanged,i.BatchApiHelper.invokeSetProperty,i.Utility.isNullOrUndefined),l=(i.Utility.isUndefined,i.Utility.throwIfNotLoaded,i.Utility.throwIfApiNotSupported,i.Utility.load,i.Utility.retrieve,i.Utility.toJson),u=i.Utility.fixObjectPathIfNecessary,d=(i.Utility._handleNavigationPropertyResults,i.Utility.adjustToDateTime,i.Utility.processRetrieveResult),f=(i.Utility.setMockData,i.CommonUtility.calculateApiFlags,function(){function e(e){this._dialogService=e}return e.prototype.close=function(){return this._dialogService.close(),this._dialogService.context.sync()},e}());t.Dialog=f,t.displayWebDialog=function(e,t){return void 0===t&&(t={}),new i.CoreUtility.Promise((function(r,o){if(t.width&&t.height&&(!n(t.width)||!n(t.height)))throw new i.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var a=new i.ClientRequestContext,s=h.newObject(a),c=new f(s),l=s.onDialogMessage.add((function(e){switch(i.Utility.log("dialogMessageHandler:"+JSON.stringify(e)),e.type){case 17:e.error?o(e.error):r(c);break;case 12:t.onMessage&&t.onMessage(e.message,c,e.origin);break;case 10:default:12006===e.originalErrorCode?(l&&(l.remove(),a.sync()),t.onClose&&t.onClose()):t.onRuntimeError&&(t.onRuntimeError(e.error,c),o(e.error))}return i.CoreUtility.Promise.resolve()}));return a.sync().then((function(){var n={width:t.width?parseInt(t.width):50,height:t.height?parseInt(t.height):50,displayInIFrame:t.displayInIFrame};return s.displayDialog(e,n),a.sync()})).catch((function(e){o(e)}))}));function n(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}};var p,h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"DialogService"},enumerable:!1,configurable:!0}),t.prototype.close=function(){s(this,"Close",1,[],4,0)},t.prototype.displayDialog=function(e,t){s(this,"DisplayDialog",1,[e,t],4,0)},t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),c(t)||u(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),d(this,t,n)},t.newObject=function(e){return a(t,e,"Microsoft.Dialog.DialogService",!1,4)},Object.defineProperty(t.prototype,"onDialogMessage",{get:function(){return this.m_dialogMessage||(this.m_dialogMessage=new i.GenericEventHandlers(this.context,this,"DialogMessage",{eventType:65536,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return null},eventArgsTransformFunc:function(e){var t,n,r,o;try{var a=JSON.parse(e.message),s=a.errorCode?new i.Error((n=a.errorCode,(r={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},r[12003]={code:"InvalidUrl",message:"HTTPS is required."},r[12004]={code:"Untrusted",message:"Domain is not trusted."},r[12005]={code:"InvalidUrl",message:"HTTPS is required."},r[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},(o=r)[n]?o[n]:{code:"Unknown",message:"An unknown error has occured with code: "+n})):null;t={originalErrorCode:a.errorCode,type:a.type,error:s,message:a.message,origin:a.origin}}catch(e){t={originalErrorCode:null,type:17,error:new i.Error({code:"GenericException",message:"Unknown error"}),message:e.message}}return i.Utility._createPromiseFromResult(t)}})),this.m_dialogMessage},enumerable:!1,configurable:!0}),t.prototype.toJSON=function(){return l(this,{},{})},t}(i.ClientObject);t.DialogService=h,function(e){e[e.dialogMessageReceived=0]="dialogMessageReceived",e[e.dialogEventReceived=1]="dialogEventReceived"}(p||(p={})),function(e){e.generalException="GeneralException"}(t.DialogErrorCodes||(t.DialogErrorCodes={}))},function(e,t,n){"use strict";var r,o=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0}),t.ErrorCodes=t.PersistentKvStorageService=t.storage=t.AsyncStorage=void 0;var i=n(0),a=(i.BatchApiHelper.createPropertyObject,i.BatchApiHelper.createMethodObject,i.BatchApiHelper.createIndexerObject,i.BatchApiHelper.createRootServiceObject,i.BatchApiHelper.createTopLevelServiceObject),s=(i.BatchApiHelper.createChildItemObject,i.BatchApiHelper.invokeMethod),c=(i.BatchApiHelper.invokeEnsureUnchanged,i.BatchApiHelper.invokeSetProperty,i.Utility.isNullOrUndefined),l=(i.Utility.isUndefined,i.Utility.throwIfNotLoaded,i.Utility.throwIfApiNotSupported,i.Utility.load,i.Utility.retrieve,i.Utility.toJson),u=i.Utility.fixObjectPathIfNecessary,d=(i.Utility._handleNavigationPropertyResults,i.Utility.adjustToDateTime,i.Utility.processRetrieveResult);function f(e,t){return new i.CoreUtility.Promise((function(n,r){var o=h.getInstance(),i=o.setCallBack((function(e,o){if(o)r(o);else{var i=t(e);n(i)}}));o.ctx.sync().then((function(){var t=o.getPersistentKvStorageService();return e(t,i),o.ctx.sync()})).catch((function(e){r(e)}))}))}function p(e,t,n){return new i.CoreUtility.Promise((function(r,o){var i=h.getInstance(),a=i.setCallBack((function(e,i){if(i)return n&&n(i),void o(i);var a=t(e);n&&n(null,a),r(a)}));i.ctx.sync().then((function(){var t=i.getPersistentKvStorageService();return e(t,a),i.ctx.sync()})).catch((function(e){o(e)}))}))}i.Utility.setMockData,i.CommonUtility.calculateApiFlags,t.AsyncStorage={getItem:function(e,t){return p((function(t,n){return t.multiGet(n,JSON.stringify([e]))}),(function(e){var t=JSON.parse(e);return t&&t[0]&&t[0][1]?t[0][1]:null}),t)},setItem:function(e,t,n){return p((function(n,r){return n.multiSet(r,JSON.stringify([[e,t]]))}),(function(){return null}),n)},removeItem:function(e,t){return p((function(t,n){return t.multiRemove(n,JSON.stringify([e]))}),(function(){return null}),t)},multiGet:function(e,t){return p((function(t,n){return t.multiGet(n,JSON.stringify(e))}),(function(t){var n=JSON.parse(t),r={};return n&&n.forEach((function(e){var t=e[0],n=e[1];return r[t]=n,n})),e.map((function(e){return[e,r[e]?r[e]:null]}))}),t)},multiSet:function(e,t){return p((function(t,n){return t.multiSet(n,JSON.stringify(e))}),(function(){return null}),t)},multiRemove:function(e,t){return p((function(t,n){return t.multiRemove(n,JSON.stringify(e))}),(function(){return null}),t)},getAllKeys:function(e){return p((function(e,t){return e.getAllKeys(t)}),(function(e){return JSON.parse(e)}),e)},clear:function(e){return p((function(e,t){return e.clear(t)}),(function(){return null}),e)}},t.storage={getItem:function(e){return f((function(t,n){return t.multiGet(n,JSON.stringify([e]))}),(function(e){var t=JSON.parse(e);return t&&t[0]&&t[0][1]?t[0][1]:null}))},setItem:function(e,t){return f((function(n,r){return n.multiSet(r,JSON.stringify([[e,t]]))}),(function(){return null}))},removeItem:function(e){return f((function(t,n){return t.multiRemove(n,JSON.stringify([e]))}),(function(){return null}))},getItems:function(e){return f((function(t,n){return t.multiGet(n,JSON.stringify(e))}),(function(t){var n=JSON.parse(t),r={};return e.forEach((function(e){r[e]=null})),n&&n.forEach((function(e){var t=e[0],n=e[1];return r[t]=n,n})),r}))},setItems:function(e){var t=[];for(var n in e)e.hasOwnProperty(n)&&t.push([n,e[n]]);return f((function(e,n){return e.multiSet(n,JSON.stringify(t))}),(function(){return null}))},removeItems:function(e){return f((function(t,n){return t.multiRemove(n,JSON.stringify(e))}),(function(){return null}))},getKeys:function(){return f((function(e,t){return e.getAllKeys(t)}),(function(e){return JSON.parse(e)}))}};var h=function(){function e(){var e=this;this._invokeId=0,this._callDict={},this.ctx=new i.ClientRequestContext,this._perkvstorService=m.newObject(this.ctx),this._eventResult=this._perkvstorService.onPersistentStorageMessage.add((function(t){i.Utility.log("persistentKvStoragegMessageHandler:"+JSON.stringify(t));var n=e._callDict[t.invokeId];n&&(n(t.message,t.error),delete e._callDict[t.invokeId])}))}return e.getInstance=function(){return void 0===e.instance?e.instance=new e:e.instance._perkvstorService=m.newObject(e.instance.ctx),e.instance},e.prototype.getPersistentKvStorageService=function(){return this._perkvstorService},e.prototype.getCallBack=function(e){return this._callDict[e]},e.prototype.setCallBack=function(e){var t=this._invokeId;return this._callDict[this._invokeId++]=e,t},e}(),m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersistentKvStorageService"},enumerable:!1,configurable:!0}),t.prototype.clear=function(e){s(this,"Clear",1,[e],4,0)},t.prototype.getAllKeys=function(e){s(this,"GetAllKeys",1,[e],4,0)},t.prototype.multiGet=function(e,t){s(this,"MultiGet",1,[e,t],4,0)},t.prototype.multiRemove=function(e,t){s(this,"MultiRemove",1,[e,t],4,0)},t.prototype.multiSet=function(e,t){s(this,"MultiSet",1,[e,t],4,0)},t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),c(t)||u(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),d(this,t,n)},t.newObject=function(e){return a(t,e,"Microsoft.PersistentKvStorage.PersistentKvStorageService",!1,4)},Object.defineProperty(t.prototype,"onPersistentStorageMessage",{get:function(){return this.m_persistentStorageMessage||(this.m_persistentStorageMessage=new i.GenericEventHandlers(this.context,this,"PersistentStorageMessage",{eventType:65537,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return null},eventArgsTransformFunc:function(e){var t,n,r,o;try{var a=JSON.parse(e.message),s=parseInt(a.errorCode),c=0!=s?new i.Error((n=s,(r={})[16389]={code:"GenericException",message:"Unknown error."},r[65535]={code:"Unexcepted",message:"Catastrophic failure."},r[14]={code:"OutOfMemory",message:"Ran out of memory."},r[87]={code:"InvalidArg",message:"One or more arguments are invalid."},r[16385]={code:"NotImplemented",message:"Not implemented."},r[6]={code:"BadHandle",message:"File Handle is not Set."},r[5]={code:"AccessDenied",message:"Can't read the Storage File."},(o=r)[n]?o[n]:{code:"Unknown",message:"An unknown error has occured"})):null;t={invokeId:a.invokeId,message:a.message,error:c}}catch(e){t={invokeId:-1,message:e.message,error:new i.Error({code:"GenericException",message:"Unknown error"})}}return i.Utility._createPromiseFromResult(t)}})),this.m_persistentStorageMessage},enumerable:!1,configurable:!0}),t.prototype.toJSON=function(){return l(this,{},{})},t}(i.ClientObject);t.PersistentKvStorageService=m,function(e){e.generalException="GeneralException"}(t.ErrorCodes||(t.ErrorCodes={}))},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiGet=t.multiRemove=t.multiSet=t.getAllKeys=t.clear=t.removeItem=t.setItem=t.getItem=void 0;var r="_Office_AsyncStorage_";function o(){window.localStorage.setItem("_Office_AsyncStorage_|_unusedKey_",null),window.localStorage.removeItem("_Office_AsyncStorage_|_unusedKey_")}function i(e,t){return void 0===t&&(t=function(){}),new Promise((function(n,r){try{o(),e(),t(null),n()}catch(e){t(e),r(e)}}))}function a(e,t){return void 0===t&&(t=function(){}),new Promise((function(n,r){try{o();var i=e();t(null,i),n(i)}catch(e){t(e,null),r(e)}}))}function s(e,t,n){return void 0===n&&(n=function(){}),new Promise((function(r,i){var a=[];try{o()}catch(e){a.push(e)}e.forEach((function(e){try{t(e)}catch(e){a.push(e)}})),n(a),a.length>0?i(a):r()}))}t.getItem=function(e,t){return a((function(){return window.localStorage.getItem(r+e)}),t)},t.setItem=function(e,t,n){return i((function(){return window.localStorage.setItem(r+e,t)}),n)},t.removeItem=function(e,t){return i((function(){return window.localStorage.removeItem(r+e)}),t)},t.clear=function(e){return i((function(){Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).forEach((function(e){return window.localStorage.removeItem(e)}))}),e)},t.getAllKeys=function(e){return a((function(){return Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).map((function(e){return e.substr(r.length)}))}),e)},t.multiSet=function(e,t){return s(e,(function(e){var t=e[0],n=e[1];return window.localStorage.setItem(r+t,n)}),t)},t.multiRemove=function(e,t){return s(e,(function(e){return window.localStorage.removeItem(r+e)}),t)},t.multiGet=function(e,t){return new Promise((function(n,o){t||(t=function(){});var i=[],a=e.map((function(e){try{return[e,window.localStorage.getItem(r+e)]}catch(e){i.push(e)}})).filter((function(e){return e}));i.length>0?(t(i,a),o(i)):(t(null,a),n(a))}))}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.storage=void 0;var r="_OfficeRuntime_Storage_";function o(){window.localStorage.setItem("_OfficeRuntime_Storage_|_unusedKey_",null),window.localStorage.removeItem("_OfficeRuntime_Storage_|_unusedKey_")}function i(e){return new Promise((function(t,n){try{o(),e(),t()}catch(e){n(e)}}))}function a(e){return new Promise((function(t,n){try{o(),t(e())}catch(e){n(e)}}))}function s(e,t){return new Promise((function(n,r){var i=[];try{o()}catch(e){i.push(e)}for(var a in e)if(e.hasOwnProperty(a)||Array.isArray(e))try{Array.isArray(e)?t(e[a]):t(a)}catch(e){i.push(e)}i.length>0?r(new Error("Unknown error.")):n()}))}t.storage={getItem:function(e){return a((function(){return window.localStorage.getItem(r+e)}))},setItem:function(e,t){return i((function(){return window.localStorage.setItem(r+e,t)}))},removeItem:function(e){return i((function(){return window.localStorage.removeItem(r+e)}))},getItems:function(e){return new Promise((function(t,n){var i={},a=[];try{o()}catch(e){n(e)}e.forEach((function(e){try{var t=window.localStorage.getItem(r+e);i[e]=t||null}catch(e){a.push(e)}})),a.length>0?n(new Error("Unknown error.")):t(i)}))},setItems:function(e){return s(e,(function(t){return window.localStorage.setItem(r+t,e[t])}))},removeItems:function(e){return s(e,(function(e){window.localStorage.removeItem(r+e)}))},getKeys:function(){return a((function(){return Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).map((function(e){return e.substr(r.length)}))}))}}},function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(o,i){function a(e){try{c(r.next(e))}catch(e){i(e)}}function s(e){try{c(r.throw(e))}catch(e){i(e)}}function c(e){var t;e.done?o(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(a,s)}c((r=r.apply(e,t||[])).next())}))},o=this&&this.__generator||function(e,t){var n,r,o,i,a={label:0,sent:function(){if(1&o[0])throw o[1];return o[1]},trys:[],ops:[]};return i={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(i[Symbol.iterator]=function(){return this}),i;function s(i){return function(s){return function(i){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(o=2&i[0]?r.return:i[0]?r.throw||((o=r.return)&&o.call(r),0):r.next)&&!(o=o.call(r,i[1])).done)return o;switch(r=0,o&&(i=[2&i[0],o.value]),i[0]){case 0:case 1:o=i;break;case 4:return a.label++,{value:i[1],done:!1};case 5:a.label++,r=i[1],i=[0];continue;case 7:i=a.ops.pop(),a.trys.pop();continue;default:if(!((o=(o=a.trys).length>0&&o[o.length-1])||6!==i[0]&&2!==i[0])){a=0;continue}if(3===i[0]&&(!o||i[1]>o[0]&&i[1]<o[3])){a.label=i[1];break}if(6===i[0]&&a.label<o[1]){a.label=o[1],o=i;break}if(o&&a.label<o[2]){a.label=o[2],a.ops.push(i);break}o[2]&&a.ops.pop(),a.trys.pop();continue}i=t.call(e,a)}catch(e){i=[6,e],r=0}finally{n=o=0}if(5&i[0])throw i[1];return{value:i[0]?i[1]:void 0,done:!0}}([i,s])}}};Object.defineProperty(t,"__esModule",{value:!0}),t.experimentation=void 0;var i=function(){function e(){}return e.prototype.getBooleanFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return"true"===n.toString().toLowerCase()||!0===n}catch(e){return t}},e.prototype.getIntFeatureGate=function(e,t){try{var n=parseInt(Microsoft.Office.WebExtension.FeatureGates[e]);return isNaN(n)?t:n}catch(e){return t}},e.prototype.getStringFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return null==n?t:n}catch(e){return t}},e.prototype.getChangeGate=function(e){return this.getBooleanFeatureGate(e,!0)},e.prototype.getBooleanFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return o(this,(function(o){switch(o.label){case 0:return o.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"Boolean",t),n.load(r),[4,n.sync()];case 1:return o.sent(),[2,r.value];case 2:return o.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getStringFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return o(this,(function(o){switch(o.label){case 0:return o.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"String",t),n.load(r),[4,n.sync()];case 1:return o.sent(),[2,r.value];case 2:return o.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getIntFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return o(this,(function(o){switch(o.label){case 0:return o.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"Integer",t),n.load(r),[4,n.sync()];case 1:return o.sent(),[2,r.value];case 2:return o.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getRequestContext=function(){var e;if(Office.context.platform!==Office.PlatformType.OfficeOnline){switch(Office.context.host){case Office.HostType.Excel:e=new Excel.RequestContext;break;case Office.HostType.OneNote:e=new OneNote.RequestContext;break;case Office.HostType.PowerPoint:e=new PowerPoint.RequestContext;break;case Office.HostType.Word:e=new Word.RequestContext;break;default:throw new Error("Unknown Application ".concat(Office.context.host))}return e}},e}();t.experimentation=new i},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Message=void 0;var r=n(10);Object.defineProperty(t,"Message",{enumerable:!0,get:function(){return r.Message}})},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Message=void 0;var r=n(11),o=function(){function e(){this.listeners={}}return e.prototype.on=function(e,t){return this.add(e,t),new Promise((function(e){e()}))},e.prototype.off=function(e,t){return this.remove(e,t),new Promise((function(e){e()}))},e.prototype.emit=function(e,t){return this.send(e,t),new Promise((function(e){e()}))},Object.defineProperty(e,"instance",{get:function(){return e.singleton||(e.singleton=new e),this.singleton},enumerable:!1,configurable:!0}),e.prototype.setupReceive=function(){Office&&Office.context&&Office.context.messaging&&!Office.context.messaging.onMessage&&(Office.context.messaging.onMessage=this.receiveMessage.bind(this))},e.prototype.add=function(e,t){this.listeners.hasOwnProperty(e)||(this.listeners[e]=new r.ListenerManager,this.setupReceive()),this.listeners[e].add(t)},e.prototype.remove=function(e,t){this.listeners.hasOwnProperty(e)&&(t?this.listeners[e].remove(t):delete this.listeners[e])},e.prototype.send=function(e,t){var n={eventName:e,message:t};Office&&Office.context&&Office.context.messaging&&Office.context.messaging.sendMessage&&Office.context.messaging.sendMessage(n)},e.prototype.receiveMessage=function(e){var t=e.eventName,n=e.message;this.listeners.hasOwnProperty(t)&&this.listeners[t].call(n)},e}();t.Message=o},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListenerManager=void 0;var r=function(){function e(){this.listeners=[]}return e.prototype.add=function(e){this.listeners.push(e)},e.prototype.remove=function(e){var t=this.listeners.lastIndexOf(e);-1!==t&&this.listeners.splice(t,1)},e.prototype.call=function(e){this.listeners.forEach((function(t){return t(e)}))},e}();t.ListenerManager=r},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ribbon=t.ui=void 0,t.ui={getRibbon:function(){return new Promise((function(e,t){e(new r)}))}};var r=function(){function e(){this.requestContext=new OfficeCore.RequestContext,OSF.WebAuth&&"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(this.requestContext._customData="WacPartition")}return e.prototype.requestUpdate=function(e){var t=this.requestContext.ribbon;return e.tabs.filter((function(e){return!!e.id})).forEach((function(e){var n=t.getTab(e.id);void 0!==e.visible&&null!==e.visible&&n.setVisibility(e.visible),e.controls.filter((function(e){return!!e.id})).forEach((function(e){var n=t.getButton(e.id);void 0!==e.enabled&&null!==e.enabled&&(n.enabled=e.enabled)}))})),this.requestContext.sync()},e}();t.Ribbon=r},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Auth=void 0;var r=n(0),o=function(){function e(){}return e.prototype.getAccessToken=function(e){return new r.CoreUtility.Promise((function(t,n){try{Office.context.auth.getAccessTokenAsync(e||{},(function(e){"succeeded"===e.status?t(e.value):n(e.error)}))}catch(e){n(e)}}))},e.prototype.getAuthContext=function(){return new r.CoreUtility.Promise((function(e,t){try{Office.context.auth.getAuthContextAsync((function(n){"succeeded"===n.status?e(n.value):t(n.error)}))}catch(e){t(e)}}))},Object.defineProperty(e,"instance",{get:function(){return e.singleton||(e.singleton=new e),e.singleton},enumerable:!1,configurable:!0}),e}();t.Auth=o}]),window.OfficeRuntime=window._OfficeRuntimeNative,exposeOfficeRuntimeThroughOfficeNamespace("undefined"!==typeof OfficeRuntime&&OfficeRuntime||void 0,"undefined"!==typeof Office&&Office||void 0),"undefined"!==typeof OSFPerformance&&(OSFPerformance.hostInitializationEnd=OSFPerformance.now(),OSFPerformance.totalJSHeapSize=OSFPerformance.getTotalJSHeapSize(),OSFPerformance.usedJSHeapSize=OSFPerformance.getUsedJSHeapSize(),OSFPerformance.jsHeapSizeLimit=OSFPerformance.getJSHeapSizeLimit());