/*
	Copyright (c) Microsoft Corporation.  All rights reserved.
*/

/*
	Your use of this file is governed by the license terms for the Microsoft Office JavaScript (Office.js) API library: https://github.com/OfficeDev/office-js/blob/release/LICENSE.md
*/

/*
* @overview es6-promise - a tiny implementation of Promises/A+.
* @copyright Copyright (c) 2014 Yehuda Katz, Tom Dale, Stefan Penner and contributors (Conversion to ES6 API by Jake Archibald)
* @license   Licensed under MIT license
*            See https://raw.githubusercontent.com/jakearchibald/es6-promise/master/LICENSE
* @version   2.3.0
*/


// Sources:
// osfweb: 16.0\16.0.17106.15020
// runtime: 16.0\16.0.17106.15020
// core: 16.0\16.0.17106.15020
// host: 16.0\16.0.17106.15020



var OfficeExt,__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t=function(){function e(){}return e.prototype.isMsAjaxLoaded=function(){return!!("undefined"!==typeof Sys&&"undefined"!==typeof Type&&Sys.StringBuilder&&"function"===typeof Sys.StringBuilder&&Type.registerNamespace&&"function"===typeof Type.registerNamespace&&Type.registerClass&&"function"===typeof Type.registerClass&&"function"===typeof Function._validateParams&&Sys.Serialization&&Sys.Serialization.JavaScriptSerializer&&"function"===typeof Sys.Serialization.JavaScriptSerializer.serialize)},e.prototype.loadMsAjaxFull=function(e){var t=("https:"===window.location.protocol.toLowerCase()?"https:":"http:")+"//ajax.aspnetcdn.com/ajax/3.5/MicrosoftAjax.js";OSF.OUtil.loadScript(t,e)},Object.defineProperty(e.prototype,"msAjaxError",{get:function(){return null==this._msAjaxError&&this.isMsAjaxLoaded()&&(this._msAjaxError=Error),this._msAjaxError},set:function(e){this._msAjaxError=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxString",{get:function(){return null==this._msAjaxString&&this.isMsAjaxLoaded()&&(this._msAjaxString=String),this._msAjaxString},set:function(e){this._msAjaxString=e},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"msAjaxDebug",{get:function(){return null==this._msAjaxDebug&&this.isMsAjaxLoaded()&&(this._msAjaxDebug=Sys.Debug),this._msAjaxDebug},set:function(e){this._msAjaxDebug=e},enumerable:!0,configurable:!0}),e}();e.MicrosoftAjaxFactory=t}(OfficeExt||(OfficeExt={}));var OSFLog,Logger,OSFAriaLogger,OSFAppTelemetry,OsfMsAjaxFactory=new OfficeExt.MicrosoftAjaxFactory,OSF=OSF||{};!function(e){var t=function(){function e(e){this._internalStorage=e}return e.prototype.getItem=function(e){try{return this._internalStorage&&this._internalStorage.getItem(e)}catch(e){return null}},e.prototype.setItem=function(e,t){try{this._internalStorage&&this._internalStorage.setItem(e,t)}catch(e){}},e.prototype.clear=function(){try{this._internalStorage&&this._internalStorage.clear()}catch(e){}},e.prototype.removeItem=function(e){try{this._internalStorage&&this._internalStorage.removeItem(e)}catch(e){}},e.prototype.getKeysWithPrefix=function(e){var t=[];try{for(var n=this._internalStorage&&this._internalStorage.length||0,r=0;r<n;r++){var i=this._internalStorage.key(r);0===i.indexOf(e)&&t.push(i)}}catch(e){}return t},e.prototype.isLocalStorageAvailable=function(){return null!=this._internalStorage},e}();e.SafeStorage=t}(OfficeExt||(OfficeExt={})),OSF.XdmFieldName={ConversationUrl:"ConversationUrl",AppId:"AppId"},OSF.TestFlightStart=1e3,OSF.TestFlightEnd=1009,OSF.FlightNames={UseOriginNotUrl:0,AddinEnforceHttps:2,FirstPartyAnonymousProxyReadyCheckTimeout:6,AddinRibbonIdAllowUnknown:9,ManifestParserDevConsoleLog:15,AddinActionDefinitionHybridMode:18,UseActionIdForUILessCommand:20,RequirementSetRibbonApiOnePointTwo:21,SetFocusToTaskpaneIsEnabled:22,ShortcutInfoArrayInUserPreferenceData:23,OSFTestFlight1000:OSF.TestFlightStart,OSFTestFlight1001:OSF.TestFlightStart+1,OSFTestFlight1002:OSF.TestFlightStart+2,OSFTestFlight1003:OSF.TestFlightStart+3,OSFTestFlight1004:OSF.TestFlightStart+4,OSFTestFlight1005:OSF.TestFlightStart+5,OSFTestFlight1006:OSF.TestFlightStart+6,OSFTestFlight1007:OSF.TestFlightStart+7,OSFTestFlight1008:OSF.TestFlightStart+8,OSFTestFlight1009:OSF.TestFlightEnd},OSF.TrustUXFlightValues={TrustUXControlA:0,TrustUXExperimentB:1,TrustUXExperimentC:2},OSF.FlightTreatmentNames={AddinTrustUXImprovement:"Microsoft.Office.SharedOnline.AddinTrustUXImprovement",BlockAutoOpenAddInIfStoreDisabled:"Microsoft.Office.SharedOnline.BlockAutoOpenAddInIfStoreDisabled",Bug7083046KillSwitch:"Microsoft.Office.SharedOnline.Bug7083046KillSwitch",CheckProxyIsReadyRetry:"Microsoft.Office.SharedOnline.OEP.CheckProxyIsReadyRetry",InsertionDialogFixesEnabled:"Microsoft.Office.SharedOnline.InsertionDialogFixesEnabled",WopiPreinstalledAddInsEnabled:"Microsoft.Office.SharedOnline.WopiPreinstalledAddInsEnabled",WopiUseNewActivate:"Microsoft.Office.SharedOnline.WopiUseNewActivate",MosManifestEnabled:"Microsoft.Office.SharedOnline.OEP.MosManifest",RemoveGetTrustNoPrompt:"Microsoft.Office.SharedOnline.removeGetTrustNoPrompt",HostTrustDialog:"Microsoft.Office.SharedOnline.HostTrustDialog",GetAddinFlyoutEnabled:"Microsoft.Office.SharedOnline.GetAddinFlyoutEnabled",BackstageEnabled:"Microsoft.Office.SharedOnline.NewBackstageEnabled",EnablingWindowOpenUsageLogging:"Microsoft.Office.SharedOnline.EnablingWindowOpenUsageLogging"},OSF.Flights=[],OSF.IntFlights={},OSF.Settings={},OSF.WindowNameItemKeys={BaseFrameName:"baseFrameName",HostInfo:"hostInfo",XdmInfo:"xdmInfo",SerializerVersion:"serializerVersion",AppContext:"appContext",Flights:"flights"},OSF.OUtil=function(){var e=-1,t="#",n={},r=null,i=null,o=(new Date).getTime();function a(){var e=2147483647*Math.random();return(e^=o^(new Date).getMilliseconds()<<Math.floor(21*Math.random())).toString(16)}function s(){if(!r){try{var e=window.sessionStorage}catch(t){e=null}r=new OfficeExt.SafeStorage(e)}return r}function c(e){var t,n,r=[],i=[],o=e.length;for(t=0;t<o;t++)(n=e[t]).tabIndex?n.tabIndex>0?i.push(n):0===n.tabIndex&&r.push(n):r.push(n);return i=i.sort((function(e,t){var n=e.tabIndex-t.tabIndex;return 0===n&&(n=i.indexOf(e)-i.indexOf(t)),n})),[].concat(i,r)}return{set_entropy:function(e){if("string"==typeof e)for(var t=0;t<e.length;t+=4){for(var n=0,r=0;r<4&&t+r<e.length;r++)n=(n<<8)+e.charCodeAt(t+r);o^=n}else o^="number"==typeof e?e:2147483647*Math.random();o&=2147483647},extend:function(e,t){var n=function(){};n.prototype=t.prototype,e.prototype=new n,e.prototype.constructor=e,e.uber=t.prototype,t.prototype.constructor===Object.prototype.constructor&&(t.prototype.constructor=t)},setNamespace:function(e,t){t&&e&&!t[e]&&(t[e]={})},unsetNamespace:function(e,t){t&&e&&t[e]&&delete t[e]},serializeSettings:function(e){var t={};for(var n in e){var r=e[n];try{r=JSON?JSON.stringify(r,(function(e,t){return OSF.OUtil.isDate(this[e])?OSF.DDA.SettingsManager.DateJSONPrefix+this[e].getTime()+OSF.DDA.SettingsManager.DataJSONSuffix:t})):Sys.Serialization.JavaScriptSerializer.serialize(r),t[n]=r}catch(e){}}return t},deserializeSettings:function(e){var t={};for(var n in e=e||{}){var r=e[n];try{r=JSON?JSON.parse(r,(function(e,t){var n;return"string"===typeof t&&t&&t.length>6&&t.slice(0,5)===OSF.DDA.SettingsManager.DateJSONPrefix&&t.slice(-1)===OSF.DDA.SettingsManager.DataJSONSuffix&&(n=new Date(parseInt(t.slice(5,-1))))?n:t})):Sys.Serialization.JavaScriptSerializer.deserialize(r,!0),t[n]=r}catch(e){}}return t},loadScript:function(e,t,r){if(e&&t){var i=window.document,o=n[e];if(o)o.loaded?t():o.pendingCallbacks.push(t);else{var a=i.createElement("script");a.type="text/javascript",o={loaded:!1,pendingCallbacks:[t],timer:null},n[e]=o;var s=function(){null!=o.timer&&(clearTimeout(o.timer),delete o.timer),o.loaded=!0;for(var e=o.pendingCallbacks.length,t=0;t<e;t++){o.pendingCallbacks.shift()()}},c=function(t){delete n[e],null!=o.timer&&(clearTimeout(o.timer),delete o.timer);for(var r=o.pendingCallbacks.length,i=0;i<r;i++){o.pendingCallbacks.shift()(t)}};a.readyState?a.onreadystatechange=function(){"loaded"!=a.readyState&&"complete"!=a.readyState||(a.onreadystatechange=null,s())}:a.onload=s,a.onerror=c,r=r||3e4,o.timer=setTimeout((function(){window.navigator.userAgent.indexOf("Trident")>0?c(null):c(new Event("Script load timed out"))}),r),a.setAttribute("crossOrigin","anonymous"),a.src=e,i.getElementsByTagName("head")[0].appendChild(a)}}},loadCSS:function(e){if(e){var t=window.document,n=t.createElement("link");n.type="text/css",n.rel="stylesheet",n.href=e,t.getElementsByTagName("head")[0].appendChild(n)}},parseEnum:function(e,t){var n=t[e.trim()];if("undefined"==typeof n)throw OsfMsAjaxFactory.msAjaxDebug.trace("invalid enumeration string:"+e),OsfMsAjaxFactory.msAjaxError.argument("str");return n},delayExecutionAndCache:function(){var e={calc:arguments[0]};return function(){return e.calc&&(e.val=e.calc.apply(this,arguments),delete e.calc),e.val}},getUniqueId:function(){return(e+=1).toString()},formatString:function(){var e=arguments,t=e[0];return t.replace(/{(\d+)}/gm,(function(t,n){var r=parseInt(n,10)+1;return void 0===e[r]?"{"+n+"}":e[r]}))},generateConversationId:function(){return[a(),a(),(new Date).getTime().toString()].join("_")},getFrameName:function(e){return"_xdm_"+e+this.generateConversationId()},addXdmInfoAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_xdm_Info=",t,!1)},addSerializerVersionAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_serializer_version=",t,!0)},addFlightsAsHash:function(e,t){return OSF.OUtil.addInfoAsHash(e,"&_flights=",t,!0)},addInfoAsHash:function(e,n,r,i){var o,a=(e=e.trim()||"").split(t),s=a.shift(),c=a.join(t);return o=i?[n,encodeURIComponent(r),c].join(""):[c,n,r].join(""),[s,t,o].join("")},parseHostInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.HostInfo)},parseXdmInfo:function(e){var t=OSF.OUtil.parseXdmInfoWithGivenFragment(e,window.location.hash);return t||(t=OSF.OUtil.parseXdmInfoFromWindowName(e,window.name)),t},parseXdmInfoFromWindowName:function(e,t){return OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.XdmInfo)},parseXdmInfoWithGivenFragment:function(e,t){return OSF.OUtil.parseInfoWithGivenFragment("&_xdm_Info=","_xdm_",!1,e,t)},parseSerializerVersion:function(e){var t=OSF.OUtil.parseSerializerVersionWithGivenFragment(e,window.location.hash);return isNaN(t)&&(t=OSF.OUtil.parseSerializerVersionFromWindowName(e,window.name)),t},parseSerializerVersionFromWindowName:function(e,t){return parseInt(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.SerializerVersion))},parseSerializerVersionWithGivenFragment:function(e,t){return parseInt(OSF.OUtil.parseInfoWithGivenFragment("&_serializer_version=","_serializer_version=",!0,e,t))},parseFlights:function(e){var t=OSF.OUtil.parseFlightsWithGivenFragment(e,window.location.hash);return 0==t.length&&(t=OSF.OUtil.parseFlightsFromWindowName(e,window.name)),t},checkFlight:function(e){return OSF.Flights&&OSF.Flights.indexOf(e)>=0},pushFlight:function(e){return OSF.Flights.indexOf(e)<0&&(OSF.Flights.push(e),!0)},getBooleanSetting:function(e){return OSF.OUtil.getBooleanFromDictionary(OSF.Settings,e)},getBooleanFromDictionary:function(e,t){var n=e&&t&&void 0!==e[t]&&e[t]&&("string"===typeof e[t]&&"TRUE"===e[t].toUpperCase()||"boolean"===typeof e[t]&&e[t]);return void 0!==n&&n},getIntFromDictionary:function(e,t){return e&&t&&void 0!==e[t]&&"string"===typeof e[t]?parseInt(e[t]):NaN},pushIntFlight:function(e,t){return!(e in OSF.IntFlights)&&(OSF.IntFlights[e]=t,!0)},getIntFlight:function(e){return OSF.IntFlights&&e in OSF.IntFlights?OSF.IntFlights[e]:NaN},parseFlightsFromWindowName:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoFromWindowName(e,t,OSF.WindowNameItemKeys.Flights))},parseFlightsWithGivenFragment:function(e,t){return OSF.OUtil.parseArrayWithDefault(OSF.OUtil.parseInfoWithGivenFragment("&_flights=","_flights=",!0,e,t))},parseArrayWithDefault:function(e){var t=[];try{t=JSON.parse(e)}catch(e){}return Array.isArray(t)||(t=[]),t},parseInfoFromWindowName:function(e,t,n){try{var r=JSON.parse(t),i=null!=r?r[n]:null,o=s();if(!e&&o&&null!=r){var a=r[OSF.WindowNameItemKeys.BaseFrameName]+n;i?o.setItem(a,i):i=o.getItem(a)}return i}catch(e){return null}},parseInfoWithGivenFragment:function(e,t,n,r,i){var o=i.split(e),a=o.length>1?o[o.length-1]:null;n&&null!=a&&(a.indexOf("&")>=0&&(a=a.split("&")[0]),a=decodeURIComponent(a));var c=s();if(!r&&c){var u=window.name.indexOf(t);if(u>-1){var l=window.name.indexOf(";",u);-1==l&&(l=window.name.length);var f=window.name.substring(u,l);a?c.setItem(f,a):a=c.getItem(f)}}return a},getConversationId:function(){var e=window.location.search,t=null;if(e){var n=e.indexOf("&");(t=n>0?e.substring(1,n):e.substr(1))&&"="===t.charAt(t.length-1)&&(t=t.substring(0,t.length-1))&&(t=decodeURIComponent(t))}return t},getInfoItems:function(e){var t=e.split("$");return"undefined"==typeof t[1]&&(t=e.split("|")),"undefined"==typeof t[1]&&(t=e.split("%7C")),t},getXdmFieldValue:function(e,t){var n="",r=OSF.OUtil.parseXdmInfo(t);if(r){var i=OSF.OUtil.getInfoItems(r);if(void 0!=i&&i.length>=3)switch(e){case OSF.XdmFieldName.ConversationUrl:n=i[2];break;case OSF.XdmFieldName.AppId:n=i[1]}}return n},validateParamObject:function(e,t,n){var r=Function._validateParams(arguments,[{name:"params",type:Object,mayBeNull:!1},{name:"expectedProperties",type:Object,mayBeNull:!1},{name:"callback",type:Function,mayBeNull:!0}]);if(r)throw r;for(var i in t)if(r=Function._validateParameter(e[i],t[i],i))throw r},writeProfilerMark:function(e){window.msWriteProfilerMark&&(window.msWriteProfilerMark(e),OsfMsAjaxFactory.msAjaxDebug.trace(e))},outputDebug:function(e){"undefined"!==typeof OsfMsAjaxFactory&&OsfMsAjaxFactory.msAjaxDebug&&OsfMsAjaxFactory.msAjaxDebug.trace&&OsfMsAjaxFactory.msAjaxDebug.trace(e)},defineNondefaultProperty:function(e,t,n,r){for(var i in n=n||{},r){var o=r[i];void 0==n[o]&&(n[o]=!0)}return Object.defineProperty(e,t,n),e},defineNondefaultProperties:function(e,t,n){for(var r in t=t||{})OSF.OUtil.defineNondefaultProperty(e,r,t[r],n);return e},defineEnumerableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["enumerable"])},defineEnumerableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["enumerable"])},defineMutableProperty:function(e,t,n){return OSF.OUtil.defineNondefaultProperty(e,t,n,["writable","enumerable","configurable"])},defineMutableProperties:function(e,t){return OSF.OUtil.defineNondefaultProperties(e,t,["writable","enumerable","configurable"])},finalizeProperties:function(e,t){t=t||{};for(var n=Object.getOwnPropertyNames(e),r=n.length,i=0;i<r;i++){var o=n[i],a=Object.getOwnPropertyDescriptor(e,o);a.get||a.set||(a.writable=t.writable||!1),a.configurable=t.configurable||!1,a.enumerable=t.enumerable||!0,Object.defineProperty(e,o,a)}return e},mapList:function(e,t){var n=[];if(e)for(var r in e)n.push(t(e[r]));return n},listContainsKey:function(e,t){for(var n in e)if(t==n)return!0;return!1},listContainsValue:function(e,t){for(var n in e)if(t==e[n])return!0;return!1},augmentList:function(e,t){var n=e.push?function(t,n){e.push(n)}:function(t,n){e[t]=n};for(var r in t)n(r,t[r])},redefineList:function(e,t){for(var n in e)delete e[n];for(var r in t)e[r]=t[r]},isArray:function(e){return"[object Array]"===Object.prototype.toString.apply(e)},isFunction:function(e){return"[object Function]"===Object.prototype.toString.apply(e)},isDate:function(e){return"[object Date]"===Object.prototype.toString.apply(e)},addEventListener:function(e,t,n){e.addEventListener?e.addEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.attachEvent?e.attachEvent("on"+t,n):e["on"+t]=n},removeEventListener:function(e,t,n){e.removeEventListener?e.removeEventListener(t,n,!1):Sys.Browser.agent===Sys.Browser.InternetExplorer&&e.detachEvent?e.detachEvent("on"+t,n):e["on"+t]=null},xhrGet:function(e,t,n){var r;try{(r=new XMLHttpRequest).onreadystatechange=function(){4==r.readyState&&(200==r.status?t(r.responseText):n(r.status))},r.open("GET",e,!0),r.send()}catch(e){n(e)}},encodeBase64:function(e){if(!e)return e;var t,n,r,i,o,a,s,c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",u=[],l=[],f=0,d=e.length;do{t=e.charCodeAt(f++),n=e.charCodeAt(f++),r=e.charCodeAt(f++),s=0,i=255&t,o=t>>8,a=255&n,l[s++]=i>>2,l[s++]=(3&i)<<4|o>>4,l[s++]=(15&o)<<2|a>>6,l[s++]=63&a,isNaN(n)||(i=n>>8,o=255&r,a=r>>8,l[s++]=i>>2,l[s++]=(3&i)<<4|o>>4,l[s++]=(15&o)<<2|a>>6,l[s++]=63&a),isNaN(n)?l[s-1]=64:isNaN(r)&&(l[s-2]=64,l[s-1]=64);for(var p=0;p<s;p++)u.push(c.charAt(l[p]))}while(f<d);return u.join("")},getSessionStorage:function(){return s()},getLocalStorage:function(){if(!i){try{var e=window.localStorage}catch(t){e=null}i=new OfficeExt.SafeStorage(e)}return i},convertIntToCssHexColor:function(e){return"#"+(Number(e)+16777216).toString(16).slice(-6)},attachClickHandler:function(e,t){e.onclick=function(e){t()},e.ontouchend=function(e){t(),e.preventDefault()}},getQueryStringParamValue:function(e,t){var n=Function._validateParams(arguments,[{name:"queryString",type:String,mayBeNull:!1},{name:"paramName",type:String,mayBeNull:!1}]);if(n)return OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: Parameters cannot be null."),"";var r=new RegExp("[\\?&]"+t+"=([^&#]*)","i");return r.test(e)?r.exec(e)[1]:(OsfMsAjaxFactory.msAjaxDebug.trace("OSF_Outil_getQueryStringParamValue: The parameter is not found."),"")},getHostnamePortionForLogging:function(e){var t=Function._validateParams(arguments,[{name:"hostname",type:String,mayBeNull:!1}]);if(t)return"";var n=e.split("."),r=n.length;return r>=2?n[r-2]+"."+n[r-1]:1==r?n[0]:void 0},isiOS:function(){return!!window.navigator.userAgent.match(/(iPad|iPhone|iPod)/g)},isChrome:function(){return window.navigator.userAgent.indexOf("Chrome")>0&&!OSF.OUtil.isEdge()},isEdge:function(){return window.navigator.userAgent.indexOf("Edge")>0},isIE:function(){return window.navigator.userAgent.indexOf("Trident")>0},isFirefox:function(){return window.navigator.userAgent.indexOf("Firefox")>0},startsWith:function(e,t,n){return n?e.substr(0,t.length)===t:e.startsWith(t)},containsPort:function(e,t,n,r){return this.startsWith(e,t+"//"+n+":"+r,!0)||this.startsWith(e,n+":"+r,!0)},getRedundandPortString:function(e,t){return e&&t?"https:"==t.protocol&&this.containsPort(e,"https:",t.hostname,"443")?":443":"http:"==t.protocol&&this.containsPort(e,"http:",t.hostname,"80")?":80":"":""},removeChar:function(e,t){return t<e.length-1?e.substring(0,t)+e.substring(t+1):t==e.length-1?e.substring(0,e.length-1):e},cleanUrlOfChar:function(e,t){var n;for(n=0;n<e.length;n++)if(e.charAt(n)===t){if(n+1>=e.length)return this.removeChar(e,n);if("/"===t){if("?"===e.charAt(n+1)||"#"===e.charAt(n+1))return this.removeChar(e,n)}else if("?"===t&&"#"===e.charAt(n+1))return this.removeChar(e,n)}return e},cleanUrl:function(e){if(e=this.cleanUrlOfChar(e,"/"),e=this.cleanUrlOfChar(e,"?"),"https://"==(e=this.cleanUrlOfChar(e,"#")).substr(0,8))-1!=(t=e.indexOf(":443"))&&(t!=e.length-4&&"/"!=e.charAt(t+4)&&"?"!=e.charAt(t+4)&&"#"!=e.charAt(t+4)||(e=e.substring(0,t)+e.substring(t+4)));else if("http://"==e.substr(0,7)){var t;-1!=(t=e.indexOf(":80"))&&(t!=e.length-3&&"/"!=e.charAt(t+3)&&"?"!=e.charAt(t+3)&&"#"!=e.charAt(t+3)||(e=e.substring(0,t)+e.substring(t+3)))}return e},parseUrl:function(e,t){if(void 0===t&&(t=!1),"undefined"!==typeof e&&e){var n=this.isIE(),r={protocol:void 0,hostname:void 0,host:void 0,port:void 0,pathname:void 0,search:void 0,hash:void 0,isPortPartOfUrl:void 0};try{if(n){var i=document.createElement("a");if(i.href=e,!i||!i.protocol||!i.host||!i.hostname||!i.href||this.cleanUrl(i.href).toLowerCase()!==this.cleanUrl(e).toLowerCase())throw"InvalidUrl";if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=i.protocol)throw new Error("NotHttps");var o=this.getRedundandPortString(e,i);r.protocol=i.protocol,r.hostname=i.hostname,r.port=""==o?i.port:"",r.host=""!=o?i.hostname:i.host,r.pathname=(n?"/":"")+i.pathname,r.search=i.search,r.hash=i.hash,r.isPortPartOfUrl=this.containsPort(e,i.protocol,i.hostname,i.port)}else{var a=new URL(e);if(a&&a.protocol&&a.host&&a.hostname){if(OSF.OUtil.checkFlight(OSF.FlightNames.AddinEnforceHttps)&&t&&"https:"!=a.protocol)throw new Error("NotHttps");r.protocol=a.protocol,r.hostname=a.hostname,r.port=a.port,r.host=a.host,r.pathname=a.pathname,r.search=a.search,r.hash=a.hash,r.isPortPartOfUrl=a.host.lastIndexOf(":"+a.port)==a.host.length-a.port.length-1}}}catch(e){if("NotHttps"===e.message)throw e}return r}},shallowCopy:function(e){if(null==e)return null;if(e instanceof Object){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(e[n]);return t}var r=e.constructor();for(var i in e)e.hasOwnProperty(i)&&(r[i]=e[i]);return r}return e},createObject:function(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t},addClass:function(e,t){if(!OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class");n?e.setAttribute("class",n+" "+t):e.setAttribute("class",t)}},removeClass:function(e,t){if(OSF.OUtil.hasClass(e,t)){var n=e.getAttribute("class"),r=new RegExp("(\\s|^)"+t+"(\\s|$)");n=n.replace(r,""),e.setAttribute("class",n)}},hasClass:function(e,t){var n=e.getAttribute("class");return n&&n.match(new RegExp("(\\s|^)"+t+"(\\s|$)"))},focusToFirstTabbable:function(e,t){var n,r,i=!1,o=function(e){i=!0},a=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(e=c(e),n=t?e.length-1:0,0===e.length)return null;for(;!i&&n>=0&&n<e.length;)r=e[n],window.focus(),r.addEventListener("focus",o),r.focus(),r.removeEventListener("focus",o),n=a(e.length,n,t),i||r!==document.activeElement||(i=!0);return i?r:null},focusToNextTabbable:function(e,t,n){var r,i,o,a=!1,s=function(e){a=!0},u=function(e,t,n){return t<0||t>e||0===t&&n?-1:t!==e-1||n?n?t-1:t+1:-1};if(r=function(e,t){for(var n=0;n<e.length;n++)if(e[n]===t)return n;return-1}(e=c(e),t),(i=u(e.length,r,n))<0)return null;for(;!a&&i>=0&&i<e.length;)(o=e[i]).addEventListener("focus",s),o.focus(),o.removeEventListener("focus",s),i=u(e.length,i,n),a||o!==document.activeElement||(a=!0);return a?o:null},isNullOrUndefined:function(e){return"undefined"===typeof e||null===e},stringEndsWith:function(e,t){if(!OSF.OUtil.isNullOrUndefined(e)&&!OSF.OUtil.isNullOrUndefined(t)){if(t.length>e.length)return!1;if(e.substr(e.length-t.length)===t)return!0}return!1},hashCode:function(e){var t=0;if(!OSF.OUtil.isNullOrUndefined(e))for(var n=0,r=e.length;n<r;)t=(t<<5)-t+e.charCodeAt(n++)|0;return t},getValue:function(e,t){return OSF.OUtil.isNullOrUndefined(e)?t:e},externalNativeFunctionExists:function(e){return"unknown"===e||"undefined"!==e}}}(),OSF.OUtil.Guid=function(){var e=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return{generateNewGuid:function(){for(var t="",n=(new Date).getTime(),r=0;r<32&&n>0;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[n%16],n=Math.floor(n/16);for(;r<32;r++)8!=r&&12!=r&&16!=r&&20!=r||(t+="-"),t+=e[Math.floor(16*Math.random())];return t}}}();try{!function(){OSF.Flights=OSF.OUtil.parseFlights(!0)}()}catch(e){}window.OSF=OSF,OSF.OUtil.setNamespace("OSF",window),OSF.MessageIDs={FetchBundleUrl:0,LoadReactBundle:1,LoadBundleSuccess:2,LoadBundleError:3},OSF.AppName={Unsupported:0,Excel:1,Word:2,PowerPoint:4,Outlook:8,ExcelWebApp:16,WordWebApp:32,OutlookWebApp:64,Project:128,AccessWebApp:256,PowerpointWebApp:512,ExcelIOS:1024,Sway:2048,WordIOS:4096,PowerPointIOS:8192,Access:16384,Lync:32768,OutlookIOS:65536,OneNoteWebApp:131072,OneNote:262144,ExcelWinRT:524288,WordWinRT:1048576,PowerpointWinRT:2097152,OutlookAndroid:4194304,OneNoteWinRT:8388608,ExcelAndroid:8388609,VisioWebApp:8388610,OneNoteIOS:8388611,WordAndroid:8388613,PowerpointAndroid:8388614,Visio:8388615,OneNoteAndroid:4194305},OSF.InternalPerfMarker={DataCoercionBegin:"Agave.HostCall.CoerceDataStart",DataCoercionEnd:"Agave.HostCall.CoerceDataEnd"},OSF.HostCallPerfMarker={IssueCall:"Agave.HostCall.IssueCall",ReceiveResponse:"Agave.HostCall.ReceiveResponse",RuntimeExceptionRaised:"Agave.HostCall.RuntimeExecptionRaised"},OSF.AgaveHostAction={Select:0,UnSelect:1,CancelDialog:2,InsertAgave:3,CtrlF6In:4,CtrlF6Exit:5,CtrlF6ExitShift:6,SelectWithError:7,NotifyHostError:8,RefreshAddinCommands:9,PageIsReady:10,TabIn:11,TabInShift:12,TabExit:13,TabExitShift:14,EscExit:15,F2Exit:16,ExitNoFocusable:17,ExitNoFocusableShift:18,MouseEnter:19,MouseLeave:20,UpdateTargetUrl:21,InstallCustomFunctions:22,SendTelemetryEvent:23,UninstallCustomFunctions:24,SendMessage:25,LaunchExtensionComponent:26,StopExtensionComponent:27,RestartExtensionComponent:28,EnableTaskPaneHeaderButton:29,DisableTaskPaneHeaderButton:30,TaskPaneHeaderButtonClicked:31,RemoveAppCommandsAddin:32,RefreshRibbonGallery:33,GetOriginalControlId:34,OfficeJsReady:35,InsertDevManifest:36,InsertDevManifestError:37,SendCustomerContent:38,KeyboardShortcuts:39},OSF.SharedConstants={NotificationConversationIdSuffix:"_ntf"},OSF.DialogMessageType={DialogMessageReceived:0,DialogParentMessageReceived:1,DialogClosed:12006},OSF.OfficeAppContext=function(e,t,n,r,i,o,a,s,c,u,l,f,d,p,h,m,g,y,O,v,b,S,_,A,D,C,P){this._id=e,this._appName=t,this._appVersion=n,this._appUILocale=r,this._dataLocale=i,this._docUrl=o,this._clientMode=a,this._settings=s,this._reason=c,this._osfControlType=u,this._eToken=l,this._correlationId=f,this._appInstanceId=d,this._touchEnabled=p,this._commerceAllowed=h,this._appMinorVersion=m,this._requirementMatrix=g,this._hostCustomMessage=y,this._hostFullVersion=O,this._isDialog=!1,this._clientWindowHeight=v,this._clientWindowWidth=b,this._addinName=S,this._appDomains=_,this._dialogRequirementMatrix=A,this._featureGates=D,this._officeTheme=C,this._initialDisplayMode=P,this.get_id=function(){return this._id},this.get_appName=function(){return this._appName},this.get_appVersion=function(){return this._appVersion},this.get_appUILocale=function(){return this._appUILocale},this.get_dataLocale=function(){return this._dataLocale},this.get_docUrl=function(){return this._docUrl},this.get_clientMode=function(){return this._clientMode},this.get_bindings=function(){return this._bindings},this.get_settings=function(){return this._settings},this.get_reason=function(){return this._reason},this.get_osfControlType=function(){return this._osfControlType},this.get_eToken=function(){return this._eToken},this.get_correlationId=function(){return this._correlationId},this.get_appInstanceId=function(){return this._appInstanceId},this.get_touchEnabled=function(){return this._touchEnabled},this.get_commerceAllowed=function(){return this._commerceAllowed},this.get_appMinorVersion=function(){return this._appMinorVersion},this.get_requirementMatrix=function(){return this._requirementMatrix},this.get_dialogRequirementMatrix=function(){return this._dialogRequirementMatrix},this.get_hostCustomMessage=function(){return this._hostCustomMessage},this.get_hostFullVersion=function(){return this._hostFullVersion},this.get_isDialog=function(){return this._isDialog},this.get_clientWindowHeight=function(){return this._clientWindowHeight},this.get_clientWindowWidth=function(){return this._clientWindowWidth},this.get_addinName=function(){return this._addinName},this.get_appDomains=function(){return this._appDomains},this.get_featureGates=function(){return this._featureGates},this.get_officeTheme=function(){return this._officeTheme},this.get_initialDisplayMode=function(){return this._initialDisplayMode?this._initialDisplayMode:0}},OSF.OsfControlType={DocumentLevel:0,ContainerLevel:1},OSF.ClientMode={ReadOnly:0,ReadWrite:1},OSF.OUtil.setNamespace("Microsoft",window),OSF.OUtil.setNamespace("Office",Microsoft),OSF.OUtil.setNamespace("Client",Microsoft.Office),OSF.OUtil.setNamespace("WebExtension",Microsoft.Office),Microsoft.Office.WebExtension.InitializationReason={Inserted:"inserted",DocumentOpened:"documentOpened",ControlActivation:"controlActivation"},Microsoft.Office.WebExtension.ValueFormat={Unformatted:"unformatted",Formatted:"formatted"},Microsoft.Office.WebExtension.FilterType={All:"all"},Microsoft.Office.WebExtension.Parameters={BindingType:"bindingType",CoercionType:"coercionType",ValueFormat:"valueFormat",FilterType:"filterType",Columns:"columns",SampleData:"sampleData",GoToType:"goToType",SelectionMode:"selectionMode",Id:"id",PromptText:"promptText",ItemName:"itemName",FailOnCollision:"failOnCollision",StartRow:"startRow",StartColumn:"startColumn",RowCount:"rowCount",ColumnCount:"columnCount",Callback:"callback",AsyncContext:"asyncContext",Data:"data",JsonData:"jsonData",Rows:"rows",OverwriteIfStale:"overwriteIfStale",FileType:"fileType",EventType:"eventType",Handler:"handler",SliceSize:"sliceSize",SliceIndex:"sliceIndex",ActiveView:"activeView",Status:"status",PlatformType:"platformType",HostType:"hostType",ForceConsent:"forceConsent",ForceAddAccount:"forceAddAccount",AuthChallenge:"authChallenge",AllowConsentPrompt:"allowConsentPrompt",ForMSGraphAccess:"forMSGraphAccess",AllowSignInPrompt:"allowSignInPrompt",JsonPayload:"jsonPayload",EnableNewHosts:"enableNewHosts",AccountTypeFilter:"accountTypeFilter",AddinTrustId:"addinTrustId",Reserved:"reserved",Tcid:"tcid",Xml:"xml",Namespace:"namespace",Prefix:"prefix",XPath:"xPath",Text:"text",ImageLeft:"imageLeft",ImageTop:"imageTop",ImageWidth:"imageWidth",ImageHeight:"imageHeight",TaskId:"taskId",FieldId:"fieldId",FieldValue:"fieldValue",ServerUrl:"serverUrl",ListName:"listName",ResourceId:"resourceId",ViewType:"viewType",ViewName:"viewName",GetRawValue:"getRawValue",CellFormat:"cellFormat",TableOptions:"tableOptions",TaskIndex:"taskIndex",ResourceIndex:"resourceIndex",CustomFieldId:"customFieldId",Url:"url",MessageHandler:"messageHandler",Width:"width",Height:"height",RequireHTTPs:"requireHTTPS",MessageToParent:"messageToParent",DisplayInIframe:"displayInIframe",MessageContent:"messageContent",HideTitle:"hideTitle",UseDeviceIndependentPixels:"useDeviceIndependentPixels",PromptBeforeOpen:"promptBeforeOpen",EnforceAppDomain:"enforceAppDomain",UrlNoHostInfo:"urlNoHostInfo",TargetOrigin:"targetOrigin",AppCommandInvocationCompletedData:"appCommandInvocationCompletedData",Base64:"base64",FormId:"formId"},OSF.OUtil.setNamespace("DDA",OSF),OSF.DDA.DocumentMode={ReadOnly:1,ReadWrite:0},OSF.DDA.PropertyDescriptors={AsyncResultStatus:"AsyncResultStatus"},OSF.DDA.EventDescriptors={},OSF.DDA.ListDescriptors={},OSF.DDA.UI={},OSF.DDA.getXdmEventName=function(e,t){return t==Microsoft.Office.WebExtension.EventType.BindingSelectionChanged||t==Microsoft.Office.WebExtension.EventType.BindingDataChanged||t==Microsoft.Office.WebExtension.EventType.DataNodeDeleted||t==Microsoft.Office.WebExtension.EventType.DataNodeInserted||t==Microsoft.Office.WebExtension.EventType.DataNodeReplaced?e+"_"+t:t},OSF.DDA.MethodDispId={dispidMethodMin:64,dispidGetSelectedDataMethod:64,dispidSetSelectedDataMethod:65,dispidAddBindingFromSelectionMethod:66,dispidAddBindingFromPromptMethod:67,dispidGetBindingMethod:68,dispidReleaseBindingMethod:69,dispidGetBindingDataMethod:70,dispidSetBindingDataMethod:71,dispidAddRowsMethod:72,dispidClearAllRowsMethod:73,dispidGetAllBindingsMethod:74,dispidLoadSettingsMethod:75,dispidSaveSettingsMethod:76,dispidGetDocumentCopyMethod:77,dispidAddBindingFromNamedItemMethod:78,dispidAddColumnsMethod:79,dispidGetDocumentCopyChunkMethod:80,dispidReleaseDocumentCopyMethod:81,dispidNavigateToMethod:82,dispidGetActiveViewMethod:83,dispidGetDocumentThemeMethod:84,dispidGetOfficeThemeMethod:85,dispidGetFilePropertiesMethod:86,dispidClearFormatsMethod:87,dispidSetTableOptionsMethod:88,dispidSetFormatsMethod:89,dispidExecuteRichApiRequestMethod:93,dispidAppCommandInvocationCompletedMethod:94,dispidCloseContainerMethod:97,dispidGetAccessTokenMethod:98,dispidGetAuthContextMethod:99,dispidOpenBrowserWindow:102,dispidCreateDocumentMethod:105,dispidInsertFormMethod:106,dispidDisplayRibbonCalloutAsyncMethod:109,dispidGetSelectedTaskMethod:110,dispidGetSelectedResourceMethod:111,dispidGetTaskMethod:112,dispidGetResourceFieldMethod:113,dispidGetWSSUrlMethod:114,dispidGetTaskFieldMethod:115,dispidGetProjectFieldMethod:116,dispidGetSelectedViewMethod:117,dispidGetTaskByIndexMethod:118,dispidGetResourceByIndexMethod:119,dispidSetTaskFieldMethod:120,dispidSetResourceFieldMethod:121,dispidGetMaxTaskIndexMethod:122,dispidGetMaxResourceIndexMethod:123,dispidCreateTaskMethod:124,dispidAddDataPartMethod:128,dispidGetDataPartByIdMethod:129,dispidGetDataPartsByNamespaceMethod:130,dispidGetDataPartXmlMethod:131,dispidGetDataPartNodesMethod:132,dispidDeleteDataPartMethod:133,dispidGetDataNodeValueMethod:134,dispidGetDataNodeXmlMethod:135,dispidGetDataNodesMethod:136,dispidSetDataNodeValueMethod:137,dispidSetDataNodeXmlMethod:138,dispidAddDataNamespaceMethod:139,dispidGetDataUriByPrefixMethod:140,dispidGetDataPrefixByUriMethod:141,dispidGetDataNodeTextMethod:142,dispidSetDataNodeTextMethod:143,dispidMessageParentMethod:144,dispidSendMessageMethod:145,dispidExecuteFeature:146,dispidQueryFeature:147,dispidGetNestedAppAuthContextMethod:205,dispidSdxSendMessage:208},OSF.DDA.EventDispId={dispidEventMin:0,dispidInitializeEvent:0,dispidSettingsChangedEvent:1,dispidDocumentSelectionChangedEvent:2,dispidBindingSelectionChangedEvent:3,dispidBindingDataChangedEvent:4,dispidDocumentOpenEvent:5,dispidDocumentCloseEvent:6,dispidActiveViewChangedEvent:7,dispidDocumentThemeChangedEvent:8,dispidOfficeThemeChangedEvent:9,dispidDialogMessageReceivedEvent:10,dispidDialogNotificationShownInAddinEvent:11,dispidDialogParentMessageReceivedEvent:12,dispidObjectDeletedEvent:13,dispidObjectSelectionChangedEvent:14,dispidObjectDataChangedEvent:15,dispidContentControlAddedEvent:16,dispidSuspend:19,dispidResume:20,dispidActivationStatusChangedEvent:32,dispidRichApiMessageEvent:33,dispidAppCommandInvokedEvent:39,dispidOnSdxSendMessageEvent:40,dispidOlkItemSelectedChangedEvent:46,dispidOlkRecipientsChangedEvent:47,dispidOlkAppointmentTimeChangedEvent:48,dispidOlkRecurrenceChangedEvent:49,dispidOlkAttachmentsChangedEvent:50,dispidOlkEnhancedLocationsChangedEvent:51,dispidOlkInfobarClickedEvent:52,dispidOlkSelectedItemsChangedEvent:53,dispidOlkSensitivityLabelChangedEvent:54,dispidTaskSelectionChangedEvent:56,dispidResourceSelectionChangedEvent:57,dispidViewSelectionChangedEvent:58,dispidDataNodeAddedEvent:60,dispidDataNodeReplacedEvent:61,dispidDataNodeDeletedEvent:62,dispidEventMax:63},OSF.DDA.ErrorCodeManager=function(){var e={};return{getErrorArgs:function(t){var n=e[t];return n?(n.name||(n.name=e[this.errorCodes.ooeInternalError].name),n.message||(n.message=e[this.errorCodes.ooeInternalError].message)):n=e[this.errorCodes.ooeInternalError],n},addErrorMessage:function(t,n){e[t]=n},errorCodes:{ooeSuccess:0,ooeChunkResult:1,ooeCoercionTypeNotSupported:1e3,ooeGetSelectionNotMatchDataType:1001,ooeCoercionTypeNotMatchBinding:1002,ooeInvalidGetRowColumnCounts:1003,ooeSelectionNotSupportCoercionType:1004,ooeInvalidGetStartRowColumn:1005,ooeNonUniformPartialGetNotSupported:1006,ooeGetDataIsTooLarge:1008,ooeFileTypeNotSupported:1009,ooeGetDataParametersConflict:1010,ooeInvalidGetColumns:1011,ooeInvalidGetRows:1012,ooeInvalidReadForBlankRow:1013,ooeUnsupportedDataObject:2e3,ooeCannotWriteToSelection:2001,ooeDataNotMatchSelection:2002,ooeOverwriteWorksheetData:2003,ooeDataNotMatchBindingSize:2004,ooeInvalidSetStartRowColumn:2005,ooeInvalidDataFormat:2006,ooeDataNotMatchCoercionType:2007,ooeDataNotMatchBindingType:2008,ooeSetDataIsTooLarge:2009,ooeNonUniformPartialSetNotSupported:2010,ooeInvalidSetColumns:2011,ooeInvalidSetRows:2012,ooeSetDataParametersConflict:2013,ooeCellDataAmountBeyondLimits:2014,ooeSelectionCannotBound:3e3,ooeBindingNotExist:3002,ooeBindingToMultipleSelection:3003,ooeInvalidSelectionForBindingType:3004,ooeOperationNotSupportedOnThisBindingType:3005,ooeNamedItemNotFound:3006,ooeMultipleNamedItemFound:3007,ooeInvalidNamedItemForBindingType:3008,ooeUnknownBindingType:3009,ooeOperationNotSupportedOnMatrixData:3010,ooeInvalidColumnsForBinding:3011,ooeSettingNameNotExist:4e3,ooeSettingsCannotSave:4001,ooeSettingsAreStale:4002,ooeOperationNotSupported:5e3,ooeInternalError:5001,ooeDocumentReadOnly:5002,ooeEventHandlerNotExist:5003,ooeInvalidApiCallInContext:5004,ooeShuttingDown:5005,ooeUnsupportedEnumeration:5007,ooeIndexOutOfRange:5008,ooeBrowserAPINotSupported:5009,ooeInvalidParam:5010,ooeRequestTimeout:5011,ooeInvalidOrTimedOutSession:5012,ooeInvalidApiArguments:5013,ooeOperationCancelled:5014,ooeWorkbookHidden:5015,ooeWriteNotSupportedWhenModalDialogOpen:5016,ooeTooManyIncompleteRequests:5100,ooeRequestTokenUnavailable:5101,ooeActivityLimitReached:5102,ooeRequestPayloadSizeLimitExceeded:5103,ooeResponsePayloadSizeLimitExceeded:5104,ooeCustomXmlNodeNotFound:6e3,ooeCustomXmlError:6100,ooeCustomXmlExceedQuota:6101,ooeCustomXmlOutOfDate:6102,ooeNoCapability:7e3,ooeCannotNavTo:7001,ooeSpecifiedIdNotExist:7002,ooeNavOutOfBound:7004,ooeElementMissing:8e3,ooeProtectedError:8001,ooeInvalidCellsValue:8010,ooeInvalidTableOptionValue:8011,ooeInvalidFormatValue:8012,ooeRowIndexOutOfRange:8020,ooeColIndexOutOfRange:8021,ooeFormatValueOutOfRange:8022,ooeCellFormatAmountBeyondLimits:8023,ooeMemoryFileLimit:11e3,ooeNetworkProblemRetrieveFile:11001,ooeInvalidSliceSize:11002,ooeInvalidCallback:11101,ooeInvalidWidth:12e3,ooeInvalidHeight:12001,ooeNavigationError:12002,ooeInvalidScheme:12003,ooeAppDomains:12004,ooeRequireHTTPS:12005,ooeWebDialogClosed:12006,ooeDialogAlreadyOpened:12007,ooeEndUserAllow:12008,ooeEndUserIgnore:12009,ooeNotUILessDialog:12010,ooeCrossZone:12011,ooeModalDialogOpen:12012,ooeDocumentIsInactive:12013,ooeDialogParentIsMinimized:12014,ooeNotSSOAgave:13e3,ooeSSOUserNotSignedIn:13001,ooeSSOUserAborted:13002,ooeSSOUnsupportedUserIdentity:13003,ooeSSOInvalidResourceUrl:13004,ooeSSOInvalidGrant:13005,ooeSSOClientError:13006,ooeSSOServerError:13007,ooeAddinIsAlreadyRequestingToken:13008,ooeSSOUserConsentNotSupportedByCurrentAddinCategory:13009,ooeSSOConnectionLost:13010,ooeResourceNotAllowed:13011,ooeSSOUnsupportedPlatform:13012,ooeSSOCallThrottled:13013,ooeAccessDenied:13990,ooeGeneralException:13991},initializeErrorMessages:function(t){e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotSupported]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetSelectionNotMatchDataType]={name:t.L_DataReadError,message:t.L_GetSelectionNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding]={name:t.L_InvalidCoercion,message:t.L_CoercionTypeNotMatchBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRowColumnCounts]={name:t.L_DataReadError,message:t.L_InvalidGetRowColumnCounts},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionNotSupportCoercionType]={name:t.L_DataReadError,message:t.L_SelectionNotSupportCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetStartRowColumn]={name:t.L_DataReadError,message:t.L_InvalidGetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialGetNotSupported]={name:t.L_DataReadError,message:t.L_NonUniformPartialGetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataIsTooLarge]={name:t.L_DataReadError,message:t.L_GetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFileTypeNotSupported]={name:t.L_DataReadError,message:t.L_FileTypeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeGetDataParametersConflict]={name:t.L_DataReadError,message:t.L_GetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetColumns]={name:t.L_DataReadError,message:t.L_InvalidGetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidGetRows]={name:t.L_DataReadError,message:t.L_InvalidGetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidReadForBlankRow]={name:t.L_DataReadError,message:t.L_InvalidReadForBlankRow},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject]={name:t.L_DataWriteError,message:t.L_UnsupportedDataObject},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotWriteToSelection]={name:t.L_DataWriteError,message:t.L_CannotWriteToSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchSelection]={name:t.L_DataWriteError,message:t.L_DataNotMatchSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOverwriteWorksheetData]={name:t.L_DataWriteError,message:t.L_OverwriteWorksheetData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingSize]={name:t.L_DataWriteError,message:t.L_DataNotMatchBindingSize},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetStartRowColumn]={name:t.L_DataWriteError,message:t.L_InvalidSetStartRowColumn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidDataFormat]={name:t.L_InvalidFormat,message:t.L_InvalidDataFormat},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchCoercionType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchCoercionType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDataNotMatchBindingType]={name:t.L_InvalidDataObject,message:t.L_DataNotMatchBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataIsTooLarge]={name:t.L_DataWriteError,message:t.L_SetDataIsTooLarge},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNonUniformPartialSetNotSupported]={name:t.L_DataWriteError,message:t.L_NonUniformPartialSetNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetColumns]={name:t.L_DataWriteError,message:t.L_InvalidSetColumns},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSetRows]={name:t.L_DataWriteError,message:t.L_InvalidSetRows},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSetDataParametersConflict]={name:t.L_DataWriteError,message:t.L_SetDataParametersConflict},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSelectionCannotBound]={name:t.L_BindingCreationError,message:t.L_SelectionCannotBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingNotExist]={name:t.L_InvalidBindingError,message:t.L_BindingNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBindingToMultipleSelection]={name:t.L_BindingCreationError,message:t.L_BindingToMultipleSelection},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSelectionForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidSelectionForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnThisBindingType]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnThisBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNamedItemNotFound]={name:t.L_BindingCreationError,message:t.L_NamedItemNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMultipleNamedItemFound]={name:t.L_BindingCreationError,message:t.L_MultipleNamedItemFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidNamedItemForBindingType]={name:t.L_BindingCreationError,message:t.L_InvalidNamedItemForBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnknownBindingType]={name:t.L_InvalidBinding,message:t.L_UnknownBindingType},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupportedOnMatrixData]={name:t.L_InvalidBindingOperation,message:t.L_OperationNotSupportedOnMatrixData},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidColumnsForBinding]={name:t.L_InvalidBinding,message:t.L_InvalidColumnsForBinding},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingNameNotExist]={name:t.L_ReadSettingsError,message:t.L_SettingNameNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsCannotSave]={name:t.L_SaveSettingsError,message:t.L_SettingsCannotSave},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSettingsAreStale]={name:t.L_SettingsStaleError,message:t.L_SettingsAreStale},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationNotSupported]={name:t.L_HostError,message:t.L_OperationNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError]={name:t.L_InternalError,message:t.L_InternalErrorDescription},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentReadOnly]={name:t.L_PermissionDenied,message:t.L_DocumentReadOnly},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist]={name:t.L_EventRegistrationError,message:t.L_EventHandlerNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext]={name:t.L_InvalidAPICall,message:t.L_InvalidApiCallInContext},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeShuttingDown]={name:t.L_ShuttingDown,message:t.L_ShuttingDown},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration]={name:t.L_UnsupportedEnumeration,message:t.L_UnsupportedEnumerationMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeBrowserAPINotSupported]={name:t.L_APINotSupported,message:t.L_BrowserAPINotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTimeout]={name:t.L_APICallFailed,message:t.L_RequestTimeout},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidOrTimedOutSession]={name:t.L_InvalidOrTimedOutSession,message:t.L_InvalidOrTimedOutSessionMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiArguments]={name:t.L_APICallFailed,message:t.L_InvalidApiArgumentsMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWorkbookHidden]={name:t.L_APICallFailed,message:t.L_WorkbookHiddenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeWriteNotSupportedWhenModalDialogOpen]={name:t.L_APICallFailed,message:t.L_WriteNotSupportedWhenModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests]={name:t.L_APICallFailed,message:t.L_TooManyIncompleteRequests},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestTokenUnavailable]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeActivityLimitReached]={name:t.L_APICallFailed,message:t.L_ActivityLimitReached},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequestPayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_RequestPayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeResponsePayloadSizeLimitExceeded]={name:t.L_APICallFailed,message:t.L_ResponsePayloadSizeLimitExceededMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlNodeNotFound]={name:t.L_InvalidNode,message:t.L_CustomXmlNodeNotFound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlError]={name:t.L_CustomXmlError,message:t.L_CustomXmlError},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlExceedQuota]={name:t.L_CustomXmlExceedQuotaName,message:t.L_CustomXmlExceedQuotaMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCustomXmlOutOfDate]={name:t.L_CustomXmlOutOfDateName,message:t.L_CustomXmlOutOfDateMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCannotNavTo]={name:t.L_CannotNavigateTo,message:t.L_CannotNavigateTo},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSpecifiedIdNotExist]={name:t.L_SpecifiedIdNotExist,message:t.L_SpecifiedIdNotExist},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavOutOfBound]={name:t.L_NavOutOfBound,message:t.L_NavOutOfBound},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellDataAmountBeyondLimits]={name:t.L_DataWriteReminder,message:t.L_CellDataAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeElementMissing]={name:t.L_MissingParameter,message:t.L_ElementMissing},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeProtectedError]={name:t.L_PermissionDenied,message:t.L_NoCapability},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCellsValue]={name:t.L_InvalidValue,message:t.L_InvalidCellsValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidTableOptionValue]={name:t.L_InvalidValue,message:t.L_InvalidTableOptionValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidFormatValue]={name:t.L_InvalidValue,message:t.L_InvalidFormatValue},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRowIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_RowIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeColIndexOutOfRange]={name:t.L_OutOfRange,message:t.L_ColIndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeFormatValueOutOfRange]={name:t.L_OutOfRange,message:t.L_FormatValueOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCellFormatAmountBeyondLimits]={name:t.L_FormattingReminder,message:t.L_CellFormatAmountBeyondLimits},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeMemoryFileLimit]={name:t.L_MemoryLimit,message:t.L_CloseFileBeforeRetrieve},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNetworkProblemRetrieveFile]={name:t.L_NetworkProblem,message:t.L_NetworkProblemRetrieveFile},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize]={name:t.L_InvalidValue,message:t.L_SliceSizeNotSupported},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened]={name:t.L_DisplayDialogError,message:t.L_DialogAlreadyOpened},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidWidth]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidHeight]={name:t.L_IndexOutOfRange,message:t.L_IndexOutOfRange},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNavigationError]={name:t.L_DisplayDialogError,message:t.L_NetworkProblem},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidScheme]={name:t.L_DialogNavigateError,message:t.L_DialogInvalidScheme},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAppDomains]={name:t.L_DisplayDialogError,message:t.L_DialogAddressNotTrusted},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeRequireHTTPS]={name:t.L_DisplayDialogError,message:t.L_DialogRequireHTTPS},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeEndUserIgnore]={name:t.L_DisplayDialogError,message:t.L_UserClickIgnore},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeCrossZone]={name:t.L_DisplayDialogError,message:t.L_NewWindowCrossZoneErrorString},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeModalDialogOpen]={name:t.L_DisplayDialogError,message:t.L_ModalDialogOpen},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDocumentIsInactive]={name:t.L_DisplayDialogError,message:t.L_DocumentIsInactive},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogParentIsMinimized]={name:t.L_DisplayDialogError,message:t.L_DialogParentIsMinimized},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeNotSSOAgave]={name:t.L_APINotSupported,message:t.L_InvalidSSOAddinMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserNotSignedIn]={name:t.L_UserNotSignedIn,message:t.L_UserNotSignedIn},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserAborted]={name:t.L_UserAborted,message:t.L_UserAbortedMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedUserIdentity]={name:t.L_UnsupportedUserIdentity,message:t.L_UnsupportedUserIdentityMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidResourceUrl]={name:t.L_InvalidResourceUrl,message:t.L_InvalidResourceUrlMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOInvalidGrant]={name:t.L_InvalidGrant,message:t.L_InvalidGrantMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOClientError]={name:t.L_SSOClientError,message:t.L_SSOClientErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOServerError]={name:t.L_SSOServerError,message:t.L_SSOServerErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeAddinIsAlreadyRequestingToken]={name:t.L_AddinIsAlreadyRequestingToken,message:t.L_AddinIsAlreadyRequestingTokenMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUserConsentNotSupportedByCurrentAddinCategory]={name:t.L_SSOUserConsentNotSupportedByCurrentAddinCategory,message:t.L_SSOUserConsentNotSupportedByCurrentAddinCategoryMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOConnectionLost]={name:t.L_SSOConnectionLostError,message:t.L_SSOConnectionLostErrorMessage},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOUnsupportedPlatform]={name:t.L_APINotSupported,message:t.L_SSOUnsupportedPlatform},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeSSOCallThrottled]={name:t.L_APICallFailed,message:t.L_RequestTokenUnavailable},e[OSF.DDA.ErrorCodeManager.errorCodes.ooeOperationCancelled]={name:t.L_OperationCancelledError,message:t.L_OperationCancelledErrorMessage}}}}(),function(e){!function(e){var t=function(){return function(){}}();e.RequirementVersion=t;var n=function(){return function(e){this.isSetSupported=function(e,t){if(void 0==e)return!1;void 0==t&&(t=0);var n=this._setMap._sets;if(n.hasOwnProperty(e.toLowerCase())){var r=n[e.toLowerCase()];try{var i=this._getVersion(r);t+="";var o=this._getVersion(t);if(i.major>0&&i.major>o.major)return!0;if(i.major>0&&i.minor>=0&&i.major==o.major&&i.minor>=o.minor)return!0}catch(e){return!1}}return!1},this._getVersion=function(e){var t=(e+="").split("."),n=0,r=0;if(t.length<2&&isNaN(Number(e)))throw"version format incorrect";if(n=Number(t[0]),t.length>=2&&(r=Number(t[1])),isNaN(n)||isNaN(r))throw"version format incorrect";return{minor:r,major:n}},this._setMap=e,this.isSetSupported=this.isSetSupported.bind(this)}}();e.RequirementMatrix=n;var r=function(){return function(e){this._addSetMap=function(e){for(var t in e)this._sets[t]=e[t]},this._sets=e}}();e.DefaultSetRequirement=r;var i=function(e){function t(){return e.call(this,{dialogapi:1.1})||this}return __extends(t,e),t}(r);e.DefaultRequiredDialogSetRequirement=i;var o=function(e){function t(){return e.call(this,{dialogorigin:1.1})||this}return __extends(t,e),t}(r);e.DefaultOptionalDialogSetRequirement=o;var a=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,excelapi:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelClientDefaultSetRequirement=a;var s=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(a);e.ExcelClientV1DefaultSetRequirement=s;var c=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookClientDefaultSetRequirement=c;var u=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1,wordapi:1.1})||this}return __extends(t,e),t}(r);e.WordClientDefaultSetRequirement=u;var l=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2,imagecoercion:1.1}),t}return __extends(t,e),t}(u);e.WordClientV1DefaultSetRequirement=l;var f=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointClientDefaultSetRequirement=f;var d=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({imagecoercion:1.1}),t}return __extends(t,e),t}(f);e.PowerpointClientV1DefaultSetRequirement=d;var p=function(e){function t(){return e.call(this,{selection:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ProjectClientDefaultSetRequirement=p;var h=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,file:1.1})||this}return __extends(t,e),t}(r);e.ExcelWebDefaultSetRequirement=h;var m=function(e){function t(){return e.call(this,{compressedfile:1.1,documentevents:1.1,file:1.1,imagecoercion:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablecoercion:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordWebDefaultSetRequirement=m;var g=function(e){function t(){return e.call(this,{activeview:1.1,settings:1.1})||this}return __extends(t,e),t}(r);e.PowerpointWebDefaultSetRequirement=g;var y=function(e){function t(){return e.call(this,{mailbox:1.3})||this}return __extends(t,e),t}(r);e.OutlookWebDefaultSetRequirement=y;var O=function(e){function t(){return e.call(this,{activeview:1.1,documentevents:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.SwayWebDefaultSetRequirement=O;var v=function(e){function t(){return e.call(this,{bindingevents:1.1,partialtablebindings:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1})||this}return __extends(t,e),t}(r);e.AccessWebDefaultSetRequirement=v;var b=function(e){function t(){return e.call(this,{bindingevents:1.1,documentevents:1.1,matrixbindings:1.1,matrixcoercion:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.ExcelIOSDefaultSetRequirement=b;var S=function(e){function t(){return e.call(this,{bindingevents:1.1,compressedfile:1.1,customxmlparts:1.1,documentevents:1.1,file:1.1,htmlcoercion:1.1,matrixbindings:1.1,matrixcoercion:1.1,ooxmlcoercion:1.1,pdffile:1.1,selection:1.1,settings:1.1,tablebindings:1.1,tablecoercion:1.1,textbindings:1.1,textcoercion:1.1,textfile:1.1})||this}return __extends(t,e),t}(r);e.WordIOSDefaultSetRequirement=S;var _=function(e){function t(){var t=e.call(this)||this;return t._addSetMap({customxmlparts:1.2,wordapi:1.2}),t}return __extends(t,e),t}(S);e.WordIOSV1DefaultSetRequirement=_;var A=function(e){function t(){return e.call(this,{activeview:1.1,compressedfile:1.1,documentevents:1.1,file:1.1,pdffile:1.1,selection:1.1,settings:1.1,textcoercion:1.1})||this}return __extends(t,e),t}(r);e.PowerpointIOSDefaultSetRequirement=A;var D=function(e){function t(){return e.call(this,{mailbox:1.1})||this}return __extends(t,e),t}(r);e.OutlookIOSDefaultSetRequirement=D;var C=function(){function e(){}return e.initializeOsfDda=function(){OSF.OUtil.setNamespace("Requirement",OSF.DDA)},e.getDefaultRequirementMatrix=function(t){this.initializeDefaultSetMatrix();var i=void 0,o=t.get_requirementMatrix();if(void 0!=o&&o.length>0&&"undefined"!==typeof JSON){var a=JSON.parse(t.get_requirementMatrix().toLowerCase());i=new n(new r(a))}else{var s=e.getClientFullVersionString(t);i=void 0!=e.DefaultSetArrayMatrix&&void 0!=e.DefaultSetArrayMatrix[s]?new n(e.DefaultSetArrayMatrix[s]):new n(new r({}))}return i},e.getDefaultDialogRequirementMatrix=function(e){var t=void 0,a=e.get_dialogRequirementMatrix();if(void 0!=a&&a.length>0&&"undefined"!==typeof JSON){var s=JSON.parse(e.get_requirementMatrix().toLowerCase());t=new r(s)}else{t=new i;var c=e.get_requirementMatrix();if(void 0!=c&&c.length>0&&"undefined"!==typeof JSON){s=JSON.parse(c.toLowerCase());for(var u in t._sets)s.hasOwnProperty(u)&&(t._sets[u]=s[u]);var l=new o;for(var u in l._sets)s.hasOwnProperty(u)&&(t._sets[u]=s[u])}}return new n(t)},e.getClientFullVersionString=function(e){var t=e.get_appMinorVersion(),n="",r="",i=e.get_appName();return(1024==i||4096==i||8192==i||65536==i)&&1==e.get_appVersion()?r=4096==i&&t>=15?"16.00.01":"16.00":64==e.get_appName()?r=e.get_appVersion():(n=t<10?"0"+t:""+t,r=e.get_appVersion()+"."+n),e.get_appName()+"-"+r},e.initializeDefaultSetMatrix=function(){e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1600]=new a,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1600]=new u,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1600]=new f,e.DefaultSetArrayMatrix[e.Excel_RCLIENT_1601]=new s,e.DefaultSetArrayMatrix[e.Word_RCLIENT_1601]=new l,e.DefaultSetArrayMatrix[e.PowerPoint_RCLIENT_1601]=new d,e.DefaultSetArrayMatrix[e.Outlook_RCLIENT_1600]=new c,e.DefaultSetArrayMatrix[e.Excel_WAC_1600]=new h,e.DefaultSetArrayMatrix[e.Word_WAC_1600]=new m,e.DefaultSetArrayMatrix[e.Outlook_WAC_1600]=new y,e.DefaultSetArrayMatrix[e.Outlook_WAC_1601]=new y,e.DefaultSetArrayMatrix[e.Project_RCLIENT_1600]=new p,e.DefaultSetArrayMatrix[e.Access_WAC_1600]=new v,e.DefaultSetArrayMatrix[e.PowerPoint_WAC_1600]=new g,e.DefaultSetArrayMatrix[e.Excel_IOS_1600]=new b,e.DefaultSetArrayMatrix[e.SWAY_WAC_1600]=new O,e.DefaultSetArrayMatrix[e.Word_IOS_1600]=new S,e.DefaultSetArrayMatrix[e.Word_IOS_16001]=new _,e.DefaultSetArrayMatrix[e.PowerPoint_IOS_1600]=new A,e.DefaultSetArrayMatrix[e.Outlook_IOS_1600]=new D},e.Excel_RCLIENT_1600="1-16.00",e.Excel_RCLIENT_1601="1-16.01",e.Word_RCLIENT_1600="2-16.00",e.Word_RCLIENT_1601="2-16.01",e.PowerPoint_RCLIENT_1600="4-16.00",e.PowerPoint_RCLIENT_1601="4-16.01",e.Outlook_RCLIENT_1600="8-16.00",e.Excel_WAC_1600="16-16.00",e.Word_WAC_1600="32-16.00",e.Outlook_WAC_1600="64-16.00",e.Outlook_WAC_1601="64-16.01",e.Project_RCLIENT_1600="128-16.00",e.Access_WAC_1600="256-16.00",e.PowerPoint_WAC_1600="512-16.00",e.Excel_IOS_1600="1024-16.00",e.SWAY_WAC_1600="2048-16.00",e.Word_IOS_1600="4096-16.00",e.Word_IOS_16001="4096-16.00.01",e.PowerPoint_IOS_1600="8192-16.00",e.Outlook_IOS_1600="65536-16.00",e.DefaultSetArrayMatrix={},e}();e.RequirementsMatrixFactory=C}(e.Requirement||(e.Requirement={}))}(OfficeExt||(OfficeExt={})),OfficeExt.Requirement.RequirementsMatrixFactory.initializeOsfDda(),Microsoft.Office.WebExtension.ApplicationMode={WebEditor:"webEditor",WebViewer:"webViewer",Client:"client"},Microsoft.Office.WebExtension.DocumentMode={ReadOnly:"readOnly",ReadWrite:"readWrite"},OSF.NamespaceManager=function(){var e,t=!1;return{enableShortcut:function(){t||(window.Office?e=window.Office:OSF.OUtil.setNamespace("Office",window),window.Office=Microsoft.Office.WebExtension,t=!0)},disableShortcut:function(){t&&(e?window.Office=e:OSF.OUtil.unsetNamespace("Office",window),t=!1)}}}(),OSF.NamespaceManager.enableShortcut(),Microsoft.Office.WebExtension.useShortNamespace=function(e){e?OSF.NamespaceManager.enableShortcut():OSF.NamespaceManager.disableShortcut()},Microsoft.Office.WebExtension.select=function(e,t){var n;if(e&&"string"==typeof e){var r=e.indexOf("#");if(-1!=r){var i=e.substring(0,r),o=e.substring(r+1);switch(i){case"binding":case"bindings":o&&(n=new OSF.DDA.BindingPromise(o))}}}if(n)return n.onFail=t,n;if(t){var a=typeof t;if("function"!=a)throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,a);var s={};s[Microsoft.Office.WebExtension.Parameters.Callback]=t,OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext,OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidApiCallInContext))}},OSF.DDA.Context=function(e,t,n,r,i){if(OSF.OUtil.defineEnumerableProperties(this,{contentLanguage:{value:e.get_dataLocale()},displayLanguage:{value:e.get_appUILocale()},touchEnabled:{value:e.get_touchEnabled()},commerceAllowed:{value:e.get_commerceAllowed()},host:{value:OfficeExt.HostName.Host.getInstance().getHost()},platform:{value:OfficeExt.HostName.Host.getInstance().getPlatform()},isDialog:{value:OSF._OfficeAppFactory.getHostInfo().isDialog},diagnostics:{value:OfficeExt.HostName.Host.getInstance().getDiagnostics(e.get_hostFullVersion())}}),n&&OSF.OUtil.defineEnumerableProperty(this,"license",{value:n}),e.ui&&OSF.OUtil.defineEnumerableProperty(this,"ui",{value:e.ui}),e.auth&&OSF.OUtil.defineEnumerableProperty(this,"auth",{value:e.auth}),e.webAuth&&OSF.OUtil.defineEnumerableProperty(this,"webAuth",{value:e.webAuth}),e.application&&OSF.OUtil.defineEnumerableProperty(this,"application",{value:e.application}),e.extensionLifeCycle&&OSF.OUtil.defineEnumerableProperty(this,"extensionLifeCycle",{value:e.extensionLifeCycle}),e.messaging&&OSF.OUtil.defineEnumerableProperty(this,"messaging",{value:e.messaging}),e.ui&&e.ui.taskPaneAction&&OSF.OUtil.defineEnumerableProperty(this,"taskPaneAction",{value:e.ui.taskPaneAction}),e.ui&&e.ui.ribbonGallery&&OSF.OUtil.defineEnumerableProperty(this,"ribbonGallery",{value:e.ui.ribbonGallery}),e.get_isDialog()){var o=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultDialogRequirementMatrix(e);OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:o})}else{if(t&&OSF.OUtil.defineEnumerableProperty(this,"document",{value:t}),r){var a=r.displayName||"appOM";delete r.displayName,OSF.OUtil.defineEnumerableProperty(this,a,{value:r})}e.get_officeTheme()?OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return e.get_officeTheme()}}):i&&OSF.OUtil.defineEnumerableProperty(this,"officeTheme",{get:function(){return i()}});o=OfficeExt.Requirement.RequirementsMatrixFactory.getDefaultRequirementMatrix(e);if(OSF.OUtil.defineEnumerableProperty(this,"requirements",{value:o}),e.get_featureGates){var s=e.get_featureGates();if(s&&s.EnablePublicThemeManager){var c=new OSF.DDA.Theming.InternalThemeHandler;c.InitializeThemeManager(),OSF.OUtil.defineEnumerableProperty(this,"themeManager",{value:c})}}}},OSF.DDA.OutlookContext=function(e,t,n,r,i){var o;(OSF.DDA.OutlookContext.uber.constructor.call(this,e,null,n,r,i),e&&e.appOM&&e.appOM.initialData&&e.appOM.initialData.roamingSettings)?(o=OSF.InitializationHelper.prototype.deserializeSettings({SettingsKey:e.appOM.initialData.roamingSettings},!1),OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:o})):t&&OSF.OUtil.defineEnumerableProperty(this,"roamingSettings",{value:t});e.sensitivityLabelsCatalog&&OSF.OUtil.defineEnumerableProperty(this,"sensitivityLabelsCatalog",{value:e.sensitivityLabelsCatalog()})},OSF.OUtil.extend(OSF.DDA.OutlookContext,OSF.DDA.Context),OSF.DDA.OutlookAppOm=function(e,t,n){},OSF.DDA.Application=function(e){},OSF.DDA.Document=function(e,t){var n;switch(e.get_clientMode()){case OSF.ClientMode.ReadOnly:n=Microsoft.Office.WebExtension.DocumentMode.ReadOnly;break;case OSF.ClientMode.ReadWrite:n=Microsoft.Office.WebExtension.DocumentMode.ReadWrite}t&&OSF.OUtil.defineEnumerableProperty(this,"settings",{value:t}),OSF.OUtil.defineMutableProperties(this,{mode:{value:n},url:{value:e.get_docUrl()}})},OSF.DDA.JsomDocument=function(e,t,n){OSF.DDA.JsomDocument.uber.constructor.call(this,e,n),t&&OSF.OUtil.defineEnumerableProperty(this,"bindings",{get:function(){return t}});var r=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[r.GetSelectedDataAsync,r.SetSelectedDataAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged]))},OSF.OUtil.extend(OSF.DDA.JsomDocument,OSF.DDA.Document),OSF.OUtil.defineEnumerableProperty(Microsoft.Office.WebExtension,"context",{get:function(){var e;return OSF&&OSF._OfficeAppFactory&&(e=OSF._OfficeAppFactory.getContext()),e}}),OSF.DDA.License=function(e){OSF.OUtil.defineEnumerableProperty(this,"value",{value:e})},OSF.DDA.ApiMethodCall=function(e,t,n,r,i){var o=e.length,a=OSF.OUtil.delayExecutionAndCache((function(){return OSF.OUtil.formatString(Strings.OfficeOM.L_InvalidParameters,i)}));this.verifyArguments=function(e,t){for(var n in e){var r=e[n],i=t[n];if(r.enum)switch(typeof i){case"string":if(OSF.OUtil.listContainsValue(r.enum,i))break;case"undefined":throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedEnumeration;default:throw a()}if(r.types&&!OSF.OUtil.listContainsValue(r.types,typeof i))throw a()}},this.extractRequiredArguments=function(t,n,r){if(t.length<o)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_MissingRequiredArguments);var i,s=[];for(i=0;i<o;i++)s.push(t[i]);this.verifyArguments(e,s);var c={};for(i=0;i<o;i++){var u=e[i],l=s[i];if(u.verify)if(!u.verify(l,n,r))throw a();c[u.name]=l}return c},this.fillOptions=function(e,n,r,i){for(var o in e=e||{},t)if(!OSF.OUtil.listContainsKey(e,o)){var a=void 0,s=t[o];s.calculate&&n&&(a=s.calculate(n,r,i)),a||void 0===s.defaultValue||(a=s.defaultValue),e[o]=a}return e},this.constructCallArgs=function(e,t,i,o){var a={};for(var s in e)a[s]=e[s];for(var c in t)a[c]=t[c];for(var u in n)a[u]=n[u](i,o);return r&&(a=r(a,i,o)),a}},OSF.OUtil.setNamespace("AsyncResultEnum",OSF.DDA),OSF.DDA.AsyncResultEnum.Properties={Context:"Context",Value:"Value",Status:"Status",Error:"Error"},Microsoft.Office.WebExtension.AsyncResultStatus={Succeeded:"succeeded",Failed:"failed"},OSF.DDA.AsyncResultEnum.ErrorCode={Success:0,Failed:1},OSF.DDA.AsyncResultEnum.ErrorProperties={Name:"Name",Message:"Message",Code:"Code"},OSF.DDA.AsyncMethodNames={},OSF.DDA.AsyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.AsyncMethodNames[t]=n}},OSF.DDA.AsyncMethodCall=function(e,t,n,r,i,o,a){var s=e.length,c=new OSF.DDA.ApiMethodCall(e,t,n,o,a);this.verifyAndExtractCall=function(e,n,r){var i=c.extractRequiredArguments(e,n,r),o=function(e,n,r,i){if(e.length>s+2)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var o,a,u=e.length-1;u>=s;u--){var l=e[u];switch(typeof l){case"object":if(o)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);o=l;break;case"function":if(a)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalFunction);a=l;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}if(o=c.fillOptions(o,n,r,i),a){if(o[Microsoft.Office.WebExtension.Parameters.Callback])throw Strings.OfficeOM.L_RedundantCallbackSpecification;o[Microsoft.Office.WebExtension.Parameters.Callback]=a}return c.verifyArguments(t,o),o}(e,i,n,r);return c.constructCallArgs(i,o,n,r)},this.processResponse=function(e,t,n,o){return e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?r?r(t,n,o):t:i?i(e,t):OSF.DDA.ErrorCodeManager.getErrorArgs(e)},this.getCallArgs=function(e){for(var t,n,r=e.length-1;r>=s;r--){var i=e[r];switch(typeof i){case"object":t=i;break;case"function":n=i}}return t=t||{},n&&(t[Microsoft.Office.WebExtension.Parameters.Callback]=n),t}},OSF.DDA.AsyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[],n=e.privateStateCallbacks?OSF.OUtil.createObject(e.privateStateCallbacks):[];return new OSF.DDA.AsyncMethodCall(e.requiredArguments||[],t,n,e.onSucceeded,e.onFailed,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.AsyncMethodCalls={},OSF.DDA.AsyncMethodCalls.define=function(e){OSF.DDA.AsyncMethodCalls[e.method.id]=OSF.DDA.AsyncMethodCallFactory.manufacture(e)},OSF.DDA.Error=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{name:{value:e},message:{value:t},code:{value:n}})},OSF.DDA.AsyncResult=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{value:{value:e[OSF.DDA.AsyncResultEnum.Properties.Value]},status:{value:t?Microsoft.Office.WebExtension.AsyncResultStatus.Failed:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded}}),e[OSF.DDA.AsyncResultEnum.Properties.Context]&&OSF.OUtil.defineEnumerableProperty(this,"asyncContext",{value:e[OSF.DDA.AsyncResultEnum.Properties.Context]}),t&&OSF.OUtil.defineEnumerableProperty(this,"error",{value:new OSF.DDA.Error(t[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],t[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])})},OSF.DDA.issueAsyncResult=function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Callback];if(r){var i,o={};o[OSF.DDA.AsyncResultEnum.Properties.Context]=e[Microsoft.Office.WebExtension.Parameters.AsyncContext],t==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess?o[OSF.DDA.AsyncResultEnum.Properties.Value]=n:(i={},n=n||OSF.DDA.ErrorCodeManager.getErrorArgs(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError),i[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=t||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,i[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=n.name||n,i[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=n.message||n),r(new OSF.DDA.AsyncResult(o,i))}},OSF.DDA.SyncMethodNames={},OSF.DDA.SyncMethodNames.addNames=function(e){for(var t in e){var n={};OSF.OUtil.defineEnumerableProperties(n,{id:{value:t},displayName:{value:e[t]}}),OSF.DDA.SyncMethodNames[t]=n}},OSF.DDA.SyncMethodCall=function(e,t,n,r,i){var o=e.length,a=new OSF.DDA.ApiMethodCall(e,t,n,r,i);this.verifyAndExtractCall=function(e,n,r){var i=a.extractRequiredArguments(e,n,r),s=function(e,n,r,i){if(e.length>o+1)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyArguments);for(var s,c=e.length-1;c>=o;c--){var u=e[c];switch(typeof u){case"object":if(s)throw OsfMsAjaxFactory.msAjaxError.parameterCount(Strings.OfficeOM.L_TooManyOptionalObjects);s=u;break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Strings.OfficeOM.L_InValidOptionalArgument)}}return s=a.fillOptions(s,n,r,i),a.verifyArguments(t,s),s}(e,i,n,r);return a.constructCallArgs(i,s,n,r)}},OSF.DDA.SyncMethodCallFactory=function(){return{manufacture:function(e){var t=e.supportedOptions?OSF.OUtil.createObject(e.supportedOptions):[];return new OSF.DDA.SyncMethodCall(e.requiredArguments||[],t,e.privateStateCallbacks,e.checkCallArgs,e.method.displayName)}}}(),OSF.DDA.SyncMethodCalls={},OSF.DDA.SyncMethodCalls.define=function(e){OSF.DDA.SyncMethodCalls[e.method.id]=OSF.DDA.SyncMethodCallFactory.manufacture(e)},OSF.DDA.ListType=function(){var e={};return{setListType:function(t,n){e[t]=n},isListType:function(t){return OSF.OUtil.listContainsKey(e,t)},getDescriptor:function(t){return e[t]}}}(),OSF.DDA.HostParameterMap=function(e,t){var n={};function r(i,o){var a=i?{}:void 0;for(var s in i){var c,u=i[s];if(OSF.DDA.ListType.isListType(s))for(var l in c=[],u)c.push(r(u[l],o));else if(OSF.OUtil.listContainsKey(n,s))c=n[s][o](u);else if("fromHost"==o&&e.preserveNesting(s))c=r(u,o);else{var f=t[s];if(f){var d=f[o];d&&void 0===(c=d[u])&&(c=u)}else c=u}a[s]=c}return a}function i(n,i,o){var a,s=t[n][o];if("toHost"==o)a=function n(r,i){var o;for(var a in i){var s;if(void 0!=(s=e.isComplexType(a)?n(r,t[a].toHost):r[a])){o||(o={});var c=i[a];"self"==c&&(c=a),o[c]=e.pack(a,s)}}return o}(r(i,o),s);else if("fromHost"==o){a=r(function n(r,i,o){for(var a in o||(o={}),i){var s,c,u=i[a];if("self"==u)s=r;else{if("sourceData"==u){o[a]=r.toArray();continue}s=r[u]}if(null===s||void 0===s)o[a]=void 0;else if(s=e.unpack(a,s),e.isComplexType(a))c=t[a].fromHost,e.preserveNesting(a)?o[a]=n(s,c):n(s,c,o);else if(OSF.DDA.ListType.isListType(a)){(c={})[OSF.DDA.ListType.getDescriptor(a)]="self";var l=new Array(s.length);for(var f in s)l[f]=n(s[f],c);o[a]=l}else o[a]=s}return o}(i,s),o)}return a}n[Microsoft.Office.WebExtension.Parameters.Data]={toHost:function(e){if(null!=e&&void 0!==e.rows){var t={};t[OSF.DDA.TableDataProperties.TableRows]=e.rows,t[OSF.DDA.TableDataProperties.TableHeaders]=e.headers,e=t}return e},fromHost:function(e){return e}},n[Microsoft.Office.WebExtension.Parameters.JsonData]={toHost:function(e){return e},fromHost:function(e){return"string"===typeof e?JSON.parse(e):e}},n[Microsoft.Office.WebExtension.Parameters.SampleData]=n[Microsoft.Office.WebExtension.Parameters.Data],t||(t={}),this.addMapping=function(e,n){var r,i;if(n.map)for(var o in i={},r=n.map){var a=r[o];"self"==a&&(a=o),i[a]=o}else r=n.toHost,i=n.fromHost;var s=t[e];if(s){var c=s.toHost;for(var u in c)r[u]=c[u];for(var l in c=s.fromHost)i[l]=c[l]}else s=t[e]={};s.toHost=r,s.fromHost=i},this.toHost=function(e,t){return i(e,t,"toHost")},this.fromHost=function(e,t){return i(e,t,"fromHost")},this.self="self",this.sourceData="sourceData",this.addComplexType=function(t){e.addComplexType(t)},this.getDynamicType=function(t){return e.getDynamicType(t)},this.setDynamicType=function(t,n){e.setDynamicType(t,n)},this.dynamicTypes=n,this.doMapValues=function(e,t){return r(e,t)}},OSF.DDA.SpecialProcessor=function(e,t){this.addComplexType=function(t){e.push(t)},this.getDynamicType=function(e){return t[e]},this.setDynamicType=function(e,n){t[e]=n},this.isComplexType=function(t){return OSF.OUtil.listContainsValue(e,t)},this.isDynamicType=function(e){return OSF.OUtil.listContainsKey(t,e)},this.preserveNesting=function(e){var t=[];return OSF.DDA.PropertyDescriptors&&t.push(OSF.DDA.PropertyDescriptors.Subset),OSF.DDA.DataNodeEventProperties&&(t=t.concat([OSF.DDA.DataNodeEventProperties.OldNode,OSF.DDA.DataNodeEventProperties.NewNode,OSF.DDA.DataNodeEventProperties.NextSiblingNode])),OSF.OUtil.listContainsValue(t,e)},this.pack=function(e,n){return this.isDynamicType(e)?t[e].toHost(n):n},this.unpack=function(e,n){return this.isDynamicType(e)?t[e].fromHost(n):n}},OSF.DDA.getDecoratedParameterMap=function(e,t){var n=new OSF.DDA.HostParameterMap(e);n.self;function r(e){var t=null;if(e){t={};for(var n=e.length,r=0;r<n;r++)t[e[r].name]=e[r].value}return t}for(var i in n.define=function(e){var t={},i=r(e.toHost);e.invertible?t.map=i:e.canonical?t.toHost=t.fromHost=i:(t.toHost=i,t.fromHost=r(e.fromHost)),n.addMapping(e.type,t),e.isComplexType&&n.addComplexType(e.type)},t)n.define(t[i]);return n},OSF.OUtil.setNamespace("DispIdHost",OSF.DDA),OSF.DDA.DispIdHost.Methods={InvokeMethod:"invokeMethod",AddEventHandler:"addEventHandler",RemoveEventHandler:"removeEventHandler",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Delegates={ExecuteAsync:"executeAsync",RegisterEventAsync:"registerEventAsync",UnregisterEventAsync:"unregisterEventAsync",ParameterMap:"parameterMap",OpenDialog:"openDialog",CloseDialog:"closeDialog",MessageParent:"messageParent",SendMessage:"sendMessage"},OSF.DDA.DispIdHost.Facade=function(e,t){var n={},r=OSF.DDA.AsyncMethodNames,i=OSF.DDA.MethodDispId,o={GoToByIdAsync:i.dispidNavigateToMethod,GetSelectedDataAsync:i.dispidGetSelectedDataMethod,SetSelectedDataAsync:i.dispidSetSelectedDataMethod,GetDocumentCopyChunkAsync:i.dispidGetDocumentCopyChunkMethod,ReleaseDocumentCopyAsync:i.dispidReleaseDocumentCopyMethod,GetDocumentCopyAsync:i.dispidGetDocumentCopyMethod,AddFromSelectionAsync:i.dispidAddBindingFromSelectionMethod,AddFromPromptAsync:i.dispidAddBindingFromPromptMethod,AddFromNamedItemAsync:i.dispidAddBindingFromNamedItemMethod,GetAllAsync:i.dispidGetAllBindingsMethod,GetByIdAsync:i.dispidGetBindingMethod,ReleaseByIdAsync:i.dispidReleaseBindingMethod,GetDataAsync:i.dispidGetBindingDataMethod,SetDataAsync:i.dispidSetBindingDataMethod,AddRowsAsync:i.dispidAddRowsMethod,AddColumnsAsync:i.dispidAddColumnsMethod,DeleteAllDataValuesAsync:i.dispidClearAllRowsMethod,RefreshAsync:i.dispidLoadSettingsMethod,SaveAsync:i.dispidSaveSettingsMethod,GetActiveViewAsync:i.dispidGetActiveViewMethod,GetFilePropertiesAsync:i.dispidGetFilePropertiesMethod,GetOfficeThemeAsync:i.dispidGetOfficeThemeMethod,GetDocumentThemeAsync:i.dispidGetDocumentThemeMethod,ClearFormatsAsync:i.dispidClearFormatsMethod,SetTableOptionsAsync:i.dispidSetTableOptionsMethod,SetFormatsAsync:i.dispidSetFormatsMethod,GetAccessTokenAsync:i.dispidGetAccessTokenMethod,GetAuthContextAsync:i.dispidGetAuthContextMethod,GetNestedAppAuthContextAsync:i.dispidGetNestedAppAuthContextMethod,ExecuteRichApiRequestAsync:i.dispidExecuteRichApiRequestMethod,AppCommandInvocationCompletedAsync:i.dispidAppCommandInvocationCompletedMethod,CloseContainerAsync:i.dispidCloseContainerMethod,OpenBrowserWindow:i.dispidOpenBrowserWindow,CreateDocumentAsync:i.dispidCreateDocumentMethod,InsertFormAsync:i.dispidInsertFormMethod,ExecuteFeature:i.dispidExecuteFeature,QueryFeature:i.dispidQueryFeature,AddDataPartAsync:i.dispidAddDataPartMethod,GetDataPartByIdAsync:i.dispidGetDataPartByIdMethod,GetDataPartsByNameSpaceAsync:i.dispidGetDataPartsByNamespaceMethod,GetPartXmlAsync:i.dispidGetDataPartXmlMethod,GetPartNodesAsync:i.dispidGetDataPartNodesMethod,DeleteDataPartAsync:i.dispidDeleteDataPartMethod,GetNodeValueAsync:i.dispidGetDataNodeValueMethod,GetNodeXmlAsync:i.dispidGetDataNodeXmlMethod,GetRelativeNodesAsync:i.dispidGetDataNodesMethod,SetNodeValueAsync:i.dispidSetDataNodeValueMethod,SetNodeXmlAsync:i.dispidSetDataNodeXmlMethod,AddDataPartNamespaceAsync:i.dispidAddDataNamespaceMethod,GetDataPartNamespaceAsync:i.dispidGetDataUriByPrefixMethod,GetDataPartPrefixAsync:i.dispidGetDataPrefixByUriMethod,GetNodeTextAsync:i.dispidGetDataNodeTextMethod,SetNodeTextAsync:i.dispidSetDataNodeTextMethod,GetSelectedTask:i.dispidGetSelectedTaskMethod,GetTask:i.dispidGetTaskMethod,GetWSSUrl:i.dispidGetWSSUrlMethod,GetTaskField:i.dispidGetTaskFieldMethod,GetSelectedResource:i.dispidGetSelectedResourceMethod,GetResourceField:i.dispidGetResourceFieldMethod,GetProjectField:i.dispidGetProjectFieldMethod,GetSelectedView:i.dispidGetSelectedViewMethod,GetTaskByIndex:i.dispidGetTaskByIndexMethod,GetResourceByIndex:i.dispidGetResourceByIndexMethod,SetTaskField:i.dispidSetTaskFieldMethod,SetResourceField:i.dispidSetResourceFieldMethod,GetMaxTaskIndex:i.dispidGetMaxTaskIndexMethod,GetMaxResourceIndex:i.dispidGetMaxResourceIndexMethod,CreateTask:i.dispidCreateTaskMethod};for(var a in o)r[a]&&(n[r[a].id]=o[a]);r=OSF.DDA.SyncMethodNames;var s={MessageParent:(i=OSF.DDA.MethodDispId).dispidMessageParentMethod,SendMessage:i.dispidSendMessageMethod};for(var a in s)r[a]&&(n[r[a].id]=s[a]);r=Microsoft.Office.WebExtension.EventType;var c={SettingsChanged:(i=OSF.DDA.EventDispId).dispidSettingsChangedEvent,DocumentSelectionChanged:i.dispidDocumentSelectionChangedEvent,BindingSelectionChanged:i.dispidBindingSelectionChangedEvent,BindingDataChanged:i.dispidBindingDataChangedEvent,ActiveViewChanged:i.dispidActiveViewChangedEvent,OfficeThemeChanged:i.dispidOfficeThemeChangedEvent,DocumentThemeChanged:i.dispidDocumentThemeChangedEvent,AppCommandInvoked:i.dispidAppCommandInvokedEvent,DialogMessageReceived:i.dispidDialogMessageReceivedEvent,DialogParentMessageReceived:i.dispidDialogParentMessageReceivedEvent,ObjectDeleted:i.dispidObjectDeletedEvent,ObjectSelectionChanged:i.dispidObjectSelectionChangedEvent,ObjectDataChanged:i.dispidObjectDataChangedEvent,ContentControlAdded:i.dispidContentControlAddedEvent,Suspend:i.dispidSuspend,Resume:i.dispidResume,RichApiMessage:i.dispidRichApiMessageEvent,ItemChanged:i.dispidOlkItemSelectedChangedEvent,RecipientsChanged:i.dispidOlkRecipientsChangedEvent,AppointmentTimeChanged:i.dispidOlkAppointmentTimeChangedEvent,RecurrenceChanged:i.dispidOlkRecurrenceChangedEvent,AttachmentsChanged:i.dispidOlkAttachmentsChangedEvent,EnhancedLocationsChanged:i.dispidOlkEnhancedLocationsChangedEvent,InfobarClicked:i.dispidOlkInfobarClickedEvent,SelectedItemsChanged:i.dispidOlkSelectedItemsChangedEvent,SensitivityLabelChanged:i.dispidOlkSensitivityLabelChangedEvent,TaskSelectionChanged:i.dispidTaskSelectionChangedEvent,ResourceSelectionChanged:i.dispidResourceSelectionChangedEvent,ViewSelectionChanged:i.dispidViewSelectionChangedEvent,DataNodeInserted:i.dispidDataNodeAddedEvent,DataNodeReplaced:i.dispidDataNodeReplacedEvent,DataNodeDeleted:i.dispidDataNodeDeletedEvent};for(var u in c)r[u]&&(n[r[u]]=c[u]);function l(e){return e==OSF.DDA.EventDispId.dispidObjectDeletedEvent||e==OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent||e==OSF.DDA.EventDispId.dispidObjectDataChangedEvent||e==OSF.DDA.EventDispId.dispidContentControlAddedEvent}function f(e,t,n,r){if("number"!=typeof e)throw e;r||(r=t.getCallArgs(n)),OSF.DDA.issueAsyncResult(r,e,OSF.DDA.ErrorCodeManager.getErrorArgs(e))}this[OSF.DDA.DispIdHost.Methods.InvokeMethod]=function(r,i,o,a){var s;try{var c=r.id,u=OSF.DDA.AsyncMethodCalls[c];s=u.verifyAndExtractCall(i,o,a);var l=n[c],d=e(c),p=null;if(window.Excel&&window.Office.context.requirements.isSetSupported("RedirectV1Api")&&(window.Excel._RedirectV1APIs=!0),window.Excel&&window.Excel._RedirectV1APIs&&(p=window.Excel._V1APIMap[c])){var h=OSF.OUtil.shallowCopy(s);delete h[Microsoft.Office.WebExtension.Parameters.AsyncContext],p.preprocess&&(h=p.preprocess(h));var m=new window.Excel.RequestContext,g=p.call(m,h);m.sync().then((function(){var e=g.value,t=e.status;delete e.status,delete e["@odata.type"],p.postprocess&&(e=p.postprocess(e,h)),0!=t&&(e=OSF.DDA.ErrorCodeManager.getErrorArgs(t)),OSF.DDA.issueAsyncResult(s,t,e)})).catch((function(e){OSF.DDA.issueAsyncResult(s,OSF.DDA.ErrorCodeManager.errorCodes.ooeFailure,null)}))}else{var y;y=t.toHost?t.toHost(l,s):s;var O=(new Date).getTime();d[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]({dispId:l,hostCallArgs:y,onCalling:function(){},onReceiving:function(){},onComplete:function(e,n){var r;r=e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&t.fromHost?t.fromHost(l,n):n;var i=u.processResponse(e,r,o,s);OSF.DDA.issueAsyncResult(s,e,i),!OSF.AppTelemetry||OSF.ConstantNames&&OSF.ConstantNames.IsCustomFunctionsRuntime||OSF.AppTelemetry.onMethodDone(l,y,Math.abs((new Date).getTime()-O),e)}})}}catch(e){f(e,u,i,s)}},this[OSF.DDA.DispIdHost.Methods.AddEventHandler]=function(r,i,o,a){var s,c,u,d=!1;function p(e){var t;e==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&((d?i.addObjectEventHandler(c,s[Microsoft.Office.WebExtension.Parameters.Id],u):i.addEventHandler(c,u))||(e=OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerAdditionFailed));e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(s,e,t)}try{var h=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.AddHandlerAsync.id];if(s=h.verifyAndExtractCall(r,o,i),c=s[Microsoft.Office.WebExtension.Parameters.EventType],u=s[Microsoft.Office.WebExtension.Parameters.Handler],a)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess);var m=n[c],g=(d=l(m))?s[Microsoft.Office.WebExtension.Parameters.Id]:o.id||"";if(0==(d?i.getObjectEventHandlerCount(c,g):i.getEventHandlerCount(c)))(0,e(c)[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync])({eventType:c,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:p,onEvent:function(e){var n=null,r=OSF._OfficeAppFactory.getHostInfo();n=r&&"web"==r.hostPlatform.toLowerCase()&&m==OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent?e:t.fromHost(m,e),d?i.fireObjectEvent(g,OSF.DDA.OMFactory.manufactureEventArgs(c,g,n)):i.fireEvent(OSF.DDA.OMFactory.manufactureEventArgs(c,o,n))}});else p(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)}catch(e){f(e,h,r,s)}},this[OSF.DDA.DispIdHost.Methods.RemoveEventHandler]=function(t,r,i){var o,a,s,c=!1;function u(e){var t;e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess&&(t=OSF.DDA.ErrorCodeManager.getErrorArgs(e)),OSF.DDA.issueAsyncResult(o,e,t)}try{var d=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.id];a=(o=d.verifyAndExtractCall(t,i,r))[Microsoft.Office.WebExtension.Parameters.EventType],s=o[Microsoft.Office.WebExtension.Parameters.Handler];var p,h,m=n[a],g=(c=l(m))?o[Microsoft.Office.WebExtension.Parameters.Id]:i.id||"";null===s?(h=c?r.clearObjectEventHandlers(a,g):r.clearEventHandlers(a),p=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):p=(h=c?r.removeObjectEventHandler(a,g,s):r.removeEventHandler(a,s))?OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess:OSF.DDA.ErrorCodeManager.errorCodes.ooeEventHandlerNotExist;var y=c?r.getObjectEventHandlerCount(a,g):r.getEventHandlerCount(a);if(h&&0==y)(0,e(a)[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:a,dispId:m,targetId:g,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:u});else u(p)}catch(e){f(e,d,t,o)}},this[OSF.DDA.DispIdHost.Methods.OpenDialog]=function(r,i,o,a){var s,c,u=null,l=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,d=Microsoft.Office.WebExtension.EventType.DialogEventReceived;function p(e){if(e!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)n=OSF.DDA.ErrorCodeManager.getErrorArgs(e);else{var t={};t[Microsoft.Office.WebExtension.Parameters.Id]=c,t[Microsoft.Office.WebExtension.Parameters.Data]=i;var n=u.processResponse(e,t,o,s);OSF.DialogShownStatus.hasDialogShown=!0,i.clearEventHandlers(l),i.clearEventHandlers(d)}OSF.DDA.issueAsyncResult(s,e,n)}try{if(void 0!=l&&void 0!=d||p(OSF.DDA.ErrorCodeManager.ooeOperationNotSupported),a){if(null==OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);u=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.id]}else{if(null==OSF.DDA.AsyncMethodNames.DisplayDialogAsync)return void p(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError);u=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.DisplayDialogAsync.id]}s=u.verifyAndExtractCall(r,o,i);var h=n[l],m=e(l),g=void 0!=m[OSF.DDA.DispIdHost.Delegates.OpenDialog]?m[OSF.DDA.DispIdHost.Delegates.OpenDialog]:m[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync];s.isModal=a,c=JSON.stringify(s),OSF.DialogShownStatus.hasDialogShown||(i.clearQueuedEvent(l),i.clearQueuedEvent(d),i.clearQueuedEvent(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived)),g({eventType:l,dispId:h,targetId:c,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:p,onEvent:function(e){var n=t.fromHost(h,e),r=OSF.DDA.OMFactory.manufactureEventArgs(l,o,n);if(r.type==d){var a=OSF.DDA.ErrorCodeManager.getErrorArgs(r.error),s={};s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code]=status||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name]=a.name||a,s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message]=a.message||a,r.error=new OSF.DDA.Error(s[OSF.DDA.AsyncResultEnum.ErrorProperties.Name],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Message],s[OSF.DDA.AsyncResultEnum.ErrorProperties.Code])}i.fireOrQueueEvent(r),n[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogClosed&&(i.clearEventHandlers(l),i.clearEventHandlers(d),i.clearEventHandlers(Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived),OSF.DialogShownStatus.hasDialogShown=!1)}})}catch(e){f(e,u,r,s)}},this[OSF.DDA.DispIdHost.Methods.CloseDialog]=function(t,r,i,o){var a,s,c,u=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess;try{var l=OSF.DDA.AsyncMethodCalls[OSF.DDA.AsyncMethodNames.CloseAsync.id];a=l.verifyAndExtractCall(t,o,i),s=Microsoft.Office.WebExtension.EventType.DialogMessageReceived,c=Microsoft.Office.WebExtension.EventType.DialogEventReceived,i.clearEventHandlers(s),i.clearEventHandlers(c);var d=n[s],p=e(s);(void 0!=p[OSF.DDA.DispIdHost.Delegates.CloseDialog]?p[OSF.DDA.DispIdHost.Delegates.CloseDialog]:p[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync])({eventType:s,dispId:d,targetId:r,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)},onComplete:function(e){u=e,OSF.DialogShownStatus.hasDialogShown=!1}})}catch(e){f(e,l,t,a)}if(u!=OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess)throw OSF.OUtil.formatString(Strings.OfficeOM.L_FunctionCallFailed,OSF.DDA.AsyncMethodNames.CloseAsync.displayName,u)},this[OSF.DDA.DispIdHost.Methods.MessageParent]=function(t,r){var i=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.MessageParent.id].verifyAndExtractCall(t,r,{});return(0,e(OSF.DDA.SyncMethodNames.MessageParent.id)[OSF.DDA.DispIdHost.Delegates.MessageParent])({dispId:n[OSF.DDA.SyncMethodNames.MessageParent.id],hostCallArgs:i,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})},this[OSF.DDA.DispIdHost.Methods.SendMessage]=function(t,r,i){var o=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.SendMessage.id].verifyAndExtractCall(t,i,{});return(0,e(OSF.DDA.SyncMethodNames.SendMessage.id)[OSF.DDA.DispIdHost.Delegates.SendMessage])({dispId:n[OSF.DDA.SyncMethodNames.SendMessage.id],hostCallArgs:o,onCalling:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.IssueCall)},onReceiving:function(){OSF.OUtil.writeProfilerMark(OSF.HostCallPerfMarker.ReceiveResponse)}})}},OSF.DDA.DispIdHost.addAsyncMethods=function(e,t,n){for(var r in t){var i=t[r],o=i.displayName;e[o]||OSF.OUtil.defineEnumerableProperty(e,o,{value:function(t){return function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.InvokeMethod];r(t,arguments,e,n)}}(i)})}},OSF.DDA.DispIdHost.addEventSupport=function(e,t,n){var r=OSF.DDA.AsyncMethodNames.AddHandlerAsync.displayName,i=OSF.DDA.AsyncMethodNames.RemoveHandlerAsync.displayName;e[r]||OSF.OUtil.defineEnumerableProperty(e,r,{value:function(){var r=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.AddEventHandler];r(arguments,t,e,n)}}),e[i]||OSF.OUtil.defineEnumerableProperty(e,i,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.RemoveEventHandler];n(arguments,t,e)}})},function(e){var t=function(){function e(){}return e.isInstanceOfType=function(e,t){if("undefined"===typeof t||null===t)return!1;if(t instanceof e)return!0;var n=t.constructor;return n&&"function"===typeof n&&n.__typeName&&"Object"!==n.__typeName||(n=Object),!(n!==e)||n.__typeName&&e.__typeName&&n.__typeName===e.__typeName},e}();e.MsAjaxTypeHelper=t;var n=function(){function e(){}return e.create=function(e,t){var n=new Error(e);if(n.message=e,t)for(var r in t)n[r]=t[r];return n.popStackFrame(),n},e.parameterCount=function(t){var n="Sys.ParameterCountException: "+(t||"Parameter count mismatch."),r=e.create(n,{name:"Sys.ParameterCountException"});return r.popStackFrame(),r},e.argument=function(t,n){var i="Sys.ArgumentException: "+(n||"Value does not fall within the expected range.");t&&(i+="\n"+r.format("Parameter name: {0}",t));var o=e.create(i,{name:"Sys.ArgumentException",paramName:t});return o.popStackFrame(),o},e.argumentNull=function(t,n){var i="Sys.ArgumentNullException: "+(n||"Value cannot be null.");t&&(i+="\n"+r.format("Parameter name: {0}",t));var o=e.create(i,{name:"Sys.ArgumentNullException",paramName:t});return o.popStackFrame(),o},e.argumentOutOfRange=function(t,n,i){var o="Sys.ArgumentOutOfRangeException: "+(i||"Specified argument was out of the range of valid values.");t&&(o+="\n"+r.format("Parameter name: {0}",t)),"undefined"!==typeof n&&null!==n&&(o+="\n"+r.format("Actual value was {0}.",n));var a=e.create(o,{name:"Sys.ArgumentOutOfRangeException",paramName:t,actualValue:n});return a.popStackFrame(),a},e.argumentType=function(t,n,i,o){var a="Sys.ArgumentTypeException: ";a+=o||(n&&i?r.format("Object of type '{0}' cannot be converted to type '{1}'.",n.getName?n.getName():n,i.getName?i.getName():i):"Object cannot be converted to the required type."),t&&(a+="\n"+r.format("Parameter name: {0}",t));var s=e.create(a,{name:"Sys.ArgumentTypeException",paramName:t,actualType:n,expectedType:i});return s.popStackFrame(),s},e.argumentUndefined=function(t,n){var i="Sys.ArgumentUndefinedException: "+(n||"Value cannot be undefined.");t&&(i+="\n"+r.format("Parameter name: {0}",t));var o=e.create(i,{name:"Sys.ArgumentUndefinedException",paramName:t});return o.popStackFrame(),o},e.invalidOperation=function(t){var n="Sys.InvalidOperationException: "+(t||"Operation is not valid due to the current state of the object."),r=e.create(n,{name:"Sys.InvalidOperationException"});return r.popStackFrame(),r},e}();e.MsAjaxError=n;var r=function(){function e(){}return e.format=function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=e;return r.replace(/{(\d+)}/gm,(function(e,n){var r=parseInt(n,10);return void 0===t[r]?"{"+n+"}":t[r]}))},e.startsWith=function(e,t){return e.substr(0,t.length)===t},e}();e.MsAjaxString=r;var i=function(){function e(){}return e.trace=function(e){"undefined"!==typeof Debug&&Debug.writeln&&Debug.writeln(e),window.console&&window.console.log&&window.console.log(e),window.opera&&window.opera.postError&&window.opera.postError(e),window.debugService&&window.debugService.trace&&window.debugService.trace(e);var t=document.getElementById("TraceConsole");t&&"TEXTAREA"===t.tagName.toUpperCase()&&t.appendChild(document.createTextNode(e+"\n"))},e}();if(e.MsAjaxDebug=i,!OsfMsAjaxFactory.isMsAjaxLoaded()){var o=function(e,t,n){void 0!==e.__typeName&&null!==e.__typeName||(e.__typeName=t),void 0!==e.__class&&null!==e.__class||(e.__class=n)};o(Function,"Function",!0),o(Error,"Error",!0),o(Object,"Object",!0),o(String,"String",!0),o(Boolean,"Boolean",!0),o(Date,"Date",!0),o(Number,"Number",!0),o(RegExp,"RegExp",!0),o(Array,"Array",!0),Function.createCallback||(Function.createCallback=function(e,t){var n=Function._validateParams(arguments,[{name:"method",type:Function},{name:"context",mayBeNull:!0}]);if(n)throw n;return function(){var n=arguments.length;if(n>0){for(var r=[],i=0;i<n;i++)r[i]=arguments[i];return r[n]=t,e.apply(this,r)}return e.call(this,t)}}),Function.createDelegate||(Function.createDelegate=function(e,t){var n=Function._validateParams(arguments,[{name:"instance",mayBeNull:!0},{name:"method",type:Function}]);if(n)throw n;return function(){return t.apply(e,arguments)}}),Function._validateParams||(Function._validateParams=function(e,t,n){var r,i=t.length;if(n=n||"undefined"===typeof n,r=Function._validateParameterCount(e,t,n))return r.popStackFrame(),r;for(var o=0,a=e.length;o<a;o++){var s=t[Math.min(o,i-1)],c=s.name;if(s.parameterArray)c+="["+(o-i+1)+"]";else if(!n&&o>=i)break;if(r=Function._validateParameter(e[o],s,c))return r.popStackFrame(),r}return null}),Function._validateParameterCount||(Function._validateParameterCount=function(e,t,r){var i,o,a=t.length,s=e.length;if(s<a){var c=a;for(i=0;i<a;i++){var u=t[i];(u.optional||u.parameterArray)&&c--}s<c&&(o=!0)}else if(r&&s>a)for(o=!0,i=0;i<a;i++)if(t[i].parameterArray){o=!1;break}if(o){var l=n.parameterCount();return l.popStackFrame(),l}return null}),Function._validateParameter||(Function._validateParameter=function(e,t,n){var r,i=t.type,o=!!t.integer,a=!!t.domElement,s=!!t.mayBeNull;if(r=Function._validateParameterType(e,i,o,a,s,n))return r.popStackFrame(),r;var c=t.elementType,u=!!t.elementMayBeNull;if(i===Array&&"undefined"!==typeof e&&null!==e&&(c||!u))for(var l=!!t.elementInteger,f=!!t.elementDomElement,d=0;d<e.length;d++){var p=e[d];if(r=Function._validateParameterType(p,c,l,f,u,n+"["+d+"]"))return r.popStackFrame(),r}return null}),Function._validateParameterType||(Function._validateParameterType=function(t,n,r,i,o,a){var s;return"undefined"===typeof t?o?null:((s=e.MsAjaxError.argumentUndefined(a)).popStackFrame(),s):null===t?o?null:((s=e.MsAjaxError.argumentNull(a)).popStackFrame(),s):n&&!e.MsAjaxTypeHelper.isInstanceOfType(n,t)?((s=e.MsAjaxError.argumentType(a,typeof t,n)).popStackFrame(),s):null}),window.Type||(window.Type=Function),Type.registerNamespace||(Type.registerNamespace=function(e){for(var t=e.split("."),n=window,r=0;r<t.length;r++)n[t[r]]=n[t[r]]||{},n=n[t[r]]}),Type.prototype.registerClass||(Type.prototype.registerClass=function(e){({})}),"undefined"===typeof Sys&&Type.registerNamespace("Sys"),Error.prototype.popStackFrame||(Error.prototype.popStackFrame=function(){if(0!==arguments.length)throw n.parameterCount();if("undefined"!==typeof this.stack&&null!==this.stack&&"undefined"!==typeof this.fileName&&null!==this.fileName&&"undefined"!==typeof this.lineNumber&&null!==this.lineNumber){for(var e=this.stack.split("\n"),t=e[0],r=this.fileName+":"+this.lineNumber;"undefined"!==typeof t&&null!==t&&-1===t.indexOf(r);)e.shift(),t=e[0];var i=e[1];if("undefined"!==typeof i&&null!==i){var o=i.match(/@(.*):(\d+)$/);"undefined"!==typeof o&&null!==o&&(this.fileName=o[1],this.lineNumber=parseInt(o[2]),e.shift(),this.stack=e.join("\n"))}}}),OsfMsAjaxFactory.msAjaxError=n,OsfMsAjaxFactory.msAjaxString=r,OsfMsAjaxFactory.msAjaxDebug=i}}(OfficeExt||(OfficeExt={})),OSF.OUtil.setNamespace("SafeArray",OSF.DDA),OSF.DDA.SafeArray.Response={Status:0,Payload:1},OSF.DDA.SafeArray.UniqueArguments={Offset:"offset",Run:"run",BindingSpecificData:"bindingSpecificData",MergedCellGuid:"{66e7831f-81b2-42e2-823c-89e872d541b3}"},OSF.OUtil.setNamespace("Delegate",OSF.DDA.SafeArray),OSF.DDA.SafeArray.Delegate._onException=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2147467259:n=t.dispId==OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent?OSF.DDA.ErrorCodeManager.errorCodes.ooeDialogAlreadyOpened:OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;break;case-2146828283:case-2147209089:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidParam;break;case-2147208704:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeTooManyIncompleteRequests;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}t.onComplete&&t.onComplete(n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError)},OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod=function(e,t){var n,r=e.number;if(r)switch(r){case-2146828218:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeNoCapability;break;case-2146827850:default:n=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}return n||OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError},OSF.DDA.SafeArray.Delegate.SpecialProcessor=function(){function e(e){var t;try{var n=e.ubound(1),r=e.ubound(2);if(e=e.toArray(),1==n&&1==r)t=[e];else{t=[];for(var i=0;i<n;i++){for(var o=[],a=0;a<r;a++){var s=e[i*r+a];s!=OSF.DDA.SafeArray.UniqueArguments.MergedCellGuid&&o.push(s)}o.length>0&&t.push(o)}}}catch(e){}return t}var t={};t[Microsoft.Office.WebExtension.Parameters.Data]=function(){return{toHost:function(e){if(OSF.DDA.TableDataProperties&&"string"!=typeof e&&void 0!==e[OSF.DDA.TableDataProperties.TableRows]){var t=[];t[0]=e[OSF.DDA.TableDataProperties.TableRows],t[1]=e[OSF.DDA.TableDataProperties.TableHeaders],e=t}return e},fromHost:function(t){var n;if(t.toArray)if(2===t.dimensions())n=e(t);else{var r=t.toArray();2===r.length&&(null!=r[0]&&r[0].toArray||null!=r[1]&&r[1].toArray)?((n={})[OSF.DDA.TableDataProperties.TableRows]=e(r[0]),n[OSF.DDA.TableDataProperties.TableHeaders]=e(r[1])):n=r}else n=t;return n}}}(),OSF.DDA.SafeArray.Delegate.SpecialProcessor.uber.constructor.call(this,[],t),this.unpack=function(e,n){var r;this.isComplexType(e)||OSF.DDA.ListType.isListType(e)?r=void 0!==n&&void 0!==n.toArray?n.toArray():n||{}:r=this.isDynamicType(e)?t[e].fromHost(n):n;return r}},OSF.OUtil.extend(OSF.DDA.SafeArray.Delegate.SpecialProcessor,OSF.DDA.SpecialProcessor),OSF.DDA.SafeArray.Delegate.ParameterMap=OSF.DDA.getDecoratedParameterMap(new OSF.DDA.SafeArray.Delegate.SpecialProcessor,[{type:Microsoft.Office.WebExtension.Parameters.ValueFormat,toHost:[{name:Microsoft.Office.WebExtension.ValueFormat.Unformatted,value:0},{name:Microsoft.Office.WebExtension.ValueFormat.Formatted,value:1}]},{type:Microsoft.Office.WebExtension.Parameters.FilterType,toHost:[{name:Microsoft.Office.WebExtension.FilterType.All,value:0}]}]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.AsyncResultStatus,fromHost:[{name:Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded,value:0},{name:Microsoft.Office.WebExtension.AsyncResultStatus.Failed,value:1}]}),OSF.DDA.SafeArray.Delegate.executeAsync=function(e){function t(e){var n=e;if(null!=e&&e.toArray){var r=e.toArray();n=new Array(r.length);for(var i=0;i<r.length;i++)n[i]=t(r[i])}return n}try{e.onCalling&&e.onCalling(),OSF.ClientHostController.execute(e.dispId,function e(t){var n=t;if(OSF.OUtil.isArray(t))for(var r=n.length,i=0;i<r;i++)n[i]=e(n[i]);else if(OSF.OUtil.isDate(t))n=t.getVarDate();else if("object"===typeof t&&!OSF.OUtil.isArray(t))for(var o in n=[],t)OSF.OUtil.isFunction(t[o])||(n[o]=e(t[o]));return n}(e.hostCallArgs),(function(n,r){var i,o;if("number"===typeof n?(i=[],o=n):o=(i=n.toArray())[OSF.DDA.SafeArray.Response.Status],o==OSF.DDA.ErrorCodeManager.errorCodes.ooeChunkResult)return null!=(a=t(a=i[OSF.DDA.SafeArray.Response.Payload]))&&(e._chunkResultData||(e._chunkResultData=new Array),e._chunkResultData[a[0]]=a[1]),!1;if(e.onReceiving&&e.onReceiving(),e.onComplete){var a;if(o==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){if(i.length>2){a=[];for(var s=1;s<i.length;s++)a[s-1]=i[s]}else a=i[OSF.DDA.SafeArray.Response.Payload];if(e._chunkResultData&&null!=(a=t(a))){var c=a[a.length-1];e._chunkResultData.length==c?a[a.length-1]=e._chunkResultData:o=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError}}else a=i[OSF.DDA.SafeArray.Response.Payload];e.onComplete(o,a)}return!0}))}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent=function(e,t){var n=(new Date).getTime();return function(r){t.onReceiving&&t.onReceiving();var i=r.toArray?r.toArray()[OSF.DDA.SafeArray.Response.Status]:r;t.onComplete&&t.onComplete(i),OSF.AppTelemetry&&OSF.AppTelemetry.onRegisterDone(e,t.dispId,Math.abs((new Date).getTime()-n),i)}},OSF.DDA.SafeArray.Delegate.registerEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);try{OSF.ClientHostController.registerEvent(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.unregisterEventAsync=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.unregisterEvent(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.ClientMode={ReadWrite:0,ReadOnly:1},OSF.DDA.RichInitializationReason={1:Microsoft.Office.WebExtension.InitializationReason.Inserted,2:Microsoft.Office.WebExtension.InitializationReason.DocumentOpened},OSF.InitializationHelper=function(e,t,n,r,i){this._hostInfo=e,this._webAppState=t,this._context=n,this._settings=r,this._hostFacade=i,this._initializeSettings=this.initializeSettings},OSF.InitializationHelper.prototype.deserializeSettings=function(e,t){var n=OSF.OUtil.getSessionStorage();if(n){var r=n.getItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey());r?e=JSON.parse(r):(r=JSON.stringify(e),n.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r))}var i=OSF.DDA.SettingsManager.deserializeSettings(e);return t?new OSF.DDA.RefreshableSettings(i):new OSF.DDA.Settings(i)},OSF.InitializationHelper.prototype.saveAndSetDialogInfo=function(e){},OSF.InitializationHelper.prototype.setAgaveHostCommunication=function(){},OSF.InitializationHelper.prototype.prepareRightBeforeWebExtensionInitialize=function(e){this.prepareApiSurface(e),Microsoft.Office.WebExtension.initialize(this.getInitializationReason(e))},OSF.InitializationHelper.prototype.prepareApiSurface=function(e){var t,n,r=new OSF.DDA.License(e.get_eToken()),i=OSF.DDA.OfficeTheme&&OSF.DDA.OfficeTheme.getOfficeTheme?OSF.DDA.OfficeTheme.getOfficeTheme:null;if(e.get_isDialog()?OSF.DDA.UI.ChildUI&&(e.ui=new OSF.DDA.UI.ChildUI):OSF.DDA.UI.ParentUI&&(e.ui=new OSF.DDA.UI.ParentUI,OfficeExt.Container&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.CloseContainerAsync])),OSF.DDA.OpenBrowser&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.OpenBrowserWindow]),OSF.DDA.ExecuteFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.ExecuteFeature]),OSF.DDA.QueryFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.QueryFeature]),OSF.DDA.Auth){e.auth=new OSF.DDA.Auth;var o=[],a=OSF.DDA.AsyncMethodNames.GetAccessTokenAsync;a&&o.push(a);var s=OSF.DDA.AsyncMethodNames.GetNestedAppAuthContextAsync;s&&o.push(s),OSF.DDA.DispIdHost.addAsyncMethods(e.auth,o)}OSF._OfficeAppFactory.setContext(new OSF.DDA.Context(e,e.doc,r,null,i)),t=OSF.DDA.DispIdHost.getClientDelegateMethods,n=OSF.DDA.SafeArray.Delegate.ParameterMap,OSF._OfficeAppFactory.setHostFacade(new OSF.DDA.DispIdHost.Facade(t,n))},OSF.InitializationHelper.prototype.getInitializationReason=function(e){return OSF.DDA.RichInitializationReason[e.get_reason()]},OSF.DDA.DispIdHost.getClientDelegateMethods=function(e){var t={};if(t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.SafeArray.Delegate.executeAsync,t[OSF.DDA.DispIdHost.Delegates.RegisterEventAsync]=OSF.DDA.SafeArray.Delegate.registerEventAsync,t[OSF.DDA.DispIdHost.Delegates.UnregisterEventAsync]=OSF.DDA.SafeArray.Delegate.unregisterEventAsync,t[OSF.DDA.DispIdHost.Delegates.OpenDialog]=OSF.DDA.SafeArray.Delegate.openDialog,t[OSF.DDA.DispIdHost.Delegates.CloseDialog]=OSF.DDA.SafeArray.Delegate.closeDialog,t[OSF.DDA.DispIdHost.Delegates.MessageParent]=OSF.DDA.SafeArray.Delegate.messageParent,t[OSF.DDA.DispIdHost.Delegates.SendMessage]=OSF.DDA.SafeArray.Delegate.sendMessage,OSF.DDA.AsyncMethodNames.RefreshAsync&&e==OSF.DDA.AsyncMethodNames.RefreshAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return"function"===typeof OSF.DDA.ClientSettingsManager.refresh?OSF.DDA.ClientSettingsManager.refresh(t,n):OSF.DDA.ClientSettingsManager.read(t,n)}))}if(OSF.DDA.AsyncMethodNames.SaveAsync&&e==OSF.DDA.AsyncMethodNames.SaveAsync.id){t[OSF.DDA.DispIdHost.Delegates.ExecuteAsync]=OSF.DDA.ClientSettingsManager.getSettingsExecuteMethod((function(e,t,n){return OSF.DDA.ClientSettingsManager.write(e[OSF.DDA.SettingsManager.SerializedSettings],e[Microsoft.Office.WebExtension.Parameters.OverwriteIfStale],t,n)}))}return t},function(e){var t=function(){function e(){}return e.prototype.execute=function(e,t,n){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.Execute(e,t,n,OsfOMToken):window.external.Execute(e,t,n)},e.prototype.registerEvent=function(e,t,n,r){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.RegisterEvent(e,t,n,r,OsfOMToken):window.external.RegisterEvent(e,t,n,r)},e.prototype.unregisterEvent=function(e,t,n){"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.UnregisterEvent(e,t,n,OsfOMToken):window.external.UnregisterEvent(e,t,n)},e.prototype.closeSdxDialog=function(e){OSF.OUtil.externalNativeFunctionExists(typeof window.external.closeSdxDialog)&&window.external.closeSdxDialog(e)},e.prototype.resizeSdxDialog=function(e,t){OSF.OUtil.externalNativeFunctionExists(typeof window.external.resizeSdxDialog)&&window.external.resizeSdxDialog(e,t)},e}();e.RichClientHostController=t}(OfficeExt||(OfficeExt={})),function(e){var t=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.prototype.messageParent=function(e){if(OSF.OUtil.externalNativeFunctionExists(typeof window.external.MessageParent2)){if(e){var t=e[Microsoft.Office.WebExtension.Parameters.MessageToParent];"boolean"===typeof t&&(!0===t?e[Microsoft.Office.WebExtension.Parameters.MessageToParent]="true":!1===t&&(e[Microsoft.Office.WebExtension.Parameters.MessageToParent]=""))}"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.MessageParent2(JSON.stringify(e),OsfOMToken):window.external.MessageParent2(JSON.stringify(e))}else{var n=e[Microsoft.Office.WebExtension.Parameters.MessageToParent];window.external.MessageParent(n)}},t.prototype.openDialog=function(e,t,n,r){this.registerEvent(e,t,n,r)},t.prototype.closeDialog=function(e,t,n){this.unregisterEvent(e,t,n)},t.prototype.sendMessage=function(e){if(OSF.OUtil.externalNativeFunctionExists(typeof window.external.MessageChild2))"undefined"!=typeof OsfOMToken&&OsfOMToken?window.external.MessageChild2(JSON.stringify(e),OsfOMToken):window.external.MessageChild2(JSON.stringify(e));else{var t=e[Microsoft.Office.WebExtension.Parameters.MessageContent];window.external.MessageChild(t)}},t}(e.RichClientHostController);e.Win32RichClientHostController=t}(OfficeExt||(OfficeExt={})),function(e){!function(t){var n=function(){function e(){this._osfOfficeTheme=null,this._osfOfficeThemeTimeStamp=null}return e.prototype.getOfficeTheme=function(){if(OSF.DDA._OsfControlContext){if(this._osfOfficeTheme&&this._osfOfficeThemeTimeStamp&&(new Date).getTime()-this._osfOfficeThemeTimeStamp<e._osfOfficeThemeCacheValidPeriod)OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",0);else{var t=(new Date).getTime(),n=OSF.DDA._OsfControlContext.GetOfficeThemeInfo(),r=(new Date).getTime();if(OSF.AppTelemetry&&OSF.AppTelemetry.onPropertyDone("GetOfficeThemeInfo",Math.abs(r-t)),this._osfOfficeTheme=JSON.parse(n),OSF.DDA.Theming&&"function"===typeof OSF.DDA.Theming.ConvertToOfficeTheme)this._osfOfficeTheme=OSF.DDA.Theming.ConvertToOfficeTheme(this._osfOfficeTheme);else for(var i in this._osfOfficeTheme)this._osfOfficeTheme[i]=OSF.OUtil.convertIntToCssHexColor(this._osfOfficeTheme[i]);this._osfOfficeThemeTimeStamp=r}return this._osfOfficeTheme}},e.instance=function(){return null==e._instance&&(e._instance=new e),e._instance},e._osfOfficeThemeCacheValidPeriod=5e3,e._instance=null,e}();t.OfficeThemeManager=n,OSF.OUtil.setNamespace("OfficeTheme",OSF.DDA),OSF.DDA.OfficeTheme.getOfficeTheme=e.OfficeTheme.OfficeThemeManager.instance().getOfficeTheme}(e.OfficeTheme||(e.OfficeTheme={}))}(OfficeExt||(OfficeExt={})),OSF.initializeRichCommon=function(){OSF.DDA.ClientSettingsManager={getSettingsExecuteMethod:function(e){return function(t){var n;try{n=e(t.hostCallArgs,t.onCalling,(function(e,n){t.onReceiving&&t.onReceiving(),t.onComplete&&t.onComplete(e,n)}))}catch(e){var r=OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError;n={name:Strings.OfficeOM.L_InternalError,message:e},t.onComplete&&t.onComplete(r,n)}}},read:function(e,t){var n=[],r=[];e&&e(),"undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken).Read(n,r):OSF.DDA._OsfControlContext.GetSettings().Read(n,r);for(var i={},o=0;o<n.length;o++)i[n[o]]=r[o];return t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,i),i},write:function(e,t,n,r){var i,o=[],a=[];for(var s in e)o.push(s),a.push(e[s]);n&&n(),"undefined"!=typeof(i="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings()).WriteAsync?i.WriteAsync(o,a,r):(i.Write(o,a),r&&r(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess))},refresh:function(e,t){var n,r=[],i=[];e&&e(),n="undefined"!=typeof OsfOMToken&&OsfOMToken?OSF.DDA._OsfControlContext.GetSettings(OsfOMToken):OSF.DDA._OsfControlContext.GetSettings();var o=function(){n.Read(r,i);for(var e={},o=0;o<r.length;o++)e[r[o]]=i[o];t&&t(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,e)};n.RefreshAsync?n.RefreshAsync((function(){o()})):o()}},OSF.InitializationHelper.prototype.initializeSettings=function(e){var t=OSF.DDA.ClientSettingsManager.read();return this.deserializeSettings(t,e)},OSF.InitializationHelper.prototype.getAppContext=function(e,t){var n,r,i="Warning: Office.js is loaded outside of Office client";try{if(!window.external||!OSF.OUtil.externalNativeFunctionExists(typeof window.external.GetContext))return void OsfMsAjaxFactory.msAjaxDebug.trace(i);r=OSF.DDA._OsfControlContext=window.external.GetContext()}catch(e){return void OsfMsAjaxFactory.msAjaxDebug.trace(i)}var o,a,s,c,u,l,f,d,p,h,m=r.GetAppType(),g=r.GetSolutionRef(),y=r.GetAppVersionMajor(),O=r.GetAppVersionMinor(),v=r.GetAppUILocale(),b=r.GetAppDataLocale(),S=r.GetDocUrl(),_=r.GetAppCapabilities(),A=r.GetActivationMode(),D=r.GetControlIntegrationLevel();try{o=r.GetSolutionToken()}catch(e){}if(OSF.OUtil.externalNativeFunctionExists(typeof r.GetCorrelationId)&&(a=r.GetCorrelationId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetInstanceId)&&(s=r.GetInstanceId()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetTouchEnabled)&&(c=r.GetTouchEnabled()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetCommerceAllowed)&&(u=r.GetCommerceAllowed()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetSupportedMatrix)&&(l=r.GetSupportedMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostCustomMessage)&&(f=r.GetHostCustomMessage()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetHostFullVersion)&&(d=r.GetHostFullVersion()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetDialogRequirementMatrix)&&(p=r.GetDialogRequirementMatrix()),OSF.OUtil.externalNativeFunctionExists(typeof r.GetFeaturesForSolution))try{var C=r.GetFeaturesForSolution();C&&(h=JSON.parse(C))}catch(e){OsfMsAjaxFactory.msAjaxDebug.trace("Exception while creating the SDX FeatureGates object. Details: "+e)}var P=0;OSF.OUtil.externalNativeFunctionExists(typeof r.GetInitialDisplayMode)&&(P=r.GetInitialDisplayMode()),o=o?o.toString():"",n=new OSF.OfficeAppContext(g,m,y,v,b,S,_,[],A,D,o,a,s,c,u,O,l,f,d,void 0,void 0,void 0,void 0,p,h,void 0,P),OSF.AppTelemetry&&OSF.AppTelemetry.initialize(n),t(n)}},OSF.OUtil.setNamespace("ExtensionLifeCycle",OSF),OSF.ExtensionLifeCycle.close=function(e){OSF.ClientHostController.closeSdxDialog(e)},OSF.ExtensionLifeCycle.resize=function(e,t){OSF.ClientHostController.resizeSdxDialog(e,t)},OSF.OUtil.setNamespace("Messaging",OSF),OSF.Messaging.sendMessage=function(e){var t=JSON.stringify(e);OSF.ClientHostController.execute(OSF.DDA.MethodDispId.dispidSdxSendMessage,[t],null)},OSF.Messaging.registerOnMessageEventHandler=function(e){OSF.ClientHostController.registerEvent(OSF.DDA.EventDispId.dispidOnSdxSendMessageEvent,"",(function(t,n){var r=n.toArray();e(JSON.parse(r[0]))}),null)},OSF.ClientHostController=new OfficeExt.Win32RichClientHostController,OSF.initializeRichCommon(),function(e){var t=function(){function e(e){this._table=e,this._fields={}}return Object.defineProperty(e.prototype,"Fields",{get:function(){return this._fields},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"Table",{get:function(){return this._table},enumerable:!0,configurable:!0}),e.prototype.SerializeFields=function(){},e.prototype.SetSerializedField=function(e,t){"undefined"!==typeof t&&null!==t&&(this._serializedFields[e]=t.toString())},e.prototype.SerializeRow=function(){return this._serializedFields={},this.SetSerializedField("Table",this._table),this.SerializeFields(),JSON.stringify(this._serializedFields)},e}();e.BaseUsageData=t;var n=function(e){function t(){return e.call(this,"AppActivated")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppId",{get:function(){return this.Fields.AppId},set:function(e){this.Fields.AppId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppInstanceId",{get:function(){return this.Fields.AppInstanceId},set:function(e){this.Fields.AppInstanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppURL",{get:function(){return this.Fields.AppURL},set:function(e){this.Fields.AppURL=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AssetId",{get:function(){return this.Fields.AssetId},set:function(e){this.Fields.AssetId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Browser",{get:function(){return this.Fields.Browser},set:function(e){this.Fields.Browser=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"UserId",{get:function(){return this.Fields.UserId},set:function(e){this.Fields.UserId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Host",{get:function(){return this.Fields.Host},set:function(e){this.Fields.Host=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostVersion",{get:function(){return this.Fields.HostVersion},set:function(e){this.Fields.HostVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ClientId",{get:function(){return this.Fields.ClientId},set:function(e){this.Fields.ClientId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeWidth",{get:function(){return this.Fields.AppSizeWidth},set:function(e){this.Fields.AppSizeWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeHeight",{get:function(){return this.Fields.AppSizeHeight},set:function(e){this.Fields.AppSizeHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"DocUrl",{get:function(){return this.Fields.DocUrl},set:function(e){this.Fields.DocUrl=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OfficeJSVersion",{get:function(){return this.Fields.OfficeJSVersion},set:function(e){this.Fields.OfficeJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"HostJSVersion",{get:function(){return this.Fields.HostJSVersion},set:function(e){this.Fields.HostJSVersion=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"WacHostEnvironment",{get:function(){return this.Fields.WacHostEnvironment},set:function(e){this.Fields.WacHostEnvironment=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"IsFromWacAutomation",{get:function(){return this.Fields.IsFromWacAutomation},set:function(e){this.Fields.IsFromWacAutomation=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"IsMOS",{get:function(){return this.Fields.IsMOS},set:function(e){this.Fields.IsMOS=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("AppId",this.AppId),this.SetSerializedField("AppInstanceId",this.AppInstanceId),this.SetSerializedField("AppURL",this.AppURL),this.SetSerializedField("AssetId",this.AssetId),this.SetSerializedField("Browser",this.Browser),this.SetSerializedField("UserId",this.UserId),this.SetSerializedField("Host",this.Host),this.SetSerializedField("HostVersion",this.HostVersion),this.SetSerializedField("ClientId",this.ClientId),this.SetSerializedField("AppSizeWidth",this.AppSizeWidth),this.SetSerializedField("AppSizeHeight",this.AppSizeHeight),this.SetSerializedField("Message",this.Message),this.SetSerializedField("DocUrl",this.DocUrl),this.SetSerializedField("OfficeJSVersion",this.OfficeJSVersion),this.SetSerializedField("HostJSVersion",this.HostJSVersion),this.SetSerializedField("WacHostEnvironment",this.WacHostEnvironment),this.SetSerializedField("IsFromWacAutomation",this.IsFromWacAutomation),this.SetSerializedField("IsMOS",this.IsMOS)},t}(t);e.AppActivatedUsageData=n;var r=function(e){function t(){return e.call(this,"ScriptLoad")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ScriptId",{get:function(){return this.Fields.ScriptId},set:function(e){this.Fields.ScriptId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"StartTime",{get:function(){return this.Fields.StartTime},set:function(e){this.Fields.StartTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("ScriptId",this.ScriptId),this.SetSerializedField("StartTime",this.StartTime),this.SetSerializedField("ResponseTime",this.ResponseTime)},t}(t);e.ScriptLoadUsageData=r;var i=function(e){function t(){return e.call(this,"AppClosed")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"FocusTime",{get:function(){return this.Fields.FocusTime},set:function(e){this.Fields.FocusTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalWidth",{get:function(){return this.Fields.AppSizeFinalWidth},set:function(e){this.Fields.AppSizeFinalWidth=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"AppSizeFinalHeight",{get:function(){return this.Fields.AppSizeFinalHeight},set:function(e){this.Fields.AppSizeFinalHeight=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"OpenTime",{get:function(){return this.Fields.OpenTime},set:function(e){this.Fields.OpenTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"CloseMethod",{get:function(){return this.Fields.CloseMethod},set:function(e){this.Fields.CloseMethod=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("FocusTime",this.FocusTime),this.SetSerializedField("AppSizeFinalWidth",this.AppSizeFinalWidth),this.SetSerializedField("AppSizeFinalHeight",this.AppSizeFinalHeight),this.SetSerializedField("OpenTime",this.OpenTime),this.SetSerializedField("CloseMethod",this.CloseMethod)},t}(t);e.AppClosedUsageData=i;var o=function(e){function t(){return e.call(this,"APIUsage")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIType",{get:function(){return this.Fields.APIType},set:function(e){this.Fields.APIType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"APIID",{get:function(){return this.Fields.APIID},set:function(e){this.Fields.APIID=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Parameters",{get:function(){return this.Fields.Parameters},set:function(e){this.Fields.Parameters=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ResponseTime",{get:function(){return this.Fields.ResponseTime},set:function(e){this.Fields.ResponseTime=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ErrorType",{get:function(){return this.Fields.ErrorType},set:function(e){this.Fields.ErrorType=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("APIType",this.APIType),this.SetSerializedField("APIID",this.APIID),this.SetSerializedField("Parameters",this.Parameters),this.SetSerializedField("ResponseTime",this.ResponseTime),this.SetSerializedField("ErrorType",this.ErrorType)},t}(t);e.APIUsageUsageData=o;var a=function(e){function t(){return e.call(this,"AppInitialization")||this}return __extends(t,e),Object.defineProperty(t.prototype,"CorrelationId",{get:function(){return this.Fields.CorrelationId},set:function(e){this.Fields.CorrelationId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SessionId",{get:function(){return this.Fields.SessionId},set:function(e){this.Fields.SessionId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"SuccessCode",{get:function(){return this.Fields.SuccessCode},set:function(e){this.Fields.SuccessCode=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"Message",{get:function(){return this.Fields.Message},set:function(e){this.Fields.Message=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("CorrelationId",this.CorrelationId),this.SetSerializedField("SessionId",this.SessionId),this.SetSerializedField("SuccessCode",this.SuccessCode),this.SetSerializedField("Message",this.Message)},t}(t);e.AppInitializationUsageData=a;var s=function(e){function t(){return e.call(this,"CheckWACHost")||this}return __extends(t,e),Object.defineProperty(t.prototype,"isWacKnownHost",{get:function(){return this.Fields.isWacKnownHost},set:function(e){this.Fields.isWacKnownHost=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return this.Fields.instanceId},set:function(e){this.Fields.instanceId=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostType",{get:function(){return this.Fields.hostType},set:function(e){this.Fields.hostType=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hostPlatform",{get:function(){return this.Fields.hostPlatform},set:function(e){this.Fields.hostPlatform=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isLocalStorageAvailable",{get:function(){return this.Fields.isLocalStorageAvailable},set:function(e){this.Fields.isLocalStorageAvailable=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"knownHostIndex",{get:function(){return this.Fields.knownHostIndex},set:function(e){this.Fields.knownHostIndex=e},enumerable:!0,configurable:!0}),t.prototype.SerializeFields=function(){this.SetSerializedField("isWacKnownHost",this.isWacKnownHost),this.SetSerializedField("instanceId",this.instanceId),this.SetSerializedField("hostType",this.hostType),this.SetSerializedField("hostPlatform",this.hostPlatform),this.SetSerializedField("isLocalStorageAvailable",this.isLocalStorageAvailable),this.SetSerializedField("knownHostIndex",this.knownHostIndex)},t}(t);e.CheckWACHostUsageData=s}(OSFLog||(OSFLog={})),function(e){"use strict";!function(e){e[e.info=0]="info",e[e.warning=1]="warning",e[e.error=2]="error"}(e.TraceLevel||(e.TraceLevel={})),function(e){e[e.none=0]="none",e[e.flush=1]="flush"}(e.SendFlag||(e.SendFlag={})),e.allowUploadingData=function(){},e.sendLog=function(e,t,n){};var t=function(){function e(){}return e.prototype.writeLog=function(e){},e.prototype.loadProxyFrame=function(){},e}();OSF.Logger||(OSF.Logger=e),e.ulsEndpoint=function(){try{return new t}catch(e){return null}}()}(Logger||(Logger={})),function(e){var t=[{name:"AppActivated",enabled:!0,critical:!0,points:[{name:"Browser",type:"string"},{name:"Message",type:"string"},{name:"Host",type:"string"},{name:"AppSizeWidth",type:"int64"},{name:"AppSizeHeight",type:"int64"},{name:"IsFromWacAutomation",type:"string"},{name:"IsMOS",type:"int64"}]},{name:"ScriptLoad",enabled:!0,critical:!1,points:[{name:"ScriptId",type:"string"},{name:"StartTime",type:"double"},{name:"ResponseTime",type:"double"}]},{name:"APIUsage",enabled:function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}(),critical:!1,points:[{name:"APIType",type:"string"},{name:"APIID",type:"int64"},{name:"Parameters",type:"string"},{name:"ResponseTime",type:"int64"},{name:"ErrorType",type:"int64"}]},{name:"AppInitialization",enabled:!0,critical:!1,points:[{name:"SuccessCode",type:"int64"},{name:"Message",type:"string"}]},{name:"AppClosed",enabled:!0,critical:!1,points:[{name:"FocusTime",type:"int64"},{name:"AppSizeFinalWidth",type:"int64"},{name:"AppSizeFinalHeight",type:"int64"},{name:"OpenTime",type:"int64"}]},{name:"CheckWACHost",enabled:!0,critical:!1,points:[{name:"isWacKnownHost",type:"int64"},{name:"knownHostIndex",type:"int64"},{name:"solutionId",type:"string"},{name:"hostType",type:"string"},{name:"hostPlatform",type:"string"},{name:"correlationId",type:"string"},{name:"isLocalStorageAvailable",type:"boolean"}]}];function n(e,t){var n=void 0===t.rename?t.name:t.rename,r=void 0;switch(t.type){case"string":r=oteljs.makeStringDataField(n,e);break;case"double":"string"===typeof e&&(e=parseFloat(e)),r=oteljs.makeDoubleDataField(n,e);break;case"int64":"string"===typeof e&&(e=parseInt(e)),r=oteljs.makeInt64DataField(n,e);break;case"boolean":"string"===typeof e&&(e="true"===e),r=oteljs.makeBooleanDataField(n,e)}return r}function r(e){for(var n=0,r=t;n<r.length;n++){var i=r[n];if(i.name===e)return i}}function i(e,t){(function(e){var t=r(e);return void 0!==t&&t.enabled})(e)&&"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var i=function(e,t){var i=r(e);if(void 0!==i){for(var o=[],a=0,s=i.points;a<s.length;a++){var c=s[a],u=t[c.name];if(void 0!==u){var l=n(u,c);void 0!==l&&o.push(l)}}var f={dataCategories:oteljs.DataCategories.ProductServiceUsage};return i.critical&&(f.samplingPolicy=oteljs.SamplingPolicy.CriticalBusinessImpact),f.diagnosticLevel=oteljs.DiagnosticLevel.NecessaryServiceDataEvent,{eventName:"Office.Extensibility.OfficeJs."+e+"X",dataFields:o,eventFlags:f}}}(e,t);void 0!==i&&Microsoft.Office.WebExtension.sendTelemetryEvent(i)}))}var o=function(){function e(){}return e.prototype.getAriaCDNLocation=function(){return OSF._OfficeAppFactory.getLoadScriptHelper().getOfficeJsBasePath()+"ariatelemetry/aria-web-telemetry.js"},e.getInstance=function(){return void 0===e.AriaLoggerObj&&(e.AriaLoggerObj=new e),e.AriaLoggerObj},e.prototype.isIUsageData=function(e){return void 0!==e.Fields},e.prototype.shouldSendDirectToAria=function(e,t){var n;if(!e)return!1;if("win32"===e.toLowerCase())n=[16,0,11601];else{if("mac"!==e.toLowerCase())return!0;n=[16,28]}if(!t)return!1;for(var r=t.split("."),i=0;i<n.length&&i<r.length;i++){var o=parseInt(r[i],10);if(isNaN(o))return!1;if(o<n[i])return!0;if(o>n[i])return!1}return!1},e.prototype.isDirectToAriaEnabled=function(){if(void 0===this.EnableDirectToAria||null===this.EnableDirectToAria){var e=void 0,t=void 0;OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&(e=OSF._OfficeAppFactory.getHostInfo().hostPlatform),window.external&&"undefined"!==typeof window.external.GetContext&&"undefined"!==typeof window.external.GetContext().GetHostFullVersion&&(t=window.external.GetContext().GetHostFullVersion()),this.EnableDirectToAria=this.shouldSendDirectToAria(e,t)}return this.EnableDirectToAria},e.prototype.sendTelemetry=function(t,n){e.EnableSendingTelemetryWithLegacyAria&&this.isDirectToAriaEnabled()&&OSF.OUtil.loadScript(this.getAriaCDNLocation(),(function(){try{if(!this.ALogger){this.ALogger=AWTLogManager.initialize("db334b301e7b474db5e0f02f07c51a47-a1b5bc36-1bbe-482f-a64a-c2d9cb606706-7439")}var e=new AWTEventProperties;for(var r in e.setName("Office.Extensibility.OfficeJS."+t),n)"table"!==r.toLowerCase()&&e.setProperty(r,n[r]);var i=new Date;e.setProperty("Date",i.toISOString()),this.ALogger.logEvent(e)}catch(e){}}),1e3),e.EnableSendingTelemetryWithOTel&&i(t,n)},e.prototype.logData=function(e){this.isIUsageData(e)?this.sendTelemetry(e.Table,e.Fields):this.sendTelemetry(e.Table,e)},e.EnableSendingTelemetryWithOTel=!0,e.EnableSendingTelemetryWithLegacyAria=!1,e}();e.AriaLogger=o}(OSFAriaLogger||(OSFAriaLogger={})),function(e){"use strict";var t,n=OSF.OUtil.Guid.generateNewGuid(),r="",i=new RegExp("^https?://store\\.office(ppe|-int)?\\.com/","i");e.enableTelemetry=!0;var o=function(){return function(){}}();e.AppInfo=o;var a=function(){return function(e,t){this.name=e,this.handler=t}}(),s=function(){function e(){this.clientIDKey="Office API client",this.logIdSetKey="Office App Log Id Set"}return e.prototype.getClientId=function(){var e=this.getValue(this.clientIDKey);return(!e||e.length<=0||e.length>40)&&(e=OSF.OUtil.Guid.generateNewGuid(),this.setValue(this.clientIDKey,e)),e},e.prototype.saveLog=function(e,t){var n=this.getValue(this.logIdSetKey);n=(n&&n.length>0?n+";":"")+e,this.setValue(this.logIdSetKey,n),this.setValue(e,t)},e.prototype.enumerateLog=function(e,t){var n=this.getValue(this.logIdSetKey);if(n){var r=n.split(";");for(var i in r){var o=r[i],a=this.getValue(o);a&&(e&&e(o,a),t&&this.remove(o))}t&&this.remove(this.logIdSetKey)}},e.prototype.getValue=function(e){var t=OSF.OUtil.getLocalStorage(),n="";return t&&(n=t.getItem(e)),n},e.prototype.setValue=function(e,t){var n=OSF.OUtil.getLocalStorage();n&&n.setItem(e,t)},e.prototype.remove=function(e){var t=OSF.OUtil.getLocalStorage();if(t)try{t.removeItem(e)}catch(e){}},e}(),c=function(){function t(){}return t.prototype.LogData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(t)}catch(e){}},t.prototype.LogRawData=function(t){if(e.enableTelemetry)try{OSFAriaLogger.AriaLogger.getInstance().logData(JSON.parse(t))}catch(e){}},t}();function u(e){return e&&(e=e.replace(/[{}]/g,"").toLowerCase()),e||""}function l(e,t){var i=new OSFLog.AppInitializationUsageData;i.CorrelationId=u(r),i.SessionId=n,i.SuccessCode=e?1:0,i.Message=t,(new c).LogData(i)}function f(){var e=0!=(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.PublicAddin);return e||!!t&&p(OSF._OfficeAppFactory.getHostInfo().hostPlatform,t.hostVersion)}function d(e,t){return f()||t!==e?t:"PRIVATE"}function p(e,t){var n=!1,r=/^(\d+)\.(\d+)\.(\d+)\.(\d+)$/.exec(t);if(r){var i=parseInt(r[1]),o=parseInt(r[2]),a=parseInt(r[3]);"win32"==e?(i<16||16==i&&a<14225)&&(n=!0):"mac"==e&&(i<16||16==i&&(o<52||52==o&&a<808))&&(n=!0)}return n}function h(){return 0!=(OSF._OfficeAppFactory.getHostInfo().flags&OSF.HostInfoFlags.IsMos)}e.initialize=function(r){if(e.enableTelemetry&&!t){t=new o,r.get_hostFullVersion()?t.hostVersion=r.get_hostFullVersion():t.hostVersion=r.get_appVersion(),t.appId=f()?r.get_id():"PRIVATE",t.marketplaceType=r._marketplaceType,t.browser=window.navigator.userAgent,t.correlationId=u(r.get_correlationId()),t.clientId=(new s).getClientId(),t.appInstanceId=r.get_appInstanceId(),t.appInstanceId&&(t.appInstanceId=u(t.appInstanceId),t.appInstanceId=d(r.get_id(),t.appInstanceId)),t.message=r.get_hostCustomMessage(),t.officeJSVersion=OSF.ConstantNames.FileVersion,t.hostJSVersion="16.0.17106.15020",r._wacHostEnvironment&&(t.wacHostEnvironment=r._wacHostEnvironment),void 0!==r._isFromWacAutomation&&null!==r._isFromWacAutomation&&(t.isFromWacAutomation=r._isFromWacAutomation.toString().toLowerCase());var c=r.get_docUrl();t.docUrl=i.test(c)?c:"";var l=location.href;l&&(l=l.split("?")[0].split("#")[0]),t.isMos=h(),t.appURL="",function(e,t){var n,r;t.assetId="",t.userId="";try{n=decodeURIComponent(e);var i=(r=(new DOMParser).parseFromString(n,"text/xml")).getElementsByTagName("t")[0].attributes.getNamedItem("cid"),o=r.getElementsByTagName("t")[0].attributes.getNamedItem("oid");i&&i.nodeValue?t.userId=i.nodeValue:o&&o.nodeValue&&(t.userId=o.nodeValue),t.assetId=r.getElementsByTagName("t")[0].attributes.getNamedItem("aid").nodeValue}catch(e){}finally{n=null,r=null,null}}(r.get_eToken(),t),t.sessionId=n,"undefined"!==typeof OTel&&OTel.OTelLogger.initialize(t),function(){var t=new Date,n=null,r=0,i=!1,o=function(){document.hasFocus()?null==n&&(n=new Date):n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null)},s=[];s.push(new a("focus",o)),s.push(new a("blur",o)),s.push(new a("focusout",o)),s.push(new a("focusin",o));var c=function(){for(var o=0;o<s.length;o++)OSF.OUtil.removeEventListener(window,s[o].name,s[o].handler);s.length=0,i||(document.hasFocus()&&n&&(r+=Math.abs((new Date).getTime()-n.getTime()),n=null),e.onAppClosed(Math.abs((new Date).getTime()-t.getTime()),r),i=!0)};s.push(new a("beforeunload",c)),s.push(new a("unload",c));for(var u=0;u<s.length;u++)OSF.OUtil.addEventListener(window,s[u].name,s[u].handler);o()}(),e.onAppActivated()}},e.onAppActivated=function(){if(t){(new s).enumerateLog((function(e,t){return(new c).LogRawData(t)}),!0);var e=new OSFLog.AppActivatedUsageData;e.SessionId=n,e.AppId=t.appId,e.AssetId=t.assetId,e.AppURL="",e.UserId="",e.ClientId=t.clientId,e.Browser=t.browser,e.HostVersion=t.hostVersion,e.CorrelationId=u(t.correlationId),e.AppSizeWidth=window.innerWidth,e.AppSizeHeight=window.innerHeight,e.AppInstanceId=t.appInstanceId,e.Message=t.message,e.DocUrl=t.docUrl,e.OfficeJSVersion=t.officeJSVersion,e.HostJSVersion=t.hostJSVersion,t.wacHostEnvironment&&(e.WacHostEnvironment=t.wacHostEnvironment),void 0!==t.isFromWacAutomation&&null!==t.isFromWacAutomation&&(e.IsFromWacAutomation=t.isFromWacAutomation),e.IsMOS=t.isMos?1:0,(new c).LogData(e)}},e.onScriptDone=function(e,t,r,i){var o=new OSFLog.ScriptLoadUsageData;o.CorrelationId=u(i),o.SessionId=n,o.ScriptId=e,o.StartTime=t,o.ResponseTime=r,(new c).LogData(o)},e.onCallDone=function(e,i,o,a,s){if(t&&function(){if(!OSF._OfficeAppFactory||!OSF._OfficeAppFactory.getHostInfo)return!1;var e=OSF._OfficeAppFactory.getHostInfo();if(!e)return!1;switch(e.hostType){case"outlook":switch(e.hostPlatform){case"mac":case"web":return!0;default:return!1}default:return!1}}()&&function(e,t){if("method"===t)switch(e){case 4:case 38:case 37:case 10:case 12:case-10:return!0;default:return!1}return!1}(i,e)){var l=new OSFLog.APIUsageUsageData;l.CorrelationId=u(r),l.SessionId=n,l.APIType=e,l.APIID=i,l.Parameters=o,l.ResponseTime=a,l.ErrorType=s,(new c).LogData(l)}},e.onMethodDone=function(e,t,n,r){var i=null;if(t)if("number"==typeof t)i=String(t);else if("object"===typeof t)for(var o in t)null!==i?i+=",":i="","number"==typeof t[o]&&(i+=String(t[o]));else i="";OSF.AppTelemetry.onCallDone("method",e,i,n,r)},e.onPropertyDone=function(e,t){OSF.AppTelemetry.onCallDone("property",-1,e,t)},e.onCheckWACHost=function(e,t,n,r,i,o){var a=new OSFLog.CheckWACHostUsageData;a.isWacKnownHost=e,a.knownHostIndex=t,a.instanceId=n,a.hostType=r,a.hostPlatform=i,a.isLocalStorageAvailable=o,(new c).LogData(a)},e.onEventDone=function(e,t){OSF.AppTelemetry.onCallDone("event",e,null,0,t)},e.onRegisterDone=function(e,t,n,r){OSF.AppTelemetry.onCallDone(e?"registerevent":"unregisterevent",t,null,n,r)},e.onAppClosed=function(e,i){if(t){var o=new OSFLog.AppClosedUsageData;o.CorrelationId=u(r),o.SessionId=n,o.FocusTime=i,o.OpenTime=e,o.AppSizeFinalWidth=window.innerWidth,o.AppSizeFinalHeight=window.innerHeight,(new s).saveLog(n,o.SerializeRow())}},e.setOsfControlAppCorrelationId=function(e){r=u(e)},e.doAppInitializationLogging=l,e.logAppCommonMessage=function(e){l(!1,e)},e.logAppException=function(e){l(!0,e)},e.canSendAddinId=f,e.getCompliantAppInstanceId=d,e._isComplianceExceptedHost=p,e.isMos=h,OSF.AppTelemetry=e}(OSFAppTelemetry||(OSFAppTelemetry={})),Microsoft.Office.WebExtension.BindingType={Table:"table",Text:"text",Matrix:"matrix"},OSF.DDA.BindingProperties={Id:"BindingId",Type:Microsoft.Office.WebExtension.Parameters.BindingType},OSF.OUtil.augmentList(OSF.DDA.ListDescriptors,{BindingList:"BindingList"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{Subset:"subset",BindingProperties:"BindingProperties"}),OSF.DDA.ListType.setListType(OSF.DDA.ListDescriptors.BindingList,OSF.DDA.PropertyDescriptors.BindingProperties),OSF.DDA.BindingPromise=function(e,t){this._id=e,OSF.OUtil.defineEnumerableProperty(this,"onFail",{get:function(){return t},set:function(e){var n=typeof e;if("undefined"!=n&&"function"!=n)throw OSF.OUtil.formatString(Strings.OfficeOM.L_CallbackNotAFunction,n);t=e}})},OSF.DDA.BindingPromise.prototype={_fetch:function(e){if(this.binding)e&&e(this.binding);else if(!this._binding){var t=this;Microsoft.Office.WebExtension.context.document.bindings.getByIdAsync(this._id,(function(n){n.status==Microsoft.Office.WebExtension.AsyncResultStatus.Succeeded?(OSF.OUtil.defineEnumerableProperty(t,"binding",{value:n.value}),e&&e(t.binding)):t.onFail&&t.onFail(n)}))}return this},getDataAsync:function(){var e=arguments;return this._fetch((function(t){t.getDataAsync.apply(t,e)})),this},setDataAsync:function(){var e=arguments;return this._fetch((function(t){t.setDataAsync.apply(t,e)})),this},addHandlerAsync:function(){var e=arguments;return this._fetch((function(t){t.addHandlerAsync.apply(t,e)})),this},removeHandlerAsync:function(){var e=arguments;return this._fetch((function(t){t.removeHandlerAsync.apply(t,e)})),this}},OSF.DDA.BindingFacade=function(e){this._eventDispatches=[],OSF.OUtil.defineEnumerableProperty(this,"document",{value:e});var t=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[t.AddFromSelectionAsync,t.AddFromNamedItemAsync,t.GetAllAsync,t.GetByIdAsync,t.ReleaseByIdAsync])},OSF.DDA.UnknownBinding=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{document:{value:t},id:{value:e}})},OSF.DDA.Binding=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{document:{value:t},id:{value:e}});var n=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[n.GetDataAsync,n.SetDataAsync]);var r=Microsoft.Office.WebExtension.EventType,i=t.bindings._eventDispatches;i[e]||(i[e]=new OSF.EventDispatch([r.BindingSelectionChanged,r.BindingDataChanged]));var o=i[e];OSF.DDA.DispIdHost.addEventSupport(this,o)},OSF.DDA.generateBindingId=function(){return"UnnamedBinding_"+OSF.OUtil.getUniqueId()+"_"+(new Date).getTime()},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureBinding=function(e,t){var n,r=e[OSF.DDA.BindingProperties.Id],i=e[OSF.DDA.BindingProperties.RowCount],o=e[OSF.DDA.BindingProperties.ColumnCount],a=e[OSF.DDA.BindingProperties.HasHeaders];switch(e[OSF.DDA.BindingProperties.Type]){case Microsoft.Office.WebExtension.BindingType.Text:n=new OSF.DDA.TextBinding(r,t);break;case Microsoft.Office.WebExtension.BindingType.Matrix:n=new OSF.DDA.MatrixBinding(r,t,i,o);break;case Microsoft.Office.WebExtension.BindingType.Table:n=new(function(){return OSF.DDA.ExcelDocument&&Microsoft.Office.WebExtension.context.document&&Microsoft.Office.WebExtension.context.document instanceof OSF.DDA.ExcelDocument}()&&OSF.DDA.ExcelTableBinding?OSF.DDA.ExcelTableBinding:OSF.DDA.TableBinding)(r,t,i,o,a);break;default:n=new OSF.DDA.UnknownBinding(r,t)}return n},OSF.DDA.AsyncMethodNames.addNames({AddFromSelectionAsync:"addFromSelectionAsync",AddFromNamedItemAsync:"addFromNamedItemAsync",GetAllAsync:"getAllAsync",GetByIdAsync:"getByIdAsync",ReleaseByIdAsync:"releaseByIdAsync",GetDataAsync:"getDataAsync",SetDataAsync:"setDataAsync"}),function(){function e(e){return OSF.DDA.OMFactory.manufactureBinding(e,Microsoft.Office.WebExtension.context.document)}function t(e){return e.id}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromSelectionAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.BindingType,enum:Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddFromNamedItemAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.ItemName,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.BindingType,enum:Microsoft.Office.WebExtension.BindingType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:{types:["string"],calculate:OSF.DDA.generateBindingId}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}}],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.FailOnCollision,value:function(){return!0}}],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAllAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(t){return OSF.OUtil.mapList(t[OSF.DDA.ListDescriptors.BindingList],e)}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:e}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]}],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=n[Microsoft.Office.WebExtension.Parameters.Id];delete t._eventDispatches[r]}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDataAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e,t){return OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)}}},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{enum:Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{enum:Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.RowCount,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.ColumnCount,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(e,t,n){if(0==e[Microsoft.Office.WebExtension.Parameters.StartRow]&&0==e[Microsoft.Office.WebExtension.Parameters.StartColumn]&&0==e[Microsoft.Office.WebExtension.Parameters.RowCount]&&0==e[Microsoft.Office.WebExtension.Parameters.ColumnCount]&&(delete e[Microsoft.Office.WebExtension.Parameters.StartRow],delete e[Microsoft.Office.WebExtension.Parameters.StartColumn],delete e[Microsoft.Office.WebExtension.Parameters.RowCount],delete e[Microsoft.Office.WebExtension.Parameters.ColumnCount]),e[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)&&(e[Microsoft.Office.WebExtension.Parameters.StartRow]||e[Microsoft.Office.WebExtension.Parameters.StartColumn]||e[Microsoft.Office.WebExtension.Parameters.RowCount]||e[Microsoft.Office.WebExtension.Parameters.ColumnCount]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return e},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:t}],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return OSF.DDA.TableDataProperties&&r&&(void 0!=r[OSF.DDA.TableDataProperties.TableRows]||void 0!=r[OSF.DDA.TableDataProperties.TableHeaders])&&(r=OSF.DDA.OMFactory.manufactureTableData(r)),void 0==(r=OSF.DDA.DataCoercion.coerceData(r,n[Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.Rows,value:{types:["object","string"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.Columns,value:{types:["object"],defaultValue:null}},{name:Microsoft.Office.WebExtension.Parameters.StartRow,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.StartColumn,value:{types:["number"],defaultValue:0}}],checkCallArgs:function(e,t,n){if(0==e[Microsoft.Office.WebExtension.Parameters.StartRow]&&0==e[Microsoft.Office.WebExtension.Parameters.StartColumn]&&(delete e[Microsoft.Office.WebExtension.Parameters.StartRow],delete e[Microsoft.Office.WebExtension.Parameters.StartColumn]),e[Microsoft.Office.WebExtension.Parameters.CoercionType]!=OSF.DDA.DataCoercion.getCoercionDefaultForBinding(t.type)&&(e[Microsoft.Office.WebExtension.Parameters.StartRow]||e[Microsoft.Office.WebExtension.Parameters.StartColumn]))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeCoercionTypeNotMatchBinding;return e},privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:t}]})}(),Microsoft.Office.WebExtension.TableData=function(e,t){function n(e){if(null==e||void 0==e)return null;try{for(var t=OSF.DDA.DataCoercion.findArrayDimensionality(e,2);t<2;t++)e=[e];return e}catch(e){}}OSF.OUtil.defineEnumerableProperties(this,{headers:{get:function(){return t},set:function(e){t=n(e)}},rows:{get:function(){return e},set:function(t){e=null==t||OSF.OUtil.isArray(t)&&0==t.length?[]:n(t)}}}),this.headers=t,this.rows=e},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureTableData=function(e){return new Microsoft.Office.WebExtension.TableData(e[OSF.DDA.TableDataProperties.TableRows],e[OSF.DDA.TableDataProperties.TableHeaders])},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{TableDataProperties:"TableDataProperties"}),OSF.OUtil.augmentList(OSF.DDA.BindingProperties,{RowCount:"BindingRowCount",ColumnCount:"BindingColumnCount",HasHeaders:"HasHeaders"}),OSF.DDA.TableDataProperties={TableRows:"TableRows",TableHeaders:"TableHeaders"},OSF.DDA.TableBinding=function(e,t,n,r,i){OSF.DDA.TableBinding.uber.constructor.call(this,e,t),OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.BindingType.Table},rowCount:{value:n||0},columnCount:{value:r||0},hasHeaders:{value:i||!1}});var o=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[o.AddRowsAsync,o.AddColumnsAsync,o.DeleteAllDataValuesAsync])},OSF.OUtil.extend(OSF.DDA.TableBinding,OSF.DDA.Binding),OSF.DDA.AsyncMethodNames.addNames({AddRowsAsync:"addRowsAsync",AddColumnsAsync:"addColumnsAsync",DeleteAllDataValuesAsync:"deleteAllDataValuesAsync"}),function(){function e(e){return e.id}OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddRowsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddColumnsAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.DeleteAllDataValuesAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:e}]})}(),Microsoft.Office.WebExtension.CoercionType={Text:"text",Matrix:"matrix",Table:"table"},OSF.DDA.DataCoercion=function(){return{findArrayDimensionality:function(e){if(OSF.OUtil.isArray(e)){for(var t=0,n=0;n<e.length;n++)t=Math.max(t,OSF.DDA.DataCoercion.findArrayDimensionality(e[n]));return t+1}return 0},getCoercionDefaultForBinding:function(e){switch(e){case Microsoft.Office.WebExtension.BindingType.Matrix:return Microsoft.Office.WebExtension.CoercionType.Matrix;case Microsoft.Office.WebExtension.BindingType.Table:return Microsoft.Office.WebExtension.CoercionType.Table;case Microsoft.Office.WebExtension.BindingType.Text:default:return Microsoft.Office.WebExtension.CoercionType.Text}},getBindingDefaultForCoercion:function(e){switch(e){case Microsoft.Office.WebExtension.CoercionType.Matrix:return Microsoft.Office.WebExtension.BindingType.Matrix;case Microsoft.Office.WebExtension.CoercionType.Table:return Microsoft.Office.WebExtension.BindingType.Table;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:return Microsoft.Office.WebExtension.BindingType.Text}},determineCoercionType:function(e){if(null==e||void 0==e)return null;var t=null,n=typeof e;if(void 0!==e.rows)t=Microsoft.Office.WebExtension.CoercionType.Table;else if(OSF.OUtil.isArray(e))t=Microsoft.Office.WebExtension.CoercionType.Matrix;else{if("string"!=n&&"number"!=n&&"boolean"!=n&&!OSF.OUtil.isDate(e))throw OSF.DDA.ErrorCodeManager.errorCodes.ooeUnsupportedDataObject;t=Microsoft.Office.WebExtension.CoercionType.Text}return t},coerceData:function(e,t,n){return(n=n||OSF.DDA.DataCoercion.determineCoercionType(e))&&n!=t&&(OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionBegin),e=OSF.DDA.DataCoercion._coerceDataFromTable(t,OSF.DDA.DataCoercion._coerceDataToTable(e,n)),OSF.OUtil.writeProfilerMark(OSF.InternalPerfMarker.DataCoercionEnd)),e},_matrixToText:function(e){if(1==e.length&&1==e[0].length)return""+e[0][0];for(var t="",n=0;n<e.length;n++)t+=e[n].join("\t")+"\n";return t.substring(0,t.length-1)},_textToMatrix:function(e){for(var t=e.split("\n"),n=0;n<t.length;n++)t[n]=t[n].split("\t");return t},_tableToText:function(e){var t="";null!=e.headers&&(t=OSF.DDA.DataCoercion._matrixToText([e.headers])+"\n");var n=OSF.DDA.DataCoercion._matrixToText(e.rows);return""==n&&(t=t.substring(0,t.length-1)),t+n},_tableToMatrix:function(e){var t=e.rows;return null!=e.headers&&t.unshift(e.headers),t},_coerceDataFromTable:function(e,t){var n;switch(e){case Microsoft.Office.WebExtension.CoercionType.Table:n=t;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=OSF.DDA.DataCoercion._tableToMatrix(t);break;case Microsoft.Office.WebExtension.CoercionType.SlideRange:n=null,OSF.DDA.OMFactory.manufactureSlideRange&&(n=OSF.DDA.OMFactory.manufactureSlideRange(OSF.DDA.DataCoercion._tableToText(t))),null==n&&(n=OSF.DDA.DataCoercion._tableToText(t));break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=OSF.DDA.DataCoercion._tableToText(t)}return n},_coerceDataToTable:function(e,t){var n;switch(void 0==t&&(t=OSF.DDA.DataCoercion.determineCoercionType(e)),t){case Microsoft.Office.WebExtension.CoercionType.Table:n=e;break;case Microsoft.Office.WebExtension.CoercionType.Matrix:n=new Microsoft.Office.WebExtension.TableData(e);break;case Microsoft.Office.WebExtension.CoercionType.Text:case Microsoft.Office.WebExtension.CoercionType.Html:case Microsoft.Office.WebExtension.CoercionType.Ooxml:default:n=new Microsoft.Office.WebExtension.TableData(OSF.DDA.DataCoercion._textToMatrix(e))}return n}}}(),OSF.DDA.FilePropertiesDescriptor={Url:"Url"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FilePropertiesDescriptor:"FilePropertiesDescriptor"}),Microsoft.Office.WebExtension.FileProperties=function(e){OSF.OUtil.defineEnumerableProperties(this,{url:{value:e[OSF.DDA.FilePropertiesDescriptor.Url]}})},OSF.DDA.AsyncMethodNames.addNames({GetFilePropertiesAsync:"getFilePropertiesAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:0}],requiredArguments:[],supportedOptions:[],onSucceeded:function(e,t,n){return new Microsoft.Office.WebExtension.FileProperties(e)}}),Microsoft.Office.WebExtension.GoToType={Binding:"binding",NamedItem:"namedItem",Slide:"slide",Index:"index"},Microsoft.Office.WebExtension.SelectionMode={Default:"default",Selected:"selected",None:"none"},Microsoft.Office.WebExtension.Index={First:"first",Last:"last",Next:"next",Previous:"previous"},OSF.DDA.AsyncMethodNames.addNames({GoToByIdAsync:"goToByIdAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GoToByIdAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string","number"]},{name:Microsoft.Office.WebExtension.Parameters.GoToType,enum:Microsoft.Office.WebExtension.GoToType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:{enum:Microsoft.Office.WebExtension.SelectionMode,defaultValue:Microsoft.Office.WebExtension.SelectionMode.Default}}]}),Microsoft.Office.WebExtension.EventType={},OSF.EventDispatch=function(e){if(this._eventHandlers={},this._objectEventHandlers={},this._queuedEventsArgs={},null!=e)for(var t=0;t<e.length;t++){var n=e[t];"objectDeleted"==n||"objectSelectionChanged"==n||"objectDataChanged"==n||"contentControlAdded"==n?this._objectEventHandlers[n]={}:this._eventHandlers[n]=[],this._queuedEventsArgs[n]=[]}},OSF.EventDispatch.prototype={getSupportedEvents:function(){var e=[];for(var t in this._eventHandlers)e.push(t);for(var t in this._objectEventHandlers)e.push(t);return e},supportsEvent:function(e){for(var t in this._eventHandlers)if(e==t)return!0;for(var t in this._objectEventHandlers)if(e==t)return!0;return!1},hasEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return!0;return!1},hasObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var i=r[t],o=0;null!=i&&o<i.length;o++)if(i[o]===n)return!0;return!1},addEventHandler:function(e,t){if("function"!=typeof t)return!1;var n=this._eventHandlers[e];return!(!n||this.hasEventHandler(e,t))&&(n.push(t),!0)},addObjectEventHandler:function(e,t,n){if("function"!=typeof n)return!1;var r=this._objectEventHandlers[e];return!(!r||this.hasObjectEventHandler(e,t,n))&&(null==r[t]&&(r[t]=[]),r[t].push(n),!0)},addEventHandlerAndFireQueuedEvent:function(e,t){var n=0==this._eventHandlers[e].length,r=this.addEventHandler(e,t);return n&&r&&this.fireQueuedEvent(e),r},removeEventHandler:function(e,t){var n=this._eventHandlers[e];if(n&&n.length>0)for(var r=0;r<n.length;r++)if(n[r]===t)return n.splice(r,1),!0;return!1},removeObjectEventHandler:function(e,t,n){var r=this._objectEventHandlers[e];if(null!=r)for(var i=r[t],o=0;null!=i&&o<i.length;o++)if(i[o]===n)return i.splice(o,1),!0;return!1},clearEventHandlers:function(e){return"undefined"!=typeof this._eventHandlers[e]&&this._eventHandlers[e].length>0&&(this._eventHandlers[e]=[],!0)},clearObjectEventHandlers:function(e,t){return null!=this._objectEventHandlers[e]&&null!=this._objectEventHandlers[e][t]&&(this._objectEventHandlers[e][t]=[],!0)},getEventHandlerCount:function(e){return void 0!=this._eventHandlers[e]?this._eventHandlers[e].length:-1},getObjectEventHandlerCount:function(e,t){return null==this._objectEventHandlers[e]||null==this._objectEventHandlers[e][t]?0:this._objectEventHandlers[e][t].length},fireEvent:function(e){if(void 0==e.type)return!1;var t=e.type;if(t&&this._eventHandlers[t]){for(var n=this._eventHandlers[t],r=0;r<n.length;r++)n[r](e);return!0}return!1},fireObjectEvent:function(e,t){if(void 0==t.type)return!1;var n=t.type;if(n&&this._objectEventHandlers[n]){var r=this._objectEventHandlers[n][e];if(null!=r){for(var i=0;i<r.length;i++)r[i](t);return!0}}return!1},fireOrQueueEvent:function(e){var t=e.type;if(t&&this._eventHandlers[t]){var n=this._eventHandlers[t],r=this._queuedEventsArgs[t];return 0==n.length?r.push(e):this.fireEvent(e),!0}return!1},fireQueuedEvent:function(e){if(e&&this._eventHandlers[e]){var t=this._eventHandlers[e],n=this._queuedEventsArgs[e];if(t.length>0){for(var r=t[0];n.length>0;){r(n.shift())}return!0}}return!1},clearQueuedEvent:function(e){e&&this._eventHandlers[e]&&(this._queuedEventsArgs[e]&&(this._queuedEventsArgs[e]=[]))}},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureEventArgs=function(e,t,n){var r;switch(e){case Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged:r=new OSF.DDA.DocumentSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.BindingSelectionChanged:r=new OSF.DDA.BindingSelectionChangedEventArgs(this.manufactureBinding(n,t.document),n[OSF.DDA.PropertyDescriptors.Subset]);break;case Microsoft.Office.WebExtension.EventType.BindingDataChanged:r=new OSF.DDA.BindingDataChangedEventArgs(this.manufactureBinding(n,t.document));break;case Microsoft.Office.WebExtension.EventType.SettingsChanged:r=new OSF.DDA.SettingsChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ActiveViewChanged:r=new OSF.DDA.ActiveViewChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.OfficeThemeChanged:r=new OSF.DDA.Theming.OfficeThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DocumentThemeChanged:r=new OSF.DDA.Theming.DocumentThemeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.Suspend:r=new OSF.DDA.SuspendEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.Resume:r=new OSF.DDA.ResumeEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppCommandInvoked:r=OSF.DDA.AppCommand.AppCommandInvokedEventArgs.create(n),"outlook"==OSF._OfficeAppFactory.getHostInfo().hostType&&"mac"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&OSF.DDA.convertOlkAppointmentTimeToDateFormat(r);break;case Microsoft.Office.WebExtension.EventType.ObjectDeleted:case Microsoft.Office.WebExtension.EventType.ObjectSelectionChanged:case Microsoft.Office.WebExtension.EventType.ObjectDataChanged:case Microsoft.Office.WebExtension.EventType.ContentControlAdded:r=new OSF.DDA.ObjectEventArgs(e,n[Microsoft.Office.WebExtension.Parameters.Id]);break;case Microsoft.Office.WebExtension.EventType.RichApiMessage:r=new OSF.DDA.RichApiMessageEventArgs(e,n);break;case Microsoft.Office.WebExtension.EventType.DataNodeInserted:r=new OSF.DDA.NodeInsertedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeReplaced:r=new OSF.DDA.NodeReplacedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NewNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.DataNodeDeleted:r=new OSF.DDA.NodeDeletedEventArgs(this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.OldNode]),this.manufactureDataNode(n[OSF.DDA.DataNodeEventProperties.NextSiblingNode]),n[OSF.DDA.DataNodeEventProperties.InUndoRedo]);break;case Microsoft.Office.WebExtension.EventType.TaskSelectionChanged:r=new OSF.DDA.TaskSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ResourceSelectionChanged:r=new OSF.DDA.ResourceSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.ViewSelectionChanged:r=new OSF.DDA.ViewSelectionChangedEventArgs(t);break;case Microsoft.Office.WebExtension.EventType.DialogMessageReceived:r=new OSF.DDA.DialogEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived:r=new OSF.DDA.DialogParentEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.ItemChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkItemSelectedChangedEventArgs(n),t.initialize(r.initialData),"win32"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform&&"mac"!=OSF._OfficeAppFactory.getHostInfo().hostPlatform||t.setCurrentItemNumber(r.itemNumber.itemNumber);break;case Microsoft.Office.WebExtension.EventType.RecipientsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecipientsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AppointmentTimeChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAppointmentTimeChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.RecurrenceChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkRecurrenceChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.AttachmentsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkAttachmentsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.EnhancedLocationsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkEnhancedLocationsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.InfobarClicked:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkInfobarClickedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.SelectedItemsChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkSelectedItemsChangedEventArgs(n);break;case Microsoft.Office.WebExtension.EventType.SensitivityLabelChanged:if("outlook"!=OSF._OfficeAppFactory.getHostInfo().hostType)throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e));r=new OSF.DDA.OlkSensitivityLabelChangedEventArgs(n);break;default:throw OsfMsAjaxFactory.msAjaxError.argument(Microsoft.Office.WebExtension.Parameters.EventType,OSF.OUtil.formatString(Strings.OfficeOM.L_NotSupportedEventType,e))}return r},OSF.DDA.AsyncMethodNames.addNames({AddHandlerAsync:"addHandlerAsync",RemoveHandlerAsync:"removeHandlerAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AddHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RemoveHandlerAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Handler,value:{types:["function","object"],defaultValue:null}}],privateStateCallbacks:[]}),OSF.DialogShownStatus={hasDialogShown:!1,isWindowDialog:!1},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogMessageReceivedEvent:"DialogMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogMessageReceived:"dialogMessageReceived",DialogEventReceived:"dialogEventReceived"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{MessageType:"messageType",MessageContent:"messageContent",MessageOrigin:"messageOrigin"}),OSF.DDA.DialogEventType={},OSF.OUtil.augmentList(OSF.DDA.DialogEventType,{DialogClosed:"dialogClosed",NavigationFailed:"naviationFailed"}),OSF.DDA.AsyncMethodNames.addNames({DisplayDialogAsync:"displayDialogAsync",DisplayModalDialogAsync:"displayModalDialogAsync",CloseAsync:"close"}),OSF.DDA.SyncMethodNames.addNames({MessageParent:"messageParent",MessageChild:"messageChild",SendMessage:"sendMessage",AddMessageHandler:"addEventHandler"}),OSF.DDA.UI.ParentUI=function(){var e;e=null!=Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived?new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived,Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived]):new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogMessageReceived,Microsoft.Office.WebExtension.EventType.DialogEventReceived]);var t=this,n=function(n,r){t[n]||OSF.OUtil.defineEnumerableProperty(t,n,{value:function(){var n=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.OpenDialog];n(arguments,e,t,r)}})};n(OSF.DDA.AsyncMethodNames.DisplayDialogAsync.displayName,!1),Microsoft.Office.WebExtension.FeatureGates.ModalWebDialogAPI&&n(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync.displayName,!0),OSF.OUtil.finalizeProperties(this)},OSF.DDA.UI.ChildUI=function(e){var t=OSF.DDA.SyncMethodNames.MessageParent.displayName,n=this;n[t]||OSF.OUtil.defineEnumerableProperty(n,t,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.MessageParent];return e(arguments,n)}});var r=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;n[r]||"undefined"==typeof OSF.DialogParentMessageEventDispatch||OSF.DDA.DispIdHost.addEventSupport(n,OSF.DialogParentMessageEventDispatch,e),OSF.OUtil.finalizeProperties(this)},OSF.DialogHandler=function(){},OSF.DDA.DialogEventArgs=function(e){e[OSF.DDA.PropertyDescriptors.MessageType]==OSF.DialogMessageType.DialogMessageReceived?OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}}):OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogEventReceived},error:{value:e[OSF.DDA.PropertyDescriptors.MessageType]}})},OSF.DDA.DialogParentEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived},message:{value:e[OSF.DDA.PropertyDescriptors.MessageContent]},origin:{value:e[OSF.DDA.PropertyDescriptors.MessageOrigin]}})};var DialogApiManager=function(){function e(){}return e.defineApi=function(e,t){OSF.DDA.AsyncMethodCalls.define({method:e,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:t,privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Id],i=e[Microsoft.Office.WebExtension.Parameters.Data],o=new OSF.DialogHandler,a=OSF.DDA.AsyncMethodNames.CloseAsync.displayName;OSF.OUtil.defineEnumerableProperty(o,a,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.CloseDialog];e(arguments,r,i,o)}});var s=OSF.DDA.SyncMethodNames.AddMessageHandler.displayName;if(OSF.OUtil.defineEnumerableProperty(o,s,{value:function(){var e=OSF.DDA.SyncMethodCalls[OSF.DDA.SyncMethodNames.AddMessageHandler.id],t=e.verifyAndExtractCall(arguments,o,i),n=t[Microsoft.Office.WebExtension.Parameters.EventType],r=t[Microsoft.Office.WebExtension.Parameters.Handler];return i.addEventHandlerAndFireQueuedEvent(n,r)}}),!0===OSF.DDA.UI.EnableSendMessageDialogAPI){var c=OSF.DDA.SyncMethodNames.SendMessage.displayName;OSF.OUtil.defineEnumerableProperty(o,c,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,i,o)}})}if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var u=OSF.DDA.SyncMethodNames.MessageChild.displayName;OSF.OUtil.defineEnumerableProperty(o,u,{value:function(){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,i,o)}})}return o},checkCallArgs:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Width]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Width]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Width]>100&&(e[Microsoft.Office.WebExtension.Parameters.Width]=99),e[Microsoft.Office.WebExtension.Parameters.Height]<=0&&(e[Microsoft.Office.WebExtension.Parameters.Height]=1),!e[Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels]&&e[Microsoft.Office.WebExtension.Parameters.Height]>100&&(e[Microsoft.Office.WebExtension.Parameters.Height]=99),e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]||(e[Microsoft.Office.WebExtension.Parameters.RequireHTTPs]=!0),e}})},e.messageChildRichApiBridge=function(){if(!0===OSF.DDA.UI.EnableMessageChildDialogAPI){var e=OSF._OfficeAppFactory.getHostFacade()[OSF.DDA.DispIdHost.Methods.SendMessage];return e(arguments,null,null)}},e.initOnce=function(){e.defineApi(OSF.DDA.AsyncMethodNames.DisplayDialogAsync,e.displayDialogAsyncApiSupportedOptions),e.defineApi(OSF.DDA.AsyncMethodNames.DisplayModalDialogAsync,e.displayModalDialogAsyncApiSupportedOptions)},e.displayDialogAsyncApiSupportedOptions=[{name:Microsoft.Office.WebExtension.Parameters.Width,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.Height,value:{types:["number"],defaultValue:99}},{name:Microsoft.Office.WebExtension.Parameters.RequireHTTPs,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.DisplayInIframe,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.HideTitle,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.UseDeviceIndependentPixels,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.PromptBeforeOpen,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.EnforceAppDomain,value:{types:["boolean"],defaultValue:!0}},{name:Microsoft.Office.WebExtension.Parameters.UrlNoHostInfo,value:{types:["boolean"],defaultValue:!1}}],e.displayModalDialogAsyncApiSupportedOptions=e.displayDialogAsyncApiSupportedOptions.concat([{name:"abortWhenParentIsMinimized",value:{types:["boolean"],defaultValue:!1}},{name:"abortWhenDocIsInactive",value:{types:["boolean"],defaultValue:!1}}]),e}();DialogApiManager.initOnce(),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CloseAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.MessageParent,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageToParent,types:["string","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.AddMessageHandler,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.EventType,enum:Microsoft.Office.WebExtension.EventType,verify:function(e,t,n){return n.supportsEvent(e)}},{name:Microsoft.Office.WebExtension.Parameters.Handler,types:["function"]}],supportedOptions:[]}),OSF.DDA.SyncMethodCalls.define({method:OSF.DDA.SyncMethodNames.SendMessage,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.MessageContent,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.TargetOrigin,value:{types:["string"],defaultValue:""}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.openDialog=function(e){try{e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!0,e);OSF.ClientHostController.openDialog(e.dispId,e.targetId,(function(t,n){e.onEvent&&e.onEvent(n),OSF.AppTelemetry&&OSF.AppTelemetry.onEventDone(e.dispId)}),t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.closeDialog=function(e){e.onCalling&&e.onCalling();var t=OSF.DDA.SafeArray.Delegate._getOnAfterRegisterEvent(!1,e);try{OSF.ClientHostController.closeDialog(e.dispId,e.targetId,t)}catch(t){OSF.DDA.SafeArray.Delegate._onException(t,e)}},OSF.DDA.SafeArray.Delegate.messageParent=function(e){try{e.onCalling&&e.onCalling();var t=(new Date).getTime(),n=OSF.ClientHostController.messageParent(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),OSF.AppTelemetry&&OSF.AppTelemetry.onMethodDone(e.dispId,e.hostCallArgs,Math.abs((new Date).getTime()-t),n),n}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.sendMessage=function(e){try{e.onCalling&&e.onCalling();(new Date).getTime();var t=OSF.ClientHostController.sendMessage(e.hostCallArgs);return e.onReceiving&&e.onReceiving(),t}catch(e){return OSF.DDA.SafeArray.Delegate._onExceptionSyncMethod(e)}},OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DialogParentMessageReceivedEvent:"DialogParentMessageReceivedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DialogParentMessageReceived:"dialogParentMessageReceived",DialogParentEventReceived:"dialogParentEventReceived"}),OSF.DialogParentMessageEventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DialogParentMessageReceived,Microsoft.Office.WebExtension.EventType.DialogParentEventReceived]),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.DialogParentMessageReceivedEvent,fromHost:[{name:OSF.DDA.PropertyDescriptors.MessageType,value:0},{name:OSF.DDA.PropertyDescriptors.MessageContent,value:1},{name:OSF.DDA.PropertyDescriptors.MessageOrigin,value:2}],isComplexType:!0}),OSF.DDA.UI.EnableMessageChildDialogAPI=!0,OSF.OUtil.redefineList(Microsoft.Office.WebExtension.CoercionType,{Text:"text"}),OSF.OUtil.redefineList(Microsoft.Office.WebExtension.ValueFormat,{Unformatted:"unformatted"}),OSF.OUtil.redefineList(Microsoft.Office.WebExtension.FilterType,{All:"all"}),OSF.OUtil.redefineList(Microsoft.Office.WebExtension.GoToType,{Slide:"slide",Index:"index"}),delete Microsoft.Office.WebExtension.BindingType,delete Microsoft.Office.WebExtension.select,OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Text,value:0},{name:Microsoft.Office.WebExtension.CoercionType.Matrix,value:1},{name:Microsoft.Office.WebExtension.CoercionType.Table,value:2}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{SlideRange:"slideRange"}),OSF.DDA.SlideProperties={Id:0,Title:1,Index:2},OSF.DDA.Slide=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{id:{value:e},title:{value:t},index:{value:n}})},OSF.DDA.SlideRange=function(e){OSF.OUtil.defineEnumerableProperties(this,{slides:{value:e}})},OSF.DDA.OMFactory=OSF.DDA.OMFactory||{},OSF.DDA.OMFactory.manufactureSlideRange=function(e){var t=null;if(null==(t=JSON?JSON.parse(e):Sys.Serialization.JavaScriptSerializer.deserialize(e)))return null;var n=0;for(var r in OSF.DDA.SlideProperties)OSF.DDA.SlideProperties.hasOwnProperty(r)&&n++;for(var i=[],o=!0,a=0;a<t.length&&o;a++)if(o=!1,t[a].length==n){var s=parseInt(t[a][OSF.DDA.SlideProperties.Id]),c=t[a][OSF.DDA.SlideProperties.Title],u=parseInt(t[a][OSF.DDA.SlideProperties.Index]);isNaN(s)||isNaN(u)||(o=!0,i.push(new OSF.DDA.Slide(s,c,u)))}return o?new OSF.DDA.SlideRange(i):null},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.SlideRange,value:7}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Html:"html"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Html,value:3}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Ooxml:"ooxml"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Ooxml,value:4}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{OoxmlPackage:"ooxmlPackage"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.OoxmlPackage,value:5}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{PdfFile:"pdf"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.PdfFile,value:6}]}),Microsoft.Office.WebExtension.FileType={Text:"text",Compressed:"compressed",Pdf:"pdf"},OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FileProperties:"FileProperties",FileSliceProperties:"FileSliceProperties"}),OSF.DDA.FileProperties={Handle:"FileHandle",FileSize:"FileSize",SliceSize:Microsoft.Office.WebExtension.Parameters.SliceSize},OSF.DDA.File=function(e,t,n){OSF.OUtil.defineEnumerableProperties(this,{size:{value:t},sliceCount:{value:Math.ceil(t/n)}});var r={};r[OSF.DDA.FileProperties.Handle]=e,r[OSF.DDA.FileProperties.SliceSize]=n;var i=OSF.DDA.AsyncMethodNames;OSF.DDA.DispIdHost.addAsyncMethods(this,[i.GetDocumentCopyChunkAsync,i.ReleaseDocumentCopyAsync],r)},OSF.DDA.FileSliceOffset="fileSliceoffset",OSF.DDA.AsyncMethodNames.addNames({GetDocumentCopyAsync:"getFileAsync",GetDocumentCopyChunkAsync:"getSliceAsync",ReleaseDocumentCopyAsync:"closeAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.FileType,enum:Microsoft.Office.WebExtension.FileType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.SliceSize,value:{types:["number"],defaultValue:4194304}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceSize];if(r<=0||r>4194304)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidSliceSize;return e},onSucceeded:function(e,t,n){return new OSF.DDA.File(e[OSF.DDA.FileProperties.Handle],e[OSF.DDA.FileProperties.FileSize],n[Microsoft.Office.WebExtension.Parameters.SliceSize])}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentCopyChunkAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.SliceIndex,types:["number"]}],privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}},{name:OSF.DDA.FileProperties.SliceSize,value:function(e,t){return t[OSF.DDA.FileProperties.SliceSize]}}],checkCallArgs:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.SliceIndex];if(r<0||r>=t.sliceCount)throw OSF.DDA.ErrorCodeManager.errorCodes.ooeIndexOutOfRange;return e[OSF.DDA.FileSliceOffset]=parseInt((r*n[OSF.DDA.FileProperties.SliceSize]).toString()),e},onSucceeded:function(e,t,n){var r={};return OSF.OUtil.defineEnumerableProperties(r,{data:{value:e[Microsoft.Office.WebExtension.Parameters.Data]},index:{value:n[Microsoft.Office.WebExtension.Parameters.SliceIndex]},size:{value:e[OSF.DDA.FileProperties.SliceSize]}}),r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ReleaseDocumentCopyAsync,privateStateCallbacks:[{name:OSF.DDA.FileProperties.Handle,value:function(e,t){return t[OSF.DDA.FileProperties.Handle]}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileProperties,fromHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileProperties.FileSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FileSliceProperties,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0},{name:OSF.DDA.FileProperties.SliceSize,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.FileType,toHost:[{name:Microsoft.Office.WebExtension.FileType.Text,value:0},{name:Microsoft.Office.WebExtension.FileType.Compressed,value:5},{name:Microsoft.Office.WebExtension.FileType.Pdf,value:6}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.FileType,value:0}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentCopyChunkMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0},{name:OSF.DDA.FileSliceOffset,value:1},{name:OSF.DDA.FileProperties.SliceSize,value:2}],fromHost:[{name:OSF.DDA.PropertyDescriptors.FileSliceProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidReleaseDocumentCopyMethod,toHost:[{name:OSF.DDA.FileProperties.Handle,value:0}]}),OSF.DDA.AsyncMethodNames.addNames({GetSelectedDataAsync:"getSelectedDataAsync",SetSelectedDataAsync:"setSelectedDataAsync"}),function(){OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,enum:Microsoft.Office.WebExtension.CoercionType}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:{enum:Microsoft.Office.WebExtension.ValueFormat,defaultValue:Microsoft.Office.WebExtension.ValueFormat.Unformatted}},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:{enum:Microsoft.Office.WebExtension.FilterType,defaultValue:Microsoft.Office.WebExtension.FilterType.All}}],privateStateCallbacks:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.Data];return OSF.DDA.TableDataProperties&&r&&(void 0!=r[OSF.DDA.TableDataProperties.TableRows]||void 0!=r[OSF.DDA.TableDataProperties.TableHeaders])&&(r=OSF.DDA.OMFactory.manufactureTableData(r)),void 0==(r=OSF.DDA.DataCoercion.coerceData(r,n[Microsoft.Office.WebExtension.Parameters.CoercionType]))?null:r}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["string","object","number","boolean"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:{enum:Microsoft.Office.WebExtension.CoercionType,calculate:function(e){return OSF.DDA.DataCoercion.determineCoercionType(e[Microsoft.Office.WebExtension.Parameters.Data])}}},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:{types:["number","boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:{types:["number","boolean"],defaultValue:!1}}],privateStateCallbacks:[]})}(),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetSelectedDataMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.ValueFormat,value:1},{name:Microsoft.Office.WebExtension.Parameters.FilterType,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSetSelectedDataMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.CoercionType,value:0},{name:Microsoft.Office.WebExtension.Parameters.Data,value:1},{name:Microsoft.Office.WebExtension.Parameters.ImageLeft,value:2},{name:Microsoft.Office.WebExtension.Parameters.ImageTop,value:3},{name:Microsoft.Office.WebExtension.Parameters.ImageWidth,value:4},{name:Microsoft.Office.WebExtension.Parameters.ImageHeight,value:5}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.GoToType,toHost:[{name:Microsoft.Office.WebExtension.GoToType.Binding,value:0},{name:Microsoft.Office.WebExtension.GoToType.NamedItem,value:1},{name:Microsoft.Office.WebExtension.GoToType.Slide,value:2},{name:Microsoft.Office.WebExtension.GoToType.Index,value:3}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.SelectionMode,toHost:[{name:Microsoft.Office.WebExtension.SelectionMode.Default,value:0},{name:Microsoft.Office.WebExtension.SelectionMode.Selected,value:1},{name:Microsoft.Office.WebExtension.SelectionMode.None,value:2}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidNavigateToMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.GoToType,value:1},{name:Microsoft.Office.WebExtension.Parameters.SelectionMode,value:2}]}),OSF.DDA.SettingsManager={SerializedSettings:"serializedSettings",RefreshingSettings:"refreshingSettings",DateJSONPrefix:"Date(",DataJSONSuffix:")",serializeSettings:function(e){return OSF.OUtil.serializeSettings(e)},deserializeSettings:function(e){return OSF.OUtil.deserializeSettings(e)}},OSF.DDA.Settings=function(e){e=e||{};var t=function(e){var t=OSF.OUtil.getSessionStorage();if(t){var n=OSF.DDA.SettingsManager.serializeSettings(e),r=JSON?JSON.stringify(n):Sys.Serialization.JavaScriptSerializer.serialize(n);t.setItem(OSF._OfficeAppFactory.getCachedSessionSettingsKey(),r)}};OSF.OUtil.defineEnumerableProperties(this,{get:{value:function(t){var n=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(n)throw n;var r=e[t];return"undefined"===typeof r?null:r}},set:{value:function(n,r){var i=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1},{name:"value",mayBeNull:!0}]);if(i)throw i;e[n]=r,t(e)}},remove:{value:function(n){var r=Function._validateParams(arguments,[{name:"name",type:String,mayBeNull:!1}]);if(r)throw r;delete e[n],t(e)}}}),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.SaveAsync],e)},OSF.DDA.RefreshableSettings=function(e){OSF.DDA.RefreshableSettings.uber.constructor.call(this,e),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.RefreshAsync],e),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.SettingsChanged]))},OSF.OUtil.extend(OSF.DDA.RefreshableSettings,OSF.DDA.Settings),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{SettingsChanged:"settingsChanged"}),OSF.DDA.SettingsChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.SettingsChanged},settings:{value:e}})},OSF.DDA.AsyncMethodNames.addNames({RefreshAsync:"refreshAsync",SaveAsync:"saveAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.RefreshAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.RefreshingSettings,value:function(e,t){return t}}],onSucceeded:function(e,t,n){var r=e[OSF.DDA.SettingsManager.SerializedSettings],i=OSF.DDA.SettingsManager.deserializeSettings(r),o=n[OSF.DDA.SettingsManager.RefreshingSettings];for(var a in o)t.remove(a);for(var a in i)t.set(a,i[a]);return t}}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.SaveAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:{types:["boolean"],defaultValue:!0}}],privateStateCallbacks:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:function(e,t){return OSF.DDA.SettingsManager.serializeSettings(t)}}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidLoadSettingsMethod,fromHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidSaveSettingsMethod,toHost:[{name:OSF.DDA.SettingsManager.SerializedSettings,value:OSF.DDA.SettingsManager.SerializedSettings},{name:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale,value:Microsoft.Office.WebExtension.Parameters.OverwriteIfStale}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidSettingsChangedEvent}),OSF.DDA.AsyncMethodNames.addNames({GetOfficeThemeAsync:"getOfficeThemeAsync",GetDocumentThemeAsync:"getDocumentThemeAsync"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{OfficeThemeChanged:"officeThemeChanged",DocumentThemeChanged:"documentThemeChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.Parameters,{DocumentTheme:"documentTheme",OfficeTheme:"officeTheme"}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{DocumentThemeChangedEvent:"DocumentThemeChangedEvent",OfficeThemeChangedEvent:"OfficeThemeChangedEvent"}),OSF.OUtil.setNamespace("Theming",OSF.DDA),OSF.DDA.Theming.OfficeThemeEnum={BodyForegroundColor:"bodyForegroundColor",BodyBackgroundColor:"bodyBackgroundColor",ControlForegroundColor:"controlForegroundColor",ControlBackgroundColor:"controlBackgroundColor",ThemeId:"themeId",IsDarkTheme:"isDarkTheme"},OSF.DDA.Theming.OfficeThemeEnumWac={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",IsDarkTheme:"isDarkTheme"},OSF.DDA.Theming.DocumentThemeEnum={PrimaryFontColor:"primaryFontColor",PrimaryBackgroundColor:"primaryBackgroundColor",SecondaryFontColor:"secondaryFontColor",SecondaryBackgroundColor:"secondaryBackgroundColor",Accent1:"accent1",Accent2:"accent2",Accent3:"accent3",Accent4:"accent4",Accent5:"accent5",Accent6:"accent6",Hyperlink:"hyperlink",FollowedHyperlink:"followedHyperlink",HeaderLatinFont:"headerLatinFont",HeaderEastAsianFont:"headerEastAsianFont",HeaderScriptFont:"headerScriptFont",HeaderLocalizedFont:"headerLocalizedFont",BodyLatinFont:"bodyLatinFont",BodyEastAsianFont:"bodyEastAsianFont",BodyScriptFont:"bodyScriptFont",BodyLocalizedFont:"bodyLocalizedFont"},OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor=function(e){var t="#"===e.charAt(0)?e.substring(1,7):e;return.299*parseInt(t.substring(0,2),16)+.587*parseInt(t.substring(2,4),16)+.114*parseInt(t.substring(4,6),16)<186},OSF.DDA.Theming.ConvertToDocumentTheme=function(e){for(var t=[{name:"primaryFontColor",needToConvertToHex:!0},{name:"primaryBackgroundColor",needToConvertToHex:!0},{name:"secondaryFontColor",needToConvertToHex:!0},{name:"secondaryBackgroundColor",needToConvertToHex:!0},{name:"accent1",needToConvertToHex:!0},{name:"accent2",needToConvertToHex:!0},{name:"accent3",needToConvertToHex:!0},{name:"accent4",needToConvertToHex:!0},{name:"accent5",needToConvertToHex:!0},{name:"accent6",needToConvertToHex:!0},{name:"hyperlink",needToConvertToHex:!0},{name:"followedHyperlink",needToConvertToHex:!0},{name:"headerLatinFont",needToConvertToHex:!1},{name:"headerEastAsianFont",needToConvertToHex:!1},{name:"headerScriptFont",needToConvertToHex:!1},{name:"headerLocalizedFont",needToConvertToHex:!1},{name:"bodyLatinFont",needToConvertToHex:!1},{name:"bodyEastAsianFont",needToConvertToHex:!1},{name:"bodyScriptFont",needToConvertToHex:!1},{name:"bodyLocalizedFont",needToConvertToHex:!1}],n={},r=0;r<t.length;r++)t[r].needToConvertToHex?n[t[r].name]=OSF.OUtil.convertIntToCssHexColor(e[t[r].name]):n[t[r].name]=e[t[r].name];return n},OSF.DDA.Theming.ConvertToOfficeTheme=function(e){var t={};if(e){var n=OSF.DDA.Theming.OfficeThemeEnum,r={bodyBackgroundColor:{name:n.BodyBackgroundColor,convertToHex:!0},bodyForegroundColor:{name:n.BodyForegroundColor,convertToHex:!0},controlBackgroundColor:{name:n.ControlBackgroundColor,convertToHex:!0},controlForegroundColor:{name:n.ControlForegroundColor,convertToHex:!0},primaryFontColor:{name:n.BodyForegroundColor,convertToHex:!0},primaryBackgroundColor:{name:n.BodyBackgroundColor,convertToHex:!0},secondaryFontColor:{name:n.ControlBackgroundColor,convertToHex:!0},secondaryBackgroundColor:{name:n.ControlForegroundColor,convertToHex:!0}};for(var i in e){var o=!1,a=i;r[i]&&(a=r[i].name,o=r[i].convertToHex),t[a]=o?OSF.OUtil.convertIntToCssHexColor(e[i]):e[i]}void 0==t[n.IsDarkTheme]&&(t[n.IsDarkTheme]=OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor(t[n.BodyBackgroundColor]))}return t},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToDocumentTheme}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:OSF.DDA.Theming.ConvertToOfficeTheme}),OSF.DDA.Theming.OfficeThemeChangedEventArgs=function(e){var t=null,n=OSF._OfficeAppFactory.getHostInfo();if((t=n&&"web"==n.hostPlatform.toLowerCase()?e:OSF.DDA.Theming.ConvertToOfficeTheme(e)).isDarkTheme=OSF.DDA.Theming.GetIsDarkThemeFromCSSHexColor(t.bodyBackgroundColor),"web"==n.hostPlatform.toLowerCase()||"mac"==n.hostPlatform.toLowerCase()||"ios"==n.hostPlatform.toLowerCase()){var r=OSF._OfficeAppFactory.getContext();r&&r.officeTheme&&(r.officeTheme.bodyBackgroundColor=t.bodyBackgroundColor,r.officeTheme.bodyForegroundColor=t.bodyForegroundColor,r.officeTheme.controlBackgroundColor=t.controlBackgroundColor,r.officeTheme.controlBackgroundColor=t.controlBackgroundColor,r.officeTheme.isDarkTheme=t.isDarkTheme)}OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.OfficeThemeChanged},officeTheme:{value:t}})},OSF.DDA.Theming.DocumentThemeChangedEventArgs=function(e){var t=OSF.DDA.Theming.ConvertToDocumentTheme(e);OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentThemeChanged},documentTheme:{value:t}})};var OSF_DDA_Theming_InternalThemeHandler=function(){function e(){this._pseudoDocumentObject=null,this._eventTarget=null,this._previousDocumentThemeData=null,this._previousOfficeThemeData=null,this._officeCss=null,this._asyncCallsCompleted=null,this._isPublicThemeManager=!1,this._onAsyncCallsCompleted=null}return e.prototype.InitializeThemeManager=function(){this._isPublicThemeManager=!0,this._eventTarget=this,OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged]))},e.prototype.InitializeAndChangeOnce=function(e){if(this._officeCss=this._getOfficeThemesCss(),this._officeCss){this._onAsyncCallsCompleted=e,this._pseudoDocumentObject={};var t=this._pseudoDocumentObject;this._isPublicThemeManager||(OSF.DDA.DispIdHost.addAsyncMethods(t,[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync,OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]),OSF.DDA.DispIdHost.addEventSupport(t,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Microsoft.Office.WebExtension.EventType.DocumentThemeChanged]))),this._asyncCallsCompleted={},this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync]=!1,this._asyncCallsCompleted[OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync]=!1;var n=OSF._OfficeAppFactory.getHostInfo();this._isPublicThemeManager?(n&&n.hostType.toLowerCase()!=Microsoft.Office.WebExtension.HostType.Word.toLowerCase()&&this._getAndProcessThemeData(this._eventTarget.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync),this._getAndProcessThemeData(this._eventTarget.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync)):(n&&n.hostType.toLowerCase()!=Microsoft.Office.WebExtension.HostType.Word.toLowerCase()&&this._getAndProcessThemeData(t.getDocumentThemeAsync,Function.createDelegate(this,this._processDocumentThemeData),OSF.DDA.AsyncMethodNames.GetDocumentThemeAsync),this._getAndProcessThemeData(t.getOfficeThemeAsync,Function.createDelegate(this,this._processOfficeThemeData),OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync))}else e&&e()},e.prototype._getOfficeThemesCss=function(){try{return function(){for(var e=0;e<document.styleSheets.length;e++){var t=document.styleSheets[e];if(!t.disabled&&t.href&&"officethemes.css"==t.href.substring(t.href.length-"officethemes.css".length,t.href.length).toLowerCase())return t.cssRules||t.rules?t:null}}()}catch(e){return null}},e.prototype._changeCss=function(e,t,n){for(var r=e.cssRules?e.cssRules.length:e.rules.length,i=0;i<r;i++){var o=(e.cssRules?e.cssRules[i]:e.rules[i]).selectorText;o&&o.toLowerCase()==t.toLowerCase()&&(e.cssRules?(e.deleteRule(i),e.insertRule(o+n,i)):(e.removeRule(i),e.addRule(o,n,i)))}},e.prototype._changeDocumentThemeData=function(e){for(var t=[{name:"primaryFontColor",cssSelector:".office-docTheme-primary-fontColor",cssProperty:"color"},{name:"primaryBackgroundColor",cssSelector:".office-docTheme-primary-bgColor",cssProperty:"background-color"},{name:"secondaryFontColor",cssSelector:".office-docTheme-secondary-fontColor",cssProperty:"color"},{name:"secondaryBackgroundColor",cssSelector:".office-docTheme-secondary-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-color",cssProperty:"color"},{name:"accent2",cssSelector:".office-contentAccent2-color",cssProperty:"color"},{name:"accent3",cssSelector:".office-contentAccent3-color",cssProperty:"color"},{name:"accent4",cssSelector:".office-contentAccent4-color",cssProperty:"color"},{name:"accent5",cssSelector:".office-contentAccent5-color",cssProperty:"color"},{name:"accent6",cssSelector:".office-contentAccent6-color",cssProperty:"color"},{name:"accent1",cssSelector:".office-contentAccent1-bgColor",cssProperty:"background-color"},{name:"accent2",cssSelector:".office-contentAccent2-bgColor",cssProperty:"background-color"},{name:"accent3",cssSelector:".office-contentAccent3-bgColor",cssProperty:"background-color"},{name:"accent4",cssSelector:".office-contentAccent4-bgColor",cssProperty:"background-color"},{name:"accent5",cssSelector:".office-contentAccent5-bgColor",cssProperty:"background-color"},{name:"accent6",cssSelector:".office-contentAccent6-bgColor",cssProperty:"background-color"},{name:"accent1",cssSelector:".office-contentAccent1-borderColor",cssProperty:"border-color"},{name:"accent2",cssSelector:".office-contentAccent2-borderColor",cssProperty:"border-color"},{name:"accent3",cssSelector:".office-contentAccent3-borderColor",cssProperty:"border-color"},{name:"accent4",cssSelector:".office-contentAccent4-borderColor",cssProperty:"border-color"},{name:"accent5",cssSelector:".office-contentAccent5-borderColor",cssProperty:"border-color"},{name:"accent6",cssSelector:".office-contentAccent6-borderColor",cssProperty:"border-color"},{name:"hyperlink",cssSelector:".office-a",cssProperty:"color"},{name:"followedHyperlink",cssSelector:".office-a:visited",cssProperty:"color"},{name:"headerLatinFont",cssSelector:".office-headerFont-latin",cssProperty:"font-family"},{name:"headerEastAsianFont",cssSelector:".office-headerFont-eastAsian",cssProperty:"font-family"},{name:"headerScriptFont",cssSelector:".office-headerFont-script",cssProperty:"font-family"},{name:"headerLocalizedFont",cssSelector:".office-headerFont-localized",cssProperty:"font-family"},{name:"bodyLatinFont",cssSelector:".office-bodyFont-latin",cssProperty:"font-family"},{name:"bodyEastAsianFont",cssSelector:".office-bodyFont-eastAsian",cssProperty:"font-family"},{name:"bodyScriptFont",cssSelector:".office-bodyFont-script",cssProperty:"font-family"},{name:"bodyLocalizedFont",cssSelector:".office-bodyFont-localized",cssProperty:"font-family"}],n=e.type==Microsoft.Office.WebExtension.EventType.DocumentThemeChanged?e.documentTheme:e,r=0;r<t.length;r++)if(null===this._previousDocumentThemeData||this._previousDocumentThemeData[t[r].name]!=n[t[r].name])if(null!=n[t[r].name]&&""!=n[t[r].name]){var i=n[t[r].name];"font-family"===t[r].cssProperty&&(i='"'+i.replace(new RegExp('"',"g"),'\\"')+'"'),this._changeCss(this._officeCss,t[r].cssSelector,"{"+t[r].cssProperty+":"+i+";}")}else this._changeCss(this._officeCss,t[r].cssSelector,"{}");this._previousDocumentThemeData=n},e.prototype._changeOfficeThemeData=function(e){for(var t=OSF.DDA.Theming.OfficeThemeEnum,n=[{name:t.BodyForegroundColor,cssSelector:".office-officeTheme-primary-fontColor",cssProperty:"color"},{name:t.BodyBackgroundColor,cssSelector:".office-officeTheme-primary-bgColor",cssProperty:"background-color"},{name:t.ControlForegroundColor,cssSelector:".office-officeTheme-secondary-fontColor",cssProperty:"color"},{name:t.ControlBackgroundColor,cssSelector:".office-officeTheme-secondary-bgColor",cssProperty:"background-color"}],r=e.type==Microsoft.Office.WebExtension.EventType.OfficeThemeChanged?e.officeTheme:e,i=0;i<n.length;i++)null!==this._previousOfficeThemeData&&this._previousOfficeThemeData[n[i].name]==r[n[i].name]||void 0!==r[n[i].name]&&this._changeCss(this._officeCss,n[i].cssSelector,"{"+n[i].cssProperty+":"+r[n[i].name]+";}");this._previousOfficeThemeData=r},e.prototype._getAndProcessThemeData=function(e,t,n){var r=OSF._OfficeAppFactory.getHostInfo();if(r&&"web"==r.hostPlatform.toLowerCase()){if(n==OSF.DDA.AsyncMethodNames.GetOfficeThemeAsync){var i={},o=OSF._OfficeAppFactory.getContext();if(o&&o.officeTheme){var a=OSF.DDA.Theming.OfficeThemeEnum;i[a.BodyBackgroundColor]=o.officeTheme.bodyBackgroundColor,i[a.BodyForegroundColor]=o.officeTheme.bodyForegroundColor,i[a.ControlBackgroundColor]=o.officeTheme.controlBackgroundColor,i[a.ControlForegroundColor]=o.officeTheme.controlForegroundColor,i[a.IsDarkTheme]=o.officeTheme.isDarkTheme}t(i)}}else e(Function.createDelegate(this,(function(e){if("succeeded"==e.status){var r=e.value;t(r)}this._areAllCallsCompleted(n)&&this._onAsyncCallsCompleted&&(this._onAsyncCallsCompleted(),this._onAsyncCallsCompleted=null)})))},e.prototype._processOfficeThemeData=function(e){this._changeOfficeThemeData(e),this._isPublicThemeManager?this._eventTarget.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null):this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.OfficeThemeChanged,Function.createDelegate(this,this._changeOfficeThemeData),null)},e.prototype._processDocumentThemeData=function(e){this._changeDocumentThemeData(e),this._isPublicThemeManager?this._eventTarget.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null):this._pseudoDocumentObject.addHandlerAsync(Microsoft.Office.WebExtension.EventType.DocumentThemeChanged,Function.createDelegate(this,this._changeDocumentThemeData),null)},e.prototype._areAllCallsCompleted=function(e){var t;if(!(t=this._asyncCallsCompleted))return!0;for(var n in e&&t.hasOwnProperty(e)&&(t[e]=!0),t)if(!t.hasOwnProperty(n)||!t[n])return!1;return!0},e}();OSF.DDA.Theming.InternalThemeHandler=OSF_DDA_Theming_InternalThemeHandler;var parameterMap=OSF.DDA.SafeArray.Delegate.ParameterMap;parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetDocumentThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.MethodDispId.dispidGetOfficeThemeMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}]}),parameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDispId.dispidOfficeThemeChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,value:parameterMap.self}],isComplexType:!0});var destKeys=OSF.DDA.Theming.DocumentThemeEnum;parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.DocumentTheme,fromHost:[{name:destKeys.PrimaryBackgroundColor,value:0},{name:destKeys.PrimaryFontColor,value:1},{name:destKeys.SecondaryBackgroundColor,value:2},{name:destKeys.SecondaryFontColor,value:3},{name:destKeys.Accent1,value:4},{name:destKeys.Accent2,value:5},{name:destKeys.Accent3,value:6},{name:destKeys.Accent4,value:7},{name:destKeys.Accent5,value:8},{name:destKeys.Accent6,value:9},{name:destKeys.Hyperlink,value:10},{name:destKeys.FollowedHyperlink,value:11},{name:destKeys.HeaderLatinFont,value:12},{name:destKeys.HeaderEastAsianFont,value:13},{name:destKeys.HeaderScriptFont,value:14},{name:destKeys.HeaderLocalizedFont,value:15},{name:destKeys.BodyLatinFont,value:16},{name:destKeys.BodyEastAsianFont,value:17},{name:destKeys.BodyScriptFont,value:18},{name:destKeys.BodyLocalizedFont,value:19}],isComplexType:!0}),destKeys=OSF.DDA.Theming.OfficeThemeEnum,parameterMap.define({type:Microsoft.Office.WebExtension.Parameters.OfficeTheme,fromHost:[{name:destKeys.BodyForegroundColor,value:0},{name:destKeys.BodyBackgroundColor,value:1},{name:destKeys.ControlForegroundColor,value:2},{name:destKeys.ControlBackgroundColor,value:3}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.DocumentThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.DocumentTheme,value:parameterMap.self}],isComplexType:!0}),parameterMap.define({type:OSF.DDA.EventDescriptors.OfficeThemeChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.OfficeTheme,value:parameterMap.self}],isComplexType:!0}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{DocumentSelectionChanged:"documentSelectionChanged"}),OSF.DDA.DocumentSelectionChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged},document:{value:e}})},OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDeleted:"objectDeleted"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectSelectionChanged:"objectSelectionChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ObjectDataChanged:"objectDataChanged"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ContentControlAdded:"contentControlAdded"}),OSF.DDA.ObjectEventArgs=function(e,t){OSF.OUtil.defineEnumerableProperties(this,{type:{value:e},object:{value:t}})},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidDocumentSelectionChangedEvent}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDeletedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectSelectionChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidObjectDataChangedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidContentControlAddedEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,fromHost:[{name:OSF.DDA.FilePropertiesDescriptor.Url,value:0}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetFilePropertiesMethod,fromHost:[{name:OSF.DDA.PropertyDescriptors.FilePropertiesDescriptor,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{ActiveViewChangedEvent:"ActiveViewChangedEvent"}),Microsoft.Office.WebExtension.ActiveView={Read:"read",Edit:"edit"},OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{ActiveViewChanged:"activeViewChanged"}),OSF.DDA.AsyncMethodNames.addNames({GetActiveViewAsync:"getActiveViewAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetActiveViewAsync,requiredArguments:[],supportedOptions:[],privateStateCallbacks:[],onSucceeded:function(e){var t=e[Microsoft.Office.WebExtension.Parameters.ActiveView];return void 0==t?null:t}}),OSF.DDA.ActiveViewChangedEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.ActiveViewChanged},activeView:{value:e.activeView}})},OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.ActiveView,fromHost:[{name:0,value:Microsoft.Office.WebExtension.ActiveView.Read},{name:1,value:Microsoft.Office.WebExtension.ActiveView.Edit}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetActiveViewMethod,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.ActiveView,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDescriptors.ActiveViewChangedEvent,fromHost:[{name:Microsoft.Office.WebExtension.Parameters.ActiveView,value:0}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidActiveViewChangedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.ActiveViewChangedEvent,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{Image:"image"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.CoercionType,{XmlSvg:"xmlSvg"}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:Microsoft.Office.WebExtension.Parameters.CoercionType,toHost:[{name:Microsoft.Office.WebExtension.CoercionType.Image,value:8},{name:Microsoft.Office.WebExtension.CoercionType.XmlSvg,value:9}]}),function(e){!function(t){var n=function(){function n(){var e=this;this._pseudoDocument=null,this._eventDispatch=null,this._useAssociatedActionsOnly=null,this._processAppCommandInvocation=function(t){var n=e._verifyManifestCallback(t.callbackName);if(n.errorCode==OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess){var r=e._constructEventObjectForCallback(t);r?window.setTimeout((function(){n.callback(r)}),0):e._invokeAppCommandCompletedMethod(t.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError,"")}else e._invokeAppCommandCompletedMethod(t.appCommandId,n.errorCode,"")}}return n.initializeOsfDda=function(){OSF.DDA.AsyncMethodNames.addNames({AppCommandInvocationCompletedAsync:"appCommandInvocationCompletedAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Id,types:["string"]},{name:Microsoft.Office.WebExtension.Parameters.Status,types:["number"]},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,types:["string"]}]}),OSF.OUtil.augmentList(OSF.DDA.EventDescriptors,{AppCommandInvokedEvent:"AppCommandInvokedEvent"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{AppCommandInvoked:"appCommandInvoked"}),OSF.OUtil.setNamespace("AppCommand",OSF.DDA),OSF.DDA.AppCommand.AppCommandInvokedEventArgs=e.AppCommand.AppCommandInvokedEventArgs},n.prototype.initializeAndChangeOnce=function(e){t.registerDdaFacade(),this._pseudoDocument={},OSF.DDA.DispIdHost.addAsyncMethods(this._pseudoDocument,[OSF.DDA.AsyncMethodNames.AppCommandInvocationCompletedAsync]),this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.AppCommandInvoked]);OSF.DDA.DispIdHost.addEventSupport(this._pseudoDocument,this._eventDispatch),this._pseudoDocument.addHandlerAsync(Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this._processAppCommandInvocation,(function(t){e&&("succeeded"==t.status?e(OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess):e(OSF.DDA.ErrorCodeManager.errorCodes.ooeInternalError))}))},n.prototype._verifyManifestCallback=function(e){var t={callback:null,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeInvalidCallback};e=e.trim();try{var n=this._getCallbackFunc(e);if("function"!=typeof n)return t}catch(e){return t}return{callback:n,errorCode:OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess}},n.prototype._getUseAssociatedActionsOnly=function(){if(null==this._useAssociatedActionsOnly){this._useAssociatedActionsOnly=!1;try{!0===window.useAssociatedActionsOnly?this._useAssociatedActionsOnly=!0:this._useAssociatedActionsOnly=OSF._OfficeAppFactory.getLoadScriptHelper().getUseAssociatedActionsOnlyDefined()}catch(e){}}return this._useAssociatedActionsOnly},n.prototype._getCallbackFuncFromWindow=function(e){for(var t=e.split("."),n=window,r=0;r<t.length-1;r++){if(!n[t[r]]||"object"!=typeof n[t[r]]&&"function"!=typeof n[t[r]])return null;n=n[t[r]]}return n[t[t.length-1]]},n.prototype._getCallbackFuncFromActionAssociateTable=function(e){var t=e.toUpperCase();return Office.actions._association.mappings[t]},n.prototype._getCallbackFunc=function(e){var t=this,r=null,i=!1;if(this._getUseAssociatedActionsOnly()||(r=this._getCallbackFuncFromWindow(e)),r||(r=this._getCallbackFuncFromActionAssociateTable(e))&&(i=!0),!n.isTelemetrySubmitted){n.isTelemetrySubmitted=!0;try{if(OTel&&oteljs&&Microsoft.Office.WebExtension.sendTelemetryEvent){var o="Outlook"==OTel.OTelLogger.getHost()?.1:.2;Math.random()<o&&OTel.OTelLogger.onTelemetryLoaded((function(){var e=[oteljs.makeBooleanDataField("UseAction",!0===t._useAssociatedActionsOnly),oteljs.makeBooleanDataField("UseAssociateTable",i)];Microsoft.Office.WebExtension.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.AppCommandDefinition",dataFields:e,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage,diagnosticLevel:oteljs.DiagnosticLevel.NecessaryServiceDataEvent}})}))}}catch(e){}}return r},n.prototype._invokeAppCommandCompletedMethod=function(e,t,n){this._pseudoDocument.appCommandInvocationCompletedAsync(e,t,n)},n.prototype._constructEventObjectForCallback=function(e){var t=this,n=new i;try{var r=JSON.parse(e.eventObjStr);this._translateEventObjectInternal(r,n),Object.defineProperty(n,"completed",{value:function(r){n.completedContext=r;var i=JSON.stringify(n);t._invokeAppCommandCompletedMethod(e.appCommandId,OSF.DDA.ErrorCodeManager.errorCodes.ooeSuccess,i)},enumerable:!0})}catch(e){n=null}return n},n.prototype._translateEventObjectInternal=function(e,t){for(var n in e)if(e.hasOwnProperty(n)){var r=e[n];"object"==typeof r&&null!=r?(OSF.OUtil.defineEnumerableProperty(t,n,{value:{}}),this._translateEventObjectInternal(r,t[n])):Object.defineProperty(t,n,{value:r,enumerable:!0,writable:!0})}},n.prototype._constructObjectByTemplate=function(e,t){var n={};if(!e||!t)return n;for(var r in e)if(e.hasOwnProperty(r)&&(n[r]=null,null!=t[r])){var i=e[r],o=t[r],a=typeof o;"object"==typeof i&&null!=i?n[r]=this._constructObjectByTemplate(i,o):"number"!=a&&"string"!=a&&"boolean"!=a||(n[r]=o)}return n},n.instance=function(){return null==n._instance&&(n._instance=new n),n._instance},n.isTelemetrySubmitted=!1,n._instance=null,n}();t.AppCommandManager=n;var r=function(){function e(e,t,n){this.type=Microsoft.Office.WebExtension.EventType.AppCommandInvoked,this.appCommandId=e,this.callbackName=t,this.eventObjStr=n}return e.create=function(n){return new e(n[t.AppCommandInvokedEventEnums.AppCommandId],n[t.AppCommandInvokedEventEnums.CallbackName],n[t.AppCommandInvokedEventEnums.EventObjStr])},e}();t.AppCommandInvokedEventArgs=r;var i=function(){return function(){}}();t.AppCommandCallbackEventArgs=i,t.AppCommandInvokedEventEnums={AppCommandId:"appCommandId",CallbackName:"callbackName",EventObjStr:"eventObjStr"}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),OfficeExt.AppCommand.AppCommandManager.initializeOsfDda(),function(e){!function(t){t.registerDdaFacade=function(){if(OSF.DDA.SafeArray){var t=OSF.DDA.SafeArray.Delegate.ParameterMap;t.define({type:OSF.DDA.MethodDispId.dispidAppCommandInvocationCompletedMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Id,value:0},{name:Microsoft.Office.WebExtension.Parameters.Status,value:1},{name:Microsoft.Office.WebExtension.Parameters.AppCommandInvocationCompletedData,value:2}]}),t.define({type:OSF.DDA.EventDispId.dispidAppCommandInvokedEvent,fromHost:[{name:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,value:t.self}],isComplexType:!0}),t.define({type:OSF.DDA.EventDescriptors.AppCommandInvokedEvent,fromHost:[{name:e.AppCommand.AppCommandInvokedEventEnums.AppCommandId,value:0},{name:e.AppCommand.AppCommandInvokedEventEnums.CallbackName,value:1},{name:e.AppCommand.AppCommandInvokedEventEnums.EventObjStr,value:2}],isComplexType:!0})}}}(e.AppCommand||(e.AppCommand={}))}(OfficeExt||(OfficeExt={})),Microsoft.Office.WebExtension.AccountTypeFilter={NoFilter:"noFilter",AAD:"aad",MSA:"msa"},OSF.DDA.AsyncMethodNames.addNames({GetAccessTokenAsync:"getAccessTokenAsync"}),OSF.DDA.Auth=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetAccessTokenAsync,requiredArguments:[],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:{types:["string"],defaultValue:""}},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:{types:["boolean"],defaultValue:!1}},{name:Microsoft.Office.WebExtension.Parameters.EnableNewHosts,value:{types:["number"],defaultValue:0}},{name:Microsoft.Office.WebExtension.Parameters.AccountTypeFilter,value:{enum:Microsoft.Office.WebExtension.AccountTypeFilter,defaultValue:Microsoft.Office.WebExtension.AccountTypeFilter.NoFilter}}],checkCallArgs:function(e,t,n){var r,i=OSF._OfficeAppFactory.getInitializationHelper()._appContext;if(i&&i._wopiHostOriginForSingleSignOn){var o=OSF.OUtil.Guid.generateNewGuid();window.parent.parent.postMessage('{"MessageId":"AddinTrustedOrigin","AddinTrustId":"'+o+'"}',i._wopiHostOriginForSingleSignOn),e[Microsoft.Office.WebExtension.Parameters.AddinTrustId]=o}if(window.Office.context.requirements.isSetSupported("JsonPayloadSSO")){for(var a=((r={})[Microsoft.Office.WebExtension.Parameters.ForceConsent]=!1,r[Microsoft.Office.WebExtension.Parameters.ForceAddAccount]=!1,r[Microsoft.Office.WebExtension.Parameters.AuthChallenge]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess]=!0,r[Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt]=!0,r[Microsoft.Office.WebExtension.Parameters.EnableNewHosts]=!0,r[Microsoft.Office.WebExtension.Parameters.AccountTypeFilter]=!0,r),s={},c=0,u=Object.keys(a);c<u.length;c++){var l=u[c];a[l]&&(s[l]=e[l]),delete e[l]}e[Microsoft.Office.WebExtension.Parameters.JsonPayload]=JSON.stringify(s)}return e},onSucceeded:function(e,t,n){return e[Microsoft.Office.WebExtension.Parameters.Data]}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetAccessTokenMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.JsonPayload,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceConsent,value:0},{name:Microsoft.Office.WebExtension.Parameters.ForceAddAccount,value:1},{name:Microsoft.Office.WebExtension.Parameters.AuthChallenge,value:2},{name:Microsoft.Office.WebExtension.Parameters.AllowConsentPrompt,value:3},{name:Microsoft.Office.WebExtension.Parameters.ForMSGraphAccess,value:4},{name:Microsoft.Office.WebExtension.Parameters.AllowSignInPrompt,value:5}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.AsyncMethodNames.addNames({GetNestedAppAuthContextAsync:"getAuthContextAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.GetNestedAppAuthContextAsync,requiredArguments:[],supportedOptions:[],onSucceeded:function(e,t,n){var r=e[Microsoft.Office.WebExtension.Parameters.JsonData];return{userObjectId:r.userObjectId||"",tenantId:r.tenantId||"",userPrincipalName:r.userPrincipalName||"",authorityType:r.authorityType||""}}}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidGetNestedAppAuthContextMethod,toHost:[],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.JsonData,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.DDA.AsyncMethodNames.addNames({ExecuteRichApiRequestAsync:"executeRichApiRequestAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Data,types:["object"]}],supportedOptions:[]}),OSF.OUtil.setNamespace("RichApi",OSF.DDA),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteRichApiRequestMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{RichApiMessage:"richApiMessage"}),OSF.DDA.RichApiMessageEventArgs=function(e,t){var n=t[Microsoft.Office.WebExtension.Parameters.Data],r=[];if(n)for(var i=0;i<n.length;i++){var o=n[i];o.toArray&&(o=o.toArray()),r.push({messageCategory:o[0],messageType:o[1],targetId:o[2],message:o[3],id:o[4],isRemoteOverride:o[5]})}OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.RichApiMessage},entries:{value:r}})},function(e){var t=function(){function e(){this._eventDispatch=null,this._registerHandlers=[],this._eventDispatch=new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.RichApiMessage]),OSF.DDA.DispIdHost.addEventSupport(this,this._eventDispatch)}return e.prototype.register=function(e){var t=this;return this._registerWithHostPromise||(this._registerWithHostPromise=new Office.Promise((function(e,n){t.addHandlerAsync(Microsoft.Office.WebExtension.EventType.RichApiMessage,(function(e){t._registerHandlers.forEach((function(t){t&&t(e)}))}),(function(t){"failed"==t.status?n(t.error):e()}))}))),this._registerWithHostPromise.then((function(){t._registerHandlers.push(e)}))},e}();e.RichApiMessageManager=t}(OfficeExt||(OfficeExt={})),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.EventDispId.dispidRichApiMessageEvent,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:0}],fromHost:[{name:Microsoft.Office.WebExtension.Parameters.Data,value:OSF.DDA.SafeArray.Delegate.ParameterMap.sourceData}]}),OSF.DDA.AsyncMethodNames.addNames({OpenBrowserWindow:"openBrowserWindow"}),OSF.DDA.OpenBrowser=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.OpenBrowserWindow,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Url,types:["string"]}],supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Reserved,value:{types:["number"],defaultValue:0}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidOpenBrowserWindow,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Reserved,value:0},{name:Microsoft.Office.WebExtension.Parameters.Url,value:1}]}),OSF.DDA.AsyncMethodNames.addNames({CreateDocumentAsync:"createDocumentAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.CreateDocumentAsync,supportedOptions:[{name:Microsoft.Office.WebExtension.Parameters.Base64,value:{types:["string"],defaultValue:""}}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidCreateDocumentMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Base64,value:0}]}),OSF.DDA.AsyncMethodNames.addNames({InsertFormAsync:"insertFormAsync"}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.InsertFormAsync,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.FormId,types:["string"]}],supportedOptions:[],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidInsertFormMethod,toHost:[{name:Microsoft.Office.WebExtension.Parameters.FormId,value:0}]}),OSF.DDA.AsyncMethodNames.addNames({ExecuteFeature:"executeFeatureAsync",QueryFeature:"queryFeatureAsync"}),OSF.OUtil.augmentList(OSF.DDA.PropertyDescriptors,{FeatureProperties:"FeatureProperties",TcidEnabled:"TcidEnabled",TcidVisible:"TcidVisible"}),OSF.DDA.ExecuteFeature=function(){},OSF.DDA.QueryFeature=function(){},OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.ExecuteFeature,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,types:["number"]}],privateStateCallbacks:[]}),OSF.DDA.AsyncMethodCalls.define({method:OSF.DDA.AsyncMethodNames.QueryFeature,requiredArguments:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,types:["number"]}],privateStateCallbacks:[]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.PropertyDescriptors.FeatureProperties,fromHost:[{name:OSF.DDA.PropertyDescriptors.TcidEnabled,value:0},{name:OSF.DDA.PropertyDescriptors.TcidVisible,value:1}],isComplexType:!0}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidExecuteFeature,toHost:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,value:0}]}),OSF.DDA.SafeArray.Delegate.ParameterMap.define({type:OSF.DDA.MethodDispId.dispidQueryFeature,fromHost:[{name:OSF.DDA.PropertyDescriptors.FeatureProperties,value:OSF.DDA.SafeArray.Delegate.ParameterMap.self}],toHost:[{name:Microsoft.Office.WebExtension.Parameters.Tcid,value:0}]}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{Suspend:"Suspend"}),OSF.OUtil.augmentList(Microsoft.Office.WebExtension.EventType,{Resume:"Resume"}),OSF.DDA.SuspendEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.Suspend}})},OSF.DDA.ResumeEventArgs=function(e){OSF.OUtil.defineEnumerableProperties(this,{type:{value:Microsoft.Office.WebExtension.EventType.Resume}})},OSF.DDA.PowerPointDocument=function(e,t){OSF.DDA.PowerPointDocument.uber.constructor.call(this,e,t),OSF.DDA.DispIdHost.addAsyncMethods(this,[OSF.DDA.AsyncMethodNames.GetSelectedDataAsync,OSF.DDA.AsyncMethodNames.SetSelectedDataAsync,OSF.DDA.AsyncMethodNames.GetDocumentCopyAsync,OSF.DDA.AsyncMethodNames.GetActiveViewAsync,OSF.DDA.AsyncMethodNames.GetFilePropertiesAsync,OSF.DDA.AsyncMethodNames.GoToByIdAsync,OSF.DDA.AsyncMethodNames.InsertFormAsync]),OSF.DDA.DispIdHost.addEventSupport(this,new OSF.EventDispatch([Microsoft.Office.WebExtension.EventType.DocumentSelectionChanged,Microsoft.Office.WebExtension.EventType.ActiveViewChanged])),OSF.OUtil.finalizeProperties(this)},OSF.OUtil.extend(OSF.DDA.PowerPointDocument,OSF.DDA.Document),OSF.InitializationHelper.prototype.prepareRightAfterWebExtensionInitialize=function(e){e&&e.get_isDialog()||OfficeExt.AppCommand.AppCommandManager.instance().initializeAndChangeOnce()},OSF.InitializationHelper.prototype.loadAppSpecificScriptAndCreateOM=function(e,t,n){OSF.DDA.ErrorCodeManager.initializeErrorMessages(Strings.OfficeOM),e.doc=new OSF.DDA.PowerPointDocument(e,this._initializeSettings(!0)),OSF.DDA.DispIdHost.addAsyncMethods(OSF.DDA.RichApi,[OSF.DDA.AsyncMethodNames.ExecuteRichApiRequestAsync]),e.get_isDialog()||(OSF.DDA.RichApi.richApiMessageManager=new OfficeExt.RichApiMessageManager),t()},OSF.InitializationHelper.prototype.prepareApiSurface=function(e){var t=new OSF.DDA.License(e.get_eToken());e.get_isDialog()?e.ui=new OSF.DDA.UI.ChildUI:e.ui=new OSF.DDA.UI.ParentUI,OSF.DDA.OpenBrowser&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.OpenBrowserWindow]),OSF.DDA.ExecuteFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.ExecuteFeature]),OSF.DDA.QueryFeature&&OSF.DDA.DispIdHost.addAsyncMethods(e.ui,[OSF.DDA.AsyncMethodNames.QueryFeature]),OSF.DDA.Auth&&(e.auth=new OSF.DDA.Auth,OSF.DDA.DispIdHost.addAsyncMethods(e.auth,[OSF.DDA.AsyncMethodNames.GetAccessTokenAsync])),e.application=new OSF.DDA.Application(e),OSF.DDA.DispIdHost.addAsyncMethods(e.application,[OSF.DDA.AsyncMethodNames.CreateDocumentAsync]),OSF.OUtil.finalizeProperties(e.application),OSF._OfficeAppFactory.setContext(new OSF.DDA.Context(e,e.doc,t,null,OSF.DDA.OfficeTheme.getOfficeTheme)),OSF._OfficeAppFactory.setHostFacade(new OSF.DDA.DispIdHost.Facade(OSF.DDA.DispIdHost.getClientDelegateMethods,OSF.DDA.SafeArray.Delegate.ParameterMap));var n=!1;if(e&&e.get_featureGates){var r=e.get_featureGates();r&&r.EnablePublicThemeManager&&"undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.themeManager&&(window.Office.context.themeManager.InitializeAndChangeOnce(),n=!0)}n||(new OSF.DDA.Theming.InternalThemeHandler).InitializeAndChangeOnce()};var OfficeExtension;__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();!function(e){var t;!function(e){e.OfficeRequire=function(){return null}()}(e._Internal||(e._Internal={})),function(e){!function(t){t.Init=function(){return function(){"use strict";function t(e){return"function"===typeof e}var n,r=Array.isArray?Array.isArray:function(e){return"[object Array]"===Object.prototype.toString.call(e)},i=0,o=function(e,t){l[i]=e,l[i+1]=t,2===(i+=2)&&(n?n(f):u())};var a=("undefined"!==typeof window?window:void 0)||{},s=(a.MutationObserver||a.WebKitMutationObserver,"undefined"!==typeof process&&"[object process]"==={}.toString.call(process)),c="undefined"!==typeof Uint8ClampedArray&&"undefined"!==typeof importScripts&&"undefined"!==typeof MessageChannel;var u,l=new Array(1e3);function f(){for(var e=0;e<i;e+=2){(0,l[e])(l[e+1]),l[e]=void 0,l[e+1]=void 0}i=0}function d(){}u=s?function(){var e=process.nextTick,t=process.versions.node.match(/^(?:(\d+)\.)?(?:(\d+)\.)?(\*|\d+)$/);return Array.isArray(t)&&"0"===t[1]&&"10"===t[2]&&(e=window.setImmediate),function(){e(f)}}():c?function(){var e=new MessageChannel;return e.port1.onmessage=f,function(){e.port2.postMessage(0)}}():function(){return function(){setTimeout(f,1)}}();var p=new S;function h(e,n){if(n.constructor===e.constructor)!function(e,t){1===t._state?y(e,t._result):2===t._state?O(e,t._result):v(t,void 0,(function(t){m(e,t)}),(function(t){O(e,t)}))}(e,n);else{var r=function(e){try{return e.then}catch(e){return p.error=e,p}}(n);r===p?O(e,p.error):void 0===r?y(e,n):t(r)?function(e,t,n){o((function(e){var r=!1,i=function(e,t,n,r){try{e.call(t,n,r)}catch(e){return e}}(n,t,(function(n){r||(r=!0,t!==n?m(e,n):y(e,n))}),(function(t){r||(r=!0,O(e,t))}),e._label);!r&&i&&(r=!0,O(e,i))}),e)}(e,n,r):y(e,n)}}function m(e,t){e===t?O(e,function(){return new TypeError("You cannot resolve a promise with itself")}()):!function(e){return"function"===typeof e||"object"===typeof e&&null!==e}(t)?y(e,t):h(e,t)}function g(e){e._onerror&&e._onerror(e._result),b(e)}function y(e,t){void 0===e._state&&(e._result=t,e._state=1,0!==e._subscribers.length&&o(b,e))}function O(e,t){void 0===e._state&&(e._state=2,e._result=t,o(g,e))}function v(e,t,n,r){var i=e._subscribers,a=i.length;e._onerror=null,i[a]=t,i[a+1]=n,i[a+2]=r,0===a&&e._state&&o(b,e)}function b(e){var t=e._subscribers,n=e._state;if(0!==t.length){for(var r,i,o=e._result,a=0;a<t.length;a+=3)r=t[a],i=t[a+n],r?A(n,r,i,o):i(o);e._subscribers.length=0}}function S(){this.error=null}var _=new S;function A(e,n,r,i){var o,a,s,c,u=t(r);if(u){if((o=function(e,t){try{return e(t)}catch(e){return _.error=e,_}}(r,i))===_?(c=!0,a=o.error,o=null):s=!0,n===o)return void O(n,function(){return new TypeError("A promises callback cannot return that same promise.")}())}else o=i,s=!0;void 0!==n._state||(u&&s?m(n,o):c?O(n,a):1===e?y(n,o):2===e&&O(n,o))}function D(e,t){this._instanceConstructor=e,this.promise=new e(d),this._validateInput(t)?(this._input=t,this.length=t.length,this._remaining=t.length,this._init(),0===this.length?y(this.promise,this._result):(this.length=this.length||0,this._enumerate(),0===this._remaining&&y(this.promise,this._result))):O(this.promise,this._validationError())}D.prototype._validateInput=function(e){return r(e)},D.prototype._validationError=function(){return new e.Error("Array Methods must be provided an Array")},D.prototype._init=function(){this._result=new Array(this.length)};var C=D;D.prototype._enumerate=function(){for(var e=this.length,t=this.promise,n=this._input,r=0;void 0===t._state&&r<e;r++)this._eachEntry(n[r],r)},D.prototype._eachEntry=function(e,t){var n=this._instanceConstructor;!function(e){return"object"===typeof e&&null!==e}(e)?(this._remaining--,this._result[t]=e):e.constructor===n&&void 0!==e._state?(e._onerror=null,this._settledAt(e._state,t,e._result)):this._willSettleAt(n.resolve(e),t)},D.prototype._settledAt=function(e,t,n){var r=this.promise;void 0===r._state&&(this._remaining--,2===e?O(r,n):this._result[t]=n),0===this._remaining&&y(r,this._result)},D.prototype._willSettleAt=function(e,t){var n=this;v(e,void 0,(function(e){n._settledAt(1,t,e)}),(function(e){n._settledAt(2,t,e)}))};var P=function(e){return new C(this,e).promise};var F=function(e){var t=new this(d);if(!r(e))return O(t,new TypeError("You must pass an array to race.")),t;var n=e.length;function i(e){m(t,e)}function o(e){O(t,e)}for(var a=0;void 0===t._state&&a<n;a++)v(this.resolve(e[a]),void 0,i,o);return t};var E=function(e){if(e&&"object"===typeof e&&e.constructor===this)return e;var t=new this(d);return m(t,e),t};var I=function(e){var t=new this(d);return O(t,e),t},x=0;var M=T;function T(e){this._id=x++,this._state=void 0,this._result=void 0,this._subscribers=[],d!==e&&(t(e)||function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof T||function(){throw new TypeError("Failed to construct 'Promise': Please use the 'new' operator, this object constructor cannot be called as a function.")}(),function(e,t){try{t((function(t){m(e,t)}),(function(t){O(e,t)}))}catch(t){O(e,t)}}(this,e))}return T.all=P,T.race=F,T.resolve=E,T.reject=I,T._setScheduler=function(e){n=e},T._setAsap=function(e){o=e},T._asap=o,T.prototype={constructor:T,then:function(e,t){var n=this,r=n._state;if(1===r&&!e||2===r&&!t)return this;var i=new this.constructor(d),a=n._result;if(r){var s=arguments[r-1];o((function(){A(r,i,s,a)}))}else v(n,i,e,t);return i},catch:function(e){return this.then(null,e)}},M}.call(this)}}(e.PromiseImpl||(e.PromiseImpl={}))}(e._Internal||(e._Internal={})),function(e){e.OfficePromise=function(){return"undefined"===typeof window&&"function"===typeof Promise?Promise:"undefined"!==typeof window&&window.Promise?function(){var e=window.navigator.userAgent,t=e.indexOf("Edge/");return t>=0&&(e=e.substring(t+5,e.length))<"14.14393"}()?e.PromiseImpl.Init():window.Promise:e.PromiseImpl.Init()}()}(t=e._Internal||(e._Internal={}));var n=t.OfficePromise;e.Promise=n}(OfficeExtension||(OfficeExtension={})),function(e){var t=function(){function e(){}return e.prototype._resolveRequestUrlAndHeaderInfo=function(){return u._createPromiseFromResult(null)},e.prototype._createRequestExecutorOrNull=function(){return null},e.prototype.getEventRegistration=function(e){return null},e}();e.SessionBase=t;var n=function(){function e(){}return e.setCustomSendRequestFunc=function(t){e.s_customSendRequestFunc=t},e.xhrSendRequestFunc=function(e){return u.createPromise((function(t,n){var i=new XMLHttpRequest;if(i.open(e.method,e.url),i.onload=function(){var e={statusCode:i.status,headers:u._parseHttpResponseHeaders(i.getAllResponseHeaders()),body:i.responseText};t(e)},i.onerror=function(){n(new r.RuntimeError({code:o.connectionFailure,httpStatusCode:i.status,message:u._getResourceString(a.connectionFailureWithStatus,i.statusText)}))},e.headers)for(var s in e.headers)i.setRequestHeader(s,e.headers[s]);i.send(u._getRequestBodyText(e))}))},e.fetchSendRequestFunc=function(e){var t=u._getRequestBodyText(e);return""===t&&(t=void 0),fetch(e.url,{method:e.method,headers:e.headers,body:t}).then((function(e){return e.text().then((function(t){var n=e.status,r={};return e.headers.forEach((function(e,t){r[t]=e})),{statusCode:n,headers:r,body:t}}))}))},e.sendRequest=function(t){e.validateAndNormalizeRequest(t);var n=e.s_customSendRequestFunc;return n||(n="undefined"!==typeof fetch?e.fetchSendRequestFunc:e.xhrSendRequestFunc),n(t)},e.setCustomSendLocalDocumentRequestFunc=function(t){e.s_customSendLocalDocumentRequestFunc=t},e.sendLocalDocumentRequest=function(t){return e.validateAndNormalizeRequest(t),(e.s_customSendLocalDocumentRequestFunc||e.officeJsSendLocalDocumentRequestFunc)(t)},e.officeJsSendLocalDocumentRequestFunc=function(e){e=u._validateLocalDocumentRequest(e);var t=u._buildRequestMessageSafeArray(e);return u.createPromise((function(e,n){OSF.DDA.RichApi.executeRichApiRequestAsync(t,(function(t){var n;n="succeeded"==t.status?{statusCode:c.getResponseStatusCode(t),headers:c.getResponseHeaders(t),body:c.getResponseBody(t)}:c.buildHttpResponseFromOfficeJsError(t.error.code,t.error.message),u.log("Response:"),u.log(JSON.stringify(n)),e(n)}))}))},e.validateAndNormalizeRequest=function(e){if(u.isNullOrUndefined(e))throw r.RuntimeError._createInvalidArgError({argumentName:"request"});u.isNullOrEmptyString(e.method)&&(e.method="GET"),e.method=e.method.toUpperCase();var t=!1;if("object"===typeof e.headers&&e.headers[s.testRequestNameHeader]&&(t=!0),!t){var n=l._getCurrentTestNameWithSequenceId();n&&(e.headers||(e.headers={}),e.headers[s.testRequestNameHeader]=n)}},e.logRequest=function(t){if(u._logEnabled){if(u.log("---HTTP Request---"),u.log(t.method+" "+t.url),t.headers)for(var n in t.headers)u.log(n+": "+t.headers[n]);e._logBodyEnabled&&u.log(u._getRequestBodyText(t))}},e.logResponse=function(t){if(u._logEnabled){if(u.log("---HTTP Response---"),u.log(""+t.statusCode),t.headers)for(var n in t.headers)u.log(n+": "+t.headers[n]);e._logBodyEnabled&&u.log(t.body)}},e._logBodyEnabled=!1,e}();e.HttpUtility=n;var r,i=function(){function e(e){var t=this;this.m_bridge=e,this.m_promiseResolver={},this.m_handlers=[],this.m_bridge.onMessageFromHost=function(e){var n=JSON.parse(e);if(3==n.type){var r=n.message;if(r&&r.entries)for(var i=0;i<r.entries.length;i++){var o=r.entries[i];if(Array.isArray(o)){var a={messageCategory:o[0],messageType:o[1],targetId:o[2],message:o[3],id:o[4]};r.entries[i]=a}}}t.dispatchMessage(n)}}return e.init=function(t){if("object"===typeof t&&t){var r=new e(t);e.s_instance=r,n.setCustomSendLocalDocumentRequestFunc((function(t){t=u._validateLocalDocumentRequest(t);var n=0;u.isReadonlyRestRequest(t.method)||(n=1);var i=t.url.indexOf("?");if(i>=0){var o=t.url.substr(i+1),a=u._parseRequestFlagsAndCustomDataFromQueryStringIfAny(o);a.flags>=0&&(n=a.flags)}"string"===typeof t.body&&(t.body=JSON.parse(t.body));var s={id:e.nextId(),type:1,flags:n,message:t};return r.sendMessageToHostAndExpectResponse(s).then((function(e){return e.message}))}));for(var i=0;i<e.s_onInitedHandlers.length;i++)e.s_onInitedHandlers[i](r)}},Object.defineProperty(e,"instance",{get:function(){return e.s_instance},enumerable:!0,configurable:!0}),e.prototype.sendMessageToHost=function(e){this.m_bridge.sendMessageToHost(JSON.stringify(e))},e.prototype.sendMessageToHostAndExpectResponse=function(e){var t=this,n=u.createPromise((function(n,r){t.m_promiseResolver[e.id]=n}));return this.m_bridge.sendMessageToHost(JSON.stringify(e)),n},e.prototype.addHostMessageHandler=function(e){this.m_handlers.push(e)},e.prototype.removeHostMessageHandler=function(e){var t=this.m_handlers.indexOf(e);t>=0&&this.m_handlers.splice(t,1)},e.onInited=function(t){e.s_onInitedHandlers.push(t),e.s_instance&&t(e.s_instance)},e.prototype.dispatchMessage=function(e){if("number"===typeof e.id){var t=this.m_promiseResolver[e.id];if(t)return t(e),void delete this.m_promiseResolver[e.id]}for(var n=0;n<this.m_handlers.length;n++)this.m_handlers[n](e)},e.nextId=function(){return e.s_nextId++},e.s_onInitedHandlers=[],e.s_nextId=1,e}();e.HostBridge=i,"object"===typeof _richApiNativeBridge&&_richApiNativeBridge&&i.init(_richApiNativeBridge),function(e){var t=function(t){function n(e){var r=t.call(this,"string"===typeof e?e:e.message)||this;if(Object.setPrototypeOf(r,n.prototype),r.name="RichApi.Error","string"===typeof e?r.message=e:(r.code=e.code,r.message=e.message,r.traceMessages=e.traceMessages||[],r.innerError=e.innerError||null,r.debugInfo=r._createDebugInfo(e.debugInfo||{}),r.httpStatusCode=e.httpStatusCode,r.data=e.data),u.isNullOrUndefined(r.httpStatusCode)||200===r.httpStatusCode){var i={};i[o.accessDenied]=401,i[o.connectionFailure]=500,i[o.generalException]=500,i[o.invalidArgument]=400,i[o.invalidObjectPath]=400,i[o.invalidOrTimedOutSession]=408,i[o.invalidRequestContext]=400,i[o.timeout]=408,i[o.valueNotLoaded]=400,r.httpStatusCode=i[r.code]}return u.isNullOrUndefined(r.httpStatusCode)&&(r.httpStatusCode=500),r}return __extends(n,t),n.prototype.toString=function(){return this.code+": "+this.message},n.prototype._createDebugInfo=function(t){var n={code:this.code,message:this.message,toString:function(){return JSON.stringify(this)}};for(var r in t)n[r]=t[r];return this.innerError&&(this.innerError instanceof e.RuntimeError?n.innerError=this.innerError.debugInfo:n.innerError=this.innerError),n},n._createInvalidArgError=function(t){return new e.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u.isNullOrEmptyString(t.argumentName)?u._getResourceString(a.invalidArgumentGeneric):u._getResourceString(a.invalidArgument,t.argumentName),debugInfo:t.errorLocation?{errorLocation:t.errorLocation}:{},innerError:t.innerError})},n}(Error);e.RuntimeError=t}(r=e._Internal||(e._Internal={})),e.Error=r.RuntimeError;var o=function(){function e(){}return e.apiNotFound="ApiNotFound",e.accessDenied="AccessDenied",e.generalException="GeneralException",e.activityLimitReached="ActivityLimitReached",e.invalidArgument="InvalidArgument",e.connectionFailure="ConnectionFailure",e.timeout="Timeout",e.invalidOrTimedOutSession="InvalidOrTimedOutSession",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e.requestPayloadSizeLimitExceeded="RequestPayloadSizeLimitExceeded",e.responsePayloadSizeLimitExceeded="ResponsePayloadSizeLimitExceeded",e.writeNotSupportedWhenModalDialogOpen="WriteNotSupportedWhenModalDialogOpen",e}();e.CoreErrorCodes=o;var a=function(){function e(){}return e.apiNotFoundDetails="ApiNotFoundDetails",e.connectionFailureWithStatus="ConnectionFailureWithStatus",e.connectionFailureWithDetails="ConnectionFailureWithDetails",e.invalidArgument="InvalidArgument",e.invalidArgumentGeneric="InvalidArgumentGeneric",e.timeout="Timeout",e.invalidOrTimedOutSessionMessage="InvalidOrTimedOutSessionMessage",e.invalidSheetName="InvalidSheetName",e.invalidObjectPath="InvalidObjectPath",e.invalidRequestContext="InvalidRequestContext",e.valueNotLoaded="ValueNotLoaded",e}();e.CoreResourceStrings=a;var s=function(){function e(){}return e.flags="flags",e.sourceLibHeader="SdkVersion",e.processQuery="ProcessQuery",e.localDocument="http://document.localhost/",e.localDocumentApiPrefix="http://document.localhost/_api/",e.customData="customdata",e.testRequestNameHeader="x-test-request-name",e}();e.CoreConstants=s;var c=function(){function e(){}return e.buildMessageArrayForIRequestExecutor=function(t,n,r,i){var o=JSON.stringify(r.Body);u.log("Request:"),u.log(o);var a={};return u._copyHeaders(r.Headers,a),a[s.sourceLibHeader]=i,e.buildRequestMessageSafeArray(t,n,"POST",s.processQuery,a,o)},e.buildResponseOnSuccess=function(e,t){var n={HttpStatusCode:200,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return n.Body=JSON.parse(e),n.Headers=t,n},e.buildResponseOnError=function(t,n){var r={HttpStatusCode:500,ErrorCode:"",ErrorMessage:"",Headers:null,Body:null};return r.ErrorCode=o.generalException,r.ErrorMessage=n,t==e.OfficeJsErrorCode_ooeNoCapability?(r.ErrorCode=o.accessDenied,r.HttpStatusCode=401):t==e.OfficeJsErrorCode_ooeActivityLimitReached?(r.ErrorCode=o.activityLimitReached,r.HttpStatusCode=429):t==e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession?(r.ErrorCode=o.invalidOrTimedOutSession,r.HttpStatusCode=408,r.ErrorMessage=u._getResourceString(a.invalidOrTimedOutSessionMessage)):t==e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded?(r.ErrorCode=o.requestPayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded?(r.ErrorCode=o.responsePayloadSizeLimitExceeded,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen?(r.ErrorCode=o.writeNotSupportedWhenModalDialogOpen,r.HttpStatusCode=400):t==e.OfficeJsErrorCode_ooeInvalidSheetName&&(r.ErrorCode=o.invalidRequestContext,r.HttpStatusCode=400,r.ErrorMessage=u._getResourceString(a.invalidSheetName)),r},e.buildHttpResponseFromOfficeJsError=function(t,n){var r=500,i={error:{}};return i.error.code=o.generalException,i.error.message=n,t===e.OfficeJsErrorCode_ooeNoCapability?(r=403,i.error.code=o.accessDenied):t===e.OfficeJsErrorCode_ooeActivityLimitReached&&(r=429,i.error.code=o.activityLimitReached),{statusCode:r,headers:{},body:JSON.stringify(i)}},e.buildRequestMessageSafeArray=function(e,t,n,r,i,o){var a=[];if(i)for(var s in i)a.push(s),a.push(i[s]);return[e,n,r,a,o,0,t,"","","","","",""]},e.getResponseBody=function(t){return e.getResponseBodyFromSafeArray(t.value.data)},e.getResponseHeaders=function(t){return e.getResponseHeadersFromSafeArray(t.value.data)},e.getResponseBodyFromSafeArray=function(e){var t=e[2];return"string"===typeof t?t:t.join("")},e.getResponseHeadersFromSafeArray=function(e){var t=e[1];if(!t)return null;for(var n={},r=0;r<t.length-1;r+=2)n[t[r]]=t[r+1];return n},e.getResponseStatusCode=function(t){return e.getResponseStatusCodeFromSafeArray(t.value.data)},e.getResponseStatusCodeFromSafeArray=function(e){return e[0]},e.OfficeJsErrorCode_ooeInvalidOrTimedOutSession=5012,e.OfficeJsErrorCode_ooeActivityLimitReached=5102,e.OfficeJsErrorCode_ooeNoCapability=7e3,e.OfficeJsErrorCode_ooeRequestPayloadSizeLimitExceeded=5103,e.OfficeJsErrorCode_ooeResponsePayloadSizeLimitExceeded=5104,e.OfficeJsErrorCode_ooeWriteNotSupportedWhenModalDialogOpen=5016,e.OfficeJsErrorCode_ooeInvalidSheetName=1014,e}();e.RichApiMessageUtility=c,function(e){e.getPromiseType=function(){if("undefined"!==typeof Promise)return Promise;if("undefined"!==typeof Office&&Office.Promise)return Office.Promise;if("undefined"!==typeof OfficeExtension&&OfficeExtension.Promise)return OfficeExtension.Promise;throw new e.Error("No Promise implementation found")}}(r=e._Internal||(e._Internal={}));var u=function(){function e(){}return e.log=function(t){e._logEnabled&&"undefined"!==typeof console&&console.log&&console.log(t)},e.checkArgumentNull=function(t,n){if(e.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:n})},e.isNullOrUndefined=function(e){return null===e||"undefined"===typeof e},e.isUndefined=function(e){return"undefined"===typeof e},e.isNullOrEmptyString=function(e){return null===e||("undefined"===typeof e||0==e.length)},e.isPlainJsonObject=function(t){if(e.isNullOrUndefined(t))return!1;if("object"!==typeof t)return!1;if("[object Object]"!==Object.prototype.toString.apply(t))return!1;if(t.constructor&&!Object.prototype.hasOwnProperty.call(t,"constructor")&&!Object.prototype.hasOwnProperty.call(t.constructor.prototype,"hasOwnProperty"))return!1;for(var n in t)if(!Object.prototype.hasOwnProperty.call(t,n))return!1;return!0},e.trim=function(e){return e.replace(new RegExp("^\\s+|\\s+$","g"),"")},e.caseInsensitiveCompareString=function(t,n){return e.isNullOrUndefined(t)?e.isNullOrUndefined(n):!e.isNullOrUndefined(n)&&t.toUpperCase()==n.toUpperCase()},e.isReadonlyRestRequest=function(t){return e.caseInsensitiveCompareString(t,"GET")},e._getResourceString=function(t,n){var r;if("undefined"!==typeof window&&window.Strings&&window.Strings.OfficeOM){var i="L_"+t,o=window.Strings.OfficeOM[i];o&&(r=o)}if(r||(r=e.s_resourceStringValues[t]),r||(r=t),!e.isNullOrUndefined(n))if(Array.isArray(n)){var a=n;r=e._formatString(r,a)}else r=r.replace("{0}",n);return r},e._formatString=function(e,t){return e.replace(/\{\d\}/g,(function(e){var n=parseInt(e.substr(1,e.length-2));if(n<t.length)return t[n];throw r.RuntimeError._createInvalidArgError({argumentName:"format"})}))},Object.defineProperty(e,"Promise",{get:function(){return r.getPromiseType()},enumerable:!0,configurable:!0}),e.createPromise=function(t){return new e.Promise(t)},e._createPromiseFromResult=function(t){return e.createPromise((function(e,n){e(t)}))},e._createPromiseFromException=function(t){return e.createPromise((function(e,n){n(t)}))},e._createTimeoutPromise=function(t){return e.createPromise((function(e,n){setTimeout((function(){e(null)}),t)}))},e._createInvalidArgError=function(e){return r.RuntimeError._createInvalidArgError(e)},e._isLocalDocumentUrl=function(t){return e._getLocalDocumentUrlPrefixLength(t)>0},e._getLocalDocumentUrlPrefixLength=function(e){for(var t=["http://document.localhost","https://document.localhost","//document.localhost"],n=e.toLowerCase().trim(),r=0;r<t.length;r++){if(n===t[r])return t[r].length;if(n.substr(0,t[r].length+1)===t[r]+"/")return t[r].length+1}return 0},e._validateLocalDocumentRequest=function(t){var n=e._getLocalDocumentUrlPrefixLength(t.url);if(n<=0)throw r.RuntimeError._createInvalidArgError({argumentName:"request"});var i=t.url.substr(n),o=i.toLowerCase();return"_api"===o?i="":"_api/"===o.substr(0,"_api/".length)&&(i=i.substr("_api/".length)),{method:t.method,url:i,headers:t.headers,body:t.body}},e._parseRequestFlagsAndCustomDataFromQueryStringIfAny=function(e){for(var t={flags:-1,customData:""},n=e.split("&"),r=0;r<n.length;r++){var i=n[r].split("=");if(i[0].toLowerCase()===s.flags){var o=parseInt(i[1]);o&=8191,t.flags=o}else i[0].toLowerCase()===s.customData&&(t.customData=decodeURIComponent(i[1]))}return t},e._getRequestBodyText=function(e){var t="";return"string"===typeof e.body?t=e.body:e.body&&"object"===typeof e.body&&(t=JSON.stringify(e.body)),t},e._parseResponseBody=function(t){if("string"===typeof t.body){var n=e.trim(t.body);return JSON.parse(n)}return t.body},e._buildRequestMessageSafeArray=function(t){var n=0;e.isReadonlyRestRequest(t.method)||(n=1);var r="";if(t.url.substr(0,s.processQuery.length).toLowerCase()===s.processQuery.toLowerCase()){var i=t.url.indexOf("?");if(i>0){var o=t.url.substr(i+1),a=e._parseRequestFlagsAndCustomDataFromQueryStringIfAny(o);a.flags>=0&&(n=a.flags),r=a.customData}}return c.buildRequestMessageSafeArray(r,n,t.method,t.url,t.headers,e._getRequestBodyText(t))},e._parseHttpResponseHeaders=function(t){var n={};if(!e.isNullOrEmptyString(t))for(var r=new RegExp("\r?\n"),i=t.split(r),o=0;o<i.length;o++){var a=i[o];if(null!=a){var s=a.indexOf(":");if(s>0){var c=a.substr(0,s),u=a.substr(s+1);c=e.trim(c),u=e.trim(u),n[c.toUpperCase()]=u}}}return n},e._parseErrorResponse=function(t){var n=e._parseErrorResponseBody(t),r=t.statusCode.toString();if(e.isNullOrUndefined(n)||"object"!==typeof n||!n.error)return e._createDefaultErrorResponse(r);var i=n.error,o=i.innerError;return o&&o.code?e._createErrorResponse(o.code,r,o.message):i.code?e._createErrorResponse(i.code,r,i.message):e._createDefaultErrorResponse(r)},e._parseErrorResponseBody=function(t){if(e.isPlainJsonObject(t.body))return t.body;if(!e.isNullOrEmptyString(t.body)){var n=e.trim(t.body);try{return JSON.parse(n)}catch(t){e.log("Error when parse "+n)}}},e._createDefaultErrorResponse=function(t){return{errorCode:o.connectionFailure,errorMessage:e._getResourceString(a.connectionFailureWithStatus,t)}},e._createErrorResponse=function(t,n,r){return{errorCode:t,errorMessage:e._getResourceString(a.connectionFailureWithDetails,[n,t,r])}},e._copyHeaders=function(e,t){if(e&&t)for(var n in e)t[n]=e[n]},e.addResourceStringValues=function(t){for(var n in t)e.s_resourceStringValues[n]=t[n]},e._logEnabled=!1,e.s_resourceStringValues={ApiNotFoundDetails:"The method or property {0} is part of the {1} requirement set, which is not available in your version of {2}.",ConnectionFailureWithStatus:"The request failed with status code of {0}.",ConnectionFailureWithDetails:"The request failed with status code of {0}, error code {1} and the following error message: {2}",InvalidArgument:"The argument '{0}' doesn't work for this situation, is missing, or isn't in the right format.",InvalidObjectPath:'The object path \'{0}\' isn\'t working for what you\'re trying to do. If you\'re using the object across multiple "context.sync" calls and outside the sequential execution of a ".run" batch, please use the "context.trackedObjects.add()" and "context.trackedObjects.remove()" methods to manage the object\'s lifetime.',InvalidRequestContext:"Cannot use the object across different request contexts.",Timeout:"The operation has timed out.",ValueNotLoaded:'The value of the result object has not been loaded yet. Before reading the value property, call "context.sync()" on the associated request context.'},e}();e.CoreUtility=u;var l=function(){function e(){}return e.setMock=function(t){e.s_isMock=t},e.isMock=function(){return e.s_isMock},e._setCurrentTestName=function(t){e.s_currentTestName=t,e.s_currentTestSequenceId=0},e._getCurrentTestNameWithSequenceId=function(){return e.s_currentTestName?(e.s_currentTestSequenceId++,e.s_currentTestName+"."+e.s_currentTestSequenceId):null},e}();e.TestUtility=l,e._internalConfig={showDisposeInfoInDebugInfo:!1,showInternalApiInDebugInfo:!1,enableEarlyDispose:!0,alwaysPolyfillClientObjectUpdateMethod:!1,alwaysPolyfillClientObjectRetrieveMethod:!1,enableConcurrentFlag:!0,enableUndoableFlag:!0,appendTypeNameToObjectPathInfo:!1,enablePreviewExecution:!1},e.config={extendedErrorLogging:!1};var f=function(){function t(){}return t.createSetPropertyAction=function(t,n,r,i,o){_.validateObjectPath(n);var a={Id:t._nextId(),ActionType:4,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},s=[i],c=_.setMethodArguments(t,a.ArgumentInfo,s);_.validateReferencedObjectPaths(c);var u=new p(a,0,o);if(u.referencedObjectPath=n._objectPath,u.referencedArgumentObjectPaths=c,e._internalConfig.enablePreviewExecution&&0!==(16&o)){var l={Id:t._nextId(),ActionType:4,Name:r,ObjectId:"",ObjectType:"",Arguments:[i]};n._addPreviewExecutionAction(l)}return n._addAction(u)},t.createQueryAction=function(e,t,n,r){_.validateObjectPath(t);var i={Id:e._nextId(),ActionType:2,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},o=new p(i,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o,r)},t.createQueryAsJsonAction=function(e,t,n,r){_.validateObjectPath(t);var i={Id:e._nextId(),ActionType:7,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,QueryInfo:n},o=new p(i,1,4);return o.referencedObjectPath=t._objectPath,t._addAction(o,r)},t.createUpdateAction=function(e,t,n){_.validateObjectPath(t);var r={Id:e._nextId(),ActionType:9,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},i=new p(r,0,0);return i.referencedObjectPath=t._objectPath,t._addAction(i)},t}();e.CommonActionFactory=f;var d=function(){function t(e,t){this.m_contextBase=e,this.m_objectPath=t}return Object.defineProperty(t.prototype,"_objectPath",{get:function(){return this.m_objectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_context",{get:function(){return this.m_contextBase},enumerable:!0,configurable:!0}),t.prototype._addAction=function(e,t){var n=this;return void 0===t&&(t=null),u.createPromise((function(r,i){n._context._addServiceApiAction(e,t,r,i)}))},t.prototype._addPreviewExecutionAction=function(e){},t.prototype._retrieve=function(t,n){var r=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;r||(r=!_.isSetSupported("RichApiRuntime","1.1"));var i=m._parseQueryOption(t);return r?f.createQueryAction(this._context,this,i,n):f.createQueryAsJsonAction(this._context,this,i,n)},t.prototype._recursivelyUpdate=function(t){var n=e._internalConfig.alwaysPolyfillClientObjectUpdateMethod;n||(n=!_.isSetSupported("RichApiRuntime","1.2"));try{var i=this[S.scalarPropertyNames];i||(i=[]);var s=this[S.scalarPropertyUpdateable];if(!s){s=[];for(var c=0;c<i.length;c++)s.push(!1)}var l=this[S.navigationPropertyNames];l||(l=[]);var d={},p={},h=0;for(var m in t){var g=i.indexOf(m);if(g>=0){if(!s[g])throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(A.attemptingToSetReadOnlyProperty,m),debugInfo:{errorLocation:m}});d[m]=t[m],++h}else{if(!(l.indexOf(m)>=0))throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(A.propertyDoesNotExist,m),debugInfo:{errorLocation:m}});p[m]=t[m]}}if(h>0)if(n)for(c=0;c<i.length;c++){var y=d[m=i[c]];_.isUndefined(y)||f.createSetPropertyAction(this._context,this,m,y)}else f.createUpdateAction(this._context,this,d);for(var m in p){var O=this[m],v=p[m];O._recursivelyUpdate(v)}}catch(e){throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".update"},innerError:e})}},t}();e.ClientObjectBase=d;var p=function(){function e(e,t,n){this.m_actionInfo=e,this.m_operationType=t,this.m_flags=n}return Object.defineProperty(e.prototype,"actionInfo",{get:function(){return this.m_actionInfo},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),e}();e.Action=p;var h=function(){function t(e,t,n,r,i,o){this.m_objectPathInfo=e,this.m_parentObjectPath=t,this.m_isCollection=n,this.m_isInvalidAfterRequest=r,this.m_isValid=!0,this.m_operationType=i,this.m_flags=o}return Object.defineProperty(t.prototype,"id",{get:function(){var e=this.m_objectPathInfo.ArgumentInfo;if(e){var t=e.Arguments;if(t)return t[0]}},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parent",{get:function(){var e=this.m_parentObjectPath;if(e)return e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentId",{get:function(){return this.parent?this.parent.id:void 0},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"objectPathInfo",{get:function(){return this.m_objectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"operationType",{get:function(){return this.m_operationType},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"flags",{get:function(){return this.m_flags},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isCollection",{get:function(){return this.m_isCollection},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isInvalidAfterRequest",{get:function(){return this.m_isInvalidAfterRequest},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"parentObjectPath",{get:function(){return this.m_parentObjectPath},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"argumentObjectPaths",{get:function(){return this.m_argumentObjectPaths},set:function(e){this.m_argumentObjectPaths=e},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isValid",{get:function(){return this.m_isValid},set:function(e){this.m_isValid=e,!e&&6===this.m_objectPathInfo.ObjectPathType&&this.m_savedObjectPathInfo&&(t.copyObjectPathInfo(this.m_savedObjectPathInfo.pathInfo,this.m_objectPathInfo),this.m_parentObjectPath=this.m_savedObjectPathInfo.parent,this.m_isValid=!0,this.m_savedObjectPathInfo=null)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"originalObjectPathInfo",{get:function(){return this.m_originalObjectPathInfo},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"getByIdMethodName",{get:function(){return this.m_getByIdMethodName},set:function(e){this.m_getByIdMethodName=e},enumerable:!0,configurable:!0}),t.prototype._updateAsNullObject=function(){this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=7,this.m_objectPathInfo.Name="",this.m_parentObjectPath=null},t.prototype.saveOriginalObjectPathInfo=function(){e.config.extendedErrorLogging&&!this.m_originalObjectPathInfo&&(this.m_originalObjectPathInfo={},t.copyObjectPathInfo(this.m_objectPathInfo,this.m_originalObjectPathInfo))},t.prototype.updateUsingObjectData=function(e,n){var r=e[S.referenceId];if(!u.isNullOrEmptyString(r)){if(!this.m_savedObjectPathInfo&&!this.isInvalidAfterRequest&&t.isRestorableObjectPath(this.m_objectPathInfo.ObjectPathType)){var i={};t.copyObjectPathInfo(this.m_objectPathInfo,i),this.m_savedObjectPathInfo={pathInfo:i,parent:this.m_parentObjectPath}}return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_objectPathInfo.ObjectPathType=6,this.m_objectPathInfo.Name=r,delete this.m_objectPathInfo.ParentObjectPathId,void(this.m_parentObjectPath=null)}if(n){var o=n[S.collectionPropertyPath];if(!u.isNullOrEmptyString(o)&&n.context){var a=_.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!u.isNullOrUndefined(a)){for(var s=o.split("."),c=n.context[s[0]],l=1;l<s.length;l++)c=c[s[l]];return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),this.m_parentObjectPath=c._objectPath,this.m_objectPathInfo.ParentObjectPathId=this.m_parentObjectPath.objectPathInfo.Id,this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name="",void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}}}var f=this.parentObjectPath&&this.parentObjectPath.isCollection,d=this.getByIdMethodName;if(f||!u.isNullOrEmptyString(d)){a=_.tryGetObjectIdFromLoadOrRetrieveResult(e);if(!u.isNullOrUndefined(a))return this.saveOriginalObjectPathInfo(),this.resetForUpdateUsingObjectData(),u.isNullOrEmptyString(d)?(this.m_objectPathInfo.ObjectPathType=5,this.m_objectPathInfo.Name=""):(this.m_objectPathInfo.ObjectPathType=3,this.m_objectPathInfo.Name=d),void(this.m_objectPathInfo.ArgumentInfo.Arguments=[a])}},t.prototype.resetForUpdateUsingObjectData=function(){this.m_isInvalidAfterRequest=!1,this.m_isValid=!0,this.m_operationType=1,this.m_flags=4,this.m_objectPathInfo.ArgumentInfo={},this.m_argumentObjectPaths=null,this.m_getByIdMethodName=null},t.isRestorableObjectPath=function(e){return 1===e||5===e||3===e||4===e},t.copyObjectPathInfo=function(e,t){t.Id=e.Id,t.ArgumentInfo=e.ArgumentInfo,t.Name=e.Name,t.ObjectPathType=e.ObjectPathType,t.ParentObjectPathId=e.ParentObjectPathId},t}();e.ObjectPath=h;var m=function(){function e(){this.m_nextId=0}return e.prototype._nextId=function(){return++this.m_nextId},e.prototype._addServiceApiAction=function(e,t,n,r){this.m_serviceApiQueue||(this.m_serviceApiQueue=new v(this)),this.m_serviceApiQueue.add(e,t,n,r)},e._parseQueryOption=function(t){var n={};if("string"===typeof t){var i=t;n.Select=_._parseSelectExpand(i)}else if(Array.isArray(t))n.Select=t;else if("object"===typeof t){var o=t;if(e.isLoadOption(o)){if("string"===typeof o.select)n.Select=_._parseSelectExpand(o.select);else if(Array.isArray(o.select))n.Select=o.select;else if(!_.isNullOrUndefined(o.select))throw r.RuntimeError._createInvalidArgError({argumentName:"option.select"});if("string"===typeof o.expand)n.Expand=_._parseSelectExpand(o.expand);else if(Array.isArray(o.expand))n.Expand=o.expand;else if(!_.isNullOrUndefined(o.expand))throw r.RuntimeError._createInvalidArgError({argumentName:"option.expand"});if("number"===typeof o.top)n.Top=o.top;else if(!_.isNullOrUndefined(o.top))throw r.RuntimeError._createInvalidArgError({argumentName:"option.top"});if("number"===typeof o.skip)n.Skip=o.skip;else if(!_.isNullOrUndefined(o.skip))throw r.RuntimeError._createInvalidArgError({argumentName:"option.skip"})}else n=e.parseStrictLoadOption(t)}else if(!_.isNullOrUndefined(t))throw r.RuntimeError._createInvalidArgError({argumentName:"option"});return n},e.isLoadOption=function(e){if(!_.isUndefined(e.select)&&("string"===typeof e.select||Array.isArray(e.select)))return!0;if(!_.isUndefined(e.expand)&&("string"===typeof e.expand||Array.isArray(e.expand)))return!0;if(!_.isUndefined(e.top)&&"number"===typeof e.top)return!0;if(!_.isUndefined(e.skip)&&"number"===typeof e.skip)return!0;for(var t in e)return!1;return!0},e.parseStrictLoadOption=function(t){var n={Select:[]};return e.parseStrictLoadOptionHelper(n,"","option",t),n},e.combineQueryPath=function(e,t,n){return 0===e.length?t:e+n+t},e.parseStrictLoadOptionHelper=function(t,n,i,o){for(var a in o){var s=o[a];if("$all"===a){if("boolean"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(i,a,".")});s&&t.Select.push(e.combineQueryPath(n,"*","/"))}else if("$top"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(i,a,".")});t.Top=s}else if("$skip"===a){if("number"!==typeof s||n.length>0)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(i,a,".")});t.Skip=s}else if("boolean"===typeof s)s&&t.Select.push(e.combineQueryPath(n,a,"/"));else{if("object"!==typeof s)throw r.RuntimeError._createInvalidArgError({argumentName:e.combineQueryPath(i,a,".")});e.parseStrictLoadOptionHelper(t,e.combineQueryPath(n,a,"/"),e.combineQueryPath(i,a,"."),s)}}},e}();e.ClientRequestContextBase=m;var g=function(){function e(e){this.m_objectPath=e}return e.prototype._handleResult=function(e){u.isNullOrUndefined(e)?this.m_objectPath._updateAsNullObject():this.m_objectPath.updateUsingObjectData(e,null)},e}(),y=function(){function t(e){this.m_contextBase=e,this.m_actions=[],this.m_actionResultHandler={},this.m_referencedObjectPaths={},this.m_instantiatedObjectPaths={},this.m_preSyncPromises=[],this.m_previewExecutionActions=[]}return t.prototype.addAction=function(e){this.m_actions.push(e),1==e.actionInfo.ActionType&&(this.m_instantiatedObjectPaths[e.actionInfo.ObjectPathId]=e)},t.prototype.addPreviewExecutionAction=function(e){this.m_previewExecutionActions.push(e)},Object.defineProperty(t.prototype,"hasActions",{get:function(){return this.m_actions.length>0},enumerable:!0,configurable:!0}),t.prototype._getLastAction=function(){return this.m_actions[this.m_actions.length-1]},t.prototype.ensureInstantiateObjectPath=function(e){if(e){if(this.m_instantiatedObjectPaths[e.objectPathInfo.Id])return;if(this.ensureInstantiateObjectPath(e.parentObjectPath),this.ensureInstantiateObjectPaths(e.argumentObjectPaths),!this.m_instantiatedObjectPaths[e.objectPathInfo.Id]){var t={Id:this.m_contextBase._nextId(),ActionType:1,Name:"",ObjectPathId:e.objectPathInfo.Id},n=new p(t,1,4);n.referencedObjectPath=e,this.addReferencedObjectPath(e),this.addAction(n);var r=new g(e);this.addActionResultHandler(n,r)}}},t.prototype.ensureInstantiateObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.ensureInstantiateObjectPath(e[t])},t.prototype.addReferencedObjectPath=function(e){if(e&&!this.m_referencedObjectPaths[e.objectPathInfo.Id]){if(!e.isValid)throw new r.RuntimeError({code:o.invalidObjectPath,httpStatusCode:400,message:u._getResourceString(a.invalidObjectPath,_.getObjectPathExpression(e)),debugInfo:{errorLocation:_.getObjectPathExpression(e)}});for(;e;)this.m_referencedObjectPaths[e.objectPathInfo.Id]=e,3==e.objectPathInfo.ObjectPathType&&this.addReferencedObjectPaths(e.argumentObjectPaths),e=e.parentObjectPath}},t.prototype.addReferencedObjectPaths=function(e){if(e)for(var t=0;t<e.length;t++)this.addReferencedObjectPath(e[t])},t.prototype.addActionResultHandler=function(e,t){this.m_actionResultHandler[e.actionInfo.Id]=t},t.prototype.aggregrateRequestFlags=function(e,t,n){return 0===t&&(e|=1,0===(2&n)&&(e&=-17),0===(8&n)&&(e&=-257),e&=-5),1&n&&(e|=2),0===(4&n)&&(e&=-5),e},t.prototype.finallyNormalizeFlags=function(t){return 0===(1&t)&&(t&=-17,t&=-257),e._internalConfig.enableConcurrentFlag||(t&=-5),e._internalConfig.enableUndoableFlag||(t&=-17),_.isSetSupported("RichApiRuntimeFlag","1.1")||(t&=-5,t&=-17),_.isSetSupported("RichApiRuntimeFlag","1.2")||(t&=-257),"number"===typeof this.m_flagsForTesting&&(t=this.m_flagsForTesting),t},t.prototype.buildRequestMessageBodyAndRequestFlags=function(){e._internalConfig.enableEarlyDispose&&t._calculateLastUsedObjectPathIds(this.m_actions);var n=276,r={};for(var i in this.m_referencedObjectPaths)n=this.aggregrateRequestFlags(n,this.m_referencedObjectPaths[i].operationType,this.m_referencedObjectPaths[i].flags),r[i]=this.m_referencedObjectPaths[i].objectPathInfo;for(var o=[],a=!1,s=0;s<this.m_actions.length;s++){var c=this.m_actions[s];3===c.actionInfo.ActionType&&c.actionInfo.Name===S.keepReference&&(a=!0),n=this.aggregrateRequestFlags(n,c.operationType,c.flags),o.push(c.actionInfo)}n=this.finallyNormalizeFlags(n);var u={AutoKeepReference:this.m_contextBase._autoCleanup&&a,Actions:o,ObjectPaths:r};return this.m_previewExecutionActions.length>0&&(u.PreviewExecutionActions=this.m_previewExecutionActions,n|=4096),{body:u,flags:n}},t.prototype.processResponse=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t],r=this.m_actionResultHandler[n.ActionId];r&&r._handleResult(n.Value)}},t.prototype.invalidatePendingInvalidObjectPaths=function(){for(var e in this.m_referencedObjectPaths)this.m_referencedObjectPaths[e].isInvalidAfterRequest&&(this.m_referencedObjectPaths[e].isValid=!1)},t.prototype._addPreSyncPromise=function(e){this.m_preSyncPromises.push(e)},Object.defineProperty(t.prototype,"_preSyncPromises",{get:function(){return this.m_preSyncPromises},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_actions",{get:function(){return this.m_actions},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_objectPaths",{get:function(){return this.m_referencedObjectPaths},enumerable:!0,configurable:!0}),t.prototype._removeKeepReferenceAction=function(e){for(var t=this.m_actions.length-1;t>=0;t--){var n=this.m_actions[t].actionInfo;if(n.ObjectPathId===e&&3===n.ActionType&&n.Name===S.keepReference){this.m_actions.splice(t,1);break}}},t._updateLastUsedActionIdOfObjectPathId=function(e,n,r){for(;n;){if(e[n.objectPathInfo.Id])return;e[n.objectPathInfo.Id]=r;var i=n.argumentObjectPaths;if(i)for(var o=i.length,a=0;a<o;a++)t._updateLastUsedActionIdOfObjectPathId(e,i[a],r);n=n.parentObjectPath}},t._calculateLastUsedObjectPathIds=function(e){for(var n={},r=e.length,i=r-1;i>=0;--i){var o=(d=e[i]).actionInfo.Id;d.referencedObjectPath&&t._updateLastUsedActionIdOfObjectPathId(n,d.referencedObjectPath,o);var a=d.referencedArgumentObjectPaths;if(a)for(var s=a.length,c=0;c<s;c++)t._updateLastUsedActionIdOfObjectPathId(n,a[c],o)}var u={};for(var l in n){var f=u[o=n[l]];f||(f=[],u[o]=f),f.push(parseInt(l))}for(i=0;i<r;i++){var d,p=u[(d=e[i]).actionInfo.Id];p&&p.length>0?d.actionInfo.L=p:d.actionInfo.L&&delete d.actionInfo.L}},t}();e.ClientRequestBase=y;var O=function(){function e(e){this.m_type=e}return Object.defineProperty(e.prototype,"value",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:o.valueNotLoaded,httpStatusCode:400,message:u._getResourceString(a.valueNotLoaded),debugInfo:{errorLocation:"clientResult.value"}});return this.m_value},enumerable:!0,configurable:!0}),e.prototype._handleResult=function(e){this.m_isLoaded=!0,"object"===typeof e&&e&&e._IsNull||(1===this.m_type?this.m_value=_.adjustToDateTime(e):this.m_value=e)},e}();e.ClientResult=O;var v=function(){function e(e){this.m_context=e,this.m_actions=[]}return e.prototype.add=function(e,t,n,r){var i=this;this.m_actions.push({action:e,resultHandler:t,resolve:n,reject:r}),1===this.m_actions.length&&setTimeout((function(){return i.processActions()}),0)},e.prototype.processActions=function(){var e=this;if(0!==this.m_actions.length){var t=this.m_actions;this.m_actions=[];for(var n=new y(this.m_context),r=0;r<t.length;r++){var i=t[r];n.ensureInstantiateObjectPath(i.action.referencedObjectPath),n.ensureInstantiateObjectPaths(i.action.referencedArgumentObjectPaths),n.addAction(i.action),n.addReferencedObjectPath(i.action.referencedObjectPath),n.addReferencedObjectPaths(i.action.referencedArgumentObjectPaths)}var o=n.buildRequestMessageBodyAndRequestFlags(),a=o.body,c=o.flags,l={Url:s.localDocumentApiPrefix,Headers:null,Body:a};u.log("Request:"),u.log(JSON.stringify(a)),(new b).executeAsync(this.m_context._customData,c,l).then((function(r){e.processResponse(n,t,r)})).catch((function(e){for(var n=0;n<t.length;n++){t[n].reject(e)}}))}},e.prototype.processResponse=function(e,t,n){var r=this.getErrorFromResponse(n),i=null;n.Body.Results?i=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(i=n.Body.ProcessedResults.Results),i||(i=[]),this.processActionResults(e,t,i,r)},e.prototype.getErrorFromResponse=function(e){return u.isNullOrEmptyString(e.ErrorCode)?e.Body&&e.Body.Error?new r.RuntimeError({code:e.Body.Error.Code,httpStatusCode:e.Body.Error.HttpStatusCode,message:e.Body.Error.Message}):null:new r.RuntimeError({code:e.ErrorCode,httpStatusCode:e.HttpStatusCode,message:e.ErrorMessage})},e.prototype.processActionResults=function(e,t,n,r){e.processResponse(n);for(var i=0;i<t.length;i++){for(var o=t[i],a=o.action.actionInfo.Id,s=!1,c=0;c<n.length;c++)if(a==n[c].ActionId){var u=n[c].Value;o.resultHandler&&(o.resultHandler._handleResult(u),u=o.resultHandler.value),o.resolve&&o.resolve(u),s=!0;break}!s&&o.reject&&(r?o.reject(r):o.reject("No response for the action."))}},e}(),b=function(){function e(){}return e.prototype.getRequestUrl=function(e,t){return"/"!=e.charAt(e.length-1)&&(e+="/"),e=(e+=s.processQuery)+"?"+s.flags+"="+t.toString()},e.prototype.executeAsync=function(t,r,i){var o={method:"POST",url:this.getRequestUrl(i.Url,r),headers:{},body:i.Body};if(o.headers[s.sourceLibHeader]=e.SourceLibHeaderValue,o.headers["CONTENT-TYPE"]="application/json",i.Headers)for(var a in i.Headers)o.headers[a]=i.Headers[a];return(u._isLocalDocumentUrl(o.url)?n.sendLocalDocumentRequest:n.sendRequest)(o).then((function(e){var t;if(200===e.statusCode)t={HttpStatusCode:e.statusCode,ErrorCode:null,ErrorMessage:null,Headers:e.headers,Body:u._parseResponseBody(e)};else{u.log("Error Response:"+e.body);var n=u._parseErrorResponse(e);t={HttpStatusCode:e.statusCode,ErrorCode:n.errorCode,ErrorMessage:n.errorMessage,Headers:e.headers,Body:null,RawErrorResponseBody:u._parseErrorResponseBody(e)}}return t}))},e.SourceLibHeaderValue="officejs-rest",e}();e.HttpRequestExecutor=b;var S=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.collectionPropertyPath="_collectionPropertyPath",t.id="Id",t.idLowerCase="id",t.idPrivate="_Id",t.keepReference="_KeepReference",t.objectPathIdPrivate="_ObjectPathId",t.referenceId="_ReferenceId",t.items="_Items",t.itemsLowerCase="items",t.scalarPropertyNames="_scalarPropertyNames",t.scalarPropertyOriginalNames="_scalarPropertyOriginalNames",t.navigationPropertyNames="_navigationPropertyNames",t.scalarPropertyUpdateable="_scalarPropertyUpdateable",t.previewExecutionObjectId="_previewExecutionObjectId",t}(s);e.CommonConstants=S;var _=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.validateObjectPath=function(e){for(var n=e._objectPath;n;){if(!n.isValid)throw new r.RuntimeError({code:o.invalidObjectPath,httpStatusCode:400,message:u._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(n)),debugInfo:{errorLocation:t.getObjectPathExpression(n)}});n=n.parentObjectPath}},t.validateReferencedObjectPaths=function(e){if(e)for(var n=0;n<e.length;n++)for(var i=e[n];i;){if(!i.isValid)throw new r.RuntimeError({code:o.invalidObjectPath,httpStatusCode:400,message:u._getResourceString(a.invalidObjectPath,t.getObjectPathExpression(i))});i=i.parentObjectPath}},t._toCamelLowerCase=function(e){if(u.isNullOrEmptyString(e))return e;for(var t=0;t<e.length&&e.charCodeAt(t)>=65&&e.charCodeAt(t)<=90;)t++;return t<e.length?e.substr(0,t).toLowerCase()+e.substr(t):e.toLowerCase()},t.adjustToDateTime=function(e){if(u.isNullOrUndefined(e))return null;if("string"===typeof e)return new Date(e);if(Array.isArray(e)){for(var n=e,r=0;r<n.length;r++)n[r]=t.adjustToDateTime(n[r]);return n}throw u._createInvalidArgError({argumentName:"date"})},t.tryGetObjectIdFromLoadOrRetrieveResult=function(e){var t=e[S.id];return u.isNullOrUndefined(t)&&(t=e[S.idLowerCase]),u.isNullOrUndefined(t)&&(t=e[S.idPrivate]),t},t.getObjectPathExpression=function(e){for(var n="";e;){switch(e.objectPathInfo.ObjectPathType){case 1:n=n;break;case 2:n="new()"+(n.length>0?".":"")+n;break;case 3:n=t.normalizeName(e.objectPathInfo.Name)+"()"+(n.length>0?".":"")+n;break;case 4:n=t.normalizeName(e.objectPathInfo.Name)+(n.length>0?".":"")+n;break;case 5:n="getItem()"+(n.length>0?".":"")+n;break;case 6:n="_reference()"+(n.length>0?".":"")+n}e=e.parentObjectPath}return n},t.setMethodArguments=function(e,n,r){if(u.isNullOrUndefined(r))return null;var i=new Array,o=new Array,a=t.collectObjectPathInfos(e,r,i,o);return n.Arguments=r,a&&(n.ReferencedObjectPathIds=o),i},t.validateContext=function(e,t){if(e&&t&&t._context!==e)throw new r.RuntimeError({code:o.invalidRequestContext,httpStatusCode:400,message:u._getResourceString(a.invalidRequestContext)})},t.isSetSupported=function(e,n){return"function"===typeof t.isSetSupportedOverride?t.isSetSupportedOverride(e,n):!("undefined"!==typeof window&&window.Office&&window.Office.context&&window.Office.context.requirements)||window.Office.context.requirements.isSetSupported(e,n)},t.throwIfApiNotSupported=function(e,n,i,s){if(t._doApiNotSupportedCheck&&!t.isSetSupported(n,i)){var c=u._getResourceString(a.apiNotFoundDetails,[e,n+" "+i,s]);throw new r.RuntimeError({code:o.apiNotFound,httpStatusCode:404,message:c,debugInfo:{errorLocation:e}})}},t.calculateApiFlags=function(e,n,r){var i=window&&window.location&&window.location.href&&-1!==window.location.href.indexOf("eed0a086-3498-4f91-a377-1e0265ecc0cc");return("function"===typeof t.isSetSupportedOverride?t.isSetSupportedOverride(n,r):!i&&t.isSetSupported(n,r))||(e&=-3),e},t._parseSelectExpand=function(e){var t=[];if(!u.isNullOrEmptyString(e))for(var n=e.split(","),r=0;r<n.length;r++){var i=n[r];(i=o(i.trim())).length>0&&t.push(i)}return t;function o(e){var t=e.toLowerCase();if("items"===t||"items/"===t)return"*";return("items/"===t.substr(0,6)||"items."===t.substr(0,6))&&(e=e.substr(6)),e.replace(new RegExp("[/.]items[/.]","gi"),"/")}},t.changePropertyNameToCamelLowerCase=function(e){if(Array.isArray(e)){for(var n=[],r=0;r<e.length;r++)n.push(this.changePropertyNameToCamelLowerCase(e[r]));return n}if("object"===typeof e&&null!==e){n={};for(var i in e){var o=e[i];if(i===S.items){(n={})[S.itemsLowerCase]=this.changePropertyNameToCamelLowerCase(o);break}n[t._toCamelLowerCase(i)]=this.changePropertyNameToCamelLowerCase(o)}return n}return e},t.purifyJson=function(e){if(Array.isArray(e)){for(var t=[],n=0;n<e.length;n++)t.push(this.purifyJson(e[n]));return t}if("object"===typeof e&&null!==e){t={};for(var r in e)if(95!==r.charCodeAt(0)){var i=e[r];"object"===typeof i&&null!==i&&Array.isArray(i.items)&&(i=i.items),t[r]=this.purifyJson(i)}return t}return e},t.collectObjectPathInfos=function(e,n,r,i){for(var o=!1,a=0;a<n.length;a++)if(n[a]instanceof d){var s=n[a];t.validateContext(e,s),n[a]=s._objectPath.objectPathInfo.Id,i.push(s._objectPath.objectPathInfo.Id),r.push(s._objectPath),o=!0}else if(Array.isArray(n[a])){var c=new Array;t.collectObjectPathInfos(e,n[a],r,c)?(i.push(c),o=!0):i.push(0)}else u.isPlainJsonObject(n[a])?(i.push(0),t.replaceClientObjectPropertiesWithObjectPathIds(n[a],r)):i.push(0);return o},t.replaceClientObjectPropertiesWithObjectPathIds=function(e,n){var r,i;for(var o in e){var a=e[o];if(a instanceof d)n.push(a._objectPath),e[o]=((r={})[S.objectPathIdPrivate]=a._objectPath.objectPathInfo.Id,r);else if(Array.isArray(a))for(var s=0;s<a.length;s++)if(a[s]instanceof d){var c=a[s];n.push(c._objectPath),a[s]=((i={})[S.objectPathIdPrivate]=c._objectPath.objectPathInfo.Id,i)}else u.isPlainJsonObject(a[s])&&t.replaceClientObjectPropertiesWithObjectPathIds(a[s],n);else u.isPlainJsonObject(a)&&t.replaceClientObjectPropertiesWithObjectPathIds(a,n)}},t.normalizeName=function(e){return e.substr(0,1).toLowerCase()+e.substr(1)},t._doApiNotSupportedCheck=!1,t}(u);e.CommonUtility=_;var A=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyDoesNotExist="PropertyDoesNotExist",t.attemptingToSetReadOnlyProperty="AttemptingToSetReadOnlyProperty",t}(a);e.CommonResourceStrings=A;var D=function(e){function t(t){var n=e.call(this)||this;return n.m_shouldPolyfill=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.m_shouldPolyfill&&(this.m_value=_.changePropertyNameToCamelLowerCase(this.m_value)),this.m_value=this.removeItemNodes(this.m_value)},t.prototype.removeItemNodes=function(e){return"object"===typeof e&&null!==e&&e[S.itemsLowerCase]&&(e=e[S.itemsLowerCase]),_.purifyJson(e)},t}(O);e.ClientRetrieveResult=D;var C=function(){function e(e){this.callback=e}return e.prototype._handleResult=function(e){this.callback&&this.callback()},e}(),P=function(e){function t(t){var n=e.call(this)||this;return n.callback=t,n}return __extends(t,e),t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),this.callback()},t}(O);e.ClientResultCallback=P;var F=function(){function t(){}return t.invokeMethod=function(e,t,n,r,i,o){return void 0===n&&(n=0),void 0===r&&(r=[]),void 0===i&&(i=0),void 0===o&&(o=0),u.createPromise((function(o,a){var s=new O,c={Id:e._context._nextId(),ActionType:3,Name:t,ObjectPathId:e._objectPath.objectPathInfo.Id,ArgumentInfo:{}},u=_.setMethodArguments(e._context,c.ArgumentInfo,r),l=new p(c,n,i);l.referencedObjectPath=e._objectPath,l.referencedArgumentObjectPaths=u,e._context._addServiceApiAction(l,s,o,a)}))},t.invokeMethodWithClientResultCallback=function(e,t,n){var r=[];return u.createPromise((function(i,o){var a=new P(e),s={Id:t._context._nextId(),ActionType:3,Name:n,ObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=_.setMethodArguments(t._context,s.ArgumentInfo,r),u=new p(s,0,0);u.referencedObjectPath=t._objectPath,u.referencedArgumentObjectPaths=c,t._context._addServiceApiAction(u,a,i,o)}))},t.invokeRetrieve=function(n,r){var i,o=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;if(o||(o=!_.isSetSupported("RichApiRuntime","1.1")),"object"===typeof r[0]&&r[0].hasOwnProperty("$all")){if(!r[0].$all)throw e.Error._createInvalidArgError({});i=r[0]}else i=t._parseSelectOption(r);return n._retrieve(i,new D(o))},t._parseSelectOption=function(n){if(!n||!n[0])throw e.Error._createInvalidArgError({});var r=n[0]&&"string"!==typeof n[0]?n[0]:n;return Array.isArray(r)?r:t.parseRecursiveSelect(r)},t.parseRecursiveSelect=function(e){var t=function(e){return Object.keys(e).reduce((function(n,r){var i=e[r];return"object"===typeof i?n.concat(t(i).map((function(e){return r+"/"+e}))):i?n.concat(r):n}),[])};return t(e)},t.invokeRecursiveUpdate=function(e,t){return u.createPromise((function(n,r){e._recursivelyUpdate(t);var i={Id:e._context._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},o=new p(i,1,4);e._context._addServiceApiAction(o,null,n,r)}))},t.createRootServiceObject=function(e,t){var n={Id:t._nextId(),ObjectPathType:1,Name:""};return new e(t,new h(n,null,!1,!1,1,4))},t.createTopLevelServiceObject=function(e,t,n,r,i){var o={Id:t._nextId(),ObjectPathType:2,Name:n};return new e(t,new h(o,null,r,!1,1,4|i))},t.createPropertyObject=function(e,t,n,r,i){var o={Id:t._context._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id},a=new h(o,t._objectPath,r,!1,1,4|i);return new e(t._context,a)},t.createIndexerObject=function(e,t,n){var r={Id:t._context._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};r.ArgumentInfo.Arguments=n;var i=new h(r,t._objectPath,!1,!1,1,4);return new e(t._context,i)},t.createMethodObject=function(e,t,n,r,i,o,a,s,c){var u={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},l=_.setMethodArguments(t._context,u.ArgumentInfo,i),f=new h(u,t._objectPath,o,a,r,c);return f.argumentObjectPaths=l,f.getByIdMethodName=s,new e(t._context,f)},t.createAndInstantiateMethodObject=function(e,t,n,r,i,o,a,s,c){return u.createPromise((function(u,l){var f={Id:t._context._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},d=_.setMethodArguments(t._context,f.ArgumentInfo,i),m=new h(f,t._objectPath,o,a,r,c);m.argumentObjectPaths=d,m.getByIdMethodName=s;var g=new O,y={Id:t._context._nextId(),ActionType:1,Name:"",ObjectPathId:m.objectPathInfo.Id,QueryInfo:{}},v=new p(y,1,4);v.referencedObjectPath=m,t._context._addServiceApiAction(v,g,(function(){return u(new e(t._context,m))}),l)}))},t.createTraceAction=function(e,t){return u.createPromise((function(n,r){var i={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},o=new p(i,1,4),a=new C(t);e._addServiceApiAction(o,a,n,r)}))},t.localDocumentContext=new m,t}();e.OperationalApiHelper=F;var E=function(){function e(e,t,n){this.eventId=e,this.targetId=t,this.eventArgumentTransform=n,this.registeredCallbacks=[]}return e.prototype.add=function(e){this.hasZero()&&V.getGenericEventRegistration("").register(this.eventId,this.targetId,this.registerCallback),this.registeredCallbacks.push(e)},e.prototype.remove=function(e){var t=this.registeredCallbacks.lastIndexOf(e);-1!==t&&this.registeredCallbacks.splice(t,1)},e.prototype.removeAll=function(){this.registeredCallbacks=[],V.getGenericEventRegistration("").unregister(this.eventId,this.targetId,this.registerCallback)},e.prototype.hasZero=function(){return 0===this.registeredCallbacks.length},Object.defineProperty(e.prototype,"registerCallback",{get:function(){var e=this;return this.outsideCallback||(this.outsideCallback=function(t){e.call(t)}),this.outsideCallback},enumerable:!0,configurable:!0}),e.prototype.call=function(t){var n=this;this.eventArgumentTransform(t).then((function(t){var r=n.registeredCallbacks.map((function(n){return e.callCallback(n,t)}));u.Promise.all(r)}))},e.callCallback=function(t,n){return u._createPromiseFromResult(null).then(e.wrapCallbackInFunction(t,n)).catch((function(e){u.log("Error when invoke handler: "+JSON.stringify(e))}))},e.wrapCallbackInFunction=function(e,t){return function(){return e(t)}},e}();e.GenericEventRegistryOperational=E;var I=function(){function e(){this.eventToTargetToHandlerMap={}}return Object.defineProperty(e,"globalEventRegistry",{get:function(){return e.singleton||(e.singleton=new e),e.singleton},enumerable:!0,configurable:!0}),e.getGlobalEventRegistry=function(t,n,r){var i=e.globalEventRegistry.eventToTargetToHandlerMap;i.hasOwnProperty(t)||(i[t]={});var o=i[t];return o.hasOwnProperty(n)||(o[n]=new E(t,n,r)),o[n]},e.singleton=void 0,e}();e.GlobalEventRegistryOperational=I;var x=function(){function e(e){this.genericEventInfo=e}return e.prototype.add=function(e){var t=this,n=void 0,r=u.createPromise((function(e){n=e}));return this.register(),this.createTrace((function(){var r=t.genericEventInfo.eventType,i=t.genericEventInfo.getTargetIdFunc();I.getGlobalEventRegistry(r,i,t.genericEventInfo.eventArgsTransformFunc).add(e),n()})),r},e.prototype.remove=function(e){var t=this;this.register(),this.createTrace((function(){var n=t.genericEventInfo.eventType,r=t.genericEventInfo.getTargetIdFunc();I.getGlobalEventRegistry(n,r,t.genericEventInfo.eventArgsTransformFunc).remove(e)}))},e.prototype.removeAll=function(){var e=this;this.unregister(),this.createTrace((function(){var t=e.genericEventInfo.eventType,n=e.genericEventInfo.getTargetIdFunc();I.getGlobalEventRegistry(t,n,e.genericEventInfo.eventArgsTransformFunc).removeAll()}))},e.prototype.createTrace=function(e){F.createTraceAction(this.genericEventInfo.object._context,e)},e.prototype.register=function(){F.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.register,0,[],0),V.getGenericEventRegistration("").isReady||V.getGenericEventRegistration("").ready()},e.prototype.unregister=function(){F.invokeMethod(this.genericEventInfo.object,this.genericEventInfo.unregister)},e}();e.GenericEventHandlerOperational=x;var M=function(){function e(){}return e.invokeOn=function(e,t,n){var r=void 0,i=u.createPromise((function(e,t){r=e}));return e.add(t).then((function(){r({})})),i},e.invokeOff=function(t,n,r,i){if(!r&&!i){var o=Object.keys(t).map((function(e){return t[e]}));return e.invokeAllOff(o)}return r?(i?n.remove(i):n.removeAll(),u.createPromise((function(e,t){return e()}))):u._createPromiseFromException(r+" must be supplied if handler is supplied.")},e.invokeAllOff=function(e){return e.forEach((function(e){e.removeAll()})),u.createPromise((function(e,t){return e()}))},e}();e.EventHelper=M;var T=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.cannotRegisterEvent="CannotRegisterEvent",t.invalidOrTimedOutSession="InvalidOrTimedOutSession",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(o);e.ErrorCodes=T;var R=function(){function e(e){this.m_callback=e}return e.prototype._handleResult=function(e){this.m_callback&&this.m_callback()},e}(),w=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.createMethodAction=function(t,n,r,i,o,a){Y.validateObjectPath(n);var s={Id:t._nextId(),ActionType:3,Name:r,ObjectPathId:n._objectPath.objectPathInfo.Id,ArgumentInfo:{}},c=Y.setMethodArguments(t,s.ArgumentInfo,o);Y.validateReferencedObjectPaths(c);var u=Y._fixupApiFlags(a),l=new p(s,i,u);if(l.referencedObjectPath=n._objectPath,l.referencedArgumentObjectPaths=c,n._addAction(l),e._internalConfig.enablePreviewExecution&&0!==(16&u)){var f={Id:t._nextId(),ActionType:3,Name:r,Arguments:o,ObjectId:"",ObjectType:""};n._addPreviewExecutionAction(f)}return l},n.createRecursiveQueryAction=function(e,t,n){Y.validateObjectPath(t);var r={Id:e._nextId(),ActionType:6,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,RecursiveQueryInfo:n},i=new p(r,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i),i},n.createEnsureUnchangedAction=function(e,t,n){Y.validateObjectPath(t);var r={Id:e._nextId(),ActionType:8,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id,ObjectState:n},i=new p(r,1,4);return i.referencedObjectPath=t._objectPath,t._addAction(i),i},n.createInstantiateAction=function(e,t){Y.validateObjectPath(t),e._pendingRequest.ensureInstantiateObjectPath(t._objectPath.parentObjectPath),e._pendingRequest.ensureInstantiateObjectPaths(t._objectPath.argumentObjectPaths);var n={Id:e._nextId(),ActionType:1,Name:"",ObjectPathId:t._objectPath.objectPathInfo.Id},r=new p(n,1,4);return r.referencedObjectPath=t._objectPath,t._addAction(r,new J(t),!0),r},n.createTraceAction=function(e,t,n){var r={Id:e._nextId(),ActionType:5,Name:"Trace",ObjectPathId:0},i=new p(r,1,4);return e._pendingRequest.addAction(i),n&&e._pendingRequest.addTrace(r.Id,t),i},n.createTraceMarkerForCallback=function(e,t){var r=n.createTraceAction(e,null,!1);e._pendingRequest.addActionResultHandler(r,new R(t))},n}(f);e.ActionFactory=w;var N=function(t){function n(n,r){var i=t.call(this,n,r)||this;return Y.checkArgumentNull(n,"context"),i.m_context=n,i._objectPath&&(!n._processingResult&&n._pendingRequest&&(w.createInstantiateAction(n,i),n._autoCleanup&&i._KeepReference&&n.trackedObjects._autoAdd(i)),e._internalConfig.appendTypeNameToObjectPathInfo&&i._objectPath.objectPathInfo&&i._className&&(i._objectPath.objectPathInfo.T=i._className)),i}return __extends(n,t),Object.defineProperty(n.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNull",{get:function(){return("undefined"!==typeof this.m_isNull||!l.isMock())&&(Y.throwIfNotLoaded("isNull",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isNullObject",{get:function(){return("undefined"!==typeof this.m_isNull||!l.isMock())&&(Y.throwIfNotLoaded("isNullObject",this._isNull,null,this._isNull),this._isNull)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isNull",{get:function(){return this.m_isNull},set:function(e){this.m_isNull=e,e&&this._objectPath&&this._objectPath._updateAsNullObject()},enumerable:!0,configurable:!0}),n.prototype._addAction=function(e,t,n){return void 0===t&&(t=null),n||(this.context._pendingRequest.ensureInstantiateObjectPath(this._objectPath),this.context._pendingRequest.ensureInstantiateObjectPaths(e.referencedArgumentObjectPaths)),this.context._pendingRequest.addAction(e),this.context._pendingRequest.addReferencedObjectPath(this._objectPath),this.context._pendingRequest.addReferencedObjectPaths(e.referencedArgumentObjectPaths),this.context._pendingRequest.addActionResultHandler(e,t),u._createPromiseFromResult(null)},n.prototype._addPreviewExecutionAction=function(e){if(!Y.isUndefined(this._className)){e.ObjectType=this._className;var t=Y._getPropertyValueWithoutCheckLoaded(this,H.idLowerCase);Y.isUndefined(t)&&(t=Y._getPropertyValueWithoutCheckLoaded(this,H.idPrivate)),Y.isUndefined(t)&&(t=Y._getPropertyValueWithoutCheckLoaded(this,H.previewExecutionObjectId)),e.ObjectId=t,this.context._pendingRequest.addPreviewExecutionAction(e)}},n.prototype._handleResult=function(e){this._isNull=Y.isNullOrUndefined(e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleIdResult=function(e){this._isNull=Y.isNullOrUndefined(e),Y.fixObjectPathIfNecessary(this,e),this.context.trackedObjects._autoTrackIfNecessaryWhenHandleObjectResultValue(this,e)},n.prototype._handleRetrieveResult=function(e,t){this._handleIdResult(e)},n.prototype._recursivelySet=function(e,t,i,s,c){var l=e instanceof n,f=e;if(l){if(Object.getPrototypeOf(this)!==Object.getPrototypeOf(e))throw r.RuntimeError._createInvalidArgError({argumentName:"properties",errorLocation:this._className+".set"});e=JSON.parse(JSON.stringify(e))}try{for(var d,p=0;p<i.length;p++)d=i[p],e.hasOwnProperty(d)&&"undefined"!==typeof e[d]&&(this[d]=e[d]);for(p=0;p<s.length;p++)if(d=s[p],e.hasOwnProperty(d)&&"undefined"!==typeof e[d]){var h=l?f[d]:e[d];this[d].set(h,t)}var m=!l;t&&!Y.isNullOrUndefined(m)&&(m=t.throwOnReadOnly);for(p=0;p<c.length;p++)if(d=c[p],e.hasOwnProperty(d)&&"undefined"!==typeof e[d]&&m)throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(Z.cannotApplyPropertyThroughSetMethod,d),debugInfo:{errorLocation:d}});for(d in e)if(i.indexOf(d)<0&&s.indexOf(d)<0){var g=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(this),d);if(!g)throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(A.propertyDoesNotExist,d),debugInfo:{errorLocation:d}});if(m&&!g.set)throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(A.attemptingToSetReadOnlyProperty,d),debugInfo:{errorLocation:d}})}}catch(e){throw new r.RuntimeError({code:o.invalidArgument,httpStatusCode:400,message:u._getResourceString(a.invalidArgument,"properties"),debugInfo:{errorLocation:this._className+".set"},innerError:e})}},n}(d);e.ClientObject=N;var j=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(e,t,n){var r={url:s.processQuery,method:"POST",headers:n.Headers,body:n.Body},o="";n.Headers&&(o=n.Headers[H.officeControlId]);var a={id:i.nextId(),type:1,flags:t,controlId:o,message:r};return u.log(JSON.stringify(a)),this.m_session.sendMessageToHost(a).then((function(e){u.log("Received response: "+JSON.stringify(e));var t,n=e.message;if(200===n.statusCode)t={HttpStatusCode:n.statusCode,ErrorCode:null,ErrorMessage:null,Headers:n.headers,Body:u._parseResponseBody(n)};else{u.log("Error Response:"+n.body);var r=u._parseErrorResponse(n);t={HttpStatusCode:n.statusCode,ErrorCode:r.errorCode,ErrorMessage:r.errorMessage,Headers:n.headers,Body:null}}return t}))},e}(),U=function(e){function t(t){var n=e.call(this)||this;return n.m_bridge=t,n.m_bridge.addHostMessageHandler((function(e){if(3===e.type){var t=e.controlId;if(u.isNullOrEmptyString(t))V.getGenericEventRegistration(t)._handleRichApiMessage(e.message);else{var n=V.peekGenericEventRegistrationOrNull(t);n&&n._handleRichApiMessage(e.message),(n=V.peekGenericEventRegistrationOrNull(""))&&n._handleRichApiMessage(e.message)}}})),n}return __extends(t,e),t.getInstanceIfHostBridgeInited=function(){return i.instance?((u.isNullOrUndefined(t.s_instance)||t.s_instance.m_bridge!==i.instance)&&(t.s_instance=new t(i.instance)),t.s_instance):null},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return u._createPromiseFromResult(null)},t.prototype._createRequestExecutorOrNull=function(){return u.log("NativeBridgeSession::CreateRequestExecutor"),new j(this)},t.prototype.getEventRegistration=function(e){return V.getGenericEventRegistration(e)},t.prototype.sendMessageToHost=function(e){return this.m_bridge.sendMessageToHostAndExpectResponse(e)},t}(t);e.HostBridgeSession=U;var k=function(n){function i(e){var o=n.call(this)||this;if(o.m_customRequestHeaders={},o.m_batchMode=0,o._onRunFinishedNotifiers=[],t._overrideSession)o.m_requestUrlAndHeaderInfoResolver=t._overrideSession;else if((Y.isNullOrUndefined(e)||"string"===typeof e&&0===e.length)&&((e=i.defaultRequestUrlAndHeaders)||(e={url:s.localDocument,headers:{}})),"string"===typeof e)o.m_requestUrlAndHeaderInfo={url:e,headers:{}};else if(i.isRequestUrlAndHeaderInfoResolver(e))o.m_requestUrlAndHeaderInfoResolver=e;else{if(!i.isRequestUrlAndHeaderInfo(e))throw r.RuntimeError._createInvalidArgError({argumentName:"url"});var a=e;o.m_requestUrlAndHeaderInfo={url:a.url,headers:{}},u._copyHeaders(a.headers,o.m_requestUrlAndHeaderInfo.headers)}return!o.m_requestUrlAndHeaderInfoResolver&&o.m_requestUrlAndHeaderInfo&&u._isLocalDocumentUrl(o.m_requestUrlAndHeaderInfo.url)&&U.getInstanceIfHostBridgeInited()&&(o.m_requestUrlAndHeaderInfo=null,o.m_requestUrlAndHeaderInfoResolver=U.getInstanceIfHostBridgeInited()),o.m_requestUrlAndHeaderInfoResolver instanceof t&&(o.m_session=o.m_requestUrlAndHeaderInfoResolver),o._processingResult=!1,o._customData=H.iterativeExecutor,o.sync=o.sync.bind(o),o}return __extends(i,n),Object.defineProperty(i.prototype,"session",{get:function(){return this.m_session},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"eventRegistration",{get:function(){return this.m_session?this.m_session.getEventRegistration(this._controlId):r.officeJsEventRegistration},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_url",{get:function(){return this.m_requestUrlAndHeaderInfo?this.m_requestUrlAndHeaderInfo.url:null},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_pendingRequest",{get:function(){return null==this.m_pendingRequest&&(this.m_pendingRequest=new W(this)),this.m_pendingRequest},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_controlId",{get:function(){var e=this.m_customRequestHeaders[H.officeControlId];return u.isNullOrUndefined(e)&&(e=""),e},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"debugInfo",{get:function(){return{pendingStatements:new $(this._rootObjectPropertyName,this._pendingRequest._objectPaths,this._pendingRequest._actions,e._internalConfig.showDisposeInfoInDebugInfo).process()}},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"trackedObjects",{get:function(){return this.m_trackedObjects||(this.m_trackedObjects=new X(this)),this.m_trackedObjects},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"requestHeaders",{get:function(){return this.m_customRequestHeaders},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"batchMode",{get:function(){return this.m_batchMode},enumerable:!0,configurable:!0}),i.prototype.ensureInProgressBatchIfBatchMode=function(){if(1===this.m_batchMode&&!this.m_explicitBatchInProgress)throw Y.createRuntimeError(o.generalException,u._getResourceString(Z.notInsideBatch),null)},i.prototype.load=function(e,t){Y.validateContext(this,e);var n=i._parseQueryOption(t);f.createQueryAction(this,e,n,e)},i.prototype.loadRecursive=function(e,t,n){if(!Y.isPlainJsonObject(t))throw r.RuntimeError._createInvalidArgError({argumentName:"options"});var o={};for(var a in t)o[a]=i._parseQueryOption(t[a]);var s=w.createRecursiveQueryAction(this,e,{Queries:o,MaxDepth:n});this._pendingRequest.addActionResultHandler(s,e)},i.prototype.trace=function(e){w.createTraceAction(this,e,!0)},i.prototype._processOfficeJsErrorResponse=function(e,t){},i.prototype.ensureRequestUrlAndHeaderInfo=function(){var e=this;return Y._createPromiseFromResult(null).then((function(){if(!e.m_requestUrlAndHeaderInfo)return e.m_requestUrlAndHeaderInfoResolver._resolveRequestUrlAndHeaderInfo().then((function(t){if(e.m_requestUrlAndHeaderInfo=t,e.m_requestUrlAndHeaderInfo||(e.m_requestUrlAndHeaderInfo={url:s.localDocument,headers:{}}),Y.isNullOrEmptyString(e.m_requestUrlAndHeaderInfo.url)&&(e.m_requestUrlAndHeaderInfo.url=s.localDocument),e.m_requestUrlAndHeaderInfo.headers||(e.m_requestUrlAndHeaderInfo.headers={}),"function"===typeof e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull){var n=e.m_requestUrlAndHeaderInfoResolver._createRequestExecutorOrNull();n&&(e._requestExecutor=n)}}))}))},i.prototype.syncPrivateMain=function(){var e=this;return this.ensureRequestUrlAndHeaderInfo().then((function(){var t=e._pendingRequest;return e.m_pendingRequest=null,e.processPreSyncPromises(t).then((function(){return e.syncPrivate(t)}))}))},i.prototype.syncPrivate=function(t){var n=this;if(l.isMock())return u._createPromiseFromResult(null);if(!t.hasActions)return this.processPendingEventHandlers(t);var i=t.buildRequestMessageBodyAndRequestFlags(),o=i.body,a=i.flags;this._requestFlagModifier&&(a|=this._requestFlagModifier),this._requestExecutor||(u._isLocalDocumentUrl(this.m_requestUrlAndHeaderInfo.url)?this._requestExecutor=new Q(this):this._requestExecutor=new b);var c=this._requestExecutor,f={};u._copyHeaders(this.m_requestUrlAndHeaderInfo.headers,f),u._copyHeaders(this.m_customRequestHeaders,f),delete this.m_customRequestHeaders[H.officeScriptEventId];var d=l._getCurrentTestNameWithSequenceId();d&&(f[s.testRequestNameHeader]=d);var p={Url:this.m_requestUrlAndHeaderInfo.url,Headers:f,Body:o};t.invalidatePendingInvalidObjectPaths();var h=null,m=null;return this._lastSyncStart="undefined"===typeof performance?Date.now():performance.now(),this._lastRequestFlags=a,c.executeAsync(this._customData,a,p).then((function(r){return n._lastSyncEnd="undefined"===typeof performance?Date.now():performance.now(),e.config.executePerfLogFunc&&e.config.executePerfLogFunc({syncStart:n._lastSyncStart,syncEnd:n._lastSyncEnd}),h=n.processRequestExecutorResponseMessage(t,r),n.processPendingEventHandlers(t).catch((function(e){u.log("Error in processPendingEventHandlers"),u.log(JSON.stringify(e)),m=e}))})).then((function(){if(h)throw u.log("Throw error from response: "+JSON.stringify(h)),h;if(m){u.log("Throw error from ProcessEventHandler: "+JSON.stringify(m));var e=null;if(m instanceof r.RuntimeError)(e=m).traceMessages=t._responseTraceMessages;else{var n=null;n="string"===typeof m?m:m.message,Y.isNullOrEmptyString(n)&&(n=u._getResourceString(Z.cannotRegisterEvent)),e=new r.RuntimeError({code:T.cannotRegisterEvent,httpStatusCode:400,message:n,traceMessages:t._responseTraceMessages})}throw e}}))},i.prototype.processRequestExecutorResponseMessage=function(t,n){n.Body&&n.Body.TraceIds&&t._setResponseTraceIds(n.Body.TraceIds);var i=t._responseTraceMessages,o=null;if(n.Body){if(n.Body.Error&&n.Body.Error.ActionIndex>=0){var a=new $(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!0),s=a.processForDebugStatementInfo(n.Body.Error.ActionIndex);o={statement:s.statement,surroundingStatements:s.surroundingStatements,fullStatements:["Please enable config.extendedErrorLogging to see full statements."]},e.config.extendedErrorLogging&&(a=new $(this._rootObjectPropertyName,t._objectPaths,t._actions,!1,!1),o.fullStatements=a.process())}var c=null;if(n.Body.Results?c=n.Body.Results:n.Body.ProcessedResults&&n.Body.ProcessedResults.Results&&(c=n.Body.ProcessedResults.Results),c){this._processingResult=!0;try{t.processResponse(c)}finally{this._processingResult=!1}}}if(!Y.isNullOrEmptyString(n.ErrorCode))return new r.RuntimeError({code:n.ErrorCode,httpStatusCode:n.HttpStatusCode,message:n.ErrorMessage,traceMessages:i,data:{responseBody:n.RawErrorResponseBody}});if(n.Body&&n.Body.Error){var u={errorLocation:n.Body.Error.Location};return o&&(u.statement=o.statement,u.surroundingStatements=o.surroundingStatements,u.fullStatements=o.fullStatements),new r.RuntimeError({code:n.Body.Error.Code,httpStatusCode:n.Body.Error.HttpStatusCode,message:n.Body.Error.Message,traceMessages:i,debugInfo:u})}return null},i.prototype.processPendingEventHandlers=function(e){for(var t=Y._createPromiseFromResult(null),n=0;n<e._pendingProcessEventHandlers.length;n++){var r=e._pendingProcessEventHandlers[n];t=t.then(this.createProcessOneEventHandlersFunc(r,e))}return t},i.prototype.createProcessOneEventHandlersFunc=function(e,t){return function(){return e._processRegistration(t)}},i.prototype.processPreSyncPromises=function(e){for(var t=Y._createPromiseFromResult(null),n=0;n<e._preSyncPromises.length;n++){var r=e._preSyncPromises[n];t=t.then(this.createProcessOneProSyncFunc(r))}return t},i.prototype.createProcessOneProSyncFunc=function(e){return function(){return e}},i.prototype.sync=function(e){return l.isMock()?u._createPromiseFromResult(e):this.syncPrivateMain().then((function(){return e}))},i.prototype.batch=function(e){var t=this;if(1!==this.m_batchMode)return u._createPromiseFromException(Y.createRuntimeError(o.generalException,null,null));if(this.m_explicitBatchInProgress)return u._createPromiseFromException(Y.createRuntimeError(o.generalException,u._getResourceString(Z.pendingBatchInProgress),null));if(Y.isNullOrUndefined(e))return Y._createPromiseFromResult(null);this.m_explicitBatchInProgress=!0;var n,r,i,a=this.m_pendingRequest;this.m_pendingRequest=new W(this);try{n=e(this._rootObject,this)}catch(e){return this.m_explicitBatchInProgress=!1,this.m_pendingRequest=a,u._createPromiseFromException(e)}return"object"===typeof n&&n&&"function"===typeof n.then?i=Y._createPromiseFromResult(null).then((function(){return n})).then((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,e})).catch((function(e){return t.m_explicitBatchInProgress=!1,r=t.m_pendingRequest,t.m_pendingRequest=a,u._createPromiseFromException(e)})):(this.m_explicitBatchInProgress=!1,r=this.m_pendingRequest,this.m_pendingRequest=a,i=Y._createPromiseFromResult(n)),i.then((function(e){return t.ensureRequestUrlAndHeaderInfo().then((function(){return t.syncPrivate(r)})).then((function(){return e}))}))},i._run=function(e,t,n,r,o,a){return void 0===n&&(n=3),void 0===r&&(r=5e3),i._runCommon("run",null,e,0,t,n,r,null,o,a)},i.isValidRequestInfo=function(e){return"string"===typeof e||i.isRequestUrlAndHeaderInfo(e)||i.isRequestUrlAndHeaderInfoResolver(e)},i.isRequestUrlAndHeaderInfo=function(e){return"object"===typeof e&&null!==e&&Object.getPrototypeOf(e)===Object.getPrototypeOf({})&&!Y.isNullOrUndefined(e.url)},i.isRequestUrlAndHeaderInfoResolver=function(e){return"object"===typeof e&&null!==e&&"function"===typeof e._resolveRequestUrlAndHeaderInfo},i._runBatch=function(e,t,n,r,o,a,s,c){return void 0===o&&(o=3),void 0===a&&(a=5e3),i._runBatchCommon(0,e,t,n,o,a,r,s,c)},i._runExplicitBatch=function(e,t,n,r,o,a,s,c){return void 0===o&&(o=3),void 0===a&&(a=5e3),i._runBatchCommon(1,e,t,n,o,a,r,s,c)},i._runBatchCommon=function(e,t,n,r,o,a,s,c,u){var l,f;void 0===o&&(o=3),void 0===a&&(a=5e3);var d=null,p=null,h=0,m=null;if(n.length>0)if(i.isValidRequestInfo(n[0]))d=n[0],h=1;else if(Y.isPlainJsonObject(n[0])){if(null!=(d=(m=n[0]).session)&&!i.isValidRequestInfo(d))return i.createErrorPromise(t);p=m.previousObjects,h=1}if(n.length==h+1)f=n[h+0];else{if(null!=m||n.length!=h+2)return i.createErrorPromise(t);p=n[h+0],f=n[h+1]}if(null!=p)if(p instanceof N)l=function(){return p.context};else if(p instanceof i)l=function(){return p};else{if(!Array.isArray(p))return i.createErrorPromise(t);var g=p;if(0==g.length)return i.createErrorPromise(t);for(var y=0;y<g.length;y++){if(!(g[y]instanceof N))return i.createErrorPromise(t);if(g[y].context!=g[0].context)return i.createErrorPromise(t,Z.invalidRequestContext)}l=function(){return g[0].context}}else l=r;var O=null;return s&&(O=function(e){return s(m||{},e)}),i._runCommon(t,d,l,e,f,o,a,O,c,u)},i.createErrorPromise=function(e,t){return void 0===t&&(t=a.invalidArgument),u._createPromiseFromException(Y.createRuntimeError(t,u._getResourceString(t),e))},i._runCommon=function(n,r,o,a,s,c,l,f,d,p){t._overrideSession&&(r=t._overrideSession);var h,m,g,y=u.createPromise((function(e,t){e()})),O=!1;return y.then((function(){if((h=o(r))._autoCleanup)return new e.Promise((function(e,t){h._onRunFinishedNotifiers.push((function(){h._autoCleanup=!0,e()}))}));h._autoCleanup=!0})).then((function(){return"function"!==typeof s?i.createErrorPromise(n):(g=h.m_batchMode,h.m_batchMode=a,f&&f(h),e=s(1==a?h.batch.bind(h):h),(Y.isNullOrUndefined(e)||"function"!==typeof e.then)&&Y.throwError(Z.runMustReturnPromise),e);var e})).then((function(e){return 1===a?e:h.sync(e)})).then((function(e){O=!0,m=e})).catch((function(e){m=e})).then((function(){var e=h.trackedObjects._retrieveAndClearAutoCleanupList();for(var t in h._autoCleanup=!1,h.m_batchMode=g,e)e[t]._objectPath.isValid=!1;var n=0;if(Y._synchronousCleanup||i.isRequestUrlAndHeaderInfoResolver(r))return o();function o(){n++;var t=h.m_pendingRequest,r=h.m_batchMode,i=new W(h);h.m_pendingRequest=i,h.m_batchMode=0;try{for(var a in e)h.trackedObjects.remove(e[a])}finally{h.m_batchMode=r,h.m_pendingRequest=t}return h.syncPrivate(i).then((function(){d&&d(n)})).catch((function(){p&&p(n),n<c&&setTimeout((function(){o()}),l)}))}o()})).then((function(){h._onRunFinishedNotifiers&&h._onRunFinishedNotifiers.length>0&&h._onRunFinishedNotifiers.shift()();if(O)return m;throw m}))},i}(m);e.ClientRequestContext=k;var L=function(){function e(e,t){this.m_proxy=e,this.m_shouldPolyfill=t;var n=e[H.scalarPropertyNames],r=e[H.navigationPropertyNames],i=e[H.className],o=e[H.isCollection];if(n)for(var a=0;a<n.length;a++)Y.definePropertyThrowUnloadedException(this,i,n[a]);if(r)for(a=0;a<r.length;a++)Y.definePropertyThrowUnloadedException(this,i,r[a]);o&&Y.definePropertyThrowUnloadedException(this,i,H.itemsLowerCase)}return Object.defineProperty(e.prototype,"$proxy",{get:function(){return this.m_proxy},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"$isNullObject",{get:function(){if(!this.m_isLoaded)throw new r.RuntimeError({code:T.valueNotLoaded,httpStatusCode:400,message:u._getResourceString(Z.valueNotLoaded),debugInfo:{errorLocation:"retrieveResult.$isNullObject"}});return this.m_isNullObject},enumerable:!0,configurable:!0}),e.prototype.toJSON=function(){if(this.m_isLoaded)return this.m_isNullObject?null:(Y.isUndefined(this.m_json)&&(this.m_json=Y.purifyJson(this.m_value)),this.m_json)},e.prototype.toString=function(){return JSON.stringify(this.toJSON())},e.prototype._handleResult=function(e){this.m_isLoaded=!0,null===e||"object"===typeof e&&e&&e._IsNull?(this.m_isNullObject=!0,e=null):this.m_isNullObject=!1,this.m_shouldPolyfill&&(e=Y.changePropertyNameToCamelLowerCase(e)),this.m_value=e,this.m_proxy._handleRetrieveResult(e,this)},e}(),H=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.getItemAt="GetItemAt",t.index="_Index",t.iterativeExecutor="IterativeExecutor",t.isTracked="_IsTracked",t.eventMessageCategory=65536,t.eventWorkbookId="Workbook",t.eventSourceRemote="Remote",t.proxy="$proxy",t.className="_className",t.isCollection="_isCollection",t.collectionPropertyPath="_collectionPropertyPath",t.objectPathInfoDoNotKeepReferenceFieldName="D",t.officeScriptEventId="X-OfficeScriptEventId",t.officeScriptFireRecordingEvent="X-OfficeScriptFireRecordingEvent",t.officeControlId="X-OfficeControlId",t}(S);e.Constants=H;var W=function(e){function t(t){var n=e.call(this,t)||this;return n.m_context=t,n.m_pendingProcessEventHandlers=[],n.m_pendingEventHandlerActions={},n.m_traceInfos={},n.m_responseTraceIds={},n.m_responseTraceMessages=[],n}return __extends(t,e),Object.defineProperty(t.prototype,"traceInfos",{get:function(){return this.m_traceInfos},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceMessages",{get:function(){return this.m_responseTraceMessages},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_responseTraceIds",{get:function(){return this.m_responseTraceIds},enumerable:!0,configurable:!0}),t.prototype._setResponseTraceIds=function(e){if(e)for(var t=0;t<e.length;t++){var n=e[t];this.m_responseTraceIds[n]=n;var r=this.m_traceInfos[n];u.isNullOrUndefined(r)||this.m_responseTraceMessages.push(r)}},t.prototype.addTrace=function(e,t){this.m_traceInfos[e]=t},t.prototype._addPendingEventHandlerAction=function(e,t){this.m_pendingEventHandlerActions[e._id]||(this.m_pendingEventHandlerActions[e._id]=[],this.m_pendingProcessEventHandlers.push(e)),this.m_pendingEventHandlerActions[e._id].push(t)},Object.defineProperty(t.prototype,"_pendingProcessEventHandlers",{get:function(){return this.m_pendingProcessEventHandlers},enumerable:!0,configurable:!0}),t.prototype._getPendingEventHandlerActions=function(e){return this.m_pendingEventHandlerActions[e._id]},t}(y);e.ClientRequest=W;var B=function(){function e(e,t,n,r){var i=this;this.m_id=e._nextId(),this.m_context=e,this.m_name=n,this.m_handlers=[],this.m_registered=!1,this.m_eventInfo=r,this.m_callback=function(e){i.m_eventInfo.eventArgsTransformFunc(e).then((function(e){return i.fireEvent(e)}))}}return Object.defineProperty(e.prototype,"_registered",{get:function(){return this.m_registered},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_id",{get:function(){return this.m_id},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_handlers",{get:function(){return this.m_handlers},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_callback",{get:function(){return this.m_callback},enumerable:!0,configurable:!0}),e.prototype.add=function(e){var t=w.createTraceAction(this.m_context,null,!1);return this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:0}),new G(this.m_context,this,e)},e.prototype.remove=function(e){var t=w.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:t.actionInfo.Id,handler:e,operation:1})},e.prototype.removeAll=function(){var e=w.createTraceAction(this.m_context,null,!1);this.m_context._pendingRequest._addPendingEventHandlerAction(this,{id:e.actionInfo.Id,handler:null,operation:2})},e.prototype._processRegistration=function(e){var t=this,n=u._createPromiseFromResult(null),r=e._getPendingEventHandlerActions(this);if(!r)return n;for(var i=[],o=0;o<this.m_handlers.length;o++)i.push(this.m_handlers[o]);var a=!1;for(o=0;o<r.length;o++)if(e._responseTraceIds[r[o].id])switch(a=!0,r[o].operation){case 0:i.push(r[o].handler);break;case 1:for(var s=i.length-1;s>=0;s--)if(i[s]===r[o].handler){i.splice(s,1);break}break;case 2:i=[]}return a&&(!this.m_registered&&i.length>0?n=n.then((function(){return t.m_eventInfo.registerFunc(t.m_callback)})).then((function(){return t.m_registered=!0})):this.m_registered&&0==i.length&&(n=n.then((function(){return t.m_eventInfo.unregisterFunc(t.m_callback)})).catch((function(e){u.log("Error when unregister event: "+JSON.stringify(e))})).then((function(){return t.m_registered=!1}))),n=n.then((function(){return t.m_handlers=i}))),n},e.prototype.fireEvent=function(e){for(var t=[],n=0;n<this.m_handlers.length;n++){var r=this.m_handlers[n],i=u._createPromiseFromResult(null).then(this.createFireOneEventHandlerFunc(r,e)).catch((function(e){u.log("Error when invoke handler: "+JSON.stringify(e))}));t.push(i)}u.Promise.all(t)},e.prototype.createFireOneEventHandlerFunc=function(e,t){return function(){return e(t)}},e}();e.EventHandlers=B;var G=function(){function e(e,t,n){this.m_context=e,this.m_allHandlers=t,this.m_handler=n}return Object.defineProperty(e.prototype,"context",{get:function(){return this.m_context},enumerable:!0,configurable:!0}),e.prototype.remove=function(){this.m_allHandlers&&this.m_handler&&(this.m_allHandlers.remove(this.m_handler),this.m_allHandlers=null,this.m_handler=null)},e}();e.EventHandlerResult=G,function(e){var t=function(){function t(){}return t.prototype.register=function(t,n,r){switch(t){case 4:return Y.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Y.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingDataChanged,r,t)}))}));case 3:return Y.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Y.promisify((function(t){return e.addHandlerAsync(Office.EventType.BindingSelectionChanged,r,t)}))}));case 2:return Y.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.DocumentSelectionChanged,r,e)}));case 1:return Y.promisify((function(e){return Office.context.document.settings.addHandlerAsync(Office.EventType.SettingsChanged,r,e)}));case 5:return OSF.DDA.RichApi.richApiMessageManager.register(r);case 13:return Y.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDeleted,r,{id:n},e)}));case 14:return Y.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectSelectionChanged,r,{id:n},e)}));case 15:return Y.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ObjectDataChanged,r,{id:n},e)}));case 16:return Y.promisify((function(e){return Office.context.document.addHandlerAsync(Office.EventType.ContentControlAdded,r,{id:n},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t.prototype.unregister=function(t,n,r){switch(t){case 4:return Y.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Y.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingDataChanged,{handler:r},t)}))}));case 3:return Y.promisify((function(e){return Office.context.document.bindings.getByIdAsync(n,e)})).then((function(e){return Y.promisify((function(t){return e.removeHandlerAsync(Office.EventType.BindingSelectionChanged,{handler:r},t)}))}));case 2:return Y.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.DocumentSelectionChanged,{handler:r},e)}));case 1:return Y.promisify((function(e){return Office.context.document.settings.removeHandlerAsync(Office.EventType.SettingsChanged,{handler:r},e)}));case 5:return Y.promisify((function(e){return OSF.DDA.RichApi.richApiMessageManager.removeHandlerAsync("richApiMessage",{handler:r},e)}));case 13:return Y.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDeleted,{id:n,handler:r},e)}));case 14:return Y.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectSelectionChanged,{id:n,handler:r},e)}));case 15:return Y.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ObjectDataChanged,{id:n,handler:r},e)}));case 16:return Y.promisify((function(e){return Office.context.document.removeHandlerAsync(Office.EventType.ContentControlAdded,{id:n,handler:r},e)}));default:throw e.RuntimeError._createInvalidArgError({argumentName:"eventId"})}},t}();e.officeJsEventRegistration=new t}(r=e._Internal||(e._Internal={}));var q=function(){function e(e,t){this.m_handlersByEventByTarget={},this.m_registerEventImpl=e,this.m_unregisterEventImpl=t}return e.getTargetIdOrDefault=function(e){return Y.isNullOrUndefined(e)?"":e},e.prototype.getHandlers=function(t,n){n=e.getTargetIdOrDefault(n);var r=this.m_handlersByEventByTarget[t];r||(r={},this.m_handlersByEventByTarget[t]=r);var i=r[n];return i||(i=[],r[n]=i),i},e.prototype.callHandlers=function(e,t,n){for(var r=this.getHandlers(e,t),i=0;i<r.length;i++)r[i](n)},e.prototype.hasHandlers=function(e,t){return this.getHandlers(e,t).length>0},e.prototype.register=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});var i=this.getHandlers(e,t);return i.push(n),1===i.length?this.m_registerEventImpl(e,t):Y._createPromiseFromResult(null)},e.prototype.unregister=function(e,t,n){if(!n)throw r.RuntimeError._createInvalidArgError({argumentName:"handler"});for(var i=this.getHandlers(e,t),o=i.length-1;o>=0;o--)if(i[o]===n){i.splice(o,1);break}return 0===i.length?this.m_unregisterEventImpl(e,t):Y._createPromiseFromResult(null)},e}();e.EventRegistration=q;var V=function(){function e(){this.m_eventRegistration=new q(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this)),this.m_richApiMessageHandler=this._handleRichApiMessage.bind(this)}return e.prototype.ready=function(){var t=this;return this.m_ready||(e._testReadyImpl?this.m_ready=e._testReadyImpl().then((function(){t.m_isReady=!0})):i.instance?this.m_ready=Y._createPromiseFromResult(null).then((function(){t.m_isReady=!0})):this.m_ready=r.officeJsEventRegistration.register(5,"",this.m_richApiMessageHandler).then((function(){t.m_isReady=!0}))),this.m_ready},Object.defineProperty(e.prototype,"isReady",{get:function(){return this.m_isReady},enumerable:!0,configurable:!0}),e.prototype.register=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.register(e,t,n)}))},e.prototype.unregister=function(e,t,n){var r=this;return this.ready().then((function(){return r.m_eventRegistration.unregister(e,t,n)}))},e.prototype._registerEventImpl=function(e,t){return Y._createPromiseFromResult(null)},e.prototype._unregisterEventImpl=function(e,t){return Y._createPromiseFromResult(null)},e.prototype._handleRichApiMessage=function(e){if(e&&e.entries)for(var t=0;t<e.entries.length;t++){var n=e.entries[t];if(n.messageCategory==H.eventMessageCategory){u._logEnabled&&u.log(JSON.stringify(n));var r=n.messageType,i=n.targetId;if(this.m_eventRegistration.hasHandlers(r,i)){var o=JSON.parse(n.message);n.isRemoteOverride&&(o.source=H.eventSourceRemote),this.m_eventRegistration.callHandlers(r,i,o)}}}},e.getGenericEventRegistration=function(t){u.isNullOrUndefined(t)&&(t="");var n=e.s_genericEventRegistrations[t];return n||(n=new e,e.s_genericEventRegistrations[t]=n),n},e.peekGenericEventRegistrationOrNull=function(t){return u.isNullOrUndefined(t)&&(t=""),e.s_genericEventRegistrations[t]},e.richApiMessageEventCategory=65536,e.s_genericEventRegistrations={},e}();e.GenericEventRegistration=V,e._testSetRichApiMessageReadyImpl=function(e){V._testReadyImpl=e},e._testTriggerRichApiMessageEvent=function(e){V.getGenericEventRegistration("")._handleRichApiMessage(e)};var z=function(e){function t(t,n,r,i){var o=e.call(this,t,n,r,i)||this;return o.m_genericEventInfo=i,o}return __extends(t,e),t.prototype.add=function(e){var t=this;0==this._handlers.length&&this.m_genericEventInfo.registerFunc&&this.m_genericEventInfo.registerFunc();var n=this._context._controlId;return V.getGenericEventRegistration(n).isReady||this._context._pendingRequest._addPreSyncPromise(V.getGenericEventRegistration(n).ready()),w.createTraceMarkerForCallback(this._context,(function(){t._handlers.push(e),1==t._handlers.length&&V.getGenericEventRegistration(n).register(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)})),new G(this._context,this,e)},t.prototype.remove=function(e){var t=this;1==this._handlers.length&&this.m_genericEventInfo.unregisterFunc&&this.m_genericEventInfo.unregisterFunc();var n=this._context._controlId;w.createTraceMarkerForCallback(this._context,(function(){for(var r=t._handlers,i=r.length-1;i>=0;i--)if(r[i]===e){r.splice(i,1);break}0==r.length&&V.getGenericEventRegistration(n).unregister(t.m_genericEventInfo.eventType,t.m_genericEventInfo.getTargetIdFunc(),t._callback)}))},t.prototype.removeAll=function(){},t}(B);e.GenericEventHandlers=z;var J=function(){function e(e){this.m_clientObject=e}return e.prototype._handleResult=function(e){this.m_clientObject._handleIdResult(e)},e}(),K=function(){function e(){}return e.createGlobalObjectObjectPath=function(e){var t={Id:e._nextId(),ObjectPathType:1,Name:""};return new h(t,null,!1,!1,1,4)},e.createNewObjectObjectPath=function(e,t,n,r){var i={Id:e._nextId(),ObjectPathType:2,Name:t};return new h(i,null,n,!1,1,Y._fixupApiFlags(r))},e.createPropertyObjectPath=function(e,t,n,r,i,o){var a={Id:e._nextId(),ObjectPathType:4,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id};return new h(a,t._objectPath,r,i,1,Y._fixupApiFlags(o))},e.createIndexerObjectPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t._objectPath,!1,!1,1,4)},e.createIndexerObjectPathUsingParentPath=function(e,t,n){var r={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t.objectPathInfo.Id,ArgumentInfo:{}};return r.ArgumentInfo.Arguments=n,new h(r,t,!1,!1,1,4)},e.createMethodObjectPath=function(e,t,n,r,i,o,a,s,c){var u={Id:e._nextId(),ObjectPathType:3,Name:n,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}},l=Y.setMethodArguments(e,u.ArgumentInfo,i),f=new h(u,t._objectPath,o,a,r,Y._fixupApiFlags(c));return f.argumentObjectPaths=l,f.getByIdMethodName=s,f},e.createReferenceIdObjectPath=function(e,t){var n={Id:e._nextId(),ObjectPathType:6,Name:t,ArgumentInfo:{}};return new h(n,null,!1,!1,1,4)},e.createChildItemObjectPathUsingIndexerOrGetItemAt=function(t,n,r,i,o){var a=Y.tryGetObjectIdFromLoadOrRetrieveResult(i);return t&&!Y.isNullOrUndefined(a)?e.createChildItemObjectPathUsingIndexer(n,r,i):e.createChildItemObjectPathUsingGetItemAt(n,r,i,o)},e.createChildItemObjectPathUsingIndexer=function(e,t,n){var r=Y.tryGetObjectIdFromLoadOrRetrieveResult(n),i=i={Id:e._nextId(),ObjectPathType:5,Name:"",ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return i.ArgumentInfo.Arguments=[r],new h(i,t._objectPath,!1,!1,1,4)},e.createChildItemObjectPathUsingGetItemAt=function(e,t,n,r){var i=n[H.index];i&&(r=i);var o={Id:e._nextId(),ObjectPathType:3,Name:H.getItemAt,ParentObjectPathId:t._objectPath.objectPathInfo.Id,ArgumentInfo:{}};return o.ArgumentInfo.Arguments=[r],new h(o,t._objectPath,!1,!1,1,4)},e}();e.ObjectPathFactory=K;var Q=function(){function t(e){this.m_context=e}return t.prototype.executeAsync=function(n,r,i){var o=this,a=c.buildMessageArrayForIRequestExecutor(n,r,i,t.SourceLibHeaderValue);return new e.Promise((function(e,t){OSF.DDA.RichApi.executeRichApiRequestAsync(a,(function(t){var n;u.log("Response:"),u.log(JSON.stringify(t)),"succeeded"==t.status?n=c.buildResponseOnSuccess(c.getResponseBody(t),c.getResponseHeaders(t)):(n=c.buildResponseOnError(t.error.code,t.error.message),o.m_context._processOfficeJsErrorResponse(t.error.code,n)),e(n)}))}))},t.SourceLibHeaderValue="officejs",t}(),X=function(){function e(e){this._autoCleanupList={},this.m_context=e}return e.prototype.add=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._addCommon(e,!0)})):this._addCommon(e,!0)},e.prototype._autoAdd=function(e){this._addCommon(e,!1),this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e},e.prototype._autoTrackIfNecessaryWhenHandleObjectResultValue=function(e,t){this.m_context._autoCleanup&&!e[H.isTracked]&&e!==this.m_context._rootObject&&t&&!Y.isNullOrEmptyString(t[H.referenceId])&&(this._autoCleanupList[e._objectPath.objectPathInfo.Id]=e,e[H.isTracked]=!0)},e.prototype._addCommon=function(e,t){if(e[H.isTracked])t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id];else{var n=e[H.referenceId];if(e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName])throw Y.createRuntimeError(o.generalException,u._getResourceString(Z.objectIsUntracked),null);Y.isNullOrEmptyString(n)&&e._KeepReference&&(e._KeepReference(),w.createInstantiateAction(this.m_context,e),t&&this.m_context._autoCleanup&&delete this._autoCleanupList[e._objectPath.objectPathInfo.Id],e[H.isTracked]=!0)}},e.prototype.remove=function(e){var t=this;Array.isArray(e)?e.forEach((function(e){return t._removeCommon(e)})):this._removeCommon(e)},e.prototype._removeCommon=function(e){e._objectPath.objectPathInfo[H.objectPathInfoDoNotKeepReferenceFieldName]=!0,e.context._pendingRequest._removeKeepReferenceAction(e._objectPath.objectPathInfo.Id);var t=e[H.referenceId];if(!Y.isNullOrEmptyString(t)){var n=this.m_context._rootObject;n._RemoveReference&&n._RemoveReference(t)}delete e[H.isTracked]},e.prototype._retrieveAndClearAutoCleanupList=function(){var e=this._autoCleanupList;return this._autoCleanupList={},e},e}();e.TrackedObjects=X;var $=function(){function t(e,t,n,r,i){e||(e="root"),this.m_globalObjName=e,this.m_referencedObjectPaths=t,this.m_actions=n,this.m_statements=[],this.m_variableNameForObjectPathMap={},this.m_variableNameToObjectPathMap={},this.m_declaredObjectPathMap={},this.m_showDispose=r,this.m_removePII=i}return t.prototype.process=function(){this.m_showDispose&&W._calculateLastUsedObjectPathIds(this.m_actions);for(var e=0;e<this.m_actions.length;e++)this.processOneAction(this.m_actions[e]);return this.m_statements},t.prototype.processForDebugStatementInfo=function(e){this.m_showDispose&&W._calculateLastUsedObjectPathIds(this.m_actions);this.m_statements=[];for(var t=-1,n=0;n<this.m_actions.length&&(this.processOneAction(this.m_actions[n]),e==n&&(t=this.m_statements.length-1),!(t>=0&&this.m_statements.length>t+5+1));n++);if(t<0)return null;var r=t-5;r<0&&(r=0);var i=t+1+5;i>this.m_statements.length&&(i=this.m_statements.length);var o=[];0!=r&&o.push("...");for(var a=r;a<t;a++)o.push(this.m_statements[a]);o.push("// >>>>>"),o.push(this.m_statements[t]),o.push("// <<<<<");for(var s=t+1;s<i;s++)o.push(this.m_statements[s]);return i<this.m_statements.length&&o.push("..."),{statement:this.m_statements[t],surroundingStatements:o}},t.prototype.processOneAction=function(e){switch(e.actionInfo.ActionType){case 1:this.processInstantiateAction(e);break;case 3:this.processMethodAction(e);break;case 2:this.processQueryAction(e);break;case 7:this.processQueryAsJsonAction(e);break;case 6:this.processRecursiveQueryAction(e);break;case 4:this.processSetPropertyAction(e);break;case 5:this.processTraceAction(e);break;case 8:this.processEnsureUnchangedAction(e);break;case 9:this.processUpdateAction(e)}},t.prototype.processInstantiateAction=function(e){var t=e.actionInfo.ObjectPathId,n=this.m_referencedObjectPaths[t],r=this.getObjVarName(t);if(this.m_declaredObjectPathMap[t]){i="// Instantiate {"+r+"}";i=this.appendDisposeCommentIfRelevant(i,e),this.m_statements.push(i)}else{var i="var "+r+" = "+this.buildObjectPathExpressionWithParent(n)+";";i=this.appendDisposeCommentIfRelevant(i,e),this.m_statements.push(i),this.m_declaredObjectPathMap[t]=r}},t.prototype.processMethodAction=function(t){var n=t.actionInfo.Name;if("_KeepReference"===n){if(!e._internalConfig.showInternalApiInDebugInfo)return;n="track"}var r=this.getObjVarName(t.actionInfo.ObjectPathId)+"."+Y._toCamelLowerCase(n)+"("+this.buildArgumentsExpression(t.actionInfo.ArgumentInfo)+");";r=this.appendDisposeCommentIfRelevant(r,t),this.m_statements.push(r)},t.prototype.processQueryAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".load("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processQueryAsJsonAction=function(e){var t=this.buildQueryExpression(e),n=this.getObjVarName(e.actionInfo.ObjectPathId)+".retrieve("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processRecursiveQueryAction=function(e){var t="";e.actionInfo.RecursiveQueryInfo&&(t=JSON.stringify(e.actionInfo.RecursiveQueryInfo));var n=this.getObjVarName(e.actionInfo.ObjectPathId)+".loadRecursive("+t+");";n=this.appendDisposeCommentIfRelevant(n,e),this.m_statements.push(n)},t.prototype.processSetPropertyAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+"."+Y._toCamelLowerCase(e.actionInfo.Name)+" = "+this.buildArgumentsExpression(e.actionInfo.ArgumentInfo)+";";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processTraceAction=function(e){var t="context.trace();";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processEnsureUnchangedAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".ensureUnchanged("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.processUpdateAction=function(e){var t=this.getObjVarName(e.actionInfo.ObjectPathId)+".update("+JSON.stringify(e.actionInfo.ObjectState)+");";t=this.appendDisposeCommentIfRelevant(t,e),this.m_statements.push(t)},t.prototype.appendDisposeCommentIfRelevant=function(e,t){var n=this;if(this.m_showDispose){var r=t.actionInfo.L;if(r&&r.length>0)return e+" // And then dispose {"+r.map((function(e){return n.getObjVarName(e)})).join(", ")+"}"}return e},t.prototype.buildQueryExpression=function(e){if(e.actionInfo.QueryInfo){var t={};return t.select=e.actionInfo.QueryInfo.Select,t.expand=e.actionInfo.QueryInfo.Expand,t.skip=e.actionInfo.QueryInfo.Skip,t.top=e.actionInfo.QueryInfo.Top,"undefined"===typeof t.top&&"undefined"===typeof t.skip&&"undefined"===typeof t.expand?"undefined"===typeof t.select?"":JSON.stringify(t.select):JSON.stringify(t)}return""},t.prototype.buildObjectPathExpressionWithParent=function(e){return(5==e.objectPathInfo.ObjectPathType||3==e.objectPathInfo.ObjectPathType||4==e.objectPathInfo.ObjectPathType)&&e.objectPathInfo.ParentObjectPathId?this.getObjVarName(e.objectPathInfo.ParentObjectPathId)+"."+this.buildObjectPathExpression(e):this.buildObjectPathExpression(e)},t.prototype.buildObjectPathExpression=function(e){var t=this.buildObjectPathInfoExpression(e.objectPathInfo),n=e.originalObjectPathInfo;return n&&(t=t+" /* originally "+this.buildObjectPathInfoExpression(n)+" */"),t},t.prototype.buildObjectPathInfoExpression=function(e){switch(e.ObjectPathType){case 1:return"context."+this.m_globalObjName;case 5:return"getItem("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 3:return Y._toCamelLowerCase(e.Name)+"("+this.buildArgumentsExpression(e.ArgumentInfo)+")";case 2:return e.Name+".newObject()";case 7:return"null";case 4:return Y._toCamelLowerCase(e.Name);case 6:return"context."+this.m_globalObjName+"._getObjectByReferenceId("+JSON.stringify(e.Name)+")"}},t.prototype.buildArgumentsExpression=function(e){var t="";if(!e.Arguments||0===e.Arguments.length)return t;if(this.m_removePII)return"undefined"===typeof e.Arguments[0]?t:"...";for(var n=0;n<e.Arguments.length;n++)n>0&&(t+=", "),t+=this.buildArgumentLiteral(e.Arguments[n],e.ReferencedObjectPathIds?e.ReferencedObjectPathIds[n]:null);return"undefined"===t&&(t=""),t},t.prototype.buildArgumentLiteral=function(e,t){return"number"==typeof e&&e===t?this.getObjVarName(t):JSON.stringify(e)},t.prototype.getObjVarNameBase=function(e){var t="v",n=this.m_referencedObjectPaths[e];if(n)switch(n.objectPathInfo.ObjectPathType){case 1:t=this.m_globalObjName;break;case 4:t=Y._toCamelLowerCase(n.objectPathInfo.Name);break;case 3:var r=n.objectPathInfo.Name;r.length>3&&"Get"===r.substr(0,3)&&(r=r.substr(3)),t=Y._toCamelLowerCase(r);break;case 5:var i=this.getObjVarNameBase(n.objectPathInfo.ParentObjectPathId);t="s"===i.charAt(i.length-1)?i.substr(0,i.length-1):i+"Item"}return t},t.prototype.getObjVarName=function(e){if(this.m_variableNameForObjectPathMap[e])return this.m_variableNameForObjectPathMap[e];var t=this.getObjVarNameBase(e);if(!this.m_variableNameToObjectPathMap[t])return this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t;for(var n=1;this.m_variableNameToObjectPathMap[t+n.toString()];)n++;return t+=n.toString(),this.m_variableNameForObjectPathMap[e]=t,this.m_variableNameToObjectPathMap[t]=e,t},t}(),Z=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),t.cannotRegisterEvent="CannotRegisterEvent",t.connectionFailureWithStatus="ConnectionFailureWithStatus",t.connectionFailureWithDetails="ConnectionFailureWithDetails",t.propertyNotLoaded="PropertyNotLoaded",t.runMustReturnPromise="RunMustReturnPromise",t.moreInfoInnerError="MoreInfoInnerError",t.cannotApplyPropertyThroughSetMethod="CannotApplyPropertyThroughSetMethod",t.invalidOperationInCellEditMode="InvalidOperationInCellEditMode",t.objectIsUntracked="ObjectIsUntracked",t.customFunctionDefintionMissing="CustomFunctionDefintionMissing",t.customFunctionImplementationMissing="CustomFunctionImplementationMissing",t.customFunctionNameContainsBadChars="CustomFunctionNameContainsBadChars",t.customFunctionNameCannotSplit="CustomFunctionNameCannotSplit",t.customFunctionUnexpectedNumberOfEntriesInResultBatch="CustomFunctionUnexpectedNumberOfEntriesInResultBatch",t.customFunctionCancellationHandlerMissing="CustomFunctionCancellationHandlerMissing",t.customFunctionInvalidFunction="CustomFunctionInvalidFunction",t.customFunctionInvalidFunctionMapping="CustomFunctionInvalidFunctionMapping",t.customFunctionWindowMissing="CustomFunctionWindowMissing",t.customFunctionDefintionMissingOnWindow="CustomFunctionDefintionMissingOnWindow",t.pendingBatchInProgress="PendingBatchInProgress",t.notInsideBatch="NotInsideBatch",t.cannotUpdateReadOnlyProperty="CannotUpdateReadOnlyProperty",t}(A);e.ResourceStrings=Z,u.addResourceStringValues({CannotRegisterEvent:"The event handler cannot be registered.",PropertyNotLoaded:"The property '{0}' is not available. Before reading the property's value, call the load method on the containing object and call \"context.sync()\" on the associated request context.",RunMustReturnPromise:'The batch function passed to the ".run" method didn\'t return a promise. The function must return a promise, so that any automatically-tracked objects can be released at the completion of the batch operation. Typically, you return a promise by returning the response from "context.sync()".',InvalidOrTimedOutSessionMessage:"Your Office Online session has expired or is invalid. To continue, refresh the page.",InvalidOperationInCellEditMode:"Excel is in cell-editing mode. Please exit the edit mode by pressing ENTER or TAB or selecting another cell, and then try again.",InvalidSheetName:"The request cannot be processed because the specified worksheet cannot be found. Please try again.",CustomFunctionDefintionMissing:"A property with the name '{0}' that represents the function's definition must exist on Excel.Script.CustomFunctions.",CustomFunctionDefintionMissingOnWindow:"A property with the name '{0}' that represents the function's definition must exist on the window object.",CustomFunctionImplementationMissing:"The property with the name '{0}' on Excel.Script.CustomFunctions that represents the function's definition must contain a 'call' property that implements the function.",CustomFunctionNameContainsBadChars:"The function name may only contain letters, digits, underscores, and periods.",CustomFunctionNameCannotSplit:"The function name must contain a non-empty namespace and a non-empty short name.",CustomFunctionUnexpectedNumberOfEntriesInResultBatch:"The batching function returned a number of results that doesn't match the number of parameter value sets that were passed into it.",CustomFunctionCancellationHandlerMissing:"The cancellation handler onCanceled is missing in the function. The handler must be present as the function is defined as cancelable.",CustomFunctionInvalidFunction:"The property with the name '{0}' that represents the function's definition is not a valid function.",CustomFunctionInvalidFunctionMapping:"The property with the name '{0}' on CustomFunctionMappings that represents the function's definition is not a valid function.",CustomFunctionWindowMissing:"The window object was not found.",PendingBatchInProgress:"There is a pending batch in progress. The batch method may not be called inside another batch, or simultaneously with another batch.",NotInsideBatch:"Operations may not be invoked outside of a batch method.",CannotUpdateReadOnlyProperty:"The property '{0}' is read-only and it cannot be updated.",ObjectIsUntracked:"The object is untracked."});var Y=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),n.fixObjectPathIfNecessary=function(e,t){e&&e._objectPath&&t&&e._objectPath.updateUsingObjectData(t,e)},n.load=function(e,t){return e.context.load(e,t),e},n.loadAndSync=function(e,t){return e.context.load(e,t),e.context.sync().then((function(){return e}))},n.retrieve=function(t,r){var i=e._internalConfig.alwaysPolyfillClientObjectRetrieveMethod;i||(i=!n.isSetSupported("RichApiRuntime","1.1"));var o=new L(t,i);return t._retrieve(r,o),o},n.retrieveAndSync=function(e,t){var r=n.retrieve(e,t);return e.context.sync().then((function(){return r}))},n.toJson=function(e,t,r,i){var o={};for(var a in t){"undefined"!==typeof(s=t[a])&&(o[a]=s)}for(var a in r){var s;"undefined"!==typeof(s=r[a])&&(s[n.fieldName_isCollection]&&"undefined"!==typeof s[n.fieldName_m__items]?o[a]=s.toJSON().items:o[a]=s.toJSON())}return i&&(o.items=i.map((function(e){return e.toJSON()}))),o},n.throwError=function(e,t,n){throw new r.RuntimeError({code:e,httpStatusCode:400,message:u._getResourceString(e,t),debugInfo:n?{errorLocation:n}:void 0})},n.createRuntimeError=function(e,t,n,i,o){return new r.RuntimeError({code:e,httpStatusCode:i,message:t,debugInfo:{errorLocation:n},data:o})},n.throwIfNotLoaded=function(e,t,r,i){if(!i&&u.isUndefined(t)&&e.charCodeAt(0)!=n.s_underscoreCharCode&&!n.s_suppressPropertyNotLoadedException)throw n.createPropertyNotLoadedException(r,e)},n._getPropertyValueWithoutCheckLoaded=function(e,t){n.s_suppressPropertyNotLoadedException=!0;try{return e[t]}finally{n.s_suppressPropertyNotLoadedException=!1}},n.createPropertyNotLoadedException=function(e,t){return new r.RuntimeError({code:T.propertyNotLoaded,httpStatusCode:400,message:u._getResourceString(Z.propertyNotLoaded,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.createCannotUpdateReadOnlyPropertyException=function(e,t){return new r.RuntimeError({code:T.cannotUpdateReadOnlyProperty,httpStatusCode:400,message:u._getResourceString(Z.cannotUpdateReadOnlyProperty,t),debugInfo:e?{errorLocation:e+"."+t}:void 0})},n.promisify=function(t){return new e.Promise((function(e,n){t((function(t){"failed"==t.status?n(t.error):e(t.value)}))}))},n._addActionResultHandler=function(e,t,n){e.context._pendingRequest.addActionResultHandler(t,n)},n._handleNavigationPropertyResults=function(e,t,n){for(var r=0;r<n.length-1;r+=2)u.isUndefined(t[n[r+1]])||e[n[r]]._handleResult(t[n[r+1]])},n._fixupApiFlags=function(e){return"boolean"===typeof e&&(e=e?1:0),e},n.definePropertyThrowUnloadedException=function(e,t,r){Object.defineProperty(e,r,{configurable:!0,enumerable:!0,get:function(){throw n.createPropertyNotLoadedException(t,r)},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(t,r)}})},n.defineReadOnlyPropertyWithValue=function(e,t,r){Object.defineProperty(e,t,{configurable:!0,enumerable:!0,get:function(){return r},set:function(){throw n.createCannotUpdateReadOnlyPropertyException(null,t)}})},n.processRetrieveResult=function(e,t,r,i){if(!u.isNullOrUndefined(t))if(i){var o=t[H.itemsLowerCase];if(Array.isArray(o)){for(var a=[],s=0;s<o.length;s++){var c=i(o[s],s),l={};l[H.proxy]=c,c._handleRetrieveResult(o[s],l),a.push(l)}n.defineReadOnlyPropertyWithValue(r,H.itemsLowerCase,a)}}else{var f=e[H.scalarPropertyNames],d=e[H.navigationPropertyNames],p=e[H.className];if(f)for(s=0;s<f.length;s++){var h=t[m=f[s]];u.isUndefined(h)?n.definePropertyThrowUnloadedException(r,p,m):n.defineReadOnlyPropertyWithValue(r,m,h)}if(d)for(s=0;s<d.length;s++){var m;h=t[m=d[s]];if(u.isUndefined(h))n.definePropertyThrowUnloadedException(r,p,m);else{var g=e[m],y={};g._handleRetrieveResult(h,y),y[H.proxy]=g,Array.isArray(y[H.itemsLowerCase])&&(y=y[H.itemsLowerCase]),n.defineReadOnlyPropertyWithValue(r,m,y)}}}},n.setMockData=function(e,t,r,i){if(u.isNullOrUndefined(t))e._handleResult(t);else{if(e[H.scalarPropertyOriginalNames]){for(var o={},a=e[H.scalarPropertyOriginalNames],s=e[H.scalarPropertyNames],c=0;c<s.length;c++)"undefined"!==typeof t[s[c]]&&(o[a[c]]=t[s[c]]);e._handleResult(o)}if(e[H.navigationPropertyNames]){var l=e[H.navigationPropertyNames];for(c=0;c<l.length;c++)if("undefined"!==typeof t[l[c]]){var f=e[l[c]];f.setMockData&&f.setMockData(t[l[c]])}}if(e[H.isCollection]&&r){var d=Array.isArray(t)?t:t[H.itemsLowerCase];if(Array.isArray(d)){var p=[];for(c=0;c<d.length;c++){var h=r(d,c);n.setMockData(h,d[c]),p.push(h)}i(p)}}}},n.applyMixin=function(e,t){Object.getOwnPropertyNames(t.prototype).forEach((function(n){"constructor"!==n&&Object.defineProperty(e.prototype,n,Object.getOwnPropertyDescriptor(t.prototype,n))}))},n.ensureTypeInitialized=function(e){var t=new k;new e(t,K.createNewObjectObjectPath(t,"Temp",!1,0))},n.fieldName_m__items="m__items",n.fieldName_isCollection="_isCollection",n._synchronousCleanup=!1,n.s_underscoreCharCode="_".charCodeAt(0),n.s_suppressPropertyNotLoadedException=!1,n}(_);e.Utility=Y;var ee=function(){function e(){}return e.invokeMethod=function(e,t,n,r,i,o){var a=w.createMethodAction(e.context,e,t,n,r,i),s=new O(o);return Y._addActionResultHandler(e,a,s),s},e.invokeEnsureUnchanged=function(e,t){w.createEnsureUnchangedAction(e.context,e,t)},e.invokeSetProperty=function(e,t,n,r){w.createSetPropertyAction(e.context,e,t,n,r)},e.createRootServiceObject=function(e,t){return new e(t,K.createGlobalObjectObjectPath(t))},e.createObjectFromReferenceId=function(e,t,n){return new e(t,K.createReferenceIdObjectPath(t,n))},e.createTopLevelServiceObject=function(e,t,n,r,i){return new e(t,K.createNewObjectObjectPath(t,n,r,i))},e.createPropertyObject=function(e,t,n,r,i){var o=K.createPropertyObjectPath(t.context,t,n,r,!1,i);return new e(t.context,o)},e.createIndexerObject=function(e,t,n){var r=K.createIndexerObjectPath(t.context,t,n);return new e(t.context,r)},e.createMethodObject=function(e,t,n,r,i,o,a,s,c){var u=K.createMethodObjectPath(t.context,t,n,r,i,o,a,s,c);return new e(t.context,u)},e.createChildItemObject=function(e,t,n,r,i){var o=K.createChildItemObjectPathUsingIndexerOrGetItemAt(t,n.context,n,r,i);return new e(n.context,o)},e}();e.BatchApiHelper=ee;var te=function(){function t(e){if(this.m_namespaceMap={},this.m_namespace=e.metadata.name,this.m_targetNamespaceObject=e.targetNamespaceObject,this.m_namespaceMap[this.m_namespace]=e.targetNamespaceObject,e.namespaceMap)for(var t in e.namespaceMap)this.m_namespaceMap[t]=e.namespaceMap[t];this.m_defaultApiSetName=e.metadata.defaultApiSetName,this.m_hostName=e.metadata.hostName;var n=e.metadata;if(n.enumTypes)for(var r=0;r<n.enumTypes.length;r++)this.buildEnumType(n.enumTypes[r]);if(n.apiSets){for(r=0;r<n.apiSets.length;r++){var i=n.apiSets[r];Array.isArray(i)&&(n.apiSets[r]={version:i[0],name:i[1]||this.m_defaultApiSetName})}this.m_apiSets=n.apiSets}if(this.m_strings=n.strings,n.clientObjectTypes)for(r=0;r<n.clientObjectTypes.length;r++){i=n.clientObjectTypes[r];Array.isArray(i)&&(this.ensureArraySize(i,11),n.clientObjectTypes[r]={name:this.getString(i[0]),behaviorFlags:i[1],collectionPropertyPath:this.getString(i[6]),newObjectServerTypeFullName:this.getString(i[9]),newObjectApiFlags:i[10],childItemTypeFullName:this.getString(i[7]),scalarProperties:i[2],navigationProperties:i[3],scalarMethods:i[4],navigationMethods:i[5],events:i[8]}),this.buildClientObjectType(n.clientObjectTypes[r],e.fullyInitialize)}}return t.prototype.ensureArraySize=function(e,t){for(var n=t-e.length;n>0;)e.push(0),n--},t.prototype.getString=function(e){return"number"===typeof e?e>0?this.m_strings[e-1]:null:e},t.prototype.buildEnumType=function(e){var t;if(Array.isArray(e)){(t={name:e[0],fields:e[2]}).fields||(t.fields={});var n=e[1];if(Array.isArray(n))for(var r=0;r<n.length;r++)t.fields[n[r]]=this.toSimpleCamelUpperCase(n[r])}else t=e;this.m_targetNamespaceObject[t.name]=t.fields},t.prototype.buildClientObjectType=function(n,r){var i=this,o=function(t,r){N.apply(this,arguments),i.m_targetNamespaceObject[n.name]._typeInited||(i.buildPrototype(i.m_targetNamespaceObject[n.name],n),i.m_targetNamespaceObject[n.name]._typeInited=!0),e._internalConfig.appendTypeNameToObjectPathInfo&&this._objectPath&&this._objectPath.objectPathInfo&&this._className&&(this._objectPath.objectPathInfo.T=this._className)};(this.m_targetNamespaceObject[n.name]=o,this.extendsType(o,N),this.buildNewObject(o,n),0!==(2&n.behaviorFlags)&&(o.prototype._KeepReference=function(){ee.invokeMethod(this,"_KeepReference",1,[],0,0)}),0!==(32&n.behaviorFlags))&&this.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_StaticCustomize").call(null,o);r&&(this.buildPrototype(o,n),o._typeInited=!0)},t.prototype.extendsType=function(e,t){function n(){this.constructor=e}e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)},t.prototype.findObjectUnderPath=function(t,n,r){for(var i=t,o=r;o<n.length;o++){if("object"!==typeof i)throw new e.Error("Cannot find "+n.join("."));i=i[n[o]]}return i},t.prototype.getFunction=function(t){var n=this.resolveObjectByFullName(t);if("function"!==typeof n)throw new e.Error("Cannot find function or type: "+t);return n},t.prototype.resolveObjectByFullName=function(e){var t=e.split(".");if(1===t.length)return this.m_targetNamespaceObject[t[0]];var n=t[0];return n===this.m_namespace?this.findObjectUnderPath(this.m_targetNamespaceObject,t,1):this.m_namespaceMap[n]?this.findObjectUnderPath(this.m_namespaceMap[n],t,1):this.findObjectUnderPath(this.m_targetNamespaceObject,t,0)},t.prototype.evaluateSimpleExpression=function(t,n){if(Y.isNullOrUndefined(t))return null;var r=t.split(".");if(3===r.length&&"OfficeExtension"===r[0]&&"Constants"===r[1])return H[r[2]];if("this"===r[0]){for(var i=n,o=1;o<r.length;o++)i="toString()"==r[o]?i.toString():"()"===r[o].substr(r[o].length-2)?i[r[o].substr(0,r[o].length-2)]():i[r[o]];return i}throw new e.Error("Cannot evaluate: "+t)},t.prototype.evaluateEventTargetId=function(e,t){return Y.isNullOrEmptyString(e)?"":this.evaluateSimpleExpression(e,t)},t.prototype.isAllDigits=function(e){for(var t="0".charCodeAt(0),n="9".charCodeAt(0),r=0;r<e.length;r++)if(e.charCodeAt(r)<t||e.charCodeAt(r)>n)return!1;return!0},t.prototype.evaluateEventType=function(t){if(Y.isNullOrEmptyString(t))return 0;if(this.isAllDigits(t))return parseInt(t);var n=this.resolveObjectByFullName(t);if("number"!==typeof n)throw new e.Error("Invalid event type: "+t);return n},t.prototype.buildPrototype=function(e,t){this.buildScalarProperties(e,t),this.buildNavigationProperties(e,t),this.buildScalarMethods(e,t),this.buildNavigationMethods(e,t),this.buildEvents(e,t),this.buildHandleResult(e,t),this.buildHandleIdResult(e,t),this.buildHandleRetrieveResult(e,t),this.buildLoad(e,t),this.buildRetrieve(e,t),this.buildSetMockData(e,t),this.buildEnsureUnchanged(e,t),this.buildUpdate(e,t),this.buildSet(e,t),this.buildToJSON(e,t),this.buildItems(e,t),this.buildTypeMetadataInfo(e,t),this.buildTrackUntrack(e,t),this.buildMixin(e,t)},t.prototype.toSimpleCamelUpperCase=function(e){return e.substr(0,1).toUpperCase()+e.substr(1)},t.prototype.ensureOriginalName=function(e){null===e.originalName&&(e.originalName=this.toSimpleCamelUpperCase(e.name))},t.prototype.getFieldName=function(e){return"m_"+e.name},t.prototype.throwIfApiNotSupported=function(e,t){if(this.m_apiSets&&t.apiSetInfoOrdinal>0){var n=this.m_apiSets[t.apiSetInfoOrdinal-1];n&&Y.throwIfApiNotSupported(e.name+"."+t.name,n.name,n.version,this.m_hostName)}},t.prototype.buildScalarProperties=function(e,t){if(Array.isArray(t.scalarProperties))for(var n=0;n<t.scalarProperties.length;n++){var r=t.scalarProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,6),t.scalarProperties[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],originalName:this.getString(r[3]),setMethodApiFlags:r[4],undoableApiSetInfoOrdinal:r[5]}),this.buildScalarProperty(e,t,t.scalarProperties[n])}},t.prototype.calculateApiFlags=function(e,t){if(t>0){var n=this.m_apiSets[t-1];n&&(e=_.calculateApiFlags(e,n.name,n.version))}return e},t.prototype.buildScalarProperty=function(e,n,r){this.ensureOriginalName(r);var i=this,o=this.getFieldName(r),a={get:function(){return Y.throwIfNotLoaded(r.name,this[o],n.name,this._isNull),i.throwIfApiNotSupported(n,r),this[o]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[o]=e;var a=i.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildNavigationProperties=function(e,t){if(Array.isArray(t.navigationProperties))for(var n=0;n<t.navigationProperties.length;n++){var r=t.navigationProperties[n];Array.isArray(r)&&(this.ensureArraySize(r,8),t.navigationProperties[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[4]),getMethodApiFlags:r[5],setMethodApiFlags:r[6],propertyTypeFullName:this.getString(r[1]),undoableApiSetInfoOrdinal:r[7]}),this.buildNavigationProperty(e,t,t.navigationProperties[n])}},t.prototype.buildNavigationProperty=function(e,n,r){this.ensureOriginalName(r);var i=this,o=this.getFieldName(r),a={get:function(){(this[i.getFieldName(r)]||(i.throwIfApiNotSupported(n,r),this[o]=ee.createPropertyObject(i.getFunction(r.propertyTypeFullName),this,r.originalName,0!==(16&r.behaviorFlags),r.getMethodApiFlags)),64&r.behaviorFlags)&&i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Get").call(this,this,this[o]);return this[o]},enumerable:!0,configurable:!0};0===(2&r.behaviorFlags)&&(a.set=function(e){if(4&r.behaviorFlags&&i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName+"_Set").call(this,this,e).handled)return;this[o]=e;var a=i.calculateApiFlags(r.setMethodApiFlags,r.undoableApiSetInfoOrdinal);ee.invokeSetProperty(this,r.originalName,e,a)}),Object.defineProperty(e.prototype,r.name,a)},t.prototype.buildScalarMethods=function(e,t){if(Array.isArray(t.scalarMethods))for(var n=0;n<t.scalarMethods.length;n++){var r=t.scalarMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.scalarMethods[n]={name:this.getString(r[0]),behaviorFlags:r[2],apiSetInfoOrdinal:r[3],originalName:this.getString(r[5]),apiFlags:r[4],parameterCount:r[1],undoableApiSetInfoOrdinal:r[6]}),this.buildScalarMethod(e,t,t.scalarMethods[n])}},t.prototype.buildScalarMethod=function(e,n,r){this.ensureOriginalName(r);var i=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var o=0;o<r.parameterCount-1;o++)e.push(arguments[o]);var a=[];for(o=r.parameterCount-1;o<arguments.length;o++)a.push(arguments[o]);e.push(a)}else for(o=0;o<arguments.length;o++)e.push(arguments[o]);if(1&r.behaviorFlags){var s=i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(o=0;o<e.length;o++)c.push(e[o]);var u=s.apply(this,c),l=u.handled,f=u.result;if(l)return f}i.throwIfApiNotSupported(n,r);var d=0;32&r.behaviorFlags&&(d=1);var p=0;2&r.behaviorFlags&&(p=1);var h=i.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.invokeMethod(this,r.originalName,p,e,h,d)}},t.prototype.buildNavigationMethods=function(e,t){if(Array.isArray(t.navigationMethods))for(var n=0;n<t.navigationMethods.length;n++){var r=t.navigationMethods[n];Array.isArray(r)&&(this.ensureArraySize(r,9),t.navigationMethods[n]={name:this.getString(r[0]),behaviorFlags:r[3],apiSetInfoOrdinal:r[4],originalName:this.getString(r[6]),apiFlags:r[5],parameterCount:r[2],returnTypeFullName:this.getString(r[1]),returnObjectGetByIdMethodName:this.getString(r[7]),undoableApiSetInfoOrdinal:r[8]}),this.buildNavigationMethod(e,t,t.navigationMethods[n])}},t.prototype.buildNavigationMethod=function(e,n,r){this.ensureOriginalName(r);var i=this;e.prototype[r.name]=function(){var e=[];if(64&r.behaviorFlags&&r.parameterCount>0){for(var o=0;o<r.parameterCount-1;o++)e.push(arguments[o]);var a=[];for(o=r.parameterCount-1;o<arguments.length;o++)a.push(arguments[o]);e.push(a)}else for(o=0;o<arguments.length;o++)e.push(arguments[o]);if(1&r.behaviorFlags){var s=i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.originalName),c=[this];for(o=0;o<e.length;o++)c.push(e[o]);var u=s.apply(this,c),l=u.handled,f=u.result;if(l)return f}if(i.throwIfApiNotSupported(n,r),0!==(16&r.behaviorFlags))return ee.createIndexerObject(i.getFunction(r.returnTypeFullName),this,e);var d=0;2&r.behaviorFlags&&(d=1);var p=i.calculateApiFlags(r.apiFlags,r.undoableApiSetInfoOrdinal);return ee.createMethodObject(i.getFunction(r.returnTypeFullName),this,r.originalName,d,e,0!==(4&r.behaviorFlags),0!==(8&r.behaviorFlags),r.returnObjectGetByIdMethodName,p)}},t.prototype.buildHandleResult=function(e,n){var r=this;e.prototype._handleResult=function(e){if(N.prototype._handleResult.call(this,e),!Y.isNullOrUndefined(e)){if(Y.fixObjectPathIfNecessary(this,e),8&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleResult").call(this,this,e);if(n.scalarProperties)for(var i=0;i<n.scalarProperties.length;i++)Y.isUndefined(e[n.scalarProperties[i].originalName])||(0!==(8&n.scalarProperties[i].behaviorFlags)?this[r.getFieldName(n.scalarProperties[i])]=Y.adjustToDateTime(e[n.scalarProperties[i].originalName]):this[r.getFieldName(n.scalarProperties[i])]=e[n.scalarProperties[i].originalName]);if(n.navigationProperties){for(var o=[],a=0;a<n.navigationProperties.length;a++)o.push(n.navigationProperties[a].name),o.push(n.navigationProperties[a].originalName);Y._handleNavigationPropertyResults(this,e,o)}if(0!==(1&n.behaviorFlags)){var s=r.hasIndexMethod(n);if(!Y.isNullOrUndefined(e[H.items])){this.m__items=[];for(var c=e[H.items],u=r.getFunction(n.childItemTypeFullName),l=0;l<c.length;l++){var f=ee.createChildItemObject(u,s,this,c[l],l);f._handleResult(c[l]),this.m__items.push(f)}}}}}},t.prototype.buildHandleRetrieveResult=function(e,t){var n=this;e.prototype._handleRetrieveResult=function(e,r){if(N.prototype._handleRetrieveResult.call(this,e,r),!Y.isNullOrUndefined(e)){if(t.scalarProperties)for(var i=0;i<t.scalarProperties.length;i++)8&t.scalarProperties[i].behaviorFlags&&(Y.isNullOrUndefined(e[t.scalarProperties[i].name])||(e[t.scalarProperties[i].name]=Y.adjustToDateTime(e[t.scalarProperties[i].name])));if(1&t.behaviorFlags){var o=n.hasIndexMethod(t),a=n.getFunction(t.childItemTypeFullName),s=this;Y.processRetrieveResult(s,e,r,(function(e,t){return ee.createChildItemObject(a,o,s,e,t)}))}else Y.processRetrieveResult(this,e,r)}}},t.prototype.buildHandleIdResult=function(e,n){var r=this;e.prototype._handleIdResult=function(e){if(N.prototype._handleIdResult.call(this,e),!Y.isNullOrUndefined(e)){if(16&n.behaviorFlags)r.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_HandleIdResult").call(this,this,e);if(n.scalarProperties)for(var i=0;i<n.scalarProperties.length;i++){var o=n.scalarProperties[i].originalName;"Id"!==o&&"_Id"!==o&&"_ReferenceId"!==o||Y.isNullOrUndefined(e[n.scalarProperties[i].originalName])||(this[r.getFieldName(n.scalarProperties[i])]=e[n.scalarProperties[i].originalName])}}}},t.prototype.buildLoad=function(e,t){e.prototype.load=function(e){return Y.load(this,e)}},t.prototype.buildRetrieve=function(e,t){e.prototype.retrieve=function(e){return Y.retrieve(this,e)}},t.prototype.buildNewObject=function(e,t){Y.isNullOrEmptyString(t.newObjectServerTypeFullName)||(e.newObject=function(n){return ee.createTopLevelServiceObject(e,n,t.newObjectServerTypeFullName,0!==(1&t.behaviorFlags),t.newObjectApiFlags)})},t.prototype.buildSetMockData=function(e,t){var n=this;if(1&t.behaviorFlags){var r=n.hasIndexMethod(t);e.prototype.setMockData=function(e){var i=this;Y.setMockData(i,e,(function(e,o){return ee.createChildItemObject(n.getFunction(t.childItemTypeFullName),r,i,e,o)}),(function(e){i.m__items=e}))}}else e.prototype.setMockData=function(e){Y.setMockData(this,e)}},t.prototype.buildEnsureUnchanged=function(e,t){e.prototype.ensureUnchanged=function(e){ee.invokeEnsureUnchanged(this,e)}},t.prototype.buildUpdate=function(e,t){e.prototype.update=function(e){this._recursivelyUpdate(e)}},t.prototype.buildSet=function(e,t){if(0===(1&t.behaviorFlags)){var n=[],r=[];if(t.scalarProperties)for(var i=0;i<t.scalarProperties.length;i++)0===(2&t.scalarProperties[i].behaviorFlags)&&0!==(1&t.scalarProperties[i].behaviorFlags)?r.push(t.scalarProperties[i].name):n.push(t.scalarProperties[i].name);var o=[];if(t.navigationProperties)for(i=0;i<t.navigationProperties.length;i++)0!==(16&t.navigationProperties[i].behaviorFlags)||0===(1&t.navigationProperties[i].behaviorFlags)||0===(32&t.navigationProperties[i].behaviorFlags)?n.push(t.navigationProperties[i].name):o.push(t.navigationProperties[i].name);0===o.length&&0===r.length||(e.prototype.set=function(e,t){this._recursivelySet(e,t,r,o,n)})}},t.prototype.buildItems=function(e,t){0!==(1&t.behaviorFlags)&&Object.defineProperty(e.prototype,"items",{get:function(){return Y.throwIfNotLoaded("items",this.m__items,t.name,this._isNull),this.m__items},enumerable:!0,configurable:!0})},t.prototype.buildToJSON=function(e,t){var n=this;0===(1&t.behaviorFlags)?e.prototype.toJSON=function(){var e={};if(t.scalarProperties)for(var r=0;r<t.scalarProperties.length;r++)0!==(1&t.scalarProperties[r].behaviorFlags)&&(e[t.scalarProperties[r].name]=this[n.getFieldName(t.scalarProperties[r])]);var i={};if(t.navigationProperties)for(r=0;r<t.navigationProperties.length;r++)0!==(1&t.navigationProperties[r].behaviorFlags)&&(i[t.navigationProperties[r].name]=this[n.getFieldName(t.navigationProperties[r])]);return Y.toJson(this,e,i)}:e.prototype.toJSON=function(){return Y.toJson(this,{},{},this.m__items)}},t.prototype.buildTypeMetadataInfo=function(e,t){Object.defineProperty(e.prototype,"_className",{get:function(){return t.name},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_isCollection",{get:function(){return 0!==(1&t.behaviorFlags)},enumerable:!0,configurable:!0}),Y.isNullOrEmptyString(t.collectionPropertyPath)||Object.defineProperty(e.prototype,"_collectionPropertyPath",{get:function(){return t.collectionPropertyPath},enumerable:!0,configurable:!0}),t.scalarProperties&&t.scalarProperties.length>0&&(Object.defineProperty(e.prototype,"_scalarPropertyNames",{get:function(){return this.m__scalarPropertyNames||(this.m__scalarPropertyNames=t.scalarProperties.map((function(e){return e.name}))),this.m__scalarPropertyNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyOriginalNames",{get:function(){return this.m__scalarPropertyOriginalNames||(this.m__scalarPropertyOriginalNames=t.scalarProperties.map((function(e){return e.originalName}))),this.m__scalarPropertyOriginalNames},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"_scalarPropertyUpdateable",{get:function(){return this.m__scalarPropertyUpdateable||(this.m__scalarPropertyUpdateable=t.scalarProperties.map((function(e){return 0===(2&e.behaviorFlags)}))),this.m__scalarPropertyUpdateable},enumerable:!0,configurable:!0})),t.navigationProperties&&t.navigationProperties.length>0&&Object.defineProperty(e.prototype,"_navigationPropertyNames",{get:function(){return this.m__navigationPropertyNames||(this.m__navigationPropertyNames=t.navigationProperties.map((function(e){return e.name}))),this.m__navigationPropertyNames},enumerable:!0,configurable:!0})},t.prototype.buildTrackUntrack=function(e,t){2&t.behaviorFlags&&(e.prototype.track=function(){return this.context.trackedObjects.add(this),this},e.prototype.untrack=function(){return this.context.trackedObjects.remove(this),this})},t.prototype.buildMixin=function(e,t){if(4&t.behaviorFlags){var n=this.getFunction(t.name+"Custom");Y.applyMixin(e,n)}},t.prototype.getOnEventName=function(e){return"_"===e[0]?"_on"+e.substr(1):"on"+e},t.prototype.buildEvents=function(e,t){if(t.events)for(var n=0;n<t.events.length;n++){var r=t.events[n];Array.isArray(r)&&(this.ensureArraySize(r,7),t.events[n]={name:this.getString(r[0]),behaviorFlags:r[1],apiSetInfoOrdinal:r[2],typeExpression:this.getString(r[3]),targetIdExpression:this.getString(r[4]),register:this.getString(r[5]),unregister:this.getString(r[6])}),this.buildEvent(e,t,t.events[n])}},t.prototype.buildEvent=function(e,t,n){1&n.behaviorFlags?this.buildV0Event(e,t,n):this.buildV2Event(e,t,n)},t.prototype.buildV2Event=function(e,n,r){var i=this,o=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,o,{get:function(){if(!this[a]){i.throwIfApiNotSupported(n,r);var e=this,o=null;"null"!==r.register&&(o=this[r.register].bind(this));var s=null;"null"!==r.unregister&&(s=this[r.unregister].bind(this));var c=null;2&r.behaviorFlags&&(c=i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));var u=i.evaluateEventType(r.typeExpression);this[a]=new z(this.context,this,r.name,{eventType:u,getTargetIdFunc:function(){return i.evaluateEventTargetId(r.targetIdExpression,e)},registerFunc:o,unregisterFunc:s,eventArgsTransformFunc:function(t){return c&&(t=c.call(e,e,t)),Y._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.buildV0Event=function(e,n,r){var i=this,o=this.getOnEventName(r.name),a=this.getFieldName(r);Object.defineProperty(e.prototype,o,{get:function(){if(!this[a]){i.throwIfApiNotSupported(n,r);var e=this,o=null;if(Y.isNullOrEmptyString(r.register)){var s=i.evaluateEventType(r.typeExpression);o=function(t){var n=i.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.register(s,n,t)}}else if("null"!==r.register){var c=i.getFunction(r.register);o=function(t){return c.call(e,e,t)}}var u=null;if(Y.isNullOrEmptyString(r.unregister)){var l=i.evaluateEventType(r.typeExpression);u=function(t){var n=i.evaluateEventTargetId(r.targetIdExpression,e);return e.context.eventRegistration.unregister(l,n,t)}}else if("null"!==r.unregister){var f=i.getFunction(r.unregister);u=function(t){return f.call(e,e,t)}}var d=null;2&r.behaviorFlags&&(d=i.getFunction(t.CustomizationCodeNamespace+"."+n.name+"_"+r.name+"_EventArgsTransform"));this[a]=new B(this.context,this,r.name,{registerFunc:o,unregisterFunc:u,eventArgsTransformFunc:function(t){return d&&(t=d.call(e,e,t)),Y._createPromiseFromResult(t)}})}return this[a]},enumerable:!0,configurable:!0})},t.prototype.hasIndexMethod=function(e){var t=!1;if(e.navigationMethods)for(var n=0;n<e.navigationMethods.length;n++)if(0!==(16&e.navigationMethods[n].behaviorFlags)){t=!0;break}return t},t.CustomizationCodeNamespace="_CC",t}();e.LibraryBuilder=te;var ne,re=1,ie=function(e){return e.DdaMethod.Version=re,e},oe=function(e){return re=e.Version,e.Error&&(e.error={},e.error.Code=e.Error),e};!function(e){e.SendingId="sId",e.RespondingId="rId",e.CommandKey="command",e.SessionInfoKey="sessionInfo",e.ParamsKey="params",e.ApiReadyCommand="apiready",e.ExecuteMethodCommand="executeMethod",e.GetAppContextCommand="getAppContext",e.RegisterEventCommand="registerEvent",e.UnregisterEventCommand="unregisterEvent",e.FireEventCommand="fireEvent"}(ne||(ne={}));var ae=function(){function e(){}return e.sessionContext="sc",e.embeddingPageOrigin="EmbeddingPageOrigin",e.embeddingPageSessionInfo="EmbeddingPageSessionInfo",e}();e.EmbeddedConstants=ae;var se=function(e){function t(t,n){var r=e.call(this)||this;return r.m_chosenWindow=null,r.m_chosenOrigin=null,r.m_enabled=!0,r.m_onMessageHandler=r._onMessage.bind(r),r.m_callbackList={},r.m_id=0,r.m_timeoutId=-1,r.m_appContext=null,r.m_url=t,r.m_options=n,r.m_options||(r.m_options={sessionKey:Math.random().toString()}),r.m_options.sessionKey||(r.m_options.sessionKey=Math.random().toString()),r.m_options.container||(r.m_options.container=document.body),r.m_options.timeoutInMilliseconds||(r.m_options.timeoutInMilliseconds=6e4),r.m_options.height||(r.m_options.height="400px"),r.m_options.width||(r.m_options.width="100%"),r.m_options.webApplication&&r.m_options.webApplication.accessToken&&r.m_options.webApplication.accessTokenTtl||(r.m_options.webApplication=null),r}return __extends(t,e),t.prototype._getIFrameSrc=function(){var e=window.location.protocol+"//"+window.location.host,t=ae.embeddingPageOrigin+"="+encodeURIComponent(e)+"&"+ae.embeddingPageSessionInfo+"="+encodeURIComponent(this.m_options.sessionKey),n=!1;(this.m_url.toLowerCase().indexOf("/_layouts/preauth.aspx")>0||this.m_url.toLowerCase().indexOf("/_layouts/15/preauth.aspx")>0)&&(n=!0);var r=document.createElement("a");if(r.href=this.m_url,this.m_options.webApplication){var i=ae.embeddingPageOrigin+"="+e+"&"+ae.embeddingPageSessionInfo+"="+this.m_options.sessionKey;0===r.search.length||"?"===r.search?r.search="?"+ae.sessionContext+"="+encodeURIComponent(i):r.search=r.search+"&"+ae.sessionContext+"="+encodeURIComponent(i)}else n?0===r.hash.length||"#"===r.hash?r.hash="#"+t:r.hash=r.hash+"&"+t:0===r.search.length||"?"===r.search?r.search="?"+t:r.search=r.search+"&"+t;return r.href},t.prototype.init=function(){var e=this;window.addEventListener("message",this.m_onMessageHandler);var t=this._getIFrameSrc();return u.createPromise((function(n,r){var i=document.createElement("iframe");if(e.m_options.id&&(i.id=e.m_options.id,i.name=e.m_options.id),i.style.height=e.m_options.height,i.style.width=e.m_options.width,e.m_options.webApplication){var s=document.createElement("form");s.setAttribute("action",t),s.setAttribute("method","post"),s.setAttribute("target",i.name),e.m_options.container.appendChild(s);var c=document.createElement("input");c.setAttribute("type","hidden"),c.setAttribute("name","access_token"),c.setAttribute("value",e.m_options.webApplication.accessToken),s.appendChild(c);var l=document.createElement("input");l.setAttribute("type","hidden"),l.setAttribute("name","access_token_ttl"),l.setAttribute("value",e.m_options.webApplication.accessTokenTtl),s.appendChild(l),e.m_options.container.appendChild(i),s.submit()}else i.src=t,e.m_options.container.appendChild(i);e.m_timeoutId=window.setTimeout((function(){e.close();var t=Y.createRuntimeError(o.timeout,u._getResourceString(a.timeout),"EmbeddedSession.init");r(t)}),e.m_options.timeoutInMilliseconds),e.m_promiseResolver=n}))},t.prototype._invoke=function(e,t,n){this.m_enabled?(ie&&(n=ie(n)),this._sendMessageWithCallback(this.m_id++,e,n,(function(e){oe&&(e=oe(e));var n=e.Error;delete e.Error,t(n||0,e)}))):t(5001,null)},t.prototype.close=function(){window.removeEventListener("message",this.m_onMessageHandler),window.clearTimeout(this.m_timeoutId),this.m_enabled=!1},t.prototype.getEventRegistration=function(e){return this.m_sessionEventManager||(this.m_sessionEventManager=new q(this._registerEventImpl.bind(this),this._unregisterEventImpl.bind(this))),this.m_sessionEventManager},t.prototype._createRequestExecutorOrNull=function(){return new ce(this)},t.prototype._resolveRequestUrlAndHeaderInfo=function(){return u._createPromiseFromResult(null)},t.prototype._registerEventImpl=function(e,t){var n=this;return u.createPromise((function(r,i){n._sendMessageWithCallback(n.m_id++,ne.RegisterEventCommand,{EventId:e,TargetId:t},(function(){r(null)}))}))},t.prototype._unregisterEventImpl=function(e,t){var n=this;return u.createPromise((function(r,i){n._sendMessageWithCallback(n.m_id++,ne.UnregisterEventCommand,{EventId:e,TargetId:t},(function(){r()}))}))},t.prototype._onMessage=function(e){var t=this;if(this.m_enabled&&(!this.m_chosenWindow||this.m_chosenWindow===e.source&&this.m_chosenOrigin===e.origin)){var n=e.data;if(n&&n[ne.CommandKey]===ne.ApiReadyCommand)!this.m_chosenWindow&&this._isValidDescendant(e.source)&&n[ne.SessionInfoKey]===this.m_options.sessionKey&&(this.m_chosenWindow=e.source,this.m_chosenOrigin=e.origin,this._sendMessageWithCallback(this.m_id++,ne.GetAppContextCommand,null,(function(e){t._setupContext(e),window.clearTimeout(t.m_timeoutId),t.m_promiseResolver()})));else if(n&&n[ne.CommandKey]===ne.FireEventCommand){var r=n[ne.ParamsKey],i=r.EventId,o=r.TargetId,a=r.Data;if(this.m_sessionEventManager)for(var s=this.m_sessionEventManager.getHandlers(i,o),c=0;c<s.length;c++)s[c](a)}else if(n&&n.hasOwnProperty(ne.RespondingId)){var u=n[ne.RespondingId];if(this.m_callbackList.hasOwnProperty(u)){var l=this.m_callbackList[u];"function"===typeof l&&l(n[ne.ParamsKey]),delete this.m_callbackList[u]}}}},t.prototype._sendMessageWithCallback=function(e,t,n,r){this.m_callbackList[e]=r;var i={};i[ne.SendingId]=e,i[ne.CommandKey]=t,i[ne.ParamsKey]=n,this.m_chosenWindow.postMessage(JSON.stringify(i),this.m_chosenOrigin)},t.prototype._isValidDescendant=function(e){function t(n){if(n===e)return!0;for(var r=0,i=n.frames.length;r<i;r++)if(t(n.frames[r]))return!0;return!1}for(var n=(this.m_options.container||document.body).getElementsByTagName("iframe"),r=0,i=n.length;r<i;r++)if(t(n[r].contentWindow))return!0;return!1},t.prototype._setupContext=function(e){this.m_appContext=e},t}(t);e.EmbeddedSession=se;var ce=function(){function e(e){this.m_session=e}return e.prototype.executeAsync=function(t,n,r){var i=this,o=c.buildMessageArrayForIRequestExecutor(t,n,r,e.SourceLibHeaderValue);return u.createPromise((function(t,n){i.m_session._invoke(ne.ExecuteMethodCommand,(function(e,n){var r;u.log("Response:"),u.log(JSON.stringify(n)),r=0==e?c.buildResponseOnSuccess(c.getResponseBodyFromSafeArray(n.Data),c.getResponseHeadersFromSafeArray(n.Data)):c.buildResponseOnError(n.error.Code,n.error.Message),t(r)}),e._transformMessageArrayIntoParams(o))}))},e._transformMessageArrayIntoParams=function(t){return{ArrayData:t,DdaMethod:{DispatchId:e.DispidExecuteRichApiRequestMethod}}},e.DispidExecuteRichApiRequestMethod=93,e.SourceLibHeaderValue="Embedded",e}()}(OfficeExtension||(OfficeExtension={}));__extends=this&&this.__extends||function(){var e=function(t,n){return(e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(t,n)};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();var OfficeFirstPartyDialog,OfficeFirstPartyAuth,OfficeCore,Office,OfficeFirstParty,__awaiter=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function a(e){try{c(r.next(e))}catch(e){o(e)}}function s(e){try{c(r.throw(e))}catch(e){o(e)}}function c(e){e.done?i(e.value):new n((function(t){t(e.value)})).then(a,s)}c((r=r.apply(e,t||[])).next())}))},__generator=this&&this.__generator||function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"===typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!(i=(i=a.trys).length>0&&i[i.length-1])&&(6===o[0]||2===o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}};!function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),i=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),o=OfficeExtension.Utility.fixObjectPathIfNecessary,a=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),s=function(s){function c(){return null!==s&&s.apply(this,arguments)||this}return __extends(c,s),Object.defineProperty(c.prototype,"_className",{get:function(){return"BiShim"},enumerable:!0,configurable:!0}),c.prototype.initialize=function(e){n(this,"Initialize",0,[e],0,0)},c.prototype.getData=function(){return n(this,"getData",1,[],4,0)},c.prototype.setVisualObjects=function(e){n(this,"setVisualObjects",0,[e],2,0)},c.prototype.setVisualObjectsToPersist=function(e){n(this,"setVisualObjectsToPersist",0,[e],2,0)},c.prototype._handleResult=function(e){(s.prototype._handleResult.call(this,e),r(e))||o(this,e)},c.prototype._handleRetrieveResult=function(e,t){s.prototype._handleRetrieveResult.call(this,e,t),a(this,e,t)},c.newObject=function(n){return t(e.BiShim,n,"Microsoft.AgaveVisual.BiShim",!1,4)},c.prototype.toJSON=function(){return i(this,{},{})},c}(OfficeExtension.ClientObject);e.BiShim=s,function(e){e.generalException1="GeneralException"}(e.AgaveVisualErrorCodes||(e.AgaveVisualErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject;var t=OfficeExtension.BatchApiHelper.createMethodObject,n=(OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),i=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,o=(OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),a=OfficeExtension.Utility.isUndefined,s=OfficeExtension.Utility.throwIfNotLoaded,c=(OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load),u=OfficeExtension.Utility.retrieve,l=OfficeExtension.Utility.toJson,f=OfficeExtension.Utility.fixObjectPathIfNecessary,d=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),p=function(i){function a(){return null!==i&&i.apply(this,arguments)||this}return __extends(a,i),Object.defineProperty(a.prototype,"_className",{get:function(){return"FlightingService"},enumerable:!0,configurable:!0}),a.prototype.getClientSessionId=function(){return r(this,"GetClientSessionId",1,[],4,0)},a.prototype.getDeferredFlights=function(){return r(this,"GetDeferredFlights",1,[],4,0)},a.prototype.getFeature=function(n,r,i,o){return t(e.ABType,this,"GetFeature",1,[n,r,i,o],!1,!1,null,4)},a.prototype.getFeatureGate=function(n,r){return t(e.ABType,this,"GetFeatureGate",1,[n,r],!1,!1,null,4)},a.prototype.resetOverride=function(e){r(this,"ResetOverride",0,[e],0,0)},a.prototype.setOverride=function(e,t,n){r(this,"SetOverride",0,[e,t,n],0,0)},a.prototype._handleResult=function(e){(i.prototype._handleResult.call(this,e),o(e))||f(this,e)},a.prototype._handleRetrieveResult=function(e,t){i.prototype._handleRetrieveResult.call(this,e,t),d(this,e,t)},a.newObject=function(t){return n(e.FlightingService,t,"Microsoft.Experiment.FlightingService",!1,4)},a.prototype.toJSON=function(){return l(this,{},{})},a}(OfficeExtension.ClientObject);e.FlightingService=p;var h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"ABType"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return s("value",this._V,"ABType",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!o(t)){var n=t;f(this,n),a(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return c(this,e)},t.prototype.retrieve=function(e){return u(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),d(this,t,n)},t.prototype.toJSON=function(){return l(this,{value:this._V},{})},t.prototype.ensureUnchanged=function(e){i(this,e)},t}(OfficeExtension.ClientObject);e.ABType=h,function(e){e.boolean="Boolean",e.integer="Integer",e.string="String"}(e.FeatureType||(e.FeatureType={})),function(e){e.generalException="GeneralException"}(e.ExperimentErrorCodes||(e.ExperimentErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t,n=function(){function e(e){this._dialogService=e}return e.prototype.close=function(){return this._dialogService.close(),this._dialogService.context.sync()},e.prototype.messageChild=function(e,t){DialogApiManager&&DialogApiManager.messageChildRichApiBridge&&DialogApiManager.messageChildRichApiBridge(e,t)},e}();e.Dialog=n,e.displayWebDialog=function(t,n){return void 0===n&&(n={}),new OfficeExtension.CoreUtility.Promise((function(i,o){if(n.width&&n.height&&(!r(n.width)||!r(n.height)))throw new OfficeExtension.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var a=new OfficeExtension.ClientRequestContext,s=OfficeCore.FirstPartyDialogService.newObject(a),c=new e.Dialog(s),u=s.onDialogMessage.add((function(e){OfficeExtension.Utility.log("dialogMessageHandler:"+JSON.stringify(e));var t=JSON.parse(e.message),r=t.errorCode?new OfficeExtension.Error(function(e){var t,n=((t={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},t[12003]={code:"InvalidUrl",message:"HTTPS is required."},t[12004]={code:"Untrusted",message:"Domain is not trusted."},t[12005]={code:"InvalidUrl",message:"HTTPS is required."},t[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},t);return n[e]?n[e]:{code:"Unknown",message:"An unknown error has occured with code: "+e}}(t.errorCode)):null,s=t.type,l=t.origin,f=t.message;switch(s){case 17:r?o(r):i(c);break;case 12:n.onMessage&&n.onMessage(f,c,l);break;case 10:default:12006===t.errorCode?(u&&(u.remove(),a.sync()),n.onClose&&n.onClose()):n.onRuntimeError&&(n.onRuntimeError(r,c),o(r))}return OfficeExtension.CoreUtility.Promise.resolve()}));return a.sync().then((function(){var e={width:n.width?parseInt(n.width):50,height:n.height?parseInt(n.height):50,displayInIFrame:n.displayInIFrame,dialogTitle:n.dialogTitle};return s.displayDialog(t,e),a.sync()})).catch((function(e){o(e)}))}));function r(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}},function(e){e[e.dialogMessageReceived=0]="dialogMessageReceived",e[e.dialogEventReceived=1]="dialogEventReceived"}(t||(t={}))}(OfficeFirstPartyDialog||(OfficeFirstPartyDialog={})),function(e){e.OfficeOnlineDomainList=["*.dod.online.office365.us","*.gov.online.office365.us","*.officeapps-df.live.com","*.officeapps.live.com","*.online.office.de","*.partner.officewebapps.cn"],e.isHostOriginTrusted=function(){if("undefined"===typeof window.external||"undefined"===typeof window.external.GetContext){var t=OSF.getClientEndPoint()._targetUrl,n=function(e){return e.split("/")[2].split(":")[0].split("?")[0]}(t);return 0!=t.indexOf("https:")||e.OfficeOnlineDomainList.forEach((function(e){if(0==e.indexOf("*.")&&(e=e.substring(2)),n.indexOf(e)==n.length-e.length)return!0})),!1}return!0}}(OfficeCore||(OfficeCore={})),function(e){var t=function(){function t(e){this.context=e}return Object.defineProperty(t.prototype,"roamingSettings",{get:function(){return this.m_roamingSettings||(this.m_roamingSettings=e.AuthenticationService.newObject(this.context).roamingSettings),this.m_roamingSettings},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"tap",{get:function(){return this.m_tap||(this.m_tap=e.Tap.newObject(this.context)),this.m_tap},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"skill",{get:function(){return this.m_skill||(this.m_skill=e.Skill.newObject(this.context)),this.m_skill},enumerable:!0,configurable:!0}),t}();e.FirstPartyApis=t;var n=function(n){function r(e){return n.call(this,e)||this}return __extends(r,n),Object.defineProperty(r.prototype,"firstParty",{get:function(){return this.m_firstPartyApis||(this.m_firstPartyApis=new t(this)),this.m_firstPartyApis},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flighting",{get:function(){return this.flightingService},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"telemetry",{get:function(){return this.m_telemetry||(this.m_telemetry=e.TelemetryService.newObject(this)),this.m_telemetry},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"ribbon",{get:function(){return this.m_ribbon||(this.m_ribbon=e.DynamicRibbon.newObject(this)),this.m_ribbon},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"bi",{get:function(){return this.m_biShim||(this.m_biShim=e.BiShim.newObject(this)),this.m_biShim},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"flightingService",{get:function(){return this.m_flightingService||(this.m_flightingService=e.FlightingService.newObject(this)),this.m_flightingService},enumerable:!0,configurable:!0}),r}(OfficeExtension.ClientRequestContext);e.RequestContext=n,e.run=function(t,n){return OfficeExtension.ClientRequestContext._runBatch("OfficeCore.run",arguments,(function(t){return new e.RequestContext(t)}))}}(OfficeCore||(OfficeCore={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.isFeatureEnabled=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,i,o;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),i=OfficeCore.License.newObject(r),o=i.isFeatureEnabled(e,n),[4,r.sync()];case 1:return a.sent(),[2,o.value]}}))}))},e.getFeatureTier=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,i,o;return __generator(this,(function(a){switch(a.label){case 0:return r=t(),i=OfficeCore.License.newObject(r),o=i.getFeatureTier(e,n),[4,r.sync()];case 1:return a.sent(),[2,o.value]}}))}))},e.isFreemiumUpsellEnabled=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(i){switch(i.label){case 0:return e=t(),n=OfficeCore.License.newObject(e),r=n.isFreemiumUpsellEnabled(),[4,e.sync()];case 1:return i.sent(),[2,r.value]}}))}))},e.launchUpsellExperience=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.License.newObject(n).launchUpsellExperience(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onFeatureStateChanged=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r,i,o,a;return __generator(this,(function(s){switch(s.label){case 0:return r=t(),i=OfficeCore.License.newObject(r),(o=i.getLicenseFeature(e)).onStateChanged.add(n),a=function(){return o.onStateChanged.remove(n),null},[4,r.sync()];case 1:return s.sent(),[2,a]}}))}))},e.getMsaDeviceTicket=function(e,n,r){return __awaiter(this,void 0,void 0,(function(){var i,o,a;return __generator(this,(function(s){switch(s.label){case 0:return i=t(),o=OfficeCore.License.newObject(i),a=o.getMsaDeviceTicket(e,n,r),[4,i.sync()];case 1:return s.sent(),[2,a.value]}}))}))}}(e.license||(e.license={}))}(Office||(Office={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t,n=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,r=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),i=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),o=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function u(){return null!==c&&c.apply(this,arguments)||this}return __extends(u,c),Object.defineProperty(u.prototype,"_className",{get:function(){return"Skill"},enumerable:!0,configurable:!0}),u.prototype.executeAction=function(e,t,n){return r(this,"ExecuteAction",1,[e,t,n],5,0)},u.prototype.notifyPaneEvent=function(e,t){r(this,"NotifyPaneEvent",1,[e,t],5,0)},u.prototype.registerHostSkillEvent=function(){r(this,"RegisterHostSkillEvent",0,[],1,0)},u.prototype.testFireEvent=function(){r(this,"TestFireEvent",0,[],1,0)},u.prototype.unregisterHostSkillEvent=function(){r(this,"UnregisterHostSkillEvent",0,[],1,0)},u.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),i(e))||a(this,e)},u.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},u.newObject=function(t){return n(e.Skill,t,"Microsoft.SkillApi.Skill",!1,4)},Object.defineProperty(u.prototype,"onHostSkillEvent",{get:function(){var e=this;return this.m_hostSkillEvent||(this.m_hostSkillEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"HostSkillEvent",{eventType:65538,registerFunc:function(){return e.registerHostSkillEvent()},unregisterFunc:function(){return e.unregisterHostSkillEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(n){var r=t.Skill_HostSkillEvent_EventArgsTransform(e,n);return OfficeExtension.Utility._createPromiseFromResult(r)}})),this.m_hostSkillEvent},enumerable:!0,configurable:!0}),u.prototype.toJSON=function(){return o(this,{},{})},u}(OfficeExtension.ClientObject));e.Skill=c,function(e){e.Skill_HostSkillEvent_EventArgsTransform=function(e,t){return{type:t.type,data:t.data}}}(t=e._CC||(e._CC={})),function(e){e.generalException="GeneralException"}(e.SkillErrorCodes||(e.SkillErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject;var t=OfficeExtension.BatchApiHelper.createTopLevelServiceObject,n=(OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod),r=(OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined),i=(OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported),o=(OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson),a=OfficeExtension.Utility.fixObjectPathIfNecessary,s=(OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),c=(OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags,function(c){function u(){return null!==c&&c.apply(this,arguments)||this}return __extends(u,c),Object.defineProperty(u.prototype,"_className",{get:function(){return"TelemetryService"},enumerable:!0,configurable:!0}),u.prototype.sendCustomerContent=function(e,t,r,o,a){i("TelemetryService.sendCustomerContent","Telemetry","1.3","OfficeCore"),n(this,"SendCustomerContent",1,[e,t,r,o,a],4,0)},u.prototype.sendTelemetryEvent=function(e,t,r,i,o){n(this,"SendTelemetryEvent",1,[e,t,r,i,o],4,0)},u.prototype._handleResult=function(e){(c.prototype._handleResult.call(this,e),r(e))||a(this,e)},u.prototype._handleRetrieveResult=function(e,t){c.prototype._handleRetrieveResult.call(this,e,t),s(this,e,t)},u.newObject=function(n){return t(e.TelemetryService,n,"Microsoft.Telemetry.TelemetryService",!1,4)},u.prototype.toJSON=function(){return o(this,{},{})},u}(OfficeExtension.ClientObject));e.TelemetryService=c,function(e){e.unset="Unset",e.string="String",e.boolean="Boolean",e.int64="Int64",e.double="Double"}(e.DataFieldType||(e.DataFieldType={})),function(e){e.generalException="GeneralException"}(e.TelemetryErrorCodes||(e.TelemetryErrorCodes={}))}(OfficeCore||(OfficeCore={})),function(e){var t=!1;function n(n,i){return new OfficeExtension.CoreUtility.Promise((function(o,a){if(OSF.WebAuth&&"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform){var s=!1;try{if(!Office||!Office.context||!Office.context.webAuth)return void a({code:"GetAuthContextAsyncMissing",message:"Office:["+!Office+"],Office.context:["+!Office.context+"],Office.context.webAuth:["+!Office.context.webAuth+"]"});Office.context.webAuth.getAuthContextAsync((function(c){if("succeeded"===c.status){s=!0;var u=c.value;if(!u||u.isAnonymous)return void a({code:"CannotGetAuthContext",message:u.Error});var l="msa"===u.authorityType.toLowerCase();if(OSF.WebAuth.config={authFlow:e.authFlow,authVersion:e.authVersion?e.authVersion:null,msal:e.msal,delayWebAuth:e.delay,delayMsal:e.delayMsal,debugging:e.debugging,authority:e.authorityOverride?e.authorityOverride:u.authority,idp:u.authorityType.toLowerCase(),appIds:[l&&u.msaAppId?u.msaAppId:u.appId],redirectUri:n||null,upn:u.upn,puid:u.userId,prefetch:i,telemetryInstance:"otel",autoPopup:e.autoPopup,enableUpnCheck:e.upnCheck,enableConsoleLogging:e.debugging},OSF.WebAuth.load().then((function(e){r(e,t=!0),o()})).catch((function(e){r(e,t),a({code:"PackageNotLoaded",message:e instanceof Event?e.type:e})})),"implicit"===e.authFlow){var f=n||window.location.href.split("?")[0],d=sessionStorage.getItem("officeWebAuthReplyUrls");d||""===d?d=f:d+=", "+f,d&&sessionStorage.setItem("officeWebAuthReplyUrls",d)}}else OSF.WebAuth.config=null,a({code:"CannotGetAuthContext",message:c.status})}))}catch(e){OSF.WebAuth.config=null,OSF.WebAuth.load().then((function(){o()})).catch((function(){a({code:s?"CannotGetAuthContext":"FailedToLoad",message:e})}))}}else o()}))}function r(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",{authFlow:OSF.WebAuth.config.authFlow,authVersion:OSF.WebAuth.config.authVersion,msal:OSF.WebAuth.config.msal,autoPopup:OSF.WebAuth.config.autoPopup,enableUpnCheck:OSF.WebAuth.config.upnCheck}),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:"")];if(e&&!(e instanceof Event)&&e.Telemetry)for(var r in e.Telemetry)if(e.Telemetry[r])switch(r){case"succeeded":n.push(oteljs.makeBooleanDataField(r,e.Telemetry[r]));break;case"loadedApplicationCount":case"timeToLoad":n.push(oteljs.makeInt64DataField(r,e.Telemetry[r]));break;default:n.push(oteljs.makeStringDataField(r,e.Telemetry[r]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.Load",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}function i(e,t,n){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var r=[oteljs.makeStringDataField("IdentityProvider",OSF.WebAuth.config.idp),oteljs.makeStringDataField("AppId",OSF.WebAuth.config.appIds[0]),oteljs.makeStringDataField("Target",{authFlow:OSF.WebAuth.config.authFlow,authVersion:OSF.WebAuth.config.authVersion,msal:OSF.WebAuth.config.msal,autoPopup:OSF.WebAuth.config.autoPopup,enableUpnCheck:OSF.WebAuth.config.upnCheck}),oteljs.makeBooleanDataField("Popup","boolean"===typeof n&&n),oteljs.makeBooleanDataField("Result",t),oteljs.makeStringDataField("Error",e instanceof Event?e.type:e.ErrorCode)];if(e&&!(e instanceof Event)&&e.Telemetry)for(var i in e.Telemetry)if(e.Telemetry[i])switch(i){case"succeeded":r.push(oteljs.makeBooleanDataField(i,e.Telemetry[i]));break;case"timeToGetToken":r.push(oteljs.makeInt64DataField(i,e.Telemetry[i]));break;default:r.push(oteljs.makeStringDataField(i,e.Telemetry[i]))}OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.GetAccessToken",dataFields:r,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}e.authFlow="authcode",e.autoPopup=!1,e.upnCheck=!0,e.msal="https://alcdn.msauth.net/browser-1p/2.28.1/js/msal-browser-1p.min.js",e.debugging=!1,e.delay=0,e.delayMsal=0,e.load=n,e.getAccessToken=function(e,n){return new OfficeExtension.CoreUtility.Promise((function(r,o){if("web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform)Office.context.webAuth.getAuthContextAsync((function(a){var s=!1;"succeeded"===a.status&&(a.value.supportsAuthToken&&(s=!0));if(s){var c=new OfficeCore.RequestContext,u=OfficeCore.AuthenticationService.newObject(c);c._customData="WacPartition";var l=u.getAccessToken(e,null);c.sync().then((function(){r(l.value)}))}else OSF.WebAuth&&t?OSF.WebAuth.config.appIds[0]&&OSF.WebAuth.getToken(e.resource,OSF.WebAuth.config.appIds[0],OSF._OfficeAppFactory.getHostInfo().osfControlAppCorrelationId,n&&n.popup?n.popup:null,e&&e.authChallenge?e.authChallenge:null).then((function(e){i(e,!0,!(!n||!n.popup)&&n.popup),r({accessToken:e.Token,tokenIdenityType:"msa"==OSF.WebAuth.config.idp.toLowerCase()?OfficeCore.IdentityType.microsoftAccount:OfficeCore.IdentityType.organizationAccount})})).catch((function(e){i(e,!1,!(!n||!n.popup)&&n.popup),o({code:e.ErrorCode,message:e instanceof Event?e.type:e.ErrorMessage})})):function(e,t){"undefined"!==typeof OTel&&OTel.OTelLogger.onTelemetryLoaded((function(){var n=[oteljs.makeBooleanDataField("Loaded",e),oteljs.makeInt64DataField("LoadAttempts","number"===typeof t?t:0)];OTel.OTelLogger.sendTelemetryEvent({eventName:"Office.Extensibility.OfficeJs.OfficeFirstPartyAuth.UnexpectedAcquire",dataFields:n,eventFlags:{dataCategories:oteljs.DataCategories.ProductServiceUsage}})}))}(t,OSF.WebAuth.loadAttempts)}));else{var a=new OfficeCore.RequestContext,s=OfficeCore.AuthenticationService.newObject(a),c=s.onTokenReceived.add((function(e){if(!OfficeExtension.CoreUtility.isNullOrUndefined(e))if(c.remove(),a.sync().catch((function(){})),0==e.code)r(e.tokenValue);else if(OfficeExtension.CoreUtility.isNullOrUndefined(e.errorInfo))o({code:e.code});else try{o(JSON.parse(e.errorInfo))}catch(t){o({code:e.code,message:e.errorInfo})}return null}));a.sync().then((function(){var t=s.getAccessToken(e,s._targetId);return a.sync().then((function(){if(OfficeExtension.CoreUtility.isNullOrUndefined(t.value))return null;var e=t.value.accessToken;OfficeExtension.CoreUtility.isNullOrUndefined(e)||r(t.value)}))})).catch((function(e){o(e)}))}}))},e.getPrimaryIdentityInfo=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e);e._customData="WacPartition";var n=t.getPrimaryIdentityInfo();return e.sync().then((function(){return n.value}))},e.getIdentities=function(){var e=new OfficeCore.RequestContext,t=OfficeCore.AuthenticationService.newObject(e).getIdentities();return e.sync().then((function(){return t.value}))},e.onIdentityChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r=this;return __generator(this,(function(i){switch(i.label){case 0:return i.trys.push([0,3,,4]),"web"===OSF._OfficeAppFactory.getHostInfo().hostPlatform?[3,2]:(t=new OfficeCore.RequestContext,n=OfficeCore.AuthenticationService.newObject(t),n.onIdentityChanged.add(e),[4,t.sync()]);case 1:return i.sent(),[2,function(){return __awaiter(r,void 0,void 0,(function(){return __generator(this,(function(r){switch(r.label){case 0:return n.onIdentityChanged.remove(e),[4,t.sync()];case 1:return r.sent(),[2]}}))}))}];case 2:return[3,4];case 3:return i.sent(),[3,4];case 4:return[2,function(){return Promise.resolve()}]}}))}))},"undefined"!==typeof window&&window.OSF&&function(){try{if("undefined"===typeof window||!window.sessionStorage)return;var e=sessionStorage.getItem("officeWebAuthReplyUrls");null!==e&&-1!==e.indexOf(window.location.origin+window.location.pathname)&&n()}catch(e){console.error(e)}}()}(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={})),function(e){!function(e){var t;!function(e){e[e.UnsupportedUserIdentity=13003]="UnsupportedUserIdentity",e[e.UserAborted=13004]="UserAborted",e[e.InteractionRequired=13005]="InteractionRequired",e[e.ClientError=13006]="ClientError",e[e.ServerError=13007]="ServerError",e[e.NotAvailable=13012]="NotAvailable",e[e.InternalError=5001]="InternalError"}(t=e.AuthErrorCode||(e.AuthErrorCode={}));var n={ACCOUNT_UNAVAILABLE:t.UnsupportedUserIdentity,USER_CANCEL:t.UserAborted,USER_INTERACTION_REQUIRED:t.InteractionRequired,PERSISTENT_ERROR:t.ClientError,NO_NETWORK:t.ServerError,TRANSIENT_ERROR:t.ServerError,NESTED_APP_AUTH_UNAVAILABLE:t.NotAvailable},r=!1,i={},o=function(e){try{var r=JSON.parse(e);if(r.requestId){var o=r.requestId;if(i.hasOwnProperty(o)){var a=t.InternalError,s=i[o],c=s[0],u=s[1];delete i[o];var l=r.body;if(l){if(!0===r.success&&l.access_token&&"number"==typeof l.expires_in)return void c({accessToken:l.access_token,expiresOn:new Date(Date.now()+1e3*l.expires_in)});var f=l.status;n[f]&&(a=n[f])}u({code:a})}}}catch(e){}};function a(e,n){var a=OSF.OUtil.Guid.generateNewGuid();return new Promise((function(s,c){if("undefined"!==typeof nestedAppAuthBridge){var u={messageType:"NestedAppAuthRequest",method:n?"GetToken":"GetTokenPopup",requestId:a,clientLibrary:"officejs",body:{clientId:e.clientId,scope:e.scope,correlationId:e.correlationId,claims:e.claims}};r||(nestedAppAuthBridge.addEventListener("message",o),r=!0),i[a]=[s,c],nestedAppAuthBridge.postMessage(JSON.stringify(u))}else c(OSF.DDA.ErrorCodeManager.getErrorArgs(t.NotAvailable))}))}e.getAccessToken=function(e){return a(e,!0).catch((function(n){if(n.code==t.InteractionRequired&&!1===e.silent)return a(e,!1);throw n}))}}(e.NestedAppAuth||(e.NestedAppAuth={}))}(OfficeFirstPartyAuth||(OfficeFirstPartyAuth={})),function(e){var t,n=OfficeExtension.BatchApiHelper.createPropertyObject,r=OfficeExtension.BatchApiHelper.createMethodObject,i=OfficeExtension.BatchApiHelper.createIndexerObject,o=(OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),a=OfficeExtension.BatchApiHelper.createChildItemObject,s=OfficeExtension.BatchApiHelper.invokeMethod,c=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,u=OfficeExtension.BatchApiHelper.invokeSetProperty,l=OfficeExtension.Utility.isNullOrUndefined,f=OfficeExtension.Utility.isUndefined,d=OfficeExtension.Utility.throwIfNotLoaded,p=OfficeExtension.Utility.throwIfApiNotSupported,h=OfficeExtension.Utility.load,m=OfficeExtension.Utility.retrieve,g=OfficeExtension.Utility.toJson,y=OfficeExtension.Utility.fixObjectPathIfNecessary,O=OfficeExtension.Utility._handleNavigationPropertyResults,v=OfficeExtension.Utility.adjustToDateTime,b=OfficeExtension.Utility.processRetrieveResult,S=OfficeExtension.Utility.setMockData,_=OfficeExtension.CommonUtility.calculateApiFlags,A=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"DialogPage"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["_Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_Id",{get:function(){return d("_Id",this.__I,"DialogPage",this._isNull),this.__I},enumerable:!0,configurable:!0}),n.prototype.close=function(){s(this,"Close",1,[],4,0)},n.prototype.readyToShow=function(){s(this,"ReadyToShow",1,[],4,0)},n.prototype.registerOnShow=function(){s(this,"RegisterOnShow",1,[],4,0)},n.prototype.sendMessageToHost=function(e){s(this,"SendMessageToHost",1,[e],4,0)},n.prototype.unregisterOnShow=function(){s(this,"UnregisterOnShow",1,[],4,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n._Id)||(this.__I=n._Id)}},n.prototype.load=function(e){return h(this,e)},n.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||f(e._Id)||(this.__I=e._Id)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.DialogPage,t,"Microsoft.Office.DialogPage.DialogPage",!1,4)},Object.defineProperty(n.prototype,"onOnShowEvent",{get:function(){var e=this;return this.m_onShowEvent||(this.m_onShowEvent=new OfficeExtension.GenericEventHandlers(this.context,this,"OnShowEvent",{eventType:1,registerFunc:function(){return e.registerOnShow()},unregisterFunc:function(){return e.unregisterOnShow()},getTargetIdFunc:function(){return e._Id},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_onShowEvent},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.DialogPage=A,function(e){e.unknown="Unknown",e.basic="Basic",e.premium="Premium"}(t=e.LicenseFeatureTier||(e.LicenseFeatureTier={}));var D=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"License"},enumerable:!0,configurable:!0}),n.prototype.getFeatureTier=function(e,t){return s(this,"GetFeatureTier",1,[e,t],4,0)},n.prototype.getLicenseFeature=function(t){return r(e.LicenseFeature,this,"GetLicenseFeature",1,[t],!1,!1,null,4)},n.prototype.getMsaDeviceTicket=function(e,t,n){return s(this,"GetMsaDeviceTicket",1,[e,t,n],5,0)},n.prototype.isFeatureEnabled=function(e,t){return s(this,"IsFeatureEnabled",1,[e,t],4,0)},n.prototype.isFreemiumUpsellEnabled=function(){return s(this,"IsFreemiumUpsellEnabled",1,[],4,0)},n.prototype.launchUpsellExperience=function(e){s(this,"LaunchUpsellExperience",1,[e],4,0)},n.prototype._TestFireStateChangedEvent=function(e){s(this,"_TestFireStateChangedEvent",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.License,t,"Microsoft.Office.Licensing.License",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.License=D;var C,P=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LicenseFeature"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return d("id",this._I,"LicenseFeature",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype._RegisterStateChange=function(){s(this,"_RegisterStateChange",1,[],4,0)},t.prototype._UnregisterStateChange=function(){s(this,"_UnregisterStateChange",1,[],4,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||f(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},Object.defineProperty(t.prototype,"onStateChanged",{get:function(){var e=this;return this.m_stateChanged||(this.m_stateChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"StateChanged",{eventType:1,registerFunc:function(){return e._RegisterStateChange()},unregisterFunc:function(){return e._UnregisterStateChange()},getTargetIdFunc:function(){return e.id},eventArgsTransformFunc:function(t){var n=C.LicenseFeature_StateChanged_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_stateChanged},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return g(this,{id:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.LicenseFeature=P,function(e){e.LicenseFeature_StateChanged_EventArgsTransform=function(e,n){var r={feature:n.featureName,isEnabled:n.isEnabled,tier:n.tierName};return n.tierName&&(r.tier=0==n.tierName?t.unknown:1==n.tierName?t.basic:2==n.tierName?t.premium:n.tierName),r}}(C=e._CC||(e._CC={}));var F=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"MsaDeviceTicketOptions"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Scopes"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"scopes",{get:function(){return d("scopes",this._S,"MsaDeviceTicketOptions",this._isNull),this._S},set:function(e){this._S=e,u(this,"Scopes",e,0)},enumerable:!0,configurable:!0}),n.prototype.set=function(e,t){this._recursivelySet(e,t,["scopes"],[],[])},n.prototype.update=function(e){this._recursivelyUpdate(e)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Scopes)||(this._S=n.Scopes)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.MsaDeviceTicketOptions,t,"Microsoft.Office.Licensing.MsaDeviceTicketOptions",!1,4)},n.prototype.toJSON=function(){return g(this,{scopes:this._S},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.MsaDeviceTicketOptions=F;var E=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimePersistenceService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeStartState=function(){return s(this,"GetAppRuntimeStartState",1,[],4,0)},n.prototype.setAppRuntimeStartState=function(e){s(this,"SetAppRuntimeStartState",0,[e],_(2,"SharedRuntimeInternal","1.2"),0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.AppRuntimePersistenceService,t,"Microsoft.AppRuntime.AppRuntimePersistenceService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimePersistenceService=E;var I=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AppRuntimeService"},enumerable:!0,configurable:!0}),n.prototype.getAppRuntimeState=function(){return s(this,"GetAppRuntimeState",1,[],4,0)},n.prototype.getContentSnapshotAsBase64=function(){return p("AppRuntimeService.getContentSnapshotAsBase64","SnapshotControl","1.1","Office"),s(this,"GetContentSnapshotAsBase64",1,[],4,0)},n.prototype.getSnapshotEnabled=function(){return p("AppRuntimeService.getSnapshotEnabled","SnapshotControl","1.1","Office"),s(this,"GetSnapshotEnabled",1,[],4,0)},n.prototype.setAppRuntimeState=function(e){s(this,"SetAppRuntimeState",0,[e],_(2,"SharedRuntimeInternal","1.2"),0)},n.prototype.setSnapshotEnabled=function(e){p("AppRuntimeService.setSnapshotEnabled","SnapshotControl","1.1","Office"),s(this,"SetSnapshotEnabled",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.AppRuntimeService,t,"Microsoft.AppRuntime.AppRuntimeService",!1,4)},Object.defineProperty(n.prototype,"onSnapshotImageReady",{get:function(){return p("AppRuntimeService.onSnapshotImageReady","SnapshotControl","1.1","Office"),this.m_snapshotImageReady||(this.m_snapshotImageReady=new OfficeExtension.GenericEventHandlers(this.context,this,"SnapshotImageReady",{eventType:65547,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={imageBase64:e.imageBase64};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_snapshotImageReady},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onVisibilityChanged",{get:function(){return this.m_visibilityChanged||(this.m_visibilityChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"VisibilityChanged",{eventType:65539,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={visibility:e.visibility};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_visibilityChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AppRuntimeService=I,function(e){e.inactive="Inactive",e.background="Background",e.visible="Visible"}(e.AppRuntimeState||(e.AppRuntimeState={})),function(e){e.hidden="Hidden",e.visible="Visible"}(e.Visibility||(e.Visibility={}));var x=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ThemeService"},enumerable:!0,configurable:!0}),n.prototype.registerOfficeThemeChangedEvent=function(){s(this,"RegisterOfficeThemeChangedEvent",0,[],0,0)},n.prototype.unregisterOfficeThemeChangedEvent=function(){s(this,"UnregisterOfficeThemeChangedEvent",0,[],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ThemeService,t,"Microsoft.Theme.ThemeService",!1,4)},Object.defineProperty(n.prototype,"onOfficeThemeChanged",{get:function(){var e=this;return this.m_officeThemeChanged||(this.m_officeThemeChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"OfficeThemeChanged",{eventType:65548,registerFunc:function(){return e.registerOfficeThemeChangedEvent()},unregisterFunc:function(){return e.unregisterOfficeThemeChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(t){var n=C.ThemeService_OfficeThemeChanged_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_officeThemeChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ThemeService=x,function(e){e.ThemeService_OfficeThemeChanged_EventArgsTransform=function(e,t){return{bodyBackgroundColor:t.bodyBackgroundColor,bodyForegroundColor:t.bodyForegroundColor,controlBackgroundColor:t.controlBackgroundColor,controlForegroundColor:t.controlForegroundColor}}}(C=e._CC||(e._CC={}));var M=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Tap"},enumerable:!0,configurable:!0}),n.prototype.getEnterpriseUserInfo=function(){return s(this,"GetEnterpriseUserInfo",1,[],5,0)},n.prototype.getMruFriendlyPath=function(e){return s(this,"GetMruFriendlyPath",1,[e],5,0)},n.prototype.launchFileUrlInOfficeApp=function(e,t){return s(this,"LaunchFileUrlInOfficeApp",1,[e,t],5,0)},n.prototype.performLocalSearch=function(e,t,n,r){return s(this,"PerformLocalSearch",1,[e,t,n,r],5,0)},n.prototype.readSearchCache=function(e,t,n){return s(this,"ReadSearchCache",1,[e,t,n],5,0)},n.prototype.writeSearchCache=function(e,t,n){return s(this,"WriteSearchCache",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.Tap,t,"Microsoft.TapRichApi.Tap",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.Tap=M,function(e){e.unknown="Unknown",e.chart="Chart",e.smartArt="SmartArt",e.table="Table",e.image="Image",e.slide="Slide",e.ole="OLE",e.text="Text"}(e.ObjectType||(e.ObjectType={})),function(e){e.placeHolderRendered="PlaceHolderRendered",e.initialCardRendered="InitialCardRendered"}(e.PersonaCardPerfPoint||(e.PersonaCardPerfPoint={})),function(e){e.notSet="NotSet",e.free="Free",e.idle="Idle",e.busy="Busy",e.idleBusy="IdleBusy",e.doNotDisturb="DoNotDisturb",e.unalertable="Unalertable",e.unavailable="Unavailable"}(e.UnifiedCommunicationAvailability||(e.UnifiedCommunicationAvailability={})),function(e){e.online="Online",e.notOnline="NotOnline",e.away="Away",e.busy="Busy",e.beRightBack="BeRightBack",e.onThePhone="OnThePhone",e.outToLunch="OutToLunch",e.inAMeeting="InAMeeting",e.outOfOffice="OutOfOffice",e.doNotDisturb="DoNotDisturb",e.inAConference="InAConference",e.getting="Getting",e.notABuddy="NotABuddy",e.disconnected="Disconnected",e.notInstalled="NotInstalled",e.urgentInterruptionsOnly="UrgentInterruptionsOnly",e.mayBeAvailable="MayBeAvailable",e.idle="Idle",e.inPresentation="InPresentation"}(e.UnifiedCommunicationStatus||(e.UnifiedCommunicationStatus={})),function(e){e.free="Free",e.busy="Busy",e.idle="Idle",e.doNotDistrub="DoNotDistrub",e.blocked="Blocked",e.notSet="NotSet",e.outOfOffice="OutOfOffice"}(e.UnifiedCommunicationPresence||(e.UnifiedCommunicationPresence={})),function(e){e.unknown="Unknown",e.free="Free",e.busy="Busy",e.elsewhere="Elsewhere",e.tentative="Tentative",e.outOfOffice="OutOfOffice"}(e.FreeBusyCalendarState||(e.FreeBusyCalendarState={})),function(e){e.unknown="Unknown",e.enterprise="Enterprise",e.contact="Contact",e.bot="Bot",e.phoneOnly="PhoneOnly",e.oneOff="OneOff",e.distributionList="DistributionList",e.personalDistributionList="PersonalDistributionList",e.anonymous="Anonymous",e.unifiedGroup="UnifiedGroup"}(e.PersonaType||(e.PersonaType={})),function(e){e.workPhone="WorkPhone",e.homePhone="HomePhone",e.mobilePhone="MobilePhone",e.businessFax="BusinessFax",e.otherPhone="OtherPhone"}(e.PhoneType||(e.PhoneType={})),function(e){e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress"}(e.AddressType||(e.AddressType={})),function(e){e.unknown="Unknown",e.individual="Individual",e.group="Group"}(e.MemberType||(e.MemberType={}));var T,R=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"MemberInfoList"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isWarmedUp",{get:function(){return d("isWarmedUp",this._I,"MemberInfoList",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"isWarmingUp",{get:function(){return d("isWarmingUp",this._Is,"MemberInfoList",this._isNull),this._Is},enumerable:!0,configurable:!0}),n.prototype.getPersonaForMember=function(t){return r(e.Persona,this,"GetPersonaForMember",1,[t],!1,!1,null,4)},n.prototype.items=function(){return s(this,"Items",1,[],4,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.IsWarmedUp)||(this._I=n.IsWarmedUp),f(n.IsWarmingUp)||(this._Is=n.IsWarmingUp)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.prototype.toJSON=function(){return g(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.MemberInfoList=R,function(e){e.hostId="HostId",e.type="Type",e.photo="Photo",e.personaInfo="PersonaInfo",e.unifiedCommunicationInfo="UnifiedCommunicationInfo",e.organization="Organization",e.unifiedGroupInfo="UnifiedGroupInfo",e.members="Members",e.membership="Membership",e.capabilities="Capabilities",e.customizations="Customizations",e.viewableSources="ViewableSources",e.placeholder="Placeholder"}(T=e.PersonaDataUpdated||(e.PersonaDataUpdated={}));var w=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaActions"},enumerable:!0,configurable:!0}),t.prototype.addContact=function(){s(this,"AddContact",0,[],0,0)},t.prototype.callPhoneNumber=function(e){s(this,"CallPhoneNumber",0,[e],0,0)},t.prototype.composeEmail=function(e){s(this,"ComposeEmail",0,[e],0,0)},t.prototype.composeInstantMessage=function(e){s(this,"ComposeInstantMessage",0,[e],0,0)},t.prototype.editContact=function(){s(this,"EditContact",0,[],0,0)},t.prototype.editContactByIdentifier=function(e){s(this,"EditContactByIdentifier",0,[e],0,0)},t.prototype.editUnifiedGroup=function(){s(this,"EditUnifiedGroup",0,[],0,0)},t.prototype.getChangePhotoUrlAndOpenInBrowser=function(){s(this,"GetChangePhotoUrlAndOpenInBrowser",0,[],0,0)},t.prototype.hideHoverCardForPersona=function(){s(this,"HideHoverCardForPersona",0,[],0,0)},t.prototype.joinUnifiedGroup=function(){s(this,"JoinUnifiedGroup",0,[],0,0)},t.prototype.leaveUnifiedGroup=function(){s(this,"LeaveUnifiedGroup",0,[],0,0)},t.prototype.openGroupCalendar=function(){s(this,"OpenGroupCalendar",0,[],0,0)},t.prototype.openLinkContactUx=function(){s(this,"OpenLinkContactUx",0,[],0,0)},t.prototype.openOutlookProperties=function(){s(this,"OpenOutlookProperties",0,[],0,0)},t.prototype.pinPersonaToQuickContacts=function(){s(this,"PinPersonaToQuickContacts",0,[],0,0)},t.prototype.scheduleMeeting=function(){s(this,"ScheduleMeeting",0,[],0,0)},t.prototype.showContactCard=function(e,t,n,r,i,o){s(this,"ShowContactCard",0,[e,t,n,r,i,o],0,0)},t.prototype.showContextMenu=function(e,t,n,r,i,o){s(this,"ShowContextMenu",0,[e,t,n,r,i,o],0,0)},t.prototype.showExpandedCard=function(e,t,n,r,i,o){s(this,"ShowExpandedCard",0,[e,t,n,r,i,o],0,0)},t.prototype.showHoverCardForPersona=function(e,t,n,r,i,o){s(this,"ShowHoverCardForPersona",0,[e,t,n,r,i,o],0,0)},t.prototype.startAudioCall=function(){s(this,"StartAudioCall",0,[],0,0)},t.prototype.startVideoCall=function(){s(this,"StartVideoCall",0,[],0,0)},t.prototype.subscribeToGroup=function(){s(this,"SubscribeToGroup",0,[],0,0)},t.prototype.toggleTagForAlerts=function(){s(this,"ToggleTagForAlerts",0,[],0,0)},t.prototype.unsubscribeFromGroup=function(){s(this,"UnsubscribeFromGroup",0,[],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),l(t))||y(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaActions=w;var N=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaInfoSource"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","phones","addresses","webSites","notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","Phones","Addresses","WebSites","Notes"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"addresses",{get:function(){return d("addresses",this._A,"PersonaInfoSource",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthday",{get:function(){return d("birthday",this._B,"PersonaInfoSource",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"birthdays",{get:function(){return d("birthdays",this._Bi,"PersonaInfoSource",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"companyName",{get:function(){return d("companyName",this._C,"PersonaInfoSource",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"displayName",{get:function(){return d("displayName",this._D,"PersonaInfoSource",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"email",{get:function(){return d("email",this._E,"PersonaInfoSource",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailAddresses",{get:function(){return d("emailAddresses",this._Em,"PersonaInfoSource",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"jobInfoDepartment",{get:function(){return d("jobInfoDepartment",this._J,"PersonaInfoSource",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedCompanyNames",{get:function(){return d("linkedCompanyNames",this._L,"PersonaInfoSource",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedDepartments",{get:function(){return d("linkedDepartments",this._Li,"PersonaInfoSource",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedOffices",{get:function(){return d("linkedOffices",this._Lin,"PersonaInfoSource",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"linkedTitles",{get:function(){return d("linkedTitles",this._Link,"PersonaInfoSource",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"notes",{get:function(){return d("notes",this._N,"PersonaInfoSource",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"office",{get:function(){return d("office",this._O,"PersonaInfoSource",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"phones",{get:function(){return d("phones",this._P,"PersonaInfoSource",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"sipAddresses",{get:function(){return d("sipAddresses",this._S,"PersonaInfoSource",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"title",{get:function(){return d("title",this._T,"PersonaInfoSource",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"webSites",{get:function(){return d("webSites",this._W,"PersonaInfoSource",this._isNull),this._W},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Addresses)||(this._A=n.Addresses),f(n.Birthday)||(this._B=n.Birthday),f(n.Birthdays)||(this._Bi=n.Birthdays),f(n.CompanyName)||(this._C=n.CompanyName),f(n.DisplayName)||(this._D=n.DisplayName),f(n.Email)||(this._E=n.Email),f(n.EmailAddresses)||(this._Em=n.EmailAddresses),f(n.JobInfoDepartment)||(this._J=n.JobInfoDepartment),f(n.LinkedCompanyNames)||(this._L=n.LinkedCompanyNames),f(n.LinkedDepartments)||(this._Li=n.LinkedDepartments),f(n.LinkedOffices)||(this._Lin=n.LinkedOffices),f(n.LinkedTitles)||(this._Link=n.LinkedTitles),f(n.Notes)||(this._N=n.Notes),f(n.Office)||(this._O=n.Office),f(n.Phones)||(this._P=n.Phones),f(n.SipAddresses)||(this._S=n.SipAddresses),f(n.Title)||(this._T=n.Title),f(n.WebSites)||(this._W=n.WebSites)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{addresses:this._A,birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,phones:this._P,sipAddresses:this._S,title:this._T,webSites:this._W},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.PersonaInfoSource=N;var j=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["displayName","email","emailAddresses","sipAddresses","birthday","birthdays","title","jobInfoDepartment","companyName","office","linkedTitles","linkedDepartments","linkedCompanyNames","linkedOffices","webSites","notes","isPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["DisplayName","Email","EmailAddresses","SipAddresses","Birthday","Birthdays","Title","JobInfoDepartment","CompanyName","Office","LinkedTitles","LinkedDepartments","LinkedCompanyNames","LinkedOffices","WebSites","Notes","IsPersonResolved"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["sources"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sources",{get:function(){return this._So||(this._So=n(e.PersonaInfoSource,this,"Sources",!1,4)),this._So},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthday",{get:function(){return d("birthday",this._B,"PersonaInfo",this._isNull),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"birthdays",{get:function(){return d("birthdays",this._Bi,"PersonaInfo",this._isNull),this._Bi},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"companyName",{get:function(){return d("companyName",this._C,"PersonaInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"displayName",{get:function(){return d("displayName",this._D,"PersonaInfo",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"email",{get:function(){return d("email",this._E,"PersonaInfo",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"emailAddresses",{get:function(){return d("emailAddresses",this._Em,"PersonaInfo",this._isNull),this._Em},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isPersonResolved",{get:function(){return d("isPersonResolved",this._I,"PersonaInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"jobInfoDepartment",{get:function(){return d("jobInfoDepartment",this._J,"PersonaInfo",this._isNull),this._J},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedCompanyNames",{get:function(){return d("linkedCompanyNames",this._L,"PersonaInfo",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedDepartments",{get:function(){return d("linkedDepartments",this._Li,"PersonaInfo",this._isNull),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedOffices",{get:function(){return d("linkedOffices",this._Lin,"PersonaInfo",this._isNull),this._Lin},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"linkedTitles",{get:function(){return d("linkedTitles",this._Link,"PersonaInfo",this._isNull),this._Link},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"notes",{get:function(){return d("notes",this._N,"PersonaInfo",this._isNull),this._N},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"office",{get:function(){return d("office",this._O,"PersonaInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"sipAddresses",{get:function(){return d("sipAddresses",this._S,"PersonaInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"title",{get:function(){return d("title",this._T,"PersonaInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"webSites",{get:function(){return d("webSites",this._W,"PersonaInfo",this._isNull),this._W},enumerable:!0,configurable:!0}),r.prototype.getAddresses=function(){return s(this,"GetAddresses",1,[],4,0)},r.prototype.getPhones=function(){return s(this,"GetPhones",1,[],4,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Birthday)||(this._B=v(n.Birthday)),f(n.Birthdays)||(this._Bi=v(n.Birthdays)),f(n.CompanyName)||(this._C=n.CompanyName),f(n.DisplayName)||(this._D=n.DisplayName),f(n.Email)||(this._E=n.Email),f(n.EmailAddresses)||(this._Em=n.EmailAddresses),f(n.IsPersonResolved)||(this._I=n.IsPersonResolved),f(n.JobInfoDepartment)||(this._J=n.JobInfoDepartment),f(n.LinkedCompanyNames)||(this._L=n.LinkedCompanyNames),f(n.LinkedDepartments)||(this._Li=n.LinkedDepartments),f(n.LinkedOffices)||(this._Lin=n.LinkedOffices),f(n.LinkedTitles)||(this._Link=n.LinkedTitles),f(n.Notes)||(this._N=n.Notes),f(n.Office)||(this._O=n.Office),f(n.SipAddresses)||(this._S=n.SipAddresses),f(n.Title)||(this._T=n.Title),f(n.WebSites)||(this._W=n.WebSites),O(this,n,["sources","Sources"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){if(t.prototype._handleRetrieveResult.call(this,e,n),!l(e)){var r=e;f(r.Birthday)||(r.birthday=v(r.birthday)),f(r.Birthdays)||(r.birthdays=v(r.birthdays)),b(this,e,n)}},r.prototype.toJSON=function(){return g(this,{birthday:this._B,birthdays:this._Bi,companyName:this._C,displayName:this._D,email:this._E,emailAddresses:this._Em,isPersonResolved:this._I,jobInfoDepartment:this._J,linkedCompanyNames:this._L,linkedDepartments:this._Li,linkedOffices:this._Lin,linkedTitles:this._Link,notes:this._N,office:this._O,sipAddresses:this._S,title:this._T,webSites:this._W},{sources:this._So})},r.prototype.setMockData=function(e){S(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.PersonaInfo=j;var U=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaUnifiedCommunicationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["availability","status","isSelf","isTagged","customStatusString","isBlocked","presenceTooltip","isOutOfOffice","outOfOfficeNote","timezone","meetingLocation","meetingSubject","timezoneBias","idleStartTime","overallCapability","isOnBuddyList","presenceNote","voiceMailUri","availabilityText","availabilityTooltip","isDurationInAvailabilityText","freeBusyStatus","calendarState","presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Availability","Status","IsSelf","IsTagged","CustomStatusString","IsBlocked","PresenceTooltip","IsOutOfOffice","OutOfOfficeNote","Timezone","MeetingLocation","MeetingSubject","TimezoneBias","IdleStartTime","OverallCapability","IsOnBuddyList","PresenceNote","VoiceMailUri","AvailabilityText","AvailabilityTooltip","IsDurationInAvailabilityText","FreeBusyStatus","CalendarState","Presence"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availability",{get:function(){return d("availability",this._A,"PersonaUnifiedCommunicationInfo",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityText",{get:function(){return d("availabilityText",this._Av,"PersonaUnifiedCommunicationInfo",this._isNull),this._Av},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"availabilityTooltip",{get:function(){return d("availabilityTooltip",this._Ava,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ava},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"calendarState",{get:function(){return d("calendarState",this._C,"PersonaUnifiedCommunicationInfo",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"customStatusString",{get:function(){return d("customStatusString",this._Cu,"PersonaUnifiedCommunicationInfo",this._isNull),this._Cu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"freeBusyStatus",{get:function(){return d("freeBusyStatus",this._F,"PersonaUnifiedCommunicationInfo",this._isNull),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"idleStartTime",{get:function(){return d("idleStartTime",this._I,"PersonaUnifiedCommunicationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isBlocked",{get:function(){return d("isBlocked",this._Is,"PersonaUnifiedCommunicationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isDurationInAvailabilityText",{get:function(){return d("isDurationInAvailabilityText",this._IsD,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsD},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOnBuddyList",{get:function(){return d("isOnBuddyList",this._IsO,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsO},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isOutOfOffice",{get:function(){return d("isOutOfOffice",this._IsOu,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsOu},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isSelf",{get:function(){return d("isSelf",this._IsS,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsS},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isTagged",{get:function(){return d("isTagged",this._IsT,"PersonaUnifiedCommunicationInfo",this._isNull),this._IsT},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingLocation",{get:function(){return d("meetingLocation",this._M,"PersonaUnifiedCommunicationInfo",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"meetingSubject",{get:function(){return d("meetingSubject",this._Me,"PersonaUnifiedCommunicationInfo",this._isNull),this._Me},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"outOfOfficeNote",{get:function(){return d("outOfOfficeNote",this._O,"PersonaUnifiedCommunicationInfo",this._isNull),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"overallCapability",{get:function(){return d("overallCapability",this._Ov,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ov},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presence",{get:function(){return d("presence",this._P,"PersonaUnifiedCommunicationInfo",this._isNull),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceNote",{get:function(){return d("presenceNote",this._Pr,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pr},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"presenceTooltip",{get:function(){return d("presenceTooltip",this._Pre,"PersonaUnifiedCommunicationInfo",this._isNull),this._Pre},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"status",{get:function(){return d("status",this._S,"PersonaUnifiedCommunicationInfo",this._isNull),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezone",{get:function(){return d("timezone",this._T,"PersonaUnifiedCommunicationInfo",this._isNull),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"timezoneBias",{get:function(){return d("timezoneBias",this._Ti,"PersonaUnifiedCommunicationInfo",this._isNull),this._Ti},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"voiceMailUri",{get:function(){return d("voiceMailUri",this._V,"PersonaUnifiedCommunicationInfo",this._isNull),this._V},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Availability)||(this._A=n.Availability),f(n.AvailabilityText)||(this._Av=n.AvailabilityText),f(n.AvailabilityTooltip)||(this._Ava=n.AvailabilityTooltip),f(n.CalendarState)||(this._C=n.CalendarState),f(n.CustomStatusString)||(this._Cu=n.CustomStatusString),f(n.FreeBusyStatus)||(this._F=n.FreeBusyStatus),f(n.IdleStartTime)||(this._I=v(n.IdleStartTime)),f(n.IsBlocked)||(this._Is=n.IsBlocked),f(n.IsDurationInAvailabilityText)||(this._IsD=n.IsDurationInAvailabilityText),f(n.IsOnBuddyList)||(this._IsO=n.IsOnBuddyList),f(n.IsOutOfOffice)||(this._IsOu=n.IsOutOfOffice),f(n.IsSelf)||(this._IsS=n.IsSelf),f(n.IsTagged)||(this._IsT=n.IsTagged),f(n.MeetingLocation)||(this._M=n.MeetingLocation),f(n.MeetingSubject)||(this._Me=n.MeetingSubject),f(n.OutOfOfficeNote)||(this._O=n.OutOfOfficeNote),f(n.OverallCapability)||(this._Ov=n.OverallCapability),f(n.Presence)||(this._P=n.Presence),f(n.PresenceNote)||(this._Pr=n.PresenceNote),f(n.PresenceTooltip)||(this._Pre=n.PresenceTooltip),f(n.Status)||(this._S=n.Status),f(n.Timezone)||(this._T=n.Timezone),f(n.TimezoneBias)||(this._Ti=n.TimezoneBias),f(n.VoiceMailUri)||(this._V=n.VoiceMailUri)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){if(e.prototype._handleRetrieveResult.call(this,t,n),!l(t)){var r=t;f(r.IdleStartTime)||(r.idleStartTime=v(r.idleStartTime)),b(this,t,n)}},t.prototype.toJSON=function(){return g(this,{availability:this._A,availabilityText:this._Av,availabilityTooltip:this._Ava,calendarState:this._C,customStatusString:this._Cu,freeBusyStatus:this._F,idleStartTime:this._I,isBlocked:this._Is,isDurationInAvailabilityText:this._IsD,isOnBuddyList:this._IsO,isOutOfOffice:this._IsOu,isSelf:this._IsS,isTagged:this._IsT,meetingLocation:this._M,meetingSubject:this._Me,outOfOfficeNote:this._O,overallCapability:this._Ov,presence:this._P,presenceNote:this._Pr,presenceTooltip:this._Pre,status:this._S,timezone:this._T,timezoneBias:this._Ti,voiceMailUri:this._V},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.PersonaUnifiedCommunicationInfo=U;var k=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersonaPhotoInfo"},enumerable:!0,configurable:!0}),t.prototype.getImageUri=function(e){return s(this,"getImageUri",1,[e],4,0)},t.prototype.getImageUriWithMetadata=function(e){return s(this,"getImageUriWithMetadata",1,[e],4,0)},t.prototype.getPlaceholderUri=function(e){return s(this,"getPlaceholderUri",1,[e],4,0)},t.prototype.setPlaceholderColor=function(e){s(this,"setPlaceholderColor",0,[e],0,0)},t.prototype._handleResult=function(t){(e.prototype._handleResult.call(this,t),l(t))||y(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t}(OfficeExtension.ClientObject);e.PersonaPhotoInfo=k;var L=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PersonaCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"PersonaCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Persona,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Persona,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.Persona,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.Persona,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.PersonaCollection=L;var H=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"PersonaOrganizationInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["isWarmedUp","isWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["IsWarmedUp","IsWarmingUp"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["hierarchy","manager","directReports"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"directReports",{get:function(){return this._D||(this._D=n(e.PersonaCollection,this,"DirectReports",!0,4)),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"hierarchy",{get:function(){return this._H||(this._H=n(e.PersonaCollection,this,"Hierarchy",!0,4)),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"manager",{get:function(){return this._M||(this._M=n(e.Persona,this,"Manager",!1,4)),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmedUp",{get:function(){return d("isWarmedUp",this._I,"PersonaOrganizationInfo",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"isWarmingUp",{get:function(){return d("isWarmingUp",this._Is,"PersonaOrganizationInfo",this._isNull),this._Is},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.IsWarmedUp)||(this._I=n.IsWarmedUp),f(n.IsWarmingUp)||(this._Is=n.IsWarmingUp),O(this,n,["directReports","DirectReports","hierarchy","Hierarchy","manager","Manager"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},r.prototype.toJSON=function(){return g(this,{isWarmedUp:this._I,isWarmingUp:this._Is},{})},r.prototype.setMockData=function(e){S(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.PersonaOrganizationInfo=H,function(e){e.email="Email",e.workPhone="WorkPhone",e.workPhone2="WorkPhone2",e.workFax="WorkFax",e.mobilePhone="MobilePhone",e.homePhone="HomePhone",e.homePhone2="HomePhone2",e.otherPhone="OtherPhone",e.sipAddress="SipAddress",e.profile="Profile",e.office="Office",e.company="Company",e.workAddress="WorkAddress",e.homeAddress="HomeAddress",e.otherAddress="OtherAddress",e.birthday="Birthday"}(e.CustomizedData||(e.CustomizedData={}));var W=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"UnifiedGroupInfo"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Description","OneDrive","OneNote","IsPublic","AmIOwner","AmIMember","AmISubscribed","MemberCount","OwnerCount","HasGuests","Site","Planner","Classification","SubscriptionEnabled"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIMember",{get:function(){return d("amIMember",this._A,"UnifiedGroupInfo",this._isNull),this._A},set:function(e){this._A=e,u(this,"AmIMember",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amIOwner",{get:function(){return d("amIOwner",this._Am,"UnifiedGroupInfo",this._isNull),this._Am},set:function(e){this._Am=e,u(this,"AmIOwner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"amISubscribed",{get:function(){return d("amISubscribed",this._AmI,"UnifiedGroupInfo",this._isNull),this._AmI},set:function(e){this._AmI=e,u(this,"AmISubscribed",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"classification",{get:function(){return d("classification",this._C,"UnifiedGroupInfo",this._isNull),this._C},set:function(e){this._C=e,u(this,"Classification",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"description",{get:function(){return d("description",this._D,"UnifiedGroupInfo",this._isNull),this._D},set:function(e){this._D=e,u(this,"Description",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"hasGuests",{get:function(){return d("hasGuests",this._H,"UnifiedGroupInfo",this._isNull),this._H},set:function(e){this._H=e,u(this,"HasGuests",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"isPublic",{get:function(){return d("isPublic",this._I,"UnifiedGroupInfo",this._isNull),this._I},set:function(e){this._I=e,u(this,"IsPublic",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"memberCount",{get:function(){return d("memberCount",this._M,"UnifiedGroupInfo",this._isNull),this._M},set:function(e){this._M=e,u(this,"MemberCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneDrive",{get:function(){return d("oneDrive",this._O,"UnifiedGroupInfo",this._isNull),this._O},set:function(e){this._O=e,u(this,"OneDrive",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"oneNote",{get:function(){return d("oneNote",this._On,"UnifiedGroupInfo",this._isNull),this._On},set:function(e){this._On=e,u(this,"OneNote",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"ownerCount",{get:function(){return d("ownerCount",this._Ow,"UnifiedGroupInfo",this._isNull),this._Ow},set:function(e){this._Ow=e,u(this,"OwnerCount",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"planner",{get:function(){return d("planner",this._P,"UnifiedGroupInfo",this._isNull),this._P},set:function(e){this._P=e,u(this,"Planner",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"site",{get:function(){return d("site",this._S,"UnifiedGroupInfo",this._isNull),this._S},set:function(e){this._S=e,u(this,"Site",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"subscriptionEnabled",{get:function(){return d("subscriptionEnabled",this._Su,"UnifiedGroupInfo",this._isNull),this._Su},set:function(e){this._Su=e,u(this,"SubscriptionEnabled",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["description","oneDrive","oneNote","isPublic","amIOwner","amIMember","amISubscribed","memberCount","ownerCount","hasGuests","site","planner","classification","subscriptionEnabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.AmIMember)||(this._A=n.AmIMember),f(n.AmIOwner)||(this._Am=n.AmIOwner),f(n.AmISubscribed)||(this._AmI=n.AmISubscribed),f(n.Classification)||(this._C=n.Classification),f(n.Description)||(this._D=n.Description),f(n.HasGuests)||(this._H=n.HasGuests),f(n.IsPublic)||(this._I=n.IsPublic),f(n.MemberCount)||(this._M=n.MemberCount),f(n.OneDrive)||(this._O=n.OneDrive),f(n.OneNote)||(this._On=n.OneNote),f(n.OwnerCount)||(this._Ow=n.OwnerCount),f(n.Planner)||(this._P=n.Planner),f(n.Site)||(this._S=n.Site),f(n.SubscriptionEnabled)||(this._Su=n.SubscriptionEnabled)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{amIMember:this._A,amIOwner:this._Am,amISubscribed:this._AmI,classification:this._C,description:this._D,hasGuests:this._H,isPublic:this._I,memberCount:this._M,oneDrive:this._O,oneNote:this._On,ownerCount:this._Ow,planner:this._P,site:this._S,subscriptionEnabled:this._Su},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.UnifiedGroupInfo=W;var B;!function(e){e[e.immediate=0]="immediate",e[e.load=3]="load"}(B=e.PersonaPromiseType||(e.PersonaPromiseType={}));var G=function(){return function(){}}();e.PersonaInfoAndSource=G;var q=function(t){function i(){return null!==t&&t.apply(this,arguments)||this}return __extends(i,t),Object.defineProperty(i.prototype,"_className",{get:function(){return"Persona"},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyNames",{get:function(){return["hostId","type","capabilities","diagnosticId","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyOriginalNames",{get:function(){return["HostId","Type","Capabilities","DiagnosticId","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_navigationPropertyNames",{get:function(){return["photo","personaInfo","unifiedCommunicationInfo","organization","unifiedGroupInfo","actions"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"actions",{get:function(){return this._A||(this._A=n(e.PersonaActions,this,"Actions",!1,4)),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"organization",{get:function(){return this._O||(this._O=n(e.PersonaOrganizationInfo,this,"Organization",!1,4)),this._O},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"personaInfo",{get:function(){return this._P||(this._P=n(e.PersonaInfo,this,"PersonaInfo",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"photo",{get:function(){return this._Ph||(this._Ph=n(e.PersonaPhotoInfo,this,"Photo",!1,4)),this._Ph},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"unifiedCommunicationInfo",{get:function(){return this._U||(this._U=n(e.PersonaUnifiedCommunicationInfo,this,"UnifiedCommunicationInfo",!1,4)),this._U},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"unifiedGroupInfo",{get:function(){return this._Un||(this._Un=n(e.UnifiedGroupInfo,this,"UnifiedGroupInfo",!1,4)),this._Un},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"capabilities",{get:function(){return d("capabilities",this._C,"Persona",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"diagnosticId",{get:function(){return d("diagnosticId",this._D,"Persona",this._isNull),this._D},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"hostId",{get:function(){return d("hostId",this._H,"Persona",this._isNull),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"instanceId",{get:function(){return d("instanceId",this._I,"Persona",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"type",{get:function(){return d("type",this._T,"Persona",this._isNull),this._T},enumerable:!0,configurable:!0}),i.prototype.set=function(e,t){this._recursivelySet(e,t,[],["unifiedGroupInfo"],["actions","organization","personaInfo","photo","unifiedCommunicationInfo"])},i.prototype.update=function(e){this._recursivelyUpdate(e)},i.prototype.dispose=function(){s(this,"Dispose",0,[],0,0)},i.prototype.getCustomizations=function(){return s(this,"GetCustomizations",1,[],4,0)},i.prototype.getMembers=function(){return r(e.MemberInfoList,this,"GetMembers",1,[],!1,!1,null,4)},i.prototype.getMembership=function(){return r(e.MemberInfoList,this,"GetMembership",1,[],!1,!1,null,4)},i.prototype.getViewableSources=function(){return s(this,"GetViewableSources",1,[],4,0)},i.prototype.reportTimeForRender=function(e,t){s(this,"ReportTimeForRender",0,[e,t],0,0)},i.prototype.warmup=function(e){s(this,"Warmup",0,[e],0,0)},i.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Capabilities)||(this._C=n.Capabilities),f(n.DiagnosticId)||(this._D=n.DiagnosticId),f(n.HostId)||(this._H=n.HostId),f(n.InstanceId)||(this._I=n.InstanceId),f(n.Type)||(this._T=n.Type),O(this,n,["actions","Actions","organization","Organization","personaInfo","PersonaInfo","photo","Photo","unifiedCommunicationInfo","UnifiedCommunicationInfo","unifiedGroupInfo","UnifiedGroupInfo"])}},i.prototype.load=function(e){return h(this,e)},i.prototype.retrieve=function(e){return m(this,e)},i.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},i.prototype.toJSON=function(){return g(this,{capabilities:this._C,diagnosticId:this._D,hostId:this._H,instanceId:this._I,type:this._T},{organization:this._O,personaInfo:this._P,unifiedCommunicationInfo:this._U,unifiedGroupInfo:this._Un})},i.prototype.setMockData=function(e){S(this,e)},i.prototype.ensureUnchanged=function(e){c(this,e)},i}(OfficeExtension.ClientObject);e.Persona=q;var V=function(){function t(){}return t.prototype.performAsyncOperation=function(e,t,n,r){var i=this;e!=B.immediate?r().then((function(e){if(e)n();else{var o=i;o.load("hostId"),o.context.sync().then((function(){var e=o.hostId;i.getPersonaLifetime().then((function(i){var a=function(s){return new OfficeExtension.CoreUtility.Promise((function(c,u){if(s.sendingPersonaHostId==e)for(var l=0;l<s.dataUpdated.length;++l){var f=s.dataUpdated[l];if(t==f)return void r().then((function(e){e&&(n(),i.onPersonaUpdated.remove(a),o.context.sync()),c(e)}))}c(!1)}))};i.onPersonaUpdated.add(a),o.context.sync()}))}))}})):n()},t.prototype.getOrganizationAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.organization,(function(){var e=i.organization;e.load("*"),i.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=i.organization;n.load("isWarmedUp"),i.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getIsPersonaInfoResolvedCheck=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.personaInfo;r.load("isPersonResolved"),e.context.sync().then((function(){t(r.isPersonResolved)}))}))},t.prototype.getPersonaInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=i.personaInfo;e.load(),i.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getPersonaInfoWithSourceAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=new G;e.info=i.personaInfo,e.info.load(),e.source=i.personaInfo.sources,e.source.load(),i.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedCommunicationInfo=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=i.unifiedCommunicationInfo;e.load("*"),i.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getUnifiedGroupInfoAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=i.unifiedGroupInfo;e.load("*"),i.context.sync().then((function(){n(e)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getTypeAsync=function(t){var n=this;return new OfficeExtension.CoreUtility.Promise((function(r,i){var o=n;n.performAsyncOperation(t,T.personaInfo,(function(){o.load("type"),o.context.sync().then((function(){r(e.PersonaType[o.type.valueOf()])}))}),(function(){return n.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getCustomizationsAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.personaInfo,(function(){var e=i.getCustomizations();i.context.sync().then((function(){n(e.value)}))}),(function(){return t.getIsPersonaInfoResolvedCheck()}))}))},t.prototype.getMembersAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.members,(function(){var e=i.getMembers();e.load("isWarmedUp"),i.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e,t){var n=i.getMembers();n.load("isWarmedUp"),i.context.sync().then((function(){e(n.isWarmedUp)}))}))}))}))},t.prototype.getMembershipAsync=function(e){var t=this;return new OfficeExtension.CoreUtility.Promise((function(n,r){var i=t;t.performAsyncOperation(e,T.membership,(function(){var e=i.getMembership();e.load("*"),i.context.sync().then((function(){n(e)}))}),(function(){return new OfficeExtension.CoreUtility.Promise((function(e){var t=i.getMembership();t.load("isWarmedUp"),i.context.sync().then((function(){e(t.isWarmedUp)}))}))}))}))},t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e;r.load("instanceId"),r.context.sync().then((function(){new Q(r.context,r.instanceId).getPersonaLifetime().then((function(e){t(e)}))}))}))},t}();e.PersonaCustom=V,OfficeExtension.Utility.applyMixin(q,V);var z=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PersonaLifetime"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"instanceId",{get:function(){return d("instanceId",this._I,"PersonaLifetime",this._isNull),this._I},enumerable:!0,configurable:!0}),n.prototype.getPersona=function(t){return r(e.Persona,this,"GetPersona",1,[t],!1,!1,null,4)},n.prototype.getPersonaForOrgByEntryId=function(t,n,i,o){return r(e.Persona,this,"GetPersonaForOrgByEntryId",1,[t,n,i,o],!1,!1,null,4)},n.prototype.getPersonaForOrgEntry=function(t,n,i,o){return r(e.Persona,this,"GetPersonaForOrgEntry",1,[t,n,i,o],!1,!1,null,4)},n.prototype.getPolicies=function(){return s(this,"GetPolicies",1,[],4,0)},n.prototype.getTextScaleFactor=function(){return s(this,"GetTextScaleFactor",1,[],4,0)},n.prototype._RegisterPersonaUpdatedEvent=function(){s(this,"_RegisterPersonaUpdatedEvent",0,[],0,0)},n.prototype._UnregisterPersonaUpdatedEvent=function(){s(this,"_UnregisterPersonaUpdatedEvent",0,[],0,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.InstanceId)||(this._I=n.InstanceId)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},Object.defineProperty(n.prototype,"onPersonaUpdated",{get:function(){var e=this;return this.m_personaUpdated||(this.m_personaUpdated=new OfficeExtension.GenericEventHandlers(this.context,this,"PersonaUpdated",{eventType:3502,registerFunc:function(){return e._RegisterPersonaUpdatedEvent()},unregisterFunc:function(){return e._UnregisterPersonaUpdatedEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={dataUpdated:e.dataUpdated,sendingPersonaHostId:e.sendingPersonaHostId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_personaUpdated},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{instanceId:this._I},{})},n.prototype.setMockData=function(e){S(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.PersonaLifetime=z;var J=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"LokiTokenProvider"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["emailOrUpn","instanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["EmailOrUpn","InstanceId"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"emailOrUpn",{get:function(){return d("emailOrUpn",this._E,"LokiTokenProvider",this._isNull),this._E},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"instanceId",{get:function(){return d("instanceId",this._I,"LokiTokenProvider",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.requestClientAccessToken=function(){s(this,"RequestClientAccessToken",0,[],0,0)},t.prototype.requestIdentityUniqueId=function(){s(this,"RequestIdentityUniqueId",0,[],0,0)},t.prototype.requestToken=function(){s(this,"RequestToken",0,[],0,0)},t.prototype._RegisterClientAccessTokenAvailableEvent=function(){s(this,"_RegisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._RegisterIdentityUniqueIdAvailableEvent=function(){s(this,"_RegisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._RegisterLokiTokenAvailableEvent=function(){s(this,"_RegisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterClientAccessTokenAvailableEvent=function(){s(this,"_UnregisterClientAccessTokenAvailableEvent",0,[],0,0)},t.prototype._UnregisterIdentityUniqueIdAvailableEvent=function(){s(this,"_UnregisterIdentityUniqueIdAvailableEvent",0,[],0,0)},t.prototype._UnregisterLokiTokenAvailableEvent=function(){s(this,"_UnregisterLokiTokenAvailableEvent",0,[],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.EmailOrUpn)||(this._E=n.EmailOrUpn),f(n.InstanceId)||(this._I=n.InstanceId)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},Object.defineProperty(t.prototype,"onClientAccessTokenAvailable",{get:function(){var e=this;return this.m_clientAccessTokenAvailable||(this.m_clientAccessTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"ClientAccessTokenAvailable",{eventType:3505,registerFunc:function(){return e._RegisterClientAccessTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterClientAccessTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={clientAccessToken:e.clientAccessToken,isAvailable:e.isAvailable,tokenTTLInSeconds:e.tokenTTLInSeconds};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_clientAccessTokenAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onIdentityUniqueIdAvailable",{get:function(){var e=this;return this.m_identityUniqueIdAvailable||(this.m_identityUniqueIdAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"IdentityUniqueIdAvailable",{eventType:3504,registerFunc:function(){return e._RegisterIdentityUniqueIdAvailableEvent()},unregisterFunc:function(){return e._UnregisterIdentityUniqueIdAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,uniqueId:e.uniqueId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_identityUniqueIdAvailable},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"onLokiTokenAvailable",{get:function(){var e=this;return this.m_lokiTokenAvailable||(this.m_lokiTokenAvailable=new OfficeExtension.GenericEventHandlers(this.context,this,"LokiTokenAvailable",{eventType:3503,registerFunc:function(){return e._RegisterLokiTokenAvailableEvent()},unregisterFunc:function(){return e._UnregisterLokiTokenAvailableEvent()},getTargetIdFunc:function(){return e.instanceId},eventArgsTransformFunc:function(e){var t={isAvailable:e.isAvailable,lokiAutoDiscoverUrl:e.lokiAutoDiscoverUrl,lokiToken:e.lokiToken};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_lokiTokenAvailable},enumerable:!0,configurable:!0}),t.prototype.toJSON=function(){return g(this,{emailOrUpn:this._E,instanceId:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.LokiTokenProvider=J;var K=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LokiTokenProviderFactory"},enumerable:!0,configurable:!0}),n.prototype.getLokiTokenProvider=function(t){return r(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.LokiTokenProviderFactory,t,"Microsoft.People.LokiTokenProviderFactory",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LokiTokenProviderFactory=K;var Q=function(){function t(e,t){this.context=e,this.instanceId=t}return Object.defineProperty(t.prototype,"serviceContext",{get:function(){return this.m_serviceConext||(this.m_serviceConext=e.ServiceContext.newObject(this.context)),this.m_serviceConext},enumerable:!0,configurable:!0}),t.prototype.getPersonaLifetime=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getPersonaLifetime(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t.prototype.getInitialPersona=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getInitialPersona(e.instanceId);e.context.sync().then((function(){t(r)}))}))},t.prototype.getLokiTokenProvider=function(){var e=this;return new OfficeExtension.CoreUtility.Promise((function(t,n){var r=e.serviceContext.getLokiTokenProvider(e.instanceId);e.context.sync().then((function(){r.load("instanceId"),e.context.sync().then((function(){t(r)}))}))}))},t}();e.PeopleApiContext=Q;var X=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ServiceContext"},enumerable:!0,configurable:!0}),n.prototype.accountEmailOrUpn=function(e){return s(this,"AccountEmailOrUpn",1,[e],4,0)},n.prototype.dispose=function(e){s(this,"Dispose",0,[e],0,0)},n.prototype.getInitialPersona=function(t){return r(e.Persona,this,"GetInitialPersona",1,[t],!1,!1,null,4)},n.prototype.getLokiTokenProvider=function(t){return r(e.LokiTokenProvider,this,"GetLokiTokenProvider",1,[t],!1,!1,null,4)},n.prototype.getPersonaLifetime=function(t){return r(e.PersonaLifetime,this,"GetPersonaLifetime",1,[t],!1,!1,null,4)},n.prototype.getPersonaPolicies=function(){return s(this,"GetPersonaPolicies",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ServiceContext,t,"Microsoft.People.ServiceContext",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ServiceContext=X;var $=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RichapiPcxFeatureChecks"},enumerable:!0,configurable:!0}),n.prototype.isAddChangePhotoLinkOnLpcPersonaImageFlightEnabled=function(){return s(this,"IsAddChangePhotoLinkOnLpcPersonaImageFlightEnabled",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.RichapiPcxFeatureChecks,t,"Microsoft.People.RichapiPcxFeatureChecks",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.RichapiPcxFeatureChecks=$;var Z=function(t){function i(){return null!==t&&t.apply(this,arguments)||this}return __extends(i,t),Object.defineProperty(i.prototype,"_className",{get:function(){return"Comment"},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyNames",{get:function(){return["id","text","created","level","resolved","author","mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Text","Created","Level","Resolved","Author","Mentions"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1,!1,!0,!1,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_navigationPropertyNames",{get:function(){return["parent","parentOrNullObject","replies"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"parent",{get:function(){return this._P||(this._P=n(e.Comment,this,"Parent",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"parentOrNullObject",{get:function(){return this._Pa||(this._Pa=n(e.Comment,this,"ParentOrNullObject",!1,4)),this._Pa},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"replies",{get:function(){return this._R||(this._R=n(e.CommentCollection,this,"Replies",!0,4)),this._R},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"author",{get:function(){return d("author",this._A,"Comment",this._isNull),this._A},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"created",{get:function(){return d("created",this._C,"Comment",this._isNull),this._C},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"id",{get:function(){return d("id",this._I,"Comment",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"level",{get:function(){return d("level",this._L,"Comment",this._isNull),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"mentions",{get:function(){return d("mentions",this._M,"Comment",this._isNull),this._M},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"resolved",{get:function(){return d("resolved",this._Re,"Comment",this._isNull),this._Re},set:function(e){this._Re=e,u(this,"Resolved",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"text",{get:function(){return d("text",this._T,"Comment",this._isNull),this._T},set:function(e){this._T=e,u(this,"Text",e,0)},enumerable:!0,configurable:!0}),i.prototype.set=function(e,t){this._recursivelySet(e,t,["text","resolved"],[],["parent","parentOrNullObject","replies"])},i.prototype.update=function(e){this._recursivelyUpdate(e)},i.prototype.delete=function(){s(this,"Delete",0,[],0,0)},i.prototype.getParentOrSelf=function(){return r(e.Comment,this,"GetParentOrSelf",1,[],!1,!1,null,4)},i.prototype.getRichText=function(e){return s(this,"GetRichText",1,[e],4,0)},i.prototype.reply=function(t,n){return r(e.Comment,this,"Reply",0,[t,n],!1,!1,null,0)},i.prototype.setRichText=function(e,t){return s(this,"SetRichText",0,[e,t],0,0)},i.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Author)||(this._A=n.Author),f(n.Created)||(this._C=v(n.Created)),f(n.Id)||(this._I=n.Id),f(n.Level)||(this._L=n.Level),f(n.Mentions)||(this._M=n.Mentions),f(n.Resolved)||(this._Re=n.Resolved),f(n.Text)||(this._T=n.Text),O(this,n,["parent","Parent","parentOrNullObject","ParentOrNullObject","replies","Replies"])}},i.prototype.load=function(e){return h(this,e)},i.prototype.retrieve=function(e){return m(this,e)},i.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},i.prototype._handleRetrieveResult=function(e,n){if(t.prototype._handleRetrieveResult.call(this,e,n),!l(e)){var r=e;f(r.Created)||(r.created=v(r.created)),b(this,e,n)}},i.prototype.toJSON=function(){return g(this,{author:this._A,created:this._C,id:this._I,level:this._L,mentions:this._M,resolved:this._Re,text:this._T},{replies:this._R})},i.prototype.setMockData=function(e){S(this,e)},i.prototype.ensureUnchanged=function(e){c(this,e)},i}(OfficeExtension.ClientObject);e.Comment=Z;var Y=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"CommentCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"CommentCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Comment,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Comment,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.Comment,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.Comment,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.CommentCollection=Y;var ee=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ExtensionLifeCycle"},enumerable:!0,configurable:!0}),n.prototype.launchExtensionComponent=function(e,t,n){s(this,"LaunchExtensionComponent",1,[e,t,n],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ExtensionLifeCycle,t,"Microsoft.OfficeSharedApi.ExtensionLifeCycle",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ExtensionLifeCycle=ee,function(e){e.plain="Plain",e.markdown="Markdown",e.delta="Delta"}(e.CommentTextFormat||(e.CommentTextFormat={})),function(e){e.shortTime="ShortTime",e.longTime="LongTime",e.shortDate="ShortDate",e.longDate="LongDate"}(e.TimeStringFormat||(e.TimeStringFormat={}));var te=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LocaleApi"},enumerable:!0,configurable:!0}),n.prototype.formatDateTimeString=function(e,t,n){return s(this,"FormatDateTimeString",1,[e,t,n],4,0)},n.prototype.getLocaleDateTimeFormattingInfo=function(e){return s(this,"GetLocaleDateTimeFormattingInfo",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.LocaleApi,t,"Microsoft.LocaleApi.LocaleApi",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LocaleApi=te;var ne=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"FirstPartyDialogService"},enumerable:!0,configurable:!0}),n.prototype.close=function(){s(this,"Close",1,[],5,0)},n.prototype.displayDialog=function(e,t){s(this,"DisplayDialog",1,[e,t],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.FirstPartyDialogService,t,"Microsoft.FirstPartyDialog.FirstPartyDialogService",!1,4)},Object.defineProperty(n.prototype,"onDialogMessage",{get:function(){var e=this;return this.m_dialogMessage||(this.m_dialogMessage=new OfficeExtension.GenericEventHandlers(this.context,this,"DialogMessage",{eventType:65536,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(t){var n=C.FirstPartyDialogService_DialogMessage_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_dialogMessage},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.FirstPartyDialogService=ne,function(e){e.FirstPartyDialogService_DialogMessage_EventArgsTransform=function(e,t){return{message:t.message}}}(C=e._CC||(e._CC={}));var re=function(t){function i(){return null!==t&&t.apply(this,arguments)||this}return __extends(i,t),Object.defineProperty(i.prototype,"_className",{get:function(){return"DynamicRibbon"},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_navigationPropertyNames",{get:function(){return["buttons"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"buttons",{get:function(){return this._B||(this._B=n(e.RibbonButtonCollection,this,"Buttons",!0,4)),this._B},enumerable:!0,configurable:!0}),i.prototype.executeRequestCreate=function(e){p("DynamicRibbon.executeRequestCreate","DynamicRibbon","1.2","Office"),s(this,"ExecuteRequestCreate",1,[e],4,0)},i.prototype.executeRequestUpdate=function(e){s(this,"ExecuteRequestUpdate",1,[e],4,0)},i.prototype.getButton=function(t){return r(e.RibbonButton,this,"GetButton",1,[t],!1,!1,null,4)},i.prototype.getTab=function(t){return r(e.RibbonTab,this,"GetTab",1,[t],!1,!1,null,4)},i.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),O(this,n,["buttons","Buttons"])}},i.prototype.load=function(e){return h(this,e)},i.prototype.retrieve=function(e){return m(this,e)},i.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},i.newObject=function(t){return o(e.DynamicRibbon,t,"Microsoft.DynamicRibbon.DynamicRibbon",!1,4)},i.prototype.toJSON=function(){return g(this,{},{buttons:this._B})},i}(OfficeExtension.ClientObject);e.DynamicRibbon=re;var ie=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonTab"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return d("id",this._I,"RibbonTab",this._isNull),this._I},enumerable:!0,configurable:!0}),t.prototype.setVisibility=function(e){s(this,"SetVisibility",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Id)||(this._I=n.Id)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||f(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{id:this._I},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RibbonTab=ie;var oe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RibbonButton"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","enabled","label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Enabled","Label"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"enabled",{get:function(){return d("enabled",this._E,"RibbonButton",this._isNull),this._E},set:function(e){this._E=e,u(this,"Enabled",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return d("id",this._I,"RibbonButton",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"label",{get:function(){return d("label",this._L,"RibbonButton",this._isNull),this._L},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["enabled"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype.setEnabled=function(e){s(this,"SetEnabled",0,[e],0,0)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Enabled)||(this._E=n.Enabled),f(n.Id)||(this._I=n.Id),f(n.Label)||(this._L=n.Label)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||f(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{enabled:this._E,id:this._I,label:this._L},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RibbonButton=oe;var ae=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RibbonButtonCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"RibbonButtonCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.RibbonButton,this,[t])},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.RibbonButton,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),b(this,n,r,(function(t,n){return a(e.RibbonButton,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;S(this,t,(function(t,r){return a(e.RibbonButton,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.RibbonButtonCollection=ae,function(e){e.ariaBrowserPipeUrl="AriaBrowserPipeUrl",e.ariaUploadUrl="AriaUploadUrl",e.ariaVNextUploadUrl="AriaVNextUploadUrl",e.lokiAutoDiscoverUrl="LokiAutoDiscoverUrl"}(e.ServiceProvider||(e.ServiceProvider={}));var se=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ServiceUrlProvider"},enumerable:!0,configurable:!0}),n.prototype.getServiceUrl=function(e,t){return s(this,"GetServiceUrl",1,[e,t],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ServiceUrlProvider,t,"Microsoft.DesktopCompliance.ServiceUrlProvider",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ServiceUrlProvider=se;var ce=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"LinkedIn"},enumerable:!0,configurable:!0}),n.prototype.isEnabledForOffice=function(){return s(this,"IsEnabledForOffice",1,[],4,0)},n.prototype.recordLinkedInSettingsCompliance=function(e,t){s(this,"RecordLinkedInSettingsCompliance",0,[e,t],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.LinkedIn,t,"Microsoft.DesktopCompliance.LinkedIn",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.LinkedIn=ce;var ue=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"NetworkUsage"},enumerable:!0,configurable:!0}),n.prototype.isInDisconnectedMode=function(){return s(this,"IsInDisconnectedMode",1,[],4,0)},n.prototype.isInOnlineMode=function(){return s(this,"IsInOnlineMode",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.NetworkUsage,t,"Microsoft.DesktopCompliance.NetworkUsage",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.NetworkUsage=ue;var le=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"BeforeDocumentCloseNotification"},enumerable:!0,configurable:!0}),n.prototype.disable=function(){s(this,"Disable",1,[],4,0)},n.prototype.enable=function(){s(this,"Enable",1,[],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.BeforeDocumentCloseNotification,t,"Microsoft.BeforeDocumentCloseNotification.BeforeDocumentCloseNotification",!1,4)},Object.defineProperty(n.prototype,"onBeforeCloseNotificationCancelled",{get:function(){return this.m_beforeCloseNotificationCancelled||(this.m_beforeCloseNotificationCancelled=new OfficeExtension.GenericEventHandlers(this.context,this,"BeforeCloseNotificationCancelled",{eventType:65540,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_beforeCloseNotificationCancelled},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.BeforeDocumentCloseNotification=le,function(e){e.organizationAccount="OrganizationAccount",e.microsoftAccount="MicrosoftAccount",e.unsupported="Unsupported"}(e.IdentityType||(e.IdentityType={}));var fe=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"AuthenticationService"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["roamingSettings"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"roamingSettings",{get:function(){return this._R||(this._R=n(e.RoamingSettingCollection,this,"RoamingSettings",!1,4)),this._R},enumerable:!0,configurable:!0}),r.prototype.getAccessToken=function(e,t){return s(this,"GetAccessToken",1,[e,t],5,0)},r.prototype.getIdentities=function(){return p("AuthenticationService.getIdentities","FirstPartyAuthentication","1.3","Office"),s(this,"GetIdentities",1,[],5,0)},r.prototype.getPrimaryIdentityInfo=function(){return p("AuthenticationService.getPrimaryIdentityInfo","FirstPartyAuthentication","1.2","Office"),s(this,"GetPrimaryIdentityInfo",1,[],5,0)},r.prototype.registerIdentityChangedEvent=function(){p("AuthenticationService.registerIdentityChangedEvent","FirstPartyAuthentication","1.5","Office"),s(this,"RegisterIdentityChangedEvent",0,[],1,0)},r.prototype.unregisterIdentityChangedEvent=function(){p("AuthenticationService.unregisterIdentityChangedEvent","FirstPartyAuthentication","1.5","Office"),s(this,"UnregisterIdentityChangedEvent",0,[],1,0)},r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),O(this,n,["roamingSettings","RoamingSettings"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},r.newObject=function(t){return o(e.AuthenticationService,t,"Microsoft.Authentication.AuthenticationService",!1,4)},Object.defineProperty(r.prototype,"onIdentityChanged",{get:function(){var e=this;return p("AuthenticationService.onIdentityChanged","FirstPartyAuthentication","1.5","Office"),this.m_identityChanged||(this.m_identityChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"IdentityChanged",{eventType:65545,registerFunc:function(){return e.registerIdentityChangedEvent()},unregisterFunc:function(){return e.unregisterIdentityChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={email:e.email,environment:e.environment,uniqueId:e.uniqueId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_identityChanged},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"onTokenReceived",{get:function(){var e=this;return p("AuthenticationService.onTokenReceived","FirstPartyAuthentication","1.2","Office"),this.m_tokenReceived||(this.m_tokenReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"TokenReceived",{eventType:3001,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return e._targetId},eventArgsTransformFunc:function(t){var n=C.AuthenticationService_TokenReceived_EventArgsTransform(e,t);return OfficeExtension.Utility._createPromiseFromResult(n)}})),this.m_tokenReceived},enumerable:!0,configurable:!0}),r.prototype.toJSON=function(){return g(this,{},{})},r}(OfficeExtension.ClientObject);e.AuthenticationService=fe;var de=function(){function e(){}return Object.defineProperty(e.prototype,"_targetId",{get:function(){return void 0==this.m_targetId&&("undefined"!==typeof OSF&&OSF.OUtil?this.m_targetId=OSF.OUtil.Guid.generateNewGuid():this.m_targetId=""+this.context._nextId()),this.m_targetId},enumerable:!0,configurable:!0}),e}();e.AuthenticationServiceCustom=de,OfficeExtension.Utility.applyMixin(fe,de),function(e){e.AuthenticationService_TokenReceived_EventArgsTransform=function(e,t){var n=t;return{tokenValue:n.tokenValue,code:n.code,errorInfo:n.errorInfo}}}(C=e._CC||(e._CC={}));var pe=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"RoamingSetting"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["id","value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"id",{get:function(){return d("id",this._I,"RoamingSetting",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return d("value",this._V,"RoamingSetting",this._isNull),this._V},set:function(e){this._V=e,u(this,"Value",e,0)},enumerable:!0,configurable:!0}),t.prototype.set=function(e,t){this._recursivelySet(e,t,["value"],[],[])},t.prototype.update=function(e){this._recursivelyUpdate(e)},t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Id)||(this._I=n.Id),f(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleIdResult=function(t){e.prototype._handleIdResult.call(this,t),l(t)||f(t.Id)||(this._I=t.Id)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),b(this,t,n)},t.prototype.toJSON=function(){return g(this,{id:this._I,value:this._V},{})},t.prototype.setMockData=function(e){S(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.RoamingSetting=pe;var he=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"RoamingSettingCollection"},enumerable:!0,configurable:!0}),n.prototype.getItem=function(t){return r(e.RoamingSetting,this,"GetItem",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.RoamingSetting,this,"GetItemOrNullObject",1,[t],!1,!1,null,4)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.RoamingSettingCollection=he;var me=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SharedFilePicker"},enumerable:!0,configurable:!0}),n.prototype.getSharedFilePickerResponse=function(e){return s(this,"GetSharedFilePickerResponse",1,[e],4,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.SharedFilePicker,t,"Microsoft.Office.SharedFilePicker",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.SharedFilePicker=me;var ge=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ActionService"},enumerable:!0,configurable:!0}),n.prototype.areShortcutsInUse=function(e){return s(this,"AreShortcutsInUse",0,[e],0,0)},n.prototype.getShortcuts=function(){return s(this,"GetShortcuts",1,[],4,0)},n.prototype.replaceShortcuts=function(e){s(this,"ReplaceShortcuts",0,[e],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ActionService,t,"Microsoft.Office.ActionService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ActionService=ge;var ye=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Auth"},enumerable:!0,configurable:!0}),n.prototype.getAccessTokenFirstPartyOAuth=function(e,t){return s(this,"GetAccessTokenFirstPartyOAuth",1,[e,t],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.Auth,t,"Microsoft.Office.Auth",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.Auth=ye;var Oe=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"AugLoopEventService"},enumerable:!0,configurable:!0}),n.prototype.sendMessage=function(e){s(this,"SendMessage",1,[e],5,0)},n.prototype._RegisterHostMessageReceivedEvent=function(){s(this,"_RegisterHostMessageReceivedEvent",1,[],5,0)},n.prototype._UnregisterHostMessageReceivedEvent=function(){s(this,"_UnregisterHostMessageReceivedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.AugLoopEventService,t,"Microsoft.Office.AugLoopEventService",!1,5)},Object.defineProperty(n.prototype,"onHostMessageReceived",{get:function(){var e=this;return this.m_hostMessageReceived||(this.m_hostMessageReceived=new OfficeExtension.GenericEventHandlers(this.context,this,"HostMessageReceived",{eventType:65542,registerFunc:function(){return e._RegisterHostMessageReceivedEvent()},unregisterFunc:function(){return e._UnregisterHostMessageReceivedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={data:e.data};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_hostMessageReceived},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.AugLoopEventService=Oe;var ve=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"UndoService"},enumerable:!0,configurable:!0}),n.prototype.endCopilotOperation=function(e){s(this,"EndCopilotOperation",0,[e],1,0)},n.prototype.startCopilotOperation=function(e){return s(this,"StartCopilotOperation",0,[e],1,0)},n.prototype.undo=function(){return s(this,"Undo",0,[],1,0)},n.prototype._RegisterUndoStackChangedEvent=function(){s(this,"_RegisterUndoStackChangedEvent",1,[],5,0)},n.prototype._UnregisterUndoStackChangedEvent=function(){s(this,"_UnregisterUndoStackChangedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.UndoService,t,"Microsoft.Office.UndoService",!1,5)},Object.defineProperty(n.prototype,"onCopilotOperationStarted",{get:function(){return this.m_copilotOperationStarted||(this.m_copilotOperationStarted=new OfficeExtension.GenericEventHandlers(this.context,this,"CopilotOperationStarted",{eventType:65544,registerFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},unregisterFunc:function(){return OfficeExtension.Utility._createPromiseFromResult(null)},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={batchId:e.batchId};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_copilotOperationStarted},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onUndoStackChanged",{get:function(){var e=this;return this.m_undoStackChanged||(this.m_undoStackChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"UndoStackChanged",{eventType:65543,registerFunc:function(){return e._RegisterUndoStackChangedEvent()},unregisterFunc:function(){return e._UnregisterUndoStackChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){return OfficeExtension.Utility._createPromiseFromResult({})}})),this.m_undoStackChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.UndoService=ve,function(e){e.notSet="NotSet",e.true="True",e.false="False"}(e.TriStateOption||(e.TriStateOption={})),function(e){e.like="Like",e.dislike="Dislike",e.idea="Idea",e.unclassified="Unclassified"}(e.UserFeedbackType||(e.UserFeedbackType={})),function(e){e.modalDialog="ModalDialog",e.taskpane="Taskpane"}(e.UserFeedbackUIType||(e.UserFeedbackUIType={}));var be=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"UserFeedbackService"},enumerable:!0,configurable:!0}),n.prototype.canCollectUserFeedback=function(){return s(this,"CanCollectUserFeedback",1,[],5,0)},n.prototype.collectUserFeedback=function(e,t,n,r){s(this,"CollectUserFeedback",1,[e,t,n,r],5,0)},n.prototype._RegisterUserFeedbackResponseEvent=function(){s(this,"_RegisterUserFeedbackResponseEvent",1,[],5,0)},n.prototype._RegisterUserFeedbackUIDismissedEvent=function(){s(this,"_RegisterUserFeedbackUIDismissedEvent",1,[],5,0)},n.prototype._UnregisterUserFeedbackResponseEvent=function(){s(this,"_UnregisterUserFeedbackResponseEvent",1,[],5,0)},n.prototype._UnregisterUserFeedbackUIDismissedEvent=function(){s(this,"_UnregisterUserFeedbackUIDismissedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.UserFeedbackService,t,"Microsoft.Office.UserFeedbackService",!1,5)},Object.defineProperty(n.prototype,"onUserFeedbackResponse",{get:function(){var e=this;return this.m_userFeedbackResponse||(this.m_userFeedbackResponse=new OfficeExtension.GenericEventHandlers(this.context,this,"UserFeedbackResponse",{eventType:65550,registerFunc:function(){return e._RegisterUserFeedbackResponseEvent()},unregisterFunc:function(){return e._UnregisterUserFeedbackResponseEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={responseData:e.responseData};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_userFeedbackResponse},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"onUserFeedbackUIDismissed",{get:function(){var e=this;return this.m_userFeedbackUIDismissed||(this.m_userFeedbackUIDismissed=new OfficeExtension.GenericEventHandlers(this.context,this,"UserFeedbackUIDismissed",{eventType:65546,registerFunc:function(){return e._RegisterUserFeedbackUIDismissedEvent()},unregisterFunc:function(){return e._UnregisterUserFeedbackUIDismissedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={isFeedbackSent:e.isFeedbackSent};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_userFeedbackUIDismissed},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.UserFeedbackService=be;var Se=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"NotificationService"},enumerable:!0,configurable:!0}),n.prototype.addNotification=function(e,t){return s(this,"AddNotification",0,[e,t],1,0)},n.prototype.removeNotification=function(e){s(this,"RemoveNotification",0,[e],1,0)},n.prototype.updateNotification=function(e,t){s(this,"UpdateNotification",0,[e,t],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.NotificationService,t,"Microsoft.Office.NotificationService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.NotificationService=Se;var _e=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SensitivityService"},enumerable:!0,configurable:!0}),n.prototype.getHighestSensitivityLabel=function(e){return s(this,"GetHighestSensitivityLabel",0,[e],1,0)},n.prototype.getLabel=function(){return s(this,"GetLabel",0,[],1,0)},n.prototype.tryUpgradeLabel=function(e,t){s(this,"TryUpgradeLabel",0,[e,t],1,0)},n.prototype._RegisterSensitivityLabelChangedEvent=function(){s(this,"_RegisterSensitivityLabelChangedEvent",1,[],5,0)},n.prototype._UnregisterSensitivityLabelChangedEvent=function(){s(this,"_UnregisterSensitivityLabelChangedEvent",1,[],5,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.SensitivityService,t,"Microsoft.Office.SensitivityService",!1,5)},Object.defineProperty(n.prototype,"onLabelChanged",{get:function(){var e=this;return this.m_labelChanged||(this.m_labelChanged=new OfficeExtension.GenericEventHandlers(this.context,this,"LabelChanged",{eventType:65549,registerFunc:function(){return e._RegisterSensitivityLabelChangedEvent()},unregisterFunc:function(){return e._UnregisterSensitivityLabelChangedEvent()},getTargetIdFunc:function(){return""},eventArgsTransformFunc:function(e){var t={context:e.context,error:e.error,newLabel:e.newLabel,previousLabel:e.previousLabel};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_labelChanged},enumerable:!0,configurable:!0}),n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.SensitivityService=_e;var Ae=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"CopilotService"},enumerable:!0,configurable:!0}),n.prototype.launchHelpPaneByArticleId=function(e){s(this,"LaunchHelpPaneByArticleId",0,[e],1,0)},n.prototype.launchHelpPaneByArticleIdString=function(e){s(this,"LaunchHelpPaneByArticleIdString",0,[e],1,0)},n.prototype.launchHelpPaneByQuery=function(e){s(this,"LaunchHelpPaneByQuery",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.CopilotService,t,"Microsoft.Office.CopilotService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.CopilotService=Ae;var De=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"PrivateApiService"},enumerable:!0,configurable:!0}),n.prototype.execute=function(e){return s(this,"Execute",0,[e],1,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.PrivateApiService,t,"Microsoft.Office.PrivateApiService",!1,5)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.PrivateApiService=De;var Ce=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ExternalCodeService"},enumerable:!0,configurable:!0}),n.prototype.executePythonCode=function(e){return s(this,"ExecutePythonCode",0,[e],0,0)},n.prototype._handleResult=function(e){(t.prototype._handleResult.call(this,e),l(e))||y(this,e)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),b(this,e,n)},n.newObject=function(t){return o(e.ExternalCodeService,t,"Microsoft.Office.ExternalCodeService",!1,4)},n.prototype.toJSON=function(){return g(this,{},{})},n}(OfficeExtension.ClientObject);e.ExternalCodeService=Ce,function(e){e.apiNotAvailable="ApiNotAvailable",e.clientError="ClientError",e.controlIdNotFound="ControlIdNotFound",e.entryIdRequired="EntryIdRequired",e.generalException="GeneralException",e.hostRestartNeeded="HostRestartNeeded",e.instanceNotFound="InstanceNotFound",e.interactiveFlowAborted="InteractiveFlowAborted",e.invalidArgument="InvalidArgument",e.invalidGrant="InvalidGrant",e.invalidResourceUrl="InvalidResourceUrl",e.invalidRibbonDefinition="InvalidRibbonDefinition",e.objectNotFound="ObjectNotFound",e.resourceNotSupported="ResourceNotSupported",e.serverError="ServerError",e.serviceUrlNotFound="ServiceUrlNotFound",e.sharedRuntimeNotAvailable="SharedRuntimeNotAvailable",e.ticketInvalidParams="TicketInvalidParams",e.ticketNetworkError="TicketNetworkError",e.ticketUnauthorized="TicketUnauthorized",e.ticketUninitialized="TicketUninitialized",e.ticketUnknownError="TicketUnknownError",e.unexpectedError="UnexpectedError",e.unsupportedUserIdentity="UnsupportedUserIdentity",e.userNotSignedIn="UserNotSignedIn"}(e.ErrorCodes||(e.ErrorCodes={})),e.Interfaces||(e.Interfaces={})}(OfficeCore||(OfficeCore={})),function(e){var t,n;!function(e){e.hidden="Hidden",e.taskpane="Taskpane"}(t=e.VisibilityMode||(e.VisibilityMode={})),function(e){e.none="None",e.load="Load"}(n=e.StartupBehavior||(e.StartupBehavior={})),function(e){function r(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}function i(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=r(!0),OfficeCore.AppRuntimeService.newObject(t).setAppRuntimeState(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}var o;function a(e){return e===OfficeCore.Visibility.visible?t.taskpane:t.hidden}e.setStartupBehavior=function(e){return __awaiter(this,void 0,void 0,(function(){var t,i;return __generator(this,(function(o){switch(o.label){case 0:if(e!==n.load&&e!==n.none)throw OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.invalidArgument,null,null);return t=e==n.load?OfficeCore.AppRuntimeState.background:OfficeCore.AppRuntimeState.inactive,i=r(!1),OfficeCore.AppRuntimePersistenceService.newObject(i).setAppRuntimeStartState(t),[4,i.sync()];case 1:return o.sent(),[2]}}))}))},e.getStartupBehavior=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,i,o;return __generator(this,(function(a){switch(a.label){case 0:return e=r(!1),t=OfficeCore.AppRuntimePersistenceService.newObject(e),i=t.getAppRuntimeStartState(),[4,e.sync()];case 1:return a.sent(),o=i.value,[2,o==OfficeCore.AppRuntimeState.inactive?n.none:n.load]}}))}))},e.setSnapshotEnabled=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=r(!0),OfficeCore.AppRuntimeService.newObject(t).setSnapshotEnabled(e),[4,t.sync()];case 1:return n.sent(),[2,Promise.resolve()]}}))}))},e.getSnapshotEnabled=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,n;return __generator(this,(function(i){switch(i.label){case 0:return e=r(!0),t=OfficeCore.AppRuntimeService.newObject(e),n=t.getSnapshotEnabled(),[4,e.sync()];case 1:return i.sent(),[2,n.value]}}))}))},e.getContentSnapshotAsBase64=function(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){return[2,new OfficeExtension.CoreUtility.Promise((function(e,t){var n=r(!0),i=OfficeCore.AppRuntimeService.newObject(n),o=setTimeout((function(){a.remove(),n.sync().catch((function(){})),t(OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.generalException,"timeout","getContentSnapshotAsBase64"))}),7e3),a=i.onSnapshotImageReady.add((function(r){return clearTimeout(o),a.remove(),OfficeExtension.CoreUtility.isNullOrUndefined(r)?(n.sync().catch((function(){})),t(OfficeExtension.Utility.createRuntimeError(OfficeExtension.ErrorCodes.generalException,"execution failed","getContentSnapshotAsBase64"))):(n.sync().catch((function(){})),e(r.imageBase64)),null}));n.sync().then((function(){i.getContentSnapshotAsBase64();return n.sync().then((function(){return null}))})).catch((function(e){t(e)}))}))]}))}))},e._getState=function(){return __awaiter(this,void 0,void 0,(function(){var e,t,n;return __generator(this,(function(i){switch(i.label){case 0:return e=r(!0),t=OfficeCore.AppRuntimeService.newObject(e),n=t.getAppRuntimeState(),[4,e.sync()];case 1:return i.sent(),[2,n.value]}}))}))},e.showAsTaskpane=function(){return i(OfficeCore.AppRuntimeState.visible)},e.hide=function(){return i(OfficeCore.AppRuntimeState.background)},e.onVisibilityModeChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,i=this;return __generator(this,(function(s){switch(s.label){case 0:return t=function(){if(!o){var e=r(!0);o=OfficeCore.AppRuntimeService.newObject(e)}return o}(),n=t.onVisibilityChanged.add((function(t){if(e){var n={visibilityMode:a(t.visibility)};e(n)}return null})),[4,t.context.sync()];case 1:return s.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return n.remove(),[4,t.context.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))},function(e){function t(e){var t=new OfficeCore.RequestContext;return t._requestFlagModifier|=64,e&&(t._customData="WacPartition"),t}e.enable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).enable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.disable=function(){return __awaiter(this,void 0,void 0,(function(){var e,n;return __generator(this,(function(r){switch(r.label){case 0:return e=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e=!0),n=t(e),OfficeCore.BeforeDocumentCloseNotification.newObject(n).disable(),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onCloseActionCancelled=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o,a=this;return __generator(this,(function(s){switch(s.label){case 0:return n=!1,"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(n=!0),r=t(n),i=OfficeCore.BeforeDocumentCloseNotification.newObject(r),o=i.onBeforeCloseNotificationCancelled.add((function(t){return e&&e(),null})),[4,r.sync()];case 1:return s.sent(),[2,function(){return __awaiter(a,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return o.remove(),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.beforeDocumentCloseNotification||(e.beforeDocumentCloseNotification={}))}(e.addin||(e.addin={}))}(Office||(Office={})),function(e){var t;!function(e){e.taskpane="Taskpane",e.dialog="Dialog"}(t||(t={})),function(e){function n(e){return new OfficeCore.RequestContext}e.launchTaskpane=function(e){return __awaiter(this,void 0,void 0,(function(){var r,i,o;return __generator(this,(function(a){switch(a.label){case 0:return r=n(),i=OfficeCore.ExtensionLifeCycle.newObject(r),o=e.settings,e.settings=o&&OSF.OUtil.serializeSettings(o),i.launchExtensionComponent("",t.taskpane,e),[4,r.sync()];case 1:return a.sent(),[2]}}))}))},e.launchDialog=function(e){return __awaiter(this,void 0,void 0,(function(){var r,i,o;return __generator(this,(function(a){switch(a.label){case 0:return r=n(),i=OfficeCore.ExtensionLifeCycle.newObject(r),o=e.settings,e.settings=o&&OSF.OUtil.serializeSettings(o),i.launchExtensionComponent("",t.dialog,e),[4,r.sync()];case 1:return a.sent(),[2]}}))}))}}(e.extensionLifeCycle||(e.extensionLifeCycle={}))}(Office||(Office={})),function(e){!function(e){e.executePythonCode=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(i){switch(i.label){case 0:return t=function(){return new OfficeCore.RequestContext}(),n=OfficeCore.ExternalCodeService.newObject(t),r=n.executePythonCode(e),[4,t.sync()];case 1:return i.sent(),[2,r.value]}}))}))}}(e.externalCodeService||(e.externalCodeService={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.requestUpdate=function(e){var n=t(),r=n.ribbon;function i(e){void 0!==e.controls&&void 0!==e.controls.length&&e.controls.length&&e.controls.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getButton(e.id);void 0!==e.enabled&&null!==e.enabled&&(t.enabled=e.enabled)}))}return e.tabs.filter((function(e){return!!e.id})).forEach((function(e){var t=r.getTab(e.id);void 0!==e.visible&&null!==e.visible&&t.setVisibility(e.visible),e.groups&&e.groups.length?e.groups.filter((function(e){return!!e.id})).forEach((function(e){i(e)})):i(e)})),n.sync()},e.requestCreateControls=function(e){var n=t();return n.ribbon.executeRequestCreate(JSON.stringify(e)),function(e){return new Promise((function(t,n){return setTimeout((function(){return t()}),e)}))}(250).then((function(){return n.sync()}))}}(e.ribbon||(e.ribbon={}))}(Office||(Office={})),function(e){var t;OfficeExtension.BatchApiHelper.createPropertyObject,OfficeExtension.BatchApiHelper.createMethodObject,OfficeExtension.BatchApiHelper.createIndexerObject,OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject,OfficeExtension.BatchApiHelper.createChildItemObject,OfficeExtension.BatchApiHelper.invokeMethod,OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,OfficeExtension.BatchApiHelper.invokeSetProperty,OfficeExtension.Utility.isNullOrUndefined,OfficeExtension.Utility.isUndefined,OfficeExtension.Utility.throwIfNotLoaded,OfficeExtension.Utility.throwIfApiNotSupported,OfficeExtension.Utility.load,OfficeExtension.Utility.retrieve,OfficeExtension.Utility.toJson,OfficeExtension.Utility.fixObjectPathIfNecessary,OfficeExtension.Utility._handleNavigationPropertyResults,OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult,OfficeExtension.Utility.setMockData,OfficeExtension.CommonUtility.calculateApiFlags;!function(e){e.generalException="GeneralException"}(t||(t={}));new OfficeExtension.LibraryBuilder({metadata:{version:"1.0.0",name:"OfficeCore",defaultApiSetName:"OfficeSharedApi",hostName:"Office",apiSets:[],strings:["AddinInternalService"],enumTypes:[],clientObjectTypes:[[1,0,0,0,[["notifyActionHandlerReady",0,2,0,4]],0,0,0,0,"Microsoft.InternalService.AddinInternalService",4]]},targetNamespaceObject:e})}(OfficeCore||(OfficeCore={})),function(e){var t;!function(t){var n,r=OfficeExtension.Utility.isNullOrUndefined;function i(e){if(e){var t=e.toUpperCase(),i=n.mappings[t];if(!r(i)&&"function"===typeof i)return i}throw OfficeExtension.Utility.createRuntimeError("invalidOperation","sourceData","ActionProxy._getFunction")}function o(e){try{OfficeExtension.Utility.log("ActionProxy._handleMessage"),OfficeExtension.Utility.checkArgumentNull(e,"args");for(var t=e.entries,n=0;n<t.length;n++)if(2===t[n].messageCategory)if("string"===typeof t[n].message&&(t[n].message=JSON.parse(t[n].message)),1e3===t[n].messageType){var r=null,o=i(t[n].message[0]);if(t[n].message.length>=2){var s=t[n].message[1];s&&(r=a(s)?JSON.parse(s):s)}"undefined"!==typeof OSF&&OSF.AppTelemetry&&OSF.AppTelemetry.CallOnAppActivatedIfPending&&OSF.AppTelemetry.CallOnAppActivatedIfPending(),o.apply(null,[r])}else OfficeExtension.Utility.log("ActionProxy._handleMessage unknown message type "+t[n].messageType)}catch(e){throw function(e){var t=function(e){var t="Unknown Error";if(e)try{e.toString&&(t=e.toString()),t=t+" "+JSON.stringify(e)}catch(e){t="Unexpected Error"}return t}(e);OfficeExtension.Utility.log(t)}(e),e}return OfficeExtension.Utility._createPromiseFromResult(null)}function a(e){return"string"===typeof e&&"{"===e[0]}function s(){try{Microsoft.Office.WebExtension.onReadyInternal().then((function(){return function(){if("undefined"!==typeof OSF&&OSF.DDA&&OSF.DDA.RichApi&&OSF.DDA.RichApi.richApiMessageManager)return(new OfficeExtension.ClientRequestContext).eventRegistration.register(5,"",o)}()})).then((function(){var e=OSF._OfficeAppFactory.getHostInfo();return!0===e.isDialog||"web"===e.hostPlatform&&"word"!==e.hostType&&"excel"!==e.hostType?void 0:function(){var e=new OfficeExtension.ClientRequestContext,t=OfficeCore.AddinInternalService.newObject(e);return e._customData="WacPartition",t.notifyActionHandlerReady(),e.sync()}()}))}catch(e){}}!function(){OfficeExtension.Utility.log("ActionProxy.initOnce"),"undefined"!=typeof e.actions&&function(e){n=e}(e.actions._association),"undefined"!==typeof document&&(document.readyState&&"loading"!==document.readyState?(OfficeExtension.Utility.log("ActionProxy.initOnce: document.readyState is not loading state"),s()):document.addEventListener&&document.addEventListener("DOMContentLoaded",(function(){OfficeExtension.Utility.log("ActionProxy.initOnce: DOMContentLoaded event triggered"),s()}))),OfficeExtension.HostBridge.onInited((function(e){!function(e){e.addHostMessageHandler((function(e){3===e.type&&o(e.message)}))}(e)}))}()}(t||(t={}))}(Office||(Office={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(e._customData="WacPartition"),e}e.areShortcutsInUse=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o,a;return __generator(this,(function(s){switch(s.label){case 0:return n=t(),r=OfficeCore.ActionService.newObject(n),i=r.areShortcutsInUse(e),[4,n.sync()];case 1:for(s.sent(),o=[],a=0;a<e.length;a++)o.push({shortcut:e[a],inUse:i.value[a]});return[2,o]}}))}))},e.replaceShortcuts=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.ActionService.newObject(n).replaceShortcuts(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.getShortcuts=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(i){switch(i.label){case 0:return e=t(),n=OfficeCore.ActionService.newObject(e),r=n.getShortcuts(),[4,e.sync()];case 1:return i.sent(),[2,r.value]}}))}))}}(e.actions||(e.actions={}))}(Office||(Office={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.SendMessage=function(e){return __awaiter(this,void 0,void 0,(function(){var n;return __generator(this,(function(r){switch(r.label){case 0:return n=t(),OfficeCore.AugLoopEventService.newObject(n).sendMessage(e),[4,n.sync()];case 1:return r.sent(),[2]}}))}))},e.onHostMessageReceived=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o=this;return __generator(this,(function(a){switch(a.label){case 0:return n=t(),r=OfficeCore.AugLoopEventService.newObject(n),i=function(t){if(e){var n=t.data;e(n)}return null},r.onHostMessageReceived.add(i),[4,r.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return r.onHostMessageReceived.remove(i),[4,n.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.AugLoop||(e.AugLoop={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(){var e=new OfficeCore.RequestContext;return e._customData="SkipUndoRecording",e}var n;function r(){return __awaiter(this,void 0,void 0,(function(){return __generator(this,(function(e){return"undefined"!==typeof n&&(n(),n=void 0),[2]}))}))}e.undo=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(i){switch(i.label){case 0:return e=t(),n=OfficeCore.UndoService.newObject(e),r=n.undo(),[4,e.sync()];case 1:return i.sent(),[2,r.value]}}))}))},e.onUndoStackChanged=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i=this;return __generator(this,(function(o){switch(o.label){case 0:return n=t(),(r=OfficeCore.UndoService.newObject(n)).onUndoStackChanged.add(e),[4,n.sync()];case 1:return o.sent(),[2,function(){return __awaiter(i,void 0,void 0,(function(){return __generator(this,(function(t){switch(t.label){case 0:return r.onUndoStackChanged.remove(e),[4,n.sync()];case 1:return t.sent(),[2]}}))}))}]}}))}))},e.startCopilotOperation=function(){return __awaiter(this,void 0,void 0,(function(){var e,i,o,a,s;return __generator(this,(function(c){switch(c.label){case 0:if("undefined"!==typeof n)throw new Error("startCopilotOperation is already inprogress");e=new Promise((function(e){n=e})),c.label=1;case 1:return c.trys.push([1,4,,5]),i=t(),(o=OfficeCore.UndoService.newObject(i)).onCopilotOperationStarted.add(r),[4,i.sync()];case 2:return c.sent(),a=o.startCopilotOperation(""),[4,i.sync()];case 3:return c.sent(),a.value?[2,e]:(n=void 0,[3,5]);case 4:throw s=c.sent(),n=void 0,s;case 5:return[2]}}))}))},e.endCopilotOperation=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(n){switch(n.label){case 0:return e=t(),OfficeCore.UndoService.newObject(e).endCopilotOperation(""),[4,e.sync()];case 1:return n.sent(),[2]}}))}))}}(e.Undo||(e.Undo={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){e.close=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).close(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.readyToShow=function(){return __awaiter(this,void 0,void 0,(function(){var e;return __generator(this,(function(t){switch(t.label){case 0:return e=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(e).readyToShow(),[4,e.sync()];case 1:return t.sent(),[2]}}))}))},e.onShow=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(i){switch(i.label){case 0:return t=new OfficeCore.RequestContext,(n=OfficeCore.DialogPage.newObject(t)).onOnShowEvent.add(e),r=function(){return n.onOnShowEvent.remove(e),null},[4,t.sync()];case 1:return i.sent(),[2,r]}}))}))},e.sendMessageToHost=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(n){switch(n.label){case 0:return t=new OfficeCore.RequestContext,OfficeCore.DialogPage.newObject(t).sendMessageToHost(e),[4,t.sync()];case 1:return n.sent(),[2]}}))}))}}(e.dialogPage||(e.dialogPage={}))}(Office||(Office={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.CollectUserFeedback=function(e,n,r,i){return __awaiter(this,void 0,void 0,(function(){var o;return __generator(this,(function(a){switch(a.label){case 0:return o=t(),OfficeCore.UserFeedbackService.newObject(o).collectUserFeedback(e,n,r,i),[4,o.sync()];case 1:return a.sent(),[2]}}))}))},e.onUserFeedbackUIDismissed=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.isFeedbackSent;e(n)}return null},r=t(),(i=OfficeCore.UserFeedbackService.newObject(r)).onUserFeedbackUIDismissed.add(n),[4,i.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return i.onUserFeedbackUIDismissed.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))},e.CanCollectUserFeedback=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(i){switch(i.label){case 0:return e=t(),n=OfficeCore.UserFeedbackService.newObject(e),r=n.canCollectUserFeedback(),[4,e.sync()];case 1:return i.sent(),[2,r.value]}}))}))},e.onUserFeedbackResponse=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.responseData;e(n)}return null},r=t(),(i=OfficeCore.UserFeedbackService.newObject(r)).onUserFeedbackResponse.add(n),[4,i.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return i.onUserFeedbackResponse.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.UserFeedback||(e.UserFeedback={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){var t=function(){return function(){}}();function n(){var e=new OfficeCore.RequestContext;return e._customData="WacPartition",e}function r(e){return JSON.stringify(e instanceof t?{type:"callout",params:e.params}:{type:"custom",props:e})}e.callout=function(e){var n=new t;return n.params=e,n},e.addNotification=function(e,t){return __awaiter(this,void 0,void 0,(function(){var i,o,a;return __generator(this,(function(s){switch(s.label){case 0:return i=n(),o=OfficeCore.NotificationService.newObject(i),a=o.addNotification(r(e),function(e){return JSON.stringify(e)}(t)),[4,i.sync()];case 1:return s.sent(),[2,a.value]}}))}))},e.updateNotification=function(e,t){return __awaiter(this,void 0,void 0,(function(){var i;return __generator(this,(function(o){switch(o.label){case 0:return i=n(),OfficeCore.NotificationService.newObject(i).updateNotification(e,r(t)),[4,i.sync()];case 1:return o.sent(),[2]}}))}))},e.removeNotification=function(e){return __awaiter(this,void 0,void 0,(function(){var t;return __generator(this,(function(r){switch(r.label){case 0:return t=n(),OfficeCore.NotificationService.newObject(t).removeNotification(e),[4,t.sync()];case 1:return r.sent(),[2]}}))}))}}(e.Notification||(e.Notification={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.getLabel=function(){return __awaiter(this,void 0,void 0,(function(){var e,n,r;return __generator(this,(function(i){switch(i.label){case 0:return e=t(),n=OfficeCore.SensitivityService.newObject(e),r=n.getLabel(),[4,e.sync()];case 1:return i.sent(),[2,r.value]}}))}))},e.tryUpgradeLabel=function(e,n){return __awaiter(this,void 0,void 0,(function(){var r;return __generator(this,(function(i){switch(i.label){case 0:return r=t(),OfficeCore.SensitivityService.newObject(r).tryUpgradeLabel(e,n),[4,r.sync()];case 1:return i.sent(),[2]}}))}))},e.getHighestSensitivityLabel=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i;return __generator(this,(function(o){switch(o.label){case 0:return n=t(),r=OfficeCore.SensitivityService.newObject(n),i=r.getHighestSensitivityLabel(e),[4,n.sync()];case 1:return o.sent(),[2,i.value]}}))}))},e.onLabelChangedEvent=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r,i,o=this;return __generator(this,(function(a){switch(a.label){case 0:return n=function(t){if(e){var n=t.previousLabel,r=t.newLabel,i=t.context,o=t.error;e(n,r,i,o)}return null},r=t(),(i=OfficeCore.SensitivityService.newObject(r)).onLabelChanged.add(n),[4,i.context.sync()];case 1:return a.sent(),[2,function(){return __awaiter(o,void 0,void 0,(function(){return __generator(this,(function(e){switch(e.label){case 0:return i.onLabelChanged.remove(n),[4,r.sync()];case 1:return e.sent(),[2]}}))}))}]}}))}))}}(e.Sensitivity||(e.Sensitivity={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){function t(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}e.launchHelpPaneByQuery=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(i){switch(i.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByQuery(e),[4,n.sync()];case 1:return i.sent(),[2]}}))}))},e.launchHelpPaneByArticleId=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(i){switch(i.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByArticleId(e),[4,n.sync()];case 1:return i.sent(),[2]}}))}))},e.launchHelpPaneByArticleIdString=function(e){return __awaiter(this,void 0,void 0,(function(){var n,r;return __generator(this,(function(i){switch(i.label){case 0:return n=t(),r=OfficeCore.CopilotService.newObject(n),r.launchHelpPaneByArticleIdString(e),[4,n.sync()];case 1:return i.sent(),[2]}}))}))}}(e.Copilot||(e.Copilot={}))}(OfficeFirstParty||(OfficeFirstParty={})),function(e){!function(e){e.execute=function(e){return __awaiter(this,void 0,void 0,(function(){var t,n,r;return __generator(this,(function(i){switch(i.label){case 0:return t=function(e){var t=new OfficeCore.RequestContext;return t._customData="WacPartition",t}(),n=OfficeCore.PrivateApiService.newObject(t),r=n.execute(e),[4,t.sync()];case 1:return i.sent(),[2,r.value]}}))}))}}(e.PrivateApi||(e.PrivateApi={}))}(OfficeFirstParty||(OfficeFirstParty={}));var PowerPoint;__extends=this&&this.__extends||function(){var e=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])};return function(t,n){function r(){this.constructor=t}e(t,n),t.prototype=null===n?Object.create(n):(r.prototype=n.prototype,new r)}}();function exposeOfficeRuntimeThroughOfficeNamespace(e,t){var n,r;"undefined"===typeof e&&"undefined"!==typeof window&&(e=null===window||void 0===window?void 0:window.OfficeRuntime),"undefined"===typeof e&&(e={}),"undefined"!==typeof t&&(t.storage=t.storage||(null===e||void 0===e?void 0:e.storage),t.auth=t.auth||(null===e||void 0===e?void 0:e.auth),t.getAccessToken=t.getAccessToken||(null===(n=null===e||void 0===e?void 0:e.auth)||void 0===n?void 0:n.getAccessToken),t.addin=t.addin||(null===e||void 0===e?void 0:e.addin),t.isSetSupported=t.isSetSupported||(null===(r=null===e||void 0===e?void 0:e.apiInformation)||void 0===r?void 0:r.isSetSupported),t.license=t.license||(null===e||void 0===e?void 0:e.license),t.message=t.message||(null===e||void 0===e?void 0:e.message))}!function(e){var t="PowerPoint",n=OfficeExtension.BatchApiHelper.createPropertyObject,r=OfficeExtension.BatchApiHelper.createMethodObject,i=OfficeExtension.BatchApiHelper.createIndexerObject,o=(OfficeExtension.BatchApiHelper.createRootServiceObject,OfficeExtension.BatchApiHelper.createTopLevelServiceObject),a=OfficeExtension.BatchApiHelper.createChildItemObject,s=OfficeExtension.BatchApiHelper.invokeMethod,c=OfficeExtension.BatchApiHelper.invokeEnsureUnchanged,u=OfficeExtension.BatchApiHelper.invokeSetProperty,l=OfficeExtension.Utility.isNullOrUndefined,f=OfficeExtension.Utility.isUndefined,d=OfficeExtension.Utility.throwIfNotLoaded,p=OfficeExtension.Utility.throwIfApiNotSupported,h=OfficeExtension.Utility.load,m=OfficeExtension.Utility.retrieve,g=OfficeExtension.Utility.toJson,y=OfficeExtension.Utility.fixObjectPathIfNecessary,O=OfficeExtension.Utility._handleNavigationPropertyResults,v=(OfficeExtension.Utility.adjustToDateTime,OfficeExtension.Utility.processRetrieveResult),b=OfficeExtension.Utility.setMockData,S=(OfficeExtension.CommonUtility.calculateApiFlags,function(n){function r(){return null!==n&&n.apply(this,arguments)||this}return __extends(r,n),Object.defineProperty(r.prototype,"_className",{get:function(){return"Application"},enumerable:!0,configurable:!0}),r.prototype.insertHyperLink=function(e,n){p("Application.insertHyperLink","PowerPointApi","1.1",t),s(this,"InsertHyperLink",0,[e,n],1,0)},r.prototype.insertSlideFromContent=function(e){return p("Application.insertSlideFromContent","PowerPointApi","1.1",t),s(this,"InsertSlideFromContent",0,[e],1,0)},r.prototype._handleResult=function(e){(n.prototype._handleResult.call(this,e),l(e))||y(this,e)},r.prototype._handleRetrieveResult=function(e,t){n.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},r.newObject=function(t){return o(e.Application,t,"Microsoft.Office.PowerPoint.Application",!1,4)},r.prototype.toJSON=function(){return g(this,{},{})},r}(OfficeExtension.ClientObject));e.Application=S;var _=function(i){function o(){return null!==i&&i.apply(this,arguments)||this}return __extends(o,i),Object.defineProperty(o.prototype,"_className",{get:function(){return"Presentation"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["title","id"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Title","Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["slides","slideMasters","tags","bindings"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"bindings",{get:function(){return p("Presentation.bindings","Experiment52","1.1",t),this._B||(this._B=n(e.BindingCollection,this,"Bindings",!0,4)),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"slideMasters",{get:function(){return p("Presentation.slideMasters","PowerPointApi","1.3",t),this._S||(this._S=n(e.SlideMasterCollection,this,"SlideMasters",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"slides",{get:function(){return p("Presentation.slides","PowerPointApi","1.2",t),this._Sl||(this._Sl=n(e.SlideCollection,this,"Slides",!0,4)),this._Sl},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"tags",{get:function(){return p("Presentation.tags","PowerPointApi","1.3",t),this._T||(this._T=n(e.TagCollection,this,"Tags",!0,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return d("id",this._I,"Presentation",this._isNull),p("Presentation.id","PowerPointApi","1.5",t),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"title",{get:function(){return d("title",this._Ti,"Presentation",this._isNull),this._Ti},enumerable:!0,configurable:!0}),o.prototype.applyJOfcCommands=function(e,n){return p("Presentation.applyJOfcCommands","PptCopilotActionApi","1.0",t),s(this,"ApplyJOfcCommands",0,[e,n],1,0)},o.prototype.applyJOfcCommandsAsync=function(e,n){return p("Presentation.applyJOfcCommandsAsync","PptCopilotActionApi","1.0",t),s(this,"ApplyJOfcCommandsAsync",0,[e,n],1,0)},o.prototype.getSelectedShapes=function(){return p("Presentation.getSelectedShapes","PowerPointApi","1.5",t),r(e.ShapeScopedCollection,this,"GetSelectedShapes",0,[],!0,!1,null,0)},o.prototype.getSelectedSlides=function(){return p("Presentation.getSelectedSlides","PowerPointApi","1.5",t),r(e.SlideScopedCollection,this,"GetSelectedSlides",0,[],!0,!1,null,0)},o.prototype.getSelectedTextRange=function(){return p("Presentation.getSelectedTextRange","PowerPointApi","1.5",t),r(e.TextRange,this,"GetSelectedTextRange",0,[],!1,!1,null,0)},o.prototype.getSelectedTextRangeOrNullObject=function(){return p("Presentation.getSelectedTextRangeOrNullObject","PowerPointApi","1.5",t),r(e.TextRange,this,"GetSelectedTextRangeOrNullObject",0,[],!1,!1,null,0)},o.prototype.insertSlidesFromBase64=function(e,n){p("Presentation.insertSlidesFromBase64","PowerPointApi","1.2",t),s(this,"InsertSlidesFromBase64",0,[e,n],0,0)},o.prototype.setSelectedSlides=function(e){p("Presentation.setSelectedSlides","PowerPointApi","1.5",t),s(this,"SetSelectedSlides",0,[e],0,0)},o.prototype._RegisterEvent=function(e,t){s(this,"_RegisterEvent",1,[e,t],4,0)},o.prototype._RegisterEventApplyJOfcCommandsCompleted=function(){p("Presentation._RegisterEventApplyJOfcCommandsCompleted","PptCopilotActionApi","1.0",t),s(this,"_RegisterEventApplyJOfcCommandsCompleted",0,[],0,0)},o.prototype._UnregisterEvent=function(e,t){s(this,"_UnregisterEvent",1,[e,t],4,0)},o.prototype._UnregisterEventApplyJOfcCommandsCompleted=function(){p("Presentation._UnregisterEventApplyJOfcCommandsCompleted","PptCopilotActionApi","1.0",t),s(this,"_UnregisterEventApplyJOfcCommandsCompleted",0,[],0,0)},o.prototype._handleResult=function(e){if(i.prototype._handleResult.call(this,e),!l(e)){var t=e;y(this,t),f(t.Id)||(this._I=t.Id),f(t.Title)||(this._Ti=t.Title),O(this,t,["bindings","Bindings","slideMasters","SlideMasters","slides","Slides","tags","Tags"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleIdResult=function(e){i.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},o.prototype._handleRetrieveResult=function(e,t){i.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},Object.defineProperty(o.prototype,"onApplyJOfcCommandsCompleted",{get:function(){var e=this;return p("Presentation.onApplyJOfcCommandsCompleted","PptCopilotActionApi","1.0",t),this.m_applyJOfcCommandsCompleted||(this.m_applyJOfcCommandsCompleted=new OfficeExtension.GenericEventHandlers(this.context,this,"ApplyJOfcCommandsCompleted",{eventType:1,registerFunc:function(){return e._RegisterEventApplyJOfcCommandsCompleted()},unregisterFunc:function(){return e._UnregisterEventApplyJOfcCommandsCompleted()},getTargetIdFunc:function(){return e.id},eventArgsTransformFunc:function(e){var t={requestId:e.requestId,result:e.result};return OfficeExtension.Utility._createPromiseFromResult(t)}})),this.m_applyJOfcCommandsCompleted},enumerable:!0,configurable:!0}),o.prototype.toJSON=function(){return g(this,{title:this._Ti},{})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.Presentation=_,function(e){e.shape="Shape"}(e.BindingType||(e.BindingType={})),function(e){e.straight="Straight",e.elbow="Elbow",e.curve="Curve"}(e.ConnectorType||(e.ConnectorType={})),function(e){e.lineInverse="LineInverse",e.triangle="Triangle",e.rightTriangle="RightTriangle",e.rectangle="Rectangle",e.diamond="Diamond",e.parallelogram="Parallelogram",e.trapezoid="Trapezoid",e.nonIsoscelesTrapezoid="NonIsoscelesTrapezoid",e.pentagon="Pentagon",e.hexagon="Hexagon",e.heptagon="Heptagon",e.octagon="Octagon",e.decagon="Decagon",e.dodecagon="Dodecagon",e.star4="Star4",e.star5="Star5",e.star6="Star6",e.star7="Star7",e.star8="Star8",e.star10="Star10",e.star12="Star12",e.star16="Star16",e.star24="Star24",e.star32="Star32",e.roundRectangle="RoundRectangle",e.round1Rectangle="Round1Rectangle",e.round2SameRectangle="Round2SameRectangle",e.round2DiagonalRectangle="Round2DiagonalRectangle",e.snipRoundRectangle="SnipRoundRectangle",e.snip1Rectangle="Snip1Rectangle",e.snip2SameRectangle="Snip2SameRectangle",e.snip2DiagonalRectangle="Snip2DiagonalRectangle",e.plaque="Plaque",e.ellipse="Ellipse",e.teardrop="Teardrop",e.homePlate="HomePlate",e.chevron="Chevron",e.pieWedge="PieWedge",e.pie="Pie",e.blockArc="BlockArc",e.donut="Donut",e.noSmoking="NoSmoking",e.rightArrow="RightArrow",e.leftArrow="LeftArrow",e.upArrow="UpArrow",e.downArrow="DownArrow",e.stripedRightArrow="StripedRightArrow",e.notchedRightArrow="NotchedRightArrow",e.bentUpArrow="BentUpArrow",e.leftRightArrow="LeftRightArrow",e.upDownArrow="UpDownArrow",e.leftUpArrow="LeftUpArrow",e.leftRightUpArrow="LeftRightUpArrow",e.quadArrow="QuadArrow",e.leftArrowCallout="LeftArrowCallout",e.rightArrowCallout="RightArrowCallout",e.upArrowCallout="UpArrowCallout",e.downArrowCallout="DownArrowCallout",e.leftRightArrowCallout="LeftRightArrowCallout",e.upDownArrowCallout="UpDownArrowCallout",e.quadArrowCallout="QuadArrowCallout",e.bentArrow="BentArrow",e.uturnArrow="UturnArrow",e.circularArrow="CircularArrow",e.leftCircularArrow="LeftCircularArrow",e.leftRightCircularArrow="LeftRightCircularArrow",e.curvedRightArrow="CurvedRightArrow",e.curvedLeftArrow="CurvedLeftArrow",e.curvedUpArrow="CurvedUpArrow",e.curvedDownArrow="CurvedDownArrow",e.swooshArrow="SwooshArrow",e.cube="Cube",e.can="Can",e.lightningBolt="LightningBolt",e.heart="Heart",e.sun="Sun",e.moon="Moon",e.smileyFace="SmileyFace",e.irregularSeal1="IrregularSeal1",e.irregularSeal2="IrregularSeal2",e.foldedCorner="FoldedCorner",e.bevel="Bevel",e.frame="Frame",e.halfFrame="HalfFrame",e.corner="Corner",e.diagonalStripe="DiagonalStripe",e.chord="Chord",e.arc="Arc",e.leftBracket="LeftBracket",e.rightBracket="RightBracket",e.leftBrace="LeftBrace",e.rightBrace="RightBrace",e.bracketPair="BracketPair",e.bracePair="BracePair",e.callout1="Callout1",e.callout2="Callout2",e.callout3="Callout3",e.accentCallout1="AccentCallout1",e.accentCallout2="AccentCallout2",e.accentCallout3="AccentCallout3",e.borderCallout1="BorderCallout1",e.borderCallout2="BorderCallout2",e.borderCallout3="BorderCallout3",e.accentBorderCallout1="AccentBorderCallout1",e.accentBorderCallout2="AccentBorderCallout2",e.accentBorderCallout3="AccentBorderCallout3",e.wedgeRectCallout="WedgeRectCallout",e.wedgeRRectCallout="WedgeRRectCallout",e.wedgeEllipseCallout="WedgeEllipseCallout",e.cloudCallout="CloudCallout",e.cloud="Cloud",e.ribbon="Ribbon",e.ribbon2="Ribbon2",e.ellipseRibbon="EllipseRibbon",e.ellipseRibbon2="EllipseRibbon2",e.leftRightRibbon="LeftRightRibbon",e.verticalScroll="VerticalScroll",e.horizontalScroll="HorizontalScroll",e.wave="Wave",e.doubleWave="DoubleWave",e.plus="Plus",e.flowChartProcess="FlowChartProcess",e.flowChartDecision="FlowChartDecision",e.flowChartInputOutput="FlowChartInputOutput",e.flowChartPredefinedProcess="FlowChartPredefinedProcess",e.flowChartInternalStorage="FlowChartInternalStorage",e.flowChartDocument="FlowChartDocument",e.flowChartMultidocument="FlowChartMultidocument",e.flowChartTerminator="FlowChartTerminator",e.flowChartPreparation="FlowChartPreparation",e.flowChartManualInput="FlowChartManualInput",e.flowChartManualOperation="FlowChartManualOperation",e.flowChartConnector="FlowChartConnector",e.flowChartPunchedCard="FlowChartPunchedCard",e.flowChartPunchedTape="FlowChartPunchedTape",e.flowChartSummingJunction="FlowChartSummingJunction",e.flowChartOr="FlowChartOr",e.flowChartCollate="FlowChartCollate",e.flowChartSort="FlowChartSort",e.flowChartExtract="FlowChartExtract",e.flowChartMerge="FlowChartMerge",e.flowChartOfflineStorage="FlowChartOfflineStorage",e.flowChartOnlineStorage="FlowChartOnlineStorage",e.flowChartMagneticTape="FlowChartMagneticTape",e.flowChartMagneticDisk="FlowChartMagneticDisk",e.flowChartMagneticDrum="FlowChartMagneticDrum",e.flowChartDisplay="FlowChartDisplay",e.flowChartDelay="FlowChartDelay",e.flowChartAlternateProcess="FlowChartAlternateProcess",e.flowChartOffpageConnector="FlowChartOffpageConnector",e.actionButtonBlank="ActionButtonBlank",e.actionButtonHome="ActionButtonHome",e.actionButtonHelp="ActionButtonHelp",e.actionButtonInformation="ActionButtonInformation",e.actionButtonForwardNext="ActionButtonForwardNext",e.actionButtonBackPrevious="ActionButtonBackPrevious",e.actionButtonEnd="ActionButtonEnd",e.actionButtonBeginning="ActionButtonBeginning",e.actionButtonReturn="ActionButtonReturn",e.actionButtonDocument="ActionButtonDocument",e.actionButtonSound="ActionButtonSound",e.actionButtonMovie="ActionButtonMovie",e.gear6="Gear6",e.gear9="Gear9",e.funnel="Funnel",e.mathPlus="MathPlus",e.mathMinus="MathMinus",e.mathMultiply="MathMultiply",e.mathDivide="MathDivide",e.mathEqual="MathEqual",e.mathNotEqual="MathNotEqual",e.cornerTabs="CornerTabs",e.squareTabs="SquareTabs",e.plaqueTabs="PlaqueTabs",e.chartX="ChartX",e.chartStar="ChartStar",e.chartPlus="ChartPlus"}(e.GeometricShapeType||(e.GeometricShapeType={}));var A=function(n){function o(){return null!==n&&n.apply(this,arguments)||this}return __extends(o,n),Object.defineProperty(o.prototype,"_className",{get:function(){return"ShapeCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"items",{get:function(){return d("items",this.m__items,"ShapeCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),o.prototype.addGeometricShape=function(n,i){return p("ShapeCollection.addGeometricShape","PowerPointApi","1.4",t),r(e.Shape,this,"AddGeometricShape",0,[n,i],!1,!1,null,0)},o.prototype.addLine=function(n,i){return p("ShapeCollection.addLine","PowerPointApi","1.4",t),r(e.Shape,this,"AddLine",0,[n,i],!1,!1,null,0)},o.prototype.addTextBox=function(n,i){return p("ShapeCollection.addTextBox","PowerPointApi","1.4",t),r(e.Shape,this,"AddTextBox",0,[n,i],!1,!1,null,0)},o.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},o.prototype.getItem=function(t){return i(e.Shape,this,[t])},o.prototype.getItemAt=function(t){return r(e.Shape,this,"GetItemAt",1,[t],!1,!1,null,4)},o.prototype.getItemOrNullObject=function(t){return r(e.Shape,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},o.prototype._handleResult=function(t){if(n.prototype._handleResult.call(this,t),!l(t)){var r=t;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Shape,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(t,r){var i=this;n.prototype._handleRetrieveResult.call(this,t,r),v(this,t,r,(function(t,n){return a(e.Shape,!0,i,t,n)}))},o.prototype.toJSON=function(){return g(this,{},{},this.m__items)},o.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Shape,!0,n,t,r)}),(function(e){return n.m__items=e}))},o}(OfficeExtension.ClientObject);e.ShapeCollection=A;var D=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"SlideLayout"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","name"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Name"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["shapes"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"shapes",{get:function(){return this._S||(this._S=n(e.ShapeCollection,this,"Shapes",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return d("id",this._I,"SlideLayout",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"name",{get:function(){return d("name",this._N,"SlideLayout",this._isNull),this._N},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Id)||(this._I=n.Id),f(n.Name)||(this._N=n.Name),O(this,n,["shapes","Shapes"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),v(this,e,n)},r.prototype.toJSON=function(){return g(this,{},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.SlideLayout=D;var C=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SlideLayoutCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"SlideLayoutCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.SlideLayout,this,[t])},n.prototype.getItemAt=function(t){return r(e.SlideLayout,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.SlideLayout,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.SlideLayout,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.SlideLayout,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.SlideLayout,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.SlideLayoutCollection=C;var P=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"SlideMaster"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["id","name"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Name"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["layouts","shapes"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"layouts",{get:function(){return this._L||(this._L=n(e.SlideLayoutCollection,this,"Layouts",!0,4)),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"shapes",{get:function(){return this._S||(this._S=n(e.ShapeCollection,this,"Shapes",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"id",{get:function(){return d("id",this._I,"SlideMaster",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"name",{get:function(){return d("name",this._N,"SlideMaster",this._isNull),this._N},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Id)||(this._I=n.Id),f(n.Name)||(this._N=n.Name),O(this,n,["layouts","Layouts","shapes","Shapes"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),v(this,e,n)},r.prototype.toJSON=function(){return g(this,{},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.SlideMaster=P;var F=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"Tag"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["key","value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Key","Value"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"key",{get:function(){return d("key",this._K,"Tag",this._isNull),this._K},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"value",{get:function(){return d("value",this._V,"Tag",this._isNull),this._V},set:function(e){this._V=e,u(this,"Value",e,0)},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Key)||(this._K=n.Key),f(n.Value)||(this._V=n.Value)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),v(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.Tag=F;var E=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"TagCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"TagCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.add=function(e,t){s(this,"Add",0,[e,t],0,0)},n.prototype.delete=function(e){s(this,"Delete",0,[e],0,0)},n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Tag,this,[t])},n.prototype.getItemAt=function(t){return r(e.Tag,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.Tag,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Tag,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.Tag,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Tag,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.TagCollection=E;var I=function(r){function i(){return null!==r&&r.apply(this,arguments)||this}return __extends(i,r),Object.defineProperty(i.prototype,"_className",{get:function(){return"Slide"},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyNames",{get:function(){return["id"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"_navigationPropertyNames",{get:function(){return["shapes","layout","slideMaster","tags"]},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"layout",{get:function(){return p("Slide.layout","PowerPointApi","1.3",t),this._L||(this._L=n(e.SlideLayout,this,"Layout",!1,4)),this._L},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"shapes",{get:function(){return p("Slide.shapes","PowerPointApi","1.3",t),this._S||(this._S=n(e.ShapeCollection,this,"Shapes",!0,4)),this._S},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"slideMaster",{get:function(){return p("Slide.slideMaster","PowerPointApi","1.3",t),this._Sl||(this._Sl=n(e.SlideMaster,this,"SlideMaster",!1,4)),this._Sl},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"tags",{get:function(){return p("Slide.tags","PowerPointApi","1.3",t),this._T||(this._T=n(e.TagCollection,this,"Tags",!0,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(i.prototype,"id",{get:function(){return d("id",this._I,"Slide",this._isNull),this._I},enumerable:!0,configurable:!0}),i.prototype.delete=function(){s(this,"Delete",0,[],0,0)},i.prototype.setSelectedShapes=function(e){p("Slide.setSelectedShapes","PowerPointApi","1.5",t),s(this,"SetSelectedShapes",0,[e],0,0)},i.prototype._handleResult=function(e){if(r.prototype._handleResult.call(this,e),!l(e)){var t=e;y(this,t),f(t.Id)||(this._I=t.Id),O(this,t,["layout","Layout","shapes","Shapes","slideMaster","SlideMaster","tags","Tags"])}},i.prototype.load=function(e){return h(this,e)},i.prototype.retrieve=function(e){return m(this,e)},i.prototype._handleIdResult=function(e){r.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},i.prototype._handleRetrieveResult=function(e,t){r.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},i.prototype.toJSON=function(){return g(this,{},{})},i.prototype.setMockData=function(e){b(this,e)},i.prototype.ensureUnchanged=function(e){c(this,e)},i}(OfficeExtension.ClientObject);e.Slide=I,function(e){e.noFill="NoFill",e.solid="Solid",e.gradient="Gradient",e.pattern="Pattern",e.pictureAndTexture="PictureAndTexture",e.slideBackground="SlideBackground"}(e.ShapeFillType||(e.ShapeFillType={}));var x=function(e){function n(){return null!==e&&e.apply(this,arguments)||this}return __extends(n,e),Object.defineProperty(n.prototype,"_className",{get:function(){return"ShapeFill"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["foregroundColor","transparency","type"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["ForegroundColor","Transparency","Type"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"foregroundColor",{get:function(){return d("foregroundColor",this._F,"ShapeFill",this._isNull),this._F},set:function(e){this._F=e,u(this,"ForegroundColor",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"transparency",{get:function(){return d("transparency",this._T,"ShapeFill",this._isNull),this._T},set:function(e){this._T=e,u(this,"Transparency",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"type",{get:function(){return d("type",this._Ty,"ShapeFill",this._isNull),this._Ty},enumerable:!0,configurable:!0}),n.prototype.clear=function(){s(this,"Clear",0,[],0,0)},n.prototype.setImage=function(e){p("ShapeFill.setImage","Experiment52","1.1",t),s(this,"SetImage",0,[e],0,0)},n.prototype.setSolidColor=function(e){s(this,"SetSolidColor",0,[e],0,0)},n.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.ForegroundColor)||(this._F=n.ForegroundColor),f(n.Transparency)||(this._T=n.Transparency),f(n.Type)||(this._Ty=n.Type)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),v(this,t,n)},n.prototype.toJSON=function(){return g(this,{},{})},n.prototype.setMockData=function(e){b(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.ShapeFill=x,function(e){e.single="Single",e.thickBetweenThin="ThickBetweenThin",e.thickThin="ThickThin",e.thinThick="ThinThick",e.thinThin="ThinThin"}(e.ShapeLineStyle||(e.ShapeLineStyle={})),function(e){e.dash="Dash",e.dashDot="DashDot",e.dashDotDot="DashDotDot",e.longDash="LongDash",e.longDashDot="LongDashDot",e.roundDot="RoundDot",e.solid="Solid",e.squareDot="SquareDot",e.longDashDotDot="LongDashDotDot",e.systemDash="SystemDash",e.systemDot="SystemDot",e.systemDashDot="SystemDashDot"}(e.ShapeLineDashStyle||(e.ShapeLineDashStyle={}));var M=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"ShapeLineFormat"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["color","dashStyle","style","transparency","visible","weight"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Color","DashStyle","Style","Transparency","Visible","Weight"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"color",{get:function(){return d("color",this._C,"ShapeLineFormat",this._isNull),this._C},set:function(e){this._C=e,u(this,"Color",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"dashStyle",{get:function(){return d("dashStyle",this._D,"ShapeLineFormat",this._isNull),this._D},set:function(e){this._D=e,u(this,"DashStyle",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"style",{get:function(){return d("style",this._S,"ShapeLineFormat",this._isNull),this._S},set:function(e){this._S=e,u(this,"Style",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"transparency",{get:function(){return d("transparency",this._T,"ShapeLineFormat",this._isNull),this._T},set:function(e){this._T=e,u(this,"Transparency",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"visible",{get:function(){return d("visible",this._V,"ShapeLineFormat",this._isNull),this._V},set:function(e){this._V=e,u(this,"Visible",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"weight",{get:function(){return d("weight",this._W,"ShapeLineFormat",this._isNull),this._W},set:function(e){this._W=e,u(this,"Weight",e,0)},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Color)||(this._C=n.Color),f(n.DashStyle)||(this._D=n.DashStyle),f(n.Style)||(this._S=n.Style),f(n.Transparency)||(this._T=n.Transparency),f(n.Visible)||(this._V=n.Visible),f(n.Weight)||(this._W=n.Weight)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),v(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.ShapeLineFormat=M,function(e){e.unsupported="Unsupported",e.image="Image",e.geometricShape="GeometricShape",e.group="Group",e.line="Line"}(e.ShapeType||(e.ShapeType={})),function(e){e.autoSizeNone="AutoSizeNone",e.autoSizeTextToFitShape="AutoSizeTextToFitShape",e.autoSizeShapeToFitText="AutoSizeShapeToFitText",e.autoSizeMixed="AutoSizeMixed"}(e.ShapeAutoSize||(e.ShapeAutoSize={})),function(e){e.top="Top",e.middle="Middle",e.bottom="Bottom",e.topCentered="TopCentered",e.middleCentered="MiddleCentered",e.bottomCentered="BottomCentered"}(e.TextVerticalAlignment||(e.TextVerticalAlignment={})),function(e){e.left="Left",e.center="Center",e.right="Right",e.justify="Justify",e.justifyLow="JustifyLow",e.distributed="Distributed",e.thaiDistributed="ThaiDistributed"}(e.ParagraphHorizontalAlignment||(e.ParagraphHorizontalAlignment={}));var T=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"BulletFormat"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["visible"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Visible"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"visible",{get:function(){return d("visible",this._V,"BulletFormat",this._isNull),this._V},set:function(e){this._V=e,u(this,"Visible",e,0)},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Visible)||(this._V=n.Visible)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),v(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.BulletFormat=T;var R=function(t){function r(){return null!==t&&t.apply(this,arguments)||this}return __extends(r,t),Object.defineProperty(r.prototype,"_className",{get:function(){return"ParagraphFormat"},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyNames",{get:function(){return["horizontalAlignment"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyOriginalNames",{get:function(){return["HorizontalAlignment"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"_navigationPropertyNames",{get:function(){return["bulletFormat"]},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"bulletFormat",{get:function(){return this._B||(this._B=n(e.BulletFormat,this,"BulletFormat",!1,4)),this._B},enumerable:!0,configurable:!0}),Object.defineProperty(r.prototype,"horizontalAlignment",{get:function(){return d("horizontalAlignment",this._H,"ParagraphFormat",this._isNull),this._H},set:function(e){this._H=e,u(this,"HorizontalAlignment",e,0)},enumerable:!0,configurable:!0}),r.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.HorizontalAlignment)||(this._H=n.HorizontalAlignment),O(this,n,["bulletFormat","BulletFormat"])}},r.prototype.load=function(e){return h(this,e)},r.prototype.retrieve=function(e){return m(this,e)},r.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),v(this,e,n)},r.prototype.toJSON=function(){return g(this,{},{})},r.prototype.setMockData=function(e){b(this,e)},r.prototype.ensureUnchanged=function(e){c(this,e)},r}(OfficeExtension.ClientObject);e.ParagraphFormat=R,function(e){e.none="None",e.single="Single",e.double="Double",e.heavy="Heavy",e.dotted="Dotted",e.dottedHeavy="DottedHeavy",e.dash="Dash",e.dashHeavy="DashHeavy",e.dashLong="DashLong",e.dashLongHeavy="DashLongHeavy",e.dotDash="DotDash",e.dotDashHeavy="DotDashHeavy",e.dotDotDash="DotDotDash",e.dotDotDashHeavy="DotDotDashHeavy",e.wavy="Wavy",e.wavyHeavy="WavyHeavy",e.wavyDouble="WavyDouble"}(e.ShapeFontUnderlineStyle||(e.ShapeFontUnderlineStyle={}));var w=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return __extends(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"ShapeFont"},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyNames",{get:function(){return["bold","color","italic","name","size","underline"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Bold","Color","Italic","Name","Size","Underline"]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"bold",{get:function(){return d("bold",this._B,"ShapeFont",this._isNull),this._B},set:function(e){this._B=e,u(this,"Bold",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"color",{get:function(){return d("color",this._C,"ShapeFont",this._isNull),this._C},set:function(e){this._C=e,u(this,"Color",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"italic",{get:function(){return d("italic",this._I,"ShapeFont",this._isNull),this._I},set:function(e){this._I=e,u(this,"Italic",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"name",{get:function(){return d("name",this._N,"ShapeFont",this._isNull),this._N},set:function(e){this._N=e,u(this,"Name",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"size",{get:function(){return d("size",this._S,"ShapeFont",this._isNull),this._S},set:function(e){this._S=e,u(this,"Size",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"underline",{get:function(){return d("underline",this._U,"ShapeFont",this._isNull),this._U},set:function(e){this._U=e,u(this,"Underline",e,0)},enumerable:!0,configurable:!0}),t.prototype._handleResult=function(t){if(e.prototype._handleResult.call(this,t),!l(t)){var n=t;y(this,n),f(n.Bold)||(this._B=n.Bold),f(n.Color)||(this._C=n.Color),f(n.Italic)||(this._I=n.Italic),f(n.Name)||(this._N=n.Name),f(n.Size)||(this._S=n.Size),f(n.Underline)||(this._U=n.Underline)}},t.prototype.load=function(e){return h(this,e)},t.prototype.retrieve=function(e){return m(this,e)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),v(this,t,n)},t.prototype.toJSON=function(){return g(this,{},{})},t.prototype.setMockData=function(e){b(this,e)},t.prototype.ensureUnchanged=function(e){c(this,e)},t}(OfficeExtension.ClientObject);e.ShapeFont=w;var N=function(i){function o(){return null!==i&&i.apply(this,arguments)||this}return __extends(o,i),Object.defineProperty(o.prototype,"_className",{get:function(){return"TextRange"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["text","length","start"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Text","Length","Start"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["font","paragraphFormat"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"font",{get:function(){return this._F||(this._F=n(e.ShapeFont,this,"Font",!1,4)),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"paragraphFormat",{get:function(){return this._P||(this._P=n(e.ParagraphFormat,this,"ParagraphFormat",!1,4)),this._P},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"length",{get:function(){return d("length",this._L,"TextRange",this._isNull),p("TextRange.length","PowerPointApi","1.5",t),this._L},set:function(e){this._L=e,u(this,"Length",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"start",{get:function(){return d("start",this._S,"TextRange",this._isNull),p("TextRange.start","PowerPointApi","1.5",t),this._S},set:function(e){this._S=e,u(this,"Start",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"text",{get:function(){return d("text",this._T,"TextRange",this._isNull),this._T},set:function(e){this._T=e,u(this,"Text",e,0)},enumerable:!0,configurable:!0}),o.prototype.getParentTextFrame=function(){return p("TextRange.getParentTextFrame","PowerPointApi","1.5",t),r(e.TextFrame,this,"GetParentTextFrame",0,[],!1,!1,null,0)},o.prototype.getSubstring=function(t,n){return r(e.TextRange,this,"GetSubstring",0,[t,n],!1,!1,null,0)},o.prototype.setSelected=function(){p("TextRange.setSelected","PowerPointApi","1.5",t),s(this,"SetSelected",0,[],0,0)},o.prototype._handleResult=function(e){if(i.prototype._handleResult.call(this,e),!l(e)){var t=e;y(this,t),f(t.Length)||(this._L=t.Length),f(t.Start)||(this._S=t.Start),f(t.Text)||(this._T=t.Text),O(this,t,["font","Font","paragraphFormat","ParagraphFormat"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(e,t){i.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},o.prototype.toJSON=function(){return g(this,{},{})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.TextRange=N;var j=function(i){function o(){return null!==i&&i.apply(this,arguments)||this}return __extends(o,i),Object.defineProperty(o.prototype,"_className",{get:function(){return"TextFrame"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["autoSizeSetting","bottomMargin","hasText","leftMargin","rightMargin","topMargin","verticalAlignment","wordWrap"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["AutoSizeSetting","BottomMargin","HasText","LeftMargin","RightMargin","TopMargin","VerticalAlignment","WordWrap"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!0,!0,!1,!0,!0,!0,!0,!0]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["textRange"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"textRange",{get:function(){return this._T||(this._T=n(e.TextRange,this,"TextRange",!1,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"autoSizeSetting",{get:function(){return d("autoSizeSetting",this._A,"TextFrame",this._isNull),this._A},set:function(e){this._A=e,u(this,"AutoSizeSetting",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"bottomMargin",{get:function(){return d("bottomMargin",this._B,"TextFrame",this._isNull),this._B},set:function(e){this._B=e,u(this,"BottomMargin",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"hasText",{get:function(){return d("hasText",this._H,"TextFrame",this._isNull),this._H},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"leftMargin",{get:function(){return d("leftMargin",this._L,"TextFrame",this._isNull),this._L},set:function(e){this._L=e,u(this,"LeftMargin",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"rightMargin",{get:function(){return d("rightMargin",this._R,"TextFrame",this._isNull),this._R},set:function(e){this._R=e,u(this,"RightMargin",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"topMargin",{get:function(){return d("topMargin",this._To,"TextFrame",this._isNull),this._To},set:function(e){this._To=e,u(this,"TopMargin",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"verticalAlignment",{get:function(){return d("verticalAlignment",this._V,"TextFrame",this._isNull),this._V},set:function(e){this._V=e,u(this,"VerticalAlignment",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"wordWrap",{get:function(){return d("wordWrap",this._W,"TextFrame",this._isNull),this._W},set:function(e){this._W=e,u(this,"WordWrap",e,0)},enumerable:!0,configurable:!0}),o.prototype.deleteText=function(){s(this,"DeleteText",0,[],0,0)},o.prototype.getParentShape=function(){return p("TextFrame.getParentShape","PowerPointApi","1.5",t),r(e.Shape,this,"GetParentShape",0,[],!1,!1,null,0)},o.prototype._handleResult=function(e){if(i.prototype._handleResult.call(this,e),!l(e)){var t=e;y(this,t),f(t.AutoSizeSetting)||(this._A=t.AutoSizeSetting),f(t.BottomMargin)||(this._B=t.BottomMargin),f(t.HasText)||(this._H=t.HasText),f(t.LeftMargin)||(this._L=t.LeftMargin),f(t.RightMargin)||(this._R=t.RightMargin),f(t.TopMargin)||(this._To=t.TopMargin),f(t.VerticalAlignment)||(this._V=t.VerticalAlignment),f(t.WordWrap)||(this._W=t.WordWrap),O(this,t,["textRange","TextRange"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(e,t){i.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},o.prototype.toJSON=function(){return g(this,{},{})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.TextFrame=j,function(e){e.bringForward="BringForward",e.bringToFront="BringToFront",e.sendBackward="SendBackward",e.sendToBack="SendToBack"}(e.ShapeZOrder||(e.ShapeZOrder={}));var U=function(i){function o(){return null!==i&&i.apply(this,arguments)||this}return __extends(o,i),Object.defineProperty(o.prototype,"_className",{get:function(){return"Shape"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyNames",{get:function(){return["id","height","left","name","top","type","width","zorderPosition"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Height","Left","Name","Top","Type","Width","ZOrderPosition"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_scalarPropertyUpdateable",{get:function(){return[!1,!0,!0,!0,!0,!1,!0,!1]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_navigationPropertyNames",{get:function(){return["tags","fill","lineFormat","textFrame"]},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"fill",{get:function(){return p("Shape.fill","PowerPointApi","1.4",t),this._F||(this._F=n(e.ShapeFill,this,"Fill",!1,4)),this._F},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"lineFormat",{get:function(){return p("Shape.lineFormat","PowerPointApi","1.4",t),this._Li||(this._Li=n(e.ShapeLineFormat,this,"LineFormat",!1,4)),this._Li},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"tags",{get:function(){return this._T||(this._T=n(e.TagCollection,this,"Tags",!0,4)),this._T},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"textFrame",{get:function(){return p("Shape.textFrame","PowerPointApi","1.4",t),this._Te||(this._Te=n(e.TextFrame,this,"TextFrame",!1,4)),this._Te},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"height",{get:function(){return d("height",this._H,"Shape",this._isNull),p("Shape.height","PowerPointApi","1.4",t),this._H},set:function(e){this._H=e,u(this,"Height",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"id",{get:function(){return d("id",this._I,"Shape",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"left",{get:function(){return d("left",this._L,"Shape",this._isNull),p("Shape.left","PowerPointApi","1.4",t),this._L},set:function(e){this._L=e,u(this,"Left",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"name",{get:function(){return d("name",this._N,"Shape",this._isNull),p("Shape.name","PowerPointApi","1.4",t),this._N},set:function(e){this._N=e,u(this,"Name",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"top",{get:function(){return d("top",this._To,"Shape",this._isNull),p("Shape.top","PowerPointApi","1.4",t),this._To},set:function(e){this._To=e,u(this,"Top",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"type",{get:function(){return d("type",this._Ty,"Shape",this._isNull),p("Shape.type","PowerPointApi","1.4",t),this._Ty},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"width",{get:function(){return d("width",this._W,"Shape",this._isNull),p("Shape.width","PowerPointApi","1.4",t),this._W},set:function(e){this._W=e,u(this,"Width",e,0)},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"zorderPosition",{get:function(){return d("zorderPosition",this._Z,"Shape",this._isNull),p("Shape.zorderPosition","Experiment52","1.1",t),this._Z},enumerable:!0,configurable:!0}),o.prototype.delete=function(){s(this,"Delete",0,[],0,0)},o.prototype.getParentSlide=function(){return p("Shape.getParentSlide","PowerPointApi","1.5",t),r(e.Slide,this,"GetParentSlide",0,[],!1,!1,null,0)},o.prototype.getParentSlideLayout=function(){return p("Shape.getParentSlideLayout","PowerPointApi","1.5",t),r(e.SlideLayout,this,"GetParentSlideLayout",0,[],!1,!1,null,0)},o.prototype.getParentSlideLayoutOrNullObject=function(){return p("Shape.getParentSlideLayoutOrNullObject","PowerPointApi","1.5",t),r(e.SlideLayout,this,"GetParentSlideLayoutOrNullObject",0,[],!1,!1,null,0)},o.prototype.getParentSlideMaster=function(){return p("Shape.getParentSlideMaster","PowerPointApi","1.5",t),r(e.SlideMaster,this,"GetParentSlideMaster",0,[],!1,!1,null,0)},o.prototype.getParentSlideMasterOrNullObject=function(){return p("Shape.getParentSlideMasterOrNullObject","PowerPointApi","1.5",t),r(e.SlideMaster,this,"GetParentSlideMasterOrNullObject",0,[],!1,!1,null,0)},o.prototype.getParentSlideOrNullObject=function(){return p("Shape.getParentSlideOrNullObject","PowerPointApi","1.5",t),r(e.Slide,this,"GetParentSlideOrNullObject",0,[],!1,!1,null,0)},o.prototype.setZOrder=function(e){p("Shape.setZOrder","Experiment52","1.1",t),s(this,"SetZOrder",0,[e],0,0)},o.prototype._handleResult=function(e){if(i.prototype._handleResult.call(this,e),!l(e)){var t=e;y(this,t),f(t.Height)||(this._H=t.Height),f(t.Id)||(this._I=t.Id),f(t.Left)||(this._L=t.Left),f(t.Name)||(this._N=t.Name),f(t.Top)||(this._To=t.Top),f(t.Type)||(this._Ty=t.Type),f(t.Width)||(this._W=t.Width),f(t.ZOrderPosition)||(this._Z=t.ZOrderPosition),O(this,t,["fill","Fill","lineFormat","LineFormat","tags","Tags","textFrame","TextFrame"])}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleIdResult=function(e){i.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},o.prototype._handleRetrieveResult=function(e,t){i.prototype._handleRetrieveResult.call(this,e,t),v(this,e,t)},o.prototype.toJSON=function(){return g(this,{},{})},o.prototype.setMockData=function(e){b(this,e)},o.prototype.ensureUnchanged=function(e){c(this,e)},o}(OfficeExtension.ClientObject);e.Shape=U;var k=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"Binding"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyNames",{get:function(){return["id","type"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_scalarPropertyOriginalNames",{get:function(){return["Id","Type"]},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"id",{get:function(){return d("id",this._I,"Binding",this._isNull),this._I},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"type",{get:function(){return d("type",this._T,"Binding",this._isNull),this._T},enumerable:!0,configurable:!0}),n.prototype.delete=function(){s(this,"Delete",0,[],0,0)},n.prototype.getShape=function(){return r(e.Shape,this,"GetShape",0,[],!1,!1,null,0)},n.prototype._handleResult=function(e){if(t.prototype._handleResult.call(this,e),!l(e)){var n=e;y(this,n),f(n.Id)||(this._I=n.Id),f(n.Type)||(this._T=n.Type)}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleIdResult=function(e){t.prototype._handleIdResult.call(this,e),l(e)||f(e.Id)||(this._I=e.Id)},n.prototype._handleRetrieveResult=function(e,n){t.prototype._handleRetrieveResult.call(this,e,n),v(this,e,n)},n.prototype.toJSON=function(){return g(this,{},{})},n.prototype.setMockData=function(e){b(this,e)},n.prototype.ensureUnchanged=function(e){c(this,e)},n}(OfficeExtension.ClientObject);e.Binding=k;var L=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"BindingCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"BindingCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.add=function(t,n,i){return r(e.Binding,this,"Add",0,[t,n,i],!1,!0,null,0)},n.prototype.addFromSelection=function(t,n){return r(e.Binding,this,"AddFromSelection",0,[t,n],!1,!1,null,0)},n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Binding,this,[t])},n.prototype.getItemAt=function(t){return r(e.Binding,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.Binding,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Binding,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.Binding,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Binding,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.BindingCollection=L,function(e){e.keepSourceFormatting="KeepSourceFormatting",e.useDestinationTheme="UseDestinationTheme"}(e.InsertSlideFormatting||(e.InsertSlideFormatting={}));var H=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"ShapeScopedCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"ShapeScopedCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Shape,this,[t])},n.prototype.getItemAt=function(t){return r(e.Shape,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.Shape,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Shape,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.Shape,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Shape,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.ShapeScopedCollection=H;var W=function(n){function o(){return null!==n&&n.apply(this,arguments)||this}return __extends(o,n),Object.defineProperty(o.prototype,"_className",{get:function(){return"SlideCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(o.prototype,"items",{get:function(){return d("items",this.m__items,"SlideCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),o.prototype.add=function(e){p("SlideCollection.add","PowerPointApi","1.3",t),s(this,"Add",0,[e],0,0)},o.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},o.prototype.getItem=function(t){return i(e.Slide,this,[t])},o.prototype.getItemAt=function(t){return r(e.Slide,this,"GetItemAt",1,[t],!1,!1,null,4)},o.prototype.getItemOrNullObject=function(t){return r(e.Slide,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},o.prototype._handleResult=function(t){if(n.prototype._handleResult.call(this,t),!l(t)){var r=t;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Slide,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},o.prototype.load=function(e){return h(this,e)},o.prototype.retrieve=function(e){return m(this,e)},o.prototype._handleRetrieveResult=function(t,r){var i=this;n.prototype._handleRetrieveResult.call(this,t,r),v(this,t,r,(function(t,n){return a(e.Slide,!0,i,t,n)}))},o.prototype.toJSON=function(){return g(this,{},{},this.m__items)},o.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Slide,!0,n,t,r)}),(function(e){return n.m__items=e}))},o}(OfficeExtension.ClientObject);e.SlideCollection=W;var B=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SlideScopedCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"SlideScopedCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.Slide,this,[t])},n.prototype.getItemAt=function(t){return r(e.Slide,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.Slide,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.Slide,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.Slide,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.Slide,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.SlideScopedCollection=B;var G=function(t){function n(){return null!==t&&t.apply(this,arguments)||this}return __extends(n,t),Object.defineProperty(n.prototype,"_className",{get:function(){return"SlideMasterCollection"},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"_isCollection",{get:function(){return!0},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"items",{get:function(){return d("items",this.m__items,"SlideMasterCollection",this._isNull),this.m__items},enumerable:!0,configurable:!0}),n.prototype.getCount=function(){return s(this,"GetCount",1,[],4,0)},n.prototype.getItem=function(t){return i(e.SlideMaster,this,[t])},n.prototype.getItemAt=function(t){return r(e.SlideMaster,this,"GetItemAt",1,[t],!1,!1,null,4)},n.prototype.getItemOrNullObject=function(t){return r(e.SlideMaster,this,"GetItemOrNullObject",0,[t],!1,!1,null,0)},n.prototype._handleResult=function(n){if(t.prototype._handleResult.call(this,n),!l(n)){var r=n;if(y(this,r),!l(r[OfficeExtension.Constants.items])){this.m__items=[];for(var i=r[OfficeExtension.Constants.items],o=0;o<i.length;o++){var s=a(e.SlideMaster,!0,this,i[o],o);s._handleResult(i[o]),this.m__items.push(s)}}}},n.prototype.load=function(e){return h(this,e)},n.prototype.retrieve=function(e){return m(this,e)},n.prototype._handleRetrieveResult=function(n,r){var i=this;t.prototype._handleRetrieveResult.call(this,n,r),v(this,n,r,(function(t,n){return a(e.SlideMaster,!0,i,t,n)}))},n.prototype.toJSON=function(){return g(this,{},{},this.m__items)},n.prototype.setMockData=function(t){var n=this;b(this,t,(function(t,r){return a(e.SlideMaster,!0,n,t,r)}),(function(e){return n.m__items=e}))},n}(OfficeExtension.ClientObject);e.SlideMasterCollection=G,function(e){e.generalException="GeneralException"}(e.ErrorCodes||(e.ErrorCodes={}))}(PowerPoint||(PowerPoint={})),function(e){var t=function(t){function n(n){var r=t.call(this,n)||this;return r.m_presentation=new e.Presentation(r,OfficeExtension.ObjectPathFactory.createGlobalObjectObjectPath(r)),r._rootObject=r.m_presentation,r}return __extends(n,t),Object.defineProperty(n.prototype,"presentation",{get:function(){return this.m_presentation},enumerable:!0,configurable:!0}),Object.defineProperty(n.prototype,"application",{get:function(){return null==this.m_application&&(this.m_application=new e.Application(this,OfficeExtension.ObjectPathFactory.createNewObjectObjectPath(this,"Microsoft.Office.PowerPoint.Application",!1))),this.m_application},enumerable:!0,configurable:!0}),n}(OfficeCore.RequestContext);e.RequestContext=t,e.run=function(t,n){return OfficeExtension.ClientRequestContext._runBatch("PowerPoint.run",arguments,(function(){return new e.RequestContext}))}}(PowerPoint||(PowerPoint={})),function(e){e.createPresentation=function(e){return new Office.Promise((function(t,n){try{OfficeExtension.Utility.throwIfApiNotSupported("PowerPoint.createPresentation","PowerPointApi","1.1","PowerPoint")}catch(e){return void n(e)}var r=function(e){e.status===Office.AsyncResultStatus.Failed?n(new OfficeExtension.Error({code:OfficeExtension.ErrorCodes.generalException,message:e.error.message,debugInfo:{}})):t()},i=Office.context.application.createDocumentAsync;e?i({base64:e},r):i(r)}))}}(PowerPoint||(PowerPoint={})),OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithOTel=!0,OSFAriaLogger.AriaLogger.EnableSendingTelemetryWithLegacyAria=!1,window.OfficeExtensionBatch=window.OfficeExtension,function(e){var t={};function n(r){if(t[r])return t[r].exports;var i=t[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,n),i.l=!0,i.exports}n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var i in e)n.d(r,i,function(t){return e[t]}.bind(null,i));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=1)}([function(e,t){e.exports=OfficeExtensionBatch},function(e,t,n){"use strict";var r=this&&this.__assign||function(){return(r=Object.assign||function(e){for(var t,n=1,r=arguments.length;n<r;n++)for(var i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e}).apply(this,arguments)};Object.defineProperty(t,"__esModule",{value:!0});var i,o,a=n(2),s=n(4),c=n(5),u=n(6),l=n(7),f=n(8),d=n(9),p=n(12),h=n(13);"undefined"!=typeof OSF&&OSF._OfficeAppFactory&&OSF._OfficeAppFactory.getHostInfo&&0!=(1&OSF._OfficeAppFactory.getHostInfo().flags)?(i=u,o=l.storage):(i=c.AsyncStorage,o=c.storage),window._OfficeRuntimeNative=r(r({},window.OfficeRuntime),{displayWebDialog:s.displayWebDialog,AsyncStorage:i,storage:o,experimentation:f.experimentation,apiInformation:a.apiInformation,message:d.Message.instance,ui:p.ui,auth:h.Auth.instance}),Object.freeze(window._OfficeRuntimeNative)},function(e,t,n){"use strict";(function(e){function n(e){var t,n=e.split("."),r=0,i=0;if(n.length<2&&isNaN(Number(e)))throw"version format incorrect";if(t=Number(n[0]),n.length>=2&&(r=Number(n[1])),n.length>=3&&(i=Number(n[2])),isNaN(t)||isNaN(r)||isNaN(i))throw"version format incorrect";return{major:t,minor:r,patch:i}}Object.defineProperty(t,"__esModule",{value:!0}),t.apiInformation=void 0,t.apiInformation={isSetSupported:function(t,r){if("string"!=typeof t)return!1;if(null==r&&(r="0.0.0"),void 0===e.__apiSets)return!1;var i=e.__apiSets,o=Object.keys(i).map((function(e){return e.toLowerCase()})).indexOf(t.toLowerCase());if(o>-1){var a=i[Object.keys(i)[o]];try{var s,c=n(r);if((s=Array.isArray(a)?function(e,t){for(var r=0;r<e.length;r++){var i=n(e[r]);if(i.major==t)return i}return{major:0,minor:0,patch:0}}(a,c.major):n(a)).major>0){if(s.major>c.major)return!0;if(s.major==c.major&&s.minor>c.minor)return!0;if(s.major==c.major&&s.minor==c.minor&&s.patch>=c.patch)return!0}}catch(e){return!1}}return!1}}}).call(this,n(3))},function(e,t){var n;n=function(){return this}();try{n=n||new Function("return this")()}catch(e){"object"==typeof window&&(n=window)}e.exports=n},function(e,t,n){"use strict";var r,i=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0}),t.DialogErrorCodes=t.DialogService=t.displayWebDialog=t.Dialog=void 0;var o=n(0),a=(o.BatchApiHelper.createPropertyObject,o.BatchApiHelper.createMethodObject,o.BatchApiHelper.createIndexerObject,o.BatchApiHelper.createRootServiceObject,o.BatchApiHelper.createTopLevelServiceObject),s=(o.BatchApiHelper.createChildItemObject,o.BatchApiHelper.invokeMethod),c=(o.BatchApiHelper.invokeEnsureUnchanged,o.BatchApiHelper.invokeSetProperty,o.Utility.isNullOrUndefined),u=(o.Utility.isUndefined,o.Utility.throwIfNotLoaded,o.Utility.throwIfApiNotSupported,o.Utility.load,o.Utility.retrieve,o.Utility.toJson),l=o.Utility.fixObjectPathIfNecessary,f=(o.Utility._handleNavigationPropertyResults,o.Utility.adjustToDateTime,o.Utility.processRetrieveResult),d=(o.Utility.setMockData,o.CommonUtility.calculateApiFlags,function(){function e(e){this._dialogService=e}return e.prototype.close=function(){return this._dialogService.close(),this._dialogService.context.sync()},e}());t.Dialog=d,t.displayWebDialog=function(e,t){return void 0===t&&(t={}),new o.CoreUtility.Promise((function(r,i){if(t.width&&t.height&&(!n(t.width)||!n(t.height)))throw new o.Error({code:"InvalidArgument",message:'Dimensions must be "number%" or number.'});var a=new o.ClientRequestContext,s=h.newObject(a),c=new d(s),u=s.onDialogMessage.add((function(e){switch(o.Utility.log("dialogMessageHandler:"+JSON.stringify(e)),e.type){case 17:e.error?i(e.error):r(c);break;case 12:t.onMessage&&t.onMessage(e.message,c,e.origin);break;case 10:default:12006===e.originalErrorCode?(u&&(u.remove(),a.sync()),t.onClose&&t.onClose()):t.onRuntimeError&&(t.onRuntimeError(e.error,c),i(e.error))}return o.CoreUtility.Promise.resolve()}));return a.sync().then((function(){var n={width:t.width?parseInt(t.width):50,height:t.height?parseInt(t.height):50,displayInIFrame:t.displayInIFrame};return s.displayDialog(e,n),a.sync()})).catch((function(e){i(e)}))}));function n(e){return/^(\-|\+)?([0-9]+)%?$/.test(e)}};var p,h=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return i(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"DialogService"},enumerable:!1,configurable:!0}),t.prototype.close=function(){s(this,"Close",1,[],4,0)},t.prototype.displayDialog=function(e,t){s(this,"DisplayDialog",1,[e,t],4,0)},t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),c(t)||l(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),f(this,t,n)},t.newObject=function(e){return a(t,e,"Microsoft.Dialog.DialogService",!1,4)},Object.defineProperty(t.prototype,"onDialogMessage",{get:function(){return this.m_dialogMessage||(this.m_dialogMessage=new o.GenericEventHandlers(this.context,this,"DialogMessage",{eventType:65536,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return null},eventArgsTransformFunc:function(e){var t,n,r,i;try{var a=JSON.parse(e.message),s=a.errorCode?new o.Error((n=a.errorCode,(r={})[12002]={code:"InvalidUrl",message:"Cannot load URL, no such page or bad URL syntax."},r[12003]={code:"InvalidUrl",message:"HTTPS is required."},r[12004]={code:"Untrusted",message:"Domain is not trusted."},r[12005]={code:"InvalidUrl",message:"HTTPS is required."},r[12007]={code:"FailedToOpen",message:"Another dialog is already opened."},(i=r)[n]?i[n]:{code:"Unknown",message:"An unknown error has occured with code: "+n})):null;t={originalErrorCode:a.errorCode,type:a.type,error:s,message:a.message,origin:a.origin}}catch(e){t={originalErrorCode:null,type:17,error:new o.Error({code:"GenericException",message:"Unknown error"}),message:e.message}}return o.Utility._createPromiseFromResult(t)}})),this.m_dialogMessage},enumerable:!1,configurable:!0}),t.prototype.toJSON=function(){return u(this,{},{})},t}(o.ClientObject);t.DialogService=h,function(e){e[e.dialogMessageReceived=0]="dialogMessageReceived",e[e.dialogEventReceived=1]="dialogEventReceived"}(p||(p={})),function(e){e.generalException="GeneralException"}(t.DialogErrorCodes||(t.DialogErrorCodes={}))},function(e,t,n){"use strict";var r,i=this&&this.__extends||(r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])})(e,t)},function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Class extends value "+String(t)+" is not a constructor or null");function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)});Object.defineProperty(t,"__esModule",{value:!0}),t.ErrorCodes=t.PersistentKvStorageService=t.storage=t.AsyncStorage=void 0;var o=n(0),a=(o.BatchApiHelper.createPropertyObject,o.BatchApiHelper.createMethodObject,o.BatchApiHelper.createIndexerObject,o.BatchApiHelper.createRootServiceObject,o.BatchApiHelper.createTopLevelServiceObject),s=(o.BatchApiHelper.createChildItemObject,o.BatchApiHelper.invokeMethod),c=(o.BatchApiHelper.invokeEnsureUnchanged,o.BatchApiHelper.invokeSetProperty,o.Utility.isNullOrUndefined),u=(o.Utility.isUndefined,o.Utility.throwIfNotLoaded,o.Utility.throwIfApiNotSupported,o.Utility.load,o.Utility.retrieve,o.Utility.toJson),l=o.Utility.fixObjectPathIfNecessary,f=(o.Utility._handleNavigationPropertyResults,o.Utility.adjustToDateTime,o.Utility.processRetrieveResult);function d(e,t){return new o.CoreUtility.Promise((function(n,r){var i=h.getInstance(),o=i.setCallBack((function(e,i){if(i)r(i);else{var o=t(e);n(o)}}));i.ctx.sync().then((function(){var t=i.getPersistentKvStorageService();return e(t,o),i.ctx.sync()})).catch((function(e){r(e)}))}))}function p(e,t,n){return new o.CoreUtility.Promise((function(r,i){var o=h.getInstance(),a=o.setCallBack((function(e,o){if(o)return n&&n(o),void i(o);var a=t(e);n&&n(null,a),r(a)}));o.ctx.sync().then((function(){var t=o.getPersistentKvStorageService();return e(t,a),o.ctx.sync()})).catch((function(e){i(e)}))}))}o.Utility.setMockData,o.CommonUtility.calculateApiFlags,t.AsyncStorage={getItem:function(e,t){return p((function(t,n){return t.multiGet(n,JSON.stringify([e]))}),(function(e){var t=JSON.parse(e);return t&&t[0]&&t[0][1]?t[0][1]:null}),t)},setItem:function(e,t,n){return p((function(n,r){return n.multiSet(r,JSON.stringify([[e,t]]))}),(function(){return null}),n)},removeItem:function(e,t){return p((function(t,n){return t.multiRemove(n,JSON.stringify([e]))}),(function(){return null}),t)},multiGet:function(e,t){return p((function(t,n){return t.multiGet(n,JSON.stringify(e))}),(function(t){var n=JSON.parse(t),r={};return n&&n.forEach((function(e){var t=e[0],n=e[1];return r[t]=n,n})),e.map((function(e){return[e,r[e]?r[e]:null]}))}),t)},multiSet:function(e,t){return p((function(t,n){return t.multiSet(n,JSON.stringify(e))}),(function(){return null}),t)},multiRemove:function(e,t){return p((function(t,n){return t.multiRemove(n,JSON.stringify(e))}),(function(){return null}),t)},getAllKeys:function(e){return p((function(e,t){return e.getAllKeys(t)}),(function(e){return JSON.parse(e)}),e)},clear:function(e){return p((function(e,t){return e.clear(t)}),(function(){return null}),e)}},t.storage={getItem:function(e){return d((function(t,n){return t.multiGet(n,JSON.stringify([e]))}),(function(e){var t=JSON.parse(e);return t&&t[0]&&t[0][1]?t[0][1]:null}))},setItem:function(e,t){return d((function(n,r){return n.multiSet(r,JSON.stringify([[e,t]]))}),(function(){return null}))},removeItem:function(e){return d((function(t,n){return t.multiRemove(n,JSON.stringify([e]))}),(function(){return null}))},getItems:function(e){return d((function(t,n){return t.multiGet(n,JSON.stringify(e))}),(function(t){var n=JSON.parse(t),r={};return e.forEach((function(e){r[e]=null})),n&&n.forEach((function(e){var t=e[0],n=e[1];return r[t]=n,n})),r}))},setItems:function(e){var t=[];for(var n in e)e.hasOwnProperty(n)&&t.push([n,e[n]]);return d((function(e,n){return e.multiSet(n,JSON.stringify(t))}),(function(){return null}))},removeItems:function(e){return d((function(t,n){return t.multiRemove(n,JSON.stringify(e))}),(function(){return null}))},getKeys:function(){return d((function(e,t){return e.getAllKeys(t)}),(function(e){return JSON.parse(e)}))}};var h=function(){function e(){var e=this;this._invokeId=0,this._callDict={},this.ctx=new o.ClientRequestContext,this._perkvstorService=m.newObject(this.ctx),this._eventResult=this._perkvstorService.onPersistentStorageMessage.add((function(t){o.Utility.log("persistentKvStoragegMessageHandler:"+JSON.stringify(t));var n=e._callDict[t.invokeId];n&&(n(t.message,t.error),delete e._callDict[t.invokeId])}))}return e.getInstance=function(){return void 0===e.instance?e.instance=new e:e.instance._perkvstorService=m.newObject(e.instance.ctx),e.instance},e.prototype.getPersistentKvStorageService=function(){return this._perkvstorService},e.prototype.getCallBack=function(e){return this._callDict[e]},e.prototype.setCallBack=function(e){var t=this._invokeId;return this._callDict[this._invokeId++]=e,t},e}(),m=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return i(t,e),Object.defineProperty(t.prototype,"_className",{get:function(){return"PersistentKvStorageService"},enumerable:!1,configurable:!0}),t.prototype.clear=function(e){s(this,"Clear",1,[e],4,0)},t.prototype.getAllKeys=function(e){s(this,"GetAllKeys",1,[e],4,0)},t.prototype.multiGet=function(e,t){s(this,"MultiGet",1,[e,t],4,0)},t.prototype.multiRemove=function(e,t){s(this,"MultiRemove",1,[e,t],4,0)},t.prototype.multiSet=function(e,t){s(this,"MultiSet",1,[e,t],4,0)},t.prototype._handleResult=function(t){e.prototype._handleResult.call(this,t),c(t)||l(this,t)},t.prototype._handleRetrieveResult=function(t,n){e.prototype._handleRetrieveResult.call(this,t,n),f(this,t,n)},t.newObject=function(e){return a(t,e,"Microsoft.PersistentKvStorage.PersistentKvStorageService",!1,4)},Object.defineProperty(t.prototype,"onPersistentStorageMessage",{get:function(){return this.m_persistentStorageMessage||(this.m_persistentStorageMessage=new o.GenericEventHandlers(this.context,this,"PersistentStorageMessage",{eventType:65537,registerFunc:function(){},unregisterFunc:function(){},getTargetIdFunc:function(){return null},eventArgsTransformFunc:function(e){var t,n,r,i;try{var a=JSON.parse(e.message),s=parseInt(a.errorCode),c=0!=s?new o.Error((n=s,(r={})[16389]={code:"GenericException",message:"Unknown error."},r[65535]={code:"Unexcepted",message:"Catastrophic failure."},r[14]={code:"OutOfMemory",message:"Ran out of memory."},r[87]={code:"InvalidArg",message:"One or more arguments are invalid."},r[16385]={code:"NotImplemented",message:"Not implemented."},r[6]={code:"BadHandle",message:"File Handle is not Set."},r[5]={code:"AccessDenied",message:"Can't read the Storage File."},(i=r)[n]?i[n]:{code:"Unknown",message:"An unknown error has occured"})):null;t={invokeId:a.invokeId,message:a.message,error:c}}catch(e){t={invokeId:-1,message:e.message,error:new o.Error({code:"GenericException",message:"Unknown error"})}}return o.Utility._createPromiseFromResult(t)}})),this.m_persistentStorageMessage},enumerable:!1,configurable:!0}),t.prototype.toJSON=function(){return u(this,{},{})},t}(o.ClientObject);t.PersistentKvStorageService=m,function(e){e.generalException="GeneralException"}(t.ErrorCodes||(t.ErrorCodes={}))},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.multiGet=t.multiRemove=t.multiSet=t.getAllKeys=t.clear=t.removeItem=t.setItem=t.getItem=void 0;var r="_Office_AsyncStorage_";function i(){window.localStorage.setItem("_Office_AsyncStorage_|_unusedKey_",null),window.localStorage.removeItem("_Office_AsyncStorage_|_unusedKey_")}function o(e,t){return void 0===t&&(t=function(){}),new Promise((function(n,r){try{i(),e(),t(null),n()}catch(e){t(e),r(e)}}))}function a(e,t){return void 0===t&&(t=function(){}),new Promise((function(n,r){try{i();var o=e();t(null,o),n(o)}catch(e){t(e,null),r(e)}}))}function s(e,t,n){return void 0===n&&(n=function(){}),new Promise((function(r,o){var a=[];try{i()}catch(e){a.push(e)}e.forEach((function(e){try{t(e)}catch(e){a.push(e)}})),n(a),a.length>0?o(a):r()}))}t.getItem=function(e,t){return a((function(){return window.localStorage.getItem(r+e)}),t)},t.setItem=function(e,t,n){return o((function(){return window.localStorage.setItem(r+e,t)}),n)},t.removeItem=function(e,t){return o((function(){return window.localStorage.removeItem(r+e)}),t)},t.clear=function(e){return o((function(){Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).forEach((function(e){return window.localStorage.removeItem(e)}))}),e)},t.getAllKeys=function(e){return a((function(){return Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).map((function(e){return e.substr(r.length)}))}),e)},t.multiSet=function(e,t){return s(e,(function(e){var t=e[0],n=e[1];return window.localStorage.setItem(r+t,n)}),t)},t.multiRemove=function(e,t){return s(e,(function(e){return window.localStorage.removeItem(r+e)}),t)},t.multiGet=function(e,t){return new Promise((function(n,i){t||(t=function(){});var o=[],a=e.map((function(e){try{return[e,window.localStorage.getItem(r+e)]}catch(e){o.push(e)}})).filter((function(e){return e}));o.length>0?(t(o,a),i(o)):(t(null,a),n(a))}))}},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.storage=void 0;var r="_OfficeRuntime_Storage_";function i(){window.localStorage.setItem("_OfficeRuntime_Storage_|_unusedKey_",null),window.localStorage.removeItem("_OfficeRuntime_Storage_|_unusedKey_")}function o(e){return new Promise((function(t,n){try{i(),e(),t()}catch(e){n(e)}}))}function a(e){return new Promise((function(t,n){try{i(),t(e())}catch(e){n(e)}}))}function s(e,t){return new Promise((function(n,r){var o=[];try{i()}catch(e){o.push(e)}for(var a in e)if(e.hasOwnProperty(a)||Array.isArray(e))try{Array.isArray(e)?t(e[a]):t(a)}catch(e){o.push(e)}o.length>0?r(new Error("Unknown error.")):n()}))}t.storage={getItem:function(e){return a((function(){return window.localStorage.getItem(r+e)}))},setItem:function(e,t){return o((function(){return window.localStorage.setItem(r+e,t)}))},removeItem:function(e){return o((function(){return window.localStorage.removeItem(r+e)}))},getItems:function(e){return new Promise((function(t,n){var o={},a=[];try{i()}catch(e){n(e)}e.forEach((function(e){try{var t=window.localStorage.getItem(r+e);o[e]=t||null}catch(e){a.push(e)}})),a.length>0?n(new Error("Unknown error.")):t(o)}))},setItems:function(e){return s(e,(function(t){return window.localStorage.setItem(r+t,e[t])}))},removeItems:function(e){return s(e,(function(e){window.localStorage.removeItem(r+e)}))},getKeys:function(){return a((function(){return Object.keys(window.localStorage).filter((function(e){return 0===e.indexOf(r)})).map((function(e){return e.substr(r.length)}))}))}}},function(e,t,n){"use strict";var r=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function a(e){try{c(r.next(e))}catch(e){o(e)}}function s(e){try{c(r.throw(e))}catch(e){o(e)}}function c(e){var t;e.done?i(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(a,s)}c((r=r.apply(e,t||[])).next())}))},i=this&&this.__generator||function(e,t){var n,r,i,o,a={label:0,sent:function(){if(1&i[0])throw i[1];return i[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;a;)try{if(n=1,r&&(i=2&o[0]?r.return:o[0]?r.throw||((i=r.return)&&i.call(r),0):r.next)&&!(i=i.call(r,o[1])).done)return i;switch(r=0,i&&(o=[2&o[0],i.value]),o[0]){case 0:case 1:i=o;break;case 4:return a.label++,{value:o[1],done:!1};case 5:a.label++,r=o[1],o=[0];continue;case 7:o=a.ops.pop(),a.trys.pop();continue;default:if(!((i=(i=a.trys).length>0&&i[i.length-1])||6!==o[0]&&2!==o[0])){a=0;continue}if(3===o[0]&&(!i||o[1]>i[0]&&o[1]<i[3])){a.label=o[1];break}if(6===o[0]&&a.label<i[1]){a.label=i[1],i=o;break}if(i&&a.label<i[2]){a.label=i[2],a.ops.push(o);break}i[2]&&a.ops.pop(),a.trys.pop();continue}o=t.call(e,a)}catch(e){o=[6,e],r=0}finally{n=i=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}};Object.defineProperty(t,"__esModule",{value:!0}),t.experimentation=void 0;var o=function(){function e(){}return e.prototype.getBooleanFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return"true"===n.toString().toLowerCase()||!0===n}catch(e){return t}},e.prototype.getIntFeatureGate=function(e,t){try{var n=parseInt(Microsoft.Office.WebExtension.FeatureGates[e]);return isNaN(n)?t:n}catch(e){return t}},e.prototype.getStringFeatureGate=function(e,t){try{var n=Microsoft.Office.WebExtension.FeatureGates[e];return null==n?t:n}catch(e){return t}},e.prototype.getChangeGate=function(e){return this.getBooleanFeatureGate(e,!0)},e.prototype.getBooleanFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return i(this,(function(i){switch(i.label){case 0:return i.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"Boolean",t),n.load(r),[4,n.sync()];case 1:return i.sent(),[2,r.value];case 2:return i.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getStringFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return i(this,(function(i){switch(i.label){case 0:return i.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"String",t),n.load(r),[4,n.sync()];case 1:return i.sent(),[2,r.value];case 2:return i.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getIntFeatureGateAsync=function(e,t){return r(this,void 0,void 0,(function(){var n,r;return i(this,(function(i){switch(i.label){case 0:return i.trys.push([0,2,,3]),n=this.getRequestContext(),r=n.flighting.getFeature(e,"Integer",t),n.load(r),[4,n.sync()];case 1:return i.sent(),[2,r.value];case 2:return i.sent(),[2,Promise.resolve(t)];case 3:return[2]}}))}))},e.prototype.getRequestContext=function(){var e;if(Office.context.platform!==Office.PlatformType.OfficeOnline){switch(Office.context.host){case Office.HostType.Excel:e=new Excel.RequestContext;break;case Office.HostType.OneNote:e=new OneNote.RequestContext;break;case Office.HostType.PowerPoint:e=new PowerPoint.RequestContext;break;case Office.HostType.Word:e=new Word.RequestContext;break;default:throw new Error("Unknown Application ".concat(Office.context.host))}return e}},e}();t.experimentation=new o},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Message=void 0;var r=n(10);Object.defineProperty(t,"Message",{enumerable:!0,get:function(){return r.Message}})},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Message=void 0;var r=n(11),i=function(){function e(){this.listeners={}}return e.prototype.on=function(e,t){return this.add(e,t),new Promise((function(e){e()}))},e.prototype.off=function(e,t){return this.remove(e,t),new Promise((function(e){e()}))},e.prototype.emit=function(e,t){return this.send(e,t),new Promise((function(e){e()}))},Object.defineProperty(e,"instance",{get:function(){return e.singleton||(e.singleton=new e),this.singleton},enumerable:!1,configurable:!0}),e.prototype.setupReceive=function(){Office&&Office.context&&Office.context.messaging&&!Office.context.messaging.onMessage&&(Office.context.messaging.onMessage=this.receiveMessage.bind(this))},e.prototype.add=function(e,t){this.listeners.hasOwnProperty(e)||(this.listeners[e]=new r.ListenerManager,this.setupReceive()),this.listeners[e].add(t)},e.prototype.remove=function(e,t){this.listeners.hasOwnProperty(e)&&(t?this.listeners[e].remove(t):delete this.listeners[e])},e.prototype.send=function(e,t){var n={eventName:e,message:t};Office&&Office.context&&Office.context.messaging&&Office.context.messaging.sendMessage&&Office.context.messaging.sendMessage(n)},e.prototype.receiveMessage=function(e){var t=e.eventName,n=e.message;this.listeners.hasOwnProperty(t)&&this.listeners[t].call(n)},e}();t.Message=i},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListenerManager=void 0;var r=function(){function e(){this.listeners=[]}return e.prototype.add=function(e){this.listeners.push(e)},e.prototype.remove=function(e){var t=this.listeners.lastIndexOf(e);-1!==t&&this.listeners.splice(t,1)},e.prototype.call=function(e){this.listeners.forEach((function(t){return t(e)}))},e}();t.ListenerManager=r},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Ribbon=t.ui=void 0,t.ui={getRibbon:function(){return new Promise((function(e,t){e(new r)}))}};var r=function(){function e(){this.requestContext=new OfficeCore.RequestContext,OSF.WebAuth&&"web"==OSF._OfficeAppFactory.getHostInfo().hostPlatform&&(this.requestContext._customData="WacPartition")}return e.prototype.requestUpdate=function(e){var t=this.requestContext.ribbon;return e.tabs.filter((function(e){return!!e.id})).forEach((function(e){var n=t.getTab(e.id);void 0!==e.visible&&null!==e.visible&&n.setVisibility(e.visible),e.controls.filter((function(e){return!!e.id})).forEach((function(e){var n=t.getButton(e.id);void 0!==e.enabled&&null!==e.enabled&&(n.enabled=e.enabled)}))})),this.requestContext.sync()},e}();t.Ribbon=r},function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Auth=void 0;var r=n(0),i=function(){function e(){}return e.prototype.getAccessToken=function(e){return new r.CoreUtility.Promise((function(t,n){try{Office.context.auth.getAccessTokenAsync(e||{},(function(e){"succeeded"===e.status?t(e.value):n(e.error)}))}catch(e){n(e)}}))},e.prototype.getAuthContext=function(){return new r.CoreUtility.Promise((function(e,t){try{Office.context.auth.getAuthContextAsync((function(n){"succeeded"===n.status?e(n.value):t(n.error)}))}catch(e){t(e)}}))},Object.defineProperty(e,"instance",{get:function(){return e.singleton||(e.singleton=new e),e.singleton},enumerable:!1,configurable:!0}),e}();t.Auth=i}]),window.OfficeRuntime=window._OfficeRuntimeNative,exposeOfficeRuntimeThroughOfficeNamespace("undefined"!==typeof OfficeRuntime&&OfficeRuntime||void 0,"undefined"!==typeof Office&&Office||void 0);